/*===========================================================================*/
/*   (Ast/venv.scm)                                                          */
/*   Bigloo (3.2b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon May 25 12:42:12 CEST 2009       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/venv.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_isfunz00_bgl
	{
		struct BgL_nodez00_bgl *BgL_originalzd2bodyzd2;
		obj_t BgL_recursivezd2callszd2;
	}               *BgL_isfunz00_bglt;


	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_bglt);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	BGL_EXPORTED_DECL obj_t BGl_alreadyzd2restoredzf3z21zzast_envz00(obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static obj_t BGl__restorezd2valuezd2typesz123287z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
	BGL_EXPORTED_DECL obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zzast_envz00();
	static obj_t BGl__addzd2genvz12zc0zzast_envz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2hashtablezd2zz__hashz00(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl__alreadyzd2restoredzf3z21zzast_envz00(obj_t, obj_t);
	static obj_t
		BGl__additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_hashtablezd2getzd2zz__hashz00(obj_t, obj_t);
	static obj_t BGl_warningzd2overridezd2globalz12z12zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_inlinez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_hrtypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_userzd2warningzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzast_envz00();
	static obj_t BGl_za2Genvza2z00zzast_envz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	BGL_IMPORT int BGl_bigloozd2warningzd2zz__paramz00();
	extern BgL_typez00_bglt BGl_findzd2typezd2zztype_envz00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t,
		obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	static obj_t BGl__getzd2globalzf2module3550z20zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_bindzd2globalz12zc0zzast_envz00(obj_t, obj_t, BgL_valuez00_bglt, obj_t,
		obj_t);
	static obj_t BGl__restorezd2globalz12zc0zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_warningzd2rebindzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_za2warningzd2overridenzd2variablesza2z00zzengine_paramz00;
	BGL_EXPORTED_DECL obj_t BGl_getzd2genvzd2zzast_envz00();
	static obj_t BGl__findzd2globalzd2zzast_envz00(obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33300ze3z83zzast_envz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_userzd2warningzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00();
	static obj_t BGl_methodzd2initzd2zzast_envz00();
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__unbindzd2globalz12zc0zzast_envz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	BGL_EXPORTED_DECL obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	static obj_t BGl__getzd2genvzd2zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_envz00 = BUNSPEC;
	static obj_t BGl__forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_genericzd2initzd2zzast_envz00();
	static obj_t BGl__restorezd2valuezd2typesz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_funz00zzast_varz00;
	extern obj_t BGl_hrtypezd2nodez12zc0zzast_hrtypez00(BgL_nodez00_bglt);
	extern obj_t BGl_globalz00zzast_varz00;
	extern obj_t BGl_modulezd2initializa7ationzd2idza7zzmodule_modulez00(obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	static obj_t BGl_importedzd2moduleszd2initz00zzast_envz00();
	static obj_t BGl__initializa7ezd2Genvz12z67zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	extern obj_t BGl_userzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_restorezd2globalz12zc0zzast_envz00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00();
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz123292z12zzast_envz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz123294z12zzast_envz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz123296z12zzast_envz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz123298z12zzast_envz00(obj_t, obj_t);
	static obj_t BGl__bindzd2globalz12zc0zzast_envz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl__setzd2genvz12zc0zzast_envz00(obj_t, obj_t);
	static obj_t BGl__globalzd2bucketzd2positionz00zzast_envz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern BgL_globalz00_bglt BGl_makezd2globalzd2zzast_varz00(obj_t, obj_t,
		BgL_typez00_bglt, BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, obj_t,
		obj_t, bool_t, obj_t, bool_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	BGL_EXPORTED_DECL obj_t BGl_globalzd2bucketzd2positionz00zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_za2restoredza2z00zzast_envz00 = BUNSPEC;
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT obj_t BGl_hashtablezd2putz12zc0zz__hashz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl__findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_isfunz00zzinline_inlinez00;
	static obj_t BGl_errorzd2rebindzd2globalz12z12zzast_envz00(obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33438ze3z83zzast_envz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_envz00();
	static obj_t __cnst[7];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_forzd2eachzd2globalz12zd2envzc0zzast_envz00,
		BgL_bgl__forza7d2eachza7d2gl3571z00, va_generic_entry,
		BGl__forzd2eachzd2globalz12z12zzast_envz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2globalzd2envz00zzast_envz00,
		BgL_bgl__findza7d2globalza7d3572z00, va_generic_entry,
		BGl__findzd2globalzd2zzast_envz00, BUNSPEC, -2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_initializa7ezd2Genvz12zd2envzb5zzast_envz00,
		BgL_bgl__initializa7a7eza7d23573z00,
		BGl__initializa7ezd2Genvz12z67zzast_envz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzd2bucketzd2positionzd2envzd2zzast_envz00,
		BgL_bgl__globalza7d2bucket3574za7,
		BGl__globalzd2bucketzd2positionz00zzast_envz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_alreadyzd2restoredzf3zd2envzf3zzast_envz00,
		BgL_bgl__alreadyza7d2resto3575za7,
		BGl__alreadyzd2restoredzf3z21zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2genvzd2envz00zzast_envz00,
		BgL_bgl__getza7d2genvza7d2za7za73576z00, BGl__getzd2genvzd2zzast_envz00, 0L,
		BUNSPEC, 0);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_restorezd2valuezd2typesz123287zd2envzc0zzast_envz00,
		BgL_bgl__restoreza7d2value3577za7,
		BGl__restorezd2valuezd2typesz123287z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_unbindzd2globalz12zd2envz12zzast_envz00,
		BgL_bgl__unbindza7d2global3578za7, BGl__unbindzd2globalz12zc0zzast_envz00,
		0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2globalzf2modulezd2envzf2zzast_envz00,
		BgL_bgl__getza7d2globalza7f23579z00,
		BGl__getzd2globalzf2module3550z20zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_addzd2genvz12zd2envz12zzast_envz00,
		BgL_bgl__addza7d2genvza712za7c3580za7, BGl__addzd2genvz12zc0zzast_envz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_restorezd2globalz12zd2envz12zzast_envz00,
		BgL_bgl__restoreza7d2globa3581za7, BGl__restorezd2globalz12zc0zzast_envz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_setzd2genvz12zd2envz12zzast_envz00,
		BgL_bgl__setza7d2genvza712za7c3582za7, BGl__setzd2genvz12zc0zzast_envz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_additionalzd2heapzd2restorezd2globalsz12zd2envz12zzast_envz00,
		BgL_bgl__additionalza7d2he3583za7,
		BGl__additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00, 0L, BUNSPEC,
		0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2globalzf2modulezd2envzf2zzast_envz00,
		BgL_bgl__findza7d2globalza7f3584z00,
		BGl__findzd2globalzf2modulez20zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3551z00zzast_envz00,
		BgL_bgl_za7c3anonymousza7a333585z00,
		BGl_zc3anonymousza33300ze3z83zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3560z00zzast_envz00,
		BgL_bgl_restoreza7d2valueza73586z00,
		BGl_restorezd2valuezd2typesz123294z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3559z00zzast_envz00,
		BgL_bgl_restoreza7d2valueza73587z00,
		BGl_restorezd2valuezd2typesz123292z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3561z00zzast_envz00,
		BgL_bgl_restoreza7d2valueza73588z00,
		BGl_restorezd2valuezd2typesz123296z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3562z00zzast_envz00,
		BgL_bgl_restoreza7d2valueza73589z00,
		BGl_restorezd2valuezd2typesz123298z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string3552z00zzast_envz00,
		BgL_bgl_string3552za700za7za7a3590za7, "~a::~a", 6);
	      DEFINE_STRING(BGl_string3553z00zzast_envz00,
		BgL_bgl_string3553za700za7za7a3591za7, "Cannot find global variable", 27);
	      DEFINE_STRING(BGl_string3554z00zzast_envz00,
		BgL_bgl_string3554za700za7za7a3592za7, "Variable overridden by", 22);
	      DEFINE_STRING(BGl_string3555z00zzast_envz00,
		BgL_bgl_string3555za700za7za7a3593za7, "Duplicate definition", 20);
	      DEFINE_STRING(BGl_string3556z00zzast_envz00,
		BgL_bgl_string3556za700za7za7a3594za7, "eval", 4);
	      DEFINE_STRING(BGl_string3557z00zzast_envz00,
		BgL_bgl_string3557za700za7za7a3595za7, "unbind-global!", 14);
	      DEFINE_STRING(BGl_string3558z00zzast_envz00,
		BgL_bgl_string3558za700za7za7a3596za7, "Can't find global", 17);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
		BgL_bgl__restoreza7d2value3597za7,
		BGl__restorezd2valuezd2typesz12z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string3563z00zzast_envz00,
		BgL_bgl_string3563za700za7za7a3598za7, "restore-value-types(sfun)", 25);
	      DEFINE_STRING(BGl_string3564z00zzast_envz00,
		BgL_bgl_string3564za700za7za7a3599za7, "Illegal argument", 16);
	      DEFINE_STRING(BGl_string3565z00zzast_envz00,
		BgL_bgl_string3565za700za7za7a3600za7, "restore-value-types", 19);
	      DEFINE_STRING(BGl_string3566z00zzast_envz00,
		BgL_bgl_string3566za700za7za7a3601za7, "Illegal non pair argument", 25);
	      DEFINE_STRING(BGl_string3567z00zzast_envz00,
		BgL_bgl_string3567za700za7za7a3602za7, "ast_env", 7);
	      DEFINE_STRING(BGl_string3568z00zzast_envz00,
		BgL_bgl_string3568za700za7za7a3603za7,
		"eval now read @ get-global/module foreign the-global-environment ", 65);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_bindzd2globalz12zd2envz12zzast_envz00,
		BgL_bgl__bindza7d2globalza713604z00, BGl__bindzd2globalz12zc0zzast_envz00,
		0L, BUNSPEC, 5);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long
		BgL_checksumz00_1885, char *BgL_fromz00_1886)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_envz00))
				{
					BGl_requirezd2initializa7ationz75zzast_envz00 = BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_envz00();
					BGl_cnstzd2initzd2zzast_envz00();
					BGl_importedzd2moduleszd2initz00zzast_envz00();
					BGl_genericzd2initzd2zzast_envz00();
					BGl_methodzd2initzd2zzast_envz00();
					BGl_toplevelzd2initzd2zzast_envz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_env");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			{	/* Ast/venv.scm 14 */
				obj_t BgL_cportz00_1876;

				BgL_cportz00_1876 =
					bgl_open_input_string(BGl_string3568z00zzast_envz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1877;

					BgL_iz00_1877 = ((long) 6);
				BgL_loopz00_1878:
					if ((BgL_iz00_1877 == ((long) -1)))
						{	/* Ast/venv.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/venv.scm 14 */
							{	/* Ast/venv.scm 14 */
								obj_t BgL_arg3570z00_1880;

								{	/* Ast/venv.scm 14 */

									{	/* Ast/venv.scm 14 */
										obj_t BgL_locationz00_1882;

										BgL_locationz00_1882 = BBOOL(((bool_t) 0));
										{	/* Ast/venv.scm 14 */

											BgL_arg3570z00_1880 =
												BGl_readz00zz__readerz00(BgL_cportz00_1876,
												BgL_locationz00_1882);
										}
									}
								}
								{	/* Ast/venv.scm 14 */
									int BgL_auxz00_1909;

									BgL_auxz00_1909 = (int) (BgL_iz00_1877);
									CNST_TABLE_SET(BgL_auxz00_1909, BgL_arg3570z00_1880);
							}}
							{	/* Ast/venv.scm 14 */
								int BgL_auxz00_1883;

								BgL_auxz00_1883 = (int) ((BgL_iz00_1877 - ((long) 1)));
								{
									long BgL_iz00_1914;

									BgL_iz00_1914 = (long) (BgL_auxz00_1883);
									BgL_iz00_1877 = BgL_iz00_1914;
									goto BgL_loopz00_1878;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_za2Genvza2z00zzast_envz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 = BNIL;
			BGl_za2restoredza2z00zzast_envz00 = BNIL;
			return BUNSPEC;
		}
	}



/* set-genv! */
	BGL_EXPORTED_DEF obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t BgL_genvz00_1)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 54 */
			return (BGl_za2Genvza2z00zzast_envz00 = BgL_genvz00_1, BUNSPEC);
		}
	}



/* _set-genv! */
	obj_t BGl__setzd2genvz12zc0zzast_envz00(obj_t BgL_envz00_1816,
		obj_t BgL_genvz00_1817)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 54 */
			return BGl_setzd2genvz12zc0zzast_envz00(BgL_genvz00_1817);
		}
	}



/* add-genv! */
	BGL_EXPORTED_DEF obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t BgL_genvz00_2)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 63 */
			BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_genvz00_2,
				BGl_proc3551z00zzast_envz00);
			return (BGl_za2restoredza2z00zzast_envz00 = BNIL, BUNSPEC);
		}
	}



/* _add-genv! */
	obj_t BGl__addzd2genvz12zc0zzast_envz00(obj_t BgL_envz00_1819,
		obj_t BgL_genvz00_1820)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 63 */
			return BGl_addzd2genvz12zc0zzast_envz00(BgL_genvz00_1820);
		}
	}



/* <anonymous:3300> */
	obj_t BGl_zc3anonymousza33300ze3z83zzast_envz00(obj_t BgL_envz00_1821,
		obj_t BgL_kz00_1822, obj_t BgL_bucketz00_1823)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 66 */
			{
				obj_t BgL_kz00_866;

				obj_t BgL_bucketz00_867;

				{	/* Ast/venv.scm 67 */
					bool_t BgL_auxz00_1920;

					BgL_kz00_866 = BgL_kz00_1822;
					BgL_bucketz00_867 = BgL_bucketz00_1823;
					{	/* Ast/venv.scm 67 */
						obj_t BgL_g3279z00_869;

						BgL_g3279z00_869 = CDR(BgL_bucketz00_867);
						{
							obj_t BgL_l3277z00_870;

							BgL_l3277z00_870 = BgL_g3279z00_869;
						BgL_forzd2each3278zd2_871:
							if (PAIRP(BgL_l3277z00_870))
								{	/* Ast/venv.scm 87 */
									{	/* Ast/venv.scm 86 */
										obj_t BgL_newz00_873;

										BgL_newz00_873 = CAR(BgL_l3277z00_870);
										BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 =
											MAKE_PAIR(BgL_newz00_873,
											BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00);
										{	/* Ast/venv.scm 69 */
											obj_t BgL_modulez00_874;

											{
												BgL_globalz00_bglt BgL_auxz00_1926;

												BgL_auxz00_1926 = (BgL_globalz00_bglt) (BgL_newz00_873);
												BgL_modulez00_874 =
													(((BgL_globalz00_bglt) CREF(BgL_auxz00_1926))->
													BgL_modulez00);
											}
											{	/* Ast/venv.scm 69 */
												obj_t BgL_idz00_875;

												{
													BgL_variablez00_bglt BgL_auxz00_1929;

													BgL_auxz00_1929 =
														(BgL_variablez00_bglt) (BgL_newz00_873);
													BgL_idz00_875 =
														(((BgL_variablez00_bglt) CREF(BgL_auxz00_1929))->
														BgL_idz00);
												}
												{	/* Ast/venv.scm 70 */
													obj_t BgL_bucketz00_876;

													BgL_bucketz00_876 =
														BGl_hashtablezd2getzd2zz__hashz00
														(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_875);
													{	/* Ast/venv.scm 71 */

														if (PAIRP(BgL_bucketz00_876))
															{	/* Ast/venv.scm 75 */
																bool_t BgL_testz00_1935;

																if (
																	(BgL_modulez00_874 ==
																		BGl_za2moduleza2z00zzmodule_modulez00))
																	{	/* Ast/venv.scm 75 */
																		BgL_testz00_1935 = ((bool_t) 1);
																	}
																else
																	{	/* Ast/venv.scm 76 */
																		bool_t BgL_testz00_1938;

																		{	/* Ast/venv.scm 77 */
																			obj_t BgL_arg3310z00_886;

																			{	/* Ast/venv.scm 77 */
																				BgL_globalz00_bglt BgL_obj1515z00_1532;

																				{	/* Ast/venv.scm 77 */
																					obj_t BgL_pairz00_1528;

																					BgL_pairz00_1528 = BgL_bucketz00_876;
																					{	/* Ast/venv.scm 77 */
																						obj_t BgL_pairz00_1531;

																						BgL_pairz00_1531 =
																							CDR(BgL_pairz00_1528);
																						BgL_obj1515z00_1532 =
																							(BgL_globalz00_bglt) (CAR
																							(BgL_pairz00_1531));
																					}
																				}
																				BgL_arg3310z00_886 =
																					(((BgL_globalz00_bglt)
																						CREF(BgL_obj1515z00_1532))->
																					BgL_modulez00);
																			}
																			BgL_testz00_1938 =
																				(BGl_za2moduleza2z00zzmodule_modulez00
																				== BgL_arg3310z00_886);
																		}
																		if (BgL_testz00_1938)
																			{	/* Ast/venv.scm 76 */
																				BgL_testz00_1935 = ((bool_t) 0);
																			}
																		else
																			{	/* Ast/venv.scm 76 */
																				BgL_testz00_1935 = ((bool_t) 1);
																			}
																	}
																if (BgL_testz00_1935)
																	{	/* Ast/venv.scm 83 */
																		obj_t BgL_newzd2bucketzd2_879;

																		BgL_newzd2bucketzd2_879 =
																			MAKE_PAIR(BgL_newz00_873,
																			CDR(BgL_bucketz00_876));
																		SET_CDR(BgL_bucketz00_876,
																			BgL_newzd2bucketzd2_879);
																	}
																else
																	{	/* Ast/venv.scm 86 */
																		obj_t BgL_arg3305z00_881;

																		obj_t BgL_arg3306z00_882;

																		BgL_arg3305z00_881 = CDR(BgL_bucketz00_876);
																		{	/* Ast/venv.scm 86 */
																			obj_t BgL_arg3307z00_883;

																			{	/* Ast/venv.scm 86 */
																				obj_t BgL_pairz00_1537;

																				BgL_pairz00_1537 = BgL_bucketz00_876;
																				BgL_arg3307z00_883 =
																					CDR(CDR(BgL_pairz00_1537));
																			}
																			BgL_arg3306z00_882 =
																				MAKE_PAIR(BgL_newz00_873,
																				BgL_arg3307z00_883);
																		}
																		SET_CDR(BgL_arg3305z00_881,
																			BgL_arg3306z00_882);
																	}
															}
														else
															{	/* Ast/venv.scm 74 */
																obj_t BgL_arg3312z00_888;

																{	/* Ast/venv.scm 74 */
																	obj_t BgL_list3313z00_889;

																	{	/* Ast/venv.scm 74 */
																		obj_t BgL_arg3314z00_890;

																		BgL_arg3314z00_890 =
																			MAKE_PAIR(BgL_newz00_873, BNIL);
																		BgL_list3313z00_889 =
																			MAKE_PAIR(BgL_idz00_875,
																			BgL_arg3314z00_890);
																	}
																	BgL_arg3312z00_888 = BgL_list3313z00_889;
																}
																BGl_hashtablezd2putz12zc0zz__hashz00
																	(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_875,
																	BgL_arg3312z00_888);
															}
													}
												}
											}
										}
									}
									{
										obj_t BgL_l3277z00_1955;

										BgL_l3277z00_1955 = CDR(BgL_l3277z00_870);
										BgL_l3277z00_870 = BgL_l3277z00_1955;
										goto BgL_forzd2each3278zd2_871;
									}
								}
							else
								{	/* Ast/venv.scm 87 */
									BgL_auxz00_1920 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_1920);
				}
			}
		}
	}



/* additional-heap-restore-globals! */
	BGL_EXPORTED_DEF obj_t
		BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 104 */
			{
				obj_t BgL_l3280z00_893;

				BgL_l3280z00_893 = BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00;
			BgL_forzd2each3281zd2_894:
				if (PAIRP(BgL_l3280z00_893))
					{	/* Ast/venv.scm 105 */
						BGl_restorezd2globalz12zc0zzast_envz00(CAR(BgL_l3280z00_893));
						{
							obj_t BgL_l3280z00_1962;

							BgL_l3280z00_1962 = CDR(BgL_l3280z00_893);
							BgL_l3280z00_893 = BgL_l3280z00_1962;
							goto BgL_forzd2each3281zd2_894;
						}
					}
				else
					{	/* Ast/venv.scm 105 */
						((bool_t) 1);
					}
			}
			return BTRUE;
		}
	}



/* _additional-heap-restore-globals! */
	obj_t BGl__additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00(obj_t
		BgL_envz00_1824)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 104 */
			return BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00();
		}
	}



/* restore-global! */
	BGL_EXPORTED_DEF obj_t BGl_restorezd2globalz12zc0zzast_envz00(obj_t
		BgL_newz00_4)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 111 */
			BGl_za2restoredza2z00zzast_envz00 =
				MAKE_PAIR(BgL_newz00_4, BGl_za2restoredza2z00zzast_envz00);
			{	/* Ast/venv.scm 114 */
				BgL_typez00_bglt BgL_typez00_899;

				{
					BgL_variablez00_bglt BgL_auxz00_1966;

					BgL_auxz00_1966 = (BgL_variablez00_bglt) (BgL_newz00_4);
					BgL_typez00_899 =
						(((BgL_variablez00_bglt) CREF(BgL_auxz00_1966))->BgL_typez00);
				}
				{	/* Ast/venv.scm 115 */
					BgL_valuez00_bglt BgL_valuez00_900;

					{
						BgL_variablez00_bglt BgL_auxz00_1969;

						BgL_auxz00_1969 = (BgL_variablez00_bglt) (BgL_newz00_4);
						BgL_valuez00_900 =
							(((BgL_variablez00_bglt) CREF(BgL_auxz00_1969))->BgL_valuez00);
					}
					{	/* Ast/venv.scm 116 */
						obj_t BgL_typezd2idzd2_901;

						BgL_typezd2idzd2_901 =
							(((BgL_typez00_bglt) CREF(BgL_typez00_899))->BgL_idz00);
						{	/* Ast/venv.scm 117 */

							{
								BgL_typez00_bglt BgL_auxz00_1975;

								BgL_variablez00_bglt BgL_auxz00_1973;

								BgL_auxz00_1975 =
									BGl_findzd2typezd2zztype_envz00(BgL_typezd2idzd2_901);
								BgL_auxz00_1973 = (BgL_variablez00_bglt) (BgL_newz00_4);
								((((BgL_variablez00_bglt) CREF(BgL_auxz00_1973))->BgL_typez00) =
									((BgL_typez00_bglt) BgL_auxz00_1975), BUNSPEC);
							}
							{	/* Ast/venv.scm 121 */
								obj_t BgL_method3288z00_1557;

								{	/* Ast/venv.scm 121 */
									BgL_objectz00_bglt BgL_objz00_1558;

									BgL_objz00_1558 = (BgL_objectz00_bglt) (BgL_valuez00_900);
									{	/* Ast/venv.scm 121 */
										long BgL_objzd2classzd2numz00_1559;

										BgL_objzd2classzd2numz00_1559 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1558);
										{	/* Ast/venv.scm 121 */
											obj_t BgL_arg2356z00_1560;

											BgL_arg2356z00_1560 =
												PROCEDURE_REF
												(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
												(int) (((long) 1)));
											{	/* Ast/venv.scm 121 */
												obj_t BgL_arrayz00_1562;

												int BgL_offsetz00_1563;

												BgL_arrayz00_1562 = BgL_arg2356z00_1560;
												BgL_offsetz00_1563 =
													(int) (BgL_objzd2classzd2numz00_1559);
												{	/* Ast/venv.scm 121 */
													long BgL_offsetz00_1564;

													BgL_offsetz00_1564 =
														((long) (BgL_offsetz00_1563) - OBJECT_TYPE);
													{	/* Ast/venv.scm 121 */
														long BgL_modz00_1565;

														{	/* Ast/venv.scm 121 */
															int BgL_arg2358z00_1566;

															BgL_arg2358z00_1566 = (int) (((long) 8));
															{	/* Ast/venv.scm 121 */
																long BgL_auxz00_1986;

																BgL_auxz00_1986 = (long) (BgL_arg2358z00_1566);
																BgL_modz00_1565 =
																	(BgL_offsetz00_1564 / BgL_auxz00_1986);
														}}
														{	/* Ast/venv.scm 121 */
															long BgL_restz00_1567;

															{	/* Ast/venv.scm 121 */
																int BgL_arg2357z00_1568;

																BgL_arg2357z00_1568 = (int) (((long) 8));
																{	/* Ast/venv.scm 121 */
																	long BgL_auxz00_1990;

																	BgL_auxz00_1990 =
																		(long) (BgL_arg2357z00_1568);
																	BgL_restz00_1567 =
																		(BgL_offsetz00_1564 % BgL_auxz00_1990);
															}}
															{	/* Ast/venv.scm 121 */

																BgL_method3288z00_1557 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1562,
																		(int) (BgL_modz00_1565)),
																	(int) (BgL_restz00_1567));
								}}}}}}}}
								PROCEDURE_ENTRY(BgL_method3288z00_1557) (BgL_method3288z00_1557,
									(obj_t) (BgL_valuez00_900), BEOA);
							}
							{	/* Ast/venv.scm 123 */
								bool_t BgL_testz00_2000;

								{	/* Ast/venv.scm 123 */
									bool_t BgL_testz00_2001;

									{	/* Ast/venv.scm 123 */
										obj_t BgL_arg3329z00_912;

										BgL_arg3329z00_912 =
											BGl_thezd2backendzd2zzbackend_backendz00();
										{
											BgL_backendz00_bglt BgL_auxz00_2003;

											BgL_auxz00_2003 =
												(BgL_backendz00_bglt) (BgL_arg3329z00_912);
											BgL_testz00_2001 =
												(((BgL_backendz00_bglt) CREF(BgL_auxz00_2003))->
												BgL_qualifiedzd2typeszd2);
									}}
									if (BgL_testz00_2001)
										{	/* Ast/venv.scm 124 */
											bool_t BgL_testz00_2006;

											{	/* Ast/venv.scm 124 */
												obj_t BgL_auxz00_2007;

												{
													BgL_globalz00_bglt BgL_auxz00_2008;

													BgL_auxz00_2008 = (BgL_globalz00_bglt) (BgL_newz00_4);
													BgL_auxz00_2007 =
														(((BgL_globalz00_bglt) CREF(BgL_auxz00_2008))->
														BgL_modulez00);
												}
												BgL_testz00_2006 =
													(BgL_auxz00_2007 == CNST_TABLE_REF(((long) 1)));
											}
											if (BgL_testz00_2006)
												{	/* Ast/venv.scm 124 */
													BgL_testz00_2000 = ((bool_t) 0);
												}
											else
												{	/* Ast/venv.scm 124 */
													BgL_testz00_2000 = ((bool_t) 1);
												}
										}
									else
										{	/* Ast/venv.scm 123 */
											BgL_testz00_2000 = ((bool_t) 0);
										}
								}
								if (BgL_testz00_2000)
									{	/* Ast/venv.scm 125 */
										obj_t BgL_arg3321z00_904;

										obj_t BgL_arg3322z00_905;

										obj_t BgL_arg3323z00_906;

										{
											BgL_globalz00_bglt BgL_auxz00_2013;

											BgL_auxz00_2013 = (BgL_globalz00_bglt) (BgL_newz00_4);
											BgL_arg3321z00_904 =
												(((BgL_globalz00_bglt) CREF(BgL_auxz00_2013))->
												BgL_modulez00);
										}
										{
											BgL_globalz00_bglt BgL_auxz00_2016;

											BgL_auxz00_2016 = (BgL_globalz00_bglt) (BgL_newz00_4);
											BgL_arg3322z00_905 =
												(((BgL_globalz00_bglt) CREF(BgL_auxz00_2016))->
												BgL_jvmzd2typezd2namez00);
										}
										BgL_arg3323z00_906 =
											BGl_shapez00zztools_shapez00(BgL_newz00_4);
										{	/* Ast/venv.scm 125 */
											obj_t BgL_list3324z00_907;

											BgL_list3324z00_907 = MAKE_PAIR(BgL_arg3323z00_906, BNIL);
											return
												BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00
												(BgL_arg3321z00_904, BgL_arg3322z00_905,
												BgL_list3324z00_907);
										}
									}
								else
									{	/* Ast/venv.scm 123 */
										return BFALSE;
									}
							}
						}
					}
				}
			}
		}
	}



/* _restore-global! */
	obj_t BGl__restorezd2globalz12zc0zzast_envz00(obj_t BgL_envz00_1825,
		obj_t BgL_newz00_1826)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 111 */
			return BGl_restorezd2globalz12zc0zzast_envz00(BgL_newz00_1826);
		}
	}



/* already-restored? */
	BGL_EXPORTED_DEF obj_t BGl_alreadyzd2restoredzf3z21zzast_envz00(obj_t
		BgL_funz00_6)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 146 */
			return
				BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_funz00_6,
				BGl_za2restoredza2z00zzast_envz00);
		}
	}



/* _already-restored? */
	obj_t BGl__alreadyzd2restoredzf3z21zzast_envz00(obj_t BgL_envz00_1829,
		obj_t BgL_funz00_1830)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 146 */
			return BGl_alreadyzd2restoredzf3z21zzast_envz00(BgL_funz00_1830);
		}
	}



/* get-genv */
	BGL_EXPORTED_DEF obj_t BGl_getzd2genvzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 220 */
			return BGl_za2Genvza2z00zzast_envz00;
		}
	}



/* _get-genv */
	obj_t BGl__getzd2genvzd2zzast_envz00(obj_t BgL_envz00_1831)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 220 */
			return BGl_za2Genvza2z00zzast_envz00;
		}
	}



/* initialize-Genv! */
	BGL_EXPORTED_DEF obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 226 */
			return (BGl_za2Genvza2z00zzast_envz00 =
				BGl_makezd2hashtablezd2zz__hashz00(BNIL), BUNSPEC);
		}
	}



/* _initialize-Genv! */
	obj_t BGl__initializa7ezd2Genvz12z67zzast_envz00(obj_t BgL_envz00_1832)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 226 */
			return BGl_initializa7ezd2Genvz12z67zzast_envz00();
		}
	}



/* find-global */
	BGL_EXPORTED_DEF obj_t BGl_findzd2globalzd2zzast_envz00(obj_t BgL_idz00_13,
		obj_t BgL_modulez00_14)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 232 */
			{	/* Ast/venv.scm 234 */
				obj_t BgL_bucketz00_914;

				obj_t BgL_modulez00_915;

				BgL_bucketz00_914 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_13);
				if (NULLP(BgL_modulez00_14))
					{	/* Ast/venv.scm 235 */
						BgL_modulez00_915 = BNIL;
					}
				else
					{	/* Ast/venv.scm 235 */
						BgL_modulez00_915 = CAR(BgL_modulez00_14);
					}
				if (PAIRP(BgL_bucketz00_914))
					{	/* Ast/venv.scm 237 */
						if (NULLP(CDR(BgL_bucketz00_914)))
							{	/* Ast/venv.scm 239 */
								return BFALSE;
							}
						else
							{	/* Ast/venv.scm 239 */
								if (NULLP(BgL_modulez00_915))
									{	/* Ast/venv.scm 242 */
										obj_t BgL_pairz00_1592;

										BgL_pairz00_1592 = BgL_bucketz00_914;
										return CAR(CDR(BgL_pairz00_1592));
									}
								else
									{
										obj_t BgL_globalsz00_920;

										BgL_globalsz00_920 = CDR(BgL_bucketz00_914);
									BgL_loopz00_921:
										if (NULLP(BgL_globalsz00_920))
											{	/* Ast/venv.scm 246 */
												return BFALSE;
											}
										else
											{	/* Ast/venv.scm 248 */
												bool_t BgL_testz00_2042;

												{	/* Ast/venv.scm 248 */
													obj_t BgL_auxz00_2043;

													{	/* Ast/venv.scm 248 */
														BgL_globalz00_bglt BgL_obj1515z00_1599;

														{	/* Ast/venv.scm 248 */
															obj_t BgL_pairz00_1598;

															BgL_pairz00_1598 = BgL_globalsz00_920;
															BgL_obj1515z00_1599 =
																(BgL_globalz00_bglt) (CAR(BgL_pairz00_1598));
														}
														BgL_auxz00_2043 =
															(((BgL_globalz00_bglt)
																CREF(BgL_obj1515z00_1599))->BgL_modulez00);
													}
													BgL_testz00_2042 =
														(BgL_auxz00_2043 == BgL_modulez00_915);
												}
												if (BgL_testz00_2042)
													{	/* Ast/venv.scm 248 */
														return CAR(BgL_globalsz00_920);
													}
												else
													{
														obj_t BgL_globalsz00_2049;

														BgL_globalsz00_2049 = CDR(BgL_globalsz00_920);
														BgL_globalsz00_920 = BgL_globalsz00_2049;
														goto BgL_loopz00_921;
													}
											}
									}
							}
					}
				else
					{	/* Ast/venv.scm 237 */
						return BFALSE;
					}
			}
		}
	}



/* _find-global */
	obj_t BGl__findzd2globalzd2zzast_envz00(obj_t BgL_envz00_1833,
		obj_t BgL_idz00_1834, obj_t BgL_modulez00_1835)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 232 */
			return
				BGl_findzd2globalzd2zzast_envz00(BgL_idz00_1834, BgL_modulez00_1835);
		}
	}



/* find-global/module */
	BGL_EXPORTED_DEF obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t
		BgL_idz00_15, obj_t BgL_modulez00_16)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 256 */
			{	/* Ast/venv.scm 257 */
				obj_t BgL_bucketz00_929;

				BgL_bucketz00_929 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_15);
				if (PAIRP(BgL_bucketz00_929))
					{	/* Ast/venv.scm 259 */
						if (NULLP(CDR(BgL_bucketz00_929)))
							{	/* Ast/venv.scm 261 */
								return BFALSE;
							}
						else
							{
								obj_t BgL_globalsz00_934;

								BgL_globalsz00_934 = CDR(BgL_bucketz00_929);
							BgL_loopz00_935:
								if (NULLP(BgL_globalsz00_934))
									{	/* Ast/venv.scm 268 */
										return BFALSE;
									}
								else
									{	/* Ast/venv.scm 270 */
										bool_t BgL_testz00_2061;

										{	/* Ast/venv.scm 270 */
											obj_t BgL_auxz00_2062;

											{	/* Ast/venv.scm 270 */
												BgL_globalz00_bglt BgL_obj1515z00_1613;

												{	/* Ast/venv.scm 270 */
													obj_t BgL_pairz00_1612;

													BgL_pairz00_1612 = BgL_globalsz00_934;
													BgL_obj1515z00_1613 =
														(BgL_globalz00_bglt) (CAR(BgL_pairz00_1612));
												}
												BgL_auxz00_2062 =
													(((BgL_globalz00_bglt) CREF(BgL_obj1515z00_1613))->
													BgL_modulez00);
											}
											BgL_testz00_2061 = (BgL_auxz00_2062 == BgL_modulez00_16);
										}
										if (BgL_testz00_2061)
											{	/* Ast/venv.scm 270 */
												return CAR(BgL_globalsz00_934);
											}
										else
											{
												obj_t BgL_globalsz00_2068;

												BgL_globalsz00_2068 = CDR(BgL_globalsz00_934);
												BgL_globalsz00_934 = BgL_globalsz00_2068;
												goto BgL_loopz00_935;
											}
									}
							}
					}
				else
					{	/* Ast/venv.scm 259 */
						return BFALSE;
					}
			}
		}
	}



/* _find-global/module */
	obj_t BGl__findzd2globalzf2modulez20zzast_envz00(obj_t BgL_envz00_1836,
		obj_t BgL_idz00_1837, obj_t BgL_modulez00_1838)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 256 */
			return
				BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_1837,
				BgL_modulez00_1838);
		}
	}



/* get-global/module */
	BGL_EXPORTED_DEF obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t
		BgL_idz00_17, obj_t BgL_modulez00_18)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 278 */
			{	/* Ast/venv.scm 279 */
				obj_t BgL_globalz00_942;

				BgL_globalz00_942 =
					BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_17,
					BgL_modulez00_18);
				{	/* Ast/venv.scm 280 */
					bool_t BgL_testz00_2073;

					if (BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_942,
							BGl_globalz00zzast_varz00))
						{	/* Ast/venv.scm 280 */
							BgL_testz00_2073 = ((bool_t) 0);
						}
					else
						{	/* Ast/venv.scm 280 */
							if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
								{	/* Ast/venv.scm 280 */
									BgL_testz00_2073 = ((bool_t) 0);
								}
							else
								{	/* Ast/venv.scm 280 */
									BgL_testz00_2073 = ((bool_t) 1);
								}
						}
					if (BgL_testz00_2073)
						{	/* Ast/venv.scm 281 */
							obj_t BgL_arg3351z00_944;

							obj_t BgL_arg3353z00_946;

							BgL_arg3351z00_944 = CNST_TABLE_REF(((long) 2));
							{	/* Ast/venv.scm 283 */
								obj_t BgL_list3354z00_947;

								{	/* Ast/venv.scm 283 */
									obj_t BgL_arg3355z00_948;

									BgL_arg3355z00_948 = MAKE_PAIR(BgL_modulez00_18, BNIL);
									BgL_list3354z00_947 =
										MAKE_PAIR(BgL_idz00_17, BgL_arg3355z00_948);
								}
								BgL_arg3353z00_946 =
									BGl_formatz00zz__r4_output_6_10_3z00
									(BGl_string3552z00zzast_envz00, BgL_list3354z00_947);
							}
							BGl_internalzd2errorzd2zztools_errorz00(BgL_arg3351z00_944,
								BGl_string3553z00zzast_envz00, BgL_arg3353z00_946);
						}
					else
						{	/* Ast/venv.scm 280 */
							BFALSE;
						}
				}
				return BgL_globalz00_942;
			}
		}
	}



/* _get-global/module3550 */
	obj_t BGl__getzd2globalzf2module3550z20zzast_envz00(obj_t BgL_envz00_1839,
		obj_t BgL_idz00_1840, obj_t BgL_modulez00_1841)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 278 */
			return
				BGl_getzd2globalzf2modulez20zzast_envz00(BgL_idz00_1840,
				BgL_modulez00_1841);
		}
	}



/* warning-override-global! */
	obj_t BGl_warningzd2overridezd2globalz12z12zzast_envz00(obj_t BgL_nz00_19,
		obj_t BgL_oz00_20, obj_t BgL_msgz00_21)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 289 */
			{	/* Ast/venv.scm 290 */
				bool_t BgL_testz00_2084;

				{	/* Ast/venv.scm 290 */
					bool_t BgL_testz00_2085;

					{	/* Ast/venv.scm 290 */
						int BgL_arg3375z00_973;

						BgL_arg3375z00_973 = BGl_bigloozd2warningzd2zz__paramz00();
						BgL_testz00_2085 = ((long) (BgL_arg3375z00_973) > ((long) 0));
					}
					if (BgL_testz00_2085)
						{	/* Ast/venv.scm 290 */
							BgL_testz00_2084 =
								CBOOL
								(BGl_za2warningzd2overridenzd2variablesza2z00zzengine_paramz00);
						}
					else
						{	/* Ast/venv.scm 290 */
							BgL_testz00_2084 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_2084)
					{	/* Ast/venv.scm 292 */
						obj_t BgL_locz00_952;

						obj_t BgL_oldz00_953;

						obj_t BgL_newz00_954;

						obj_t BgL_msgz00_955;

						{	/* Ast/venv.scm 292 */
							obj_t BgL_arg3358z00_956;

							{
								BgL_globalz00_bglt BgL_auxz00_2090;

								BgL_auxz00_2090 = (BgL_globalz00_bglt) (BgL_oz00_20);
								BgL_arg3358z00_956 =
									(((BgL_globalz00_bglt) CREF(BgL_auxz00_2090))->BgL_srcz00);
							}
							BgL_locz00_952 =
								BGl_findzd2locationzd2zztools_locationz00(BgL_arg3358z00_956);
						}
						{	/* Ast/venv.scm 293 */
							obj_t BgL_arg3359z00_957;

							obj_t BgL_arg3360z00_958;

							BgL_arg3359z00_957 = CNST_TABLE_REF(((long) 3));
							{	/* Ast/venv.scm 293 */
								obj_t BgL_arg3361z00_959;

								obj_t BgL_arg3362z00_960;

								{
									BgL_variablez00_bglt BgL_auxz00_2095;

									BgL_auxz00_2095 = (BgL_variablez00_bglt) (BgL_oz00_20);
									BgL_arg3361z00_959 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_2095))->BgL_idz00);
								}
								{
									BgL_globalz00_bglt BgL_auxz00_2098;

									BgL_auxz00_2098 = (BgL_globalz00_bglt) (BgL_oz00_20);
									BgL_arg3362z00_960 =
										(((BgL_globalz00_bglt) CREF(BgL_auxz00_2098))->
										BgL_modulez00);
								}
								{	/* Ast/venv.scm 293 */
									obj_t BgL_list3364z00_962;

									{	/* Ast/venv.scm 293 */
										obj_t BgL_arg3365z00_963;

										BgL_arg3365z00_963 = MAKE_PAIR(BNIL, BNIL);
										BgL_list3364z00_962 =
											MAKE_PAIR(BgL_arg3362z00_960, BgL_arg3365z00_963);
									}
									BgL_arg3360z00_958 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
										(BgL_arg3361z00_959, BgL_list3364z00_962);
							}}
							BgL_oldz00_953 =
								MAKE_PAIR(BgL_arg3359z00_957, BgL_arg3360z00_958);
						}
						{	/* Ast/venv.scm 294 */
							obj_t BgL_arg3366z00_964;

							obj_t BgL_arg3367z00_965;

							BgL_arg3366z00_964 = CNST_TABLE_REF(((long) 3));
							{	/* Ast/venv.scm 294 */
								obj_t BgL_arg3368z00_966;

								obj_t BgL_arg3369z00_967;

								{
									BgL_variablez00_bglt BgL_auxz00_2106;

									BgL_auxz00_2106 = (BgL_variablez00_bglt) (BgL_nz00_19);
									BgL_arg3368z00_966 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_2106))->BgL_idz00);
								}
								{
									BgL_globalz00_bglt BgL_auxz00_2109;

									BgL_auxz00_2109 = (BgL_globalz00_bglt) (BgL_nz00_19);
									BgL_arg3369z00_967 =
										(((BgL_globalz00_bglt) CREF(BgL_auxz00_2109))->
										BgL_modulez00);
								}
								{	/* Ast/venv.scm 294 */
									obj_t BgL_list3371z00_969;

									{	/* Ast/venv.scm 294 */
										obj_t BgL_arg3372z00_970;

										BgL_arg3372z00_970 = MAKE_PAIR(BNIL, BNIL);
										BgL_list3371z00_969 =
											MAKE_PAIR(BgL_arg3369z00_967, BgL_arg3372z00_970);
									}
									BgL_arg3367z00_965 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
										(BgL_arg3368z00_966, BgL_list3371z00_969);
							}}
							BgL_newz00_954 =
								MAKE_PAIR(BgL_arg3366z00_964, BgL_arg3367z00_965);
						}
						if (PAIRP(BgL_msgz00_21))
							{	/* Ast/venv.scm 295 */
								BgL_msgz00_955 = CAR(BgL_msgz00_21);
							}
						else
							{	/* Ast/venv.scm 295 */
								BgL_msgz00_955 = BGl_string3554z00zzast_envz00;
							}
						if (CBOOL(BgL_locz00_952))
							{	/* Ast/venv.scm 296 */
								return
									BGl_userzd2warningzf2locationz20zztools_errorz00
									(BgL_locz00_952, BgL_oldz00_953, BgL_msgz00_955,
									BgL_newz00_954);
							}
						else
							{	/* Ast/venv.scm 296 */
								return
									BGl_userzd2warningzd2zztools_errorz00(BgL_oldz00_953,
									BgL_msgz00_955, BgL_newz00_954);
							}
					}
				else
					{	/* Ast/venv.scm 290 */
						return BFALSE;
					}
			}
		}
	}



/* error-rebind-global! */
	obj_t BGl_errorzd2rebindzd2globalz12z12zzast_envz00(obj_t BgL_oz00_22,
		obj_t BgL_srcz00_23)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 303 */
			{	/* Ast/venv.scm 305 */
				obj_t BgL_locz00_976;

				BgL_locz00_976 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_23);
				if (CBOOL(BgL_locz00_976))
					{	/* Ast/venv.scm 308 */
						obj_t BgL_arg3377z00_978;

						obj_t BgL_arg3378z00_979;

						{
							BgL_globalz00_bglt BgL_auxz00_2126;

							BgL_auxz00_2126 = (BgL_globalz00_bglt) (BgL_oz00_22);
							BgL_arg3377z00_978 =
								(((BgL_globalz00_bglt) CREF(BgL_auxz00_2126))->BgL_modulez00);
						}
						BgL_arg3378z00_979 = BGl_shapez00zztools_shapez00(BgL_oz00_22);
						return
							BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_976,
							BgL_arg3377z00_978, BGl_string3555z00zzast_envz00,
							BgL_arg3378z00_979, BNIL);
					}
				else
					{	/* Ast/venv.scm 309 */
						obj_t BgL_arg3380z00_981;

						obj_t BgL_arg3381z00_982;

						{
							BgL_globalz00_bglt BgL_auxz00_2131;

							BgL_auxz00_2131 = (BgL_globalz00_bglt) (BgL_oz00_22);
							BgL_arg3380z00_981 =
								(((BgL_globalz00_bglt) CREF(BgL_auxz00_2131))->BgL_modulez00);
						}
						BgL_arg3381z00_982 = BGl_shapez00zztools_shapez00(BgL_oz00_22);
						return
							BGl_userzd2errorzd2zztools_errorz00(BgL_arg3380z00_981,
							BGl_string3555z00zzast_envz00, BgL_arg3381z00_982, BNIL);
					}
			}
		}
	}



/* warning-rebind-global! */
	obj_t BGl_warningzd2rebindzd2globalz12z12zzast_envz00(obj_t BgL_oz00_24,
		obj_t BgL_srcz00_25)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 314 */
			{	/* Ast/venv.scm 316 */
				obj_t BgL_locz00_985;

				BgL_locz00_985 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_25);
				if (CBOOL(BgL_locz00_985))
					{	/* Ast/venv.scm 319 */
						obj_t BgL_arg3383z00_987;

						obj_t BgL_arg3384z00_988;

						{
							BgL_globalz00_bglt BgL_auxz00_2139;

							BgL_auxz00_2139 = (BgL_globalz00_bglt) (BgL_oz00_24);
							BgL_arg3383z00_987 =
								(((BgL_globalz00_bglt) CREF(BgL_auxz00_2139))->BgL_modulez00);
						}
						BgL_arg3384z00_988 = BGl_shapez00zztools_shapez00(BgL_oz00_24);
						return
							BGl_userzd2warningzf2locationz20zztools_errorz00(BgL_locz00_985,
							BgL_arg3383z00_987, BGl_string3555z00zzast_envz00,
							BgL_arg3384z00_988);
					}
				else
					{	/* Ast/venv.scm 320 */
						obj_t BgL_arg3385z00_989;

						obj_t BgL_arg3386z00_990;

						{
							BgL_globalz00_bglt BgL_auxz00_2144;

							BgL_auxz00_2144 = (BgL_globalz00_bglt) (BgL_oz00_24);
							BgL_arg3385z00_989 =
								(((BgL_globalz00_bglt) CREF(BgL_auxz00_2144))->BgL_modulez00);
						}
						BgL_arg3386z00_990 = BGl_shapez00zztools_shapez00(BgL_oz00_24);
						return
							BGl_userzd2warningzd2zztools_errorz00(BgL_arg3385z00_989,
							BGl_string3555z00zzast_envz00, BgL_arg3386z00_990);
					}
			}
		}
	}



/* bind-global! */
	BGL_EXPORTED_DEF BgL_globalz00_bglt BGl_bindzd2globalz12zc0zzast_envz00(obj_t
		BgL_idz00_26, obj_t BgL_modulez00_27, BgL_valuez00_bglt BgL_valuez00_28,
		obj_t BgL_importz00_29, obj_t BgL_srcz00_30)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 337 */
			{	/* Ast/venv.scm 340 */
				obj_t BgL_oldz00_991;

				{	/* Ast/venv.scm 340 */
					obj_t BgL_list3419z00_1028;

					BgL_list3419z00_1028 = MAKE_PAIR(BgL_modulez00_27, BNIL);
					BgL_oldz00_991 =
						BGl_findzd2globalzd2zzast_envz00(BgL_idz00_26,
						BgL_list3419z00_1028);
				}
				if (BGl_iszd2azf3z21zz__objectz00(BgL_oldz00_991,
						BGl_globalz00zzast_varz00))
					{	/* Ast/venv.scm 341 */
						if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
							{	/* Ast/venv.scm 343 */
								return (BgL_globalz00_bglt) (BgL_oldz00_991);
							}
						else
							{	/* Ast/venv.scm 345 */
								bool_t BgL_testz00_2156;

								{	/* Ast/venv.scm 345 */
									obj_t BgL_auxz00_2157;

									{
										BgL_globalz00_bglt BgL_auxz00_2158;

										BgL_auxz00_2158 = (BgL_globalz00_bglt) (BgL_oldz00_991);
										BgL_auxz00_2157 =
											(((BgL_globalz00_bglt) CREF(BgL_auxz00_2158))->
											BgL_modulez00);
									}
									BgL_testz00_2156 = (BgL_modulez00_27 == BgL_auxz00_2157);
								}
								if (BgL_testz00_2156)
									{	/* Ast/venv.scm 345 */
										BGl_warningzd2rebindzd2globalz12z12zzast_envz00
											(BgL_oldz00_991, BgL_srcz00_30);
										return (BgL_globalz00_bglt) (BgL_oldz00_991);
									}
								else
									{	/* Ast/venv.scm 345 */
										return
											(BgL_globalz00_bglt)
											(BGl_errorzd2rebindzd2globalz12z12zzast_envz00
											(BgL_oldz00_991, BgL_srcz00_30));
									}
							}
					}
				else
					{	/* Ast/venv.scm 350 */
						obj_t BgL_bucketz00_995;

						BgL_globalz00_bglt BgL_newz00_996;

						BgL_bucketz00_995 =
							BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
							BgL_idz00_26);
						{	/* Ast/var.scm 32 */
							obj_t BgL_arg3413z00_1022;

							obj_t BgL_arg3414z00_1023;

							obj_t BgL_arg3417z00_1026;

							BgL_arg3413z00_1022 = CNST_TABLE_REF(((long) 4));
							BgL_arg3414z00_1023 = CNST_TABLE_REF(((long) 5));
							if ((BgL_importz00_29 == CNST_TABLE_REF(((long) 6))))
								{	/* Ast/venv.scm 353 */
									BgL_arg3417z00_1026 = BGl_string3556z00zzast_envz00;
								}
							else
								{	/* Ast/venv.scm 353 */
									BgL_arg3417z00_1026 =
										BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00
										(BgL_modulez00_27);
								}
							BgL_newz00_996 =
								BGl_makezd2globalzd2zzast_varz00(BgL_idz00_26, BFALSE,
								(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00),
								BgL_valuez00_28, BgL_arg3413z00_1022, BUNSPEC,
								BgL_arg3414z00_1023, ((long) 0), BgL_modulez00_27,
								BgL_importz00_29, ((bool_t) 1), BFALSE, ((bool_t) 1), BNIL,
								BgL_srcz00_30, BgL_arg3417z00_1026);
						}
						{	/* Ast/venv.scm 361 */
							bool_t BgL_testz00_2175;

							if (PAIRP(BgL_bucketz00_995))
								{	/* Ast/venv.scm 361 */
									BgL_testz00_2175 = NULLP(CDR(BgL_bucketz00_995));
								}
							else
								{	/* Ast/venv.scm 361 */
									BgL_testz00_2175 = ((bool_t) 1);
								}
							if (BgL_testz00_2175)
								{	/* Ast/venv.scm 361 */
									{	/* Ast/venv.scm 363 */
										obj_t BgL_arg3391z00_998;

										{	/* Ast/venv.scm 363 */
											obj_t BgL_list3392z00_999;

											{	/* Ast/venv.scm 363 */
												obj_t BgL_arg3393z00_1000;

												BgL_arg3393z00_1000 =
													MAKE_PAIR((obj_t) (BgL_newz00_996), BNIL);
												BgL_list3392z00_999 =
													MAKE_PAIR(BgL_idz00_26, BgL_arg3393z00_1000);
											}
											BgL_arg3391z00_998 = BgL_list3392z00_999;
										}
										BGl_hashtablezd2putz12zc0zz__hashz00
											(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_26,
											BgL_arg3391z00_998);
									}
									return BgL_newz00_996;
								}
							else
								{	/* Ast/venv.scm 366 */
									obj_t BgL_oldza2za2_1001;

									BgL_oldza2za2_1001 = CDR(BgL_bucketz00_995);
									{	/* Ast/venv.scm 366 */
										obj_t BgL_midz00_1002;

										{	/* Ast/venv.scm 368 */
											obj_t BgL_arg3408z00_1018;

											{	/* Ast/venv.scm 368 */
												BgL_globalz00_bglt BgL_obj1515z00_1639;

												{	/* Ast/venv.scm 368 */
													obj_t BgL_pairz00_1638;

													BgL_pairz00_1638 = BgL_oldza2za2_1001;
													BgL_obj1515z00_1639 =
														(BgL_globalz00_bglt) (CAR(BgL_pairz00_1638));
												}
												BgL_arg3408z00_1018 =
													(((BgL_globalz00_bglt) CREF(BgL_obj1515z00_1639))->
													BgL_modulez00);
											}
											BgL_midz00_1002 =
												BGl_modulezd2initializa7ationzd2idza7zzmodule_modulez00
												(BgL_arg3408z00_1018);
										}
										{	/* Ast/venv.scm 367 */

											{	/* Ast/venv.scm 370 */
												bool_t BgL_testz00_2189;

												{	/* Ast/venv.scm 370 */
													obj_t BgL_arg3406z00_1016;

													{	/* Ast/venv.scm 370 */
														BgL_globalz00_bglt BgL_obj1515z00_1641;

														{	/* Ast/venv.scm 370 */
															obj_t BgL_pairz00_1640;

															BgL_pairz00_1640 = BgL_oldza2za2_1001;
															BgL_obj1515z00_1641 =
																(BgL_globalz00_bglt) (CAR(BgL_pairz00_1640));
														}
														BgL_arg3406z00_1016 =
															(((BgL_globalz00_bglt)
																CREF(BgL_obj1515z00_1641))->BgL_modulez00);
													}
													BgL_testz00_2189 =
														(BgL_arg3406z00_1016 ==
														BGl_za2moduleza2z00zzmodule_modulez00);
												}
												if (BgL_testz00_2189)
													{	/* Ast/venv.scm 370 */
														{	/* Ast/venv.scm 372 */
															bool_t BgL_testz00_2194;

															if ((BgL_idz00_26 == BgL_midz00_1002))
																{	/* Ast/venv.scm 372 */
																	BgL_testz00_2194 = ((bool_t) 0);
																}
															else
																{	/* Ast/venv.scm 372 */
																	if (CBOOL
																		(BGl_za2libzd2modeza2zd2zzengine_paramz00))
																		{	/* Ast/venv.scm 372 */
																			BgL_testz00_2194 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 372 */
																			BgL_testz00_2194 = ((bool_t) 1);
																		}
																}
															if (BgL_testz00_2194)
																{	/* Ast/venv.scm 372 */
																	BGl_warningzd2overridezd2globalz12z12zzast_envz00
																		(CAR(BgL_oldza2za2_1001),
																		(obj_t) (BgL_newz00_996), BNIL);
																}
															else
																{	/* Ast/venv.scm 372 */
																	BFALSE;
																}
														}
														{	/* Ast/venv.scm 374 */
															obj_t BgL_arg3399z00_1008;

															obj_t BgL_arg3400z00_1009;

															BgL_arg3399z00_1008 = CDR(BgL_bucketz00_995);
															{	/* Ast/venv.scm 374 */
																obj_t BgL_arg3401z00_1010;

																{	/* Ast/venv.scm 374 */
																	obj_t BgL_pairz00_1644;

																	BgL_pairz00_1644 = BgL_bucketz00_995;
																	BgL_arg3401z00_1010 =
																		CDR(CDR(BgL_pairz00_1644));
																}
																BgL_arg3400z00_1009 =
																	MAKE_PAIR(
																	(obj_t) (BgL_newz00_996),
																	BgL_arg3401z00_1010);
															}
															SET_CDR(BgL_arg3399z00_1008, BgL_arg3400z00_1009);
														}
														return BgL_newz00_996;
													}
												else
													{	/* Ast/venv.scm 377 */
														obj_t BgL_newza2za2_1011;

														BgL_newza2za2_1011 =
															MAKE_PAIR(
															(obj_t) (BgL_newz00_996), BgL_oldza2za2_1001);
														{	/* Ast/venv.scm 378 */
															bool_t BgL_testz00_2210;

															if ((BgL_idz00_26 == BgL_midz00_1002))
																{	/* Ast/venv.scm 378 */
																	BgL_testz00_2210 = ((bool_t) 0);
																}
															else
																{	/* Ast/venv.scm 378 */
																	if (CBOOL
																		(BGl_za2libzd2modeza2zd2zzengine_paramz00))
																		{	/* Ast/venv.scm 378 */
																			BgL_testz00_2210 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 378 */
																			BgL_testz00_2210 = ((bool_t) 1);
																		}
																}
															if (BgL_testz00_2210)
																{	/* Ast/venv.scm 378 */
																	BGl_warningzd2overridezd2globalz12z12zzast_envz00
																		((obj_t) (BgL_newz00_996),
																		CAR(BgL_oldza2za2_1001), BNIL);
																}
															else
																{	/* Ast/venv.scm 378 */
																	BFALSE;
																}
														}
														SET_CDR(BgL_bucketz00_995, BgL_newza2za2_1011);
														return BgL_newz00_996;
													}
											}
										}
									}
								}
						}
					}
			}
		}
	}



/* _bind-global! */
	obj_t BGl__bindzd2globalz12zc0zzast_envz00(obj_t BgL_envz00_1842,
		obj_t BgL_idz00_1843, obj_t BgL_modulez00_1844, obj_t BgL_valuez00_1845,
		obj_t BgL_importz00_1846, obj_t BgL_srcz00_1847)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 337 */
			return
				(obj_t) (BGl_bindzd2globalz12zc0zzast_envz00(BgL_idz00_1843,
					BgL_modulez00_1844, (BgL_valuez00_bglt) (BgL_valuez00_1845),
					BgL_importz00_1846, BgL_srcz00_1847));
		}
	}



/* unbind-global! */
	BGL_EXPORTED_DEF obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t
		BgL_idz00_31, obj_t BgL_modulez00_32)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 386 */
			{	/* Ast/venv.scm 387 */
				obj_t BgL_globalz00_1029;

				{	/* Ast/venv.scm 387 */
					obj_t BgL_list3434z00_1049;

					BgL_list3434z00_1049 = MAKE_PAIR(BgL_modulez00_32, BNIL);
					BgL_globalz00_1029 =
						BGl_findzd2globalzd2zzast_envz00(BgL_idz00_31,
						BgL_list3434z00_1049);
				}
				if (BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_1029,
						BGl_globalz00zzast_varz00))
					{	/* Ast/venv.scm 390 */
						obj_t BgL_bucketz00_1031;

						BgL_bucketz00_1031 =
							BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
							BgL_idz00_31);
						{	/* Ast/venv.scm 391 */
							obj_t BgL_g3275z00_1032;

							BgL_g3275z00_1032 = CDR(BgL_bucketz00_1031);
							{
								obj_t BgL_curz00_1033;

								obj_t BgL_prevz00_1034;

								BgL_curz00_1033 = BgL_g3275z00_1032;
								BgL_prevz00_1034 = BgL_bucketz00_1031;
							BgL_loopz00_1035:
								if ((CAR(BgL_curz00_1033) == BgL_globalz00_1029))
									{	/* Ast/venv.scm 394 */
										obj_t BgL_auxz00_2231;

										BgL_auxz00_2231 = CDR(BgL_curz00_1033);
										return SET_CDR(BgL_prevz00_1034, BgL_auxz00_2231);
									}
								else
									{
										obj_t BgL_prevz00_2236;

										obj_t BgL_curz00_2234;

										BgL_curz00_2234 = CDR(BgL_curz00_1033);
										BgL_prevz00_2236 = CDR(BgL_prevz00_1034);
										BgL_prevz00_1034 = BgL_prevz00_2236;
										BgL_curz00_1033 = BgL_curz00_2234;
										goto BgL_loopz00_1035;
									}
							}
						}
					}
				else
					{	/* Ast/venv.scm 389 */
						obj_t BgL_arg3428z00_1043;

						{	/* Ast/venv.scm 389 */
							obj_t BgL_arg3430z00_1045;

							obj_t BgL_arg3431z00_1046;

							BgL_arg3430z00_1045 = CNST_TABLE_REF(((long) 3));
							{	/* Ast/venv.scm 389 */
								obj_t BgL_list3432z00_1047;

								{	/* Ast/venv.scm 389 */
									obj_t BgL_arg3433z00_1048;

									BgL_arg3433z00_1048 = MAKE_PAIR(BNIL, BNIL);
									BgL_list3432z00_1047 =
										MAKE_PAIR(BgL_modulez00_32, BgL_arg3433z00_1048);
								}
								BgL_arg3431z00_1046 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_idz00_31,
									BgL_list3432z00_1047);
							}
							BgL_arg3428z00_1043 =
								MAKE_PAIR(BgL_arg3430z00_1045, BgL_arg3431z00_1046);
						}
						return
							BGl_userzd2errorzd2zztools_errorz00(BGl_string3557z00zzast_envz00,
							BGl_string3558z00zzast_envz00, BgL_arg3428z00_1043, BNIL);
					}
			}
		}
	}



/* _unbind-global! */
	obj_t BGl__unbindzd2globalz12zc0zzast_envz00(obj_t BgL_envz00_1848,
		obj_t BgL_idz00_1849, obj_t BgL_modulez00_1850)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 386 */
			return
				BGl_unbindzd2globalz12zc0zzast_envz00(BgL_idz00_1849,
				BgL_modulez00_1850);
		}
	}



/* for-each-global! */
	BGL_EXPORTED_DEF obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t
		BgL_procz00_33, obj_t BgL_envz00_34)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 400 */
			{	/* Ast/venv.scm 401 */
				obj_t BgL_arg3435z00_1050;

				if (NULLP(BgL_envz00_34))
					{	/* Ast/venv.scm 401 */
						BgL_arg3435z00_1050 = BGl_za2Genvza2z00zzast_envz00;
					}
				else
					{	/* Ast/venv.scm 401 */
						BgL_arg3435z00_1050 = CAR(BgL_envz00_34);
					}
				{	/* Ast/venv.scm 402 */
					obj_t BgL_zc3anonymousza33438ze3z83_1851;

					BgL_zc3anonymousza33438ze3z83_1851 =
						make_fx_procedure(BGl_zc3anonymousza33438ze3z83zzast_envz00,
						(int) (((long) 2)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3anonymousza33438ze3z83_1851,
						(int) (((long) 0)), BgL_procz00_33);
					return
						BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_arg3435z00_1050,
						BgL_zc3anonymousza33438ze3z83_1851);
				}
			}
		}
	}



/* _for-each-global! */
	obj_t BGl__forzd2eachzd2globalz12z12zzast_envz00(obj_t BgL_envz00_1852,
		obj_t BgL_procz00_1853, obj_t BgL_envz00_1854)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 400 */
			return
				BGl_forzd2eachzd2globalz12z12zzast_envz00(BgL_procz00_1853,
				BgL_envz00_1854);
		}
	}



/* <anonymous:3438> */
	obj_t BGl_zc3anonymousza33438ze3z83zzast_envz00(obj_t BgL_envz00_1855,
		obj_t BgL_kz00_1857, obj_t BgL_bucketz00_1858)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 402 */
			{	/* Ast/venv.scm 402 */
				obj_t BgL_procz00_1856;

				BgL_procz00_1856 = PROCEDURE_REF(BgL_envz00_1855, (int) (((long) 0)));
				{
					obj_t BgL_kz00_1053;

					obj_t BgL_bucketz00_1054;

					{	/* Ast/venv.scm 402 */
						bool_t BgL_auxz00_2257;

						BgL_kz00_1053 = BgL_kz00_1857;
						BgL_bucketz00_1054 = BgL_bucketz00_1858;
						{	/* Ast/venv.scm 402 */
							obj_t BgL_g3285z00_1056;

							BgL_g3285z00_1056 = CDR(BgL_bucketz00_1054);
							{
								obj_t BgL_l3282z00_1057;

								BgL_l3282z00_1057 = BgL_g3285z00_1056;
							BgL_forzd2each3284zd2_1058:
								if (PAIRP(BgL_l3282z00_1057))
									{	/* Ast/venv.scm 402 */
										{	/* Ast/venv.scm 402 */
											obj_t BgL_arg3440z00_1060;

											BgL_arg3440z00_1060 = CAR(BgL_l3282z00_1057);
											PROCEDURE_ENTRY(BgL_procz00_1856) (BgL_procz00_1856,
												BgL_arg3440z00_1060, BEOA);
										}
										{
											obj_t BgL_l3282z00_2264;

											BgL_l3282z00_2264 = CDR(BgL_l3282z00_1057);
											BgL_l3282z00_1057 = BgL_l3282z00_2264;
											goto BgL_forzd2each3284zd2_1058;
										}
									}
								else
									{	/* Ast/venv.scm 402 */
										BgL_auxz00_2257 = ((bool_t) 1);
									}
							}
						}
						return BBOOL(BgL_auxz00_2257);
					}
				}
			}
		}
	}



/* global-bucket-position */
	BGL_EXPORTED_DEF obj_t BGl_globalzd2bucketzd2positionz00zzast_envz00(obj_t
		BgL_idz00_35, obj_t BgL_modulez00_36)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 407 */
			{	/* Ast/venv.scm 408 */
				obj_t BgL_bucketz00_1063;

				BgL_bucketz00_1063 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_35);
				if (PAIRP(BgL_bucketz00_1063))
					{
						obj_t BgL_globalsz00_1066;

						long BgL_posz00_1067;

						{	/* Ast/venv.scm 411 */
							long BgL_auxz00_2270;

							BgL_globalsz00_1066 = CDR(BgL_bucketz00_1063);
							BgL_posz00_1067 = ((long) 0);
						BgL_loopz00_1068:
							if (NULLP(BgL_globalsz00_1066))
								{	/* Ast/venv.scm 414 */
									BgL_auxz00_2270 = ((long) -1);
								}
							else
								{	/* Ast/venv.scm 416 */
									bool_t BgL_testz00_2273;

									{	/* Ast/venv.scm 416 */
										obj_t BgL_auxz00_2274;

										{	/* Ast/venv.scm 416 */
											BgL_globalz00_bglt BgL_obj1515z00_1671;

											{	/* Ast/venv.scm 416 */
												obj_t BgL_pairz00_1670;

												BgL_pairz00_1670 = BgL_globalsz00_1066;
												BgL_obj1515z00_1671 =
													(BgL_globalz00_bglt) (CAR(BgL_pairz00_1670));
											}
											BgL_auxz00_2274 =
												(((BgL_globalz00_bglt) CREF(BgL_obj1515z00_1671))->
												BgL_modulez00);
										}
										BgL_testz00_2273 = (BgL_auxz00_2274 == BgL_modulez00_36);
									}
									if (BgL_testz00_2273)
										{	/* Ast/venv.scm 416 */
											BgL_auxz00_2270 = BgL_posz00_1067;
										}
									else
										{
											long BgL_posz00_2281;

											obj_t BgL_globalsz00_2279;

											BgL_globalsz00_2279 = CDR(BgL_globalsz00_1066);
											BgL_posz00_2281 = (BgL_posz00_1067 + ((long) 1));
											BgL_posz00_1067 = BgL_posz00_2281;
											BgL_globalsz00_1066 = BgL_globalsz00_2279;
											goto BgL_loopz00_1068;
										}
								}
							return BINT(BgL_auxz00_2270);
						}
					}
				else
					{	/* Ast/venv.scm 409 */
						return BINT(((long) -1));
		}}}
	}



/* _global-bucket-position */
	obj_t BGl__globalzd2bucketzd2positionz00zzast_envz00(obj_t BgL_envz00_1859,
		obj_t BgL_idz00_1860, obj_t BgL_modulez00_1861)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 407 */
			return
				BGl_globalzd2bucketzd2positionz00zzast_envz00(BgL_idz00_1860,
				BgL_modulez00_1861);
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_restorezd2valuezd2typesz123287zd2envzc0zzast_envz00);
		}
	}



/* restore-value-types! */
	obj_t BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_bglt
		BgL_valuez00_7)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 152 */
			{	/* Ast/venv.scm 152 */
				obj_t BgL_method3288z00_1675;

				{	/* Ast/venv.scm 152 */
					BgL_objectz00_bglt BgL_objz00_1676;

					BgL_objz00_1676 = (BgL_objectz00_bglt) (BgL_valuez00_7);
					{	/* Ast/venv.scm 152 */
						long BgL_objzd2classzd2numz00_1677;

						BgL_objzd2classzd2numz00_1677 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1676);
						{	/* Ast/venv.scm 152 */
							obj_t BgL_arg2356z00_1678;

							BgL_arg2356z00_1678 =
								PROCEDURE_REF
								(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
								(int) (((long) 1)));
							{	/* Ast/venv.scm 152 */
								obj_t BgL_arrayz00_1680;

								int BgL_offsetz00_1681;

								BgL_arrayz00_1680 = BgL_arg2356z00_1678;
								BgL_offsetz00_1681 = (int) (BgL_objzd2classzd2numz00_1677);
								{	/* Ast/venv.scm 152 */
									long BgL_offsetz00_1682;

									BgL_offsetz00_1682 =
										((long) (BgL_offsetz00_1681) - OBJECT_TYPE);
									{	/* Ast/venv.scm 152 */
										long BgL_modz00_1683;

										{	/* Ast/venv.scm 152 */
											int BgL_arg2358z00_1684;

											BgL_arg2358z00_1684 = (int) (((long) 8));
											{	/* Ast/venv.scm 152 */
												long BgL_auxz00_2296;

												BgL_auxz00_2296 = (long) (BgL_arg2358z00_1684);
												BgL_modz00_1683 =
													(BgL_offsetz00_1682 / BgL_auxz00_2296);
										}}
										{	/* Ast/venv.scm 152 */
											long BgL_restz00_1685;

											{	/* Ast/venv.scm 152 */
												int BgL_arg2357z00_1686;

												BgL_arg2357z00_1686 = (int) (((long) 8));
												{	/* Ast/venv.scm 152 */
													long BgL_auxz00_2300;

													BgL_auxz00_2300 = (long) (BgL_arg2357z00_1686);
													BgL_restz00_1685 =
														(BgL_offsetz00_1682 % BgL_auxz00_2300);
											}}
											{	/* Ast/venv.scm 152 */

												BgL_method3288z00_1675 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1680,
														(int) (BgL_modz00_1683)), (int) (BgL_restz00_1685));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3288z00_1675) (BgL_method3288z00_1675,
					(obj_t) (BgL_valuez00_7), BEOA);
			}
		}
	}



/* _restore-value-types! */
	obj_t BGl__restorezd2valuezd2typesz12z12zzast_envz00(obj_t BgL_envz00_1827,
		obj_t BgL_valuez00_1828)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 152 */
			return
				BGl_restorezd2valuezd2typesz12z12zzast_envz00(
				(BgL_valuez00_bglt) (BgL_valuez00_1828));
		}
	}



/* _restore-value-types!3287 */
	obj_t BGl__restorezd2valuezd2typesz123287z12zzast_envz00(obj_t
		BgL_envz00_1862, obj_t BgL_valuez00_1863)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_funz00zzast_varz00, BGl_proc3559z00zzast_envz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_sfunz00zzast_varz00, BGl_proc3560z00zzast_envz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_isfunz00zzinline_inlinez00, BGl_proc3561z00zzast_envz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_cfunz00zzast_varz00, BGl_proc3562z00zzast_envz00);
		}
	}



/* restore-value-types!3298 */
	obj_t BGl_restorezd2valuezd2typesz123298z12zzast_envz00(obj_t BgL_envz00_1868,
		obj_t BgL_valuez00_1869)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 208 */
			{
				BgL_cfunz00_bglt BgL_valuez00_1507;

				{	/* Ast/venv.scm 208 */
					bool_t BgL_auxz00_2316;

					BgL_valuez00_1507 = (BgL_cfunz00_bglt) (BgL_valuez00_1869);
					{

						{	/* Ast/venv.scm 208 */
							obj_t BgL_nextzd2method3297zd2_1519;

							BgL_nextzd2method3297zd2_1519 =
								BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
								(BgL_objectz00_bglt) (BgL_valuez00_1507),
								BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
								BGl_cfunz00zzast_varz00);
							if (PROCEDUREP(BgL_nextzd2method3297zd2_1519))
								{	/* Ast/venv.scm 208 */
									PROCEDURE_ENTRY(BgL_nextzd2method3297zd2_1519)
										(BgL_nextzd2method3297zd2_1519, (obj_t) (BgL_valuez00_1507),
										BEOA);
								}
							else
								{	/* Ast/venv.scm 208 */
									{	/* Ast/venv.scm 208 */
										BgL_valuez00_bglt BgL_valuez00_1790;

										BgL_valuez00_1790 = (BgL_valuez00_bglt) (BgL_valuez00_1507);
										{	/* Ast/venv.scm 208 */
											obj_t BgL_method3288z00_1791;

											{	/* Ast/venv.scm 208 */
												BgL_objectz00_bglt BgL_objz00_1792;

												BgL_objz00_1792 =
													(BgL_objectz00_bglt) (BgL_valuez00_1790);
												{	/* Ast/venv.scm 208 */
													long BgL_objzd2classzd2numz00_1793;

													BgL_objzd2classzd2numz00_1793 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_1792);
													{	/* Ast/venv.scm 208 */
														obj_t BgL_arg2356z00_1794;

														BgL_arg2356z00_1794 =
															PROCEDURE_REF
															(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
															(int) (((long) 1)));
														{	/* Ast/venv.scm 208 */
															obj_t BgL_arrayz00_1796;

															int BgL_offsetz00_1797;

															BgL_arrayz00_1796 = BgL_arg2356z00_1794;
															BgL_offsetz00_1797 =
																(int) (BgL_objzd2classzd2numz00_1793);
															{	/* Ast/venv.scm 208 */
																long BgL_offsetz00_1798;

																BgL_offsetz00_1798 =
																	((long) (BgL_offsetz00_1797) - OBJECT_TYPE);
																{	/* Ast/venv.scm 208 */
																	long BgL_modz00_1799;

																	{	/* Ast/venv.scm 208 */
																		int BgL_arg2358z00_1800;

																		BgL_arg2358z00_1800 = (int) (((long) 8));
																		{	/* Ast/venv.scm 208 */
																			long BgL_auxz00_2333;

																			BgL_auxz00_2333 =
																				(long) (BgL_arg2358z00_1800);
																			BgL_modz00_1799 =
																				(BgL_offsetz00_1798 / BgL_auxz00_2333);
																	}}
																	{	/* Ast/venv.scm 208 */
																		long BgL_restz00_1801;

																		{	/* Ast/venv.scm 208 */
																			int BgL_arg2357z00_1802;

																			BgL_arg2357z00_1802 = (int) (((long) 8));
																			{	/* Ast/venv.scm 208 */
																				long BgL_auxz00_2337;

																				BgL_auxz00_2337 =
																					(long) (BgL_arg2357z00_1802);
																				BgL_restz00_1801 =
																					(BgL_offsetz00_1798 %
																					BgL_auxz00_2337);
																		}}
																		{	/* Ast/venv.scm 208 */

																			BgL_method3288z00_1791 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_1796,
																					(int) (BgL_modz00_1799)),
																				(int) (BgL_restz00_1801));
											}}}}}}}}
											PROCEDURE_ENTRY(BgL_method3288z00_1791)
												(BgL_method3288z00_1791, (obj_t) (BgL_valuez00_1790),
												BEOA);
						}}}}
						{
							obj_t BgL_argsz00_1511;

							{	/* Ast/venv.scm 211 */
								obj_t BgL_arg3530z00_1513;

								BgL_arg3530z00_1513 =
									(((BgL_cfunz00_bglt) CREF(BgL_valuez00_1507))->
									BgL_argszd2typezd2);
								BgL_argsz00_1511 = BgL_arg3530z00_1513;
							BgL_loopz00_1512:
								if (PAIRP(BgL_argsz00_1511))
									{	/* Ast/venv.scm 212 */
										{	/* Ast/venv.scm 214 */
											BgL_typez00_bglt BgL_arg3532z00_1515;

											{	/* Ast/venv.scm 214 */
												obj_t BgL_arg3533z00_1516;

												{	/* Ast/venv.scm 214 */
													BgL_typez00_bglt BgL_obj1342z00_1785;

													{	/* Ast/venv.scm 214 */
														obj_t BgL_pairz00_1784;

														BgL_pairz00_1784 = BgL_argsz00_1511;
														BgL_obj1342z00_1785 =
															(BgL_typez00_bglt) (CAR(BgL_pairz00_1784));
													}
													BgL_arg3533z00_1516 =
														(((BgL_typez00_bglt) CREF(BgL_obj1342z00_1785))->
														BgL_idz00);
												}
												BgL_arg3532z00_1515 =
													BGl_findzd2typezd2zztype_envz00(BgL_arg3533z00_1516);
											}
											{	/* Ast/venv.scm 214 */
												obj_t BgL_auxz00_2354;

												BgL_auxz00_2354 = (obj_t) (BgL_arg3532z00_1515);
												SET_CAR(BgL_argsz00_1511, BgL_auxz00_2354);
											}
										}
										{
											obj_t BgL_argsz00_2357;

											BgL_argsz00_2357 = CDR(BgL_argsz00_1511);
											BgL_argsz00_1511 = BgL_argsz00_2357;
											goto BgL_loopz00_1512;
										}
									}
								else
									{	/* Ast/venv.scm 212 */
										BgL_auxz00_2316 = ((bool_t) 0);
									}
							}
						}
					}
					return BBOOL(BgL_auxz00_2316);
				}
			}
		}
	}



/* restore-value-types!3296 */
	obj_t BGl_restorezd2valuezd2typesz123296z12zzast_envz00(obj_t BgL_envz00_1870,
		obj_t BgL_valuez00_1871)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 201 */
			{
				BgL_isfunz00_bglt BgL_valuez00_1501;

				BgL_valuez00_1501 = (BgL_isfunz00_bglt) (BgL_valuez00_1871);
				{

					{	/* Ast/venv.scm 201 */
						obj_t BgL_nextzd2method3295zd2_1505;

						BgL_nextzd2method3295zd2_1505 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							(BgL_objectz00_bglt) (BgL_valuez00_1501),
							BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
							BGl_isfunz00zzinline_inlinez00);
						if (PROCEDUREP(BgL_nextzd2method3295zd2_1505))
							{	/* Ast/venv.scm 201 */
								PROCEDURE_ENTRY(BgL_nextzd2method3295zd2_1505)
									(BgL_nextzd2method3295zd2_1505, (obj_t) (BgL_valuez00_1501),
									BEOA);
							}
						else
							{	/* Ast/venv.scm 201 */
								{	/* Ast/venv.scm 201 */
									BgL_valuez00_bglt BgL_valuez00_1756;

									BgL_valuez00_1756 = (BgL_valuez00_bglt) (BgL_valuez00_1501);
									{	/* Ast/venv.scm 201 */
										obj_t BgL_method3288z00_1757;

										{	/* Ast/venv.scm 201 */
											BgL_objectz00_bglt BgL_objz00_1758;

											BgL_objz00_1758 =
												(BgL_objectz00_bglt) (BgL_valuez00_1756);
											{	/* Ast/venv.scm 201 */
												long BgL_objzd2classzd2numz00_1759;

												BgL_objzd2classzd2numz00_1759 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1758);
												{	/* Ast/venv.scm 201 */
													obj_t BgL_arg2356z00_1760;

													BgL_arg2356z00_1760 =
														PROCEDURE_REF
														(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
														(int) (((long) 1)));
													{	/* Ast/venv.scm 201 */
														obj_t BgL_arrayz00_1762;

														int BgL_offsetz00_1763;

														BgL_arrayz00_1762 = BgL_arg2356z00_1760;
														BgL_offsetz00_1763 =
															(int) (BgL_objzd2classzd2numz00_1759);
														{	/* Ast/venv.scm 201 */
															long BgL_offsetz00_1764;

															BgL_offsetz00_1764 =
																((long) (BgL_offsetz00_1763) - OBJECT_TYPE);
															{	/* Ast/venv.scm 201 */
																long BgL_modz00_1765;

																{	/* Ast/venv.scm 201 */
																	int BgL_arg2358z00_1766;

																	BgL_arg2358z00_1766 = (int) (((long) 8));
																	{	/* Ast/venv.scm 201 */
																		long BgL_auxz00_2377;

																		BgL_auxz00_2377 =
																			(long) (BgL_arg2358z00_1766);
																		BgL_modz00_1765 =
																			(BgL_offsetz00_1764 / BgL_auxz00_2377);
																}}
																{	/* Ast/venv.scm 201 */
																	long BgL_restz00_1767;

																	{	/* Ast/venv.scm 201 */
																		int BgL_arg2357z00_1768;

																		BgL_arg2357z00_1768 = (int) (((long) 8));
																		{	/* Ast/venv.scm 201 */
																			long BgL_auxz00_2381;

																			BgL_auxz00_2381 =
																				(long) (BgL_arg2357z00_1768);
																			BgL_restz00_1767 =
																				(BgL_offsetz00_1764 % BgL_auxz00_2381);
																	}}
																	{	/* Ast/venv.scm 201 */

																		BgL_method3288z00_1757 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1762,
																				(int) (BgL_modz00_1765)),
																			(int) (BgL_restz00_1767));
										}}}}}}}}
										PROCEDURE_ENTRY(BgL_method3288z00_1757)
											(BgL_method3288z00_1757, (obj_t) (BgL_valuez00_1756),
											BEOA);
					}}}}
					{	/* Ast/venv.scm 203 */
						BgL_nodez00_bglt BgL_arg3528z00_1504;

						{
							obj_t BgL_auxz00_2391;

							{	/* Ast/venv.scm 203 */
								BgL_objectz00_bglt BgL_auxz00_2392;

								BgL_auxz00_2392 = (BgL_objectz00_bglt) (BgL_valuez00_1501);
								BgL_auxz00_2391 = BGL_OBJECT_WIDENING(BgL_auxz00_2392);
							}
							BgL_arg3528z00_1504 =
								(((BgL_isfunz00_bglt) CREF(BgL_auxz00_2391))->
								BgL_originalzd2bodyzd2);
						}
						return BGl_hrtypezd2nodez12zc0zzast_hrtypez00(BgL_arg3528z00_1504);
					}
				}
			}
		}
	}



/* restore-value-types!3294 */
	obj_t BGl_restorezd2valuezd2typesz123294z12zzast_envz00(obj_t BgL_envz00_1872,
		obj_t BgL_valuez00_1873)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 166 */
			{
				BgL_sfunz00_bglt BgL_valuez00_1469;

				BgL_valuez00_1469 = (BgL_sfunz00_bglt) (BgL_valuez00_1873);
				{

					{	/* Ast/venv.scm 166 */
						obj_t BgL_nextzd2method3293zd2_1499;

						BgL_nextzd2method3293zd2_1499 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							(BgL_objectz00_bglt) (BgL_valuez00_1469),
							BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
							BGl_sfunz00zzast_varz00);
						if (PROCEDUREP(BgL_nextzd2method3293zd2_1499))
							{	/* Ast/venv.scm 166 */
								PROCEDURE_ENTRY(BgL_nextzd2method3293zd2_1499)
									(BgL_nextzd2method3293zd2_1499, (obj_t) (BgL_valuez00_1469),
									BEOA);
							}
						else
							{	/* Ast/venv.scm 166 */
								{	/* Ast/venv.scm 166 */
									BgL_valuez00_bglt BgL_valuez00_1728;

									BgL_valuez00_1728 = (BgL_valuez00_bglt) (BgL_valuez00_1469);
									{	/* Ast/venv.scm 166 */
										obj_t BgL_method3288z00_1729;

										{	/* Ast/venv.scm 166 */
											BgL_objectz00_bglt BgL_objz00_1730;

											BgL_objz00_1730 =
												(BgL_objectz00_bglt) (BgL_valuez00_1728);
											{	/* Ast/venv.scm 166 */
												long BgL_objzd2classzd2numz00_1731;

												BgL_objzd2classzd2numz00_1731 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1730);
												{	/* Ast/venv.scm 166 */
													obj_t BgL_arg2356z00_1732;

													BgL_arg2356z00_1732 =
														PROCEDURE_REF
														(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
														(int) (((long) 1)));
													{	/* Ast/venv.scm 166 */
														obj_t BgL_arrayz00_1734;

														int BgL_offsetz00_1735;

														BgL_arrayz00_1734 = BgL_arg2356z00_1732;
														BgL_offsetz00_1735 =
															(int) (BgL_objzd2classzd2numz00_1731);
														{	/* Ast/venv.scm 166 */
															long BgL_offsetz00_1736;

															BgL_offsetz00_1736 =
																((long) (BgL_offsetz00_1735) - OBJECT_TYPE);
															{	/* Ast/venv.scm 166 */
																long BgL_modz00_1737;

																{	/* Ast/venv.scm 166 */
																	int BgL_arg2358z00_1738;

																	BgL_arg2358z00_1738 = (int) (((long) 8));
																	{	/* Ast/venv.scm 166 */
																		long BgL_auxz00_2414;

																		BgL_auxz00_2414 =
																			(long) (BgL_arg2358z00_1738);
																		BgL_modz00_1737 =
																			(BgL_offsetz00_1736 / BgL_auxz00_2414);
																}}
																{	/* Ast/venv.scm 166 */
																	long BgL_restz00_1739;

																	{	/* Ast/venv.scm 166 */
																		int BgL_arg2357z00_1740;

																		BgL_arg2357z00_1740 = (int) (((long) 8));
																		{	/* Ast/venv.scm 166 */
																			long BgL_auxz00_2418;

																			BgL_auxz00_2418 =
																				(long) (BgL_arg2357z00_1740);
																			BgL_restz00_1739 =
																				(BgL_offsetz00_1736 % BgL_auxz00_2418);
																	}}
																	{	/* Ast/venv.scm 166 */

																		BgL_method3288z00_1729 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1734,
																				(int) (BgL_modz00_1737)),
																			(int) (BgL_restz00_1739));
										}}}}}}}}
										PROCEDURE_ENTRY(BgL_method3288z00_1729)
											(BgL_method3288z00_1729, (obj_t) (BgL_valuez00_1728),
											BEOA);
					}}}}
					{
						obj_t BgL_argsz00_1473;

						{	/* Ast/venv.scm 169 */
							obj_t BgL_arg3504z00_1475;

							BgL_arg3504z00_1475 =
								(((BgL_sfunz00_bglt) CREF(BgL_valuez00_1469))->BgL_argsz00);
							BgL_argsz00_1473 = BgL_arg3504z00_1475;
						BgL_loopz00_1474:
							if (PAIRP(BgL_argsz00_1473))
								{	/* Ast/venv.scm 172 */
									obj_t BgL_argz00_1477;

									BgL_argz00_1477 = CAR(BgL_argsz00_1473);
									if (BGl_iszd2azf3z21zz__objectz00(BgL_argz00_1477,
											BGl_typez00zztype_typez00))
										{	/* Ast/venv.scm 175 */
											BgL_typez00_bglt BgL_arg3507z00_1479;

											{	/* Ast/venv.scm 175 */
												obj_t BgL_arg3508z00_1480;

												{
													BgL_typez00_bglt BgL_auxz00_2434;

													BgL_auxz00_2434 =
														(BgL_typez00_bglt) (BgL_argz00_1477);
													BgL_arg3508z00_1480 =
														(((BgL_typez00_bglt) CREF(BgL_auxz00_2434))->
														BgL_idz00);
												}
												BgL_arg3507z00_1479 =
													BGl_findzd2typezd2zztype_envz00(BgL_arg3508z00_1480);
											}
											{	/* Ast/venv.scm 175 */
												obj_t BgL_auxz00_2438;

												BgL_auxz00_2438 = (obj_t) (BgL_arg3507z00_1479);
												SET_CAR(BgL_argsz00_1473, BgL_auxz00_2438);
											}
										}
									else
										{	/* Ast/venv.scm 174 */
											if (BGl_iszd2azf3z21zz__objectz00(BgL_argz00_1477,
													BGl_localz00zzast_varz00))
												{	/* Ast/venv.scm 177 */
													BgL_typez00_bglt BgL_newzd2typezd2_1482;

													{	/* Ast/venv.scm 177 */
														obj_t BgL_arg3510z00_1483;

														{	/* Ast/venv.scm 177 */
															BgL_typez00_bglt BgL_obj1342z00_1715;

															{
																BgL_variablez00_bglt BgL_auxz00_2443;

																BgL_auxz00_2443 =
																	(BgL_variablez00_bglt) (BgL_argz00_1477);
																BgL_obj1342z00_1715 =
																	(((BgL_variablez00_bglt)
																		CREF(BgL_auxz00_2443))->BgL_typez00);
															}
															BgL_arg3510z00_1483 =
																(((BgL_typez00_bglt)
																	CREF(BgL_obj1342z00_1715))->BgL_idz00);
														}
														BgL_newzd2typezd2_1482 =
															BGl_findzd2typezd2zztype_envz00
															(BgL_arg3510z00_1483);
													}
													{
														BgL_variablez00_bglt BgL_auxz00_2448;

														BgL_auxz00_2448 =
															(BgL_variablez00_bglt) (BgL_argz00_1477);
														((((BgL_variablez00_bglt) CREF(BgL_auxz00_2448))->
																BgL_typez00) =
															((BgL_typez00_bglt) BgL_newzd2typezd2_1482),
															BUNSPEC);
													}
												}
											else
												{	/* Ast/venv.scm 176 */
													BGl_errorz00zz__errorz00
														(BGl_string3563z00zzast_envz00,
														BGl_string3564z00zzast_envz00,
														BGl_shapez00zztools_shapez00(BgL_argz00_1477));
												}
										}
									{
										obj_t BgL_argsz00_2453;

										BgL_argsz00_2453 = CDR(BgL_argsz00_1473);
										BgL_argsz00_1473 = BgL_argsz00_2453;
										goto BgL_loopz00_1474;
									}
								}
							else
								{	/* Ast/venv.scm 171 */
									if (NULLP(BgL_argsz00_1473))
										{	/* Ast/venv.scm 185 */
											obj_t BgL_bodyz00_1490;

											BgL_bodyz00_1490 =
												(((BgL_sfunz00_bglt) CREF(BgL_valuez00_1469))->
												BgL_bodyz00);
											if (BGl_iszd2azf3z21zz__objectz00(BgL_bodyz00_1490,
													BGl_nodez00zzast_nodez00))
												{	/* Ast/venv.scm 188 */
													BgL_typez00_bglt BgL_tresz00_1492;

													{
														BgL_nodez00_bglt BgL_auxz00_2460;

														BgL_auxz00_2460 =
															(BgL_nodez00_bglt) (BgL_bodyz00_1490);
														BgL_tresz00_1492 =
															(((BgL_nodez00_bglt) CREF(BgL_auxz00_2460))->
															BgL_typez00);
													}
													BGl_hrtypezd2nodez12zc0zzast_hrtypez00(
														(BgL_nodez00_bglt) (BgL_bodyz00_1490));
													{	/* Ast/venv.scm 190 */
														bool_t BgL_testz00_2465;

														{	/* Ast/venv.scm 190 */
															obj_t BgL_obj1438z00_1723;

															BgL_obj1438z00_1723 = (obj_t) (BgL_tresz00_1492);
															BgL_testz00_2465 =
																BGl_iszd2azf3z21zz__objectz00
																(BgL_obj1438z00_1723,
																BGl_typez00zztype_typez00);
														}
														if (BgL_testz00_2465)
															{	/* Ast/venv.scm 192 */
																BgL_typez00_bglt BgL_arg3522z00_1494;

																{	/* Ast/venv.scm 192 */
																	obj_t BgL_arg3523z00_1495;

																	BgL_arg3523z00_1495 =
																		(((BgL_typez00_bglt)
																			CREF(BgL_tresz00_1492))->BgL_idz00);
																	BgL_arg3522z00_1494 =
																		BGl_findzd2typezd2zztype_envz00
																		(BgL_arg3523z00_1495);
																}
																{
																	BgL_nodez00_bglt BgL_auxz00_2470;

																	BgL_auxz00_2470 =
																		(BgL_nodez00_bglt) (BgL_bodyz00_1490);
																	return
																		((((BgL_nodez00_bglt)
																				CREF(BgL_auxz00_2470))->BgL_typez00) =
																		((BgL_typez00_bglt) BgL_arg3522z00_1494),
																		BUNSPEC);
																}
															}
														else
															{	/* Ast/venv.scm 190 */
																return BFALSE;
															}
													}
												}
											else
												{	/* Ast/venv.scm 187 */
													return BFALSE;
												}
										}
									else
										{	/* Ast/venv.scm 184 */
											return
												BGl_errorz00zz__errorz00(BGl_string3565z00zzast_envz00,
												BGl_string3566z00zzast_envz00,
												BGl_shapez00zztools_shapez00(BgL_argsz00_1473));
										}
								}
						}
					}
				}
			}
		}
	}



/* restore-value-types!3292 */
	obj_t BGl_restorezd2valuezd2typesz123292z12zzast_envz00(obj_t BgL_envz00_1874,
		obj_t BgL_valuez00_1875)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 158 */
			{
				BgL_funz00_bglt BgL_valuez00_1458;

				BgL_valuez00_1458 = (BgL_funz00_bglt) (BgL_valuez00_1875);
				{	/* Ast/venv.scm 160 */
					bool_t BgL_testz00_2476;

					{	/* Ast/venv.scm 160 */
						obj_t BgL_arg3502z00_1466;

						BgL_arg3502z00_1466 =
							(((BgL_funz00_bglt) CREF(BgL_valuez00_1458))->
							BgL_predicatezd2ofzd2);
						BgL_testz00_2476 =
							BGl_iszd2azf3z21zz__objectz00(BgL_arg3502z00_1466,
							BGl_typez00zztype_typez00);
					}
					if (BgL_testz00_2476)
						{	/* Ast/venv.scm 161 */
							BgL_typez00_bglt BgL_arg3499z00_1463;

							{	/* Ast/venv.scm 161 */
								obj_t BgL_arg3500z00_1464;

								{	/* Ast/venv.scm 161 */
									BgL_typez00_bglt BgL_obj1342z00_1703;

									BgL_obj1342z00_1703 =
										(BgL_typez00_bglt) (
										(((BgL_funz00_bglt) CREF(BgL_valuez00_1458))->
											BgL_predicatezd2ofzd2));
									BgL_arg3500z00_1464 =
										(((BgL_typez00_bglt) CREF(BgL_obj1342z00_1703))->BgL_idz00);
								}
								BgL_arg3499z00_1463 =
									BGl_findzd2typezd2zztype_envz00(BgL_arg3500z00_1464);
							}
							{
								obj_t BgL_auxz00_2483;

								BgL_auxz00_2483 = (obj_t) (BgL_arg3499z00_1463);
								return
									((((BgL_funz00_bglt) CREF(BgL_valuez00_1458))->
										BgL_predicatezd2ofzd2) =
									((obj_t) BgL_auxz00_2483), BUNSPEC);
							}
						}
					else
						{	/* Ast/venv.scm 160 */
							return BFALSE;
						}
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 446742181),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_hrtypez00(((long) 346346738),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 143212498),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 358171001),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
			return
				BGl_modulezd2initializa7ationz75zzinline_inlinez00(((long) 326457085),
				BSTRING_TO_STRING(BGl_string3567z00zzast_envz00));
		}
	}

#ifdef __cplusplus
}
#endif
