/*===========================================================================*/
/*   (Cfa/arithmetic.scm)                                                    */
/*   Bigloo (3.2b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon May 25 12:42:12 CEST 2009       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/arithmetic.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_approxz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_typez00_bgl *BgL_typez00;
		bool_t BgL_typezd2lockedzf3z21;
		obj_t BgL_allocsz00;
		bool_t BgL_topzf3zf3;
		long BgL_lostzd2stampzd2;
	}                *BgL_approxz00_bglt;

	typedef struct BgL_prezd2arithmeticzd2appz00_bgl
	{
		obj_t BgL_speczd2typeszd2;
	}                                *BgL_prezd2arithmeticzd2appz00_bglt;

	typedef struct BgL_arithmeticzd2appzd2_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		obj_t BgL_speczd2typeszd2;
	}                          *BgL_arithmeticzd2appzd2_bglt;


	extern BgL_approxz00_bglt BGl_loosez12z12zzcfa_loosez00(BgL_approxz00_bglt,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern obj_t BGl_approxzd2setzd2typez12z12zzcfa_approxz00(BgL_approxz00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_cnstzd2initzd2zzcfa_arithmeticz00();
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcfa_arithmeticz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_approxz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_setupz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_cfaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_iteratez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_loosez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_info2z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_infoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzcfa_arithmeticz00();
	extern obj_t BGl_za2longza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern obj_t BGl_continuezd2cfaz12zc0zzcfa_iteratez00();
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzcfa_arithmeticz00();
	BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	extern BgL_approxz00_bglt BGl_makezd2emptyzd2approxz00zzcfa_approxz00();
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00 = BUNSPEC;
	static obj_t BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00(obj_t);
	static obj_t BGl_genericzd2initzd2zzcfa_arithmeticz00();
	static obj_t BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 = BUNSPEC;
	extern obj_t BGl_typez00zztype_typez00;
	extern obj_t BGl_nodezd2setupza2z12z62zzcfa_setupz00(obj_t);
	static obj_t
		BGl__cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00(obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00();
	extern obj_t BGl_prezd2arithmeticzd2appz00zzcfa_info2z00;
	extern BgL_approxz00_bglt
		BGl_makezd2typezd2approxz00zzcfa_approxz00(BgL_typez00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00();
	extern BgL_approxz00_bglt BGl_cfaz12z12zzcfa_cfaz00(BgL_nodez00_bglt);
	static obj_t BGl_nodezd2setupz12zd2prezd2arit4567zc0zzcfa_arithmeticz00(obj_t,
		obj_t);
	static obj_t BGl_cfaz12zd2arithmeticzd2app4570z12zzcfa_arithmeticz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	extern obj_t
		BGl_wideningzd2arithmeticzd2appz00zzcfa_info2z00(BgL_approxz00_bglt, obj_t);
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_arithmeticzd2appzd2zzcfa_info2z00;
	static obj_t BGl_cleanupzd2typezd2zzcfa_arithmeticz00(obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00();
	static obj_t __cnst[1];


	extern obj_t BGl_cfaz12zd2envzc0zzcfa_cfaz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4774z00zzcfa_arithmeticz00,
		BgL_bgl_nodeza7d2setupza712za74782za7,
		BGl_nodezd2setupz12zd2prezd2arit4567zc0zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4775z00zzcfa_arithmeticz00,
		BgL_bgl_cfaza712za7d2arithme4783z00,
		BGl_cfaz12zd2arithmeticzd2app4570z12zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string4776z00zzcfa_arithmeticz00,
		BgL_bgl_string4776za700za7za7c4784za7, "node-setup!", 11);
	      DEFINE_STRING(BGl_string4777z00zzcfa_arithmeticz00,
		BgL_bgl_string4777za700za7za7c4785za7, "Illegal arithmetic node", 23);
	      DEFINE_STRING(BGl_string4778z00zzcfa_arithmeticz00,
		BgL_bgl_string4778za700za7za7c4786za7, "cfa_arithmetic", 14);
	      DEFINE_STRING(BGl_string4779z00zzcfa_arithmeticz00,
		BgL_bgl_string4779za700za7za7c4787za7, "all ", 4);
	extern obj_t BGl_nodezd2setupz12zd2envz12zzcfa_setupz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_cleanupzd2arithmeticzd2nodesz12zd2envzc0zzcfa_arithmeticz00,
		BgL_bgl__cleanupza7d2arith4788za7,
		BGl__cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00, 0L, BUNSPEC, 0);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcfa_arithmeticz00(long
		BgL_checksumz00_1870, char *BgL_fromz00_1871)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00))
				{
					BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00();
					BGl_cnstzd2initzd2zzcfa_arithmeticz00();
					BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00();
					BGl_methodzd2initzd2zzcfa_arithmeticz00();
					BGl_toplevelzd2initzd2zzcfa_arithmeticz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"cfa_arithmetic");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			{	/* Cfa/arithmetic.scm 28 */
				obj_t BgL_cportz00_1862;

				BgL_cportz00_1862 =
					bgl_open_input_string(BGl_string4779z00zzcfa_arithmeticz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1863;

					BgL_iz00_1863 = ((long) 0);
				BgL_loopz00_1864:
					if ((BgL_iz00_1863 == ((long) -1)))
						{	/* Cfa/arithmetic.scm 28 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/arithmetic.scm 28 */
							{	/* Cfa/arithmetic.scm 28 */
								obj_t BgL_arg4781z00_1866;

								{	/* Cfa/arithmetic.scm 28 */

									{	/* Cfa/arithmetic.scm 28 */
										obj_t BgL_locationz00_1868;

										BgL_locationz00_1868 = BBOOL(((bool_t) 0));
										{	/* Cfa/arithmetic.scm 28 */

											BgL_arg4781z00_1866 =
												BGl_readz00zz__readerz00(BgL_cportz00_1862,
												BgL_locationz00_1868);
										}
									}
								}
								{	/* Cfa/arithmetic.scm 28 */
									int BgL_auxz00_1890;

									BgL_auxz00_1890 = (int) (BgL_iz00_1863);
									CNST_TABLE_SET(BgL_auxz00_1890, BgL_arg4781z00_1866);
							}}
							{	/* Cfa/arithmetic.scm 28 */
								int BgL_auxz00_1869;

								BgL_auxz00_1869 = (int) ((BgL_iz00_1863 - ((long) 1)));
								{
									long BgL_iz00_1895;

									BgL_iz00_1895 = (long) (BgL_auxz00_1869);
									BgL_iz00_1863 = BgL_iz00_1895;
									goto BgL_loopz00_1864;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 = BNIL;
			return BUNSPEC;
		}
	}



/* cleanup-arithmetic-nodes! */
	BGL_EXPORTED_DEF obj_t
		BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 52 */
			{
				obj_t BgL_l4549z00_1002;

				{	/* Cfa/arithmetic.scm 67 */
					bool_t BgL_auxz00_1897;

					BgL_l4549z00_1002 =
						BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00;
				BgL_forzd2each4551zd2_1003:
					if (PAIRP(BgL_l4549z00_1002))
						{	/* Cfa/arithmetic.scm 67 */
							{	/* Cfa/arithmetic.scm 68 */
								obj_t BgL_nodez00_1005;

								BgL_nodez00_1005 = CAR(BgL_l4549z00_1002);
								{	/* Cfa/arithmetic.scm 69 */
									BgL_variablez00_bglt BgL_fz00_1007;

									{	/* Cfa/arithmetic.scm 69 */
										BgL_varz00_bglt BgL_obj1993z00_1721;

										{
											BgL_appz00_bglt BgL_auxz00_1901;

											BgL_auxz00_1901 = (BgL_appz00_bglt) (BgL_nodez00_1005);
											BgL_obj1993z00_1721 =
												(((BgL_appz00_bglt) CREF(BgL_auxz00_1901))->BgL_funz00);
										}
										BgL_fz00_1007 =
											(((BgL_varz00_bglt) CREF(BgL_obj1993z00_1721))->
											BgL_variablez00);
									}
									{	/* Cfa/arithmetic.scm 69 */
										BgL_valuez00_bglt BgL_valz00_1008;

										BgL_valz00_1008 =
											(((BgL_variablez00_bglt) CREF(BgL_fz00_1007))->
											BgL_valuez00);
										{	/* Cfa/arithmetic.scm 70 */

											{	/* Cfa/arithmetic.scm 72 */
												bool_t BgL_testz00_1906;

												{	/* Cfa/arithmetic.scm 72 */
													BgL_typez00_bglt BgL_arg4573z00_1010;

													BgL_arg4573z00_1010 =
														(((BgL_variablez00_bglt) CREF(BgL_fz00_1007))->
														BgL_typez00);
													BgL_testz00_1906 =
														((obj_t) (BgL_arg4573z00_1010) ==
														BGl_za2_za2z00zztype_cachez00);
												}
												if (BgL_testz00_1906)
													{
														BgL_typez00_bglt BgL_auxz00_1910;

														BgL_auxz00_1910 =
															(BgL_typez00_bglt)
															(BGl_za2objza2z00zztype_cachez00);
														((((BgL_variablez00_bglt) CREF(BgL_fz00_1007))->
																BgL_typez00) =
															((BgL_typez00_bglt) BgL_auxz00_1910), BUNSPEC);
													}
												else
													{	/* Cfa/arithmetic.scm 72 */
														BFALSE;
													}
											}
											{	/* Cfa/arithmetic.scm 74 */
												bool_t BgL_testz00_1913;

												{	/* Cfa/arithmetic.scm 74 */
													BgL_typez00_bglt BgL_arg4575z00_1012;

													{
														BgL_nodez00_bglt BgL_auxz00_1914;

														BgL_auxz00_1914 =
															(BgL_nodez00_bglt) (BgL_nodez00_1005);
														BgL_arg4575z00_1012 =
															(((BgL_nodez00_bglt) CREF(BgL_auxz00_1914))->
															BgL_typez00);
													}
													BgL_testz00_1913 =
														(
														(obj_t) (BgL_arg4575z00_1012) ==
														BGl_za2_za2z00zztype_cachez00);
												}
												if (BgL_testz00_1913)
													{
														BgL_typez00_bglt BgL_auxz00_1921;

														BgL_nodez00_bglt BgL_auxz00_1919;

														BgL_auxz00_1921 =
															(BgL_typez00_bglt)
															(BGl_za2objza2z00zztype_cachez00);
														BgL_auxz00_1919 =
															(BgL_nodez00_bglt) (BgL_nodez00_1005);
														((((BgL_nodez00_bglt) CREF(BgL_auxz00_1919))->
																BgL_typez00) =
															((BgL_typez00_bglt) BgL_auxz00_1921), BUNSPEC);
													}
												else
													{	/* Cfa/arithmetic.scm 74 */
														BFALSE;
													}
											}
											{	/* Cfa/arithmetic.scm 77 */
												bool_t BgL_testz00_1924;

												{	/* Cfa/arithmetic.scm 77 */
													obj_t BgL_obj1793z00_1729;

													BgL_obj1793z00_1729 = (obj_t) (BgL_valz00_1008);
													BgL_testz00_1924 =
														BGl_iszd2azf3z21zz__objectz00(BgL_obj1793z00_1729,
														BGl_sfunz00zzast_varz00);
												}
												if (BgL_testz00_1924)
													{	/* Cfa/arithmetic.scm 79 */
														obj_t BgL_arg4577z00_1014;

														{	/* Cfa/arithmetic.scm 79 */
															obj_t BgL_l4543z00_1015;

															{
																BgL_sfunz00_bglt BgL_auxz00_1927;

																BgL_auxz00_1927 =
																	(BgL_sfunz00_bglt) (BgL_valz00_1008);
																BgL_l4543z00_1015 =
																	(((BgL_sfunz00_bglt) CREF(BgL_auxz00_1927))->
																	BgL_argsz00);
															}
															if (NULLP(BgL_l4543z00_1015))
																{	/* Cfa/arithmetic.scm 79 */
																	BgL_arg4577z00_1014 = BNIL;
																}
															else
																{	/* Cfa/arithmetic.scm 79 */
																	obj_t BgL_head4545z00_1017;

																	BgL_head4545z00_1017 =
																		MAKE_PAIR
																		(BGl_cleanupzd2typezd2zzcfa_arithmeticz00
																		(CAR(BgL_l4543z00_1015)), BNIL);
																	{	/* Cfa/arithmetic.scm 79 */
																		obj_t BgL_g4548z00_1018;

																		BgL_g4548z00_1018 = CDR(BgL_l4543z00_1015);
																		{
																			obj_t BgL_l4543z00_1019;

																			obj_t BgL_tail4546z00_1020;

																			BgL_l4543z00_1019 = BgL_g4548z00_1018;
																			BgL_tail4546z00_1020 =
																				BgL_head4545z00_1017;
																		BgL_map4544z00_1021:
																			if (NULLP(BgL_l4543z00_1019))
																				{	/* Cfa/arithmetic.scm 79 */
																					BgL_arg4577z00_1014 =
																						BgL_head4545z00_1017;
																				}
																			else
																				{	/* Cfa/arithmetic.scm 79 */
																					obj_t BgL_newtail4547z00_1023;

																					BgL_newtail4547z00_1023 =
																						MAKE_PAIR
																						(BGl_cleanupzd2typezd2zzcfa_arithmeticz00
																						(CAR(BgL_l4543z00_1019)), BNIL);
																					SET_CDR(BgL_tail4546z00_1020,
																						BgL_newtail4547z00_1023);
																					{
																						obj_t BgL_tail4546z00_1944;

																						obj_t BgL_l4543z00_1942;

																						BgL_l4543z00_1942 =
																							CDR(BgL_l4543z00_1019);
																						BgL_tail4546z00_1944 =
																							BgL_newtail4547z00_1023;
																						BgL_tail4546z00_1020 =
																							BgL_tail4546z00_1944;
																						BgL_l4543z00_1019 =
																							BgL_l4543z00_1942;
																						goto BgL_map4544z00_1021;
																					}
																				}
																		}
																	}
																}
														}
														{
															BgL_sfunz00_bglt BgL_auxz00_1945;

															BgL_auxz00_1945 =
																(BgL_sfunz00_bglt) (BgL_valz00_1008);
															((((BgL_sfunz00_bglt) CREF(BgL_auxz00_1945))->
																	BgL_argsz00) =
																((obj_t) BgL_arg4577z00_1014), BUNSPEC);
														}
													}
												else
													{	/* Cfa/arithmetic.scm 80 */
														bool_t BgL_testz00_1948;

														{	/* Cfa/arithmetic.scm 80 */
															obj_t BgL_obj1857z00_1745;

															BgL_obj1857z00_1745 = (obj_t) (BgL_valz00_1008);
															BgL_testz00_1948 =
																BGl_iszd2azf3z21zz__objectz00
																(BgL_obj1857z00_1745, BGl_cfunz00zzast_varz00);
														}
														if (BgL_testz00_1948)
															{	/* Cfa/arithmetic.scm 81 */
																obj_t BgL_g4533z00_1032;

																{
																	BgL_cfunz00_bglt BgL_auxz00_1951;

																	BgL_auxz00_1951 =
																		(BgL_cfunz00_bglt) (BgL_valz00_1008);
																	BgL_g4533z00_1032 =
																		(((BgL_cfunz00_bglt)
																			CREF(BgL_auxz00_1951))->
																		BgL_argszd2typezd2);
																}
																{
																	obj_t BgL_lz00_1033;

																	{	/* Cfa/arithmetic.scm 81 */
																		bool_t BgL_auxz00_1954;

																		BgL_lz00_1033 = BgL_g4533z00_1032;
																	BgL_loopz00_1034:
																		if (PAIRP(BgL_lz00_1033))
																			{	/* Cfa/arithmetic.scm 82 */
																				{	/* Cfa/arithmetic.scm 84 */
																					obj_t BgL_auxz00_1957;

																					BgL_auxz00_1957 =
																						BGl_cleanupzd2typezd2zzcfa_arithmeticz00
																						(CAR(BgL_lz00_1033));
																					SET_CAR(BgL_lz00_1033,
																						BgL_auxz00_1957);
																				}
																				{
																					obj_t BgL_lz00_1961;

																					BgL_lz00_1961 = CDR(BgL_lz00_1033);
																					BgL_lz00_1033 = BgL_lz00_1961;
																					goto BgL_loopz00_1034;
																				}
																			}
																		else
																			{	/* Cfa/arithmetic.scm 82 */
																				BgL_auxz00_1954 = ((bool_t) 0);
																			}
																		BBOOL(BgL_auxz00_1954);
																	}
																}
															}
														else
															{	/* Cfa/arithmetic.scm 80 */
																BFALSE;
															}
													}
											}
										}
									}
								}
							}
							{
								obj_t BgL_l4549z00_1964;

								BgL_l4549z00_1964 = CDR(BgL_l4549z00_1002);
								BgL_l4549z00_1002 = BgL_l4549z00_1964;
								goto BgL_forzd2each4551zd2_1003;
							}
						}
					else
						{	/* Cfa/arithmetic.scm 67 */
							BgL_auxz00_1897 = ((bool_t) 1);
						}
					return BBOOL(BgL_auxz00_1897);
				}
			}
		}
	}



/* cleanup-type */
	obj_t BGl_cleanupzd2typezd2zzcfa_arithmeticz00(obj_t BgL_tz00_1041)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 66 */
			if (BGl_iszd2azf3z21zz__objectz00(BgL_tz00_1041,
					BGl_typez00zztype_typez00))
				{	/* Cfa/arithmetic.scm 55 */
					if ((BgL_tz00_1041 == BGl_za2_za2z00zztype_cachez00))
						{	/* Cfa/arithmetic.scm 56 */
							return BGl_za2objza2z00zztype_cachez00;
						}
					else
						{	/* Cfa/arithmetic.scm 56 */
							return BgL_tz00_1041;
						}
				}
			else
				{	/* Cfa/arithmetic.scm 55 */
					if (BGl_iszd2azf3z21zz__objectz00(BgL_tz00_1041,
							BGl_localz00zzast_varz00))
						{	/* Cfa/arithmetic.scm 59 */
							{	/* Cfa/arithmetic.scm 60 */
								bool_t BgL_testz00_1973;

								{	/* Cfa/arithmetic.scm 60 */
									BgL_typez00_bglt BgL_arg4600z00_1047;

									{
										BgL_variablez00_bglt BgL_auxz00_1974;

										BgL_auxz00_1974 = (BgL_variablez00_bglt) (BgL_tz00_1041);
										BgL_arg4600z00_1047 =
											(((BgL_variablez00_bglt) CREF(BgL_auxz00_1974))->
											BgL_typez00);
									}
									BgL_testz00_1973 =
										(
										(obj_t) (BgL_arg4600z00_1047) ==
										BGl_za2_za2z00zztype_cachez00);
								}
								if (BgL_testz00_1973)
									{
										BgL_typez00_bglt BgL_auxz00_1981;

										BgL_variablez00_bglt BgL_auxz00_1979;

										BgL_auxz00_1981 =
											(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
										BgL_auxz00_1979 = (BgL_variablez00_bglt) (BgL_tz00_1041);
										((((BgL_variablez00_bglt) CREF(BgL_auxz00_1979))->
												BgL_typez00) =
											((BgL_typez00_bglt) BgL_auxz00_1981), BUNSPEC);
									}
								else
									{	/* Cfa/arithmetic.scm 60 */
										BFALSE;
									}
							}
							return BgL_tz00_1041;
						}
					else
						{	/* Cfa/arithmetic.scm 59 */
							return BgL_tz00_1041;
						}
				}
		}
	}



/* _cleanup-arithmetic-nodes! */
	obj_t BGl__cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00(obj_t
		BgL_envz00_1851)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 52 */
			return BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00();
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2setupz12zd2envz12zzcfa_setupz00,
				BGl_prezd2arithmeticzd2appz00zzcfa_info2z00,
				BGl_proc4774z00zzcfa_arithmeticz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00(BGl_cfaz12zd2envzc0zzcfa_cfaz00,
				BGl_arithmeticzd2appzd2zzcfa_info2z00,
				BGl_proc4775z00zzcfa_arithmeticz00);
		}
	}



/* cfa!-arithmetic-app4570 */
	obj_t BGl_cfaz12zd2arithmeticzd2app4570z12zzcfa_arithmeticz00(obj_t
		BgL_envz00_1854, obj_t BgL_nodez00_1855)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 141 */
			{
				BgL_arithmeticzd2appzd2_bglt BgL_nodez00_1633;

				{	/* Cfa/arithmetic.scm 170 */
					BgL_approxz00_bglt BgL_auxz00_1987;

					BgL_nodez00_1633 = (BgL_arithmeticzd2appzd2_bglt) (BgL_nodez00_1855);
					{
						obj_t BgL_argszd2approxzd2_1673;

						obj_t BgL_speczd2typeszd2_1674;

						obj_t BgL_argszd2approxzd2_1684;

						obj_t BgL_typez00_1685;

						obj_t BgL_speczd2typeszd2_1686;

						obj_t BgL_argszd2approxzd2_1699;

						{	/* Cfa/arithmetic.scm 182 */
							obj_t BgL_argszd2approxzd2_1641;

							{	/* Cfa/arithmetic.scm 182 */
								obj_t BgL_l4558z00_1657;

								{
									BgL_appz00_bglt BgL_auxz00_1988;

									BgL_auxz00_1988 = (BgL_appz00_bglt) (BgL_nodez00_1633);
									BgL_l4558z00_1657 =
										(((BgL_appz00_bglt) CREF(BgL_auxz00_1988))->BgL_argsz00);
								}
								if (NULLP(BgL_l4558z00_1657))
									{	/* Cfa/arithmetic.scm 182 */
										BgL_argszd2approxzd2_1641 = BNIL;
									}
								else
									{	/* Cfa/arithmetic.scm 182 */
										obj_t BgL_head4560z00_1659;

										{	/* Cfa/arithmetic.scm 182 */
											BgL_approxz00_bglt BgL_arg4743z00_1670;

											{	/* Cfa/arithmetic.scm 182 */
												obj_t BgL_arg4745z00_1672;

												BgL_arg4745z00_1672 = CAR(BgL_l4558z00_1657);
												BgL_arg4743z00_1670 =
													BGl_cfaz12z12zzcfa_cfaz00(
													(BgL_nodez00_bglt) (BgL_arg4745z00_1672));
											}
											BgL_head4560z00_1659 =
												MAKE_PAIR((obj_t) (BgL_arg4743z00_1670), BNIL);
										}
										{	/* Cfa/arithmetic.scm 182 */
											obj_t BgL_g4563z00_1660;

											BgL_g4563z00_1660 = CDR(BgL_l4558z00_1657);
											{
												obj_t BgL_l4558z00_1661;

												obj_t BgL_tail4561z00_1662;

												BgL_l4558z00_1661 = BgL_g4563z00_1660;
												BgL_tail4561z00_1662 = BgL_head4560z00_1659;
											BgL_map4559z00_1663:
												if (NULLP(BgL_l4558z00_1661))
													{	/* Cfa/arithmetic.scm 182 */
														BgL_argszd2approxzd2_1641 = BgL_head4560z00_1659;
													}
												else
													{	/* Cfa/arithmetic.scm 182 */
														obj_t BgL_newtail4562z00_1665;

														{	/* Cfa/arithmetic.scm 182 */
															BgL_approxz00_bglt BgL_arg4740z00_1667;

															{	/* Cfa/arithmetic.scm 182 */
																obj_t BgL_arg4742z00_1669;

																BgL_arg4742z00_1669 = CAR(BgL_l4558z00_1661);
																BgL_arg4740z00_1667 =
																	BGl_cfaz12z12zzcfa_cfaz00(
																	(BgL_nodez00_bglt) (BgL_arg4742z00_1669));
															}
															BgL_newtail4562z00_1665 =
																MAKE_PAIR((obj_t) (BgL_arg4740z00_1667), BNIL);
														}
														SET_CDR(BgL_tail4561z00_1662,
															BgL_newtail4562z00_1665);
														{
															obj_t BgL_tail4561z00_2009;

															obj_t BgL_l4558z00_2007;

															BgL_l4558z00_2007 = CDR(BgL_l4558z00_1661);
															BgL_tail4561z00_2009 = BgL_newtail4562z00_1665;
															BgL_tail4561z00_1662 = BgL_tail4561z00_2009;
															BgL_l4558z00_1661 = BgL_l4558z00_2007;
															goto BgL_map4559z00_1663;
														}
													}
											}
										}
									}
							}
							{	/* Cfa/arithmetic.scm 184 */
								obj_t BgL_tyz00_1642;

								BgL_argszd2approxzd2_1699 = BgL_argszd2approxzd2_1641;
								{
									obj_t BgL_argsz00_1701;

									BgL_argsz00_1701 = BgL_argszd2approxzd2_1699;
								BgL_loopz00_1702:
									if (NULLP(BgL_argsz00_1701))
										{	/* Cfa/arithmetic.scm 150 */
											BgL_tyz00_1642 = BFALSE;
										}
									else
										{	/* Cfa/arithmetic.scm 152 */
											obj_t BgL_tz00_1704;

											{	/* Cfa/arithmetic.scm 152 */
												BgL_typez00_bglt BgL_arg4765z00_1707;

												{	/* Cfa/arithmetic.scm 152 */
													BgL_approxz00_bglt BgL_obj3079z00_1846;

													{	/* Cfa/arithmetic.scm 152 */
														obj_t BgL_pairz00_1845;

														BgL_pairz00_1845 = BgL_argsz00_1701;
														BgL_obj3079z00_1846 =
															(BgL_approxz00_bglt) (CAR(BgL_pairz00_1845));
													}
													BgL_arg4765z00_1707 =
														(((BgL_approxz00_bglt) CREF(BgL_obj3079z00_1846))->
														BgL_typez00);
												}
												if (
													((obj_t) (BgL_arg4765z00_1707) ==
														BGl_za2intza2z00zztype_cachez00))
													{	/* Cfa/arithmetic.scm 152 */
														BgL_tz00_1704 = BGl_za2longza2z00zztype_cachez00;
													}
												else
													{	/* Cfa/arithmetic.scm 152 */
														BgL_tz00_1704 = (obj_t) (BgL_arg4765z00_1707);
													}
											}
											if ((BgL_tz00_1704 == BGl_za2_za2z00zztype_cachez00))
												{
													obj_t BgL_argsz00_2021;

													BgL_argsz00_2021 = CDR(BgL_argsz00_1701);
													BgL_argsz00_1701 = BgL_argsz00_2021;
													goto BgL_loopz00_1702;
												}
											else
												{	/* Cfa/arithmetic.scm 153 */
													BgL_tyz00_1642 = BgL_tz00_1704;
												}
										}
								}
								{	/* Cfa/arithmetic.scm 185 */
									bool_t BgL_testz00_2023;

									BgL_argszd2approxzd2_1684 = BgL_argszd2approxzd2_1641;
									BgL_typez00_1685 = BgL_tyz00_1642;
									{
										obj_t BgL_auxz00_2045;

										{	/* Cfa/arithmetic.scm 185 */
											BgL_objectz00_bglt BgL_auxz00_2046;

											BgL_auxz00_2046 = (BgL_objectz00_bglt) (BgL_nodez00_1633);
											BgL_auxz00_2045 = BGL_OBJECT_WIDENING(BgL_auxz00_2046);
										}
										BgL_speczd2typeszd2_1686 =
											(((BgL_arithmeticzd2appzd2_bglt) CREF(BgL_auxz00_2045))->
											BgL_speczd2typeszd2);
									}
									{	/* Cfa/arithmetic.scm 159 */
										bool_t BgL__ortest_4539z00_1688;

										if (CBOOL(BgL_typez00_1685))
											{	/* Cfa/arithmetic.scm 159 */
												BgL__ortest_4539z00_1688 = ((bool_t) 0);
											}
										else
											{	/* Cfa/arithmetic.scm 159 */
												BgL__ortest_4539z00_1688 = ((bool_t) 1);
											}
										if (BgL__ortest_4539z00_1688)
											{	/* Cfa/arithmetic.scm 159 */
												BgL_testz00_2023 = BgL__ortest_4539z00_1688;
											}
										else
											{	/* Cfa/arithmetic.scm 159 */
												if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
														(BgL_typez00_1685, BgL_speczd2typeszd2_1686)))
													{
														obj_t BgL_argsz00_1690;

														BgL_argsz00_1690 = BgL_argszd2approxzd2_1684;
													BgL_loopz00_1691:
														if (NULLP(BgL_argsz00_1690))
															{	/* Cfa/arithmetic.scm 162 */
																BgL_testz00_2023 = ((bool_t) 1);
															}
														else
															{	/* Cfa/arithmetic.scm 164 */
																obj_t BgL_tz00_1693;

																{	/* Cfa/arithmetic.scm 164 */
																	BgL_typez00_bglt BgL_arg4759z00_1697;

																	{	/* Cfa/arithmetic.scm 164 */
																		BgL_approxz00_bglt BgL_obj3079z00_1840;

																		{	/* Cfa/arithmetic.scm 164 */
																			obj_t BgL_pairz00_1839;

																			BgL_pairz00_1839 = BgL_argsz00_1690;
																			BgL_obj3079z00_1840 =
																				(BgL_approxz00_bglt) (CAR
																				(BgL_pairz00_1839));
																		}
																		BgL_arg4759z00_1697 =
																			(((BgL_approxz00_bglt)
																				CREF(BgL_obj3079z00_1840))->
																			BgL_typez00);
																	}
																	if (
																		((obj_t) (BgL_arg4759z00_1697) ==
																			BGl_za2intza2z00zztype_cachez00))
																		{	/* Cfa/arithmetic.scm 164 */
																			BgL_tz00_1693 =
																				BGl_za2longza2z00zztype_cachez00;
																		}
																	else
																		{	/* Cfa/arithmetic.scm 164 */
																			BgL_tz00_1693 =
																				(obj_t) (BgL_arg4759z00_1697);
																		}
																}
																{	/* Cfa/arithmetic.scm 165 */
																	bool_t BgL_testz00_2039;

																	if ((BgL_tz00_1693 == BgL_typez00_1685))
																		{	/* Cfa/arithmetic.scm 165 */
																			BgL_testz00_2039 = ((bool_t) 1);
																		}
																	else
																		{	/* Cfa/arithmetic.scm 165 */
																			BgL_testz00_2039 =
																				(BgL_tz00_1693 ==
																				BGl_za2_za2z00zztype_cachez00);
																		}
																	if (BgL_testz00_2039)
																		{
																			obj_t BgL_argsz00_2043;

																			BgL_argsz00_2043 = CDR(BgL_argsz00_1690);
																			BgL_argsz00_1690 = BgL_argsz00_2043;
																			goto BgL_loopz00_1691;
																		}
																	else
																		{	/* Cfa/arithmetic.scm 165 */
																			BgL_testz00_2023 = ((bool_t) 0);
																		}
																}
															}
													}
												else
													{	/* Cfa/arithmetic.scm 160 */
														BgL_testz00_2023 = ((bool_t) 0);
													}
											}
									}
									if (BgL_testz00_2023)
										{	/* Cfa/arithmetic.scm 187 */
											bool_t BgL_testz00_2050;

											BgL_argszd2approxzd2_1673 = BgL_argszd2approxzd2_1641;
											{
												obj_t BgL_auxz00_2065;

												{	/* Cfa/arithmetic.scm 187 */
													BgL_objectz00_bglt BgL_auxz00_2066;

													BgL_auxz00_2066 =
														(BgL_objectz00_bglt) (BgL_nodez00_1633);
													BgL_auxz00_2065 =
														BGL_OBJECT_WIDENING(BgL_auxz00_2066);
												}
												BgL_speczd2typeszd2_1674 =
													(((BgL_arithmeticzd2appzd2_bglt)
														CREF(BgL_auxz00_2065))->BgL_speczd2typeszd2);
											}
											{
												obj_t BgL_argsz00_1676;

												BgL_argsz00_1676 = BgL_argszd2approxzd2_1673;
											BgL_loopz00_1677:
												if (NULLP(BgL_argsz00_1676))
													{	/* Cfa/arithmetic.scm 172 */
														BgL_testz00_2050 = ((bool_t) 1);
													}
												else
													{	/* Cfa/arithmetic.scm 174 */
														bool_t BgL_testz00_2053;

														{	/* Cfa/arithmetic.scm 174 */
															obj_t BgL_arg4751z00_1681;

															{	/* Cfa/arithmetic.scm 174 */
																BgL_typez00_bglt BgL_arg4752z00_1682;

																{	/* Cfa/arithmetic.scm 174 */
																	BgL_approxz00_bglt BgL_obj3079z00_1834;

																	{	/* Cfa/arithmetic.scm 174 */
																		obj_t BgL_pairz00_1833;

																		BgL_pairz00_1833 = BgL_argsz00_1676;
																		BgL_obj3079z00_1834 =
																			(BgL_approxz00_bglt) (CAR
																			(BgL_pairz00_1833));
																	}
																	BgL_arg4752z00_1682 =
																		(((BgL_approxz00_bglt)
																			CREF(BgL_obj3079z00_1834))->BgL_typez00);
																}
																if (
																	((obj_t) (BgL_arg4752z00_1682) ==
																		BGl_za2intza2z00zztype_cachez00))
																	{	/* Cfa/arithmetic.scm 174 */
																		BgL_arg4751z00_1681 =
																			BGl_za2longza2z00zztype_cachez00;
																	}
																else
																	{	/* Cfa/arithmetic.scm 174 */
																		BgL_arg4751z00_1681 =
																			(obj_t) (BgL_arg4752z00_1682);
																	}
															}
															BgL_testz00_2053 =
																CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
																(BgL_arg4751z00_1681,
																	BgL_speczd2typeszd2_1674));
														}
														if (BgL_testz00_2053)
															{
																obj_t BgL_argsz00_2063;

																BgL_argsz00_2063 = CDR(BgL_argsz00_1676);
																BgL_argsz00_1676 = BgL_argsz00_2063;
																goto BgL_loopz00_1677;
															}
														else
															{	/* Cfa/arithmetic.scm 174 */
																BgL_testz00_2050 = ((bool_t) 0);
															}
													}
											}
											if (BgL_testz00_2050)
												{	/* Cfa/arithmetic.scm 190 */
													bool_t BgL_testz00_2070;

													{	/* Cfa/arithmetic.scm 190 */
														BgL_typez00_bglt BgL_arg4730z00_1647;

														{	/* Cfa/arithmetic.scm 190 */
															BgL_approxz00_bglt BgL_obj3079z00_1825;

															{
																obj_t BgL_auxz00_2071;

																{	/* Cfa/arithmetic.scm 190 */
																	BgL_objectz00_bglt BgL_auxz00_2072;

																	BgL_auxz00_2072 =
																		(BgL_objectz00_bglt) (BgL_nodez00_1633);
																	BgL_auxz00_2071 =
																		BGL_OBJECT_WIDENING(BgL_auxz00_2072);
																}
																BgL_obj3079z00_1825 =
																	(((BgL_arithmeticzd2appzd2_bglt)
																		CREF(BgL_auxz00_2071))->BgL_approxz00);
															}
															BgL_arg4730z00_1647 =
																(((BgL_approxz00_bglt)
																	CREF(BgL_obj3079z00_1825))->BgL_typez00);
														}
														BgL_testz00_2070 =
															(
															(obj_t) (BgL_arg4730z00_1647) ==
															BGl_za2_za2z00zztype_cachez00);
													}
													if (BgL_testz00_2070)
														{	/* Cfa/arithmetic.scm 190 */
															{	/* Cfa/arithmetic.scm 193 */
																BgL_approxz00_bglt BgL_arg4729z00_1646;

																{
																	obj_t BgL_auxz00_2079;

																	{	/* Cfa/arithmetic.scm 193 */
																		BgL_objectz00_bglt BgL_auxz00_2080;

																		BgL_auxz00_2080 =
																			(BgL_objectz00_bglt) (BgL_nodez00_1633);
																		BgL_auxz00_2079 =
																			BGL_OBJECT_WIDENING(BgL_auxz00_2080);
																	}
																	BgL_arg4729z00_1646 =
																		(((BgL_arithmeticzd2appzd2_bglt)
																			CREF(BgL_auxz00_2079))->BgL_approxz00);
																}
																BGl_approxzd2setzd2typez12z12zzcfa_approxz00
																	(BgL_arg4729z00_1646,
																	(BgL_typez00_bglt) (BgL_tyz00_1642));
															}
															BGl_continuezd2cfaz12zc0zzcfa_iteratez00();
														}
													else
														{	/* Cfa/arithmetic.scm 190 */
															BFALSE;
														}
												}
											else
												{	/* Cfa/arithmetic.scm 187 */
													BFALSE;
												}
										}
									else
										{	/* Cfa/arithmetic.scm 185 */
											{
												obj_t BgL_l4564z00_1650;

												BgL_l4564z00_1650 = BgL_argszd2approxzd2_1641;
											BgL_forzd2each4565zd2_1651:
												if (PAIRP(BgL_l4564z00_1650))
													{	/* Cfa/arithmetic.scm 197 */
														{	/* Cfa/arithmetic.scm 197 */
															obj_t BgL_az00_1653;

															BgL_az00_1653 = CAR(BgL_l4564z00_1650);
															BGl_loosez12z12zzcfa_loosez00(
																(BgL_approxz00_bglt) (BgL_az00_1653),
																CNST_TABLE_REF(((long) 0)));
														}
														{
															obj_t BgL_l4564z00_2093;

															BgL_l4564z00_2093 = CDR(BgL_l4564z00_1650);
															BgL_l4564z00_1650 = BgL_l4564z00_2093;
															goto BgL_forzd2each4565zd2_1651;
														}
													}
												else
													{	/* Cfa/arithmetic.scm 197 */
														((bool_t) 1);
													}
											}
											{	/* Cfa/arithmetic.scm 198 */
												BgL_approxz00_bglt BgL_arg4735z00_1655;

												{
													obj_t BgL_auxz00_2095;

													{	/* Cfa/arithmetic.scm 198 */
														BgL_objectz00_bglt BgL_auxz00_2096;

														BgL_auxz00_2096 =
															(BgL_objectz00_bglt) (BgL_nodez00_1633);
														BgL_auxz00_2095 =
															BGL_OBJECT_WIDENING(BgL_auxz00_2096);
													}
													BgL_arg4735z00_1655 =
														(((BgL_arithmeticzd2appzd2_bglt)
															CREF(BgL_auxz00_2095))->BgL_approxz00);
												}
												BGl_approxzd2setzd2typez12z12zzcfa_approxz00
													(BgL_arg4735z00_1655,
													(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00));
											}
										}
								}
							}
						}
						{
							obj_t BgL_auxz00_2102;

							{	/* Cfa/arithmetic.scm 200 */
								BgL_objectz00_bglt BgL_auxz00_2103;

								BgL_auxz00_2103 = (BgL_objectz00_bglt) (BgL_nodez00_1633);
								BgL_auxz00_2102 = BGL_OBJECT_WIDENING(BgL_auxz00_2103);
							}
							BgL_auxz00_1987 =
								(((BgL_arithmeticzd2appzd2_bglt) CREF(BgL_auxz00_2102))->
								BgL_approxz00);
						}
					}
					return (obj_t) (BgL_auxz00_1987);
				}
			}
		}
	}



/* node-setup!-pre-arit4567 */
	obj_t BGl_nodezd2setupz12zd2prezd2arit4567zc0zzcfa_arithmeticz00(obj_t
		BgL_envz00_1856, obj_t BgL_nodez00_1857)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 96 */
			{
				BgL_prezd2arithmeticzd2appz00_bglt BgL_nodez00_1576;

				{	/* Cfa/arithmetic.scm 99 */
					BgL_appz00_bglt BgL_auxz00_2109;

					BgL_nodez00_1576 =
						(BgL_prezd2arithmeticzd2appz00_bglt) (BgL_nodez00_1857);
					{	/* Cfa/arithmetic.scm 107 */
						BgL_variablez00_bglt BgL_fz00_1581;

						{	/* Cfa/arithmetic.scm 107 */
							BgL_varz00_bglt BgL_obj1993z00_1759;

							{
								BgL_appz00_bglt BgL_auxz00_2110;

								BgL_auxz00_2110 = (BgL_appz00_bglt) (BgL_nodez00_1576);
								BgL_obj1993z00_1759 =
									(((BgL_appz00_bglt) CREF(BgL_auxz00_2110))->BgL_funz00);
							}
							BgL_fz00_1581 =
								(((BgL_varz00_bglt) CREF(BgL_obj1993z00_1759))->
								BgL_variablez00);
						}
						{	/* Cfa/arithmetic.scm 107 */
							BgL_valuez00_bglt BgL_valz00_1582;

							BgL_valz00_1582 =
								(((BgL_variablez00_bglt) CREF(BgL_fz00_1581))->BgL_valuez00);
							{	/* Cfa/arithmetic.scm 108 */

								{	/* Cfa/arithmetic.scm 110 */
									bool_t BgL_testz00_2115;

									{	/* Cfa/arithmetic.scm 110 */
										BgL_typez00_bglt BgL_arg4694z00_1584;

										BgL_arg4694z00_1584 =
											(((BgL_variablez00_bglt) CREF(BgL_fz00_1581))->
											BgL_typez00);
										BgL_testz00_2115 =
											((obj_t) (BgL_arg4694z00_1584) ==
											BGl_za2objza2z00zztype_cachez00);
									}
									if (BgL_testz00_2115)
										{	/* Cfa/arithmetic.scm 110 */
											{
												BgL_typez00_bglt BgL_auxz00_2119;

												BgL_auxz00_2119 =
													(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00);
												((((BgL_variablez00_bglt) CREF(BgL_fz00_1581))->
														BgL_typez00) =
													((BgL_typez00_bglt) BgL_auxz00_2119), BUNSPEC);
											}
											{
												BgL_typez00_bglt BgL_auxz00_2124;

												BgL_nodez00_bglt BgL_auxz00_2122;

												BgL_auxz00_2124 =
													(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00);
												BgL_auxz00_2122 = (BgL_nodez00_bglt) (BgL_nodez00_1576);
												((((BgL_nodez00_bglt) CREF(BgL_auxz00_2122))->
														BgL_typez00) =
													((BgL_typez00_bglt) BgL_auxz00_2124), BUNSPEC);
											}
										}
									else
										{	/* Cfa/arithmetic.scm 110 */
											BFALSE;
										}
								}
								{	/* Cfa/arithmetic.scm 117 */
									bool_t BgL_testz00_2127;

									{	/* Cfa/arithmetic.scm 117 */
										obj_t BgL_obj1793z00_1766;

										BgL_obj1793z00_1766 = (obj_t) (BgL_valz00_1582);
										BgL_testz00_2127 =
											BGl_iszd2azf3z21zz__objectz00(BgL_obj1793z00_1766,
											BGl_sfunz00zzast_varz00);
									}
									if (BgL_testz00_2127)
										{	/* Cfa/arithmetic.scm 119 */
											obj_t BgL_arg4696z00_1586;

											{	/* Cfa/arithmetic.scm 119 */
												obj_t BgL_l4552z00_1587;

												{
													BgL_sfunz00_bglt BgL_auxz00_2130;

													BgL_auxz00_2130 =
														(BgL_sfunz00_bglt) (BgL_valz00_1582);
													BgL_l4552z00_1587 =
														(((BgL_sfunz00_bglt) CREF(BgL_auxz00_2130))->
														BgL_argsz00);
												}
												if (NULLP(BgL_l4552z00_1587))
													{	/* Cfa/arithmetic.scm 119 */
														BgL_arg4696z00_1586 = BNIL;
													}
												else
													{	/* Cfa/arithmetic.scm 119 */
														obj_t BgL_head4554z00_1589;

														BgL_head4554z00_1589 =
															MAKE_PAIR
															(BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00(CAR
																(BgL_l4552z00_1587)), BNIL);
														{	/* Cfa/arithmetic.scm 119 */
															obj_t BgL_g4557z00_1590;

															BgL_g4557z00_1590 = CDR(BgL_l4552z00_1587);
															{
																obj_t BgL_l4552z00_1591;

																obj_t BgL_tail4555z00_1592;

																BgL_l4552z00_1591 = BgL_g4557z00_1590;
																BgL_tail4555z00_1592 = BgL_head4554z00_1589;
															BgL_map4553z00_1593:
																if (NULLP(BgL_l4552z00_1591))
																	{	/* Cfa/arithmetic.scm 119 */
																		BgL_arg4696z00_1586 = BgL_head4554z00_1589;
																	}
																else
																	{	/* Cfa/arithmetic.scm 119 */
																		obj_t BgL_newtail4556z00_1595;

																		BgL_newtail4556z00_1595 =
																			MAKE_PAIR
																			(BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00
																			(CAR(BgL_l4552z00_1591)), BNIL);
																		SET_CDR(BgL_tail4555z00_1592,
																			BgL_newtail4556z00_1595);
																		{
																			obj_t BgL_tail4555z00_2147;

																			obj_t BgL_l4552z00_2145;

																			BgL_l4552z00_2145 =
																				CDR(BgL_l4552z00_1591);
																			BgL_tail4555z00_2147 =
																				BgL_newtail4556z00_1595;
																			BgL_tail4555z00_1592 =
																				BgL_tail4555z00_2147;
																			BgL_l4552z00_1591 = BgL_l4552z00_2145;
																			goto BgL_map4553z00_1593;
																		}
																	}
															}
														}
													}
											}
											{
												BgL_sfunz00_bglt BgL_auxz00_2148;

												BgL_auxz00_2148 = (BgL_sfunz00_bglt) (BgL_valz00_1582);
												((((BgL_sfunz00_bglt) CREF(BgL_auxz00_2148))->
														BgL_argsz00) =
													((obj_t) BgL_arg4696z00_1586), BUNSPEC);
											}
										}
									else
										{	/* Cfa/arithmetic.scm 120 */
											bool_t BgL_testz00_2151;

											{	/* Cfa/arithmetic.scm 120 */
												obj_t BgL_obj1857z00_1782;

												BgL_obj1857z00_1782 = (obj_t) (BgL_valz00_1582);
												BgL_testz00_2151 =
													BGl_iszd2azf3z21zz__objectz00(BgL_obj1857z00_1782,
													BGl_cfunz00zzast_varz00);
											}
											if (BgL_testz00_2151)
												{	/* Cfa/arithmetic.scm 121 */
													obj_t BgL_g4536z00_1604;

													{
														BgL_cfunz00_bglt BgL_auxz00_2154;

														BgL_auxz00_2154 =
															(BgL_cfunz00_bglt) (BgL_valz00_1582);
														BgL_g4536z00_1604 =
															(((BgL_cfunz00_bglt) CREF(BgL_auxz00_2154))->
															BgL_argszd2typezd2);
													}
													{
														obj_t BgL_lz00_1605;

														BgL_lz00_1605 = BgL_g4536z00_1604;
													BgL_loopz00_1606:
														if (PAIRP(BgL_lz00_1605))
															{	/* Cfa/arithmetic.scm 123 */
																obj_t BgL_auxz00_2159;

																BgL_auxz00_2159 =
																	BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00
																	(CAR(BgL_lz00_1605));
																SET_CAR(BgL_lz00_1605, BgL_auxz00_2159);
															}
														else
															{
																obj_t BgL_lz00_2163;

																BgL_lz00_2163 = CDR(BgL_lz00_1605);
																BgL_lz00_1605 = BgL_lz00_2163;
																goto BgL_loopz00_1606;
															}
													}
												}
											else
												{	/* Cfa/arithmetic.scm 120 */
													BGl_errorz00zz__errorz00
														(BGl_string4776z00zzcfa_arithmeticz00,
														BGl_string4777z00zzcfa_arithmeticz00,
														(obj_t) (BgL_nodez00_1576));
												}
										}
								}
								BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 =
									MAKE_PAIR(
									(obj_t) (BgL_nodez00_1576),
									BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00);
								{	/* Cfa/arithmetic.scm 129 */
									obj_t BgL_arg4711z00_1611;

									{
										BgL_appz00_bglt BgL_auxz00_2169;

										BgL_auxz00_2169 = (BgL_appz00_bglt) (BgL_nodez00_1576);
										BgL_arg4711z00_1611 =
											(((BgL_appz00_bglt) CREF(BgL_auxz00_2169))->BgL_argsz00);
									}
									BGl_nodezd2setupza2z12z62zzcfa_setupz00(BgL_arg4711z00_1611);
								}
								{	/* Cfa/arithmetic.scm 130 */
									obj_t BgL_speczd2typeszd2_1612;

									{
										obj_t BgL_auxz00_2173;

										{	/* Cfa/arithmetic.scm 130 */
											BgL_objectz00_bglt BgL_auxz00_2174;

											BgL_auxz00_2174 = (BgL_objectz00_bglt) (BgL_nodez00_1576);
											BgL_auxz00_2173 = BGL_OBJECT_WIDENING(BgL_auxz00_2174);
										}
										BgL_speczd2typeszd2_1612 =
											(((BgL_prezd2arithmeticzd2appz00_bglt)
												CREF(BgL_auxz00_2173))->BgL_speczd2typeszd2);
									}
									{	/* Cfa/arithmetic.scm 130 */
										BgL_prezd2arithmeticzd2appz00_bglt BgL_nodez00_1613;

										{	/* Cfa/arithmetic.scm 131 */
											long BgL_arg4718z00_1622;

											{	/* Cfa/arithmetic.scm 131 */
												obj_t BgL_arg4719z00_1623;

												{	/* Cfa/arithmetic.scm 131 */
													obj_t BgL_arg4720z00_1624;

													{	/* Cfa/arithmetic.scm 131 */
														BgL_objectz00_bglt BgL_objectz00_1791;

														BgL_objectz00_1791 =
															(BgL_objectz00_bglt) (BgL_nodez00_1576);
														{	/* Cfa/arithmetic.scm 131 */
															long BgL_arg2359z00_1792;

															{	/* Cfa/arithmetic.scm 131 */
																long BgL_arg2360z00_1793;

																BgL_arg2360z00_1793 =
																	BGL_OBJECT_CLASS_NUM(BgL_objectz00_1791);
																BgL_arg2359z00_1792 =
																	(BgL_arg2360z00_1793 - OBJECT_TYPE);
															}
															BgL_arg4720z00_1624 =
																VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
																(int) (BgL_arg2359z00_1792));
													}}
													BgL_arg4719z00_1623 =
														BGl_classzd2superzd2zz__objectz00
														(BgL_arg4720z00_1624);
												}
												BgL_arg4718z00_1622 =
													BGl_classzd2numzd2zz__objectz00(BgL_arg4719z00_1623);
											}
											BGL_OBJECT_CLASS_NUM_SET(
												(BgL_objectz00_bglt) (BgL_nodez00_1576),
												BgL_arg4718z00_1622);
										}
										{	/* Cfa/arithmetic.scm 131 */
											BgL_objectz00_bglt BgL_auxz00_2187;

											BgL_auxz00_2187 = (BgL_objectz00_bglt) (BgL_nodez00_1576);
											BGL_OBJECT_WIDENING_SET(BgL_auxz00_2187, BFALSE);
										}
										BgL_nodez00_1613 = BgL_nodez00_1576;
										{	/* Cfa/arithmetic.scm 131 */

											{	/* Cfa/arithmetic.scm 132 */
												BgL_appz00_bglt BgL_obj4538z00_1614;

												BgL_obj4538z00_1614 =
													((BgL_appz00_bglt)
													(BgL_appz00_bglt) (BgL_nodez00_1613));
												{	/* Cfa/arithmetic.scm 134 */
													obj_t BgL_arg4712z00_1615;

													{	/* Cfa/arithmetic.scm 134 */
														BgL_approxz00_bglt BgL_arg4713z00_1616;

														{	/* Cfa/arithmetic.scm 134 */
															bool_t BgL_testz00_2192;

															{	/* Cfa/arithmetic.scm 134 */
																BgL_typez00_bglt BgL_arg4716z00_1619;

																BgL_arg4716z00_1619 =
																	(((BgL_variablez00_bglt)
																		CREF(BgL_fz00_1581))->BgL_typez00);
																BgL_testz00_2192 =
																	((obj_t) (BgL_arg4716z00_1619) ==
																	BGl_za2_za2z00zztype_cachez00);
															}
															if (BgL_testz00_2192)
																{	/* Cfa/arithmetic.scm 134 */
																	BgL_arg4713z00_1616 =
																		BGl_makezd2emptyzd2approxz00zzcfa_approxz00
																		();
																}
															else
																{	/* Cfa/arithmetic.scm 136 */
																	BgL_typez00_bglt BgL_arg4715z00_1618;

																	BgL_arg4715z00_1618 =
																		(((BgL_variablez00_bglt)
																			CREF(BgL_fz00_1581))->BgL_typez00);
																	BgL_arg4713z00_1616 =
																		BGl_makezd2typezd2approxz00zzcfa_approxz00
																		(BgL_arg4715z00_1618);
																}
														}
														BgL_arg4712z00_1615 =
															BGl_wideningzd2arithmeticzd2appz00zzcfa_info2z00
															(BgL_arg4713z00_1616, BgL_speczd2typeszd2_1612);
													}
													{	/* Cfa/arithmetic.scm 132 */
														BgL_objectz00_bglt BgL_auxz00_2200;

														BgL_auxz00_2200 =
															(BgL_objectz00_bglt) (BgL_obj4538z00_1614);
														BGL_OBJECT_WIDENING_SET(BgL_auxz00_2200,
															BgL_arg4712z00_1615);
													}
												}
												BGL_OBJECT_CLASS_NUM_SET(
													(BgL_objectz00_bglt) (BgL_obj4538z00_1614),
													BGl_classzd2numzd2zz__objectz00
													(BGl_arithmeticzd2appzd2zzcfa_info2z00));
												BgL_auxz00_2109 = BgL_obj4538z00_1614;
											}
										}
									}
								}
							}
						}
					}
					return (obj_t) (BgL_auxz00_2109);
				}
			}
		}
	}



/* unspecified-type */
	obj_t BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00(obj_t BgL_lz00_1626)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 105 */
			if (BGl_iszd2azf3z21zz__objectz00(BgL_lz00_1626,
					BGl_typez00zztype_typez00))
				{	/* Cfa/arithmetic.scm 99 */
					return BGl_za2_za2z00zztype_cachez00;
				}
			else
				{	/* Cfa/arithmetic.scm 99 */
					if (BGl_iszd2azf3z21zz__objectz00(BgL_lz00_1626,
							BGl_localz00zzast_varz00))
						{	/* Cfa/arithmetic.scm 101 */
							{
								BgL_typez00_bglt BgL_auxz00_2214;

								BgL_variablez00_bglt BgL_auxz00_2212;

								BgL_auxz00_2214 =
									(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00);
								BgL_auxz00_2212 = (BgL_variablez00_bglt) (BgL_lz00_1626);
								((((BgL_variablez00_bglt) CREF(BgL_auxz00_2212))->BgL_typez00) =
									((BgL_typez00_bglt) BgL_auxz00_2214), BUNSPEC);
							}
							return BgL_lz00_1626;
						}
					else
						{	/* Cfa/arithmetic.scm 101 */
							return BgL_lz00_1626;
						}
				}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_infoz00(((long) 243010053),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_info2z00(((long) 0),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_loosez00(((long) 235614963),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_iteratez00(((long) 326518176),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_cfaz00(((long) 42139303),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_setupz00(((long) 212645849),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_approxz00(((long) 535144917),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
			return
				BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(((long) 249450490),
				BSTRING_TO_STRING(BGl_string4778z00zzcfa_arithmeticz00));
		}
	}

#ifdef __cplusplus
}
#endif
