/*===========================================================================*/
/*   (Coerce/convert.scm)                                                    */
/*   Bigloo (3.2b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon May 25 12:42:12 CEST 2009       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Coerce/convert.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;


	extern obj_t BGl_nodez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_convertzd2errorzd2zzcoerce_convertz00(BgL_typez00_bglt,
		BgL_typez00_bglt, obj_t, BgL_nodez00_bglt);
	static BgL_nodez00_bglt
		BGl_skipzd2letzd2varz00zzcoerce_convertz00(BgL_nodez00_bglt);
	static obj_t BGl_cnstzd2initzd2zzcoerce_convertz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt, BgL_typez00_bglt,
		BgL_typez00_bglt, bool_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_spreadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_lvtypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_coercionz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzcoerce_convertz00();
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_dozd2convertzd2zzcoerce_convertz00(obj_t, obj_t,
		BgL_typez00_bglt);
	extern obj_t BGl_appz00zzast_nodez00;
	extern bool_t BGl_subzd2typezf3z21zztype_envz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern obj_t BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_nodez00_bglt);
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	extern obj_t BGl_userzd2warningzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzcoerce_convertz00();
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	extern bool_t
		BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00(BgL_nodez00_bglt);
	extern BgL_castz00_bglt BGl_makezd2castzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_nodez00_bglt);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcoerce_convertz00 = BUNSPEC;
	extern obj_t BGl_tclassz00zzobject_classz00;
	static obj_t BGl_genericzd2initzd2zzcoerce_convertz00();
	extern BgL_typez00_bglt
		BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_typez00_bglt);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	static obj_t BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_makezd2onezd2conversionz00zzcoerce_convertz00(obj_t,
		BgL_typez00_bglt, BgL_typez00_bglt, obj_t, obj_t, obj_t, bool_t);
	extern obj_t BGl_findzd2coercerzd2zztype_coercionz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_importedzd2moduleszd2initz00zzcoerce_convertz00();
	static obj_t BGl__convertz123771z12zzcoerce_convertz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00(obj_t,
		BgL_typez00_bglt, BgL_typez00_bglt, obj_t, obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_bglt,
		obj_t, BgL_typez00_bglt, bool_t);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	static obj_t BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00(obj_t,
		BgL_typez00_bglt, BgL_typez00_bglt, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t string_to_symbol(char *);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	BGL_IMPORT obj_t BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_varz00_bglt BGl_makezd2varzd2zzast_nodez00(obj_t, BgL_typez00_bglt,
		BgL_variablez00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t, obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00();
	extern bool_t BGl_typezd2subclasszf3z21zzobject_classz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t __cnst[15];


	   
		 
		DEFINE_STRING(BGl_string3772z00zzcoerce_convertz00,
		BgL_bgl_string3772za700za7za7c3781za7, "Type error", 10);
	      DEFINE_STRING(BGl_string3773z00zzcoerce_convertz00,
		BgL_bgl_string3773za700za7za7c3782za7, "", 0);
	      DEFINE_STRING(BGl_string3774z00zzcoerce_convertz00,
		BgL_bgl_string3774za700za7za7c3783za7, "Illegal conversion", 18);
	      DEFINE_STRING(BGl_string3775z00zzcoerce_convertz00,
		BgL_bgl_string3775za700za7za7c3784za7, "do-convert", 10);
	      DEFINE_STRING(BGl_string3776z00zzcoerce_convertz00,
		BgL_bgl_string3776za700za7za7c3785za7, "Illegal converter", 17);
	      DEFINE_STRING(BGl_string3777z00zzcoerce_convertz00,
		BgL_bgl_string3777za700za7za7c3786za7, "coerce_convert", 14);
	      DEFINE_STRING(BGl_string3778z00zzcoerce_convertz00,
		BgL_bgl_string3778za700za7za7c3787za7,
		"aux2 if coercer bigloo-type-error failure quote bigloo-type-error/location __error @ begin location bdb ::obj let aux ",
		118);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_convertz12zd2envzc0zzcoerce_convertz00,
		BgL_bgl__convertza7123771za73788z00,
		BGl__convertz123771z12zzcoerce_convertz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_runtimezd2typezd2errorzd2envzd2zzcoerce_convertz00,
		BgL_bgl__runtimeza7d2typeza73789z00,
		BGl__runtimezd2typezd2errorz00zzcoerce_convertz00, 0L, BUNSPEC, 3);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long
		BgL_checksumz00_1822, char *BgL_fromz00_1823)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcoerce_convertz00))
				{
					BGl_requirezd2initializa7ationz75zzcoerce_convertz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00();
					BGl_cnstzd2initzd2zzcoerce_convertz00();
					BGl_importedzd2moduleszd2initz00zzcoerce_convertz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"coerce_convert");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			{	/* Coerce/convert.scm 16 */
				obj_t BgL_cportz00_1814;

				BgL_cportz00_1814 =
					bgl_open_input_string(BGl_string3778z00zzcoerce_convertz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1815;

					BgL_iz00_1815 = ((long) 14);
				BgL_loopz00_1816:
					if ((BgL_iz00_1815 == ((long) -1)))
						{	/* Coerce/convert.scm 16 */
							return BUNSPEC;
						}
					else
						{	/* Coerce/convert.scm 16 */
							{	/* Coerce/convert.scm 16 */
								obj_t BgL_arg3780z00_1818;

								{	/* Coerce/convert.scm 16 */

									{	/* Coerce/convert.scm 16 */
										obj_t BgL_locationz00_1820;

										BgL_locationz00_1820 = BBOOL(((bool_t) 0));
										{	/* Coerce/convert.scm 16 */

											BgL_arg3780z00_1818 =
												BGl_readz00zz__readerz00(BgL_cportz00_1814,
												BgL_locationz00_1820);
										}
									}
								}
								{	/* Coerce/convert.scm 16 */
									int BgL_auxz00_1842;

									BgL_auxz00_1842 = (int) (BgL_iz00_1815);
									CNST_TABLE_SET(BgL_auxz00_1842, BgL_arg3780z00_1818);
							}}
							{	/* Coerce/convert.scm 16 */
								int BgL_auxz00_1821;

								BgL_auxz00_1821 = (int) ((BgL_iz00_1815 - ((long) 1)));
								{
									long BgL_iz00_1847;

									BgL_iz00_1847 = (long) (BgL_auxz00_1821);
									BgL_iz00_1815 = BgL_iz00_1847;
									goto BgL_loopz00_1816;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}
	}



/* runtime-type-error */
	BGL_EXPORTED_DEF obj_t BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t
		BgL_locz00_41, obj_t BgL_tiz00_42, obj_t BgL_valuez00_43)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 69 */
			{

				if (BGl_iszd2azf3z21zz__objectz00(BgL_valuez00_43,
						BGl_nodez00zzast_nodez00))
					{	/* Coerce/convert.scm 104 */
						BgL_nodez00_bglt BgL_auxz00_1851;

						{	/* Coerce/convert.scm 95 */
							obj_t BgL_auxz00_970;

							BgL_auxz00_970 =
								BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 0)));
							{	/* Coerce/convert.scm 95 */
								BgL_nodez00_bglt BgL_resz00_971;

								{	/* Coerce/convert.scm 97 */
									obj_t BgL_arg3470z00_974;

									{	/* Coerce/convert.scm 97 */
										obj_t BgL_arg3471z00_975;

										obj_t BgL_arg3472z00_976;

										BgL_arg3471z00_975 = CNST_TABLE_REF(((long) 1));
										{	/* Coerce/convert.scm 97 */
											obj_t BgL_arg3473z00_977;

											obj_t BgL_arg3474z00_978;

											{	/* Coerce/convert.scm 97 */
												obj_t BgL_arg3478z00_982;

												{	/* Coerce/convert.scm 97 */
													obj_t BgL_arg3480z00_984;

													obj_t BgL_arg3481z00_985;

													{	/* Coerce/convert.scm 97 */
														obj_t BgL_arg3482z00_986;

														{	/* Coerce/convert.scm 97 */
															obj_t BgL_arg3483z00_987;

															{	/* Coerce/convert.scm 97 */
																obj_t BgL_arg3484z00_988;

																obj_t BgL_arg3485z00_989;

																BgL_arg3484z00_988 =
																	SYMBOL_TO_STRING(BgL_auxz00_970);
																{	/* Coerce/convert.scm 97 */
																	obj_t BgL_symbolz00_1665;

																	BgL_symbolz00_1665 =
																		CNST_TABLE_REF(((long) 2));
																	BgL_arg3485z00_989 =
																		SYMBOL_TO_STRING(BgL_symbolz00_1665);
																}
																{	/* Coerce/convert.scm 97 */
																	obj_t BgL_list3486z00_990;

																	{	/* Coerce/convert.scm 97 */
																		obj_t BgL_arg3487z00_991;

																		BgL_arg3487z00_991 =
																			MAKE_PAIR(BgL_arg3485z00_989, BNIL);
																		BgL_list3486z00_990 =
																			MAKE_PAIR(BgL_arg3484z00_988,
																			BgL_arg3487z00_991);
																	}
																	BgL_arg3483z00_987 =
																		BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																		(BgL_list3486z00_990);
															}}
															BgL_arg3482z00_986 =
																string_to_symbol(BSTRING_TO_STRING
																(BgL_arg3483z00_987));
														}
														BgL_arg3480z00_984 =
															BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
															(BgL_arg3482z00_986);
													}
													{	/* Coerce/convert.scm 97 */
														obj_t BgL_list3488z00_992;

														BgL_list3488z00_992 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg3481z00_985 =
															BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
															(BUNSPEC, BgL_list3488z00_992);
													}
													BgL_arg3478z00_982 =
														MAKE_PAIR(BgL_arg3480z00_984, BgL_arg3481z00_985);
												}
												BgL_arg3473z00_977 =
													MAKE_PAIR(BgL_arg3478z00_982, BNIL);
											}
											BgL_arg3474z00_978 =
												BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00
												(BgL_tiz00_42, BgL_locz00_41, BgL_auxz00_970);
											{	/* Coerce/convert.scm 97 */
												obj_t BgL_list3476z00_980;

												{	/* Coerce/convert.scm 97 */
													obj_t BgL_arg3477z00_981;

													BgL_arg3477z00_981 = MAKE_PAIR(BNIL, BNIL);
													BgL_list3476z00_980 =
														MAKE_PAIR(BgL_arg3474z00_978, BgL_arg3477z00_981);
												}
												BgL_arg3472z00_976 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3473z00_977, BgL_list3476z00_980);
										}}
										BgL_arg3470z00_974 =
											MAKE_PAIR(BgL_arg3471z00_975, BgL_arg3472z00_976);
									}
									BgL_resz00_971 =
										BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
										(BgL_arg3470z00_974, BgL_locz00_41);
								}
								{	/* Coerce/convert.scm 96 */

									{	/* Coerce/convert.scm 101 */
										obj_t BgL_arg3468z00_972;

										{	/* Coerce/convert.scm 101 */
											obj_t BgL_pairz00_1668;

											{
												BgL_letzd2varzd2_bglt BgL_auxz00_1874;

												BgL_auxz00_1874 =
													(BgL_letzd2varzd2_bglt) (BgL_resz00_971);
												BgL_pairz00_1668 =
													(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_1874))->
													BgL_bindingsz00);
											}
											BgL_arg3468z00_972 = CAR(BgL_pairz00_1668);
										}
										SET_CDR(BgL_arg3468z00_972, BgL_valuez00_43);
									}
									BgL_auxz00_1851 = BgL_resz00_971;
						}}}
						return (obj_t) (BgL_auxz00_1851);
					}
				else
					{	/* Coerce/convert.scm 103 */
						return
							BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00
							(BgL_tiz00_42, BgL_locz00_41, BgL_valuez00_43);
					}
			}
		}
	}



/* runtime-type-error/id */
	obj_t BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00(obj_t
		BgL_tiz00_1811, obj_t BgL_locz00_1810, obj_t BgL_idz00_993)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 73 */
			{	/* Coerce/convert.scm 74 */
				bool_t BgL_testz00_1881;

				{	/* Coerce/convert.scm 74 */
					bool_t BgL_testz00_1882;

					{	/* Coerce/convert.scm 74 */
						bool_t BgL_testz00_1883;

						if (
							((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00) >
								((long) 0)))
							{	/* Coerce/convert.scm 75 */
								obj_t BgL_arg3561z00_1063;

								obj_t BgL_arg3562z00_1064;

								BgL_arg3561z00_1063 = CNST_TABLE_REF(((long) 3));
								{	/* Coerce/convert.scm 75 */
									obj_t BgL_arg3563z00_1065;

									BgL_arg3563z00_1065 =
										BGl_thezd2backendzd2zzbackend_backendz00();
									{
										BgL_backendz00_bglt BgL_auxz00_1889;

										BgL_auxz00_1889 =
											(BgL_backendz00_bglt) (BgL_arg3563z00_1065);
										BgL_arg3562z00_1064 =
											(((BgL_backendz00_bglt) CREF(BgL_auxz00_1889))->
											BgL_debugzd2supportzd2);
								}}
								BgL_testz00_1883 =
									CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
									(BgL_arg3561z00_1063, BgL_arg3562z00_1064));
							}
						else
							{	/* Coerce/convert.scm 74 */
								BgL_testz00_1883 = ((bool_t) 0);
							}
						if (BgL_testz00_1883)
							{	/* Coerce/convert.scm 74 */
								BgL_testz00_1882 = ((bool_t) 1);
							}
						else
							{	/* Coerce/convert.scm 74 */
								BgL_testz00_1882 =
									(
									(long) CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00) >
									((long) 0));
					}}
					if (BgL_testz00_1882)
						{	/* Coerce/convert.scm 74 */
							if (STRUCTP(BgL_locz00_1810))
								{	/* Coerce/convert.scm 77 */
									BgL_testz00_1881 =
										(STRUCT_KEY(BgL_locz00_1810) == CNST_TABLE_REF(((long) 4)));
								}
							else
								{	/* Coerce/convert.scm 77 */
									BgL_testz00_1881 = ((bool_t) 0);
								}
						}
					else
						{	/* Coerce/convert.scm 74 */
							BgL_testz00_1881 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_1881)
					{	/* Coerce/convert.scm 78 */
						obj_t BgL_arg3491z00_996;

						obj_t BgL_arg3492z00_997;

						BgL_arg3491z00_996 = CNST_TABLE_REF(((long) 5));
						{	/* Coerce/convert.scm 79 */
							obj_t BgL_arg3493z00_998;

							obj_t BgL_arg3494z00_999;

							{	/* Coerce/convert.scm 79 */
								obj_t BgL_arg3498z00_1003;

								obj_t BgL_arg3499z00_1004;

								{	/* Coerce/convert.scm 79 */
									obj_t BgL_arg3500z00_1005;

									obj_t BgL_arg3501z00_1006;

									BgL_arg3500z00_1005 = CNST_TABLE_REF(((long) 6));
									{	/* Coerce/convert.scm 79 */
										obj_t BgL_list3502z00_1007;

										{	/* Coerce/convert.scm 79 */
											obj_t BgL_arg3503z00_1008;

											obj_t BgL_arg3504z00_1009;

											BgL_arg3503z00_1008 = CNST_TABLE_REF(((long) 7));
											BgL_arg3504z00_1009 = MAKE_PAIR(BNIL, BNIL);
											BgL_list3502z00_1007 =
												MAKE_PAIR(BgL_arg3503z00_1008, BgL_arg3504z00_1009);
										}
										BgL_arg3501z00_1006 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(CNST_TABLE_REF
											(((long) 8)), BgL_list3502z00_1007);
									}
									BgL_arg3498z00_1003 =
										MAKE_PAIR(BgL_arg3500z00_1005, BgL_arg3501z00_1006);
								}
								{	/* Coerce/convert.scm 79 */
									obj_t BgL_arg3505z00_1010;

									obj_t BgL_arg3506z00_1011;

									obj_t BgL_arg3507z00_1012;

									obj_t BgL_arg3508z00_1013;

									{	/* Coerce/convert.scm 79 */
										obj_t BgL_arg3517z00_1020;

										obj_t BgL_arg3518z00_1021;

										BgL_arg3517z00_1020 = CNST_TABLE_REF(((long) 9));
										{	/* Coerce/convert.scm 79 */
											obj_t BgL_arg3519z00_1022;

											BgL_arg3519z00_1022 =
												BGl_currentzd2functionzd2zztools_errorz00();
											{	/* Coerce/convert.scm 79 */
												obj_t BgL_list3521z00_1024;

												BgL_list3521z00_1024 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3518z00_1021 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3519z00_1022, BgL_list3521z00_1024);
										}}
										BgL_arg3505z00_1010 =
											MAKE_PAIR(BgL_arg3517z00_1020, BgL_arg3518z00_1021);
									}
									BgL_arg3506z00_1011 = SYMBOL_TO_STRING(BgL_tiz00_1811);
									BgL_arg3507z00_1012 =
										BGl_locationzd2fullzd2fnamez00zztools_locationz00
										(BgL_locz00_1810);
									BgL_arg3508z00_1013 =
										STRUCT_REF(BgL_locz00_1810, (int) (((long) 1)));
									{	/* Coerce/convert.scm 79 */
										obj_t BgL_list3510z00_1015;

										{	/* Coerce/convert.scm 79 */
											obj_t BgL_arg3513z00_1016;

											{	/* Coerce/convert.scm 79 */
												obj_t BgL_arg3514z00_1017;

												{	/* Coerce/convert.scm 79 */
													obj_t BgL_arg3515z00_1018;

													{	/* Coerce/convert.scm 79 */
														obj_t BgL_arg3516z00_1019;

														BgL_arg3516z00_1019 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg3515z00_1018 =
															MAKE_PAIR(BgL_arg3508z00_1013,
															BgL_arg3516z00_1019);
													}
													BgL_arg3514z00_1017 =
														MAKE_PAIR(BgL_arg3507z00_1012, BgL_arg3515z00_1018);
												}
												BgL_arg3513z00_1016 =
													MAKE_PAIR(BgL_idz00_993, BgL_arg3514z00_1017);
											}
											BgL_list3510z00_1015 =
												MAKE_PAIR(BgL_arg3506z00_1011, BgL_arg3513z00_1016);
										}
										BgL_arg3499z00_1004 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg3505z00_1010, BgL_list3510z00_1015);
								}}
								BgL_arg3493z00_998 =
									MAKE_PAIR(BgL_arg3498z00_1003, BgL_arg3499z00_1004);
							}
							{	/* Coerce/convert.scm 87 */
								obj_t BgL_arg3522z00_1025;

								obj_t BgL_arg3523z00_1026;

								BgL_arg3522z00_1025 = CNST_TABLE_REF(((long) 10));
								{	/* Coerce/convert.scm 87 */
									obj_t BgL_list3524z00_1027;

									{	/* Coerce/convert.scm 87 */
										obj_t BgL_arg3525z00_1028;

										{	/* Coerce/convert.scm 87 */
											obj_t BgL_arg3526z00_1029;

											BgL_arg3526z00_1029 = MAKE_PAIR(BNIL, BNIL);
											BgL_arg3525z00_1028 =
												MAKE_PAIR(BFALSE, BgL_arg3526z00_1029);
										}
										BgL_list3524z00_1027 =
											MAKE_PAIR(BFALSE, BgL_arg3525z00_1028);
									}
									BgL_arg3523z00_1026 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BFALSE,
										BgL_list3524z00_1027);
								}
								BgL_arg3494z00_999 =
									MAKE_PAIR(BgL_arg3522z00_1025, BgL_arg3523z00_1026);
							}
							{	/* Coerce/convert.scm 78 */
								obj_t BgL_list3496z00_1001;

								{	/* Coerce/convert.scm 78 */
									obj_t BgL_arg3497z00_1002;

									BgL_arg3497z00_1002 = MAKE_PAIR(BNIL, BNIL);
									BgL_list3496z00_1001 =
										MAKE_PAIR(BgL_arg3494z00_999, BgL_arg3497z00_1002);
								}
								BgL_arg3492z00_997 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
									(BgL_arg3493z00_998, BgL_list3496z00_1001);
						}}
						return MAKE_PAIR(BgL_arg3491z00_996, BgL_arg3492z00_997);
					}
				else
					{	/* Coerce/convert.scm 88 */
						obj_t BgL_arg3527z00_1030;

						obj_t BgL_arg3528z00_1031;

						BgL_arg3527z00_1030 = CNST_TABLE_REF(((long) 5));
						{	/* Coerce/convert.scm 89 */
							obj_t BgL_arg3529z00_1032;

							obj_t BgL_arg3530z00_1033;

							{	/* Coerce/convert.scm 89 */
								obj_t BgL_arg3535z00_1037;

								obj_t BgL_arg3536z00_1038;

								{	/* Coerce/convert.scm 89 */
									obj_t BgL_arg3537z00_1039;

									obj_t BgL_arg3538z00_1040;

									BgL_arg3537z00_1039 = CNST_TABLE_REF(((long) 6));
									{	/* Coerce/convert.scm 89 */
										obj_t BgL_list3539z00_1041;

										{	/* Coerce/convert.scm 89 */
											obj_t BgL_arg3540z00_1042;

											obj_t BgL_arg3541z00_1043;

											BgL_arg3540z00_1042 = CNST_TABLE_REF(((long) 7));
											BgL_arg3541z00_1043 = MAKE_PAIR(BNIL, BNIL);
											BgL_list3539z00_1041 =
												MAKE_PAIR(BgL_arg3540z00_1042, BgL_arg3541z00_1043);
										}
										BgL_arg3538z00_1040 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(CNST_TABLE_REF
											(((long) 11)), BgL_list3539z00_1041);
									}
									BgL_arg3535z00_1037 =
										MAKE_PAIR(BgL_arg3537z00_1039, BgL_arg3538z00_1040);
								}
								{	/* Coerce/convert.scm 89 */
									obj_t BgL_arg3542z00_1044;

									obj_t BgL_arg3543z00_1045;

									{	/* Coerce/convert.scm 89 */
										obj_t BgL_arg3548z00_1050;

										obj_t BgL_arg3549z00_1051;

										BgL_arg3548z00_1050 = CNST_TABLE_REF(((long) 9));
										{	/* Coerce/convert.scm 89 */
											obj_t BgL_arg3550z00_1052;

											BgL_arg3550z00_1052 =
												BGl_currentzd2functionzd2zztools_errorz00();
											{	/* Coerce/convert.scm 89 */
												obj_t BgL_list3552z00_1054;

												BgL_list3552z00_1054 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3549z00_1051 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3550z00_1052, BgL_list3552z00_1054);
										}}
										BgL_arg3542z00_1044 =
											MAKE_PAIR(BgL_arg3548z00_1050, BgL_arg3549z00_1051);
									}
									BgL_arg3543z00_1045 = SYMBOL_TO_STRING(BgL_tiz00_1811);
									{	/* Coerce/convert.scm 89 */
										obj_t BgL_list3545z00_1047;

										{	/* Coerce/convert.scm 89 */
											obj_t BgL_arg3546z00_1048;

											{	/* Coerce/convert.scm 89 */
												obj_t BgL_arg3547z00_1049;

												BgL_arg3547z00_1049 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3546z00_1048 =
													MAKE_PAIR(BgL_idz00_993, BgL_arg3547z00_1049);
											}
											BgL_list3545z00_1047 =
												MAKE_PAIR(BgL_arg3543z00_1045, BgL_arg3546z00_1048);
										}
										BgL_arg3536z00_1038 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg3542z00_1044, BgL_list3545z00_1047);
								}}
								BgL_arg3529z00_1032 =
									MAKE_PAIR(BgL_arg3535z00_1037, BgL_arg3536z00_1038);
							}
							{	/* Coerce/convert.scm 92 */
								obj_t BgL_arg3553z00_1055;

								obj_t BgL_arg3554z00_1056;

								BgL_arg3553z00_1055 = CNST_TABLE_REF(((long) 10));
								{	/* Coerce/convert.scm 92 */
									obj_t BgL_list3555z00_1057;

									{	/* Coerce/convert.scm 92 */
										obj_t BgL_arg3556z00_1058;

										{	/* Coerce/convert.scm 92 */
											obj_t BgL_arg3557z00_1059;

											BgL_arg3557z00_1059 = MAKE_PAIR(BNIL, BNIL);
											BgL_arg3556z00_1058 =
												MAKE_PAIR(BFALSE, BgL_arg3557z00_1059);
										}
										BgL_list3555z00_1057 =
											MAKE_PAIR(BFALSE, BgL_arg3556z00_1058);
									}
									BgL_arg3554z00_1056 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BFALSE,
										BgL_list3555z00_1057);
								}
								BgL_arg3530z00_1033 =
									MAKE_PAIR(BgL_arg3553z00_1055, BgL_arg3554z00_1056);
							}
							{	/* Coerce/convert.scm 88 */
								obj_t BgL_list3532z00_1035;

								{	/* Coerce/convert.scm 88 */
									obj_t BgL_arg3533z00_1036;

									BgL_arg3533z00_1036 = MAKE_PAIR(BNIL, BNIL);
									BgL_list3532z00_1035 =
										MAKE_PAIR(BgL_arg3530z00_1033, BgL_arg3533z00_1036);
								}
								BgL_arg3528z00_1031 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
									(BgL_arg3529z00_1032, BgL_list3532z00_1035);
						}}
						return MAKE_PAIR(BgL_arg3527z00_1030, BgL_arg3528z00_1031);
					}
			}
		}
	}



/* _runtime-type-error */
	obj_t BGl__runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t BgL_envz00_1801,
		obj_t BgL_locz00_1802, obj_t BgL_tiz00_1803, obj_t BgL_valuez00_1804)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 69 */
			return
				BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(BgL_locz00_1802,
				BgL_tiz00_1803, BgL_valuez00_1804);
		}
	}



/* convert-error */
	obj_t BGl_convertzd2errorzd2zzcoerce_convertz00(BgL_typez00_bglt
		BgL_fromz00_44, BgL_typez00_bglt BgL_toz00_45, obj_t BgL_locz00_46,
		BgL_nodez00_bglt BgL_nodez00_47)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 114 */
			{	/* Coerce/convert.scm 117 */
				bool_t BgL_testz00_1965;

				if (((obj_t) (BgL_toz00_45) == BGl_za2objza2z00zztype_cachez00))
					{	/* Coerce/convert.scm 117 */
						BgL_testz00_1965 = ((bool_t) 0);
					}
				else
					{	/* Coerce/convert.scm 117 */
						BgL_testz00_1965 =
							BGl_subzd2typezf3z21zztype_envz00(BgL_toz00_45,
							(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00));
					}
				if (BgL_testz00_1965)
					{	/* Coerce/convert.scm 117 */
						{	/* Coerce/convert.scm 119 */
							obj_t BgL_arg3565z00_1069;

							BgL_arg3565z00_1069 = BGl_currentzd2functionzd2zztools_errorz00();
							BGl_userzd2warningzf2locationz20zztools_errorz00(BgL_locz00_46,
								BgL_arg3565z00_1069, BGl_string3772z00zzcoerce_convertz00,
								BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
								(BGl_string3773z00zzcoerce_convertz00,
									BGl_shapez00zztools_shapez00((obj_t) (BgL_toz00_45)),
									BGl_shapez00zztools_shapez00((obj_t) (BgL_fromz00_44))));
						}
						{	/* Coerce/convert.scm 120 */
							obj_t BgL_arg3566z00_1070;

							{	/* Coerce/convert.scm 120 */
								obj_t BgL_arg3567z00_1071;

								BgL_arg3567z00_1071 =
									(((BgL_typez00_bglt) CREF(BgL_toz00_45))->BgL_idz00);
								BgL_arg3566z00_1070 =
									BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
									(BgL_locz00_46, BgL_arg3567z00_1071,
									(obj_t) (BgL_nodez00_47));
							}
							return
								(obj_t) (BGl_coercez12z12zzcoerce_coercez00(
									(BgL_nodez00_bglt) (BgL_arg3566z00_1070), BUNSPEC,
									BgL_fromz00_44, ((bool_t) 0)));
						}
					}
				else
					{	/* Coerce/convert.scm 124 */
						obj_t BgL_arg3568z00_1072;

						BgL_arg3568z00_1072 = BGl_currentzd2functionzd2zztools_errorz00();
						return
							BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_46,
							BgL_arg3568z00_1072, BGl_string3772z00zzcoerce_convertz00,
							BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
							(BGl_string3773z00zzcoerce_convertz00,
								BGl_shapez00zztools_shapez00((obj_t) (BgL_toz00_45)),
								BGl_shapez00zztools_shapez00((obj_t) (BgL_fromz00_44))), BNIL);
					}
			}
		}
	}



/* convert! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt BgL_nodez00_48,
		BgL_typez00_bglt BgL_fromz00_49, BgL_typez00_bglt BgL_toz00_50,
		bool_t BgL_safez00_51)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 132 */
			{	/* Coerce/convert.scm 136 */
				BgL_typez00_bglt BgL_toz00_1074;

				BgL_typez00_bglt BgL_fromz00_1075;

				BgL_toz00_1074 =
					BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_toz00_50);
				BgL_fromz00_1075 =
					BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_fromz00_49);
				{	/* Coerce/convert.scm 138 */
					bool_t BgL_testz00_1993;

					if (((obj_t) (BgL_fromz00_1075) == (obj_t) (BgL_toz00_1074)))
						{	/* Coerce/convert.scm 138 */
							BgL_testz00_1993 = ((bool_t) 1);
						}
					else
						{	/* Coerce/convert.scm 138 */
							BgL_testz00_1993 =
								(((BgL_typez00_bglt) CREF(BgL_fromz00_1075))->BgL_magiczf3zf3);
						}
					if (BgL_testz00_1993)
						{	/* Coerce/convert.scm 138 */
							return BgL_nodez00_48;
						}
					else
						{	/* Coerce/convert.scm 140 */
							obj_t BgL_coercerz00_1077;

							obj_t BgL_locz00_1078;

							BgL_coercerz00_1077 =
								BGl_findzd2coercerzd2zztype_coercionz00(BgL_fromz00_1075,
								BgL_toz00_1074);
							BgL_locz00_1078 =
								(((BgL_nodez00_bglt) CREF(BgL_nodez00_48))->BgL_locz00);
							{	/* Coerce/convert.scm 142 */
								bool_t BgL_testz00_2001;

								if (STRUCTP(BgL_coercerz00_1077))
									{	/* Coerce/convert.scm 142 */
										BgL_testz00_2001 =
											(STRUCT_KEY(BgL_coercerz00_1077) ==
											CNST_TABLE_REF(((long) 12)));
									}
								else
									{	/* Coerce/convert.scm 142 */
										BgL_testz00_2001 = ((bool_t) 0);
									}
								if (BgL_testz00_2001)
									{	/* Coerce/convert.scm 146 */
										obj_t BgL_checksz00_1080;

										obj_t BgL_coercesz00_1081;

										BgL_checksz00_1080 =
											STRUCT_REF(BgL_coercerz00_1077, (int) (((long) 2)));
										BgL_coercesz00_1081 =
											STRUCT_REF(BgL_coercerz00_1077, (int) (((long) 3)));
										{
											obj_t BgL_checksz00_1082;

											obj_t BgL_coercesz00_1083;

											obj_t BgL_nodez00_1084;

											{	/* Coerce/convert.scm 151 */
												obj_t BgL_auxz00_2011;

												BgL_checksz00_1082 = BgL_checksz00_1080;
												BgL_coercesz00_1083 = BgL_coercesz00_1081;
												BgL_nodez00_1084 = (obj_t) (BgL_nodez00_48);
											BgL_loopz00_1085:
												if (NULLP(BgL_checksz00_1082))
													{	/* Coerce/convert.scm 155 */
														if (NULLP(BgL_coercesz00_1083))
															{	/* Coerce/convert.scm 156 */
																BgL_auxz00_2011 = BgL_nodez00_1084;
															}
														else
															{	/* Coerce/convert.scm 156 */
																BgL_auxz00_2011 =
																	BGl_internalzd2errorzd2zztools_errorz00
																	(BGl_string3774z00zzcoerce_convertz00,
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_fromz00_1075)),
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_toz00_1074)));
															}
													}
												else
													{	/* Coerce/convert.scm 155 */
														if (NULLP(BgL_coercesz00_1083))
															{	/* Coerce/convert.scm 161 */
																BgL_auxz00_2011 =
																	BGl_internalzd2errorzd2zztools_errorz00
																	(BGl_string3774z00zzcoerce_convertz00,
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_fromz00_1075)),
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_toz00_1074)));
															}
														else
															{
																obj_t BgL_nodez00_2032;

																obj_t BgL_coercesz00_2030;

																obj_t BgL_checksz00_2028;

																BgL_checksz00_2028 = CDR(BgL_checksz00_1082);
																BgL_coercesz00_2030 = CDR(BgL_coercesz00_1083);
																BgL_nodez00_2032 =
																	BGl_makezd2onezd2conversionz00zzcoerce_convertz00
																	(CAR(BgL_checksz00_1082), BgL_fromz00_1075,
																	BgL_toz00_1074, CAR(BgL_checksz00_1082),
																	CAR(BgL_coercesz00_1083), BgL_nodez00_1084,
																	BgL_safez00_51);
																BgL_nodez00_1084 = BgL_nodez00_2032;
																BgL_coercesz00_1083 = BgL_coercesz00_2030;
																BgL_checksz00_1082 = BgL_checksz00_2028;
																goto BgL_loopz00_1085;
															}
													}
												return (BgL_nodez00_bglt) (BgL_auxz00_2011);
											}
										}
									}
								else
									{	/* Coerce/convert.scm 142 */
										return
											(BgL_nodez00_bglt)
											(BGl_convertzd2errorzd2zzcoerce_convertz00
											(BgL_fromz00_1075, BgL_toz00_1074, BgL_locz00_1078,
												BgL_nodez00_48));
									}
							}
						}
				}
			}
		}
	}



/* _convert!3771 */
	obj_t BGl__convertz123771z12zzcoerce_convertz00(obj_t BgL_envz00_1805,
		obj_t BgL_nodez00_1806, obj_t BgL_fromz00_1807, obj_t BgL_toz00_1808,
		obj_t BgL_safez00_1809)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 132 */
			return
				(obj_t) (BGl_convertz12z12zzcoerce_convertz00(
					(BgL_nodez00_bglt) (BgL_nodez00_1806),
					(BgL_typez00_bglt) (BgL_fromz00_1807),
					(BgL_typez00_bglt) (BgL_toz00_1808), CBOOL(BgL_safez00_1809)));
		}
	}



/* make-one-conversion */
	obj_t BGl_makezd2onezd2conversionz00zzcoerce_convertz00(obj_t
		BgL_idzd2fromzd2_52, BgL_typez00_bglt BgL_fromz00_53,
		BgL_typez00_bglt BgL_toz00_54, obj_t BgL_checkopz00_55,
		obj_t BgL_coerceopz00_56, obj_t BgL_nodez00_57, bool_t BgL_safez00_58)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 185 */
			{	/* Coerce/convert.scm 186 */
				bool_t BgL_testz00_2047;

				if (NULLP(BgL_checkopz00_55))
					{	/* Coerce/convert.scm 186 */
						BgL_testz00_2047 = ((bool_t) 1);
					}
				else
					{	/* Coerce/convert.scm 186 */
						if (BgL_safez00_58)
							{	/* Coerce/convert.scm 186 */
								BgL_testz00_2047 = ((bool_t) 0);
							}
						else
							{	/* Coerce/convert.scm 186 */
								BgL_testz00_2047 = ((bool_t) 1);
							}
					}
				if (BgL_testz00_2047)
					{	/* Coerce/convert.scm 186 */
						return
							BGl_dozd2convertzd2zzcoerce_convertz00(BgL_coerceopz00_56,
							BgL_nodez00_57, BgL_fromz00_53);
					}
				else
					{	/* Coerce/convert.scm 188 */
						bool_t BgL_testz00_2052;

						{	/* Coerce/convert.scm 188 */
							obj_t BgL_obj3213z00_1732;

							BgL_obj3213z00_1732 = (obj_t) (BgL_fromz00_53);
							BgL_testz00_2052 =
								BGl_iszd2azf3z21zz__objectz00(BgL_obj3213z00_1732,
								BGl_tclassz00zzobject_classz00);
						}
						if (BgL_testz00_2052)
							{	/* Coerce/convert.scm 188 */
								return
									BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00
									(BgL_idzd2fromzd2_52, BgL_fromz00_53, BgL_toz00_54,
									BgL_checkopz00_55, BgL_coerceopz00_56, BgL_nodez00_57);
							}
						else
							{	/* Coerce/convert.scm 188 */
								return
									(obj_t)
									(BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00
									(BgL_idzd2fromzd2_52, BgL_fromz00_53, BgL_toz00_54,
										BgL_checkopz00_55, BgL_coerceopz00_56, BgL_nodez00_57));
							}
					}
			}
		}
	}



/* skip-let-var */
	BgL_nodez00_bglt BGl_skipzd2letzd2varz00zzcoerce_convertz00(BgL_nodez00_bglt
		BgL_nodez00_59)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 195 */
		BGl_skipzd2letzd2varz00zzcoerce_convertz00:
			{	/* Coerce/convert.scm 196 */
				bool_t BgL_testz00_2058;

				{	/* Coerce/convert.scm 196 */
					obj_t BgL_obj3021z00_1733;

					BgL_obj3021z00_1733 = (obj_t) (BgL_nodez00_59);
					BgL_testz00_2058 =
						BGl_iszd2azf3z21zz__objectz00(BgL_obj3021z00_1733,
						BGl_letzd2varzd2zzast_nodez00);
				}
				if (BgL_testz00_2058)
					{
						BgL_nodez00_bglt BgL_nodez00_2061;

						{
							BgL_letzd2varzd2_bglt BgL_auxz00_2062;

							BgL_auxz00_2062 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_59);
							BgL_nodez00_2061 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2062))->BgL_bodyz00);
						}
						BgL_nodez00_59 = BgL_nodez00_2061;
						goto BGl_skipzd2letzd2varz00zzcoerce_convertz00;
					}
				else
					{	/* Coerce/convert.scm 196 */
						return BgL_nodez00_59;
					}
			}
		}
	}



/* make-one-type-conversion */
	BgL_nodez00_bglt
		BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00(obj_t
		BgL_idzd2fromzd2_60, BgL_typez00_bglt BgL_fromz00_61,
		BgL_typez00_bglt BgL_toz00_62, obj_t BgL_checkzd2opzd2_63,
		obj_t BgL_coercezd2opzd2_64, obj_t BgL_nodez00_65)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 203 */
			{	/* Coerce/convert.scm 204 */
				obj_t BgL_auxz00_1107;

				BgL_auxz00_1107 =
					BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
					(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 0))));
				{	/* Coerce/convert.scm 204 */
					obj_t BgL_locz00_1108;

					{
						BgL_nodez00_bglt BgL_auxz00_2068;

						BgL_auxz00_2068 = (BgL_nodez00_bglt) (BgL_nodez00_65);
						BgL_locz00_1108 =
							(((BgL_nodez00_bglt) CREF(BgL_auxz00_2068))->BgL_locz00);
					}
					{	/* Coerce/convert.scm 205 */
						BgL_nodez00_bglt BgL_lnodez00_1109;

						{	/* Coerce/convert.scm 212 */
							obj_t BgL_arg3602z00_1120;

							{	/* Coerce/convert.scm 212 */
								obj_t BgL_arg3603z00_1121;

								obj_t BgL_arg3604z00_1122;

								BgL_arg3603z00_1121 = CNST_TABLE_REF(((long) 1));
								{	/* Coerce/convert.scm 213 */
									obj_t BgL_arg3605z00_1123;

									obj_t BgL_arg3606z00_1124;

									{	/* Coerce/convert.scm 213 */
										obj_t BgL_arg3610z00_1128;

										{	/* Coerce/convert.scm 213 */
											obj_t BgL_arg3612z00_1130;

											obj_t BgL_arg3613z00_1131;

											{	/* Coerce/convert.scm 213 */
												obj_t BgL_arg3614z00_1132;

												{	/* Coerce/convert.scm 213 */
													obj_t BgL_arg3615z00_1133;

													BgL_arg3615z00_1133 =
														(((BgL_typez00_bglt) CREF(BgL_fromz00_61))->
														BgL_idz00);
													BgL_arg3614z00_1132 =
														BGl_makezd2typedzd2identz00zzast_identz00
														(BgL_auxz00_1107, BgL_arg3615z00_1133);
												}
												BgL_arg3612z00_1130 =
													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
													(BgL_arg3614z00_1132);
											}
											{	/* Coerce/convert.scm 212 */
												obj_t BgL_list3616z00_1134;

												BgL_list3616z00_1134 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3613z00_1131 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BUNSPEC,
													BgL_list3616z00_1134);
											}
											BgL_arg3610z00_1128 =
												MAKE_PAIR(BgL_arg3612z00_1130, BgL_arg3613z00_1131);
										}
										BgL_arg3605z00_1123 = MAKE_PAIR(BgL_arg3610z00_1128, BNIL);
									}
									{	/* Coerce/convert.scm 215 */
										obj_t BgL_arg3617z00_1135;

										obj_t BgL_arg3618z00_1136;

										BgL_arg3617z00_1135 = CNST_TABLE_REF(((long) 13));
										{	/* Coerce/convert.scm 215 */
											obj_t BgL_arg3619z00_1137;

											obj_t BgL_arg3620z00_1138;

											{	/* Coerce/convert.scm 215 */
												obj_t BgL_arg3625z00_1143;

												{	/* Coerce/convert.scm 215 */
													obj_t BgL_list3626z00_1144;

													BgL_list3626z00_1144 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg3625z00_1143 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_auxz00_1107, BgL_list3626z00_1144);
												}
												BgL_arg3619z00_1137 =
													MAKE_PAIR(BgL_checkzd2opzd2_63, BgL_arg3625z00_1143);
											}
											{	/* Coerce/convert.scm 217 */
												obj_t BgL_arg3627z00_1145;

												BgL_arg3627z00_1145 =
													(((BgL_typez00_bglt) CREF(BgL_toz00_62))->BgL_idz00);
												BgL_arg3620z00_1138 =
													BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
													(BgL_locz00_1108, BgL_arg3627z00_1145,
													BgL_auxz00_1107);
											}
											{	/* Coerce/convert.scm 215 */
												obj_t BgL_list3622z00_1140;

												{	/* Coerce/convert.scm 215 */
													obj_t BgL_arg3623z00_1141;

													{	/* Coerce/convert.scm 215 */
														obj_t BgL_arg3624z00_1142;

														BgL_arg3624z00_1142 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg3623z00_1141 =
															MAKE_PAIR(BgL_arg3620z00_1138,
															BgL_arg3624z00_1142);
													}
													BgL_list3622z00_1140 =
														MAKE_PAIR(BgL_auxz00_1107, BgL_arg3623z00_1141);
												}
												BgL_arg3618z00_1136 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3619z00_1137, BgL_list3622z00_1140);
										}}
										BgL_arg3606z00_1124 =
											MAKE_PAIR(BgL_arg3617z00_1135, BgL_arg3618z00_1136);
									}
									{	/* Coerce/convert.scm 212 */
										obj_t BgL_list3608z00_1126;

										{	/* Coerce/convert.scm 212 */
											obj_t BgL_arg3609z00_1127;

											BgL_arg3609z00_1127 = MAKE_PAIR(BNIL, BNIL);
											BgL_list3608z00_1126 =
												MAKE_PAIR(BgL_arg3606z00_1124, BgL_arg3609z00_1127);
										}
										BgL_arg3604z00_1122 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg3605z00_1123, BgL_list3608z00_1126);
								}}
								BgL_arg3602z00_1120 =
									MAKE_PAIR(BgL_arg3603z00_1121, BgL_arg3604z00_1122);
							}
							BgL_lnodez00_1109 =
								BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
								(BgL_arg3602z00_1120, BgL_locz00_1108);
						}
						{	/* Coerce/convert.scm 206 */

							BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_lnodez00_1109);
							BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00
								(BgL_lnodez00_1109);
							{	/* Coerce/convert.scm 221 */
								obj_t BgL_varz00_1110;

								{	/* Coerce/convert.scm 221 */
									obj_t BgL_pairz00_1740;

									{	/* Coerce/convert.scm 221 */
										obj_t BgL_pairz00_1739;

										{
											BgL_letzd2varzd2_bglt BgL_auxz00_2097;

											BgL_auxz00_2097 =
												(BgL_letzd2varzd2_bglt) (BgL_lnodez00_1109);
											BgL_pairz00_1739 =
												(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2097))->
												BgL_bindingsz00);
										}
										BgL_pairz00_1740 = CAR(BgL_pairz00_1739);
									}
									BgL_varz00_1110 = CAR(BgL_pairz00_1740);
								}
								{	/* Coerce/convert.scm 221 */
									obj_t BgL_coercezd2appzd2_1111;

									{	/* Coerce/convert.scm 223 */
										BgL_varz00_bglt BgL_arg3598z00_1117;

										BgL_arg3598z00_1117 =
											BGl_makezd2varzd2zzast_nodez00(BgL_locz00_1108,
											BgL_fromz00_61, (BgL_variablez00_bglt) (BgL_varz00_1110));
										BgL_coercezd2appzd2_1111 =
											BGl_dozd2convertzd2zzcoerce_convertz00
											(BgL_coercezd2opzd2_64, (obj_t) (BgL_arg3598z00_1117),
											BgL_fromz00_61);
									}
									{	/* Coerce/convert.scm 222 */
										BgL_nodez00_bglt BgL_condnz00_1112;

										BgL_condnz00_1112 =
											BGl_skipzd2letzd2varz00zzcoerce_convertz00
											(BgL_lnodez00_1109);
										{	/* Coerce/convert.scm 228 */

											{
												BgL_variablez00_bglt BgL_auxz00_2107;

												BgL_auxz00_2107 =
													(BgL_variablez00_bglt) (BgL_varz00_1110);
												((((BgL_variablez00_bglt) CREF(BgL_auxz00_2107))->
														BgL_typez00) =
													((BgL_typez00_bglt) BgL_fromz00_61), BUNSPEC);
											}
											{	/* Coerce/convert.scm 232 */
												obj_t BgL_arg3594z00_1113;

												{	/* Coerce/convert.scm 232 */
													obj_t BgL_pairz00_1744;

													{
														BgL_letzd2varzd2_bglt BgL_auxz00_2110;

														BgL_auxz00_2110 =
															(BgL_letzd2varzd2_bglt) (BgL_lnodez00_1109);
														BgL_pairz00_1744 =
															(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2110))->
															BgL_bindingsz00);
													}
													BgL_arg3594z00_1113 = CAR(BgL_pairz00_1744);
												}
												SET_CDR(BgL_arg3594z00_1113, BgL_nodez00_65);
											}
											{
												BgL_nodez00_bglt BgL_auxz00_2117;

												BgL_conditionalz00_bglt BgL_auxz00_2115;

												BgL_auxz00_2117 =
													(BgL_nodez00_bglt) (BgL_coercezd2appzd2_1111);
												BgL_auxz00_2115 =
													(BgL_conditionalz00_bglt) (BgL_condnz00_1112);
												((((BgL_conditionalz00_bglt) CREF(BgL_auxz00_2115))->
														BgL_truez00) =
													((BgL_nodez00_bglt) BgL_auxz00_2117), BUNSPEC);
											}
											{	/* Coerce/convert.scm 235 */
												BgL_nodez00_bglt BgL_arg3596z00_1115;

												{	/* Coerce/convert.scm 235 */
													BgL_nodez00_bglt BgL_arg3597z00_1116;

													{
														BgL_conditionalz00_bglt BgL_auxz00_2120;

														BgL_auxz00_2120 =
															(BgL_conditionalz00_bglt) (BgL_condnz00_1112);
														BgL_arg3597z00_1116 =
															(((BgL_conditionalz00_bglt)
																CREF(BgL_auxz00_2120))->BgL_falsez00);
													}
													BgL_arg3596z00_1115 =
														BGl_coercez12z12zzcoerce_coercez00
														(BgL_arg3597z00_1116, BUNSPEC, BgL_fromz00_61,
														((bool_t) 0));
												}
												{
													BgL_conditionalz00_bglt BgL_auxz00_2124;

													BgL_auxz00_2124 =
														(BgL_conditionalz00_bglt) (BgL_condnz00_1112);
													((((BgL_conditionalz00_bglt) CREF(BgL_auxz00_2124))->
															BgL_falsez00) =
														((BgL_nodez00_bglt) BgL_arg3596z00_1115), BUNSPEC);
											}}
											return BgL_lnodez00_1109;
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* make-one-class-conversion */
	obj_t BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00(obj_t
		BgL_idzd2fromzd2_66, BgL_typez00_bglt BgL_fromz00_67,
		BgL_typez00_bglt BgL_toz00_68, obj_t BgL_checkzd2opzd2_69,
		obj_t BgL_coercezd2opzd2_70, obj_t BgL_nodez00_71)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 244 */
			{	/* Coerce/convert.scm 245 */
				bool_t BgL_testz00_2127;

				{	/* Coerce/convert.scm 245 */
					bool_t BgL_testz00_2128;

					{	/* Coerce/convert.scm 245 */
						obj_t BgL_obj3213z00_1752;

						BgL_obj3213z00_1752 = (obj_t) (BgL_toz00_68);
						BgL_testz00_2128 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj3213z00_1752,
							BGl_tclassz00zzobject_classz00);
					}
					if (BgL_testz00_2128)
						{	/* Coerce/convert.scm 245 */
							BgL_testz00_2127 =
								BGl_typezd2subclasszf3z21zzobject_classz00(BgL_fromz00_67,
								BgL_toz00_68);
						}
					else
						{	/* Coerce/convert.scm 245 */
							BgL_testz00_2127 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_2127)
					{	/* Coerce/convert.scm 245 */
						return
							BGl_dozd2convertzd2zzcoerce_convertz00(BgL_coercezd2opzd2_70,
							BgL_nodez00_71, BgL_fromz00_67);
					}
				else
					{	/* Coerce/convert.scm 247 */
						obj_t BgL_auxz00_1148;

						BgL_auxz00_1148 =
							BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 0)));
						{	/* Coerce/convert.scm 247 */
							obj_t BgL_aux2z00_1149;

							BgL_aux2z00_1149 =
								BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 14)));
							{	/* Coerce/convert.scm 248 */
								obj_t BgL_locz00_1150;

								{
									BgL_nodez00_bglt BgL_auxz00_2137;

									BgL_auxz00_2137 = (BgL_nodez00_bglt) (BgL_nodez00_71);
									BgL_locz00_1150 =
										(((BgL_nodez00_bglt) CREF(BgL_auxz00_2137))->BgL_locz00);
								}
								{	/* Coerce/convert.scm 249 */
									BgL_nodez00_bglt BgL_lnodez00_1151;

									{	/* Coerce/convert.scm 251 */
										obj_t BgL_arg3641z00_1167;

										{	/* Coerce/convert.scm 251 */
											obj_t BgL_arg3642z00_1168;

											obj_t BgL_arg3643z00_1169;

											BgL_arg3642z00_1168 = CNST_TABLE_REF(((long) 1));
											{	/* Coerce/convert.scm 252 */
												obj_t BgL_arg3644z00_1170;

												obj_t BgL_arg3645z00_1171;

												{	/* Coerce/convert.scm 252 */
													obj_t BgL_arg3649z00_1175;

													{	/* Coerce/convert.scm 252 */
														obj_t BgL_arg3651z00_1177;

														obj_t BgL_arg3652z00_1178;

														{	/* Coerce/convert.scm 252 */
															obj_t BgL_arg3653z00_1179;

															{	/* Coerce/convert.scm 252 */
																obj_t BgL_arg3654z00_1180;

																{	/* Coerce/convert.scm 252 */
																	obj_t BgL_arg3656z00_1181;

																	obj_t BgL_arg3657z00_1182;

																	BgL_arg3656z00_1181 =
																		SYMBOL_TO_STRING(BgL_auxz00_1148);
																	{	/* Coerce/convert.scm 252 */
																		obj_t BgL_symbolz00_1755;

																		BgL_symbolz00_1755 =
																			CNST_TABLE_REF(((long) 2));
																		BgL_arg3657z00_1182 =
																			SYMBOL_TO_STRING(BgL_symbolz00_1755);
																	}
																	{	/* Coerce/convert.scm 252 */
																		obj_t BgL_list3658z00_1183;

																		{	/* Coerce/convert.scm 252 */
																			obj_t BgL_arg3659z00_1184;

																			BgL_arg3659z00_1184 =
																				MAKE_PAIR(BgL_arg3657z00_1182, BNIL);
																			BgL_list3658z00_1183 =
																				MAKE_PAIR(BgL_arg3656z00_1181,
																				BgL_arg3659z00_1184);
																		}
																		BgL_arg3654z00_1180 =
																			BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																			(BgL_list3658z00_1183);
																}}
																BgL_arg3653z00_1179 =
																	string_to_symbol(BSTRING_TO_STRING
																	(BgL_arg3654z00_1180));
															}
															BgL_arg3651z00_1177 =
																BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																(BgL_arg3653z00_1179);
														}
														{	/* Coerce/convert.scm 251 */
															obj_t BgL_list3660z00_1185;

															BgL_list3660z00_1185 = MAKE_PAIR(BNIL, BNIL);
															BgL_arg3652z00_1178 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BUNSPEC, BgL_list3660z00_1185);
														}
														BgL_arg3649z00_1175 =
															MAKE_PAIR(BgL_arg3651z00_1177,
															BgL_arg3652z00_1178);
													}
													BgL_arg3644z00_1170 =
														MAKE_PAIR(BgL_arg3649z00_1175, BNIL);
												}
												{	/* Coerce/convert.scm 253 */
													obj_t BgL_arg3661z00_1186;

													obj_t BgL_arg3662z00_1187;

													BgL_arg3661z00_1186 = CNST_TABLE_REF(((long) 1));
													{	/* Coerce/convert.scm 254 */
														obj_t BgL_arg3663z00_1188;

														obj_t BgL_arg3664z00_1189;

														{	/* Coerce/convert.scm 254 */
															obj_t BgL_arg3668z00_1193;

															{	/* Coerce/convert.scm 254 */
																obj_t BgL_arg3670z00_1195;

																obj_t BgL_arg3671z00_1196;

																{	/* Coerce/convert.scm 254 */
																	obj_t BgL_arg3672z00_1197;

																	{	/* Coerce/convert.scm 254 */
																		obj_t BgL_arg3673z00_1198;

																		{	/* Coerce/convert.scm 254 */
																			obj_t BgL_arg3674z00_1199;

																			obj_t BgL_arg3675z00_1200;

																			BgL_arg3674z00_1199 =
																				SYMBOL_TO_STRING(BgL_aux2z00_1149);
																			{	/* Coerce/convert.scm 254 */
																				obj_t BgL_symbolz00_1758;

																				BgL_symbolz00_1758 =
																					CNST_TABLE_REF(((long) 2));
																				BgL_arg3675z00_1200 =
																					SYMBOL_TO_STRING(BgL_symbolz00_1758);
																			}
																			{	/* Coerce/convert.scm 254 */
																				obj_t BgL_list3676z00_1201;

																				{	/* Coerce/convert.scm 254 */
																					obj_t BgL_arg3677z00_1202;

																					BgL_arg3677z00_1202 =
																						MAKE_PAIR(BgL_arg3675z00_1200,
																						BNIL);
																					BgL_list3676z00_1201 =
																						MAKE_PAIR(BgL_arg3674z00_1199,
																						BgL_arg3677z00_1202);
																				}
																				BgL_arg3673z00_1198 =
																					BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																					(BgL_list3676z00_1201);
																		}}
																		BgL_arg3672z00_1197 =
																			string_to_symbol(BSTRING_TO_STRING
																			(BgL_arg3673z00_1198));
																	}
																	BgL_arg3670z00_1195 =
																		BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																		(BgL_arg3672z00_1197);
																}
																{	/* Coerce/convert.scm 253 */
																	obj_t BgL_list3678z00_1203;

																	BgL_list3678z00_1203 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg3671z00_1196 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BUNSPEC, BgL_list3678z00_1203);
																}
																BgL_arg3668z00_1193 =
																	MAKE_PAIR(BgL_arg3670z00_1195,
																	BgL_arg3671z00_1196);
															}
															BgL_arg3663z00_1188 =
																MAKE_PAIR(BgL_arg3668z00_1193, BNIL);
														}
														{	/* Coerce/convert.scm 255 */
															obj_t BgL_arg3679z00_1204;

															obj_t BgL_arg3680z00_1205;

															BgL_arg3679z00_1204 = CNST_TABLE_REF(((long) 13));
															{	/* Coerce/convert.scm 255 */
																obj_t BgL_arg3681z00_1206;

																obj_t BgL_arg3682z00_1207;

																{	/* Coerce/convert.scm 255 */
																	obj_t BgL_arg3687z00_1212;

																	{	/* Coerce/convert.scm 255 */
																		obj_t BgL_list3688z00_1213;

																		BgL_list3688z00_1213 =
																			MAKE_PAIR(BNIL, BNIL);
																		BgL_arg3687z00_1212 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_aux2z00_1149, BgL_list3688z00_1213);
																	}
																	BgL_arg3681z00_1206 =
																		MAKE_PAIR(BgL_checkzd2opzd2_69,
																		BgL_arg3687z00_1212);
																}
																{	/* Coerce/convert.scm 257 */
																	obj_t BgL_arg3689z00_1214;

																	BgL_arg3689z00_1214 =
																		(((BgL_typez00_bglt) CREF(BgL_toz00_68))->
																		BgL_idz00);
																	BgL_arg3682z00_1207 =
																		BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
																		(BgL_locz00_1150, BgL_arg3689z00_1214,
																		BgL_auxz00_1148);
																}
																{	/* Coerce/convert.scm 255 */
																	obj_t BgL_list3684z00_1209;

																	{	/* Coerce/convert.scm 255 */
																		obj_t BgL_arg3685z00_1210;

																		{	/* Coerce/convert.scm 255 */
																			obj_t BgL_arg3686z00_1211;

																			BgL_arg3686z00_1211 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg3685z00_1210 =
																				MAKE_PAIR(BgL_arg3682z00_1207,
																				BgL_arg3686z00_1211);
																		}
																		BgL_list3684z00_1209 =
																			MAKE_PAIR(BgL_auxz00_1148,
																			BgL_arg3685z00_1210);
																	}
																	BgL_arg3680z00_1205 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg3681z00_1206, BgL_list3684z00_1209);
															}}
															BgL_arg3664z00_1189 =
																MAKE_PAIR(BgL_arg3679z00_1204,
																BgL_arg3680z00_1205);
														}
														{	/* Coerce/convert.scm 253 */
															obj_t BgL_list3666z00_1191;

															{	/* Coerce/convert.scm 253 */
																obj_t BgL_arg3667z00_1192;

																BgL_arg3667z00_1192 = MAKE_PAIR(BNIL, BNIL);
																BgL_list3666z00_1191 =
																	MAKE_PAIR(BgL_arg3664z00_1189,
																	BgL_arg3667z00_1192);
															}
															BgL_arg3662z00_1187 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg3663z00_1188, BgL_list3666z00_1191);
													}}
													BgL_arg3645z00_1171 =
														MAKE_PAIR(BgL_arg3661z00_1186, BgL_arg3662z00_1187);
												}
												{	/* Coerce/convert.scm 251 */
													obj_t BgL_list3647z00_1173;

													{	/* Coerce/convert.scm 251 */
														obj_t BgL_arg3648z00_1174;

														BgL_arg3648z00_1174 = MAKE_PAIR(BNIL, BNIL);
														BgL_list3647z00_1173 =
															MAKE_PAIR(BgL_arg3645z00_1171,
															BgL_arg3648z00_1174);
													}
													BgL_arg3643z00_1169 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg3644z00_1170, BgL_list3647z00_1173);
											}}
											BgL_arg3641z00_1167 =
												MAKE_PAIR(BgL_arg3642z00_1168, BgL_arg3643z00_1169);
										}
										BgL_lnodez00_1151 =
											BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
											(BgL_arg3641z00_1167, BgL_locz00_1150);
									}
									{	/* Coerce/convert.scm 250 */

										BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_lnodez00_1151);
										BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00
											(BgL_lnodez00_1151);
										{	/* Coerce/convert.scm 261 */
											obj_t BgL_varz00_1152;

											{	/* Coerce/convert.scm 261 */
												obj_t BgL_pairz00_1763;

												{	/* Coerce/convert.scm 261 */
													obj_t BgL_pairz00_1762;

													{
														BgL_letzd2varzd2_bglt BgL_auxz00_2190;

														BgL_auxz00_2190 =
															(BgL_letzd2varzd2_bglt) (BgL_lnodez00_1151);
														BgL_pairz00_1762 =
															(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2190))->
															BgL_bindingsz00);
													}
													BgL_pairz00_1763 = CAR(BgL_pairz00_1762);
												}
												BgL_varz00_1152 = CAR(BgL_pairz00_1763);
											}
											{	/* Coerce/convert.scm 261 */
												obj_t BgL_coercezd2appzd2_1153;

												{	/* Coerce/convert.scm 263 */
													BgL_varz00_bglt BgL_arg3638z00_1164;

													BgL_arg3638z00_1164 =
														BGl_makezd2varzd2zzast_nodez00(BgL_locz00_1150,
														BgL_fromz00_67,
														(BgL_variablez00_bglt) (BgL_varz00_1152));
													BgL_coercezd2appzd2_1153 =
														BGl_dozd2convertzd2zzcoerce_convertz00
														(BgL_coercezd2opzd2_70,
														(obj_t) (BgL_arg3638z00_1164), BgL_fromz00_67);
												}
												{	/* Coerce/convert.scm 262 */
													BgL_nodez00_bglt BgL_condnz00_1154;

													BgL_condnz00_1154 =
														BGl_skipzd2letzd2varz00zzcoerce_convertz00
														(BgL_lnodez00_1151);
													{	/* Coerce/convert.scm 268 */

														{
															BgL_variablez00_bglt BgL_auxz00_2200;

															BgL_auxz00_2200 =
																(BgL_variablez00_bglt) (BgL_varz00_1152);
															((((BgL_variablez00_bglt) CREF(BgL_auxz00_2200))->
																	BgL_typez00) =
																((BgL_typez00_bglt) BgL_fromz00_67), BUNSPEC);
														}
														{	/* Coerce/convert.scm 272 */
															obj_t BgL_arg3630z00_1155;

															{	/* Coerce/convert.scm 272 */
																obj_t BgL_pairz00_1767;

																{
																	BgL_letzd2varzd2_bglt BgL_auxz00_2203;

																	BgL_auxz00_2203 =
																		(BgL_letzd2varzd2_bglt) (BgL_lnodez00_1151);
																	BgL_pairz00_1767 =
																		(((BgL_letzd2varzd2_bglt)
																			CREF(BgL_auxz00_2203))->BgL_bindingsz00);
																}
																BgL_arg3630z00_1155 = CAR(BgL_pairz00_1767);
															}
															SET_CDR(BgL_arg3630z00_1155, BgL_nodez00_71);
														}
														{	/* Coerce/convert.scm 273 */
															obj_t BgL_binding2z00_1157;

															{	/* Coerce/convert.scm 273 */
																obj_t BgL_pairz00_1772;

																{	/* Coerce/convert.scm 273 */
																	BgL_letzd2varzd2_bglt BgL_obj2988z00_1771;

																	{	/* Coerce/convert.scm 273 */
																		BgL_letzd2varzd2_bglt BgL_obj2991z00_1770;

																		BgL_obj2991z00_1770 =
																			(BgL_letzd2varzd2_bglt)
																			(BgL_lnodez00_1151);
																		BgL_obj2988z00_1771 =
																			(BgL_letzd2varzd2_bglt) (((
																					(BgL_letzd2varzd2_bglt)
																					CREF(BgL_obj2991z00_1770))->
																				BgL_bodyz00));
																	}
																	BgL_pairz00_1772 =
																		(((BgL_letzd2varzd2_bglt)
																			CREF(BgL_obj2988z00_1771))->
																		BgL_bindingsz00);
																}
																BgL_binding2z00_1157 = CAR(BgL_pairz00_1772);
															}
															{	/* Coerce/convert.scm 277 */
																BgL_castz00_bglt BgL_arg3632z00_1158;

																{	/* Coerce/convert.scm 277 */
																	BgL_varz00_bglt BgL_arg3633z00_1159;

																	BgL_arg3633z00_1159 =
																		BGl_makezd2varzd2zzast_nodez00
																		(BgL_locz00_1150, BgL_fromz00_67,
																		(BgL_variablez00_bglt) (BgL_varz00_1152));
																	BgL_arg3632z00_1158 =
																		BGl_makezd2castzd2zzast_nodez00
																		(BgL_locz00_1150,
																		(BgL_typez00_bglt)
																		(BGl_za2objza2z00zztype_cachez00),
																		(BgL_nodez00_bglt) (BgL_arg3633z00_1159));
																}
																{	/* Coerce/convert.scm 274 */
																	obj_t BgL_auxz00_2218;

																	BgL_auxz00_2218 =
																		(obj_t) (BgL_arg3632z00_1158);
																	SET_CDR(BgL_binding2z00_1157,
																		BgL_auxz00_2218);
														}}}
														{
															BgL_nodez00_bglt BgL_auxz00_2223;

															BgL_conditionalz00_bglt BgL_auxz00_2221;

															BgL_auxz00_2223 =
																(BgL_nodez00_bglt) (BgL_coercezd2appzd2_1153);
															BgL_auxz00_2221 =
																(BgL_conditionalz00_bglt) (BgL_condnz00_1154);
															((((BgL_conditionalz00_bglt)
																		CREF(BgL_auxz00_2221))->BgL_truez00) =
																((BgL_nodez00_bglt) BgL_auxz00_2223), BUNSPEC);
														}
														{	/* Coerce/convert.scm 283 */
															BgL_nodez00_bglt BgL_arg3636z00_1162;

															{	/* Coerce/convert.scm 283 */
																BgL_nodez00_bglt BgL_arg3637z00_1163;

																{
																	BgL_conditionalz00_bglt BgL_auxz00_2226;

																	BgL_auxz00_2226 =
																		(BgL_conditionalz00_bglt)
																		(BgL_condnz00_1154);
																	BgL_arg3637z00_1163 =
																		(((BgL_conditionalz00_bglt)
																			CREF(BgL_auxz00_2226))->BgL_falsez00);
																}
																BgL_arg3636z00_1162 =
																	BGl_coercez12z12zzcoerce_coercez00
																	(BgL_arg3637z00_1163, BUNSPEC, BgL_fromz00_67,
																	((bool_t) 0));
															}
															{
																BgL_conditionalz00_bglt BgL_auxz00_2230;

																BgL_auxz00_2230 =
																	(BgL_conditionalz00_bglt) (BgL_condnz00_1154);
																((((BgL_conditionalz00_bglt)
																			CREF(BgL_auxz00_2230))->BgL_falsez00) =
																	((BgL_nodez00_bglt) BgL_arg3636z00_1162),
																	BUNSPEC);
														}}
														return (obj_t) (BgL_lnodez00_1151);
													}
												}
											}
										}
									}
								}
							}
						}
					}
			}
		}
	}



/* do-convert */
	obj_t BGl_dozd2convertzd2zzcoerce_convertz00(obj_t BgL_coercezd2opzd2_72,
		obj_t BgL_nodez00_73, BgL_typez00_bglt BgL_fromz00_74)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 292 */
			if (NULLP(BgL_coercezd2opzd2_72))
				{	/* Coerce/convert.scm 295 */
					return BgL_nodez00_73;
				}
			else
				{	/* Coerce/convert.scm 297 */
					BgL_nodez00_bglt BgL_nnodez00_1217;

					{	/* Coerce/convert.scm 297 */
						obj_t BgL_arg3709z00_1236;

						obj_t BgL_arg3710z00_1237;

						{	/* Coerce/convert.scm 297 */
							obj_t BgL_arg3711z00_1238;

							{	/* Coerce/convert.scm 297 */
								obj_t BgL_list3712z00_1239;

								BgL_list3712z00_1239 = MAKE_PAIR(BNIL, BNIL);
								BgL_arg3711z00_1238 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BUNSPEC,
									BgL_list3712z00_1239);
							}
							BgL_arg3709z00_1236 =
								MAKE_PAIR(BgL_coercezd2opzd2_72, BgL_arg3711z00_1238);
						}
						{
							BgL_nodez00_bglt BgL_auxz00_2239;

							BgL_auxz00_2239 = (BgL_nodez00_bglt) (BgL_nodez00_73);
							BgL_arg3710z00_1237 =
								(((BgL_nodez00_bglt) CREF(BgL_auxz00_2239))->BgL_locz00);
						}
						BgL_nnodez00_1217 =
							BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
							(BgL_arg3709z00_1236, BgL_arg3710z00_1237);
					}
					{	/* Coerce/convert.scm 297 */

						{
							BgL_nodez00_bglt BgL_auxz00_2243;

							BgL_auxz00_2243 = (BgL_nodez00_bglt) (BgL_nodez00_73);
							((((BgL_nodez00_bglt) CREF(BgL_auxz00_2243))->BgL_typez00) =
								((BgL_typez00_bglt) BgL_fromz00_74), BUNSPEC);
						}
						BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00
							(BgL_nnodez00_1217);
						{	/* Coerce/convert.scm 311 */
							bool_t BgL_testz00_2247;

							{	/* Coerce/convert.scm 311 */
								obj_t BgL_obj2194z00_1784;

								BgL_obj2194z00_1784 = (obj_t) (BgL_nnodez00_1217);
								BgL_testz00_2247 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj2194z00_1784,
									BGl_appz00zzast_nodez00);
							}
							if (BgL_testz00_2247)
								{	/* Coerce/convert.scm 311 */
									{	/* Coerce/convert.scm 312 */
										obj_t BgL_arg3693z00_1219;

										{	/* Coerce/convert.scm 312 */
											obj_t BgL_list3694z00_1220;

											BgL_list3694z00_1220 = MAKE_PAIR(BgL_nodez00_73, BNIL);
											BgL_arg3693z00_1219 = BgL_list3694z00_1220;
										}
										{
											BgL_appz00_bglt BgL_auxz00_2251;

											BgL_auxz00_2251 = (BgL_appz00_bglt) (BgL_nnodez00_1217);
											((((BgL_appz00_bglt) CREF(BgL_auxz00_2251))->
													BgL_argsz00) =
												((obj_t) BgL_arg3693z00_1219), BUNSPEC);
										}
									}
									return (obj_t) (BgL_nnodez00_1217);
								}
							else
								{	/* Coerce/convert.scm 314 */
									bool_t BgL_testz00_2255;

									{	/* Coerce/convert.scm 314 */
										obj_t BgL_obj3021z00_1789;

										BgL_obj3021z00_1789 = (obj_t) (BgL_nnodez00_1217);
										BgL_testz00_2255 =
											BGl_iszd2azf3z21zz__objectz00(BgL_obj3021z00_1789,
											BGl_letzd2varzd2zzast_nodez00);
									}
									if (BgL_testz00_2255)
										{	/* Coerce/convert.scm 315 */
											obj_t BgL_bdgsz00_1222;

											{
												BgL_letzd2varzd2_bglt BgL_auxz00_2258;

												BgL_auxz00_2258 =
													(BgL_letzd2varzd2_bglt) (BgL_nnodez00_1217);
												BgL_bdgsz00_1222 =
													(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2258))->
													BgL_bindingsz00);
											}
											{	/* Coerce/convert.scm 316 */
												bool_t BgL_testz00_2261;

												if (NULLP(BgL_bdgsz00_1222))
													{	/* Coerce/convert.scm 316 */
														BgL_testz00_2261 = ((bool_t) 1);
													}
												else
													{	/* Coerce/convert.scm 316 */
														if (NULLP(CDR(BgL_bdgsz00_1222)))
															{	/* Coerce/convert.scm 316 */
																BgL_testz00_2261 = ((bool_t) 0);
															}
														else
															{	/* Coerce/convert.scm 316 */
																BgL_testz00_2261 = ((bool_t) 1);
															}
													}
												if (BgL_testz00_2261)
													{	/* Coerce/convert.scm 316 */
														return
															BGl_internalzd2errorzd2zztools_errorz00
															(BGl_string3775z00zzcoerce_convertz00,
															BGl_string3776z00zzcoerce_convertz00,
															BGl_shapez00zztools_shapez00
															(BgL_coercezd2opzd2_72));
													}
												else
													{	/* Coerce/convert.scm 316 */
														{	/* Coerce/convert.scm 321 */
															obj_t BgL_arg3700z00_1227;

															BgL_arg3700z00_1227 = CAR(CAR(BgL_bdgsz00_1222));
															{
																BgL_variablez00_bglt BgL_auxz00_2271;

																BgL_auxz00_2271 =
																	(BgL_variablez00_bglt) (BgL_arg3700z00_1227);
																((((BgL_variablez00_bglt)
																			CREF(BgL_auxz00_2271))->BgL_typez00) =
																	((BgL_typez00_bglt) BgL_fromz00_74), BUNSPEC);
															}
														}
														{	/* Coerce/convert.scm 322 */
															obj_t BgL_auxz00_2274;

															BgL_auxz00_2274 = CAR(BgL_bdgsz00_1222);
															SET_CDR(BgL_auxz00_2274, BgL_nodez00_73);
														}
														return (obj_t) (BgL_nnodez00_1217);
													}
											}
										}
									else
										{	/* Coerce/convert.scm 314 */
											return
												BGl_internalzd2errorzd2zztools_errorz00
												(BGl_string3775z00zzcoerce_convertz00,
												BGl_string3776z00zzcoerce_convertz00,
												BGl_shapez00zztools_shapez00(BgL_coercezd2opzd2_72));
										}
								}
						}
					}
				}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 446742181),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 315910987),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_coercionz00(((long) 451733024),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 341705556),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 77938009),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_lvtypez00(((long) 498901618),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 71067807),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzcoerce_coercez00(((long) 387636515),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_spreadz00(((long) 476444243),
				BSTRING_TO_STRING(BGl_string3777z00zzcoerce_convertz00));
		}
	}

#ifdef __cplusplus
}
#endif
