/*===========================================================================*/
/*   (Engine/heap.scm)                                                       */
/*   Bigloo (3.2b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon May 25 12:42:12 CEST 2009       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Engine/heap.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_tclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		struct BgL_globalz00_bgl *BgL_holderz00;
		obj_t BgL_wideningz00;
		long BgL_depthz00;
		bool_t BgL_finalzf3zf3;
		obj_t BgL_constructorz00;
		obj_t BgL_virtualzd2slotszd2numberz00;
		bool_t BgL_abstractzf3zf3;
		obj_t BgL_widezd2typezd2;
	}                *BgL_tclassz00_bglt;


	static obj_t BGl_zc3anonymousza32370ze3z83zzengine_heapz00(obj_t, obj_t);
	static obj_t BGl_dumpzd2Tenvzd2zzengine_heapz00(obj_t);
	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza32362ze3z83zzengine_heapz00(obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32377ze3z83zzengine_heapz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	extern obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzengine_heapz00 = BUNSPEC;
	static obj_t BGl_zc3anonymousza32384ze3z83zzengine_heapz00(obj_t);
	static obj_t BGl_dumpzd2heapzd2zzengine_heapz00(obj_t);
	extern obj_t BGl_tclassz00zzobject_classz00;
	static obj_t BGl_genericzd2initzd2zzengine_heapz00();
	static obj_t BGl_zc3anonymousza32400ze3z83zzengine_heapz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_dumpzd2heapszd2zzengine_heapz00(obj_t);
	extern obj_t BGl_initializa7ezd2Tenvz12z67zztype_envz00();
	static obj_t BGl_cnstzd2initzd2zzengine_heapz00();
	extern obj_t BGl_setzd2backendz12zc0zzbackend_backendz00(obj_t);
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzengine_heapz00();
	extern obj_t BGl_setzd2tenvz12zc0zztype_envz00(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2libzd2dirza2zd2zzengine_paramz00;
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	BGL_IMPORT obj_t bgl_display_string(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_findzd2filezf2pathz20zz__osz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzengine_heapz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzheap_restorez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__binaryz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t close_binary_port(obj_t);
	BGL_IMPORT obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00(obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t,
		obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	static obj_t BGl_zc3anonymousza32473ze3z83zzengine_heapz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_dumpzd2Genvzd2zzengine_heapz00(obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_za2targetzd2languageza2zd2zzengine_paramz00;
	extern obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
	BGL_IMPORT obj_t input_obj(obj_t);
	extern obj_t BGl_heapzd2modulezd2listz00zzheap_restorez00(obj_t);
	static obj_t BGl__dumpzd2heapszd2zzengine_heapz00(obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzengine_heapz00();
	extern obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00();
	static obj_t BGl_methodzd2initzd2zzengine_heapz00();
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	static obj_t __cnst[14];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2556z00zzengine_heapz00,
		BgL_bgl_za7c3anonymousza7a322565z00,
		BGl_zc3anonymousza32400ze3z83zzengine_heapz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2560z00zzengine_heapz00,
		BgL_bgl_za7c3anonymousza7a322566z00,
		BGl_zc3anonymousza32473ze3z83zzengine_heapz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2544z00zzengine_heapz00,
		BgL_bgl_string2544za700za7za7e2567za7, "Cannot open heap file ~s", 24);
	      DEFINE_STRING(BGl_string2545z00zzengine_heapz00,
		BgL_bgl_string2545za700za7za7e2568za7, "Corrupted heap", 14);
	      DEFINE_STRING(BGl_string2548z00zzengine_heapz00,
		BgL_bgl_string2548za700za7za7e2569za7, "(heap \"", 7);
	      DEFINE_STRING(BGl_string2550z00zzengine_heapz00,
		BgL_bgl_string2550za700za7za7e2570za7, " (variables", 11);
	      DEFINE_STRING(BGl_string2549z00zzengine_heapz00,
		BgL_bgl_string2549za700za7za7e2571za7, "\"", 1);
	      DEFINE_STRING(BGl_string2551z00zzengine_heapz00,
		BgL_bgl_string2551za700za7za7e2572za7, " )\n", 3);
	      DEFINE_STRING(BGl_string2552z00zzengine_heapz00,
		BgL_bgl_string2552za700za7za7e2573za7, " (types", 7);
	      DEFINE_STRING(BGl_string2553z00zzengine_heapz00,
		BgL_bgl_string2553za700za7za7e2574za7, " )", 2);
	      DEFINE_STRING(BGl_string2554z00zzengine_heapz00,
		BgL_bgl_string2554za700za7za7e2575za7, " (includes", 10);
	      DEFINE_STRING(BGl_string2555z00zzengine_heapz00,
		BgL_bgl_string2555za700za7za7e2576za7, ")\n", 2);
	      DEFINE_STRING(BGl_string2557z00zzengine_heapz00,
		BgL_bgl_string2557za700za7za7e2577za7, "   ", 3);
	      DEFINE_STRING(BGl_string2558z00zzengine_heapz00,
		BgL_bgl_string2558za700za7za7e2578za7, "\n    ", 5);
	      DEFINE_STRING(BGl_string2559z00zzengine_heapz00,
		BgL_bgl_string2559za700za7za7e2579za7, "", 0);
	      DEFINE_STRING(BGl_string2561z00zzengine_heapz00,
		BgL_bgl_string2561za700za7za7e2580za7, "engine_heap", 11);
	      DEFINE_STRING(BGl_string2562z00zzengine_heapz00,
		BgL_bgl_string2562za700za7za7e2581za7,
		"type super class jvm-type-name inline sifun qualified-type name module id variable native function dump-heap ",
		109);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_dumpzd2heapszd2envz00zzengine_heapz00,
		BgL_bgl__dumpza7d2heapsza7d22582z00, BGl__dumpzd2heapszd2zzengine_heapz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2546z00zzengine_heapz00,
		BgL_bgl_za7c3anonymousza7a322583z00,
		BGl_zc3anonymousza32370ze3z83zzengine_heapz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2547z00zzengine_heapz00,
		BgL_bgl_za7c3anonymousza7a322584z00,
		BGl_zc3anonymousza32377ze3z83zzengine_heapz00, 0L, BUNSPEC, 2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzengine_heapz00(long
		BgL_checksumz00_1015, char *BgL_fromz00_1016)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzengine_heapz00))
				{
					BGl_requirezd2initializa7ationz75zzengine_heapz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzengine_heapz00();
					BGl_cnstzd2initzd2zzengine_heapz00();
					BGl_importedzd2moduleszd2initz00zzengine_heapz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__binaryz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"engine_heap");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			{	/* Engine/heap.scm 15 */
				obj_t BgL_cportz00_1007;

				BgL_cportz00_1007 =
					bgl_open_input_string(BGl_string2562z00zzengine_heapz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1008;

					BgL_iz00_1008 = ((long) 13);
				BgL_loopz00_1009:
					if ((BgL_iz00_1008 == ((long) -1)))
						{	/* Engine/heap.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Engine/heap.scm 15 */
							{	/* Engine/heap.scm 15 */
								obj_t BgL_arg2564z00_1011;

								{	/* Engine/heap.scm 15 */

									{	/* Engine/heap.scm 15 */
										obj_t BgL_locationz00_1013;

										BgL_locationz00_1013 = BBOOL(((bool_t) 0));
										{	/* Engine/heap.scm 15 */

											BgL_arg2564z00_1011 =
												BGl_readz00zz__readerz00(BgL_cportz00_1007,
												BgL_locationz00_1013);
										}
									}
								}
								{	/* Engine/heap.scm 15 */
									int BgL_auxz00_1039;

									BgL_auxz00_1039 = (int) (BgL_iz00_1008);
									CNST_TABLE_SET(BgL_auxz00_1039, BgL_arg2564z00_1011);
							}}
							{	/* Engine/heap.scm 15 */
								int BgL_auxz00_1014;

								BgL_auxz00_1014 = (int) ((BgL_iz00_1008 - ((long) 1)));
								{
									long BgL_iz00_1044;

									BgL_iz00_1044 = (long) (BgL_auxz00_1014);
									BgL_iz00_1008 = BgL_iz00_1044;
									goto BgL_loopz00_1009;
								}
							}
						}
				}
			}
		}
	}



/* dump-heaps */
	BGL_EXPORTED_DEF obj_t BGl_dumpzd2heapszd2zzengine_heapz00(obj_t
		BgL_namesz00_1)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 33 */
			BGl_setzd2backendz12zc0zzbackend_backendz00
				(BGl_za2targetzd2languageza2zd2zzengine_paramz00);
			BGl_initializa7ezd2Genvz12z67zzast_envz00();
			BGl_initializa7ezd2Tenvz12z67zztype_envz00();
			{
				obj_t BgL_l2294z00_478;

				{	/* Engine/heap.scm 40 */
					bool_t BgL_auxz00_1049;

					BgL_l2294z00_478 = BgL_namesz00_1;
				BgL_forzd2each2295zd2_479:
					if (PAIRP(BgL_l2294z00_478))
						{	/* Engine/heap.scm 40 */
							BGl_dumpzd2heapzd2zzengine_heapz00(CAR(BgL_l2294z00_478));
							{
								obj_t BgL_l2294z00_1054;

								BgL_l2294z00_1054 = CDR(BgL_l2294z00_478);
								BgL_l2294z00_478 = BgL_l2294z00_1054;
								goto BgL_forzd2each2295zd2_479;
							}
						}
					else
						{	/* Engine/heap.scm 40 */
							BgL_auxz00_1049 = ((bool_t) 1);
						}
					return BBOOL(BgL_auxz00_1049);
				}
			}
		}
	}



/* _dump-heaps */
	obj_t BGl__dumpzd2heapszd2zzengine_heapz00(obj_t BgL_envz00_981,
		obj_t BgL_namesz00_982)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 33 */
			return BGl_dumpzd2heapszd2zzengine_heapz00(BgL_namesz00_982);
		}
	}



/* dump-heap */
	obj_t BGl_dumpzd2heapzd2zzengine_heapz00(obj_t BgL_heapz00_2)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 45 */
			{	/* Engine/heap.scm 46 */
				obj_t BgL_fnamez00_483;

				BgL_fnamez00_483 =
					BGl_findzd2filezf2pathz20zz__osz00(BgL_heapz00_2,
					BGl_za2libzd2dirza2zd2zzengine_paramz00);
				if (STRINGP(BgL_fnamez00_483))
					{	/* Engine/heap.scm 48 */
						obj_t BgL_portz00_485;

						BgL_portz00_485 =
							BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00
							(BgL_fnamez00_483);
						if (BINARY_PORTP(BgL_portz00_485))
							{	/* Engine/heap.scm 53 */
								obj_t BgL_val2288z00_487;

								BgL_val2288z00_487 =
									BGl_zc3exitza32362ze3z83zzengine_heapz00(BgL_heapz00_2,
									BgL_portz00_485);
								close_binary_port(BgL_portz00_485);
								if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
										(BgL_val2288z00_487)))
									{	/* Engine/heap.scm 113 */
										return
											BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
											(BgL_val2288z00_487), CDR(BgL_val2288z00_487));
									}
								else
									{	/* Engine/heap.scm 113 */
										return BgL_val2288z00_487;
									}
							}
						else
							{	/* Engine/heap.scm 50 */
								obj_t BgL_arg2395z00_554;

								obj_t BgL_arg2396z00_555;

								BgL_arg2395z00_554 = CNST_TABLE_REF(((long) 0));
								{	/* Engine/heap.scm 51 */
									obj_t BgL_list2397z00_556;

									BgL_list2397z00_556 = MAKE_PAIR(BgL_fnamez00_483, BNIL);
									BgL_arg2396z00_555 =
										BGl_formatz00zz__r4_output_6_10_3z00
										(BGl_string2544z00zzengine_heapz00, BgL_list2397z00_556);
								}
								return
									BGl_errorz00zz__errorz00(BgL_arg2395z00_554,
									BgL_arg2396z00_555, BGl_za2libzd2dirza2zd2zzengine_paramz00);
							}
					}
				else
					{	/* Engine/heap.scm 114 */
						obj_t BgL_mz00_557;

						{	/* Engine/heap.scm 114 */
							obj_t BgL_list2398z00_558;

							BgL_list2398z00_558 = MAKE_PAIR(BgL_heapz00_2, BNIL);
							BgL_mz00_557 =
								BGl_formatz00zz__r4_output_6_10_3z00
								(BGl_string2544z00zzengine_heapz00, BgL_list2398z00_558);
						}
						BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)), BgL_mz00_557,
							BGl_za2libzd2dirza2zd2zzengine_paramz00);
						return BFALSE;
					}
			}
		}
	}



/* <exit:2362> */
	obj_t BGl_zc3exitza32362ze3z83zzengine_heapz00(obj_t BgL_heapz00_1005,
		obj_t BgL_portz00_1004)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 113 */
			jmp_buf_t jmpbuf;

			void *BgL_an_exit2289z00_492;

			{
				BGL_STORE_TRACE();
				if (SET_EXIT(BgL_an_exit2289z00_492))
					{
						BGL_RESTORE_TRACE();
						return _exit_value_;
					}
				else
					{
						BgL_an_exit2289z00_492 = (void *) jmpbuf;
						{	/* Engine/heap.scm 113 */

							PUSH_EXIT(BgL_an_exit2289z00_492, ((long) 0));
							{	/* Engine/heap.scm 54 */
								obj_t BgL_val2290z00_493;

								{	/* Engine/heap.scm 54 */
									obj_t BgL_envsz00_494;

									BgL_envsz00_494 = input_obj(BgL_portz00_1004);
									{	/* Engine/heap.scm 54 */
										obj_t BgL__z00_495;

										{	/* Engine/heap.scm 55 */
											bool_t BgL_testz00_1084;

											{	/* Engine/heap.scm 55 */
												bool_t BgL_testz00_1085;

												{	/* Engine/heap.scm 55 */
													obj_t BgL_v2296z00_553;

													BgL_v2296z00_553 = create_vector((int) (((long) 1)));
													VECTOR_SET(BgL_v2296z00_553,
														(int) (((long) 0)), BgL_envsz00_494);
													BgL_testz00_1085 = ((bool_t) 1);
												}
												if (BgL_testz00_1085)
													{	/* Engine/heap.scm 56 */
														bool_t BgL__ortest_2291z00_548;

														{	/* Engine/heap.scm 56 */
															int BgL_arg2393z00_551;

															BgL_arg2393z00_551 =
																VECTOR_LENGTH(BgL_envsz00_494);
															BgL__ortest_2291z00_548 =
																((long) (BgL_arg2393z00_551) == ((long) 5));
														}
														if (BgL__ortest_2291z00_548)
															{	/* Engine/heap.scm 56 */
																BgL_testz00_1084 = BgL__ortest_2291z00_548;
															}
														else
															{	/* Engine/heap.scm 57 */
																int BgL_arg2391z00_549;

																BgL_arg2391z00_549 =
																	VECTOR_LENGTH(BgL_envsz00_494);
																BgL_testz00_1084 =
																	((long) (BgL_arg2391z00_549) == ((long) 6));
													}}
												else
													{	/* Engine/heap.scm 55 */
														BgL_testz00_1084 = ((bool_t) 0);
													}
											}
											if (BgL_testz00_1084)
												{	/* Engine/heap.scm 55 */
													BgL__z00_495 = BFALSE;
												}
											else
												{	/* Engine/heap.scm 55 */
													BgL__z00_495 =
														BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
														BGl_string2545z00zzengine_heapz00,
														BgL_heapz00_1005);
										}}
										{	/* Engine/heap.scm 55 */
											obj_t BgL_targetz00_496;

											BgL_targetz00_496 =
												VECTOR_REF(BgL_envsz00_494, (int) (((long) 0)));
											{	/* Engine/heap.scm 59 */
												obj_t BgL_versionz00_497;

												BgL_versionz00_497 =
													VECTOR_REF(BgL_envsz00_494, (int) (((long) 1)));
												{	/* Engine/heap.scm 60 */
													obj_t BgL_specificz00_498;

													BgL_specificz00_498 =
														VECTOR_REF(BgL_envsz00_494, (int) (((long) 2)));
													{	/* Engine/heap.scm 61 */
														obj_t BgL_genvz00_499;

														BgL_genvz00_499 =
															VECTOR_REF(BgL_envsz00_494, (int) (((long) 3)));
														{	/* Engine/heap.scm 62 */
															obj_t BgL_tenvz00_500;

															BgL_tenvz00_500 =
																VECTOR_REF(BgL_envsz00_494, (int) (((long) 4)));
															{	/* Engine/heap.scm 63 */
																obj_t BgL_includesz00_501;

																{	/* Engine/heap.scm 64 */
																	bool_t BgL_testz00_1109;

																	{	/* Engine/heap.scm 64 */
																		int BgL_arg2387z00_544;

																		BgL_arg2387z00_544 =
																			VECTOR_LENGTH(BgL_envsz00_494);
																		BgL_testz00_1109 =
																			(
																			(long) (BgL_arg2387z00_544) ==
																			((long) 6));
																	}
																	if (BgL_testz00_1109)
																		{	/* Engine/heap.scm 64 */
																			BgL_includesz00_501 =
																				VECTOR_REF(BgL_envsz00_494,
																				(int) (((long) 5)));
																		}
																	else
																		{	/* Engine/heap.scm 64 */
																			BgL_includesz00_501 = BNIL;
																		}
																}
																{	/* Engine/heap.scm 64 */

																	{	/* Engine/heap.scm 76 */
																		bool_t BgL_testz00_1115;

																		{	/* Engine/heap.scm 76 */
																			int BgL_arg2365z00_503;

																			BgL_arg2365z00_503 =
																				VECTOR_LENGTH(BgL_envsz00_494);
																			BgL_testz00_1115 =
																				(
																				(long) (BgL_arg2365z00_503) ==
																				((long) 6));
																		}
																		if (BgL_testz00_1115)
																			{	/* Engine/heap.scm 76 */
																				BGl_addzd2genvz12zc0zzast_envz00
																					(BgL_genvz00_499);
																			}
																		else
																			{	/* Engine/heap.scm 76 */
																				BGl_setzd2tenvz12zc0zztype_envz00
																					(BgL_tenvz00_500);
																				BGl_setzd2genvz12zc0zzast_envz00
																					(BgL_genvz00_499);
																			}
																	}
																	{	/* Engine/heap.scm 85 */
																		bool_t BgL_testz00_1122;

																		{	/* Engine/heap.scm 85 */
																			obj_t BgL_arg2375z00_515;

																			BgL_arg2375z00_515 =
																				BGl_thezd2backendzd2zzbackend_backendz00
																				();
																			{
																				BgL_backendz00_bglt BgL_auxz00_1124;

																				BgL_auxz00_1124 =
																					(BgL_backendz00_bglt)
																					(BgL_arg2375z00_515);
																				BgL_testz00_1122 =
																					(((BgL_backendz00_bglt)
																						CREF(BgL_auxz00_1124))->
																					BgL_qualifiedzd2typeszd2);
																			}
																		}
																		if (BgL_testz00_1122)
																			{	/* Engine/heap.scm 85 */
																				BGl_forzd2eachzd2globalz12z12zzast_envz00
																					(BGl_proc2546z00zzengine_heapz00,
																					BNIL);
																			}
																		else
																			{	/* Engine/heap.scm 85 */
																				BFALSE;
																			}
																	}
																	BGl_hashtablezd2forzd2eachz00zz__hashz00
																		(BgL_genvz00_499,
																		BGl_proc2547z00zzengine_heapz00);
																	{	/* Engine/heap.scm 99 */
																		obj_t BgL_arg2382z00_529;

																		{	/* Engine/heap.scm 99 */
																			obj_t BgL_res2531z00_883;

																			{	/* Engine/heap.scm 99 */
																				obj_t BgL_auxz00_1129;

																				BgL_auxz00_1129 =
																					BGL_CURRENT_DYNAMIC_ENV();
																				BgL_res2531z00_883 =
																					BGL_ENV_CURRENT_ERROR_PORT
																					(BgL_auxz00_1129);
																			}
																			BgL_arg2382z00_529 = BgL_res2531z00_883;
																		}
																		{	/* Engine/heap.scm 101 */
																			obj_t BgL_zc3anonymousza32384ze3z83_983;

																			BgL_zc3anonymousza32384ze3z83_983 =
																				make_fx_procedure
																				(BGl_zc3anonymousza32384ze3z83zzengine_heapz00,
																				(int) (((long) 0)), (int) (((long) 4)));
																			PROCEDURE_SET
																				(BgL_zc3anonymousza32384ze3z83_983,
																				(int) (((long) 0)), BgL_heapz00_1005);
																			PROCEDURE_SET
																				(BgL_zc3anonymousza32384ze3z83_983,
																				(int) (((long) 1)), BgL_genvz00_499);
																			PROCEDURE_SET
																				(BgL_zc3anonymousza32384ze3z83_983,
																				(int) (((long) 2)), BgL_tenvz00_500);
																			PROCEDURE_SET
																				(BgL_zc3anonymousza32384ze3z83_983,
																				(int) (((long) 3)),
																				BgL_includesz00_501);
																			BgL_val2290z00_493 =
																				BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00
																				(BgL_arg2382z00_529,
																				BgL_zc3anonymousza32384ze3z83_983);
								}}}}}}}}}}}
								POP_EXIT();
								return BgL_val2290z00_493;
							}
						}
					}
			}
		}
	}



/* <anonymous:2384> */
	obj_t BGl_zc3anonymousza32384ze3z83zzengine_heapz00(obj_t BgL_envz00_986)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 100 */
			{	/* Engine/heap.scm 101 */
				obj_t BgL_heapz00_987;

				obj_t BgL_genvz00_988;

				obj_t BgL_tenvz00_989;

				obj_t BgL_includesz00_990;

				BgL_heapz00_987 = PROCEDURE_REF(BgL_envz00_986, (int) (((long) 0)));
				BgL_genvz00_988 = PROCEDURE_REF(BgL_envz00_986, (int) (((long) 1)));
				BgL_tenvz00_989 = PROCEDURE_REF(BgL_envz00_986, (int) (((long) 2)));
				BgL_includesz00_990 = PROCEDURE_REF(BgL_envz00_986, (int) (((long) 3)));
				{

					{	/* Engine/heap.scm 101 */
						obj_t BgL_port2300z00_532;

						{	/* Engine/heap.scm 101 */
							obj_t BgL_res2532z00_885;

							{	/* Engine/heap.scm 101 */
								obj_t BgL_auxz00_1153;

								BgL_auxz00_1153 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2532z00_885 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1153);
							}
							BgL_port2300z00_532 = BgL_res2532z00_885;
						}
						bgl_display_string(BGl_string2548z00zzengine_heapz00,
							BgL_port2300z00_532);
						bgl_display_obj(BgL_heapz00_987, BgL_port2300z00_532);
						bgl_display_string(BGl_string2549z00zzengine_heapz00,
							BgL_port2300z00_532);
						bgl_display_char(((unsigned char) '\n'), BgL_port2300z00_532);
					}
					{	/* Engine/heap.scm 102 */
						obj_t BgL_port2301z00_533;

						{	/* Engine/heap.scm 102 */
							obj_t BgL_res2533z00_892;

							{	/* Engine/heap.scm 102 */
								obj_t BgL_auxz00_1160;

								BgL_auxz00_1160 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2533z00_892 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1160);
							}
							BgL_port2301z00_533 = BgL_res2533z00_892;
						}
						bgl_display_string(BGl_string2550z00zzengine_heapz00,
							BgL_port2301z00_533);
						bgl_display_char(((unsigned char) '\n'), BgL_port2301z00_533);
					}
					BGl_dumpzd2Genvzd2zzengine_heapz00(BgL_genvz00_988);
					{	/* Engine/heap.scm 104 */
						obj_t BgL_port2302z00_534;

						{	/* Engine/heap.scm 104 */
							obj_t BgL_res2534z00_897;

							{	/* Engine/heap.scm 104 */
								obj_t BgL_auxz00_1166;

								BgL_auxz00_1166 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2534z00_897 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1166);
							}
							BgL_port2302z00_534 = BgL_res2534z00_897;
						}
						bgl_display_string(BGl_string2551z00zzengine_heapz00,
							BgL_port2302z00_534);
						bgl_display_char(((unsigned char) '\n'), BgL_port2302z00_534);
					}
					{	/* Engine/heap.scm 105 */
						obj_t BgL_port2303z00_535;

						{	/* Engine/heap.scm 105 */
							obj_t BgL_res2535z00_902;

							{	/* Engine/heap.scm 105 */
								obj_t BgL_auxz00_1171;

								BgL_auxz00_1171 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2535z00_902 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1171);
							}
							BgL_port2303z00_535 = BgL_res2535z00_902;
						}
						bgl_display_string(BGl_string2552z00zzengine_heapz00,
							BgL_port2303z00_535);
						bgl_display_char(((unsigned char) '\n'), BgL_port2303z00_535);
					}
					BGl_dumpzd2Tenvzd2zzengine_heapz00(BgL_tenvz00_989);
					{	/* Engine/heap.scm 107 */
						obj_t BgL_port2304z00_536;

						{	/* Engine/heap.scm 107 */
							obj_t BgL_res2536z00_907;

							{	/* Engine/heap.scm 107 */
								obj_t BgL_auxz00_1177;

								BgL_auxz00_1177 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2536z00_907 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1177);
							}
							BgL_port2304z00_536 = BgL_res2536z00_907;
						}
						bgl_display_string(BGl_string2553z00zzengine_heapz00,
							BgL_port2304z00_536);
						bgl_display_char(((unsigned char) '\n'), BgL_port2304z00_536);
					}
					if (PAIRP(BgL_includesz00_990))
						{	/* Engine/heap.scm 108 */
							{	/* Engine/heap.scm 109 */
								obj_t BgL_port2305z00_538;

								{	/* Engine/heap.scm 109 */
									obj_t BgL_res2537z00_913;

									{	/* Engine/heap.scm 109 */
										obj_t BgL_auxz00_1184;

										BgL_auxz00_1184 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res2537z00_913 =
											BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1184);
									}
									BgL_port2305z00_538 = BgL_res2537z00_913;
								}
								bgl_display_string(BGl_string2554z00zzengine_heapz00,
									BgL_port2305z00_538);
								bgl_display_char(((unsigned char) '\n'), BgL_port2305z00_538);
							}
							{	/* Engine/heap.scm 110 */
								obj_t BgL_port2306z00_539;

								{	/* Engine/heap.scm 110 */
									obj_t BgL_res2538z00_918;

									{	/* Engine/heap.scm 110 */
										obj_t BgL_auxz00_1189;

										BgL_auxz00_1189 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res2538z00_918 =
											BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1189);
									}
									BgL_port2306z00_539 = BgL_res2538z00_918;
								}
								bgl_display_obj(BgL_includesz00_990, BgL_port2306z00_539);
								bgl_display_char(((unsigned char) '\n'), BgL_port2306z00_539);
							}
							{	/* Engine/heap.scm 111 */
								obj_t BgL_port2307z00_540;

								{	/* Engine/heap.scm 111 */
									obj_t BgL_res2539z00_921;

									{	/* Engine/heap.scm 111 */
										obj_t BgL_auxz00_1194;

										BgL_auxz00_1194 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res2539z00_921 =
											BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1194);
									}
									BgL_port2307z00_540 = BgL_res2539z00_921;
								}
								bgl_display_string(BGl_string2553z00zzengine_heapz00,
									BgL_port2307z00_540);
								bgl_display_char(((unsigned char) '\n'), BgL_port2307z00_540);
						}}
					else
						{	/* Engine/heap.scm 108 */
							BFALSE;
						}
					{	/* Engine/heap.scm 112 */
						obj_t BgL_port2308z00_541;

						{	/* Engine/heap.scm 112 */
							obj_t BgL_res2540z00_926;

							{	/* Engine/heap.scm 112 */
								obj_t BgL_auxz00_1199;

								BgL_auxz00_1199 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2540z00_926 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1199);
							}
							BgL_port2308z00_541 = BgL_res2540z00_926;
						}
						bgl_display_string(BGl_string2555z00zzengine_heapz00,
							BgL_port2308z00_541);
						return bgl_display_char(((unsigned char) '\n'),
							BgL_port2308z00_541);
		}}}}
	}



/* <anonymous:2377> */
	obj_t BGl_zc3anonymousza32377ze3z83zzengine_heapz00(obj_t BgL_envz00_991,
		obj_t BgL_kz00_992, obj_t BgL_bucketz00_993)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 95 */
			{
				obj_t BgL_kz00_517;

				obj_t BgL_bucketz00_518;

				{	/* Engine/heap.scm 96 */
					bool_t BgL_auxz00_1204;

					BgL_kz00_517 = BgL_kz00_992;
					BgL_bucketz00_518 = BgL_bucketz00_993;
					{	/* Engine/heap.scm 96 */
						obj_t BgL_g2299z00_520;

						BgL_g2299z00_520 = CDR(BgL_bucketz00_518);
						{
							obj_t BgL_l2297z00_521;

							BgL_l2297z00_521 = BgL_g2299z00_520;
						BgL_forzd2each2298zd2_522:
							if (PAIRP(BgL_l2297z00_521))
								{	/* Engine/heap.scm 98 */
									{	/* Engine/heap.scm 97 */
										obj_t BgL_newz00_524;

										BgL_newz00_524 = CAR(BgL_l2297z00_521);
										{	/* Engine/heap.scm 97 */
											obj_t BgL_arg2379z00_525;

											{
												BgL_globalz00_bglt BgL_auxz00_1209;

												BgL_auxz00_1209 = (BgL_globalz00_bglt) (BgL_newz00_524);
												BgL_arg2379z00_525 =
													(((BgL_globalz00_bglt) CREF(BgL_auxz00_1209))->
													BgL_modulez00);
											}
											{	/* Engine/heap.scm 97 */
												obj_t BgL_list2380z00_526;

												BgL_list2380z00_526 =
													MAKE_PAIR(BgL_arg2379z00_525, BNIL);
												BGl_heapzd2modulezd2listz00zzheap_restorez00
													(BgL_list2380z00_526);
											}
										}
									}
									{
										obj_t BgL_l2297z00_1214;

										BgL_l2297z00_1214 = CDR(BgL_l2297z00_521);
										BgL_l2297z00_521 = BgL_l2297z00_1214;
										goto BgL_forzd2each2298zd2_522;
									}
								}
							else
								{	/* Engine/heap.scm 98 */
									BgL_auxz00_1204 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_1204);
				}
			}
		}
	}



/* <anonymous:2370> */
	obj_t BGl_zc3anonymousza32370ze3z83zzengine_heapz00(obj_t BgL_envz00_994,
		obj_t BgL_newz00_995)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 87 */
			{
				obj_t BgL_newz00_508;

				BgL_newz00_508 = BgL_newz00_995;
				{	/* Engine/heap.scm 89 */
					obj_t BgL_arg2371z00_510;

					obj_t BgL_arg2372z00_511;

					obj_t BgL_arg2373z00_512;

					{
						BgL_globalz00_bglt BgL_auxz00_1217;

						BgL_auxz00_1217 = (BgL_globalz00_bglt) (BgL_newz00_508);
						BgL_arg2371z00_510 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1217))->BgL_modulez00);
					}
					{
						BgL_globalz00_bglt BgL_auxz00_1220;

						BgL_auxz00_1220 = (BgL_globalz00_bglt) (BgL_newz00_508);
						BgL_arg2372z00_511 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1220))->
							BgL_jvmzd2typezd2namez00);
					}
					BgL_arg2373z00_512 = BGl_shapez00zztools_shapez00(BgL_newz00_508);
					{	/* Engine/heap.scm 88 */
						obj_t BgL_list2374z00_513;

						BgL_list2374z00_513 = MAKE_PAIR(BgL_arg2373z00_512, BNIL);
						return
							BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(BgL_arg2371z00_510,
							BgL_arg2372z00_511, BgL_list2374z00_513);
					}
				}
			}
		}
	}



/* dump-Genv */
	obj_t BGl_dumpzd2Genvzd2zzengine_heapz00(obj_t BgL_genvz00_3)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 121 */
			return
				BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_genvz00_3,
				BGl_proc2556z00zzengine_heapz00);
		}
	}



/* <anonymous:2400> */
	obj_t BGl_zc3anonymousza32400ze3z83zzengine_heapz00(obj_t BgL_envz00_997,
		obj_t BgL_kz00_998, obj_t BgL_bucketz00_999)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 152 */
			{
				obj_t BgL_kz00_561;

				obj_t BgL_bucketz00_562;

				{	/* Engine/heap.scm 152 */
					bool_t BgL_auxz00_1227;

					BgL_kz00_561 = BgL_kz00_998;
					BgL_bucketz00_562 = BgL_bucketz00_999;
					{
						obj_t BgL_newz00_571;

						{	/* Engine/heap.scm 152 */
							obj_t BgL_g2312z00_564;

							BgL_g2312z00_564 = CDR(BgL_bucketz00_562);
							{
								obj_t BgL_l2310z00_565;

								BgL_l2310z00_565 = BgL_g2312z00_564;
							BgL_forzd2each2311zd2_566:
								if (PAIRP(BgL_l2310z00_565))
									{	/* Engine/heap.scm 152 */
										BgL_newz00_571 = CAR(BgL_l2310z00_565);
										{	/* Engine/heap.scm 123 */
											obj_t BgL_modulez00_573;

											{
												BgL_globalz00_bglt BgL_auxz00_1231;

												BgL_auxz00_1231 = (BgL_globalz00_bglt) (BgL_newz00_571);
												BgL_modulez00_573 =
													(((BgL_globalz00_bglt) CREF(BgL_auxz00_1231))->
													BgL_modulez00);
											}
											{	/* Engine/heap.scm 123 */
												obj_t BgL_idz00_574;

												{
													BgL_variablez00_bglt BgL_auxz00_1234;

													BgL_auxz00_1234 =
														(BgL_variablez00_bglt) (BgL_newz00_571);
													BgL_idz00_574 =
														(((BgL_variablez00_bglt) CREF(BgL_auxz00_1234))->
														BgL_idz00);
												}
												{	/* Engine/heap.scm 124 */
													obj_t BgL_qtz00_575;

													BgL_qtz00_575 =
														BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00
														(BgL_modulez00_573);
													{	/* Engine/heap.scm 125 */
														obj_t BgL_jtz00_576;

														{
															BgL_globalz00_bglt BgL_auxz00_1238;

															BgL_auxz00_1238 =
																(BgL_globalz00_bglt) (BgL_newz00_571);
															BgL_jtz00_576 =
																(((BgL_globalz00_bglt) CREF(BgL_auxz00_1238))->
																BgL_jvmzd2typezd2namez00);
														}
														{	/* Engine/heap.scm 126 */
															BgL_valuez00_bglt BgL_valz00_577;

															{
																BgL_variablez00_bglt BgL_auxz00_1241;

																BgL_auxz00_1241 =
																	(BgL_variablez00_bglt) (BgL_newz00_571);
																BgL_valz00_577 =
																	(((BgL_variablez00_bglt)
																		CREF(BgL_auxz00_1241))->BgL_valuez00);
															}
															{	/* Engine/heap.scm 127 */
																obj_t BgL_kindz00_578;

																{	/* Engine/heap.scm 129 */
																	bool_t BgL_testz00_1244;

																	{	/* Engine/heap.scm 129 */
																		obj_t BgL_obj1782z00_941;

																		BgL_obj1782z00_941 =
																			(obj_t) (BgL_valz00_577);
																		BgL_testz00_1244 =
																			BGl_iszd2azf3z21zz__objectz00
																			(BgL_obj1782z00_941,
																			BGl_sfunz00zzast_varz00);
																	}
																	if (BgL_testz00_1244)
																		{	/* Engine/heap.scm 129 */
																			BgL_kindz00_578 =
																				CNST_TABLE_REF(((long) 1));
																		}
																	else
																		{	/* Engine/heap.scm 130 */
																			bool_t BgL_testz00_1248;

																			{	/* Engine/heap.scm 130 */
																				obj_t BgL_obj1846z00_942;

																				BgL_obj1846z00_942 =
																					(obj_t) (BgL_valz00_577);
																				BgL_testz00_1248 =
																					BGl_iszd2azf3z21zz__objectz00
																					(BgL_obj1846z00_942,
																					BGl_cfunz00zzast_varz00);
																			}
																			if (BgL_testz00_1248)
																				{	/* Engine/heap.scm 130 */
																					BgL_kindz00_578 =
																						CNST_TABLE_REF(((long) 2));
																				}
																			else
																				{	/* Engine/heap.scm 130 */
																					BgL_kindz00_578 =
																						CNST_TABLE_REF(((long) 3));
																}}}
																{	/* Engine/heap.scm 128 */

																	{	/* Engine/heap.scm 132 */
																		obj_t BgL_port2309z00_579;

																		{	/* Engine/heap.scm 132 */
																			obj_t BgL_res2541z00_944;

																			{	/* Engine/heap.scm 132 */
																				obj_t BgL_auxz00_1253;

																				BgL_auxz00_1253 =
																					BGL_CURRENT_DYNAMIC_ENV();
																				BgL_res2541z00_944 =
																					BGL_ENV_CURRENT_OUTPUT_PORT
																					(BgL_auxz00_1253);
																			}
																			BgL_port2309z00_579 = BgL_res2541z00_944;
																		}
																		bgl_display_string
																			(BGl_string2557z00zzengine_heapz00,
																			BgL_port2309z00_579);
																		{	/* Engine/heap.scm 133 */
																			obj_t BgL_arg2405z00_580;

																			{	/* Engine/heap.scm 133 */
																				obj_t BgL_arg2406z00_581;

																				{	/* Engine/heap.scm 133 */
																					obj_t BgL_arg2407z00_582;

																					obj_t BgL_arg2409z00_584;

																					obj_t BgL_arg2411z00_586;

																					obj_t BgL_arg2413z00_588;

																					obj_t BgL_arg2415z00_590;

																					obj_t BgL_arg2417z00_591;

																					obj_t BgL_arg2418z00_592;

																					obj_t BgL_arg2420z00_594;

																					BgL_arg2407z00_582 =
																						BGl_shapez00zztools_shapez00
																						(BgL_newz00_571);
																					{	/* Engine/heap.scm 135 */
																						obj_t BgL_arg2435z00_609;

																						obj_t BgL_arg2436z00_610;

																						BgL_arg2435z00_609 =
																							CNST_TABLE_REF(((long) 4));
																						{	/* Engine/heap.scm 135 */
																							obj_t BgL_list2437z00_611;

																							BgL_list2437z00_611 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2436z00_610 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_idz00_574,
																								BgL_list2437z00_611);
																						}
																						BgL_arg2409z00_584 =
																							MAKE_PAIR(BgL_arg2435z00_609,
																							BgL_arg2436z00_610);
																					}
																					{	/* Engine/heap.scm 137 */
																						obj_t BgL_arg2438z00_612;

																						obj_t BgL_arg2440z00_613;

																						BgL_arg2438z00_612 =
																							CNST_TABLE_REF(((long) 5));
																						{	/* Engine/heap.scm 137 */
																							obj_t BgL_list2441z00_614;

																							BgL_list2441z00_614 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2440z00_613 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_modulez00_573,
																								BgL_list2441z00_614);
																						}
																						BgL_arg2411z00_586 =
																							MAKE_PAIR(BgL_arg2438z00_612,
																							BgL_arg2440z00_613);
																					}
																					{	/* Engine/heap.scm 139 */
																						obj_t BgL_arg2442z00_615;

																						obj_t BgL_arg2443z00_616;

																						BgL_arg2442z00_615 =
																							CNST_TABLE_REF(((long) 6));
																						{	/* Engine/heap.scm 139 */
																							obj_t BgL_arg2444z00_617;

																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_1267;
																								BgL_auxz00_1267 =
																									(BgL_variablez00_bglt)
																									(BgL_newz00_571);
																								BgL_arg2444z00_617 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_auxz00_1267))->
																									BgL_namez00);
																							}
																							{	/* Engine/heap.scm 139 */
																								obj_t BgL_list2446z00_619;

																								BgL_list2446z00_619 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg2443z00_616 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg2444z00_617,
																									BgL_list2446z00_619);
																						}}
																						BgL_arg2413z00_588 =
																							MAKE_PAIR(BgL_arg2442z00_615,
																							BgL_arg2443z00_616);
																					}
																					{	/* Engine/heap.scm 141 */
																						obj_t BgL_arg2447z00_620;

																						obj_t BgL_arg2448z00_621;

																						BgL_arg2447z00_620 =
																							CNST_TABLE_REF(((long) 7));
																						{	/* Engine/heap.scm 141 */
																							obj_t BgL_list2449z00_622;

																							BgL_list2449z00_622 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2448z00_621 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_qtz00_575,
																								BgL_list2449z00_622);
																						}
																						BgL_arg2415z00_590 =
																							MAKE_PAIR(BgL_arg2447z00_620,
																							BgL_arg2448z00_621);
																					}
																					{	/* Engine/heap.scm 142 */
																						bool_t BgL_testz00_1277;

																						{	/* Engine/heap.scm 142 */
																							bool_t BgL_testz00_1278;

																							{	/* Engine/heap.scm 142 */
																								obj_t BgL_obj1782z00_948;

																								BgL_obj1782z00_948 =
																									(obj_t) (BgL_valz00_577);
																								BgL_testz00_1278 =
																									BGl_iszd2azf3z21zz__objectz00
																									(BgL_obj1782z00_948,
																									BGl_sfunz00zzast_varz00);
																							}
																							if (BgL_testz00_1278)
																								{	/* Engine/heap.scm 142 */
																									obj_t BgL_auxz00_1281;

																									{
																										BgL_sfunz00_bglt
																											BgL_auxz00_1282;
																										BgL_auxz00_1282 =
																											(BgL_sfunz00_bglt)
																											(BgL_valz00_577);
																										BgL_auxz00_1281 =
																											(((BgL_sfunz00_bglt)
																												CREF(BgL_auxz00_1282))->
																											BgL_classz00);
																									}
																									BgL_testz00_1277 =
																										(BgL_auxz00_1281 ==
																										CNST_TABLE_REF(((long) 8)));
																								}
																							else
																								{	/* Engine/heap.scm 142 */
																									BgL_testz00_1277 =
																										((bool_t) 0);
																								}
																						}
																						if (BgL_testz00_1277)
																							{	/* Engine/heap.scm 142 */
																								BgL_arg2417z00_591 =
																									BGl_string2558z00zzengine_heapz00;
																							}
																						else
																							{	/* Engine/heap.scm 142 */
																								BgL_arg2417z00_591 =
																									BGl_string2559z00zzengine_heapz00;
																							}
																					}
																					{	/* Engine/heap.scm 145 */
																						bool_t BgL_testz00_1287;

																						{	/* Engine/heap.scm 145 */
																							bool_t BgL_testz00_1288;

																							{	/* Engine/heap.scm 145 */
																								obj_t BgL_obj1782z00_950;

																								BgL_obj1782z00_950 =
																									(obj_t) (BgL_valz00_577);
																								BgL_testz00_1288 =
																									BGl_iszd2azf3z21zz__objectz00
																									(BgL_obj1782z00_950,
																									BGl_sfunz00zzast_varz00);
																							}
																							if (BgL_testz00_1288)
																								{	/* Engine/heap.scm 145 */
																									obj_t BgL_auxz00_1291;

																									{
																										BgL_sfunz00_bglt
																											BgL_auxz00_1292;
																										BgL_auxz00_1292 =
																											(BgL_sfunz00_bglt)
																											(BgL_valz00_577);
																										BgL_auxz00_1291 =
																											(((BgL_sfunz00_bglt)
																												CREF(BgL_auxz00_1292))->
																											BgL_classz00);
																									}
																									BgL_testz00_1287 =
																										(BgL_auxz00_1291 ==
																										CNST_TABLE_REF(((long) 8)));
																								}
																							else
																								{	/* Engine/heap.scm 145 */
																									BgL_testz00_1287 =
																										((bool_t) 0);
																								}
																						}
																						if (BgL_testz00_1287)
																							{	/* Engine/heap.scm 146 */
																								obj_t BgL_arg2456z00_628;

																								obj_t BgL_arg2457z00_629;

																								BgL_arg2456z00_628 =
																									CNST_TABLE_REF(((long) 9));
																								{	/* Engine/heap.scm 146 */
																									obj_t BgL_arg2459z00_630;

																									{	/* Engine/heap.scm 146 */
																										obj_t BgL_arg2462z00_633;

																										{
																											BgL_sfunz00_bglt
																												BgL_auxz00_1298;
																											BgL_auxz00_1298 =
																												(BgL_sfunz00_bglt)
																												(BgL_valz00_577);
																											BgL_arg2462z00_633 =
																												(((BgL_sfunz00_bglt)
																													CREF
																													(BgL_auxz00_1298))->
																												BgL_bodyz00);
																										}
																										BgL_arg2459z00_630 =
																											BGl_shapez00zztools_shapez00
																											(BgL_arg2462z00_633);
																									}
																									{	/* Engine/heap.scm 146 */
																										obj_t BgL_list2461z00_632;

																										BgL_list2461z00_632 =
																											MAKE_PAIR(BNIL, BNIL);
																										BgL_arg2457z00_629 =
																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																											(BgL_arg2459z00_630,
																											BgL_list2461z00_632);
																								}}
																								BgL_arg2418z00_592 =
																									MAKE_PAIR(BgL_arg2456z00_628,
																									BgL_arg2457z00_629);
																							}
																						else
																							{	/* Engine/heap.scm 145 */
																								BgL_arg2418z00_592 =
																									BGl_string2559z00zzengine_heapz00;
																							}
																					}
																					{	/* Engine/heap.scm 149 */
																						obj_t BgL_arg2467z00_637;

																						obj_t BgL_arg2468z00_638;

																						BgL_arg2467z00_637 =
																							CNST_TABLE_REF(((long) 10));
																						{	/* Engine/heap.scm 149 */
																							obj_t BgL_list2469z00_639;

																							BgL_list2469z00_639 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2468z00_638 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_jtz00_576,
																								BgL_list2469z00_639);
																						}
																						BgL_arg2420z00_594 =
																							MAKE_PAIR(BgL_arg2467z00_637,
																							BgL_arg2468z00_638);
																					}
																					{	/* Engine/heap.scm 132 */
																						obj_t BgL_list2422z00_596;

																						{	/* Engine/heap.scm 132 */
																							obj_t BgL_arg2423z00_597;

																							{	/* Engine/heap.scm 132 */
																								obj_t BgL_arg2424z00_598;

																								{	/* Engine/heap.scm 132 */
																									obj_t BgL_arg2425z00_599;

																									{	/* Engine/heap.scm 132 */
																										obj_t BgL_arg2426z00_600;

																										{	/* Engine/heap.scm 132 */
																											obj_t BgL_arg2427z00_601;

																											{	/* Engine/heap.scm 132 */
																												obj_t
																													BgL_arg2428z00_602;
																												{	/* Engine/heap.scm 132 */
																													obj_t
																														BgL_arg2429z00_603;
																													{	/* Engine/heap.scm 132 */
																														obj_t
																															BgL_arg2430z00_604;
																														{	/* Engine/heap.scm 132 */
																															obj_t
																																BgL_arg2431z00_605;
																															{	/* Engine/heap.scm 132 */
																																obj_t
																																	BgL_arg2432z00_606;
																																{	/* Engine/heap.scm 132 */
																																	obj_t
																																		BgL_arg2433z00_607;
																																	{	/* Engine/heap.scm 132 */
																																		obj_t
																																			BgL_arg2434z00_608;
																																		BgL_arg2434z00_608
																																			=
																																			MAKE_PAIR
																																			(BNIL,
																																			BNIL);
																																		BgL_arg2433z00_607
																																			=
																																			MAKE_PAIR
																																			(BgL_arg2420z00_594,
																																			BgL_arg2434z00_608);
																																	}
																																	BgL_arg2432z00_606
																																		=
																																		MAKE_PAIR
																																		(BGl_string2558z00zzengine_heapz00,
																																		BgL_arg2433z00_607);
																																}
																																BgL_arg2431z00_605
																																	=
																																	MAKE_PAIR
																																	(BgL_arg2418z00_592,
																																	BgL_arg2432z00_606);
																															}
																															BgL_arg2430z00_604
																																=
																																MAKE_PAIR
																																(BgL_arg2417z00_591,
																																BgL_arg2431z00_605);
																														}
																														BgL_arg2429z00_603 =
																															MAKE_PAIR
																															(BgL_arg2415z00_590,
																															BgL_arg2430z00_604);
																													}
																													BgL_arg2428z00_602 =
																														MAKE_PAIR
																														(BGl_string2558z00zzengine_heapz00,
																														BgL_arg2429z00_603);
																												}
																												BgL_arg2427z00_601 =
																													MAKE_PAIR
																													(BgL_arg2413z00_588,
																													BgL_arg2428z00_602);
																											}
																											BgL_arg2426z00_600 =
																												MAKE_PAIR
																												(BGl_string2558z00zzengine_heapz00,
																												BgL_arg2427z00_601);
																										}
																										BgL_arg2425z00_599 =
																											MAKE_PAIR
																											(BgL_arg2411z00_586,
																											BgL_arg2426z00_600);
																									}
																									BgL_arg2424z00_598 =
																										MAKE_PAIR
																										(BGl_string2558z00zzengine_heapz00,
																										BgL_arg2425z00_599);
																								}
																								BgL_arg2423z00_597 =
																									MAKE_PAIR(BgL_arg2409z00_584,
																									BgL_arg2424z00_598);
																							}
																							BgL_list2422z00_596 =
																								MAKE_PAIR
																								(BGl_string2558z00zzengine_heapz00,
																								BgL_arg2423z00_597);
																						}
																						BgL_arg2406z00_581 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg2407z00_582,
																							BgL_list2422z00_596);
																				}}
																				BgL_arg2405z00_580 =
																					MAKE_PAIR(BgL_kindz00_578,
																					BgL_arg2406z00_581);
																			}
																			bgl_display_obj(BgL_arg2405z00_580,
																				BgL_port2309z00_579);
																		}
																		bgl_display_char(((unsigned char) '\n'),
																			BgL_port2309z00_579);
										}}}}}}}}
										{
											obj_t BgL_l2310z00_1327;

											BgL_l2310z00_1327 = CDR(BgL_l2310z00_565);
											BgL_l2310z00_565 = BgL_l2310z00_1327;
											goto BgL_forzd2each2311zd2_566;
										}
									}
								else
									{	/* Engine/heap.scm 152 */
										BgL_auxz00_1227 = ((bool_t) 1);
									}
							}
						}
					}
					return BBOOL(BgL_auxz00_1227);
				}
			}
		}
	}



/* dump-Tenv */
	obj_t BGl_dumpzd2Tenvzd2zzengine_heapz00(obj_t BgL_tenvz00_4)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 157 */
			return
				BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_tenvz00_4,
				BGl_proc2560z00zzengine_heapz00);
		}
	}



/* <anonymous:2473> */
	obj_t BGl_zc3anonymousza32473ze3z83zzengine_heapz00(obj_t BgL_envz00_1001,
		obj_t BgL_kz00_1002, obj_t BgL_newz00_1003)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 159 */
			{
				obj_t BgL_kz00_644;

				obj_t BgL_newz00_645;

				BgL_kz00_644 = BgL_kz00_1002;
				BgL_newz00_645 = BgL_newz00_1003;
				{	/* Engine/heap.scm 160 */
					obj_t BgL_idz00_647;

					{
						BgL_typez00_bglt BgL_auxz00_1331;

						BgL_auxz00_1331 = (BgL_typez00_bglt) (BgL_newz00_645);
						BgL_idz00_647 =
							(((BgL_typez00_bglt) CREF(BgL_auxz00_1331))->BgL_idz00);
					}
					{	/* Engine/heap.scm 160 */
						obj_t BgL_namez00_648;

						{
							BgL_typez00_bglt BgL_auxz00_1334;

							BgL_auxz00_1334 = (BgL_typez00_bglt) (BgL_newz00_645);
							BgL_namez00_648 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_1334))->BgL_namez00);
						}
						{	/* Engine/heap.scm 161 */

							if (BGl_iszd2azf3z21zz__objectz00(BgL_newz00_645,
									BGl_tclassz00zzobject_classz00))
								{	/* Engine/heap.scm 164 */
									obj_t BgL_port2320z00_651;

									{	/* Engine/heap.scm 164 */
										obj_t BgL_res2542z00_958;

										{	/* Engine/heap.scm 164 */
											obj_t BgL_auxz00_1339;

											BgL_auxz00_1339 = BGL_CURRENT_DYNAMIC_ENV();
											BgL_res2542z00_958 =
												BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1339);
										}
										BgL_port2320z00_651 = BgL_res2542z00_958;
									}
									bgl_display_string(BGl_string2557z00zzengine_heapz00,
										BgL_port2320z00_651);
									{	/* Engine/heap.scm 165 */
										obj_t BgL_arg2475z00_652;

										{	/* Engine/heap.scm 165 */
											obj_t BgL_arg2476z00_653;

											obj_t BgL_arg2477z00_654;

											BgL_arg2476z00_653 = CNST_TABLE_REF(((long) 11));
											{	/* Engine/heap.scm 165 */
												obj_t BgL_arg2478z00_655;

												obj_t BgL_arg2479z00_656;

												obj_t BgL_arg2480z00_657;

												BgL_arg2478z00_655 =
													BGl_shapez00zztools_shapez00(BgL_newz00_645);
												{	/* Engine/heap.scm 166 */
													obj_t BgL_arg2484z00_660;

													obj_t BgL_arg2486z00_661;

													BgL_arg2484z00_660 = CNST_TABLE_REF(((long) 12));
													{	/* Engine/heap.scm 166 */
														obj_t BgL_arg2487z00_662;

														{	/* Engine/heap.scm 166 */
															obj_t BgL_arg2490z00_665;

															{	/* Engine/heap.scm 166 */
																BgL_tclassz00_bglt BgL_obj2058z00_961;

																BgL_obj2058z00_961 =
																	(BgL_tclassz00_bglt) (BgL_newz00_645);
																{
																	obj_t BgL_auxz00_1347;

																	{	/* Engine/heap.scm 166 */
																		BgL_objectz00_bglt BgL_auxz00_1348;

																		BgL_auxz00_1348 =
																			(BgL_objectz00_bglt) (BgL_obj2058z00_961);
																		BgL_auxz00_1347 =
																			BGL_OBJECT_WIDENING(BgL_auxz00_1348);
																	}
																	BgL_arg2490z00_665 =
																		(((BgL_tclassz00_bglt)
																			CREF(BgL_auxz00_1347))->
																		BgL_itszd2superzd2);
															}}
															BgL_arg2487z00_662 =
																BGl_shapez00zztools_shapez00
																(BgL_arg2490z00_665);
														}
														{	/* Engine/heap.scm 166 */
															obj_t BgL_list2489z00_664;

															BgL_list2489z00_664 = MAKE_PAIR(BNIL, BNIL);
															BgL_arg2486z00_661 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg2487z00_662, BgL_list2489z00_664);
													}}
													BgL_arg2479z00_656 =
														MAKE_PAIR(BgL_arg2484z00_660, BgL_arg2486z00_661);
												}
												{	/* Engine/heap.scm 167 */
													obj_t BgL_arg2492z00_666;

													{	/* Engine/heap.scm 167 */
														obj_t BgL_l2313z00_668;

														{	/* Engine/heap.scm 167 */
															BgL_tclassz00_bglt BgL_obj2061z00_962;

															BgL_obj2061z00_962 =
																(BgL_tclassz00_bglt) (BgL_newz00_645);
															{
																obj_t BgL_auxz00_1357;

																{	/* Engine/heap.scm 167 */
																	BgL_objectz00_bglt BgL_auxz00_1358;

																	BgL_auxz00_1358 =
																		(BgL_objectz00_bglt) (BgL_obj2061z00_962);
																	BgL_auxz00_1357 =
																		BGL_OBJECT_WIDENING(BgL_auxz00_1358);
																}
																BgL_l2313z00_668 =
																	(((BgL_tclassz00_bglt)
																		CREF(BgL_auxz00_1357))->BgL_slotsz00);
														}}
														if (NULLP(BgL_l2313z00_668))
															{	/* Engine/heap.scm 167 */
																BgL_arg2492z00_666 = BNIL;
															}
														else
															{	/* Engine/heap.scm 167 */
																obj_t BgL_head2316z00_670;

																BgL_head2316z00_670 =
																	MAKE_PAIR(BGl_shapez00zztools_shapez00(CAR
																		(BgL_l2313z00_668)), BNIL);
																{	/* Engine/heap.scm 167 */
																	obj_t BgL_g2319z00_671;

																	BgL_g2319z00_671 = CDR(BgL_l2313z00_668);
																	{
																		obj_t BgL_l2313z00_672;

																		obj_t BgL_tail2317z00_673;

																		BgL_l2313z00_672 = BgL_g2319z00_671;
																		BgL_tail2317z00_673 = BgL_head2316z00_670;
																	BgL_map2315z00_674:
																		if (NULLP(BgL_l2313z00_672))
																			{	/* Engine/heap.scm 167 */
																				BgL_arg2492z00_666 =
																					BgL_head2316z00_670;
																			}
																		else
																			{	/* Engine/heap.scm 167 */
																				obj_t BgL_newtail2318z00_676;

																				BgL_newtail2318z00_676 =
																					MAKE_PAIR(BGl_shapez00zztools_shapez00
																					(CAR(BgL_l2313z00_672)), BNIL);
																				SET_CDR(BgL_tail2317z00_673,
																					BgL_newtail2318z00_676);
																				{
																					obj_t BgL_tail2317z00_1376;

																					obj_t BgL_l2313z00_1374;

																					BgL_l2313z00_1374 =
																						CDR(BgL_l2313z00_672);
																					BgL_tail2317z00_1376 =
																						BgL_newtail2318z00_676;
																					BgL_tail2317z00_673 =
																						BgL_tail2317z00_1376;
																					BgL_l2313z00_672 = BgL_l2313z00_1374;
																					goto BgL_map2315z00_674;
																				}
																			}
																	}
																}
															}
													}
													BgL_arg2480z00_657 =
														BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg2492z00_666, BNIL);
												}
												{	/* Engine/heap.scm 165 */
													obj_t BgL_list2481z00_658;

													{	/* Engine/heap.scm 165 */
														obj_t BgL_arg2482z00_659;

														BgL_arg2482z00_659 =
															MAKE_PAIR(BgL_arg2480z00_657, BNIL);
														BgL_list2481z00_658 =
															MAKE_PAIR(BgL_arg2479z00_656, BgL_arg2482z00_659);
													}
													BgL_arg2477z00_654 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg2478z00_655, BgL_list2481z00_658);
												}
											}
											BgL_arg2475z00_652 =
												MAKE_PAIR(BgL_arg2476z00_653, BgL_arg2477z00_654);
										}
										bgl_display_obj(BgL_arg2475z00_652, BgL_port2320z00_651);
									}
									return
										bgl_display_char(((unsigned char) '\n'),
										BgL_port2320z00_651);
								}
							else
								{	/* Engine/heap.scm 168 */
									obj_t BgL_port2321z00_684;

									{	/* Engine/heap.scm 168 */
										obj_t BgL_res2543z00_977;

										{	/* Engine/heap.scm 168 */
											obj_t BgL_auxz00_1384;

											BgL_auxz00_1384 = BGL_CURRENT_DYNAMIC_ENV();
											BgL_res2543z00_977 =
												BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1384);
										}
										BgL_port2321z00_684 = BgL_res2543z00_977;
									}
									bgl_display_string(BGl_string2557z00zzengine_heapz00,
										BgL_port2321z00_684);
									{	/* Engine/heap.scm 168 */
										obj_t BgL_arg2503z00_685;

										{	/* Engine/heap.scm 168 */
											obj_t BgL_arg2504z00_686;

											obj_t BgL_arg2505z00_687;

											BgL_arg2504z00_686 = CNST_TABLE_REF(((long) 13));
											{	/* Engine/heap.scm 168 */
												obj_t BgL_arg2506z00_688;

												{	/* Engine/heap.scm 168 */
													obj_t BgL_arg2510z00_692;

													obj_t BgL_arg2511z00_693;

													BgL_arg2510z00_692 = CNST_TABLE_REF(((long) 6));
													{	/* Engine/heap.scm 168 */
														obj_t BgL_list2512z00_694;

														BgL_list2512z00_694 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg2511z00_693 =
															BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
															(BgL_namez00_648, BgL_list2512z00_694);
													}
													BgL_arg2506z00_688 =
														MAKE_PAIR(BgL_arg2510z00_692, BgL_arg2511z00_693);
												}
												{	/* Engine/heap.scm 168 */
													obj_t BgL_list2508z00_690;

													{	/* Engine/heap.scm 168 */
														obj_t BgL_arg2509z00_691;

														BgL_arg2509z00_691 = MAKE_PAIR(BNIL, BNIL);
														BgL_list2508z00_690 =
															MAKE_PAIR(BgL_arg2506z00_688, BgL_arg2509z00_691);
													}
													BgL_arg2505z00_687 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_idz00_647, BgL_list2508z00_690);
											}}
											BgL_arg2503z00_685 =
												MAKE_PAIR(BgL_arg2504z00_686, BgL_arg2505z00_687);
										}
										bgl_display_obj(BgL_arg2503z00_685, BgL_port2321z00_684);
									}
									return
										bgl_display_char(((unsigned char) '\n'),
										BgL_port2321z00_684);
		}}}}}}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 446742181),
				BSTRING_TO_STRING(BGl_string2561z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string2561z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string2561z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string2561z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string2561z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 71067807),
				BSTRING_TO_STRING(BGl_string2561z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string2561z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 143212498),
				BSTRING_TO_STRING(BGl_string2561z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string2561z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzheap_restorez00(((long) 307873065),
				BSTRING_TO_STRING(BGl_string2561z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 358171001),
				BSTRING_TO_STRING(BGl_string2561z00zzengine_heapz00));
			return
				BGl_modulezd2initializa7ationz75zzmodule_pragmaz00(((long) 284127067),
				BSTRING_TO_STRING(BGl_string2561z00zzengine_heapz00));
		}
	}

#ifdef __cplusplus
}
#endif
