/*===========================================================================*/
/*   (Heap/restore.scm)                                                      */
/*   Bigloo (3.2b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon May 25 12:42:12 CEST 2009       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Heap/restore.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;


	extern obj_t BGl_za2bigloozd2versionza2zd2zzengine_paramz00;
	extern obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	extern obj_t BGl_addzd2tenvz12zc0zztype_envz00(obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzheap_restorez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_restorezd2additionalzd2heapsz00zzheap_restorez00();
	static obj_t BGl_zc3exitza32376ze3z83zzheap_restorez00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzheap_restorez00();
	static obj_t BGl_zc3anonymousza32253ze3z83zzheap_restorez00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
	static obj_t BGl__restorezd2heapzd2zzheap_restorez00(obj_t);
	static bool_t BGl_backendzd2heapzd2compatiblezf3zf3zzheap_restorez00(obj_t);
	static obj_t BGl_zc3anonymousza32405ze3z83zzheap_restorez00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza32398ze3z83zzheap_restorez00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_putpropz12z12zz__r4_symbols_6_4z00(obj_t, obj_t, obj_t);
	extern obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32266ze3z83zzheap_restorez00(obj_t, obj_t);
	extern obj_t BGl_za2additionalzd2heapzd2namesza2z00zzengine_paramz00;
	static obj_t BGl_cnstzd2initzd2zzheap_restorez00();
	static obj_t BGl_unbindzd2callzf2ccz12z32zzheap_restorez00();
	BGL_EXPORTED_DECL obj_t BGl_restorezd2heapzd2zzheap_restorez00();
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	static obj_t BGl__heapzd2modulezd2listz00zzheap_restorez00(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzheap_restorez00();
	extern obj_t BGl_setzd2tenvz12zc0zztype_envz00(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2libzd2dirza2zd2zzengine_paramz00;
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_findzd2filezf2pathz20zz__osz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzheap_restorez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinit_mainz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_enginez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__binaryz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzheap_restorez00();
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	extern obj_t BGl_za2callzf2cczf3za2z01zzengine_paramz00;
	BGL_IMPORT obj_t close_binary_port(obj_t);
	extern obj_t BGl_za2additionalzd2includezd2foreignza2z00zzengine_paramz00;
	static obj_t BGl_zc3exitza32154ze3z83zzheap_restorez00(obj_t);
	BGL_IMPORT obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
	BGL_IMPORT obj_t bgl_reverse(obj_t);
	extern obj_t BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00;
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00(obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	static obj_t BGl__restorezd2additionalzd2heapz00zzheap_restorez00(obj_t,
		obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT obj_t BGl_getpropz00zz__r4_symbols_6_4z00(obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00 = BUNSPEC;
	static obj_t BGl__restorezd2additionalzd2heapsz00zzheap_restorez00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_restorezd2additionalzd2heapz00zzheap_restorez00(obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	BGL_IMPORT obj_t input_obj(obj_t);
	BGL_IMPORT obj_t bgl_append2(obj_t, obj_t);
	extern obj_t BGl_compilerzd2exitzd2zzinit_mainz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_heapzd2modulezd2listz00zzheap_restorez00(obj_t);
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_za2heapzd2nameza2zd2zzengine_paramz00;
	static obj_t BGl_libraryzd2moduleszd2initz00zzheap_restorez00();
	static obj_t BGl_za2heapzd2markza2zd2zzheap_restorez00 = BUNSPEC;
	static obj_t BGl_methodzd2initzd2zzheap_restorez00();
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	static obj_t __cnst[7];


	   
		 
		DEFINE_STRING(BGl_string2437z00zzheap_restorez00,
		BgL_bgl_string2437za700za7za7h2460za7, "Heap", 4);
	      DEFINE_STRING(BGl_string2438z00zzheap_restorez00,
		BgL_bgl_string2438za700za7za7h2461za7, "   . ", 5);
	      DEFINE_STRING(BGl_string2440z00zzheap_restorez00,
		BgL_bgl_string2440za700za7za7h2462za7, "]", 1);
	      DEFINE_STRING(BGl_string2439z00zzheap_restorez00,
		BgL_bgl_string2439za700za7za7h2463za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string2441z00zzheap_restorez00,
		BgL_bgl_string2441za700za7za7h2464za7, "      [reading ", 15);
	      DEFINE_STRING(BGl_string2442z00zzheap_restorez00,
		BgL_bgl_string2442za700za7za7h2465za7, "Cannot open heap file ~s", 24);
	      DEFINE_STRING(BGl_string2443z00zzheap_restorez00,
		BgL_bgl_string2443za700za7za7h2466za7, "Corrupted heap", 14);
	      DEFINE_STRING(BGl_string2444z00zzheap_restorez00,
		BgL_bgl_string2444za700za7za7h2467za7, "~a vs. ~a", 9);
	      DEFINE_STRING(BGl_string2445z00zzheap_restorez00,
		BgL_bgl_string2445za700za7za7h2468za7, "Target language mismatch", 24);
	      DEFINE_STRING(BGl_string2446z00zzheap_restorez00,
		BgL_bgl_string2446za700za7za7h2469za7, "Heap is `~a', Bigloo is `~a'", 28);
	      DEFINE_STRING(BGl_string2447z00zzheap_restorez00,
		BgL_bgl_string2447za700za7za7h2470za7, "Release mismatch", 16);
	      DEFINE_STRING(BGl_string2448z00zzheap_restorez00,
		BgL_bgl_string2448za700za7za7h2471za7, "Specific version mismatch", 25);
	      DEFINE_STRING(BGl_string2451z00zzheap_restorez00,
		BgL_bgl_string2451za700za7za7h2472za7, ".", 1);
	      DEFINE_STRING(BGl_string2452z00zzheap_restorez00,
		BgL_bgl_string2452za700za7za7h2473za7, "Library", 7);
	      DEFINE_STRING(BGl_string2453z00zzheap_restorez00,
		BgL_bgl_string2453za700za7za7h2474za7, "restore-additional-heap", 23);
	      DEFINE_STRING(BGl_string2456z00zzheap_restorez00,
		BgL_bgl_string2456za700za7za7h2475za7, "heap_restore", 12);
	      DEFINE_STRING(BGl_string2457z00zzheap_restorez00,
		BgL_bgl_string2457za700za7za7h2476za7,
		"restore-additional-heap call-with-current-continuation __r4_control_features_6_9 call/cc restore-heap pass-started heap-mark ",
		125);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_restorezd2heapzd2envz00zzheap_restorez00,
		BgL_bgl__restoreza7d2heapza72477z00,
		BGl__restorezd2heapzd2zzheap_restorez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_heapzd2modulezd2listzd2envzd2zzheap_restorez00,
		BgL_bgl__heapza7d2moduleza7d2478z00, va_generic_entry,
		BGl__heapzd2modulezd2listz00zzheap_restorez00, BUNSPEC, -1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_restorezd2additionalzd2heapzd2envzd2zzheap_restorez00,
		BgL_bgl__restoreza7d2addit2479za7,
		BGl__restorezd2additionalzd2heapz00zzheap_restorez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2450z00zzheap_restorez00,
		BgL_bgl_za7c3anonymousza7a322480z00,
		BGl_zc3anonymousza32266ze3z83zzheap_restorez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2449z00zzheap_restorez00,
		BgL_bgl_za7c3anonymousza7a322481z00,
		BGl_zc3anonymousza32253ze3z83zzheap_restorez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2454z00zzheap_restorez00,
		BgL_bgl_za7c3anonymousza7a322482z00,
		BGl_zc3anonymousza32398ze3z83zzheap_restorez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2455z00zzheap_restorez00,
		BgL_bgl_za7c3anonymousza7a322483z00,
		BGl_zc3anonymousza32405ze3z83zzheap_restorez00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_restorezd2additionalzd2heapszd2envzd2zzheap_restorez00,
		BgL_bgl__restoreza7d2addit2484za7,
		BGl__restorezd2additionalzd2heapsz00zzheap_restorez00, 0L, BUNSPEC, 0);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzheap_restorez00(long
		BgL_checksumz00_859, char *BgL_fromz00_860)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzheap_restorez00))
				{
					BGl_requirezd2initializa7ationz75zzheap_restorez00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzheap_restorez00();
					BGl_cnstzd2initzd2zzheap_restorez00();
					BGl_importedzd2moduleszd2initz00zzheap_restorez00();
					BGl_toplevelzd2initzd2zzheap_restorez00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"heap_restore");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"heap_restore");
			BGl_modulezd2initializa7ationz75zz__binaryz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"heap_restore");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			{	/* Heap/restore.scm 15 */
				obj_t BgL_cportz00_851;

				BgL_cportz00_851 =
					bgl_open_input_string(BGl_string2457z00zzheap_restorez00,
					(int) (((long) 0)));
				{
					long BgL_iz00_852;

					BgL_iz00_852 = ((long) 6);
				BgL_loopz00_853:
					if ((BgL_iz00_852 == ((long) -1)))
						{	/* Heap/restore.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Heap/restore.scm 15 */
							{	/* Heap/restore.scm 15 */
								obj_t BgL_arg2459z00_855;

								{	/* Heap/restore.scm 15 */

									{	/* Heap/restore.scm 15 */
										obj_t BgL_locationz00_857;

										BgL_locationz00_857 = BBOOL(((bool_t) 0));
										{	/* Heap/restore.scm 15 */

											BgL_arg2459z00_855 =
												BGl_readz00zz__readerz00(BgL_cportz00_851,
												BgL_locationz00_857);
										}
									}
								}
								{	/* Heap/restore.scm 15 */
									int BgL_auxz00_884;

									BgL_auxz00_884 = (int) (BgL_iz00_852);
									CNST_TABLE_SET(BgL_auxz00_884, BgL_arg2459z00_855);
							}}
							{	/* Heap/restore.scm 15 */
								int BgL_auxz00_858;

								BgL_auxz00_858 = (int) ((BgL_iz00_852 - ((long) 1)));
								{
									long BgL_iz00_889;

									BgL_iz00_889 = (long) (BgL_auxz00_858);
									BgL_iz00_852 = BgL_iz00_889;
									goto BgL_loopz00_853;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00 = BNIL;
			return (BGl_za2heapzd2markza2zd2zzheap_restorez00 =
				CNST_TABLE_REF(((long) 0)), BUNSPEC);
		}
	}



/* backend-heap-compatible? */
	bool_t BGl_backendzd2heapzd2compatiblezf3zf3zzheap_restorez00(obj_t
		BgL_targetz00_1)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 36 */
			{	/* Heap/restore.scm 37 */
				obj_t BgL_instance2014z00_417;

				BgL_instance2014z00_417 = BGl_thezd2backendzd2zzbackend_backendz00();
				{	/* Heap/restore.scm 38 */
					bool_t BgL__ortest_2016z00_418;

					{	/* Heap/restore.scm 38 */
						obj_t BgL_auxz00_893;

						{
							BgL_backendz00_bglt BgL_auxz00_894;

							BgL_auxz00_894 = (BgL_backendz00_bglt) (BgL_instance2014z00_417);
							BgL_auxz00_893 =
								(((BgL_backendz00_bglt) CREF(BgL_auxz00_894))->BgL_languagez00);
						}
						BgL__ortest_2016z00_418 = (BgL_targetz00_1 == BgL_auxz00_893);
					}
					if (BgL__ortest_2016z00_418)
						{	/* Heap/restore.scm 38 */
							return BgL__ortest_2016z00_418;
						}
					else
						{	/* Heap/restore.scm 38 */
							obj_t BgL_auxz00_899;

							{
								BgL_backendz00_bglt BgL_auxz00_900;

								BgL_auxz00_900 =
									(BgL_backendz00_bglt) (BgL_instance2014z00_417);
								BgL_auxz00_899 =
									(((BgL_backendz00_bglt) CREF(BgL_auxz00_900))->
									BgL_heapzd2compatiblezd2);
							}
							return (BgL_targetz00_1 == BgL_auxz00_899);
						}
				}
			}
		}
	}



/* restore-heap */
	BGL_EXPORTED_DEF obj_t BGl_restorezd2heapzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 43 */
			if (STRINGP(BGl_za2heapzd2nameza2zd2zzengine_paramz00))
				{	/* Heap/restore.scm 44 */
					{	/* Heap/restore.scm 45 */
						obj_t BgL_list2049z00_422;

						{	/* Heap/restore.scm 45 */
							obj_t BgL_arg2060z00_424;

							{	/* Heap/restore.scm 45 */
								obj_t BgL_arg2073z00_426;

								BgL_arg2073z00_426 =
									MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
								BgL_arg2060z00_424 =
									MAKE_PAIR(BGl_string2437z00zzheap_restorez00,
									BgL_arg2073z00_426);
							}
							BgL_list2049z00_422 =
								MAKE_PAIR(BGl_string2438z00zzheap_restorez00,
								BgL_arg2060z00_424);
						}
						BGl_verbosez00zztools_speekz00(BINT(((long) 1)),
							BgL_list2049z00_422);
					}
					BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 =
						BINT(((long) 0));
					BGl_za2currentzd2passza2zd2zzengine_passz00 =
						BGl_string2437z00zzheap_restorez00;
					{
						obj_t BgL_hooksz00_429;

						obj_t BgL_hnamesz00_430;

						BgL_hooksz00_429 = BNIL;
						BgL_hnamesz00_430 = BNIL;
					BgL_loopz00_431:
						if (NULLP(BgL_hooksz00_429))
							{	/* Heap/restore.scm 45 */
								CNST_TABLE_REF(((long) 1));
							}
						else
							{	/* Heap/restore.scm 45 */
								bool_t BgL_testz00_916;

								{	/* Heap/restore.scm 45 */
									obj_t BgL_fun2102z00_439;

									BgL_fun2102z00_439 = CAR(BgL_hooksz00_429);
									BgL_testz00_916 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun2102z00_439)
										(BgL_fun2102z00_439, BEOA));
								}
								if (BgL_testz00_916)
									{
										obj_t BgL_hnamesz00_923;

										obj_t BgL_hooksz00_921;

										BgL_hooksz00_921 = CDR(BgL_hooksz00_429);
										BgL_hnamesz00_923 = CDR(BgL_hnamesz00_430);
										BgL_hnamesz00_430 = BgL_hnamesz00_923;
										BgL_hooksz00_429 = BgL_hooksz00_921;
										goto BgL_loopz00_431;
									}
								else
									{	/* Heap/restore.scm 45 */
										BGl_internalzd2errorzd2zztools_errorz00
											(BGl_string2437z00zzheap_restorez00,
											BGl_string2439z00zzheap_restorez00,
											CAR(BgL_hnamesz00_430));
									}
							}
					}
					{	/* Heap/restore.scm 46 */
						obj_t BgL_fnamez00_441;

						BgL_fnamez00_441 =
							BGl_findzd2filezf2pathz20zz__osz00
							(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
							BGl_za2libzd2dirza2zd2zzengine_paramz00);
						if (STRINGP(BgL_fnamez00_441))
							{	/* Heap/restore.scm 48 */
								obj_t BgL_portz00_443;

								BgL_portz00_443 =
									BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00
									(BgL_fnamez00_441);
								if (BINARY_PORTP(BgL_portz00_443))
									{	/* Heap/restore.scm 49 */
										{	/* Heap/restore.scm 54 */
											obj_t BgL_list2106z00_445;

											{	/* Heap/restore.scm 54 */
												obj_t BgL_arg2114z00_447;

												{	/* Heap/restore.scm 54 */
													obj_t BgL_arg2120z00_448;

													{	/* Heap/restore.scm 54 */
														obj_t BgL_arg2140z00_450;

														BgL_arg2140z00_450 =
															MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
														BgL_arg2120z00_448 =
															MAKE_PAIR(BGl_string2440z00zzheap_restorez00,
															BgL_arg2140z00_450);
													}
													BgL_arg2114z00_447 =
														MAKE_PAIR(BgL_fnamez00_441, BgL_arg2120z00_448);
												}
												BgL_list2106z00_445 =
													MAKE_PAIR(BGl_string2441z00zzheap_restorez00,
													BgL_arg2114z00_447);
											}
											BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
												BgL_list2106z00_445);
										}
										{	/* Heap/restore.scm 55 */
											obj_t BgL_val2019z00_451;

											BgL_val2019z00_451 =
												BGl_zc3exitza32154ze3z83zzheap_restorez00
												(BgL_portz00_443);
											close_binary_port(BgL_portz00_443);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val2019z00_451)))
												{	/* Heap/restore.scm 107 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val2019z00_451), CDR(BgL_val2019z00_451));
												}
											else
												{	/* Heap/restore.scm 107 */
													return BgL_val2019z00_451;
												}
										}
									}
								else
									{	/* Heap/restore.scm 50 */
										obj_t BgL_mz00_505;

										{	/* Heap/restore.scm 50 */
											obj_t BgL_list2275z00_506;

											BgL_list2275z00_506 = MAKE_PAIR(BgL_fnamez00_441, BNIL);
											BgL_mz00_505 =
												BGl_formatz00zz__r4_output_6_10_3z00
												(BGl_string2442z00zzheap_restorez00,
												BgL_list2275z00_506);
										}
										BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
											BgL_mz00_505, BGl_za2libzd2dirza2zd2zzengine_paramz00);
										return BGl_compilerzd2exitzd2zzinit_mainz00(BINT(((long)
													5)));
							}}
						else
							{	/* Heap/restore.scm 108 */
								obj_t BgL_mz00_507;

								{	/* Heap/restore.scm 108 */
									obj_t BgL_list2276z00_508;

									BgL_list2276z00_508 =
										MAKE_PAIR(BGl_za2heapzd2nameza2zd2zzengine_paramz00, BNIL);
									BgL_mz00_507 =
										BGl_formatz00zz__r4_output_6_10_3z00
										(BGl_string2442z00zzheap_restorez00, BgL_list2276z00_508);
								}
								BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
									BgL_mz00_507, BGl_za2libzd2dirza2zd2zzengine_paramz00);
								return BGl_compilerzd2exitzd2zzinit_mainz00(BINT(((long) 5)));
				}}}
			else
				{	/* Heap/restore.scm 44 */
					return BFALSE;
				}
		}
	}



/* <exit:2154> */
	obj_t BGl_zc3exitza32154ze3z83zzheap_restorez00(obj_t BgL_portz00_849)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 107 */
			jmp_buf_t jmpbuf;

			void *BgL_an_exit2020z00_456;

			{
				BGL_STORE_TRACE();
				if (SET_EXIT(BgL_an_exit2020z00_456))
					{
						BGL_RESTORE_TRACE();
						return _exit_value_;
					}
				else
					{
						BgL_an_exit2020z00_456 = (void *) jmpbuf;
						{	/* Heap/restore.scm 107 */

							PUSH_EXIT(BgL_an_exit2020z00_456, ((long) 0));
							{	/* Heap/restore.scm 56 */
								bool_t BgL_val2021z00_457;

								{	/* Heap/restore.scm 56 */
									obj_t BgL_envsz00_458;

									BgL_envsz00_458 = input_obj(BgL_portz00_849);
									{	/* Heap/restore.scm 56 */
										obj_t BgL__z00_459;

										{	/* Heap/restore.scm 57 */
											bool_t BgL_testz00_964;

											if (VECTORP(BgL_envsz00_458))
												{	/* Heap/restore.scm 58 */
													int BgL_arg2273z00_503;

													BgL_arg2273z00_503 = VECTOR_LENGTH(BgL_envsz00_458);
													BgL_testz00_964 =
														((long) (BgL_arg2273z00_503) == ((long) 5));
												}
											else
												{	/* Heap/restore.scm 57 */
													BgL_testz00_964 = ((bool_t) 0);
												}
											if (BgL_testz00_964)
												{	/* Heap/restore.scm 57 */
													BgL__z00_459 = BFALSE;
												}
											else
												{	/* Heap/restore.scm 57 */
													BgL__z00_459 =
														BGl_errorz00zz__errorz00
														(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
														BGl_string2443z00zzheap_restorez00,
														BgL_envsz00_458);
												}
										}
										{	/* Heap/restore.scm 57 */
											obj_t BgL_targetz00_460;

											BgL_targetz00_460 =
												VECTOR_REF(BgL_envsz00_458, (int) (((long) 0)));
											{	/* Heap/restore.scm 62 */
												obj_t BgL_versionz00_461;

												BgL_versionz00_461 =
													VECTOR_REF(BgL_envsz00_458, (int) (((long) 1)));
												{	/* Heap/restore.scm 63 */
													obj_t BgL_specificz00_462;

													BgL_specificz00_462 =
														VECTOR_REF(BgL_envsz00_458, (int) (((long) 2)));
													{	/* Heap/restore.scm 64 */
														obj_t BgL_genvz00_463;

														BgL_genvz00_463 =
															VECTOR_REF(BgL_envsz00_458, (int) (((long) 3)));
														{	/* Heap/restore.scm 65 */
															obj_t BgL_tenvz00_464;

															BgL_tenvz00_464 =
																VECTOR_REF(BgL_envsz00_458, (int) (((long) 4)));
															{	/* Heap/restore.scm 66 */

																if (BGl_backendzd2heapzd2compatiblezf3zf3zzheap_restorez00(BgL_targetz00_460))
																	{	/* Heap/restore.scm 68 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 69 */
																		obj_t BgL_arg2166z00_467;

																		{	/* Heap/restore.scm 71 */
																			obj_t BgL_arg2185z00_469;

																			{	/* Heap/restore.scm 73 */
																				obj_t BgL_arg2205z00_472;

																				BgL_arg2205z00_472 =
																					BGl_thezd2backendzd2zzbackend_backendz00
																					();
																				{
																					BgL_backendz00_bglt BgL_auxz00_984;

																					BgL_auxz00_984 =
																						(BgL_backendz00_bglt)
																						(BgL_arg2205z00_472);
																					BgL_arg2185z00_469 =
																						(((BgL_backendz00_bglt)
																							CREF(BgL_auxz00_984))->
																						BgL_languagez00);
																				}
																			}
																			{	/* Heap/restore.scm 71 */
																				obj_t BgL_list2186z00_470;

																				{	/* Heap/restore.scm 71 */
																					obj_t BgL_arg2198z00_471;

																					BgL_arg2198z00_471 =
																						MAKE_PAIR(BgL_arg2185z00_469, BNIL);
																					BgL_list2186z00_470 =
																						MAKE_PAIR(BgL_targetz00_460,
																						BgL_arg2198z00_471);
																				}
																				BgL_arg2166z00_467 =
																					BGl_formatz00zz__r4_output_6_10_3z00
																					(BGl_string2444z00zzheap_restorez00,
																					BgL_list2186z00_470);
																			}
																		}
																		BGl_errorz00zz__errorz00
																			(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																			BGl_string2445z00zzheap_restorez00,
																			BgL_arg2166z00_467);
																	}
																if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																	(BgL_versionz00_461,
																		BGl_za2bigloozd2versionza2zd2zzengine_paramz00))
																	{	/* Heap/restore.scm 74 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 75 */
																		obj_t BgL_arg2225z00_475;

																		{	/* Heap/restore.scm 77 */
																			obj_t BgL_list2226z00_476;

																			{	/* Heap/restore.scm 77 */
																				obj_t BgL_arg2231z00_477;

																				BgL_arg2231z00_477 =
																					MAKE_PAIR
																					(BGl_za2bigloozd2versionza2zd2zzengine_paramz00,
																					BNIL);
																				BgL_list2226z00_476 =
																					MAKE_PAIR(BgL_versionz00_461,
																					BgL_arg2231z00_477);
																			}
																			BgL_arg2225z00_475 =
																				BGl_formatz00zz__r4_output_6_10_3z00
																				(BGl_string2446z00zzheap_restorez00,
																				BgL_list2226z00_476);
																		}
																		BGl_errorz00zz__errorz00
																			(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																			BGl_string2447z00zzheap_restorez00,
																			BgL_arg2225z00_475);
																	}
																if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																	(BgL_specificz00_462,
																		BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00))
																	{	/* Heap/restore.scm 80 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 81 */
																		obj_t BgL_arg2239z00_480;

																		{	/* Heap/restore.scm 83 */
																			obj_t BgL_list2240z00_481;

																			{	/* Heap/restore.scm 83 */
																				obj_t BgL_arg2245z00_482;

																				BgL_arg2245z00_482 =
																					MAKE_PAIR
																					(BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00,
																					BNIL);
																				BgL_list2240z00_481 =
																					MAKE_PAIR(BgL_specificz00_462,
																					BgL_arg2245z00_482);
																			}
																			BgL_arg2239z00_480 =
																				BGl_formatz00zz__r4_output_6_10_3z00
																				(BGl_string2446z00zzheap_restorez00,
																				BgL_list2240z00_481);
																		}
																		BGl_errorz00zz__errorz00
																			(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																			BGl_string2448z00zzheap_restorez00,
																			BgL_arg2239z00_480);
																	}
																BGl_setzd2genvz12zc0zzast_envz00
																	(BgL_genvz00_463);
																BGl_setzd2tenvz12zc0zztype_envz00
																	(BgL_tenvz00_464);
																if (CBOOL
																	(BGl_za2callzf2cczf3za2z01zzengine_paramz00))
																	{	/* Heap/restore.scm 91 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 91 */
																		BGl_unbindzd2callzf2ccz12z32zzheap_restorez00
																			();
																	}
																{	/* Heap/restore.scm 94 */
																	bool_t BgL_testz00_1008;

																	{	/* Heap/restore.scm 94 */
																		obj_t BgL_arg2263z00_493;

																		BgL_arg2263z00_493 =
																			BGl_thezd2backendzd2zzbackend_backendz00
																			();
																		{
																			BgL_backendz00_bglt BgL_auxz00_1010;

																			BgL_auxz00_1010 =
																				(BgL_backendz00_bglt)
																				(BgL_arg2263z00_493);
																			BgL_testz00_1008 =
																				(((BgL_backendz00_bglt)
																					CREF(BgL_auxz00_1010))->
																				BgL_qualifiedzd2typeszd2);
																		}
																	}
																	if (BgL_testz00_1008)
																		{	/* Heap/restore.scm 94 */
																			BGl_forzd2eachzd2globalz12z12zzast_envz00
																				(BGl_proc2449z00zzheap_restorez00,
																				BNIL);
																			BgL_genvz00_463;
																		}
																	else
																		{	/* Heap/restore.scm 94 */
																			BFALSE;
																		}
																}
																BGl_forzd2eachzd2globalz12z12zzast_envz00
																	(BGl_proc2450z00zzheap_restorez00, BNIL);
																BgL_val2021z00_457 = ((bool_t) 1);
															}
														}
													}
												}
											}
										}
									}
								}
								POP_EXIT();
								return BBOOL(BgL_val2021z00_457);
							}
						}
					}
			}
		}
	}



/* _restore-heap */
	obj_t BGl__restorezd2heapzd2zzheap_restorez00(obj_t BgL_envz00_830)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 43 */
			return BGl_restorezd2heapzd2zzheap_restorez00();
		}
	}



/* <anonymous:2266> */
	obj_t BGl_zc3anonymousza32266ze3z83zzheap_restorez00(obj_t BgL_envz00_831,
		obj_t BgL_newz00_832)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 104 */
			{
				obj_t BgL_newz00_496;

				BgL_newz00_496 = BgL_newz00_832;
				{	/* Heap/restore.scm 105 */
					obj_t BgL_arg2268z00_773;

					{
						BgL_globalz00_bglt BgL_auxz00_1018;

						BgL_auxz00_1018 = (BgL_globalz00_bglt) (BgL_newz00_496);
						BgL_arg2268z00_773 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1018))->BgL_modulez00);
					}
					{	/* Heap/restore.scm 105 */
						obj_t BgL_list2269z00_774;

						BgL_list2269z00_774 = MAKE_PAIR(BgL_arg2268z00_773, BNIL);
						return
							BGl_heapzd2modulezd2listz00zzheap_restorez00(BgL_list2269z00_774);
					}
				}
			}
		}
	}



/* <anonymous:2253> */
	obj_t BGl_zc3anonymousza32253ze3z83zzheap_restorez00(obj_t BgL_envz00_833,
		obj_t BgL_newz00_834)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 96 */
			{
				obj_t BgL_newz00_486;

				BgL_newz00_486 = BgL_newz00_834;
				{	/* Heap/restore.scm 98 */
					obj_t BgL_arg2258z00_488;

					obj_t BgL_arg2259z00_489;

					obj_t BgL_arg2260z00_490;

					{
						BgL_globalz00_bglt BgL_auxz00_1023;

						BgL_auxz00_1023 = (BgL_globalz00_bglt) (BgL_newz00_486);
						BgL_arg2258z00_488 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1023))->BgL_modulez00);
					}
					{
						BgL_globalz00_bglt BgL_auxz00_1026;

						BgL_auxz00_1026 = (BgL_globalz00_bglt) (BgL_newz00_486);
						BgL_arg2259z00_489 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1026))->
							BgL_jvmzd2typezd2namez00);
					}
					BgL_arg2260z00_490 = BGl_shapez00zztools_shapez00(BgL_newz00_486);
					{	/* Heap/restore.scm 97 */
						obj_t BgL_list2261z00_491;

						BgL_list2261z00_491 = MAKE_PAIR(BgL_arg2260z00_490, BNIL);
						return
							BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(BgL_arg2258z00_488,
							BgL_arg2259z00_489, BgL_list2261z00_491);
					}
				}
			}
		}
	}



/* unbind-call/cc! */
	obj_t BGl_unbindzd2callzf2ccz12z32zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 115 */
			if (CBOOL(BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long)
								3)), CNST_TABLE_REF(((long) 4)))))
				{	/* Heap/restore.scm 116 */
					BGl_unbindzd2globalz12zc0zzast_envz00(CNST_TABLE_REF(((long) 3)),
						CNST_TABLE_REF(((long) 4)));
				}
			else
				{	/* Heap/restore.scm 116 */
					BFALSE;
				}
			if (CBOOL(BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long)
								5)), CNST_TABLE_REF(((long) 4)))))
				{	/* Heap/restore.scm 118 */
					return
						BGl_unbindzd2globalz12zc0zzast_envz00(CNST_TABLE_REF(((long) 5)),
						CNST_TABLE_REF(((long) 4)));
				}
			else
				{	/* Heap/restore.scm 118 */
					return BFALSE;
				}
		}
	}



/* restore-additional-heaps */
	BGL_EXPORTED_DEF obj_t BGl_restorezd2additionalzd2heapsz00zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 126 */
			if (PAIRP(BGl_za2additionalzd2heapzd2namesza2z00zzengine_paramz00))
				{	/* Heap/restore.scm 128 */
					obj_t BgL_sufz00_512;

					{	/* Heap/restore.scm 128 */
						obj_t BgL_arg2363z00_540;

						{	/* Heap/restore.scm 128 */
							obj_t BgL_arg2364z00_541;

							BgL_arg2364z00_541 = BGl_thezd2backendzd2zzbackend_backendz00();
							{
								BgL_backendz00_bglt BgL_auxz00_1051;

								BgL_auxz00_1051 = (BgL_backendz00_bglt) (BgL_arg2364z00_541);
								BgL_arg2363z00_540 =
									(((BgL_backendz00_bglt) CREF(BgL_auxz00_1051))->
									BgL_heapzd2suffixzd2);
							}
						}
						BgL_sufz00_512 =
							string_append(BGl_string2451z00zzheap_restorez00,
							BgL_arg2363z00_540);
					}
					{	/* Heap/restore.scm 129 */
						obj_t BgL_list2284z00_513;

						{	/* Heap/restore.scm 129 */
							obj_t BgL_arg2289z00_515;

							{	/* Heap/restore.scm 129 */
								obj_t BgL_arg2300z00_517;

								BgL_arg2300z00_517 =
									MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
								BgL_arg2289z00_515 =
									MAKE_PAIR(BGl_string2452z00zzheap_restorez00,
									BgL_arg2300z00_517);
							}
							BgL_list2284z00_513 =
								MAKE_PAIR(BGl_string2438z00zzheap_restorez00,
								BgL_arg2289z00_515);
						}
						BGl_verbosez00zztools_speekz00(BINT(((long) 1)),
							BgL_list2284z00_513);
					}
					BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 =
						BINT(((long) 0));
					BGl_za2currentzd2passza2zd2zzengine_passz00 =
						BGl_string2452z00zzheap_restorez00;
					{
						obj_t BgL_hooksz00_520;

						obj_t BgL_hnamesz00_521;

						BgL_hooksz00_520 = BNIL;
						BgL_hnamesz00_521 = BNIL;
					BgL_loopz00_522:
						if (NULLP(BgL_hooksz00_520))
							{	/* Heap/restore.scm 129 */
								CNST_TABLE_REF(((long) 1));
							}
						else
							{	/* Heap/restore.scm 129 */
								bool_t BgL_testz00_1065;

								{	/* Heap/restore.scm 129 */
									obj_t BgL_fun2342z00_530;

									BgL_fun2342z00_530 = CAR(BgL_hooksz00_520);
									BgL_testz00_1065 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun2342z00_530)
										(BgL_fun2342z00_530, BEOA));
								}
								if (BgL_testz00_1065)
									{
										obj_t BgL_hnamesz00_1072;

										obj_t BgL_hooksz00_1070;

										BgL_hooksz00_1070 = CDR(BgL_hooksz00_520);
										BgL_hnamesz00_1072 = CDR(BgL_hnamesz00_521);
										BgL_hnamesz00_521 = BgL_hnamesz00_1072;
										BgL_hooksz00_520 = BgL_hooksz00_1070;
										goto BgL_loopz00_522;
									}
								else
									{	/* Heap/restore.scm 129 */
										BGl_internalzd2errorzd2zztools_errorz00
											(BGl_string2452z00zzheap_restorez00,
											BGl_string2439z00zzheap_restorez00,
											CAR(BgL_hnamesz00_521));
									}
							}
					}
					{	/* Heap/restore.scm 130 */
						obj_t BgL_g2029z00_532;

						BgL_g2029z00_532 =
							bgl_reverse
							(BGl_za2additionalzd2heapzd2namesza2z00zzengine_paramz00);
						{
							obj_t BgL_l2027z00_533;

							{	/* Heap/restore.scm 132 */
								bool_t BgL_auxz00_1077;

								BgL_l2027z00_533 = BgL_g2029z00_532;
							BgL_forzd2each2028zd2_534:
								if (PAIRP(BgL_l2027z00_533))
									{	/* Heap/restore.scm 132 */
										{	/* Heap/restore.scm 131 */
											obj_t BgL_hz00_536;

											BgL_hz00_536 = CAR(BgL_l2027z00_533);
											BGl_restorezd2additionalzd2heapz00zzheap_restorez00
												(string_append(BgL_hz00_536, BgL_sufz00_512));
										}
										{
											obj_t BgL_l2027z00_1083;

											BgL_l2027z00_1083 = CDR(BgL_l2027z00_533);
											BgL_l2027z00_533 = BgL_l2027z00_1083;
											goto BgL_forzd2each2028zd2_534;
										}
									}
								else
									{	/* Heap/restore.scm 132 */
										BgL_auxz00_1077 = ((bool_t) 1);
									}
								return BBOOL(BgL_auxz00_1077);
							}
						}
					}
				}
			else
				{	/* Heap/restore.scm 127 */
					return BFALSE;
				}
		}
	}



/* _restore-additional-heaps */
	obj_t BGl__restorezd2additionalzd2heapsz00zzheap_restorez00(obj_t
		BgL_envz00_835)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 126 */
			return BGl_restorezd2additionalzd2heapsz00zzheap_restorez00();
		}
	}



/* restore-additional-heap */
	BGL_EXPORTED_DEF obj_t
		BGl_restorezd2additionalzd2heapz00zzheap_restorez00(obj_t BgL_heapz00_2)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 137 */
			{	/* Heap/restore.scm 138 */
				obj_t BgL_fnamez00_542;

				BgL_fnamez00_542 =
					BGl_findzd2filezf2pathz20zz__osz00(BgL_heapz00_2,
					BGl_za2libzd2dirza2zd2zzengine_paramz00);
				if (STRINGP(BgL_fnamez00_542))
					{	/* Heap/restore.scm 140 */
						obj_t BgL_portz00_544;

						BgL_portz00_544 =
							BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00
							(BgL_fnamez00_542);
						if (BINARY_PORTP(BgL_portz00_544))
							{	/* Heap/restore.scm 141 */
								{	/* Heap/restore.scm 146 */
									obj_t BgL_list2367z00_546;

									{	/* Heap/restore.scm 146 */
										obj_t BgL_arg2369z00_548;

										{	/* Heap/restore.scm 146 */
											obj_t BgL_arg2370z00_549;

											{	/* Heap/restore.scm 146 */
												obj_t BgL_arg2372z00_551;

												BgL_arg2372z00_551 =
													MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
												BgL_arg2370z00_549 =
													MAKE_PAIR(BGl_string2440z00zzheap_restorez00,
													BgL_arg2372z00_551);
											}
											BgL_arg2369z00_548 =
												MAKE_PAIR(BgL_fnamez00_542, BgL_arg2370z00_549);
										}
										BgL_list2367z00_546 =
											MAKE_PAIR(BGl_string2441z00zzheap_restorez00,
											BgL_arg2369z00_548);
									}
									BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
										BgL_list2367z00_546);
								}
								{	/* Heap/restore.scm 147 */
									obj_t BgL_val2024z00_552;

									BgL_val2024z00_552 =
										BGl_zc3exitza32376ze3z83zzheap_restorez00(BgL_heapz00_2,
										BgL_portz00_544);
									close_binary_port(BgL_portz00_544);
									if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
											(BgL_val2024z00_552)))
										{	/* Heap/restore.scm 210 */
											return
												BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
												(BgL_val2024z00_552), CDR(BgL_val2024z00_552));
										}
									else
										{	/* Heap/restore.scm 210 */
											return BgL_val2024z00_552;
										}
								}
							}
						else
							{	/* Heap/restore.scm 142 */
								obj_t BgL_mz00_614;

								{	/* Heap/restore.scm 142 */
									obj_t BgL_list2414z00_615;

									BgL_list2414z00_615 = MAKE_PAIR(BgL_fnamez00_542, BNIL);
									BgL_mz00_614 =
										BGl_formatz00zz__r4_output_6_10_3z00
										(BGl_string2442z00zzheap_restorez00, BgL_list2414z00_615);
								}
								BGl_errorz00zz__errorz00(BGl_string2453z00zzheap_restorez00,
									BgL_mz00_614, BGl_za2libzd2dirza2zd2zzengine_paramz00);
								return BGl_compilerzd2exitzd2zzinit_mainz00(BINT(((long) 6)));
					}}
				else
					{	/* Heap/restore.scm 211 */
						obj_t BgL_mz00_616;

						{	/* Heap/restore.scm 211 */
							obj_t BgL_list2415z00_617;

							BgL_list2415z00_617 = MAKE_PAIR(BgL_heapz00_2, BNIL);
							BgL_mz00_616 =
								BGl_formatz00zz__r4_output_6_10_3z00
								(BGl_string2442z00zzheap_restorez00, BgL_list2415z00_617);
						}
						BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 6)), BgL_mz00_616,
							BGl_za2libzd2dirza2zd2zzengine_paramz00);
						return BGl_compilerzd2exitzd2zzinit_mainz00(BINT(((long) 6)));
		}}}
	}



/* <exit:2376> */
	obj_t BGl_zc3exitza32376ze3z83zzheap_restorez00(obj_t BgL_heapz00_848,
		obj_t BgL_portz00_847)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 210 */
			jmp_buf_t jmpbuf;

			void *BgL_an_exit2025z00_557;

			{
				BGL_STORE_TRACE();
				if (SET_EXIT(BgL_an_exit2025z00_557))
					{
						BGL_RESTORE_TRACE();
						return _exit_value_;
					}
				else
					{
						BgL_an_exit2025z00_557 = (void *) jmpbuf;
						{	/* Heap/restore.scm 210 */

							PUSH_EXIT(BgL_an_exit2025z00_557, ((long) 0));
							{	/* Heap/restore.scm 148 */
								bool_t BgL_val2026z00_558;

								{	/* Heap/restore.scm 148 */
									obj_t BgL_envsz00_559;

									BgL_envsz00_559 = input_obj(BgL_portz00_847);
									{	/* Heap/restore.scm 148 */
										obj_t BgL__z00_560;

										{	/* Heap/restore.scm 149 */
											bool_t BgL_testz00_1123;

											{	/* Heap/restore.scm 149 */
												bool_t BgL_testz00_1124;

												{	/* Heap/restore.scm 149 */
													obj_t BgL_v2030z00_613;

													BgL_v2030z00_613 = create_vector((int) (((long) 1)));
													VECTOR_SET(BgL_v2030z00_613,
														(int) (((long) 0)), BgL_envsz00_559);
													BgL_testz00_1124 = ((bool_t) 1);
												}
												if (BgL_testz00_1124)
													{	/* Heap/restore.scm 150 */
														int BgL_arg2412z00_611;

														BgL_arg2412z00_611 = VECTOR_LENGTH(BgL_envsz00_559);
														BgL_testz00_1123 =
															((long) (BgL_arg2412z00_611) == ((long) 6));
													}
												else
													{	/* Heap/restore.scm 149 */
														BgL_testz00_1123 = ((bool_t) 0);
													}
											}
											if (BgL_testz00_1123)
												{	/* Heap/restore.scm 149 */
													BgL__z00_560 = BFALSE;
												}
											else
												{	/* Heap/restore.scm 149 */
													BgL__z00_560 =
														BGl_errorz00zz__errorz00(BgL_heapz00_848,
														BGl_string2443z00zzheap_restorez00,
														BgL_envsz00_559);
												}
										}
										{	/* Heap/restore.scm 149 */
											obj_t BgL_targetz00_561;

											BgL_targetz00_561 =
												VECTOR_REF(BgL_envsz00_559, (int) (((long) 0)));
											{	/* Heap/restore.scm 152 */
												obj_t BgL_versionz00_562;

												BgL_versionz00_562 =
													VECTOR_REF(BgL_envsz00_559, (int) (((long) 1)));
												{	/* Heap/restore.scm 153 */
													obj_t BgL_specificz00_563;

													BgL_specificz00_563 =
														VECTOR_REF(BgL_envsz00_559, (int) (((long) 2)));
													{	/* Heap/restore.scm 154 */
														obj_t BgL_genvz00_564;

														BgL_genvz00_564 =
															VECTOR_REF(BgL_envsz00_559, (int) (((long) 3)));
														{	/* Heap/restore.scm 155 */
															obj_t BgL_tenvz00_565;

															BgL_tenvz00_565 =
																VECTOR_REF(BgL_envsz00_559, (int) (((long) 4)));
															{	/* Heap/restore.scm 156 */
																obj_t BgL_includesz00_566;

																BgL_includesz00_566 =
																	VECTOR_REF(BgL_envsz00_559,
																	(int) (((long) 5)));
																{	/* Heap/restore.scm 157 */

																	if (BGl_backendzd2heapzd2compatiblezf3zf3zzheap_restorez00(BgL_targetz00_561))
																		{	/* Heap/restore.scm 159 */
																			BFALSE;
																		}
																	else
																		{	/* Heap/restore.scm 160 */
																			obj_t BgL_arg2379z00_569;

																			{	/* Heap/restore.scm 162 */
																				obj_t BgL_arg2381z00_571;

																				{	/* Heap/restore.scm 164 */
																					obj_t BgL_arg2384z00_574;

																					BgL_arg2384z00_574 =
																						BGl_thezd2backendzd2zzbackend_backendz00
																						();
																					{
																						BgL_backendz00_bglt BgL_auxz00_1148;

																						BgL_auxz00_1148 =
																							(BgL_backendz00_bglt)
																							(BgL_arg2384z00_574);
																						BgL_arg2381z00_571 =
																							(((BgL_backendz00_bglt)
																								CREF(BgL_auxz00_1148))->
																							BgL_languagez00);
																					}
																				}
																				{	/* Heap/restore.scm 162 */
																					obj_t BgL_list2382z00_572;

																					{	/* Heap/restore.scm 162 */
																						obj_t BgL_arg2383z00_573;

																						BgL_arg2383z00_573 =
																							MAKE_PAIR(BgL_arg2381z00_571,
																							BNIL);
																						BgL_list2382z00_572 =
																							MAKE_PAIR(BgL_targetz00_561,
																							BgL_arg2383z00_573);
																					}
																					BgL_arg2379z00_569 =
																						BGl_formatz00zz__r4_output_6_10_3z00
																						(BGl_string2444z00zzheap_restorez00,
																						BgL_list2382z00_572);
																				}
																			}
																			BGl_errorz00zz__errorz00(BgL_heapz00_848,
																				BGl_string2445z00zzheap_restorez00,
																				BgL_arg2379z00_569);
																		}
																	if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																		(BgL_versionz00_562,
																			BGl_za2bigloozd2versionza2zd2zzengine_paramz00))
																		{	/* Heap/restore.scm 165 */
																			BFALSE;
																		}
																	else
																		{	/* Heap/restore.scm 166 */
																			obj_t BgL_arg2387z00_577;

																			{	/* Heap/restore.scm 168 */
																				obj_t BgL_list2388z00_578;

																				{	/* Heap/restore.scm 168 */
																					obj_t BgL_arg2389z00_579;

																					BgL_arg2389z00_579 =
																						MAKE_PAIR
																						(BGl_za2bigloozd2versionza2zd2zzengine_paramz00,
																						BNIL);
																					BgL_list2388z00_578 =
																						MAKE_PAIR(BgL_versionz00_562,
																						BgL_arg2389z00_579);
																				}
																				BgL_arg2387z00_577 =
																					BGl_formatz00zz__r4_output_6_10_3z00
																					(BGl_string2446z00zzheap_restorez00,
																					BgL_list2388z00_578);
																			}
																			BGl_errorz00zz__errorz00
																				(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																				BGl_string2447z00zzheap_restorez00,
																				BgL_arg2387z00_577);
																		}
																	if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																		(BgL_specificz00_563,
																			BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00))
																		{	/* Heap/restore.scm 171 */
																			BFALSE;
																		}
																	else
																		{	/* Heap/restore.scm 172 */
																			obj_t BgL_arg2392z00_582;

																			{	/* Heap/restore.scm 174 */
																				obj_t BgL_list2393z00_583;

																				{	/* Heap/restore.scm 174 */
																					obj_t BgL_arg2394z00_584;

																					BgL_arg2394z00_584 =
																						MAKE_PAIR
																						(BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00,
																						BNIL);
																					BgL_list2393z00_583 =
																						MAKE_PAIR(BgL_specificz00_563,
																						BgL_arg2394z00_584);
																				}
																				BgL_arg2392z00_582 =
																					BGl_formatz00zz__r4_output_6_10_3z00
																					(BGl_string2446z00zzheap_restorez00,
																					BgL_list2393z00_583);
																			}
																			BGl_errorz00zz__errorz00
																				(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																				BGl_string2448z00zzheap_restorez00,
																				BgL_arg2392z00_582);
																		}
																	BGl_addzd2tenvz12zc0zztype_envz00
																		(BgL_tenvz00_565);
																	BGl_addzd2genvz12zc0zzast_envz00
																		(BgL_genvz00_564);
																	{	/* Heap/restore.scm 190 */
																		bool_t BgL_testz00_1169;

																		{	/* Heap/restore.scm 190 */
																			obj_t BgL_arg2403z00_595;

																			BgL_arg2403z00_595 =
																				BGl_thezd2backendzd2zzbackend_backendz00
																				();
																			{
																				BgL_backendz00_bglt BgL_auxz00_1171;

																				BgL_auxz00_1171 =
																					(BgL_backendz00_bglt)
																					(BgL_arg2403z00_595);
																				BgL_testz00_1169 =
																					(((BgL_backendz00_bglt)
																						CREF(BgL_auxz00_1171))->
																					BgL_qualifiedzd2typeszd2);
																			}
																		}
																		if (BgL_testz00_1169)
																			{	/* Heap/restore.scm 190 */
																				BGl_forzd2eachzd2globalz12z12zzast_envz00
																					(BGl_proc2454z00zzheap_restorez00,
																					BNIL);
																			}
																		else
																			{	/* Heap/restore.scm 190 */
																				BFALSE;
																			}
																	}
																	BGl_hashtablezd2forzd2eachz00zz__hashz00
																		(BgL_genvz00_564,
																		BGl_proc2455z00zzheap_restorez00);
																	BGl_za2additionalzd2includezd2foreignza2z00zzengine_paramz00
																		=
																		bgl_append2
																		(BGl_za2additionalzd2includezd2foreignza2z00zzengine_paramz00,
																		BgL_includesz00_566);
																	BgL_val2026z00_558 = ((bool_t) 1);
																}
															}
														}
													}
												}
											}
										}
									}
								}
								POP_EXIT();
								return BBOOL(BgL_val2026z00_558);
							}
						}
					}
			}
		}
	}



/* _restore-additional-heap */
	obj_t BGl__restorezd2additionalzd2heapz00zzheap_restorez00(obj_t
		BgL_envz00_838, obj_t BgL_heapz00_839)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 137 */
			return
				BGl_restorezd2additionalzd2heapz00zzheap_restorez00(BgL_heapz00_839);
		}
	}



/* <anonymous:2405> */
	obj_t BGl_zc3anonymousza32405ze3z83zzheap_restorez00(obj_t BgL_envz00_840,
		obj_t BgL_kz00_841, obj_t BgL_bucketz00_842)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 200 */
			{
				obj_t BgL_kz00_597;

				obj_t BgL_bucketz00_598;

				{	/* Heap/restore.scm 201 */
					bool_t BgL_auxz00_1180;

					BgL_kz00_597 = BgL_kz00_841;
					BgL_bucketz00_598 = BgL_bucketz00_842;
					{	/* Heap/restore.scm 201 */
						obj_t BgL_g2033z00_600;

						BgL_g2033z00_600 = CDR(BgL_bucketz00_598);
						{
							obj_t BgL_l2031z00_601;

							BgL_l2031z00_601 = BgL_g2033z00_600;
						BgL_forzd2each2032zd2_602:
							if (PAIRP(BgL_l2031z00_601))
								{	/* Heap/restore.scm 204 */
									{	/* Heap/restore.scm 202 */
										obj_t BgL_newz00_604;

										BgL_newz00_604 = CAR(BgL_l2031z00_601);
										{	/* Heap/restore.scm 203 */
											obj_t BgL_arg2407z00_605;

											{
												BgL_globalz00_bglt BgL_auxz00_1185;

												BgL_auxz00_1185 = (BgL_globalz00_bglt) (BgL_newz00_604);
												BgL_arg2407z00_605 =
													(((BgL_globalz00_bglt) CREF(BgL_auxz00_1185))->
													BgL_modulez00);
											}
											{	/* Heap/restore.scm 202 */
												obj_t BgL_list2408z00_606;

												BgL_list2408z00_606 =
													MAKE_PAIR(BgL_arg2407z00_605, BNIL);
												BGl_heapzd2modulezd2listz00zzheap_restorez00
													(BgL_list2408z00_606);
											}
										}
									}
									{
										obj_t BgL_l2031z00_1190;

										BgL_l2031z00_1190 = CDR(BgL_l2031z00_601);
										BgL_l2031z00_601 = BgL_l2031z00_1190;
										goto BgL_forzd2each2032zd2_602;
									}
								}
							else
								{	/* Heap/restore.scm 204 */
									BgL_auxz00_1180 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_1180);
				}
			}
		}
	}



/* <anonymous:2398> */
	obj_t BGl_zc3anonymousza32398ze3z83zzheap_restorez00(obj_t BgL_envz00_843,
		obj_t BgL_newz00_844)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 192 */
			{
				obj_t BgL_newz00_588;

				BgL_newz00_588 = BgL_newz00_844;
				{	/* Heap/restore.scm 194 */
					obj_t BgL_arg2399z00_590;

					obj_t BgL_arg2400z00_591;

					obj_t BgL_arg2401z00_592;

					{
						BgL_globalz00_bglt BgL_auxz00_1193;

						BgL_auxz00_1193 = (BgL_globalz00_bglt) (BgL_newz00_588);
						BgL_arg2399z00_590 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1193))->BgL_modulez00);
					}
					{
						BgL_globalz00_bglt BgL_auxz00_1196;

						BgL_auxz00_1196 = (BgL_globalz00_bglt) (BgL_newz00_588);
						BgL_arg2400z00_591 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1196))->
							BgL_jvmzd2typezd2namez00);
					}
					BgL_arg2401z00_592 = BGl_shapez00zztools_shapez00(BgL_newz00_588);
					{	/* Heap/restore.scm 193 */
						obj_t BgL_list2402z00_593;

						BgL_list2402z00_593 = MAKE_PAIR(BgL_arg2401z00_592, BNIL);
						return
							BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(BgL_arg2399z00_590,
							BgL_arg2400z00_591, BgL_list2402z00_593);
					}
				}
			}
		}
	}



/* heap-module-list */
	BGL_EXPORTED_DEF obj_t BGl_heapzd2modulezd2listz00zzheap_restorez00(obj_t
		BgL_argsz00_3)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 231 */
			if (NULLP(BgL_argsz00_3))
				{	/* Heap/restore.scm 233 */
					return BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00;
				}
			else
				{	/* Heap/restore.scm 235 */
					bool_t BgL_testz00_1204;

					{	/* Heap/restore.scm 235 */
						obj_t BgL_arg2420z00_622;

						BgL_arg2420z00_622 = CAR(BgL_argsz00_3);
						BgL_testz00_1204 =
							CBOOL(BGl_getpropz00zz__r4_symbols_6_4z00(BgL_arg2420z00_622,
								BGl_za2heapzd2markza2zd2zzheap_restorez00));
					}
					if (BgL_testz00_1204)
						{	/* Heap/restore.scm 235 */
							return BFALSE;
						}
					else
						{	/* Heap/restore.scm 235 */
							{	/* Heap/restore.scm 236 */
								obj_t BgL_arg2418z00_620;

								BgL_arg2418z00_620 = CAR(BgL_argsz00_3);
								BGl_putpropz12z12zz__r4_symbols_6_4z00(BgL_arg2418z00_620,
									BGl_za2heapzd2markza2zd2zzheap_restorez00, BTRUE);
							}
							{	/* Heap/restore.scm 237 */
								obj_t BgL_arg2419z00_621;

								BgL_arg2419z00_621 = CAR(BgL_argsz00_3);
								return (BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00 =
									MAKE_PAIR(BgL_arg2419z00_621,
										BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00),
									BUNSPEC);
							}
						}
				}
		}
	}



/* _heap-module-list */
	obj_t BGl__heapzd2modulezd2listz00zzheap_restorez00(obj_t BgL_envz00_845,
		obj_t BgL_argsz00_846)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 231 */
			return BGl_heapzd2modulezd2listz00zzheap_restorez00(BgL_argsz00_846);
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 182148081),
				BSTRING_TO_STRING(BGl_string2456z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string2456z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 216344604),
				BSTRING_TO_STRING(BGl_string2456z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 446742181),
				BSTRING_TO_STRING(BGl_string2456z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzengine_enginez00(((long) 528201616),
				BSTRING_TO_STRING(BGl_string2456z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzinit_mainz00(((long) 230845835),
				BSTRING_TO_STRING(BGl_string2456z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string2456z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string2456z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string2456z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string2456z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 143212498),
				BSTRING_TO_STRING(BGl_string2456z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string2456z00zzheap_restorez00));
			return
				BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string2456z00zzheap_restorez00));
		}
	}

#ifdef __cplusplus
}
#endif
