/*===========================================================================*/
/*   (Ast/sexp.scm)                                                          */
/*   Bigloo (3.2b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon May 25 12:42:12 CEST 2009       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/sexp.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_feffectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_readz00;
		obj_t BgL_writez00;
	}                 *BgL_feffectz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;


	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_letzd2ze3nodez31zzast_letz00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BUNSPEC;
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t,
		obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static obj_t BGl_zc3anonymousza33208ze3z83zzast_sexpz00(obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33209ze3z83zzast_sexpz00(obj_t);
	static obj_t BGl_liipz00zzast_sexpz00(obj_t);
	static obj_t BGl_za2cachezd2resza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_zc3exitza33205ze3z83zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	extern BgL_appz00_bglt BGl_makezd2appzd2zzast_nodez00(obj_t, BgL_typez00_bglt,
		obj_t, obj_t, BgL_varz00_bglt, obj_t);
	static obj_t BGl_cnstzd2initzd2zzast_sexpz00();
	extern BgL_letzd2funzd2_bglt BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	static obj_t BGl__locationzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	static obj_t BGl__definezd2primopzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_findzd2locationzf2locz20zztools_locationz00(obj_t, obj_t);
	extern BgL_kwotez00_bglt BGl_makezd2kwotezd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t);
	BGL_IMPORT bool_t bigloo_strncmp(obj_t, obj_t, long);
	BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_feffectz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_exitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_labelsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_buildz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern BgL_sequencez00_bglt BGl_makezd2sequencezd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzast_sexpz00();
	extern BgL_jumpzd2exzd2itz00_bglt
		BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	extern BgL_closurez00_bglt BGl_makezd2closurezd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_variablez00_bglt);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t c_substring(obj_t, long, long);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	BGL_IMPORT obj_t string_to_bstring(char *);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern BgL_nodez00_bglt BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(bool_t,
		obj_t, BgL_typez00_bglt, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(obj_t);
	static obj_t BGl_loopz00zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_replacez12z12zztools_miscz00(obj_t, obj_t);
	extern obj_t BGl_epairifyz00zztools_miscz00(obj_t, obj_t);
	extern BgL_setqz00_bglt BGl_makezd2setqzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_varz00_bglt, BgL_nodez00_bglt);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern BgL_selectz00_bglt BGl_makezd2selectzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t, BgL_nodez00_bglt, obj_t, BgL_typez00_bglt);
	BGL_EXPORTED_DECL BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2magicza2z00zztype_cachez00;
	static obj_t BGl_methodzd2initzd2zzast_sexpz00();
	static obj_t BGl__usezd2variablez12zc0zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza33590ze3z83zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	extern bool_t BGl_dssslzd2namedzd2constantzf3zf3zztools_dssslz00(obj_t);
	extern BgL_nodez00_bglt BGl_applycationzd2ze3nodez31zzast_applyz00(obj_t,
		obj_t, obj_t, obj_t);
	extern bool_t BGl_globalzd2readzd2onlyzf3zf3zzast_varz00(BgL_globalz00_bglt);
	extern BgL_letzd2funzd2_bglt BGl_labelszd2ze3nodez31zzast_labelsz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_sexpz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt, obj_t, obj_t);
	extern BgL_atomz00_bglt BGl_makezd2atomzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t);
	extern BgL_failz00_bglt BGl_makezd2failzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_nodez00_bglt, BgL_nodez00_bglt, BgL_nodez00_bglt);
	BGL_IMPORT obj_t BGl_withzd2exceptionzd2handlerz00zz__errorz00(obj_t, obj_t);
	static obj_t BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_genericzd2initzd2zzast_sexpz00();
	static obj_t BGl__makezd2anonymouszd2namez00zzast_sexpz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_funz00zzast_varz00;
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t BGl_za2sitesza2z00zzast_sexpz00 = BUNSPEC;
	BGL_IMPORT obj_t BGl_exceptionzd2notifyzd2zz__errorz00(obj_t);
	extern BgL_conditionalz00_bglt BGl_makezd2conditionalzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t, BgL_nodez00_bglt, BgL_nodez00_bglt,
		BgL_nodez00_bglt);
	extern bool_t BGl_privatezd2sexpzf3z21zzast_privatez00(obj_t);
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl__errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_privatezd2ze3nodez31zzast_privatez00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	extern obj_t BGl_za2bnilza2z00zztype_cachez00;
	static obj_t BGl__definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_epairifyzd2reczd2zztools_miscz00(obj_t, obj_t);
	extern obj_t BGl_normaliza7ezd2prognz75zztools_prognz00(obj_t);
	extern BgL_nodez00_bglt BGl_applicationzd2ze3nodez31zzast_appz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt);
	BGL_IMPORT obj_t string_to_symbol(char *);
	static obj_t BGl__sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt,
		BgL_nodez00_bglt);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl_lookupz00zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	extern BgL_feffectz00_bglt BGl_parsezd2effectzd2zzeffect_feffectz00(obj_t);
	static obj_t BGl__topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl__sexpza2zd2ze3nodez93zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_varz00_bglt BGl_makezd2varzd2zzast_nodez00(obj_t, BgL_typez00_bglt,
		BgL_variablez00_bglt);
	BGL_IMPORT char *BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	extern BgL_typez00_bglt BGl_typeofzd2atomzd2zztype_typeofz00(obj_t);
	extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
	static obj_t __cnst[39];


	   
		 
		DEFINE_STRING(BGl_string3900z00zzast_sexpz00,
		BgL_bgl_string3900za700za7za7a3927za7, "Illegal `define' form", 21);
	      DEFINE_STRING(BGl_string3901z00zzast_sexpz00,
		BgL_bgl_string3901za700za7za7a3928za7, "illegal `define' expression", 27);
	      DEFINE_STRING(BGl_string3902z00zzast_sexpz00,
		BgL_bgl_string3902za700za7za7a3929za7, "Illegal `set!' form", 19);
	      DEFINE_STRING(BGl_string3903z00zzast_sexpz00,
		BgL_bgl_string3903za700za7za7a3930za7, "Read-only variable", 18);
	      DEFINE_STRING(BGl_string3904z00zzast_sexpz00,
		BgL_bgl_string3904za700za7za7a3931za7, "illegal `set!' expression", 25);
	      DEFINE_STRING(BGl_string3894z00zzast_sexpz00,
		BgL_bgl_string3894za700za7za7a3932za7, "Illegal `pragma/effect' form", 28);
	      DEFINE_STRING(BGl_string3905z00zzast_sexpz00,
		BgL_bgl_string3905za700za7za7a3933za7, "Illegal `if' form", 17);
	      DEFINE_STRING(BGl_string3895z00zzast_sexpz00,
		BgL_bgl_string3895za700za7za7a3934za7, "Illegal `free-pragma/effect' form",
		33);
	      DEFINE_STRING(BGl_string3906z00zzast_sexpz00,
		BgL_bgl_string3906za700za7za7a3935za7, "Illegal `quote' expression", 26);
	      DEFINE_STRING(BGl_string3896z00zzast_sexpz00,
		BgL_bgl_string3896za700za7za7a3936za7, "Illegal `lambda' form", 21);
	      DEFINE_STRING(BGl_string3907z00zzast_sexpz00,
		BgL_bgl_string3907za700za7za7a3937za7, "Illegal `@' expression", 22);
	      DEFINE_STRING(BGl_string3897z00zzast_sexpz00,
		BgL_bgl_string3897za700za7za7a3938za7, "Illegal `application' form", 26);
	      DEFINE_STRING(BGl_string3908z00zzast_sexpz00,
		BgL_bgl_string3908za700za7za7a3939za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string3898z00zzast_sexpz00,
		BgL_bgl_string3898za700za7za7a3940za7, "Illegal `case' form", 19);
	      DEFINE_STRING(BGl_string3910z00zzast_sexpz00,
		BgL_bgl_string3910za700za7za7a3941za7, "Illegal atom", 12);
	      DEFINE_STRING(BGl_string3909z00zzast_sexpz00,
		BgL_bgl_string3909za700za7za7a3942za7,
		"This backend (~a) does not support external first class value functions",
		71);
	      DEFINE_STRING(BGl_string3899z00zzast_sexpz00,
		BgL_bgl_string3899za700za7za7a3943za7, "Illegal `failure' form", 22);
	      DEFINE_STRING(BGl_string3911z00zzast_sexpz00,
		BgL_bgl_string3911za700za7za7a3944za7, "Illegal `()' expression", 23);
	      DEFINE_STRING(BGl_string3912z00zzast_sexpz00,
		BgL_bgl_string3912za700za7za7a3945za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string3913z00zzast_sexpz00,
		BgL_bgl_string3913za700za7za7a3946za7, "Illegal formal argument", 23);
	      DEFINE_STRING(BGl_string3914z00zzast_sexpz00,
		BgL_bgl_string3914za700za7za7a3947za7, "Illegal empty sequence", 22);
	      DEFINE_STRING(BGl_string3915z00zzast_sexpz00,
		BgL_bgl_string3915za700za7za7a3948za7, "Illegal mutation", 16);
	      DEFINE_STRING(BGl_string3916z00zzast_sexpz00,
		BgL_bgl_string3916za700za7za7a3949za7, "($1)", 4);
	      DEFINE_STRING(BGl_string3917z00zzast_sexpz00,
		BgL_bgl_string3917za700za7za7a3950za7, "anonymous", 9);
	      DEFINE_STRING(BGl_string3918z00zzast_sexpz00,
		BgL_bgl_string3918za700za7za7a3951za7, "<", 1);
	      DEFINE_STRING(BGl_string3920z00zzast_sexpz00,
		BgL_bgl_string3920za700za7za7a3952za7, "./", 2);
	      DEFINE_STRING(BGl_string3919z00zzast_sexpz00,
		BgL_bgl_string3919za700za7za7a3953za7, ":", 1);
	      DEFINE_STRING(BGl_string3921z00zzast_sexpz00,
		BgL_bgl_string3921za700za7za7a3954za7, ">", 1);
	      DEFINE_STRING(BGl_string3922z00zzast_sexpz00,
		BgL_bgl_string3922za700za7za7a3955za7, "-", 1);
	      DEFINE_STRING(BGl_string3923z00zzast_sexpz00,
		BgL_bgl_string3923za700za7za7a3956za7, "ast_sexp", 8);
	      DEFINE_STRING(BGl_string3924z00zzast_sexpz00,
		BgL_bgl_string3924za700za7za7a3957za7,
		"> bdb pragma::obj (@ __evmeaning_address foreign) (@ define-primop! __evenv) (@ define-primop-ref! __evenv) write cons (quote ()) jump-exit set-exit case failure letrec define begin apply quote @ app eval not if ::bool test location set! let else labels lambda free-pragma/effect free-pragma exp car pragma/effect pragma value (value apply app set!) ",
		350);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_errorzd2sexpzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl__errorza7d2sexpza7d23958z00,
		BGl__errorzd2sexpzd2ze3nodeze3zzast_sexpz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl__defineza7d2primop3959za7,
		BGl__definezd2primopzd2ze3nodeze3zzast_sexpz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl__sexpza7d2za7e3nodeza73960za7, BGl__sexpzd2ze3nodez31zzast_sexpz00,
		0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_locationzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl__locationza7d2za7e3n3961z00,
		BGl__locationzd2ze3nodez31zzast_sexpz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_usezd2variablez12zd2envz12zzast_sexpz00,
		BgL_bgl__useza7d2variableza73962z00, BGl__usezd2variablez12zc0zzast_sexpz00,
		0L, BUNSPEC, 3);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpza2zd2ze3nodezd2envz41zzast_sexpz00,
		BgL_bgl__sexpza7a2za7d2za7e3no3963za7,
		BGl__sexpza2zd2ze3nodez93zzast_sexpz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2anonymouszd2namezd2envzd2zzast_sexpz00,
		BgL_bgl__makeza7d2anonymou3964za7, va_generic_entry,
		BGl__makezd2anonymouszd2namez00zzast_sexpz00, BUNSPEC, -2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_topzd2levelzd2sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl__topza7d2levelza7d2s3965z00,
		BGl__topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2refzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl__defineza7d2primop3966za7,
		BGl__definezd2primopzd2refzd2ze3nodez31zzast_sexpz00, 0L, BUNSPEC, 2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long
		BgL_checksumz00_2610, char *BgL_fromz00_2611)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_sexpz00))
				{
					BGl_requirezd2initializa7ationz75zzast_sexpz00 = BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
					BGl_cnstzd2initzd2zzast_sexpz00();
					BGl_importedzd2moduleszd2initz00zzast_sexpz00();
					BGl_toplevelzd2initzd2zzast_sexpz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"ast_sexp");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			{	/* Ast/sexp.scm 14 */
				obj_t BgL_cportz00_2602;

				BgL_cportz00_2602 =
					bgl_open_input_string(BGl_string3924z00zzast_sexpz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2603;

					BgL_iz00_2603 = ((long) 38);
				BgL_loopz00_2604:
					if ((BgL_iz00_2603 == ((long) -1)))
						{	/* Ast/sexp.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/sexp.scm 14 */
							{	/* Ast/sexp.scm 14 */
								obj_t BgL_arg3926z00_2606;

								{	/* Ast/sexp.scm 14 */

									{	/* Ast/sexp.scm 14 */
										obj_t BgL_locationz00_2608;

										BgL_locationz00_2608 = BBOOL(((bool_t) 0));
										{	/* Ast/sexp.scm 14 */

											BgL_arg3926z00_2606 =
												BGl_readz00zz__readerz00(BgL_cportz00_2602,
												BgL_locationz00_2608);
										}
									}
								}
								{	/* Ast/sexp.scm 14 */
									int BgL_auxz00_2636;

									BgL_auxz00_2636 = (int) (BgL_iz00_2603);
									CNST_TABLE_SET(BgL_auxz00_2636, BgL_arg3926z00_2606);
							}}
							{	/* Ast/sexp.scm 14 */
								int BgL_auxz00_2609;

								BgL_auxz00_2609 = (int) ((BgL_iz00_2603 - ((long) 1)));
								{
									long BgL_iz00_2641;

									BgL_iz00_2641 = (long) (BgL_auxz00_2609);
									BgL_iz00_2603 = BgL_iz00_2641;
									goto BgL_loopz00_2604;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			BGl_za2sitesza2z00zzast_sexpz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BFALSE;
			BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BFALSE;
			return (BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE, BUNSPEC);
		}
	}



/* top-level-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_15,
		obj_t BgL_locz00_16)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 58 */
			return
				(BgL_nodez00_bglt) (BGl_zc3exitza33205ze3z83zzast_sexpz00(BgL_locz00_16,
					BgL_expz00_15));
		}
	}



/* <exit:3205> */
	obj_t BGl_zc3exitza33205ze3z83zzast_sexpz00(obj_t BgL_locz00_2600,
		obj_t BgL_expz00_2599)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 59 */
			jmp_buf_t jmpbuf;

			void *BgL_an_exit3168z00_860;

			{
				BGL_STORE_TRACE();
				if (SET_EXIT(BgL_an_exit3168z00_860))
					{
						BGL_RESTORE_TRACE();
						return _exit_value_;
					}
				else
					{
						BgL_an_exit3168z00_860 = (void *) jmpbuf;
						{	/* Ast/sexp.scm 59 */

							PUSH_EXIT(BgL_an_exit3168z00_860, ((long) 1));
							{	/* Ast/sexp.scm 59 */
								obj_t BgL_an_exitd3169z00_861;

								BgL_an_exitd3169z00_861 = BGL_EXITD_TOP();
								{	/* Ast/sexp.scm 62 */
									obj_t BgL_res3171z00_864;

									{	/* Ast/sexp.scm 62 */
										obj_t BgL_zc3anonymousza33209ze3z83_2552;

										obj_t BgL_zc3anonymousza33208ze3z83_2553;

										BgL_zc3anonymousza33209ze3z83_2552 =
											make_fx_procedure
											(BGl_zc3anonymousza33209ze3z83zzast_sexpz00,
											(int) (((long) 0)), (int) (((long) 2)));
										BgL_zc3anonymousza33208ze3z83_2553 =
											make_fx_procedure
											(BGl_zc3anonymousza33208ze3z83zzast_sexpz00,
											(int) (((long) 1)), (int) (((long) 1)));
										PROCEDURE_SET(BgL_zc3anonymousza33209ze3z83_2552,
											(int) (((long) 0)), BgL_expz00_2599);
										PROCEDURE_SET(BgL_zc3anonymousza33209ze3z83_2552,
											(int) (((long) 1)), BgL_locz00_2600);
										PROCEDURE_SET(BgL_zc3anonymousza33208ze3z83_2553,
											(int) (((long) 0)), BgL_an_exitd3169z00_861);
										BgL_res3171z00_864 =
											BGl_withzd2exceptionzd2handlerz00zz__errorz00
											(BgL_zc3anonymousza33208ze3z83_2553,
											BgL_zc3anonymousza33209ze3z83_2552);
									}
									POP_EXIT();
									return BgL_res3171z00_864;
								}
							}
						}
					}
			}
		}
	}



/* _top-level-sexp->node */
	obj_t BGl__topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_envz00_2554,
		obj_t BgL_expz00_2555, obj_t BgL_locz00_2556)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 58 */
			return
				(obj_t) (BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
				(BgL_expz00_2555, BgL_locz00_2556));
		}
	}



/* <anonymous:3209> */
	obj_t BGl_zc3anonymousza33209ze3z83zzast_sexpz00(obj_t BgL_envz00_2557)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 64 */
			{	/* Ast/sexp.scm 65 */
				obj_t BgL_expz00_2558;

				obj_t BgL_locz00_2559;

				BgL_expz00_2558 = PROCEDURE_REF(BgL_envz00_2557, (int) (((long) 0)));
				BgL_locz00_2559 = PROCEDURE_REF(BgL_envz00_2557, (int) (((long) 1)));
				{

					{	/* Ast/sexp.scm 65 */
						BgL_nodez00_bglt BgL_auxz00_2670;

						BgL_auxz00_2670 =
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_2558, BNIL,
							BgL_locz00_2559, CNST_TABLE_REF(((long) 1)));
						return (obj_t) (BgL_auxz00_2670);
					}
				}
			}
		}
	}



/* <anonymous:3208> */
	obj_t BGl_zc3anonymousza33208ze3z83zzast_sexpz00(obj_t BgL_envz00_2560,
		obj_t BgL_ez00_2562)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 61 */
			{	/* Ast/sexp.scm 62 */
				obj_t BgL_an_exitd3169z00_2561;

				BgL_an_exitd3169z00_2561 =
					PROCEDURE_REF(BgL_envz00_2560, (int) (((long) 0)));
				{
					obj_t BgL_ez00_867;

					BgL_ez00_867 = BgL_ez00_2562;
					BGl_exceptionzd2notifyzd2zz__errorz00(BgL_ez00_867);
					return
						BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd3169z00_2561,
						BUNSPEC);
				}
			}
		}
	}



/* sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t
		BgL_expz00_17, obj_t BgL_stackz00_18, obj_t BgL_locz00_19,
		obj_t BgL_sitez00_20)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 80 */
		BGl_sexpzd2ze3nodez31zzast_sexpz00:
			{
				obj_t BgL_atomz00_874;

				obj_t BgL_bodyz00_878;

				obj_t BgL_bodyz00_883;

				obj_t BgL_argsz00_884;

				obj_t BgL_varsz00_888;

				obj_t BgL_bodyz00_889;

				obj_t BgL_argsz00_890;

				obj_t BgL_effectz00_894;

				obj_t BgL_restz00_895;

				obj_t BgL_effectz00_898;

				obj_t BgL_restz00_899;

				if (NULLP(BgL_expz00_17))
					{	/* Ast/sexp.scm 85 */
						return
							BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
							(BGl_string3911z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_19);
					}
				else
					{	/* Ast/sexp.scm 85 */
						if (BGl_iszd2azf3z21zz__objectz00(BgL_expz00_17,
								BGl_nodez00zzast_nodez00))
							{	/* Ast/sexp.scm 85 */
								return (BgL_nodez00_bglt) (BgL_expz00_17);
							}
						else
							{	/* Ast/sexp.scm 85 */
								if (PAIRP(BgL_expz00_17))
									{	/* Ast/sexp.scm 85 */
										if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 20))))
											{	/* Ast/sexp.scm 85 */
												obj_t BgL_auxz00_2690;

												{	/* Ast/sexp.scm 157 */
													obj_t BgL_locz00_1091;

													BgL_locz00_1091 =
														BGl_findzd2locationzf2locz20zztools_locationz00
														(BgL_expz00_17, BgL_locz00_19);
													{
														obj_t BgL_namez00_1092;

														obj_t BgL_modulez00_1093;

														if (PAIRP(BgL_expz00_17))
															{	/* Ast/sexp.scm 158 */
																obj_t BgL_cdrzd21861zd2_1098;

																BgL_cdrzd21861zd2_1098 = CDR(BgL_expz00_17);
																if (
																	(CAR(BgL_expz00_17) ==
																		CNST_TABLE_REF(((long) 20))))
																	{	/* Ast/sexp.scm 158 */
																		if (PAIRP(BgL_cdrzd21861zd2_1098))
																			{	/* Ast/sexp.scm 158 */
																				obj_t BgL_carzd21864zd2_1101;

																				obj_t BgL_cdrzd21865zd2_1102;

																				BgL_carzd21864zd2_1101 =
																					CAR(BgL_cdrzd21861zd2_1098);
																				BgL_cdrzd21865zd2_1102 =
																					CDR(BgL_cdrzd21861zd2_1098);
																				if (SYMBOLP(BgL_carzd21864zd2_1101))
																					{	/* Ast/sexp.scm 158 */
																						if (PAIRP(BgL_cdrzd21865zd2_1102))
																							{	/* Ast/sexp.scm 158 */
																								obj_t BgL_carzd21870zd2_1105;

																								BgL_carzd21870zd2_1105 =
																									CAR(BgL_cdrzd21865zd2_1102);
																								if (SYMBOLP
																									(BgL_carzd21870zd2_1105))
																									{	/* Ast/sexp.scm 158 */
																										if (NULLP(CDR
																												(BgL_cdrzd21865zd2_1102)))
																											{	/* Ast/sexp.scm 158 */
																												BgL_namez00_1092 =
																													BgL_carzd21864zd2_1101;
																												BgL_modulez00_1093 =
																													BgL_carzd21870zd2_1105;
																												{	/* Ast/sexp.scm 160 */
																													obj_t
																														BgL_globalz00_1111;
																													BgL_globalz00_1111 =
																														BGl_findzd2globalzf2modulez20zzast_envz00
																														(BgL_namez00_1092,
																														BgL_modulez00_1093);
																													if (BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_1111, BGl_globalz00zzast_varz00))
																														{	/* Ast/sexp.scm 164 */
																															bool_t
																																BgL_testz00_2716;
																															{	/* Ast/sexp.scm 164 */
																																obj_t
																																	BgL_auxz00_2717;
																																{
																																	BgL_globalz00_bglt
																																		BgL_auxz00_2718;
																																	BgL_auxz00_2718
																																		=
																																		(BgL_globalz00_bglt)
																																		(BgL_globalz00_1111);
																																	BgL_auxz00_2717
																																		=
																																		(((BgL_globalz00_bglt) CREF(BgL_auxz00_2718))->BgL_importz00);
																																}
																																BgL_testz00_2716
																																	=
																																	(BgL_auxz00_2717
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			18)));
																															}
																															if (BgL_testz00_2716)
																																{	/* Ast/sexp.scm 165 */
																																	obj_t
																																		BgL_arg3385z00_1114;
																																	{	/* Ast/sexp.scm 165 */
																																		obj_t
																																			BgL_arg3386z00_1115;
																																		obj_t
																																			BgL_arg3387z00_1116;
																																		BgL_arg3386z00_1115
																																			=
																																			CNST_TABLE_REF
																																			(((long)
																																				18));
																																		{	/* Ast/sexp.scm 165 */
																																			obj_t
																																				BgL_list3388z00_1117;
																																			BgL_list3388z00_1117
																																				=
																																				MAKE_PAIR
																																				(BNIL,
																																				BNIL);
																																			BgL_arg3387z00_1116
																																				=
																																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																				(BGl_atomz00zzast_nodez00,
																																				BgL_list3388z00_1117);
																																		}
																																		BgL_arg3385z00_1114
																																			=
																																			MAKE_PAIR
																																			(BgL_arg3386z00_1115,
																																			BgL_arg3387z00_1116);
																																	}
																																	BgL_auxz00_2690
																																		=
																																		(obj_t)
																																		(BGl_sexpzd2ze3nodez31zzast_sexpz00
																																		(BgL_arg3385z00_1114,
																																			BgL_stackz00_18,
																																			BgL_locz00_1091,
																																			BgL_sitez00_20));
																																}
																															else
																																{	/* Ast/sexp.scm 164 */
																																	BGl_usezd2variablez12zc0zzast_sexpz00
																																		(
																																		(BgL_variablez00_bglt)
																																		(BgL_globalz00_1111),
																																		BgL_locz00_1091,
																																		BgL_sitez00_20);
																																	{	/* Ast/sexp.scm 168 */
																																		bool_t
																																			BgL_testz00_2731;
																																		if (
																																			(BgL_sitez00_20
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						19))))
																																			{	/* Ast/sexp.scm 168 */
																																				BgL_testz00_2731
																																					=
																																					(
																																					(bool_t)
																																					0);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 169 */
																																				BgL_valuez00_bglt
																																					BgL_arg3393z00_1122;
																																				{
																																					BgL_variablez00_bglt
																																						BgL_auxz00_2735;
																																					BgL_auxz00_2735
																																						=
																																						(BgL_variablez00_bglt)
																																						(BgL_globalz00_1111);
																																					BgL_arg3393z00_1122
																																						=
																																						(((BgL_variablez00_bglt) CREF(BgL_auxz00_2735))->BgL_valuez00);
																																				}
																																				{	/* Ast/sexp.scm 169 */
																																					obj_t
																																						BgL_obj1776z00_2215;
																																					BgL_obj1776z00_2215
																																						=
																																						(obj_t)
																																						(BgL_arg3393z00_1122);
																																					BgL_testz00_2731
																																						=
																																						BGl_iszd2azf3z21zz__objectz00
																																						(BgL_obj1776z00_2215,
																																						BGl_funz00zzast_varz00);
																																				}
																																			}
																																		if (BgL_testz00_2731)
																																			{	/* Ast/sexp.scm 171 */
																																				BgL_typez00_bglt
																																					BgL_arg3390z00_1119;
																																				{
																																					BgL_variablez00_bglt
																																						BgL_auxz00_2740;
																																					BgL_auxz00_2740
																																						=
																																						(BgL_variablez00_bglt)
																																						(BgL_globalz00_1111);
																																					BgL_arg3390z00_1119
																																						=
																																						(((BgL_variablez00_bglt) CREF(BgL_auxz00_2740))->BgL_typez00);
																																				}
																																				BgL_auxz00_2690
																																					=
																																					(obj_t)
																																					(BGl_makezd2closurezd2zzast_nodez00
																																					(BgL_locz00_1091,
																																						BgL_arg3390z00_1119,
																																						(BgL_variablez00_bglt)
																																						(BgL_globalz00_1111)));
																																			}
																																		else
																																			{	/* Ast/sexp.scm 174 */
																																				BgL_typez00_bglt
																																					BgL_arg3391z00_1120;
																																				{
																																					BgL_variablez00_bglt
																																						BgL_auxz00_2746;
																																					BgL_auxz00_2746
																																						=
																																						(BgL_variablez00_bglt)
																																						(BgL_globalz00_1111);
																																					BgL_arg3391z00_1120
																																						=
																																						(((BgL_variablez00_bglt) CREF(BgL_auxz00_2746))->BgL_typez00);
																																				}
																																				BgL_auxz00_2690
																																					=
																																					(obj_t)
																																					(BGl_makezd2varzd2zzast_nodez00
																																					(BgL_locz00_1091,
																																						BgL_arg3391z00_1120,
																																						(BgL_variablez00_bglt)
																																						(BgL_globalz00_1111)));
																																			}
																																	}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 162 */
																															BgL_auxz00_2690 =
																																(obj_t)
																																(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																(BGl_string3908z00zzast_sexpz00,
																																	BgL_expz00_17,
																																	BgL_locz00_1091));
																														}
																												}
																											}
																										else
																											{	/* Ast/sexp.scm 158 */
																												BgL_nodez00_bglt
																													BgL_auxz00_2754;
																											BgL_tagzd21854zd2_1095:
																												BgL_auxz00_2754 =
																													BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																													(BGl_string3907z00zzast_sexpz00,
																													BgL_expz00_17,
																													BgL_locz00_1091);
																												BgL_auxz00_2690 =
																													(obj_t)
																													(BgL_auxz00_2754);
																											}
																									}
																								else
																									{	/* Ast/sexp.scm 158 */
																										BgL_nodez00_bglt
																											BgL_auxz00_2757;
																										goto BgL_tagzd21854zd2_1095;
																										BgL_auxz00_2690 =
																											(obj_t) (BgL_auxz00_2757);
																									}
																							}
																						else
																							{	/* Ast/sexp.scm 158 */
																								BgL_nodez00_bglt
																									BgL_auxz00_2759;
																								goto BgL_tagzd21854zd2_1095;
																								BgL_auxz00_2690 =
																									(obj_t) (BgL_auxz00_2759);
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 158 */
																						BgL_nodez00_bglt BgL_auxz00_2761;

																						goto BgL_tagzd21854zd2_1095;
																						BgL_auxz00_2690 =
																							(obj_t) (BgL_auxz00_2761);
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 158 */
																				BgL_nodez00_bglt BgL_auxz00_2763;

																				goto BgL_tagzd21854zd2_1095;
																				BgL_auxz00_2690 =
																					(obj_t) (BgL_auxz00_2763);
																			}
																	}
																else
																	{	/* Ast/sexp.scm 158 */
																		BgL_nodez00_bglt BgL_auxz00_2765;

																		goto BgL_tagzd21854zd2_1095;
																		BgL_auxz00_2690 = (obj_t) (BgL_auxz00_2765);
																	}
															}
														else
															{	/* Ast/sexp.scm 158 */
																BgL_nodez00_bglt BgL_auxz00_2767;

																goto BgL_tagzd21854zd2_1095;
																BgL_auxz00_2690 = (obj_t) (BgL_auxz00_2767);
															}
													}
												}
												return (BgL_nodez00_bglt) (BgL_auxz00_2690);
											}
										else
											{	/* Ast/sexp.scm 85 */
												if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 21))))
													{	/* Ast/sexp.scm 85 */
														obj_t BgL_auxz00_2774;

														{
															obj_t BgL_valuez00_1125;

															if (PAIRP(BgL_expz00_17))
																{	/* Ast/sexp.scm 85 */
																	obj_t BgL_cdrzd21881zd2_1130;

																	BgL_cdrzd21881zd2_1130 = CDR(BgL_expz00_17);
																	if (PAIRP(BgL_cdrzd21881zd2_1130))
																		{	/* Ast/sexp.scm 85 */
																			if (NULLP(CDR(BgL_cdrzd21881zd2_1130)))
																				{	/* Ast/sexp.scm 85 */
																					BgL_valuez00_1125 =
																						CAR(BgL_cdrzd21881zd2_1130);
																					{	/* Ast/sexp.scm 182 */
																						obj_t BgL_locz00_1135;

																						BgL_locz00_1135 =
																							BGl_findzd2locationzf2locz20zztools_locationz00
																							(BgL_expz00_17, BgL_locz00_19);
																						if (NULLP(BgL_valuez00_1125))
																							{	/* Ast/sexp.scm 184 */
																								BgL_auxz00_2774 =
																									(obj_t)
																									(BGl_makezd2atomzd2zzast_nodez00
																									(BgL_locz00_1135,
																										(BgL_typez00_bglt)
																										(BGl_za2bnilza2z00zztype_cachez00),
																										BNIL));
																							}
																						else
																							{	/* Ast/sexp.scm 188 */
																								bool_t BgL_testz00_2789;

																								if (PAIRP(BgL_valuez00_1125))
																									{	/* Ast/sexp.scm 188 */
																										BgL_testz00_2789 =
																											((bool_t) 1);
																									}
																								else
																									{	/* Ast/sexp.scm 188 */
																										if (VECTORP
																											(BgL_valuez00_1125))
																											{	/* Ast/sexp.scm 189 */
																												BgL_testz00_2789 =
																													((bool_t) 1);
																											}
																										else
																											{	/* Ast/sexp.scm 189 */
																												if (BGL_HVECTORP
																													(BgL_valuez00_1125))
																													{	/* Ast/sexp.scm 190 */
																														BgL_testz00_2789 =
																															((bool_t) 1);
																													}
																												else
																													{	/* Ast/sexp.scm 190 */
																														if (STRUCTP
																															(BgL_valuez00_1125))
																															{	/* Ast/sexp.scm 191 */
																																BgL_testz00_2789
																																	=
																																	((bool_t) 1);
																															}
																														else
																															{	/* Ast/sexp.scm 191 */
																																if (SYMBOLP
																																	(BgL_valuez00_1125))
																																	{	/* Ast/sexp.scm 192 */
																																		BgL_testz00_2789
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 192 */
																																		BgL_testz00_2789
																																			=
																																			KEYWORDP
																																			(BgL_valuez00_1125);
																																	}
																															}
																													}
																											}
																									}
																								if (BgL_testz00_2789)
																									{	/* Ast/sexp.scm 188 */
																										BgL_auxz00_2774 =
																											(obj_t)
																											(BGl_makezd2kwotezd2zzast_nodez00
																											(BgL_locz00_1135,
																												(BgL_typez00_bglt)
																												(BGl_za2_za2z00zztype_cachez00),
																												BgL_valuez00_1125));
																									}
																								else
																									{	/* Ast/sexp.scm 197 */
																										bool_t BgL_testz00_2804;

																										{	/* Ast/sexp.scm 197 */
																											bool_t BgL_testz00_2805;

																											if (INTEGERP
																												(BgL_valuez00_1125))
																												{	/* Ast/sexp.scm 197 */
																													BgL_testz00_2805 =
																														((bool_t) 1);
																												}
																											else
																												{	/* Ast/sexp.scm 197 */
																													if (REALP
																														(BgL_valuez00_1125))
																														{	/* Ast/sexp.scm 197 */
																															BgL_testz00_2805 =
																																((bool_t) 1);
																														}
																													else
																														{	/* Ast/sexp.scm 197 */
																															if (ELONGP
																																(BgL_valuez00_1125))
																																{	/* Ast/sexp.scm 197 */
																																	BgL_testz00_2805
																																		=
																																		((bool_t)
																																		1);
																																}
																															else
																																{	/* Ast/sexp.scm 197 */
																																	if (LLONGP
																																		(BgL_valuez00_1125))
																																		{	/* Ast/sexp.scm 197 */
																																			BgL_testz00_2805
																																				=
																																				(
																																				(bool_t)
																																				1);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 197 */
																																			BgL_testz00_2805
																																				=
																																				BIGNUMP
																																				(BgL_valuez00_1125);
																																		}
																																}
																														}
																												}
																											if (BgL_testz00_2805)
																												{	/* Ast/sexp.scm 197 */
																													BgL_testz00_2804 =
																														((bool_t) 1);
																												}
																											else
																												{	/* Ast/sexp.scm 197 */
																													if (STRINGP
																														(BgL_valuez00_1125))
																														{	/* Ast/sexp.scm 198 */
																															BgL_testz00_2804 =
																																((bool_t) 1);
																														}
																													else
																														{	/* Ast/sexp.scm 198 */
																															if (CNSTP
																																(BgL_valuez00_1125))
																																{	/* Ast/sexp.scm 199 */
																																	BgL_testz00_2804
																																		=
																																		((bool_t)
																																		1);
																																}
																															else
																																{	/* Ast/sexp.scm 199 */
																																	if (CHARP
																																		(BgL_valuez00_1125))
																																		{	/* Ast/sexp.scm 203 */
																																			BgL_testz00_2804
																																				=
																																				(
																																				(bool_t)
																																				1);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 203 */
																																			BgL_testz00_2804
																																				=
																																				BOOLEANP
																																				(BgL_valuez00_1125);
																																		}
																																}
																														}
																												}
																										}
																										if (BgL_testz00_2804)
																											{	/* Ast/sexp.scm 197 */
																												BgL_auxz00_2774 =
																													(obj_t)
																													(BGl_sexpzd2ze3nodez31zzast_sexpz00
																													(BgL_valuez00_1125,
																														BgL_stackz00_18,
																														BgL_locz00_1135,
																														BgL_sitez00_20));
																											}
																										else
																											{	/* Ast/sexp.scm 197 */
																												BgL_auxz00_2774 =
																													(obj_t)
																													(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																													(BGl_string3906z00zzast_sexpz00,
																														BgL_expz00_17,
																														BgL_locz00_1135));
																											}
																									}
																							}
																					}
																				}
																			else
																				{	/* Ast/sexp.scm 85 */
																					BgL_nodez00_bglt BgL_auxz00_2827;

																				BgL_tagzd21876zd2_1127:
																					BgL_auxz00_2827 =
																						BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																						(BGl_string3906z00zzast_sexpz00,
																						BgL_expz00_17, BgL_locz00_19);
																					BgL_auxz00_2774 =
																						(obj_t) (BgL_auxz00_2827);
																				}
																		}
																	else
																		{	/* Ast/sexp.scm 85 */
																			BgL_nodez00_bglt BgL_auxz00_2830;

																			goto BgL_tagzd21876zd2_1127;
																			BgL_auxz00_2774 =
																				(obj_t) (BgL_auxz00_2830);
																		}
																}
															else
																{	/* Ast/sexp.scm 85 */
																	BgL_nodez00_bglt BgL_auxz00_2832;

																	goto BgL_tagzd21876zd2_1127;
																	BgL_auxz00_2774 = (obj_t) (BgL_auxz00_2832);
																}
														}
														return (BgL_nodez00_bglt) (BgL_auxz00_2774);
													}
												else
													{	/* Ast/sexp.scm 85 */
														if (
															(CAR(BgL_expz00_17) ==
																CNST_TABLE_REF(((long) 23))))
															{	/* Ast/sexp.scm 85 */
																obj_t BgL_arg3216z00_916;

																BgL_arg3216z00_916 = CDR(BgL_expz00_17);
																{	/* Ast/sexp.scm 85 */
																	BgL_sequencez00_bglt BgL_auxz00_2840;

																	BgL_bodyz00_878 = BgL_arg3216z00_916;
																	{	/* Ast/sexp.scm 212 */
																		obj_t BgL_bodyz00_1148;

																		if (NULLP(BgL_bodyz00_878))
																			{	/* Ast/sexp.scm 213 */
																				obj_t BgL_list3414z00_1152;

																				BgL_list3414z00_1152 =
																					MAKE_PAIR(BUNSPEC, BNIL);
																				BgL_bodyz00_1148 = BgL_list3414z00_1152;
																			}
																		else
																			{	/* Ast/sexp.scm 212 */
																				BgL_bodyz00_1148 = BgL_bodyz00_878;
																			}
																		{	/* Ast/sexp.scm 215 */
																			obj_t BgL_locz00_1149;

																			BgL_locz00_1149 =
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_expz00_17, BgL_locz00_19);
																			{	/* Ast/sexp.scm 215 */
																				obj_t BgL_nodesz00_1150;

																				BgL_nodesz00_1150 =
																					BGl_sexpza2zd2ze3nodez93zzast_sexpz00
																					(BgL_bodyz00_1148, BgL_stackz00_18,
																					BgL_locz00_1149, BgL_sitez00_20);
																				{	/* Ast/sexp.scm 216 */

																					BgL_auxz00_2840 =
																						BGl_makezd2sequencezd2zzast_nodez00
																						(BgL_locz00_1149,
																						(BgL_typez00_bglt)
																						(BGl_za2_za2z00zztype_cachez00),
																						BUNSPEC, BINT(((long) -1)),
																						BgL_nodesz00_1150);
																	}}}}
																	return (BgL_nodez00_bglt) (BgL_auxz00_2840);
																}
															}
														else
															{	/* Ast/sexp.scm 85 */
																if (
																	(CAR(BgL_expz00_17) ==
																		CNST_TABLE_REF(((long) 16))))
																	{	/* Ast/sexp.scm 85 */
																		obj_t BgL_auxz00_2854;

																		{
																			obj_t BgL_siz00_1153;

																			obj_t BgL_alorsz00_1154;

																			obj_t BgL_sinonz00_1155;

																			obj_t BgL_siz00_1157;

																			obj_t BgL_alorsz00_1158;

																			if (PAIRP(BgL_expz00_17))
																				{	/* Ast/sexp.scm 85 */
																					obj_t BgL_cdrzd21897zd2_1163;

																					BgL_cdrzd21897zd2_1163 =
																						CDR(BgL_expz00_17);
																					if (PAIRP(BgL_cdrzd21897zd2_1163))
																						{	/* Ast/sexp.scm 85 */
																							obj_t BgL_cdrzd21902zd2_1165;

																							BgL_cdrzd21902zd2_1165 =
																								CDR(BgL_cdrzd21897zd2_1163);
																							if (PAIRP(BgL_cdrzd21902zd2_1165))
																								{	/* Ast/sexp.scm 85 */
																									obj_t BgL_cdrzd21907zd2_1167;

																									BgL_cdrzd21907zd2_1167 =
																										CDR(BgL_cdrzd21902zd2_1165);
																									if (PAIRP
																										(BgL_cdrzd21907zd2_1167))
																										{	/* Ast/sexp.scm 85 */
																											if (NULLP(CDR
																													(BgL_cdrzd21907zd2_1167)))
																												{	/* Ast/sexp.scm 85 */
																													BgL_siz00_1153 =
																														CAR
																														(BgL_cdrzd21897zd2_1163);
																													BgL_alorsz00_1154 =
																														CAR
																														(BgL_cdrzd21902zd2_1165);
																													BgL_sinonz00_1155 =
																														CAR
																														(BgL_cdrzd21907zd2_1167);
																													{
																														obj_t
																															BgL_siz00_1180;
																														if (PAIRP
																															(BgL_siz00_1153))
																															{	/* Ast/sexp.scm 85 */
																																obj_t
																																	BgL_cdrzd21962zd2_1185;
																																BgL_cdrzd21962zd2_1185
																																	=
																																	CDR
																																	(BgL_siz00_1153);
																																if ((CAR
																																		(BgL_siz00_1153)
																																		==
																																		CNST_TABLE_REF
																																		(((long)
																																				16))))
																																	{	/* Ast/sexp.scm 85 */
																																		if (PAIRP
																																			(BgL_cdrzd21962zd2_1185))
																																			{	/* Ast/sexp.scm 85 */
																																				obj_t
																																					BgL_cdrzd21965zd2_1188;
																																				BgL_cdrzd21965zd2_1188
																																					=
																																					CDR
																																					(BgL_cdrzd21962zd2_1185);
																																				if (PAIRP(BgL_cdrzd21965zd2_1188))
																																					{	/* Ast/sexp.scm 85 */
																																						obj_t
																																							BgL_cdrzd21968zd2_1190;
																																						BgL_cdrzd21968zd2_1190
																																							=
																																							CDR
																																							(BgL_cdrzd21965zd2_1188);
																																						if (
																																							(CAR
																																								(BgL_cdrzd21965zd2_1188)
																																								==
																																								BFALSE))
																																							{	/* Ast/sexp.scm 85 */
																																								if (PAIRP(BgL_cdrzd21968zd2_1190))
																																									{	/* Ast/sexp.scm 85 */
																																										if ((CAR(BgL_cdrzd21968zd2_1190) == BTRUE))
																																											{	/* Ast/sexp.scm 85 */
																																												if (NULLP(CDR(BgL_cdrzd21968zd2_1190)))
																																													{	/* Ast/sexp.scm 85 */
																																														obj_t
																																															BgL_arg3436z00_1195;
																																														BgL_arg3436z00_1195
																																															=
																																															CAR
																																															(BgL_cdrzd21962zd2_1185);
																																														{	/* Ast/sexp.scm 85 */
																																															BgL_nodez00_bglt
																																																BgL_auxz00_2894;
																																															BgL_siz00_1180
																																																=
																																																BgL_arg3436z00_1195;
																																														BgL_tagzd21954zd2_1181:
																																															{	/* Ast/sexp.scm 226 */
																																																obj_t
																																																	BgL_auxz00_2895;
																																																BgL_auxz00_2895
																																																	=
																																																	CDR
																																																	(BgL_expz00_17);
																																																SET_CAR
																																																	(BgL_auxz00_2895,
																																																	BgL_siz00_1180);
																																															}
																																															{	/* Ast/sexp.scm 227 */
																																																obj_t
																																																	BgL_arg3453z00_1212;
																																																{	/* Ast/sexp.scm 227 */
																																																	obj_t
																																																		BgL_pairz00_2289;
																																																	BgL_pairz00_2289
																																																		=
																																																		BgL_expz00_17;
																																																	BgL_arg3453z00_1212
																																																		=
																																																		CDR
																																																		(CDR
																																																		(BgL_pairz00_2289));
																																																}
																																																SET_CAR
																																																	(BgL_arg3453z00_1212,
																																																	BgL_sinonz00_1155);
																																															}
																																															{	/* Ast/sexp.scm 228 */
																																																obj_t
																																																	BgL_arg3454z00_1213;
																																																{	/* Ast/sexp.scm 228 */
																																																	obj_t
																																																		BgL_pairz00_2295;
																																																	BgL_pairz00_2295
																																																		=
																																																		BgL_expz00_17;
																																																	BgL_arg3454z00_1213
																																																		=
																																																		CDR
																																																		(CDR
																																																		(CDR
																																																			(BgL_pairz00_2295)));
																																																}
																																																SET_CAR
																																																	(BgL_arg3454z00_1213,
																																																	BgL_alorsz00_1154);
																																															}
																																															BgL_auxz00_2894
																																																=
																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																(BgL_expz00_17,
																																																BgL_stackz00_18,
																																																BgL_locz00_19,
																																																BgL_sitez00_20);
																																															BgL_auxz00_2854
																																																=
																																																(obj_t)
																																																(BgL_auxz00_2894);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 85 */
																																													BgL_tagzd21955zd2_1182:
																																														{	/* Ast/sexp.scm 231 */
																																															bool_t
																																																BgL_testz00_2907;
																																															if (SYMBOLP(BgL_siz00_1153))
																																																{	/* Ast/sexp.scm 231 */
																																																	BgL_testz00_2907
																																																		=
																																																		(
																																																		(bool_t)
																																																		1);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 231 */
																																																	BgL_testz00_2907
																																																		=
																																																		BGl_iszd2azf3z21zz__objectz00
																																																		(BgL_siz00_1153,
																																																		BGl_atomz00zzast_nodez00);
																																																}
																																															if (BgL_testz00_2907)
																																																{	/* Ast/sexp.scm 232 */
																																																	obj_t
																																																		BgL_olocz00_1215;
																																																	BgL_olocz00_1215
																																																		=
																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																		(BgL_expz00_17,
																																																		BgL_locz00_19);
																																																	{	/* Ast/sexp.scm 232 */
																																																		obj_t
																																																			BgL_cdlocz00_1216;
																																																		BgL_cdlocz00_1216
																																																			=
																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																			(CDR
																																																			(BgL_expz00_17),
																																																			BgL_locz00_19);
																																																		{	/* Ast/sexp.scm 233 */
																																																			obj_t
																																																				BgL_cddlocz00_1217;
																																																			{	/* Ast/sexp.scm 234 */
																																																				obj_t
																																																					BgL_arg3460z00_1230;
																																																				{	/* Ast/sexp.scm 234 */
																																																					obj_t
																																																						BgL_pairz00_2306;
																																																					BgL_pairz00_2306
																																																						=
																																																						BgL_expz00_17;
																																																					BgL_arg3460z00_1230
																																																						=
																																																						CDR
																																																						(CDR
																																																						(BgL_pairz00_2306));
																																																				}
																																																				BgL_cddlocz00_1217
																																																					=
																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																					(BgL_arg3460z00_1230,
																																																					BgL_locz00_19);
																																																			}
																																																			{	/* Ast/sexp.scm 234 */
																																																				obj_t
																																																					BgL_cdddlocz00_1218;
																																																				{	/* Ast/sexp.scm 235 */
																																																					obj_t
																																																						BgL_arg3459z00_1229;
																																																					{	/* Ast/sexp.scm 235 */
																																																						obj_t
																																																							BgL_pairz00_2310;
																																																						BgL_pairz00_2310
																																																							=
																																																							BgL_expz00_17;
																																																						BgL_arg3459z00_1229
																																																							=
																																																							CDR
																																																							(CDR
																																																							(CDR
																																																								(BgL_pairz00_2310)));
																																																					}
																																																					BgL_cdddlocz00_1218
																																																						=
																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																						(BgL_arg3459z00_1229,
																																																						BgL_locz00_19);
																																																				}
																																																				{	/* Ast/sexp.scm 235 */
																																																					obj_t
																																																						BgL_lzd2sizd2_1219;
																																																					BgL_lzd2sizd2_1219
																																																						=
																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																						(BgL_siz00_1153,
																																																						BgL_cdlocz00_1216);
																																																					{	/* Ast/sexp.scm 236 */
																																																						obj_t
																																																							BgL_lzd2alorszd2_1220;
																																																						BgL_lzd2alorszd2_1220
																																																							=
																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																							(BgL_alorsz00_1154,
																																																							BgL_cddlocz00_1217);
																																																						{	/* Ast/sexp.scm 237 */
																																																							obj_t
																																																								BgL_lzd2sinonzd2_1221;
																																																							BgL_lzd2sinonzd2_1221
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_sinonz00_1155,
																																																								BgL_cdddlocz00_1218);
																																																							{	/* Ast/sexp.scm 238 */
																																																								BgL_nodez00_bglt
																																																									BgL_siz00_1222;
																																																								BgL_siz00_1222
																																																									=
																																																									BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																									(BgL_siz00_1153,
																																																									BgL_stackz00_18,
																																																									BgL_lzd2sizd2_1219,
																																																									CNST_TABLE_REF
																																																									(((long) 1)));
																																																								{	/* Ast/sexp.scm 239 */
																																																									BgL_nodez00_bglt
																																																										BgL_alorsz00_1223;
																																																									BgL_alorsz00_1223
																																																										=
																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																										(BgL_alorsz00_1154,
																																																										BgL_stackz00_18,
																																																										BgL_lzd2alorszd2_1220,
																																																										CNST_TABLE_REF
																																																										(((long) 1)));
																																																									{	/* Ast/sexp.scm 240 */
																																																										BgL_nodez00_bglt
																																																											BgL_sinonz00_1224;
																																																										BgL_sinonz00_1224
																																																											=
																																																											BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																											(BgL_sinonz00_1155,
																																																											BgL_stackz00_18,
																																																											BgL_lzd2sinonzd2_1221,
																																																											CNST_TABLE_REF
																																																											(((long) 1)));
																																																										{	/* Ast/sexp.scm 241 */
																																																											obj_t
																																																												BgL_locz00_1225;
																																																											{	/* Ast/sexp.scm 242 */
																																																												obj_t
																																																													BgL_locz00_1226;
																																																												{	/* Ast/sexp.scm 244 */
																																																													obj_t
																																																														BgL_arg3457z00_1228;
																																																													BgL_arg3457z00_1228
																																																														=
																																																														(
																																																														((BgL_nodez00_bglt) CREF(BgL_siz00_1222))->BgL_locz00);
																																																													BgL_locz00_1226
																																																														=
																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																														(BgL_expz00_17,
																																																														BgL_arg3457z00_1228);
																																																												}
																																																												{	/* Ast/sexp.scm 245 */
																																																													bool_t
																																																														BgL_testz00_2932;
																																																													if (STRUCTP(BgL_locz00_1226))
																																																														{	/* Ast/sexp.scm 245 */
																																																															BgL_testz00_2932
																																																																=
																																																																(STRUCT_KEY
																																																																(BgL_locz00_1226)
																																																																==
																																																																CNST_TABLE_REF
																																																																(((long) 13)));
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 245 */
																																																															BgL_testz00_2932
																																																																=
																																																																(
																																																																(bool_t)
																																																																0);
																																																														}
																																																													if (BgL_testz00_2932)
																																																														{	/* Ast/sexp.scm 245 */
																																																															BgL_locz00_1225
																																																																=
																																																																BgL_locz00_1226;
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 245 */
																																																															BgL_locz00_1225
																																																																=
																																																																BgL_olocz00_1215;
																																																														}
																																																												}
																																																											}
																																																											{	/* Ast/sexp.scm 242 */

																																																												BgL_auxz00_2854
																																																													=
																																																													(obj_t)
																																																													(BGl_makezd2conditionalzd2zzast_nodez00
																																																													(BgL_locz00_1225,
																																																														(BgL_typez00_bglt)
																																																														(BGl_za2_za2z00zztype_cachez00),
																																																														BUNSPEC,
																																																														BINT
																																																														(((long) -1)), BgL_siz00_1222, BgL_alorsz00_1223, BgL_sinonz00_1224));
																																																}}}}}}}}}}}}
																																															else
																																																{	/* Ast/sexp.scm 253 */
																																																	obj_t
																																																		BgL_testz00_1232;
																																																	BgL_testz00_1232
																																																		=
																																																		BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																																																		(BGl_gensymz00zz__r4_symbols_6_4z00
																																																		(CNST_TABLE_REF
																																																			(((long) 14))));
																																																	{	/* Ast/sexp.scm 255 */
																																																		obj_t
																																																			BgL_arg3462z00_1233;
																																																		{	/* Ast/sexp.scm 255 */
																																																			obj_t
																																																				BgL_arg3463z00_1234;
																																																			obj_t
																																																				BgL_arg3464z00_1235;
																																																			BgL_arg3463z00_1234
																																																				=
																																																				CNST_TABLE_REF
																																																				(
																																																				((long) 11));
																																																			{	/* Ast/sexp.scm 255 */
																																																				obj_t
																																																					BgL_arg3465z00_1236;
																																																				obj_t
																																																					BgL_arg3466z00_1237;
																																																				{	/* Ast/sexp.scm 255 */
																																																					obj_t
																																																						BgL_arg3470z00_1241;
																																																					{	/* Ast/sexp.scm 255 */
																																																						obj_t
																																																							BgL_arg3472z00_1243;
																																																						obj_t
																																																							BgL_arg3473z00_1244;
																																																						{	/* Ast/sexp.scm 255 */
																																																							obj_t
																																																								BgL_arg3474z00_1245;
																																																							{	/* Ast/sexp.scm 255 */
																																																								obj_t
																																																									BgL_arg3475z00_1246;
																																																								obj_t
																																																									BgL_arg3476z00_1247;
																																																								BgL_arg3475z00_1246
																																																									=
																																																									SYMBOL_TO_STRING
																																																									(BgL_testz00_1232);
																																																								{	/* Ast/sexp.scm 255 */
																																																									obj_t
																																																										BgL_symbolz00_2325;
																																																									BgL_symbolz00_2325
																																																										=
																																																										CNST_TABLE_REF
																																																										(
																																																										((long) 15));
																																																									BgL_arg3476z00_1247
																																																										=
																																																										SYMBOL_TO_STRING
																																																										(BgL_symbolz00_2325);
																																																								}
																																																								{	/* Ast/sexp.scm 255 */
																																																									obj_t
																																																										BgL_list3477z00_1248;
																																																									{	/* Ast/sexp.scm 255 */
																																																										obj_t
																																																											BgL_arg3478z00_1249;
																																																										BgL_arg3478z00_1249
																																																											=
																																																											MAKE_PAIR
																																																											(BgL_arg3476z00_1247,
																																																											BNIL);
																																																										BgL_list3477z00_1248
																																																											=
																																																											MAKE_PAIR
																																																											(BgL_arg3475z00_1246,
																																																											BgL_arg3478z00_1249);
																																																									}
																																																									BgL_arg3474z00_1245
																																																										=
																																																										BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																																																										(BgL_list3477z00_1248);
																																																							}}
																																																							BgL_arg3472z00_1243
																																																								=
																																																								string_to_symbol
																																																								(BSTRING_TO_STRING
																																																								(BgL_arg3474z00_1245));
																																																						}
																																																						{	/* Ast/sexp.scm 255 */
																																																							obj_t
																																																								BgL_list3479z00_1250;
																																																							BgL_list3479z00_1250
																																																								=
																																																								MAKE_PAIR
																																																								(BNIL,
																																																								BNIL);
																																																							BgL_arg3473z00_1244
																																																								=
																																																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																								(BgL_siz00_1153,
																																																								BgL_list3479z00_1250);
																																																						}
																																																						BgL_arg3470z00_1241
																																																							=
																																																							MAKE_PAIR
																																																							(BgL_arg3472z00_1243,
																																																							BgL_arg3473z00_1244);
																																																					}
																																																					BgL_arg3465z00_1236
																																																						=
																																																						MAKE_PAIR
																																																						(BgL_arg3470z00_1241,
																																																						BNIL);
																																																				}
																																																				{	/* Ast/sexp.scm 256 */
																																																					obj_t
																																																						BgL_arg3480z00_1251;
																																																					{	/* Ast/sexp.scm 256 */
																																																						obj_t
																																																							BgL_arg3481z00_1252;
																																																						obj_t
																																																							BgL_arg3482z00_1253;
																																																						BgL_arg3481z00_1252
																																																							=
																																																							CNST_TABLE_REF
																																																							(
																																																							((long) 16));
																																																						{	/* Ast/sexp.scm 256 */
																																																							obj_t
																																																								BgL_list3483z00_1254;
																																																							{	/* Ast/sexp.scm 256 */
																																																								obj_t
																																																									BgL_arg3484z00_1255;
																																																								{	/* Ast/sexp.scm 256 */
																																																									obj_t
																																																										BgL_arg3485z00_1256;
																																																									BgL_arg3485z00_1256
																																																										=
																																																										MAKE_PAIR
																																																										(BNIL,
																																																										BNIL);
																																																									BgL_arg3484z00_1255
																																																										=
																																																										MAKE_PAIR
																																																										(BgL_sinonz00_1155,
																																																										BgL_arg3485z00_1256);
																																																								}
																																																								BgL_list3483z00_1254
																																																									=
																																																									MAKE_PAIR
																																																									(BgL_alorsz00_1154,
																																																									BgL_arg3484z00_1255);
																																																							}
																																																							BgL_arg3482z00_1253
																																																								=
																																																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																								(BgL_testz00_1232,
																																																								BgL_list3483z00_1254);
																																																						}
																																																						BgL_arg3480z00_1251
																																																							=
																																																							MAKE_PAIR
																																																							(BgL_arg3481z00_1252,
																																																							BgL_arg3482z00_1253);
																																																					}
																																																					BgL_arg3466z00_1237
																																																						=
																																																						BGl_epairifyzd2reczd2zztools_miscz00
																																																						(BgL_arg3480z00_1251,
																																																						BgL_expz00_17);
																																																				}
																																																				{	/* Ast/sexp.scm 255 */
																																																					obj_t
																																																						BgL_list3468z00_1239;
																																																					{	/* Ast/sexp.scm 255 */
																																																						obj_t
																																																							BgL_arg3469z00_1240;
																																																						BgL_arg3469z00_1240
																																																							=
																																																							MAKE_PAIR
																																																							(BNIL,
																																																							BNIL);
																																																						BgL_list3468z00_1239
																																																							=
																																																							MAKE_PAIR
																																																							(BgL_arg3466z00_1237,
																																																							BgL_arg3469z00_1240);
																																																					}
																																																					BgL_arg3464z00_1235
																																																						=
																																																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																						(BgL_arg3465z00_1236,
																																																						BgL_list3468z00_1239);
																																																			}}
																																																			BgL_arg3462z00_1233
																																																				=
																																																				MAKE_PAIR
																																																				(BgL_arg3463z00_1234,
																																																				BgL_arg3464z00_1235);
																																																		}
																																																		BGl_replacez12z12zztools_miscz00
																																																			(BgL_expz00_17,
																																																			BgL_arg3462z00_1233);
																																																	}
																																																	BgL_auxz00_2854
																																																		=
																																																		(obj_t)
																																																		(BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																		(BgL_expz00_17,
																																																			BgL_stackz00_18,
																																																			BgL_locz00_19,
																																																			BgL_sitez00_20));
																																											}}}}
																																										else
																																											{	/* Ast/sexp.scm 85 */
																																												goto
																																													BgL_tagzd21955zd2_1182;
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 85 */
																																										goto
																																											BgL_tagzd21955zd2_1182;
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 85 */
																																								goto
																																									BgL_tagzd21955zd2_1182;
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 85 */
																																						goto
																																							BgL_tagzd21955zd2_1182;
																																					}
																																			}
																																		else
																																			{	/* Ast/sexp.scm 85 */
																																				goto
																																					BgL_tagzd21955zd2_1182;
																																			}
																																	}
																																else
																																	{	/* Ast/sexp.scm 85 */
																																		if (
																																			(CAR
																																				(BgL_siz00_1153)
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						17))))
																																			{	/* Ast/sexp.scm 85 */
																																				if (PAIRP(BgL_cdrzd21962zd2_1185))
																																					{	/* Ast/sexp.scm 85 */
																																						if (NULLP(CDR(BgL_cdrzd21962zd2_1185)))
																																							{	/* Ast/sexp.scm 85 */
																																								obj_t
																																									BgL_arg3446z00_1205;
																																								BgL_arg3446z00_1205
																																									=
																																									CAR
																																									(BgL_cdrzd21962zd2_1185);
																																								{	/* Ast/sexp.scm 85 */
																																									BgL_nodez00_bglt
																																										BgL_auxz00_2982;
																																									{
																																										obj_t
																																											BgL_siz00_2983;
																																										BgL_siz00_2983
																																											=
																																											BgL_arg3446z00_1205;
																																										BgL_siz00_1180
																																											=
																																											BgL_siz00_2983;
																																										goto
																																											BgL_tagzd21954zd2_1181;
																																									}
																																									BgL_auxz00_2854
																																										=
																																										(obj_t)
																																										(BgL_auxz00_2982);
																																								}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 85 */
																																								goto
																																									BgL_tagzd21955zd2_1182;
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 85 */
																																						goto
																																							BgL_tagzd21955zd2_1182;
																																					}
																																			}
																																		else
																																			{	/* Ast/sexp.scm 85 */
																																				goto
																																					BgL_tagzd21955zd2_1182;
																																			}
																																	}
																															}
																														else
																															{	/* Ast/sexp.scm 85 */
																																goto
																																	BgL_tagzd21955zd2_1182;
																															}
																													}
																												}
																											else
																												{	/* Ast/sexp.scm 85 */
																													BgL_nodez00_bglt
																														BgL_auxz00_2988;
																												BgL_tagzd21888zd2_1160:
																													BgL_auxz00_2988 =
																														BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																														(BGl_string3905z00zzast_sexpz00,
																														BgL_expz00_17,
																														BgL_locz00_19);
																													BgL_auxz00_2854 =
																														(obj_t)
																														(BgL_auxz00_2988);
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 85 */
																											obj_t
																												BgL_cdrzd21932zd2_1175;
																											BgL_cdrzd21932zd2_1175 =
																												CDR
																												(BgL_cdrzd21897zd2_1163);
																											if (NULLP(CDR
																													(BgL_cdrzd21932zd2_1175)))
																												{	/* Ast/sexp.scm 85 */
																													obj_t
																														BgL_arg3425z00_1177;
																													obj_t
																														BgL_arg3426z00_1178;
																													BgL_arg3425z00_1177 =
																														CAR
																														(BgL_cdrzd21897zd2_1163);
																													BgL_arg3426z00_1178 =
																														CAR
																														(BgL_cdrzd21932zd2_1175);
																													{	/* Ast/sexp.scm 85 */
																														BgL_nodez00_bglt
																															BgL_auxz00_2997;
																														BgL_siz00_1157 =
																															BgL_arg3425z00_1177;
																														BgL_alorsz00_1158 =
																															BgL_arg3426z00_1178;
																														{	/* Ast/sexp.scm 260 */
																															obj_t
																																BgL_arg3488z00_1259;
																															obj_t
																																BgL_arg3489z00_1260;
																															{	/* Ast/sexp.scm 260 */
																																obj_t
																																	BgL_pairz00_2327;
																																BgL_pairz00_2327
																																	=
																																	BgL_expz00_17;
																																BgL_arg3488z00_1259
																																	=
																																	CDR(CDR
																																	(BgL_pairz00_2327));
																															}
																															{	/* Ast/sexp.scm 260 */
																																obj_t
																																	BgL_list3490z00_1261;
																																BgL_list3490z00_1261
																																	=
																																	MAKE_PAIR
																																	(BUNSPEC,
																																	BNIL);
																																BgL_arg3489z00_1260
																																	=
																																	BgL_list3490z00_1261;
																															}
																															SET_CDR
																																(BgL_arg3488z00_1259,
																																BgL_arg3489z00_1260);
																														}
																														BgL_auxz00_2997 =
																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																															(BgL_expz00_17,
																															BgL_stackz00_18,
																															BgL_locz00_19,
																															BgL_sitez00_20);
																														BgL_auxz00_2854 =
																															(obj_t)
																															(BgL_auxz00_2997);
																													}
																												}
																											else
																												{	/* Ast/sexp.scm 85 */
																													BgL_nodez00_bglt
																														BgL_auxz00_3004;
																													goto
																														BgL_tagzd21888zd2_1160;
																													BgL_auxz00_2854 =
																														(obj_t)
																														(BgL_auxz00_3004);
																												}
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 85 */
																									BgL_nodez00_bglt
																										BgL_auxz00_3006;
																									goto BgL_tagzd21888zd2_1160;
																									BgL_auxz00_2854 =
																										(obj_t) (BgL_auxz00_3006);
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 85 */
																							BgL_nodez00_bglt BgL_auxz00_3008;

																							goto BgL_tagzd21888zd2_1160;
																							BgL_auxz00_2854 =
																								(obj_t) (BgL_auxz00_3008);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 85 */
																					BgL_nodez00_bglt BgL_auxz00_3010;

																					goto BgL_tagzd21888zd2_1160;
																					BgL_auxz00_2854 =
																						(obj_t) (BgL_auxz00_3010);
																				}
																		}
																		return (BgL_nodez00_bglt) (BgL_auxz00_2854);
																	}
																else
																	{	/* Ast/sexp.scm 85 */
																		if (
																			(CAR(BgL_expz00_17) ==
																				CNST_TABLE_REF(((long) 12))))
																			{	/* Ast/sexp.scm 85 */
																				obj_t BgL_auxz00_3017;

																				{
																					obj_t BgL_varz00_1262;

																					obj_t BgL_valz00_1263;

																					if (PAIRP(BgL_expz00_17))
																						{	/* Ast/sexp.scm 85 */
																							obj_t BgL_cdrzd21993zd2_1268;

																							BgL_cdrzd21993zd2_1268 =
																								CDR(BgL_expz00_17);
																							if (PAIRP(BgL_cdrzd21993zd2_1268))
																								{	/* Ast/sexp.scm 85 */
																									obj_t BgL_cdrzd21997zd2_1270;

																									BgL_cdrzd21997zd2_1270 =
																										CDR(BgL_cdrzd21993zd2_1268);
																									if (PAIRP
																										(BgL_cdrzd21997zd2_1270))
																										{	/* Ast/sexp.scm 85 */
																											if (NULLP(CDR
																													(BgL_cdrzd21997zd2_1270)))
																												{	/* Ast/sexp.scm 85 */
																													BgL_varz00_1262 =
																														CAR
																														(BgL_cdrzd21993zd2_1268);
																													BgL_valz00_1263 =
																														CAR
																														(BgL_cdrzd21997zd2_1270);
																													{	/* Ast/sexp.scm 268 */
																														obj_t
																															BgL_locz00_1276;
																														BgL_locz00_1276 =
																															BGl_findzd2locationzf2locz20zztools_locationz00
																															(BgL_expz00_17,
																															BgL_locz00_19);
																														{	/* Ast/sexp.scm 268 */
																															obj_t
																																BgL_cdlocz00_1277;
																															BgL_cdlocz00_1277
																																=
																																BGl_findzd2locationzf2locz20zztools_locationz00
																																(CDR
																																(BgL_expz00_17),
																																BgL_locz00_1276);
																															{	/* Ast/sexp.scm 269 */
																																obj_t
																																	BgL_cddlocz00_1278;
																																{	/* Ast/sexp.scm 270 */
																																	obj_t
																																		BgL_arg3503z00_1288;
																																	{	/* Ast/sexp.scm 270 */
																																		obj_t
																																			BgL_pairz00_2345;
																																		BgL_pairz00_2345
																																			=
																																			BgL_expz00_17;
																																		BgL_arg3503z00_1288
																																			=
																																			CDR(CDR
																																			(BgL_pairz00_2345));
																																	}
																																	BgL_cddlocz00_1278
																																		=
																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																		(BgL_arg3503z00_1288,
																																		BgL_locz00_1276);
																																}
																																{	/* Ast/sexp.scm 270 */
																																	obj_t
																																		BgL_valzd2loczd2_1279;
																																	BgL_valzd2loczd2_1279
																																		=
																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																		(BgL_valz00_1263,
																																		BgL_cddlocz00_1278);
																																	{	/* Ast/sexp.scm 271 */
																																		BgL_nodez00_bglt
																																			BgL_valz00_1280;
																																		BgL_valz00_1280
																																			=
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																			(BgL_valz00_1263,
																																			BgL_stackz00_18,
																																			BgL_valzd2loczd2_1279,
																																			CNST_TABLE_REF
																																			(((long)
																																					1)));
																																		{	/* Ast/sexp.scm 272 */

																																			{	/* Ast/sexp.scm 273 */
																																				BgL_nodez00_bglt
																																					BgL_astz00_1281;
																																				BgL_astz00_1281
																																					=
																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																					(BgL_varz00_1262,
																																					BgL_stackz00_18,
																																					BgL_cdlocz00_1277,
																																					CNST_TABLE_REF
																																					(((long) 12)));
																																				{	/* Ast/sexp.scm 274 */
																																					bool_t
																																						BgL_testz00_3040;
																																					{	/* Ast/sexp.scm 274 */
																																						obj_t
																																							BgL_obj2088z00_2349;
																																						BgL_obj2088z00_2349
																																							=
																																							(obj_t)
																																							(BgL_astz00_1281);
																																						BgL_testz00_3040
																																							=
																																							BGl_iszd2azf3z21zz__objectz00
																																							(BgL_obj2088z00_2349,
																																							BGl_varz00zzast_nodez00);
																																					}
																																					if (BgL_testz00_3040)
																																						{	/* Ast/sexp.scm 276 */
																																							bool_t
																																								BgL_testz00_3043;
																																							{	/* Ast/sexp.scm 276 */
																																								bool_t
																																									BgL_testz00_3044;
																																								{	/* Ast/sexp.scm 276 */
																																									BgL_variablez00_bglt
																																										BgL_arg3502z00_1287;
																																									{
																																										BgL_varz00_bglt
																																											BgL_auxz00_3045;
																																										BgL_auxz00_3045
																																											=
																																											(BgL_varz00_bglt)
																																											(BgL_astz00_1281);
																																										BgL_arg3502z00_1287
																																											=
																																											(
																																											((BgL_varz00_bglt) CREF(BgL_auxz00_3045))->BgL_variablez00);
																																									}
																																									{	/* Ast/sexp.scm 276 */
																																										obj_t
																																											BgL_obj1671z00_2351;
																																										BgL_obj1671z00_2351
																																											=
																																											(obj_t)
																																											(BgL_arg3502z00_1287);
																																										BgL_testz00_3044
																																											=
																																											BGl_iszd2azf3z21zz__objectz00
																																											(BgL_obj1671z00_2351,
																																											BGl_globalz00zzast_varz00);
																																									}
																																								}
																																								if (BgL_testz00_3044)
																																									{	/* Ast/sexp.scm 277 */
																																										BgL_variablez00_bglt
																																											BgL_arg3501z00_1286;
																																										{
																																											BgL_varz00_bglt
																																												BgL_auxz00_3050;
																																											BgL_auxz00_3050
																																												=
																																												(BgL_varz00_bglt)
																																												(BgL_astz00_1281);
																																											BgL_arg3501z00_1286
																																												=
																																												(
																																												((BgL_varz00_bglt) CREF(BgL_auxz00_3050))->BgL_variablez00);
																																										}
																																										BgL_testz00_3043
																																											=
																																											BGl_globalzd2readzd2onlyzf3zf3zzast_varz00
																																											(
																																											(BgL_globalz00_bglt)
																																											(BgL_arg3501z00_1286));
																																									}
																																								else
																																									{	/* Ast/sexp.scm 276 */
																																										BgL_testz00_3043
																																											=
																																											(
																																											(bool_t)
																																											0);
																																									}
																																							}
																																							if (BgL_testz00_3043)
																																								{	/* Ast/sexp.scm 276 */
																																									BgL_auxz00_3017
																																										=
																																										(obj_t)
																																										(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																										(BGl_string3903z00zzast_sexpz00,
																																											BgL_expz00_17,
																																											BgL_cdlocz00_1277));
																																								}
																																							else
																																								{	/* Ast/sexp.scm 276 */
																																									BgL_auxz00_3017
																																										=
																																										(obj_t)
																																										(BGl_makezd2setqzd2zzast_nodez00
																																										(BgL_locz00_1276,
																																											(BgL_typez00_bglt)
																																											(BGl_za2unspecza2z00zztype_cachez00),
																																											(BgL_varz00_bglt)
																																											(BgL_astz00_1281),
																																											BgL_valz00_1280));
																																								}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 274 */
																																							BgL_auxz00_3017
																																								=
																																								(obj_t)
																																								(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																								(BGl_string3904z00zzast_sexpz00,
																																									BgL_expz00_17,
																																									BgL_locz00_1276));
																																						}
																																				}
																																			}
																																		}
																																	}
																																}
																															}
																														}
																													}
																												}
																											else
																												{	/* Ast/sexp.scm 85 */
																													BgL_nodez00_bglt
																														BgL_auxz00_3065;
																												BgL_tagzd21986zd2_1265:
																													BgL_auxz00_3065 =
																														BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																														(BGl_string3902z00zzast_sexpz00,
																														BgL_expz00_17,
																														BGl_findzd2locationzf2locz20zztools_locationz00
																														(BgL_expz00_17,
																															BgL_locz00_19));
																													BgL_auxz00_3017 =
																														(obj_t)
																														(BgL_auxz00_3065);
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 85 */
																											BgL_nodez00_bglt
																												BgL_auxz00_3069;
																											goto
																												BgL_tagzd21986zd2_1265;
																											BgL_auxz00_3017 =
																												(obj_t)
																												(BgL_auxz00_3069);
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 85 */
																									BgL_nodez00_bglt
																										BgL_auxz00_3071;
																									goto BgL_tagzd21986zd2_1265;
																									BgL_auxz00_3017 =
																										(obj_t) (BgL_auxz00_3071);
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 85 */
																							BgL_nodez00_bglt BgL_auxz00_3073;

																							goto BgL_tagzd21986zd2_1265;
																							BgL_auxz00_3017 =
																								(obj_t) (BgL_auxz00_3073);
																						}
																				}
																				return
																					(BgL_nodez00_bglt) (BgL_auxz00_3017);
																			}
																		else
																			{	/* Ast/sexp.scm 85 */
																				if (
																					(CAR(BgL_expz00_17) ==
																						CNST_TABLE_REF(((long) 24))))
																					{	/* Ast/sexp.scm 85 */
																						obj_t BgL_auxz00_3080;

																						{
																							obj_t BgL_varz00_1292;

																							obj_t BgL_valz00_1293;

																							if (PAIRP(BgL_expz00_17))
																								{	/* Ast/sexp.scm 85 */
																									obj_t BgL_cdrzd22011zd2_1298;

																									BgL_cdrzd22011zd2_1298 =
																										CDR(BgL_expz00_17);
																									if (PAIRP
																										(BgL_cdrzd22011zd2_1298))
																										{	/* Ast/sexp.scm 85 */
																											obj_t
																												BgL_cdrzd22015zd2_1300;
																											BgL_cdrzd22015zd2_1300 =
																												CDR
																												(BgL_cdrzd22011zd2_1298);
																											if (PAIRP
																												(BgL_cdrzd22015zd2_1300))
																												{	/* Ast/sexp.scm 85 */
																													if (NULLP(CDR
																															(BgL_cdrzd22015zd2_1300)))
																														{	/* Ast/sexp.scm 85 */
																															BgL_varz00_1292 =
																																CAR
																																(BgL_cdrzd22011zd2_1298);
																															BgL_valz00_1293 =
																																CAR
																																(BgL_cdrzd22015zd2_1300);
																															{	/* Ast/sexp.scm 299 */
																																obj_t
																																	BgL_locz00_1306;
																																BgL_locz00_1306
																																	=
																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																	(BgL_expz00_17,
																																	BgL_locz00_19);
																																{	/* Ast/sexp.scm 299 */
																																	obj_t
																																		BgL_cdlocz00_1307;
																																	BgL_cdlocz00_1307
																																		=
																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																		(CDR
																																		(BgL_expz00_17),
																																		BgL_locz00_1306);
																																	{	/* Ast/sexp.scm 300 */
																																		obj_t
																																			BgL_cddlocz00_1308;
																																		{	/* Ast/sexp.scm 301 */
																																			obj_t
																																				BgL_arg3520z00_1316;
																																			{	/* Ast/sexp.scm 301 */
																																				obj_t
																																					BgL_pairz00_2363;
																																				BgL_pairz00_2363
																																					=
																																					BgL_expz00_17;
																																				BgL_arg3520z00_1316
																																					=
																																					CDR
																																					(CDR
																																					(BgL_pairz00_2363));
																																			}
																																			BgL_cddlocz00_1308
																																				=
																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																				(BgL_arg3520z00_1316,
																																				BgL_locz00_1306);
																																		}
																																		{	/* Ast/sexp.scm 301 */
																																			obj_t
																																				BgL_valzd2loczd2_1309;
																																			BgL_valzd2loczd2_1309
																																				=
																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																				(BgL_valz00_1293,
																																				BgL_cddlocz00_1308);
																																			{	/* Ast/sexp.scm 302 */
																																				BgL_nodez00_bglt
																																					BgL_valz00_1310;
																																				BgL_valz00_1310
																																					=
																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																					(BgL_valz00_1293,
																																					BgL_stackz00_18,
																																					BgL_valzd2loczd2_1309,
																																					CNST_TABLE_REF
																																					(((long) 1)));
																																				{	/* Ast/sexp.scm 303 */

																																					{	/* Ast/sexp.scm 304 */
																																						BgL_nodez00_bglt
																																							BgL_astz00_1311;
																																						BgL_astz00_1311
																																							=
																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																							(BgL_varz00_1292,
																																							BgL_stackz00_18,
																																							BgL_cdlocz00_1307,
																																							CNST_TABLE_REF
																																							(((long) 1)));
																																						{	/* Ast/sexp.scm 305 */
																																							bool_t
																																								BgL_testz00_3103;
																																							{	/* Ast/sexp.scm 305 */
																																								bool_t
																																									BgL_testz00_3104;
																																								{	/* Ast/sexp.scm 305 */
																																									obj_t
																																										BgL_obj2088z00_2367;
																																									BgL_obj2088z00_2367
																																										=
																																										(obj_t)
																																										(BgL_astz00_1311);
																																									BgL_testz00_3104
																																										=
																																										BGl_iszd2azf3z21zz__objectz00
																																										(BgL_obj2088z00_2367,
																																										BGl_varz00zzast_nodez00);
																																								}
																																								if (BgL_testz00_3104)
																																									{	/* Ast/sexp.scm 305 */
																																										BgL_variablez00_bglt
																																											BgL_arg3519z00_1315;
																																										{
																																											BgL_varz00_bglt
																																												BgL_auxz00_3107;
																																											BgL_auxz00_3107
																																												=
																																												(BgL_varz00_bglt)
																																												(BgL_astz00_1311);
																																											BgL_arg3519z00_1315
																																												=
																																												(
																																												((BgL_varz00_bglt) CREF(BgL_auxz00_3107))->BgL_variablez00);
																																										}
																																										{	/* Ast/sexp.scm 305 */
																																											obj_t
																																												BgL_obj1671z00_2369;
																																											BgL_obj1671z00_2369
																																												=
																																												(obj_t)
																																												(BgL_arg3519z00_1315);
																																											BgL_testz00_3103
																																												=
																																												BGl_iszd2azf3z21zz__objectz00
																																												(BgL_obj1671z00_2369,
																																												BGl_globalz00zzast_varz00);
																																										}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 305 */
																																										BgL_testz00_3103
																																											=
																																											(
																																											(bool_t)
																																											0);
																																									}
																																							}
																																							if (BgL_testz00_3103)
																																								{	/* Ast/sexp.scm 305 */
																																									{	/* Ast/sexp.scm 307 */
																																										BgL_variablez00_bglt
																																											BgL_arg3517z00_1313;
																																										{
																																											BgL_varz00_bglt
																																												BgL_auxz00_3112;
																																											BgL_auxz00_3112
																																												=
																																												(BgL_varz00_bglt)
																																												(BgL_astz00_1311);
																																											BgL_arg3517z00_1313
																																												=
																																												(
																																												((BgL_varz00_bglt) CREF(BgL_auxz00_3112))->BgL_variablez00);
																																										}
																																										{
																																											obj_t
																																												BgL_auxz00_3117;
																																											BgL_globalz00_bglt
																																												BgL_auxz00_3115;
																																											BgL_auxz00_3117
																																												=
																																												(obj_t)
																																												(BgL_valz00_1310);
																																											BgL_auxz00_3115
																																												=
																																												(BgL_globalz00_bglt)
																																												(BgL_arg3517z00_1313);
																																											((((BgL_globalz00_bglt) CREF(BgL_auxz00_3115))->BgL_srcz00) = ((obj_t) BgL_auxz00_3117), BUNSPEC);
																																										}
																																									}
																																									BgL_auxz00_3080
																																										=
																																										(obj_t)
																																										(BGl_makezd2setqzd2zzast_nodez00
																																										(BgL_locz00_1306,
																																											(BgL_typez00_bglt)
																																											(BGl_za2unspecza2z00zztype_cachez00),
																																											(BgL_varz00_bglt)
																																											(BgL_astz00_1311),
																																											BgL_valz00_1310));
																																								}
																																							else
																																								{	/* Ast/sexp.scm 305 */
																																									BgL_auxz00_3080
																																										=
																																										(obj_t)
																																										(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																										(BGl_string3901z00zzast_sexpz00,
																																											BgL_expz00_17,
																																											BgL_locz00_1306));
																																								}
																																						}
																																					}
																																				}
																																			}
																																		}
																																	}
																																}
																															}
																														}
																													else
																														{	/* Ast/sexp.scm 85 */
																															BgL_nodez00_bglt
																																BgL_auxz00_3128;
																														BgL_tagzd22004zd2_1295:
																															BgL_auxz00_3128 =
																																BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																(BGl_string3900z00zzast_sexpz00,
																																BgL_expz00_17,
																																BGl_findzd2locationzf2locz20zztools_locationz00
																																(BgL_expz00_17,
																																	BgL_locz00_19));
																															BgL_auxz00_3080 =
																																(obj_t)
																																(BgL_auxz00_3128);
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 85 */
																													BgL_nodez00_bglt
																														BgL_auxz00_3132;
																													goto
																														BgL_tagzd22004zd2_1295;
																													BgL_auxz00_3080 =
																														(obj_t)
																														(BgL_auxz00_3132);
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 85 */
																											BgL_nodez00_bglt
																												BgL_auxz00_3134;
																											goto
																												BgL_tagzd22004zd2_1295;
																											BgL_auxz00_3080 =
																												(obj_t)
																												(BgL_auxz00_3134);
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 85 */
																									BgL_nodez00_bglt
																										BgL_auxz00_3136;
																									goto BgL_tagzd22004zd2_1295;
																									BgL_auxz00_3080 =
																										(obj_t) (BgL_auxz00_3136);
																								}
																						}
																						return
																							(BgL_nodez00_bglt)
																							(BgL_auxz00_3080);
																					}
																				else
																					{	/* Ast/sexp.scm 85 */
																						obj_t BgL_carzd21563zd2_920;

																						BgL_carzd21563zd2_920 =
																							CAR(BgL_expz00_17);
																						if (PAIRP(BgL_carzd21563zd2_920))
																							{	/* Ast/sexp.scm 85 */
																								obj_t BgL_carzd21566zd2_922;

																								obj_t BgL_cdrzd21567zd2_923;

																								BgL_carzd21566zd2_922 =
																									CAR(BgL_carzd21563zd2_920);
																								BgL_cdrzd21567zd2_923 =
																									CDR(BgL_carzd21563zd2_920);
																								{

																									if (
																										(BgL_carzd21566zd2_922 ==
																											CNST_TABLE_REF(((long)
																													11))))
																										{	/* Ast/sexp.scm 85 */
																											obj_t BgL_auxz00_3147;

																										BgL_kapzd21568zd2_924:
																											if (PAIRP
																												(BgL_cdrzd21567zd2_923))
																												{	/* Ast/sexp.scm 85 */
																													obj_t
																														BgL_cdrzd21571zd2_941;
																													BgL_cdrzd21571zd2_941
																														=
																														CDR
																														(BgL_cdrzd21567zd2_923);
																													if (PAIRP
																														(BgL_cdrzd21571zd2_941))
																														{	/* Ast/sexp.scm 85 */
																															if (NULLP(CDR
																																	(BgL_cdrzd21571zd2_941)))
																																{	/* Ast/sexp.scm 85 */
																																	obj_t
																																		BgL_arg3236z00_944;
																																	obj_t
																																		BgL_arg3237z00_945;
																																	BgL_arg3236z00_944
																																		=
																																		CAR
																																		(BgL_cdrzd21571zd2_941);
																																	BgL_arg3237z00_945
																																		=
																																		CDR
																																		(BgL_expz00_17);
																																	{	/* Ast/sexp.scm 85 */
																																		BgL_nodez00_bglt
																																			BgL_auxz00_3158;
																																		BgL_bodyz00_883
																																			=
																																			BgL_arg3236z00_944;
																																		BgL_argsz00_884
																																			=
																																			BgL_arg3237z00_945;
																																		{	/* Ast/sexp.scm 322 */
																																			obj_t
																																				BgL_letzd2partzd2_1320;
																																			BgL_letzd2partzd2_1320
																																				=
																																				CAR
																																				(BgL_expz00_17);
																																			{	/* Ast/sexp.scm 322 */
																																				obj_t
																																					BgL_nexpz00_1321;
																																				{	/* Ast/sexp.scm 323 */
																																					obj_t
																																						BgL_arg3525z00_1322;
																																					obj_t
																																						BgL_arg3526z00_1323;
																																					BgL_arg3525z00_1322
																																						=
																																						CAR
																																						(BgL_letzd2partzd2_1320);
																																					{	/* Ast/sexp.scm 323 */
																																						obj_t
																																							BgL_arg3527z00_1324;
																																						obj_t
																																							BgL_arg3528z00_1325;
																																						{	/* Ast/sexp.scm 323 */
																																							obj_t
																																								BgL_pairz00_2375;
																																							BgL_pairz00_2375
																																								=
																																								BgL_letzd2partzd2_1320;
																																							BgL_arg3527z00_1324
																																								=
																																								CAR
																																								(CDR
																																								(BgL_pairz00_2375));
																																						}
																																						BgL_arg3528z00_1325
																																							=
																																							MAKE_PAIR
																																							(BgL_bodyz00_883,
																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																							(BgL_argsz00_884,
																																								BNIL));
																																						{	/* Ast/sexp.scm 323 */
																																							obj_t
																																								BgL_list3530z00_1327;
																																							{	/* Ast/sexp.scm 323 */
																																								obj_t
																																									BgL_arg3531z00_1328;
																																								BgL_arg3531z00_1328
																																									=
																																									MAKE_PAIR
																																									(BNIL,
																																									BNIL);
																																								BgL_list3530z00_1327
																																									=
																																									MAKE_PAIR
																																									(BgL_arg3528z00_1325,
																																									BgL_arg3531z00_1328);
																																							}
																																							BgL_arg3526z00_1323
																																								=
																																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																								(BgL_arg3527z00_1324,
																																								BgL_list3530z00_1327);
																																						}
																																					}
																																					BgL_nexpz00_1321
																																						=
																																						MAKE_PAIR
																																						(BgL_arg3525z00_1322,
																																						BgL_arg3526z00_1323);
																																				}
																																				{	/* Ast/sexp.scm 323 */

																																					BgL_auxz00_3158
																																						=
																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																						(BgL_nexpz00_1321,
																																						BgL_stackz00_18,
																																						BgL_locz00_19,
																																						BgL_sitez00_20);
																																				}
																																			}
																																		}
																																		BgL_auxz00_3147
																																			=
																																			(obj_t)
																																			(BgL_auxz00_3158);
																																	}
																																}
																															else
																																{	/* Ast/sexp.scm 85 */
																																	obj_t
																																		BgL_carzd21598zd2_946;
																																	BgL_carzd21598zd2_946
																																		=
																																		CAR
																																		(BgL_expz00_17);
																																	{	/* Ast/sexp.scm 85 */
																																		obj_t
																																			BgL_cdrzd21603zd2_947;
																																		BgL_cdrzd21603zd2_947
																																			=
																																			CDR
																																			(BgL_carzd21598zd2_946);
																																		if ((CAR
																																				(BgL_carzd21598zd2_946)
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						8))))
																																			{	/* Ast/sexp.scm 85 */
																																				obj_t
																																					BgL_arg3239z00_949;
																																				obj_t
																																					BgL_arg3240z00_950;
																																				obj_t
																																					BgL_arg3241z00_951;
																																				BgL_arg3239z00_949
																																					=
																																					CAR
																																					(BgL_cdrzd21603zd2_947);
																																				BgL_arg3240z00_950
																																					=
																																					CDR
																																					(BgL_cdrzd21603zd2_947);
																																				BgL_arg3241z00_951
																																					=
																																					CDR
																																					(BgL_expz00_17);
																																				{	/* Ast/sexp.scm 85 */
																																					BgL_nodez00_bglt
																																						BgL_auxz00_3180;
																																					BgL_varsz00_888
																																						=
																																						BgL_arg3239z00_949;
																																					BgL_bodyz00_889
																																						=
																																						BgL_arg3240z00_950;
																																					BgL_argsz00_890
																																						=
																																						BgL_arg3241z00_951;
																																				BgL_tagzd21475zd2_891:
																																					{	/* Ast/sexp.scm 333 */
																																						obj_t
																																							BgL_locz00_1330;
																																						BgL_locz00_1330
																																							=
																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																							(BgL_expz00_17,
																																							BgL_locz00_19);
																																						{	/* Ast/sexp.scm 334 */
																																							obj_t
																																								BgL_arg3533z00_1331;
																																							{	/* Ast/sexp.scm 334 */
																																								obj_t
																																									BgL_arg3535z00_1332;
																																								obj_t
																																									BgL_arg3536z00_1333;
																																								BgL_arg3535z00_1332
																																									=
																																									CNST_TABLE_REF
																																									(
																																									((long) 11));
																																								{	/* Ast/sexp.scm 334 */
																																									obj_t
																																										BgL_arg3537z00_1334;
																																									obj_t
																																										BgL_arg3538z00_1335;
																																									BgL_arg3537z00_1334
																																										=
																																										BGl_loopz00zzast_sexpz00
																																										(BgL_expz00_17,
																																										BgL_locz00_1330,
																																										BgL_varsz00_888,
																																										BgL_argsz00_890);
																																									{	/* Ast/sexp.scm 376 */
																																										obj_t
																																											BgL_arg3586z00_1388;
																																										obj_t
																																											BgL_arg3587z00_1389;
																																										BgL_arg3586z00_1388
																																											=
																																											BGl_shapez00zztools_shapez00
																																											(BGl_currentzd2functionzd2zztools_errorz00
																																											());
																																										BgL_arg3587z00_1389
																																											=
																																											BGl_normaliza7ezd2prognz75zztools_prognz00
																																											(BgL_bodyz00_889);
																																										{	/* Ast/sexp.scm 380 */
																																											obj_t
																																												BgL_zc3anonymousza33590ze3z83_2563;
																																											BgL_zc3anonymousza33590ze3z83_2563
																																												=
																																												make_fx_procedure
																																												(BGl_zc3anonymousza33590ze3z83zzast_sexpz00,
																																												(int)
																																												(((long) 3)), (int) (((long) 1)));
																																											PROCEDURE_SET
																																												(BgL_zc3anonymousza33590ze3z83_2563,
																																												(int)
																																												(((long) 0)), BgL_locz00_1330);
																																											BgL_arg3538z00_1335
																																												=
																																												BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
																																												(BgL_arg3586z00_1388,
																																												BgL_varsz00_888,
																																												BgL_arg3587z00_1389,
																																												BgL_zc3anonymousza33590ze3z83_2563);
																																									}}
																																									{	/* Ast/sexp.scm 334 */
																																										obj_t
																																											BgL_list3540z00_1337;
																																										{	/* Ast/sexp.scm 334 */
																																											obj_t
																																												BgL_arg3541z00_1338;
																																											BgL_arg3541z00_1338
																																												=
																																												MAKE_PAIR
																																												(BNIL,
																																												BNIL);
																																											BgL_list3540z00_1337
																																												=
																																												MAKE_PAIR
																																												(BgL_arg3538z00_1335,
																																												BgL_arg3541z00_1338);
																																										}
																																										BgL_arg3536z00_1333
																																											=
																																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																											(BgL_arg3537z00_1334,
																																											BgL_list3540z00_1337);
																																								}}
																																								BgL_arg3533z00_1331
																																									=
																																									MAKE_PAIR
																																									(BgL_arg3535z00_1332,
																																									BgL_arg3536z00_1333);
																																							}
																																							BgL_auxz00_3180
																																								=
																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																								(BgL_arg3533z00_1331,
																																								BgL_stackz00_18,
																																								BgL_locz00_1330,
																																								BgL_sitez00_20);
																																					}}
																																					BgL_auxz00_3147
																																						=
																																						(obj_t)
																																						(BgL_auxz00_3180);
																																			}}
																																		else
																																			{	/* Ast/sexp.scm 85 */
																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																					{	/* Ast/sexp.scm 85 */
																																					BgL_tagzd21487zd2_907:
																																						BgL_auxz00_3147 = BGl_privatezd2ze3nodez31zzast_privatez00(BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 85 */
																																						BgL_nodez00_bglt
																																							BgL_auxz00_3202;
																																					BgL_tagzd21488zd2_908:
																																						{	/* Ast/sexp.scm 505 */
																																							obj_t
																																								BgL_callerz00_1520;
																																							obj_t
																																								BgL_locz00_1521;
																																							BgL_callerz00_1520
																																								=
																																								CAR
																																								(BgL_expz00_17);
																																							BgL_locz00_1521
																																								=
																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																								(BgL_expz00_17,
																																								BgL_locz00_19);
																																							if (SYMBOLP(BgL_callerz00_1520))
																																								{	/* Ast/sexp.scm 509 */
																																									obj_t
																																										BgL_pidz00_1523;
																																									BgL_pidz00_1523
																																										=
																																										BGl_parsezd2idzd2zzast_identz00
																																										(BgL_callerz00_1520,
																																										BgL_locz00_1521);
																																									{	/* Ast/sexp.scm 509 */
																																										obj_t
																																											BgL_idz00_1524;
																																										BgL_idz00_1524
																																											=
																																											CAR
																																											(BgL_pidz00_1523);
																																										{	/* Ast/sexp.scm 510 */
																																											obj_t
																																												BgL_typez00_1525;
																																											BgL_typez00_1525
																																												=
																																												CDR
																																												(BgL_pidz00_1523);
																																											{	/* Ast/sexp.scm 511 */

																																												if ((BgL_idz00_1524 == CNST_TABLE_REF(((long) 2))))
																																													{	/* Ast/sexp.scm 512 */
																																														BgL_auxz00_3202
																																															=
																																															BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																															(
																																															((bool_t) 0), BFALSE, (BgL_typez00_bglt) (BgL_typez00_1525), BgL_expz00_17, BgL_stackz00_18, BgL_locz00_1521, BgL_sitez00_20);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 512 */
																																														if ((BgL_idz00_1524 == CNST_TABLE_REF(((long) 3))))
																																															{	/* Ast/sexp.scm 516 */
																																																bool_t
																																																	BgL_testz00_3218;
																																																{	/* Ast/sexp.scm 516 */
																																																	obj_t
																																																		BgL_auxz00_3219;
																																																	BgL_auxz00_3219
																																																		=
																																																		CDR
																																																		(BgL_expz00_17);
																																																	BgL_testz00_3218
																																																		=
																																																		PAIRP
																																																		(BgL_auxz00_3219);
																																																}
																																																if (BgL_testz00_3218)
																																																	{	/* Ast/sexp.scm 520 */
																																																		BgL_feffectz00_bglt
																																																			BgL_arg3676z00_1530;
																																																		obj_t
																																																			BgL_arg3677z00_1531;
																																																		{	/* Ast/sexp.scm 520 */
																																																			obj_t
																																																				BgL_arg3678z00_1532;
																																																			{	/* Ast/sexp.scm 520 */
																																																				obj_t
																																																					BgL_pairz00_2457;
																																																				BgL_pairz00_2457
																																																					=
																																																					BgL_expz00_17;
																																																				BgL_arg3678z00_1532
																																																					=
																																																					CAR
																																																					(CDR
																																																					(BgL_pairz00_2457));
																																																			}
																																																			BgL_arg3676z00_1530
																																																				=
																																																				BGl_parsezd2effectzd2zzeffect_feffectz00
																																																				(BgL_arg3678z00_1532);
																																																		}
																																																		{	/* Ast/sexp.scm 521 */
																																																			obj_t
																																																				BgL_arg3679z00_1533;
																																																			obj_t
																																																				BgL_arg3680z00_1534;
																																																			{	/* Ast/sexp.scm 521 */
																																																				obj_t
																																																					BgL_arg3681z00_1535;
																																																				obj_t
																																																					BgL_arg3682z00_1536;
																																																				BgL_arg3681z00_1535
																																																					=
																																																					CNST_TABLE_REF
																																																					(
																																																					((long) 4));
																																																				{	/* Ast/sexp.scm 521 */
																																																					obj_t
																																																						BgL_list3683z00_1537;
																																																					BgL_list3683z00_1537
																																																						=
																																																						MAKE_PAIR
																																																						(BNIL,
																																																						BNIL);
																																																					BgL_arg3682z00_1536
																																																						=
																																																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																						(CNST_TABLE_REF
																																																						(((long) 5)), BgL_list3683z00_1537);
																																																				}
																																																				BgL_arg3679z00_1533
																																																					=
																																																					MAKE_PAIR
																																																					(BgL_arg3681z00_1535,
																																																					BgL_arg3682z00_1536);
																																																			}
																																																			{	/* Ast/sexp.scm 521 */
																																																				obj_t
																																																					BgL_auxz00_3230;
																																																				{	/* Ast/sexp.scm 521 */
																																																					obj_t
																																																						BgL_pairz00_2461;
																																																					BgL_pairz00_2461
																																																						=
																																																						BgL_expz00_17;
																																																					BgL_auxz00_3230
																																																						=
																																																						CDR
																																																						(CDR
																																																						(BgL_pairz00_2461));
																																																				}
																																																				BgL_arg3680z00_1534
																																																					=
																																																					BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																					(BgL_auxz00_3230,
																																																					BNIL);
																																																			}
																																																			BgL_arg3677z00_1531
																																																				=
																																																				MAKE_PAIR
																																																				(BgL_arg3679z00_1533,
																																																				BgL_arg3680z00_1534);
																																																		}
																																																		BgL_auxz00_3202
																																																			=
																																																			BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																			(
																																																			((bool_t) 0), (obj_t) (BgL_arg3676z00_1530), (BgL_typez00_bglt) (BgL_typez00_1525), BgL_arg3677z00_1531, BgL_stackz00_18, BgL_locz00_1521, BgL_sitez00_20);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 516 */
																																																		BgL_auxz00_3202
																																																			=
																																																			BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																																			(BGl_string3894z00zzast_sexpz00,
																																																			BgL_expz00_17,
																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																			(BgL_expz00_17,
																																																				BgL_locz00_1521));
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 512 */
																																																if ((BgL_idz00_1524 == CNST_TABLE_REF(((long) 6))))
																																																	{	/* Ast/sexp.scm 512 */
																																																		BgL_auxz00_3202
																																																			=
																																																			BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																			(
																																																			((bool_t) 1), BFALSE, (BgL_typez00_bglt) (BgL_typez00_1525), BgL_expz00_17, BgL_stackz00_18, BgL_locz00_1521, BgL_sitez00_20);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 512 */
																																																		if ((BgL_idz00_1524 == CNST_TABLE_REF(((long) 7))))
																																																			{	/* Ast/sexp.scm 526 */
																																																				bool_t
																																																					BgL_testz00_3248;
																																																				{	/* Ast/sexp.scm 526 */
																																																					obj_t
																																																						BgL_auxz00_3249;
																																																					BgL_auxz00_3249
																																																						=
																																																						CDR
																																																						(BgL_expz00_17);
																																																					BgL_testz00_3248
																																																						=
																																																						PAIRP
																																																						(BgL_auxz00_3249);
																																																				}
																																																				if (BgL_testz00_3248)
																																																					{	/* Ast/sexp.scm 530 */
																																																						BgL_feffectz00_bglt
																																																							BgL_arg3692z00_1546;
																																																						obj_t
																																																							BgL_arg3693z00_1547;
																																																						{	/* Ast/sexp.scm 530 */
																																																							obj_t
																																																								BgL_arg3694z00_1548;
																																																							{	/* Ast/sexp.scm 530 */
																																																								obj_t
																																																									BgL_pairz00_2471;
																																																								BgL_pairz00_2471
																																																									=
																																																									BgL_expz00_17;
																																																								BgL_arg3694z00_1548
																																																									=
																																																									CAR
																																																									(CDR
																																																									(BgL_pairz00_2471));
																																																							}
																																																							BgL_arg3692z00_1546
																																																								=
																																																								BGl_parsezd2effectzd2zzeffect_feffectz00
																																																								(BgL_arg3694z00_1548);
																																																						}
																																																						{	/* Ast/sexp.scm 531 */
																																																							obj_t
																																																								BgL_arg3695z00_1549;
																																																							obj_t
																																																								BgL_arg3696z00_1550;
																																																							{	/* Ast/sexp.scm 531 */
																																																								obj_t
																																																									BgL_arg3697z00_1551;
																																																								obj_t
																																																									BgL_arg3698z00_1552;
																																																								BgL_arg3697z00_1551
																																																									=
																																																									CNST_TABLE_REF
																																																									(
																																																									((long) 4));
																																																								{	/* Ast/sexp.scm 531 */
																																																									obj_t
																																																										BgL_list3699z00_1553;
																																																									BgL_list3699z00_1553
																																																										=
																																																										MAKE_PAIR
																																																										(BNIL,
																																																										BNIL);
																																																									BgL_arg3698z00_1552
																																																										=
																																																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																										(CNST_TABLE_REF
																																																										(((long) 5)), BgL_list3699z00_1553);
																																																								}
																																																								BgL_arg3695z00_1549
																																																									=
																																																									MAKE_PAIR
																																																									(BgL_arg3697z00_1551,
																																																									BgL_arg3698z00_1552);
																																																							}
																																																							{	/* Ast/sexp.scm 531 */
																																																								obj_t
																																																									BgL_auxz00_3260;
																																																								{	/* Ast/sexp.scm 531 */
																																																									obj_t
																																																										BgL_pairz00_2475;
																																																									BgL_pairz00_2475
																																																										=
																																																										BgL_expz00_17;
																																																									BgL_auxz00_3260
																																																										=
																																																										CDR
																																																										(CDR
																																																										(BgL_pairz00_2475));
																																																								}
																																																								BgL_arg3696z00_1550
																																																									=
																																																									BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																									(BgL_auxz00_3260,
																																																									BNIL);
																																																							}
																																																							BgL_arg3693z00_1547
																																																								=
																																																								MAKE_PAIR
																																																								(BgL_arg3695z00_1549,
																																																								BgL_arg3696z00_1550);
																																																						}
																																																						BgL_auxz00_3202
																																																							=
																																																							BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																							(
																																																							((bool_t) 1), (obj_t) (BgL_arg3692z00_1546), (BgL_typez00_bglt) (BgL_typez00_1525), BgL_arg3693z00_1547, BgL_stackz00_18, BgL_locz00_1521, BgL_sitez00_20);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 526 */
																																																						BgL_auxz00_3202
																																																							=
																																																							BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																																							(BGl_string3895z00zzast_sexpz00,
																																																							BgL_expz00_17,
																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																							(BgL_expz00_17,
																																																								BgL_locz00_1521));
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 512 */
																																																				if ((BgL_idz00_1524 == CNST_TABLE_REF(((long) 8))))
																																																					{
																																																						obj_t
																																																							BgL_argsz00_1560;
																																																						obj_t
																																																							BgL_bodyz00_1561;
																																																						if (PAIRP(BgL_expz00_17))
																																																							{	/* Ast/sexp.scm 534 */
																																																								obj_t
																																																									BgL_cdrzd22085zd2_1566;
																																																								BgL_cdrzd22085zd2_1566
																																																									=
																																																									CDR
																																																									(BgL_expz00_17);
																																																								if (PAIRP(BgL_cdrzd22085zd2_1566))
																																																									{	/* Ast/sexp.scm 534 */
																																																										BgL_argsz00_1560
																																																											=
																																																											CAR
																																																											(BgL_cdrzd22085zd2_1566);
																																																										BgL_bodyz00_1561
																																																											=
																																																											CDR
																																																											(BgL_cdrzd22085zd2_1566);
																																																										{	/* Ast/sexp.scm 536 */
																																																											obj_t
																																																												BgL_locz00_1570;
																																																											BgL_locz00_1570
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_expz00_17,
																																																												BgL_locz00_1521);
																																																											{	/* Ast/sexp.scm 536 */
																																																												obj_t
																																																													BgL_funz00_1571;
																																																												BgL_funz00_1571
																																																													=
																																																													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																																																													(BGl_gensymz00zz__r4_symbols_6_4z00
																																																													(CNST_TABLE_REF
																																																														(((long) 8))));
																																																												{	/* Ast/sexp.scm 537 */
																																																													obj_t
																																																														BgL_tfunz00_1572;
																																																													{	/* Ast/sexp.scm 538 */
																																																														obj_t
																																																															BgL_arg3724z00_1587;
																																																														{
																																																															BgL_typez00_bglt
																																																																BgL_auxz00_3282;
																																																															BgL_auxz00_3282
																																																																=
																																																																(BgL_typez00_bglt)
																																																																(BgL_typez00_1525);
																																																															BgL_arg3724z00_1587
																																																																=
																																																																(
																																																																((BgL_typez00_bglt) CREF(BgL_auxz00_3282))->BgL_idz00);
																																																														}
																																																														BgL_tfunz00_1572
																																																															=
																																																															BGl_makezd2typedzd2identz00zzast_identz00
																																																															(BgL_funz00_1571,
																																																															BgL_arg3724z00_1587);
																																																													}
																																																													{	/* Ast/sexp.scm 538 */

																																																														{	/* Ast/sexp.scm 540 */
																																																															obj_t
																																																																BgL_arg3710z00_1573;
																																																															{	/* Ast/sexp.scm 540 */
																																																																obj_t
																																																																	BgL_arg3711z00_1574;
																																																																obj_t
																																																																	BgL_arg3712z00_1575;
																																																																BgL_arg3711z00_1574
																																																																	=
																																																																	CNST_TABLE_REF
																																																																	(
																																																																	((long) 9));
																																																																{	/* Ast/sexp.scm 540 */
																																																																	obj_t
																																																																		BgL_arg3713z00_1576;
																																																																	{	/* Ast/sexp.scm 540 */
																																																																		obj_t
																																																																			BgL_arg3717z00_1580;
																																																																		{	/* Ast/sexp.scm 540 */
																																																																			obj_t
																																																																				BgL_arg3719z00_1582;
																																																																			{	/* Ast/sexp.scm 540 */
																																																																				obj_t
																																																																					BgL_arg3720z00_1583;
																																																																				BgL_arg3720z00_1583
																																																																					=
																																																																					BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																					(BgL_bodyz00_1561);
																																																																				{	/* Ast/sexp.scm 540 */
																																																																					obj_t
																																																																						BgL_list3722z00_1585;
																																																																					{	/* Ast/sexp.scm 540 */
																																																																						obj_t
																																																																							BgL_arg3723z00_1586;
																																																																						BgL_arg3723z00_1586
																																																																							=
																																																																							MAKE_PAIR
																																																																							(BNIL,
																																																																							BNIL);
																																																																						BgL_list3722z00_1585
																																																																							=
																																																																							MAKE_PAIR
																																																																							(BgL_arg3720z00_1583,
																																																																							BgL_arg3723z00_1586);
																																																																					}
																																																																					BgL_arg3719z00_1582
																																																																						=
																																																																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																																						(BgL_argsz00_1560,
																																																																						BgL_list3722z00_1585);
																																																																			}}
																																																																			BgL_arg3717z00_1580
																																																																				=
																																																																				MAKE_PAIR
																																																																				(BgL_tfunz00_1572,
																																																																				BgL_arg3719z00_1582);
																																																																		}
																																																																		BgL_arg3713z00_1576
																																																																			=
																																																																			MAKE_PAIR
																																																																			(BgL_arg3717z00_1580,
																																																																			BNIL);
																																																																	}
																																																																	{	/* Ast/sexp.scm 540 */
																																																																		obj_t
																																																																			BgL_list3715z00_1578;
																																																																		{	/* Ast/sexp.scm 540 */
																																																																			obj_t
																																																																				BgL_arg3716z00_1579;
																																																																			BgL_arg3716z00_1579
																																																																				=
																																																																				MAKE_PAIR
																																																																				(BNIL,
																																																																				BNIL);
																																																																			BgL_list3715z00_1578
																																																																				=
																																																																				MAKE_PAIR
																																																																				(BgL_funz00_1571,
																																																																				BgL_arg3716z00_1579);
																																																																		}
																																																																		BgL_arg3712z00_1575
																																																																			=
																																																																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																																			(BgL_arg3713z00_1576,
																																																																			BgL_list3715z00_1578);
																																																																}}
																																																																BgL_arg3710z00_1573
																																																																	=
																																																																	MAKE_PAIR
																																																																	(BgL_arg3711z00_1574,
																																																																	BgL_arg3712z00_1575);
																																																															}
																																																															BgL_auxz00_3202
																																																																=
																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																(BgL_arg3710z00_1573,
																																																																BgL_stackz00_18,
																																																																BgL_locz00_1570,
																																																																BgL_sitez00_20);
																																																									}}}}}}
																																																								else
																																																									{	/* Ast/sexp.scm 534 */
																																																									BgL_tagzd22078zd2_1563:
																																																										BgL_auxz00_3202 = BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string3896z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_1521);
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 534 */
																																																								goto
																																																									BgL_tagzd22078zd2_1563;
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 512 */
																																																						BgL_auxz00_3202
																																																							=
																																																							BGl_applicationzd2ze3nodez31zzast_appz00
																																																							(BgL_expz00_17,
																																																							BgL_stackz00_18,
																																																							BgL_locz00_1521,
																																																							BgL_sitez00_20);
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																										}
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 507 */
																																									BgL_auxz00_3202
																																										=
																																										BGl_applicationzd2ze3nodez31zzast_appz00
																																										(BgL_expz00_17,
																																										BgL_stackz00_18,
																																										BgL_locz00_1521,
																																										BgL_sitez00_20);
																																								}
																																						}
																																						BgL_auxz00_3147
																																							=
																																							(obj_t)
																																							(BgL_auxz00_3202);
																																					}
																																			}
																																	}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 85 */
																															obj_t
																																BgL_carzd21646zd2_956;
																															BgL_carzd21646zd2_956
																																=
																																CAR
																																(BgL_expz00_17);
																															{	/* Ast/sexp.scm 85 */
																																obj_t
																																	BgL_cdrzd21651zd2_957;
																																BgL_cdrzd21651zd2_957
																																	=
																																	CDR
																																	(BgL_carzd21646zd2_956);
																																if ((CAR
																																		(BgL_carzd21646zd2_956)
																																		==
																																		CNST_TABLE_REF
																																		(((long)
																																				8))))
																																	{	/* Ast/sexp.scm 85 */
																																		obj_t
																																			BgL_arg3249z00_959;
																																		obj_t
																																			BgL_arg3250z00_960;
																																		obj_t
																																			BgL_arg3251z00_961;
																																		BgL_arg3249z00_959
																																			=
																																			CAR
																																			(BgL_cdrzd21651zd2_957);
																																		BgL_arg3250z00_960
																																			=
																																			CDR
																																			(BgL_cdrzd21651zd2_957);
																																		BgL_arg3251z00_961
																																			=
																																			CDR
																																			(BgL_expz00_17);
																																		{	/* Ast/sexp.scm 85 */
																																			BgL_nodez00_bglt
																																				BgL_auxz00_3313;
																																			{
																																				obj_t
																																					BgL_argsz00_3316;
																																				obj_t
																																					BgL_bodyz00_3315;
																																				obj_t
																																					BgL_varsz00_3314;
																																				BgL_varsz00_3314
																																					=
																																					BgL_arg3249z00_959;
																																				BgL_bodyz00_3315
																																					=
																																					BgL_arg3250z00_960;
																																				BgL_argsz00_3316
																																					=
																																					BgL_arg3251z00_961;
																																				BgL_argsz00_890
																																					=
																																					BgL_argsz00_3316;
																																				BgL_bodyz00_889
																																					=
																																					BgL_bodyz00_3315;
																																				BgL_varsz00_888
																																					=
																																					BgL_varsz00_3314;
																																				goto
																																					BgL_tagzd21475zd2_891;
																																			}
																																			BgL_auxz00_3147
																																				=
																																				(obj_t)
																																				(BgL_auxz00_3313);
																																		}
																																	}
																																else
																																	{	/* Ast/sexp.scm 85 */
																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																			{	/* Ast/sexp.scm 85 */
																																				goto
																																					BgL_tagzd21487zd2_907;
																																			}
																																		else
																																			{	/* Ast/sexp.scm 85 */
																																				BgL_nodez00_bglt
																																					BgL_auxz00_3320;
																																				goto
																																					BgL_tagzd21488zd2_908;
																																				BgL_auxz00_3147
																																					=
																																					(obj_t)
																																					(BgL_auxz00_3320);
																																			}
																																	}
																															}
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 85 */
																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																														{	/* Ast/sexp.scm 85 */
																															goto
																																BgL_tagzd21487zd2_907;
																														}
																													else
																														{	/* Ast/sexp.scm 85 */
																															BgL_nodez00_bglt
																																BgL_auxz00_3324;
																															goto
																																BgL_tagzd21488zd2_908;
																															BgL_auxz00_3147 =
																																(obj_t)
																																(BgL_auxz00_3324);
																														}
																												}
																											return
																												(BgL_nodez00_bglt)
																												(BgL_auxz00_3147);
																										}
																									else
																										{	/* Ast/sexp.scm 85 */
																											if (
																												(BgL_carzd21566zd2_922
																													==
																													CNST_TABLE_REF(((long)
																															25))))
																												{	/* Ast/sexp.scm 85 */
																													obj_t BgL_auxz00_3330;

																													goto
																														BgL_kapzd21568zd2_924;
																													return
																														(BgL_nodez00_bglt)
																														(BgL_auxz00_3330);
																												}
																											else
																												{	/* Ast/sexp.scm 85 */
																													if (
																														(BgL_carzd21566zd2_922
																															==
																															CNST_TABLE_REF((
																																	(long) 9))))
																														{	/* Ast/sexp.scm 85 */
																															obj_t
																																BgL_auxz00_3335;
																															goto
																																BgL_kapzd21568zd2_924;
																															return
																																(BgL_nodez00_bglt)
																																(BgL_auxz00_3335);
																														}
																													else
																														{	/* Ast/sexp.scm 85 */
																															obj_t
																																BgL_cdrzd21735zd2_930;
																															BgL_cdrzd21735zd2_930
																																=
																																CDR
																																(BgL_carzd21563zd2_920);
																															if ((CAR
																																	(BgL_carzd21563zd2_920)
																																	==
																																	CNST_TABLE_REF
																																	(((long) 8))))
																																{	/* Ast/sexp.scm 85 */
																																	if (PAIRP
																																		(BgL_cdrzd21735zd2_930))
																																		{
																																			obj_t
																																				BgL_argsz00_3348;
																																			obj_t
																																				BgL_bodyz00_3346;
																																			obj_t
																																				BgL_varsz00_3344;
																																			BgL_varsz00_3344
																																				=
																																				CAR
																																				(BgL_cdrzd21735zd2_930);
																																			BgL_bodyz00_3346
																																				=
																																				CDR
																																				(BgL_cdrzd21735zd2_930);
																																			BgL_argsz00_3348
																																				=
																																				CDR
																																				(BgL_expz00_17);
																																			BgL_argsz00_890
																																				=
																																				BgL_argsz00_3348;
																																			BgL_bodyz00_889
																																				=
																																				BgL_bodyz00_3346;
																																			BgL_varsz00_888
																																				=
																																				BgL_varsz00_3344;
																																			goto
																																				BgL_tagzd21475zd2_891;
																																		}
																																	else
																																		{	/* Ast/sexp.scm 85 */
																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																				{	/* Ast/sexp.scm 85 */
																																					obj_t
																																						BgL_auxz00_3352;
																																					goto
																																						BgL_tagzd21487zd2_907;
																																					return
																																						(BgL_nodez00_bglt)
																																						(BgL_auxz00_3352);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 85 */
																																					goto
																																						BgL_tagzd21488zd2_908;
																																				}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 85 */
																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																		{	/* Ast/sexp.scm 85 */
																																			obj_t
																																				BgL_auxz00_3356;
																																			goto
																																				BgL_tagzd21487zd2_907;
																																			return
																																				(BgL_nodez00_bglt)
																																				(BgL_auxz00_3356);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 85 */
																																			goto
																																				BgL_tagzd21488zd2_908;
																																		}
																																}
																														}
																												}
																										}
																								}
																							}
																						else
																							{	/* Ast/sexp.scm 85 */
																								if (
																									(BgL_carzd21563zd2_920 ==
																										CNST_TABLE_REF(((long)
																												11))))
																									{	/* Ast/sexp.scm 85 */
																									BgL_tagzd21473zd2_886:
																										return
																											BGl_letzd2ze3nodez31zzast_letz00
																											(BgL_expz00_17,
																											BgL_stackz00_18,
																											BgL_locz00_19,
																											CNST_TABLE_REF(((long)
																													1)));
																									}
																								else
																									{	/* Ast/sexp.scm 85 */
																										if (
																											(BgL_carzd21563zd2_920 ==
																												CNST_TABLE_REF(((long)
																														25))))
																											{	/* Ast/sexp.scm 85 */
																												goto
																													BgL_tagzd21473zd2_886;
																											}
																										else
																											{	/* Ast/sexp.scm 85 */
																												if (
																													(CAR(BgL_expz00_17) ==
																														CNST_TABLE_REF((
																																(long) 9))))
																													{	/* Ast/sexp.scm 85 */
																														BgL_letzd2funzd2_bglt
																															BgL_auxz00_3370;
																														BgL_auxz00_3370 =
																															BGl_labelszd2ze3nodez31zzast_labelsz00
																															(BgL_expz00_17,
																															BgL_stackz00_18,
																															BgL_locz00_19,
																															CNST_TABLE_REF((
																																	(long) 1)));
																														return
																															(BgL_nodez00_bglt)
																															(BgL_auxz00_3370);
																													}
																												else
																													{	/* Ast/sexp.scm 85 */
																														if (
																															(CAR
																																(BgL_expz00_17)
																																==
																																CNST_TABLE_REF((
																																		(long) 8))))
																															{	/* Ast/sexp.scm 85 */
																																{
																																	obj_t
																																		BgL_argsz00_1398;
																																	obj_t
																																		BgL_bodyz00_1399;
																																	if (PAIRP
																																		(BgL_expz00_17))
																																		{	/* Ast/sexp.scm 85 */
																																			obj_t
																																				BgL_cdrzd22029zd2_1404;
																																			BgL_cdrzd22029zd2_1404
																																				=
																																				CDR
																																				(BgL_expz00_17);
																																			if (PAIRP
																																				(BgL_cdrzd22029zd2_1404))
																																				{	/* Ast/sexp.scm 85 */
																																					BgL_argsz00_1398
																																						=
																																						CAR
																																						(BgL_cdrzd22029zd2_1404);
																																					BgL_bodyz00_1399
																																						=
																																						CDR
																																						(BgL_cdrzd22029zd2_1404);
																																					{	/* Ast/sexp.scm 388 */
																																						obj_t
																																							BgL_locz00_1408;
																																						obj_t
																																							BgL_funz00_1409;
																																						BgL_locz00_1408
																																							=
																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																							(BgL_expz00_17,
																																							BgL_locz00_19);
																																						BgL_funz00_1409
																																							=
																																							BGl_makezd2anonymouszd2namez00zzast_sexpz00
																																							(BgL_locz00_19,
																																							BNIL);
																																						{	/* Ast/sexp.scm 390 */
																																							obj_t
																																								BgL_arg3596z00_1410;
																																							{	/* Ast/sexp.scm 390 */
																																								obj_t
																																									BgL_arg3597z00_1411;
																																								obj_t
																																									BgL_arg3598z00_1412;
																																								BgL_arg3597z00_1411
																																									=
																																									CNST_TABLE_REF
																																									(
																																									((long) 9));
																																								{	/* Ast/sexp.scm 390 */
																																									obj_t
																																										BgL_arg3600z00_1413;
																																									{	/* Ast/sexp.scm 390 */
																																										obj_t
																																											BgL_arg3604z00_1417;
																																										{	/* Ast/sexp.scm 390 */
																																											obj_t
																																												BgL_arg3606z00_1419;
																																											{	/* Ast/sexp.scm 390 */
																																												obj_t
																																													BgL_arg3607z00_1420;
																																												BgL_arg3607z00_1420
																																													=
																																													BGl_normaliza7ezd2prognz75zztools_prognz00
																																													(BgL_bodyz00_1399);
																																												{	/* Ast/sexp.scm 390 */
																																													obj_t
																																														BgL_list3609z00_1422;
																																													{	/* Ast/sexp.scm 390 */
																																														obj_t
																																															BgL_arg3610z00_1423;
																																														BgL_arg3610z00_1423
																																															=
																																															MAKE_PAIR
																																															(BNIL,
																																															BNIL);
																																														BgL_list3609z00_1422
																																															=
																																															MAKE_PAIR
																																															(BgL_arg3607z00_1420,
																																															BgL_arg3610z00_1423);
																																													}
																																													BgL_arg3606z00_1419
																																														=
																																														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																														(BgL_argsz00_1398,
																																														BgL_list3609z00_1422);
																																											}}
																																											BgL_arg3604z00_1417
																																												=
																																												MAKE_PAIR
																																												(BgL_funz00_1409,
																																												BgL_arg3606z00_1419);
																																										}
																																										BgL_arg3600z00_1413
																																											=
																																											MAKE_PAIR
																																											(BgL_arg3604z00_1417,
																																											BNIL);
																																									}
																																									{	/* Ast/sexp.scm 390 */
																																										obj_t
																																											BgL_list3602z00_1415;
																																										{	/* Ast/sexp.scm 390 */
																																											obj_t
																																												BgL_arg3603z00_1416;
																																											BgL_arg3603z00_1416
																																												=
																																												MAKE_PAIR
																																												(BNIL,
																																												BNIL);
																																											BgL_list3602z00_1415
																																												=
																																												MAKE_PAIR
																																												(BgL_funz00_1409,
																																												BgL_arg3603z00_1416);
																																										}
																																										BgL_arg3598z00_1412
																																											=
																																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																											(BgL_arg3600z00_1413,
																																											BgL_list3602z00_1415);
																																								}}
																																								BgL_arg3596z00_1410
																																									=
																																									MAKE_PAIR
																																									(BgL_arg3597z00_1411,
																																									BgL_arg3598z00_1412);
																																							}
																																							{
																																								obj_t
																																									BgL_locz00_3397;
																																								obj_t
																																									BgL_expz00_3396;
																																								BgL_expz00_3396
																																									=
																																									BgL_arg3596z00_1410;
																																								BgL_locz00_3397
																																									=
																																									BgL_locz00_1408;
																																								BgL_locz00_19
																																									=
																																									BgL_locz00_3397;
																																								BgL_expz00_17
																																									=
																																									BgL_expz00_3396;
																																								goto
																																									BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																							}
																																						}
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 85 */
																																				BgL_tagzd22022zd2_1401:
																																					return
																																						BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																						(BGl_string3896z00zzast_sexpz00,
																																						BgL_expz00_17,
																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																						(BgL_expz00_17,
																																							BgL_locz00_19));
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 85 */
																																			goto
																																				BgL_tagzd22022zd2_1401;
																																		}
																																}
																															}
																														else
																															{	/* Ast/sexp.scm 85 */
																																if (
																																	(CAR
																																		(BgL_expz00_17)
																																		==
																																		CNST_TABLE_REF
																																		(((long)
																																				2))))
																																	{	/* Ast/sexp.scm 85 */
																																		return
																																			BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																			(((bool_t)
																																				0),
																																			BFALSE,
																																			(BgL_typez00_bglt)
																																			(BGl_za2unspecza2z00zztype_cachez00),
																																			BgL_expz00_17,
																																			BgL_stackz00_18,
																																			BgL_locz00_19,
																																			BgL_sitez00_20);
																																	}
																																else
																																	{	/* Ast/sexp.scm 85 */
																																		obj_t
																																			BgL_cdrzd21807zd2_972;
																																		BgL_cdrzd21807zd2_972
																																			=
																																			CDR
																																			(BgL_expz00_17);
																																		if ((CAR
																																				(BgL_expz00_17)
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						3))))
																																			{	/* Ast/sexp.scm 85 */
																																				if (PAIRP(BgL_cdrzd21807zd2_972))
																																					{	/* Ast/sexp.scm 85 */
																																						BgL_effectz00_894
																																							=
																																							CAR
																																							(BgL_cdrzd21807zd2_972);
																																						BgL_restz00_895
																																							=
																																							CDR
																																							(BgL_cdrzd21807zd2_972);
																																						{	/* Ast/sexp.scm 404 */
																																							BgL_feffectz00_bglt
																																								BgL_arg3614z00_1427;
																																							obj_t
																																								BgL_arg3615z00_1428;
																																							BgL_arg3614z00_1427
																																								=
																																								BGl_parsezd2effectzd2zzeffect_feffectz00
																																								(BgL_effectz00_894);
																																							{	/* Ast/sexp.scm 405 */
																																								obj_t
																																									BgL_arg3616z00_1429;
																																								obj_t
																																									BgL_arg3617z00_1430;
																																								BgL_arg3616z00_1429
																																									=
																																									CNST_TABLE_REF
																																									(
																																									((long) 2));
																																								BgL_arg3617z00_1430
																																									=
																																									BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																									(BgL_restz00_895,
																																									BNIL);
																																								BgL_arg3615z00_1428
																																									=
																																									MAKE_PAIR
																																									(BgL_arg3616z00_1429,
																																									BgL_arg3617z00_1430);
																																							}
																																							return
																																								BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																								(
																																								((bool_t) 0), (obj_t) (BgL_arg3614z00_1427), (BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00), BgL_arg3615z00_1428, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20);
																																						}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 85 */
																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																							{	/* Ast/sexp.scm 85 */
																																								obj_t
																																									BgL_auxz00_3426;
																																								goto
																																									BgL_tagzd21487zd2_907;
																																								return
																																									(BgL_nodez00_bglt)
																																									(BgL_auxz00_3426);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 85 */
																																								goto
																																									BgL_tagzd21488zd2_908;
																																							}
																																					}
																																			}
																																		else
																																			{	/* Ast/sexp.scm 85 */
																																				if (
																																					(CAR
																																						(BgL_expz00_17)
																																						==
																																						CNST_TABLE_REF
																																						(((long) 6))))
																																					{	/* Ast/sexp.scm 85 */
																																						return
																																							BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																							(((bool_t) 1), BFALSE, (BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 85 */
																																						if (
																																							(CAR
																																								(BgL_expz00_17)
																																								==
																																								CNST_TABLE_REF
																																								(((long) 7))))
																																							{	/* Ast/sexp.scm 85 */
																																								if (PAIRP(BgL_cdrzd21807zd2_972))
																																									{	/* Ast/sexp.scm 85 */
																																										BgL_effectz00_898
																																											=
																																											CAR
																																											(BgL_cdrzd21807zd2_972);
																																										BgL_restz00_899
																																											=
																																											CDR
																																											(BgL_cdrzd21807zd2_972);
																																										{	/* Ast/sexp.scm 412 */
																																											BgL_feffectz00_bglt
																																												BgL_arg3618z00_1431;
																																											obj_t
																																												BgL_arg3619z00_1432;
																																											BgL_arg3618z00_1431
																																												=
																																												BGl_parsezd2effectzd2zzeffect_feffectz00
																																												(BgL_effectz00_898);
																																											{	/* Ast/sexp.scm 413 */
																																												obj_t
																																													BgL_arg3620z00_1433;
																																												obj_t
																																													BgL_arg3621z00_1434;
																																												BgL_arg3620z00_1433
																																													=
																																													CNST_TABLE_REF
																																													(
																																													((long) 2));
																																												BgL_arg3621z00_1434
																																													=
																																													BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																													(BgL_restz00_899,
																																													BNIL);
																																												BgL_arg3619z00_1432
																																													=
																																													MAKE_PAIR
																																													(BgL_arg3620z00_1433,
																																													BgL_arg3621z00_1434);
																																											}
																																											return
																																												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																												(
																																												((bool_t) 1), (obj_t) (BgL_arg3618z00_1431), (BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00), BgL_arg3619z00_1432, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20);
																																										}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 85 */
																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																											{	/* Ast/sexp.scm 85 */
																																												obj_t
																																													BgL_auxz00_3451;
																																												goto
																																													BgL_tagzd21487zd2_907;
																																												return
																																													(BgL_nodez00_bglt)
																																													(BgL_auxz00_3451);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 85 */
																																												goto
																																													BgL_tagzd21488zd2_908;
																																											}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 85 */
																																								if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 26))))
																																									{	/* Ast/sexp.scm 85 */
																																										obj_t
																																											BgL_auxz00_3457;
																																										{
																																											obj_t
																																												BgL_procz00_1435;
																																											obj_t
																																												BgL_msgz00_1436;
																																											obj_t
																																												BgL_objz00_1437;
																																											if (PAIRP(BgL_expz00_17))
																																												{	/* Ast/sexp.scm 85 */
																																													obj_t
																																														BgL_cdrzd22046zd2_1442;
																																													BgL_cdrzd22046zd2_1442
																																														=
																																														CDR
																																														(BgL_expz00_17);
																																													if (PAIRP(BgL_cdrzd22046zd2_1442))
																																														{	/* Ast/sexp.scm 85 */
																																															obj_t
																																																BgL_cdrzd22051zd2_1444;
																																															BgL_cdrzd22051zd2_1444
																																																=
																																																CDR
																																																(BgL_cdrzd22046zd2_1442);
																																															if (PAIRP(BgL_cdrzd22051zd2_1444))
																																																{	/* Ast/sexp.scm 85 */
																																																	obj_t
																																																		BgL_cdrzd22056zd2_1446;
																																																	BgL_cdrzd22056zd2_1446
																																																		=
																																																		CDR
																																																		(BgL_cdrzd22051zd2_1444);
																																																	if (PAIRP(BgL_cdrzd22056zd2_1446))
																																																		{	/* Ast/sexp.scm 85 */
																																																			if (NULLP(CDR(BgL_cdrzd22056zd2_1446)))
																																																				{	/* Ast/sexp.scm 85 */
																																																					obj_t
																																																						BgL_arg3627z00_1449;
																																																					obj_t
																																																						BgL_arg3628z00_1450;
																																																					obj_t
																																																						BgL_arg3629z00_1451;
																																																					BgL_arg3627z00_1449
																																																						=
																																																						CAR
																																																						(BgL_cdrzd22046zd2_1442);
																																																					BgL_arg3628z00_1450
																																																						=
																																																						CAR
																																																						(BgL_cdrzd22051zd2_1444);
																																																					BgL_arg3629z00_1451
																																																						=
																																																						CAR
																																																						(BgL_cdrzd22056zd2_1446);
																																																					{	/* Ast/sexp.scm 85 */
																																																						BgL_failz00_bglt
																																																							BgL_auxz00_3475;
																																																						BgL_procz00_1435
																																																							=
																																																							BgL_arg3627z00_1449;
																																																						BgL_msgz00_1436
																																																							=
																																																							BgL_arg3628z00_1450;
																																																						BgL_objz00_1437
																																																							=
																																																							BgL_arg3629z00_1451;
																																																						{	/* Ast/sexp.scm 418 */
																																																							obj_t
																																																								BgL_locz00_1453;
																																																							BgL_locz00_1453
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_17,
																																																								BgL_locz00_19);
																																																							{	/* Ast/sexp.scm 418 */
																																																								obj_t
																																																									BgL_cdlocz00_1454;
																																																								BgL_cdlocz00_1454
																																																									=
																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																									(CDR
																																																									(BgL_expz00_17),
																																																									BgL_locz00_1453);
																																																								{	/* Ast/sexp.scm 419 */
																																																									obj_t
																																																										BgL_cddlocz00_1455;
																																																									{	/* Ast/sexp.scm 420 */
																																																										obj_t
																																																											BgL_arg3632z00_1464;
																																																										{	/* Ast/sexp.scm 420 */
																																																											obj_t
																																																												BgL_pairz00_2419;
																																																											BgL_pairz00_2419
																																																												=
																																																												BgL_expz00_17;
																																																											BgL_arg3632z00_1464
																																																												=
																																																												CDR
																																																												(CDR
																																																												(BgL_pairz00_2419));
																																																										}
																																																										BgL_cddlocz00_1455
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_arg3632z00_1464,
																																																											BgL_locz00_1453);
																																																									}
																																																									{	/* Ast/sexp.scm 420 */
																																																										obj_t
																																																											BgL_cdddlocz00_1456;
																																																										{	/* Ast/sexp.scm 421 */
																																																											obj_t
																																																												BgL_arg3631z00_1463;
																																																											{	/* Ast/sexp.scm 421 */
																																																												obj_t
																																																													BgL_pairz00_2423;
																																																												BgL_pairz00_2423
																																																													=
																																																													BgL_expz00_17;
																																																												BgL_arg3631z00_1463
																																																													=
																																																													CDR
																																																													(CDR
																																																													(CDR
																																																														(BgL_pairz00_2423)));
																																																											}
																																																											BgL_cdddlocz00_1456
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_arg3631z00_1463,
																																																												BgL_locz00_1453);
																																																										}
																																																										{	/* Ast/sexp.scm 421 */
																																																											obj_t
																																																												BgL_loczd2proczd2_1457;
																																																											BgL_loczd2proczd2_1457
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_procz00_1435,
																																																												BgL_cdlocz00_1454);
																																																											{	/* Ast/sexp.scm 422 */
																																																												obj_t
																																																													BgL_loczd2msgzd2_1458;
																																																												BgL_loczd2msgzd2_1458
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_msgz00_1436,
																																																													BgL_cddlocz00_1455);
																																																												{	/* Ast/sexp.scm 423 */
																																																													obj_t
																																																														BgL_loczd2objzd2_1459;
																																																													BgL_loczd2objzd2_1459
																																																														=
																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																														(BgL_objz00_1437,
																																																														BgL_cdddlocz00_1456);
																																																													{	/* Ast/sexp.scm 424 */
																																																														BgL_nodez00_bglt
																																																															BgL_procz00_1460;
																																																														BgL_procz00_1460
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_procz00_1435,
																																																															BgL_stackz00_18,
																																																															BgL_loczd2proczd2_1457,
																																																															CNST_TABLE_REF
																																																															(((long) 1)));
																																																														{	/* Ast/sexp.scm 425 */
																																																															BgL_nodez00_bglt
																																																																BgL_msgz00_1461;
																																																															BgL_msgz00_1461
																																																																=
																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																(BgL_msgz00_1436,
																																																																BgL_stackz00_18,
																																																																BgL_loczd2msgzd2_1458,
																																																																CNST_TABLE_REF
																																																																(((long) 1)));
																																																															{	/* Ast/sexp.scm 426 */
																																																																BgL_nodez00_bglt
																																																																	BgL_objz00_1462;
																																																																BgL_objz00_1462
																																																																	=
																																																																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																	(BgL_objz00_1437,
																																																																	BgL_stackz00_18,
																																																																	BgL_loczd2objzd2_1459,
																																																																	CNST_TABLE_REF
																																																																	(((long) 1)));
																																																																{	/* Ast/sexp.scm 427 */

																																																																	BgL_auxz00_3475
																																																																		=
																																																																		BGl_makezd2failzd2zzast_nodez00
																																																																		(BgL_locz00_1453,
																																																																		(BgL_typez00_bglt)
																																																																		(BGl_za2magicza2z00zztype_cachez00),
																																																																		BgL_procz00_1460,
																																																																		BgL_msgz00_1461,
																																																																		BgL_objz00_1462);
																																																						}}}}}}}}}}}
																																																						BgL_auxz00_3457
																																																							=
																																																							(obj_t)
																																																							(BgL_auxz00_3475);
																																																				}}
																																																			else
																																																				{	/* Ast/sexp.scm 85 */
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_3498;
																																																				BgL_tagzd22037zd2_1439:
																																																					BgL_auxz00_3498 = BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string3899z00zzast_sexpz00, BgL_expz00_17, BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19));
																																																					BgL_auxz00_3457
																																																						=
																																																						(obj_t)
																																																						(BgL_auxz00_3498);
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 85 */
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_3502;
																																																			goto
																																																				BgL_tagzd22037zd2_1439;
																																																			BgL_auxz00_3457
																																																				=
																																																				(obj_t)
																																																				(BgL_auxz00_3502);
																																																		}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 85 */
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_3504;
																																																	goto
																																																		BgL_tagzd22037zd2_1439;
																																																	BgL_auxz00_3457
																																																		=
																																																		(obj_t)
																																																		(BgL_auxz00_3504);
																																																}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 85 */
																																															BgL_nodez00_bglt
																																																BgL_auxz00_3506;
																																															goto
																																																BgL_tagzd22037zd2_1439;
																																															BgL_auxz00_3457
																																																=
																																																(obj_t)
																																																(BgL_auxz00_3506);
																																														}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 85 */
																																													BgL_nodez00_bglt
																																														BgL_auxz00_3508;
																																													goto
																																														BgL_tagzd22037zd2_1439;
																																													BgL_auxz00_3457
																																														=
																																														(obj_t)
																																														(BgL_auxz00_3508);
																																												}
																																										}
																																										return
																																											(BgL_nodez00_bglt)
																																											(BgL_auxz00_3457);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 85 */
																																										if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 27))))
																																											{	/* Ast/sexp.scm 85 */
																																												obj_t
																																													BgL_auxz00_3515;
																																												{
																																													obj_t
																																														BgL_testz00_1468;
																																													obj_t
																																														BgL_clausesz00_1469;
																																													if (PAIRP(BgL_expz00_17))
																																														{	/* Ast/sexp.scm 85 */
																																															obj_t
																																																BgL_cdrzd22070zd2_1474;
																																															BgL_cdrzd22070zd2_1474
																																																=
																																																CDR
																																																(BgL_expz00_17);
																																															if (PAIRP(BgL_cdrzd22070zd2_1474))
																																																{	/* Ast/sexp.scm 85 */
																																																	BgL_testz00_1468
																																																		=
																																																		CAR
																																																		(BgL_cdrzd22070zd2_1474);
																																																	BgL_clausesz00_1469
																																																		=
																																																		CDR
																																																		(BgL_cdrzd22070zd2_1474);
																																																	{	/* Ast/sexp.scm 447 */
																																																		obj_t
																																																			BgL_locz00_1478;
																																																		BgL_locz00_1478
																																																			=
																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																			(BgL_expz00_17,
																																																			BgL_locz00_19);
																																																		{	/* Ast/sexp.scm 447 */
																																																			obj_t
																																																				BgL_cdlocz00_1479;
																																																			BgL_cdlocz00_1479
																																																				=
																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																				(CDR
																																																				(BgL_expz00_17),
																																																				BgL_locz00_1478);
																																																			{	/* Ast/sexp.scm 448 */
																																																				obj_t
																																																					BgL_cddlocz00_1480;
																																																				BgL_cddlocz00_1480
																																																					=
																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																					(CDR
																																																					(BgL_expz00_17),
																																																					BgL_locz00_1478);
																																																				{	/* Ast/sexp.scm 449 */
																																																					BgL_nodez00_bglt
																																																						BgL_testz00_1481;
																																																					{	/* Ast/sexp.scm 452 */
																																																						obj_t
																																																							BgL_arg3664z00_1512;
																																																						obj_t
																																																							BgL_arg3665z00_1513;
																																																						BgL_arg3664z00_1512
																																																							=
																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																							(BgL_testz00_1468,
																																																							BgL_cdlocz00_1479);
																																																						BgL_arg3665z00_1513
																																																							=
																																																							CNST_TABLE_REF
																																																							(
																																																							((long) 1));
																																																						BgL_testz00_1481
																																																							=
																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																							(BgL_testz00_1468,
																																																							BgL_stackz00_18,
																																																							BgL_arg3664z00_1512,
																																																							BgL_arg3665z00_1513);
																																																					}
																																																					{	/* Ast/sexp.scm 450 */

																																																						{
																																																							obj_t
																																																								BgL_clsz00_1483;
																																																							obj_t
																																																								BgL_nclausesz00_1484;
																																																							BgL_clsz00_1483
																																																								=
																																																								BgL_clausesz00_1469;
																																																							BgL_nclausesz00_1484
																																																								=
																																																								BNIL;
																																																						BgL_loopz00_1485:
																																																							if (NULLP(BgL_clsz00_1483))
																																																								{	/* Ast/sexp.scm 457 */
																																																									obj_t
																																																										BgL_arg3642z00_1488;
																																																									BgL_typez00_bglt
																																																										BgL_arg3643z00_1489;
																																																									BgL_arg3642z00_1488
																																																										=
																																																										bgl_reverse_bang
																																																										(BgL_nclausesz00_1484);
																																																									BgL_arg3643z00_1489
																																																										=
																																																										BGl_typeofzd2atomzd2zztype_typeofz00
																																																										(CAR
																																																										(CAR
																																																											(CAR
																																																												(BgL_clausesz00_1469))));
																																																									BgL_auxz00_3515
																																																										=
																																																										(obj_t)
																																																										(BGl_makezd2selectzd2zzast_nodez00
																																																										(BgL_locz00_1478,
																																																											(BgL_typez00_bglt)
																																																											(BGl_za2_za2z00zztype_cachez00),
																																																											BUNSPEC,
																																																											BINT
																																																											(((long) -1)), BgL_testz00_1481, BgL_arg3642z00_1488, BgL_arg3643z00_1489));
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 463 */
																																																									obj_t
																																																										BgL_clausez00_1493;
																																																									BgL_clausez00_1493
																																																										=
																																																										CAR
																																																										(BgL_clsz00_1483);
																																																									{	/* Ast/sexp.scm 463 */
																																																										BgL_nodez00_bglt
																																																											BgL_bodyz00_1494;
																																																										{	/* Ast/sexp.scm 464 */
																																																											obj_t
																																																												BgL_arg3660z00_1508;
																																																											obj_t
																																																												BgL_arg3661z00_1509;
																																																											obj_t
																																																												BgL_arg3662z00_1510;
																																																											BgL_arg3660z00_1508
																																																												=
																																																												BGl_normaliza7ezd2prognz75zztools_prognz00
																																																												(CDR
																																																												(BgL_clausez00_1493));
																																																											BgL_arg3661z00_1509
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_clausez00_1493,
																																																												BgL_cddlocz00_1480);
																																																											BgL_arg3662z00_1510
																																																												=
																																																												CNST_TABLE_REF
																																																												(
																																																												((long) 1));
																																																											BgL_bodyz00_1494
																																																												=
																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																												(BgL_arg3660z00_1508,
																																																												BgL_stackz00_18,
																																																												BgL_arg3661z00_1509,
																																																												BgL_arg3662z00_1510);
																																																										}
																																																										{	/* Ast/sexp.scm 464 */
																																																											obj_t
																																																												BgL_nclausez00_1495;
																																																											BgL_nclausez00_1495
																																																												=
																																																												MAKE_PAIR
																																																												(CAR
																																																												(BgL_clausez00_1493),
																																																												(obj_t)
																																																												(BgL_bodyz00_1494));
																																																											{	/* Ast/sexp.scm 468 */

																																																												{	/* Ast/sexp.scm 470 */
																																																													bool_t
																																																														BgL_testz00_3549;
																																																													if ((CAR(BgL_clausez00_1493) == CNST_TABLE_REF(((long) 10))))
																																																														{	/* Ast/sexp.scm 470 */
																																																															if (NULLP(CDR(BgL_clsz00_1483)))
																																																																{	/* Ast/sexp.scm 471 */
																																																																	BgL_testz00_3549
																																																																		=
																																																																		(
																																																																		(bool_t)
																																																																		0);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 471 */
																																																																	BgL_testz00_3549
																																																																		=
																																																																		(
																																																																		(bool_t)
																																																																		1);
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 470 */
																																																															BgL_testz00_3549
																																																																=
																																																																(
																																																																(bool_t)
																																																																0);
																																																														}
																																																													if (BgL_testz00_3549)
																																																														{	/* Ast/sexp.scm 472 */
																																																															obj_t
																																																																BgL_arg3649z00_1498;
																																																															BgL_arg3649z00_1498
																																																																=
																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																(BgL_expz00_17,
																																																																BgL_locz00_1478);
																																																															BgL_auxz00_3515
																																																																=
																																																																(obj_t)
																																																																(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																																																(BGl_string3898z00zzast_sexpz00,
																																																																	BgL_expz00_17,
																																																																	BgL_arg3649z00_1498));
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 475 */
																																																															obj_t
																																																																BgL_arg3650z00_1499;
																																																															obj_t
																																																																BgL_arg3651z00_1500;
																																																															BgL_arg3650z00_1499
																																																																=
																																																																CDR
																																																																(BgL_clsz00_1483);
																																																															BgL_arg3651z00_1500
																																																																=
																																																																MAKE_PAIR
																																																																(BGl_epairifyz00zztools_miscz00
																																																																(BgL_nclausez00_1495,
																																																																	BgL_clausez00_1493),
																																																																BgL_nclausesz00_1484);
																																																															{
																																																																obj_t
																																																																	BgL_nclausesz00_3564;
																																																																obj_t
																																																																	BgL_clsz00_3563;
																																																																BgL_clsz00_3563
																																																																	=
																																																																	BgL_arg3650z00_1499;
																																																																BgL_nclausesz00_3564
																																																																	=
																																																																	BgL_arg3651z00_1500;
																																																																BgL_nclausesz00_1484
																																																																	=
																																																																	BgL_nclausesz00_3564;
																																																																BgL_clsz00_1483
																																																																	=
																																																																	BgL_clsz00_3563;
																																																																goto
																																																																	BgL_loopz00_1485;
																																																															}
																																																														}
																																																												}
																																																											}
																																																										}
																																																									}
																																																								}
																																																						}
																																																					}
																																																				}
																																																			}
																																																		}
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 85 */
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_3567;
																																																BgL_tagzd22063zd2_1471:
																																																	BgL_auxz00_3567 = BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string3898z00zzast_sexpz00, BgL_expz00_17, BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19));
																																																	BgL_auxz00_3515
																																																		=
																																																		(obj_t)
																																																		(BgL_auxz00_3567);
																																																}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 85 */
																																															BgL_nodez00_bglt
																																																BgL_auxz00_3571;
																																															goto
																																																BgL_tagzd22063zd2_1471;
																																															BgL_auxz00_3515
																																																=
																																																(obj_t)
																																																(BgL_auxz00_3571);
																																														}
																																												}
																																												return
																																													(BgL_nodez00_bglt)
																																													(BgL_auxz00_3515);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 85 */
																																												if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 28))))
																																													{	/* Ast/sexp.scm 85 */
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_3578;
																																														BgL_auxz00_3578
																																															=
																																															BGl_setzd2exitzd2ze3nodeze3zzast_exitz00
																																															(BgL_expz00_17,
																																															BgL_stackz00_18,
																																															BgL_locz00_19,
																																															BgL_sitez00_20);
																																														return
																																															(BgL_nodez00_bglt)
																																															(BgL_auxz00_3578);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 85 */
																																														if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 29))))
																																															{	/* Ast/sexp.scm 85 */
																																																BgL_jumpzd2exzd2itz00_bglt
																																																	BgL_auxz00_3585;
																																																BgL_auxz00_3585
																																																	=
																																																	BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00
																																																	(BgL_expz00_17,
																																																	BgL_stackz00_18,
																																																	BgL_locz00_19,
																																																	BgL_sitez00_20);
																																																return
																																																	(BgL_nodez00_bglt)
																																																	(BgL_auxz00_3585);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 85 */
																																																obj_t
																																																	BgL_cdrzd21845zd2_989;
																																																BgL_cdrzd21845zd2_989
																																																	=
																																																	CDR
																																																	(BgL_expz00_17);
																																																if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 22))))
																																																	{	/* Ast/sexp.scm 85 */
																																																		if (PAIRP(BgL_cdrzd21845zd2_989))
																																																			{	/* Ast/sexp.scm 85 */
																																																				obj_t
																																																					BgL_cdrzd21847zd2_992;
																																																				BgL_cdrzd21847zd2_992
																																																					=
																																																					CDR
																																																					(BgL_cdrzd21845zd2_989);
																																																				if (PAIRP(BgL_cdrzd21847zd2_992))
																																																					{	/* Ast/sexp.scm 85 */
																																																						if (NULLP(CDR(BgL_cdrzd21847zd2_992)))
																																																							{	/* Ast/sexp.scm 85 */
																																																								return
																																																									BGl_applycationzd2ze3nodez31zzast_applyz00
																																																									(BgL_expz00_17,
																																																									BgL_stackz00_18,
																																																									BgL_locz00_19,
																																																									BgL_sitez00_20);
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 85 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																																									{	/* Ast/sexp.scm 85 */
																																																										obj_t
																																																											BgL_auxz00_3604;
																																																										goto
																																																											BgL_tagzd21487zd2_907;
																																																										return
																																																											(BgL_nodez00_bglt)
																																																											(BgL_auxz00_3604);
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 85 */
																																																										goto
																																																											BgL_tagzd21488zd2_908;
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 85 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																																							{	/* Ast/sexp.scm 85 */
																																																								obj_t
																																																									BgL_auxz00_3608;
																																																								goto
																																																									BgL_tagzd21487zd2_907;
																																																								return
																																																									(BgL_nodez00_bglt)
																																																									(BgL_auxz00_3608);
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 85 */
																																																								goto
																																																									BgL_tagzd21488zd2_908;
																																																							}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 85 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																																					{	/* Ast/sexp.scm 85 */
																																																						obj_t
																																																							BgL_auxz00_3612;
																																																						goto
																																																							BgL_tagzd21487zd2_907;
																																																						return
																																																							(BgL_nodez00_bglt)
																																																							(BgL_auxz00_3612);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 85 */
																																																						goto
																																																							BgL_tagzd21488zd2_908;
																																																					}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 85 */
																																																		if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_17), BUNSPEC))
																																																			{	/* Ast/sexp.scm 85 */
																																																				if (NULLP(BgL_cdrzd21845zd2_989))
																																																					{	/* Ast/sexp.scm 85 */
																																																						return
																																																							BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																																							(BGl_string3897z00zzast_sexpz00,
																																																							BgL_expz00_17,
																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																							(BgL_expz00_17,
																																																								BgL_locz00_19));
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 85 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																																							{	/* Ast/sexp.scm 85 */
																																																								obj_t
																																																									BgL_auxz00_3623;
																																																								goto
																																																									BgL_tagzd21487zd2_907;
																																																								return
																																																									(BgL_nodez00_bglt)
																																																									(BgL_auxz00_3623);
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 85 */
																																																								goto
																																																									BgL_tagzd21488zd2_908;
																																																							}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 85 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																																					{	/* Ast/sexp.scm 85 */
																																																						obj_t
																																																							BgL_auxz00_3627;
																																																						goto
																																																							BgL_tagzd21487zd2_907;
																																																						return
																																																							(BgL_nodez00_bglt)
																																																							(BgL_auxz00_3627);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 85 */
																																																						goto
																																																							BgL_tagzd21488zd2_908;
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
									}
								else
									{	/* Ast/sexp.scm 85 */
										obj_t BgL_auxz00_3629;

										BgL_atomz00_874 = BgL_expz00_17;
										if (SYMBOLP(BgL_atomz00_874))
											{	/* Ast/sexp.scm 95 */
												if (CBOOL(BGl_lookupz00zzast_sexpz00(BgL_atomz00_874,
															BgL_stackz00_18)))
													{	/* Ast/sexp.scm 118 */
														obj_t BgL_localz00_1042;

														BgL_localz00_1042 =
															BGl_lookupz00zzast_sexpz00(BgL_atomz00_874,
															BgL_stackz00_18);
														{	/* Ast/sexp.scm 118 */
															obj_t BgL_varz00_1043;

															{	/* Ast/sexp.scm 119 */
																bool_t BgL_testz00_3636;

																if (
																	(BgL_sitez00_20 ==
																		CNST_TABLE_REF(((long) 19))))
																	{	/* Ast/sexp.scm 119 */
																		BgL_testz00_3636 = ((bool_t) 0);
																	}
																else
																	{	/* Ast/sexp.scm 120 */
																		BgL_valuez00_bglt BgL_arg3331z00_1048;

																		{
																			BgL_variablez00_bglt BgL_auxz00_3640;

																			BgL_auxz00_3640 =
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1042);
																			BgL_arg3331z00_1048 =
																				(((BgL_variablez00_bglt)
																					CREF(BgL_auxz00_3640))->BgL_valuez00);
																		}
																		{	/* Ast/sexp.scm 120 */
																			obj_t BgL_obj1776z00_2178;

																			BgL_obj1776z00_2178 =
																				(obj_t) (BgL_arg3331z00_1048);
																			BgL_testz00_3636 =
																				BGl_iszd2azf3z21zz__objectz00
																				(BgL_obj1776z00_2178,
																				BGl_funz00zzast_varz00);
																		}
																	}
																if (BgL_testz00_3636)
																	{	/* Ast/sexp.scm 123 */
																		BgL_typez00_bglt BgL_arg3328z00_1045;

																		{
																			BgL_variablez00_bglt BgL_auxz00_3645;

																			BgL_auxz00_3645 =
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1042);
																			BgL_arg3328z00_1045 =
																				(((BgL_variablez00_bglt)
																					CREF(BgL_auxz00_3645))->BgL_typez00);
																		}
																		BgL_varz00_1043 =
																			(obj_t)
																			(BGl_makezd2closurezd2zzast_nodez00
																			(BgL_locz00_19, BgL_arg3328z00_1045,
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1042)));
																	}
																else
																	{	/* Ast/sexp.scm 127 */
																		BgL_typez00_bglt BgL_arg3329z00_1046;

																		{
																			BgL_variablez00_bglt BgL_auxz00_3651;

																			BgL_auxz00_3651 =
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1042);
																			BgL_arg3329z00_1046 =
																				(((BgL_variablez00_bglt)
																					CREF(BgL_auxz00_3651))->BgL_typez00);
																		}
																		BgL_varz00_1043 =
																			(obj_t) (BGl_makezd2varzd2zzast_nodez00
																			(BgL_locz00_19, BgL_arg3329z00_1046,
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1042)));
																	}
															}
															{	/* Ast/sexp.scm 119 */

																BGl_usezd2variablez12zc0zzast_sexpz00(
																	(BgL_variablez00_bglt) (BgL_localz00_1042),
																	BgL_locz00_19, BgL_sitez00_20);
																BgL_auxz00_3629 = BgL_varz00_1043;
															}
														}
													}
												else
													{	/* Ast/sexp.scm 132 */
														obj_t BgL_globalz00_1049;

														BgL_globalz00_1049 =
															BGl_findzd2globalzd2zzast_envz00(BgL_atomz00_874,
															BNIL);
														if (BGl_iszd2azf3z21zz__objectz00
															(BgL_globalz00_1049, BGl_globalz00zzast_varz00))
															{	/* Ast/sexp.scm 136 */
																bool_t BgL_testz00_3662;

																{	/* Ast/sexp.scm 136 */
																	obj_t BgL_auxz00_3663;

																	{
																		BgL_globalz00_bglt BgL_auxz00_3664;

																		BgL_auxz00_3664 =
																			(BgL_globalz00_bglt) (BgL_globalz00_1049);
																		BgL_auxz00_3663 =
																			(((BgL_globalz00_bglt)
																				CREF(BgL_auxz00_3664))->BgL_importz00);
																	}
																	BgL_testz00_3662 =
																		(BgL_auxz00_3663 ==
																		CNST_TABLE_REF(((long) 18)));
																}
																if (BgL_testz00_3662)
																	{	/* Ast/sexp.scm 137 */
																		obj_t BgL_arg3334z00_1052;

																		{	/* Ast/sexp.scm 137 */
																			obj_t BgL_arg3335z00_1053;

																			obj_t BgL_arg3336z00_1054;

																			BgL_arg3335z00_1053 =
																				CNST_TABLE_REF(((long) 18));
																			{	/* Ast/sexp.scm 137 */
																				obj_t BgL_arg3337z00_1055;

																				{	/* Ast/sexp.scm 137 */
																					obj_t BgL_arg3340z00_1058;

																					obj_t BgL_arg3341z00_1059;

																					BgL_arg3340z00_1058 =
																						CNST_TABLE_REF(((long) 21));
																					{	/* Ast/sexp.scm 137 */
																						obj_t BgL_list3342z00_1060;

																						BgL_list3342z00_1060 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg3341z00_1059 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_atomz00_874,
																							BgL_list3342z00_1060);
																					}
																					BgL_arg3337z00_1055 =
																						MAKE_PAIR(BgL_arg3340z00_1058,
																						BgL_arg3341z00_1059);
																				}
																				{	/* Ast/sexp.scm 137 */
																					obj_t BgL_list3339z00_1057;

																					BgL_list3339z00_1057 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3336z00_1054 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg3337z00_1055,
																						BgL_list3339z00_1057);
																			}}
																			BgL_arg3334z00_1052 =
																				MAKE_PAIR(BgL_arg3335z00_1053,
																				BgL_arg3336z00_1054);
																		}
																		BgL_auxz00_3629 =
																			(obj_t)
																			(BGl_sexpzd2ze3nodez31zzast_sexpz00
																			(BgL_arg3334z00_1052, BgL_stackz00_18,
																				BgL_locz00_19, BgL_sitez00_20));
																	}
																else
																	{	/* Ast/sexp.scm 136 */
																		BGl_usezd2variablez12zc0zzast_sexpz00(
																			(BgL_variablez00_bglt)
																			(BgL_globalz00_1049), BgL_locz00_19,
																			BgL_sitez00_20);
																		{	/* Ast/sexp.scm 140 */
																			bool_t BgL_testz00_3681;

																			if (
																				(BgL_sitez00_20 ==
																					CNST_TABLE_REF(((long) 19))))
																				{	/* Ast/sexp.scm 140 */
																					BgL_testz00_3681 = ((bool_t) 0);
																				}
																			else
																				{	/* Ast/sexp.scm 140 */
																					BgL_valuez00_bglt BgL_arg3358z00_1076;

																					{
																						BgL_variablez00_bglt
																							BgL_auxz00_3685;
																						BgL_auxz00_3685 =
																							(BgL_variablez00_bglt)
																							(BgL_globalz00_1049);
																						BgL_arg3358z00_1076 =
																							(((BgL_variablez00_bglt)
																								CREF(BgL_auxz00_3685))->
																							BgL_valuez00);
																					}
																					{	/* Ast/sexp.scm 140 */
																						obj_t BgL_obj1776z00_2184;

																						BgL_obj1776z00_2184 =
																							(obj_t) (BgL_arg3358z00_1076);
																						BgL_testz00_3681 =
																							BGl_iszd2azf3z21zz__objectz00
																							(BgL_obj1776z00_2184,
																							BGl_funz00zzast_varz00);
																					}
																				}
																			if (BgL_testz00_3681)
																				{	/* Ast/sexp.scm 141 */
																					bool_t BgL_testz00_3690;

																					{	/* Ast/sexp.scm 141 */
																						bool_t BgL_testz00_3691;

																						{	/* Ast/sexp.scm 141 */
																							BgL_valuez00_bglt
																								BgL_arg3355z00_1073;
																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_3692;
																								BgL_auxz00_3692 =
																									(BgL_variablez00_bglt)
																									(BgL_globalz00_1049);
																								BgL_arg3355z00_1073 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_auxz00_3692))->
																									BgL_valuez00);
																							}
																							{	/* Ast/sexp.scm 141 */
																								obj_t BgL_obj1938z00_2186;

																								BgL_obj1938z00_2186 =
																									(obj_t) (BgL_arg3355z00_1073);
																								BgL_testz00_3691 =
																									BGl_iszd2azf3z21zz__objectz00
																									(BgL_obj1938z00_2186,
																									BGl_cfunz00zzast_varz00);
																							}
																						}
																						if (BgL_testz00_3691)
																							{	/* Ast/sexp.scm 142 */
																								bool_t BgL_testz00_3697;

																								{	/* Ast/sexp.scm 142 */
																									obj_t BgL_arg3354z00_1072;

																									BgL_arg3354z00_1072 =
																										BGl_thezd2backendzd2zzbackend_backendz00
																										();
																									{
																										BgL_backendz00_bglt
																											BgL_auxz00_3699;
																										BgL_auxz00_3699 =
																											(BgL_backendz00_bglt)
																											(BgL_arg3354z00_1072);
																										BgL_testz00_3697 =
																											(((BgL_backendz00_bglt)
																												CREF(BgL_auxz00_3699))->
																											BgL_foreignzd2closurezd2);
																									}
																								}
																								if (BgL_testz00_3697)
																									{	/* Ast/sexp.scm 142 */
																										BgL_testz00_3690 =
																											((bool_t) 0);
																									}
																								else
																									{	/* Ast/sexp.scm 142 */
																										if (
																											(BgL_sitez00_20 ==
																												CNST_TABLE_REF(((long)
																														22))))
																											{	/* Ast/sexp.scm 143 */
																												BgL_testz00_3690 =
																													((bool_t) 0);
																											}
																										else
																											{	/* Ast/sexp.scm 143 */
																												BgL_testz00_3690 =
																													((bool_t) 1);
																											}
																									}
																							}
																						else
																							{	/* Ast/sexp.scm 141 */
																								BgL_testz00_3690 = ((bool_t) 0);
																							}
																					}
																					if (BgL_testz00_3690)
																						{	/* Ast/sexp.scm 145 */
																							obj_t BgL_arg3345z00_1063;

																							{	/* Ast/sexp.scm 145 */
																								obj_t BgL_arg3347z00_1065;

																								{	/* Ast/sexp.scm 145 */
																									obj_t BgL_arg3349z00_1067;

																									BgL_arg3349z00_1067 =
																										BGl_thezd2backendzd2zzbackend_backendz00
																										();
																									{
																										BgL_backendz00_bglt
																											BgL_auxz00_3706;
																										BgL_auxz00_3706 =
																											(BgL_backendz00_bglt)
																											(BgL_arg3349z00_1067);
																										BgL_arg3347z00_1065 =
																											(((BgL_backendz00_bglt)
																												CREF(BgL_auxz00_3706))->
																											BgL_namez00);
																									}
																								}
																								{	/* Ast/sexp.scm 145 */
																									obj_t BgL_list3348z00_1066;

																									BgL_list3348z00_1066 =
																										MAKE_PAIR
																										(BgL_arg3347z00_1065, BNIL);
																									BgL_arg3345z00_1063 =
																										BGl_formatz00zz__r4_output_6_10_3z00
																										(BGl_string3909z00zzast_sexpz00,
																										BgL_list3348z00_1066);
																								}
																							}
																							BgL_auxz00_3629 =
																								(obj_t)
																								(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																								(BgL_arg3345z00_1063,
																									BgL_expz00_17,
																									BgL_locz00_19));
																						}
																					else
																						{	/* Ast/sexp.scm 149 */
																							BgL_typez00_bglt
																								BgL_arg3350z00_1068;
																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_3713;
																								BgL_auxz00_3713 =
																									(BgL_variablez00_bglt)
																									(BgL_globalz00_1049);
																								BgL_arg3350z00_1068 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_auxz00_3713))->
																									BgL_typez00);
																							}
																							BgL_auxz00_3629 =
																								(obj_t)
																								(BGl_makezd2closurezd2zzast_nodez00
																								(BgL_locz00_19,
																									BgL_arg3350z00_1068,
																									(BgL_variablez00_bglt)
																									(BgL_globalz00_1049)));
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 153 */
																					BgL_typez00_bglt BgL_arg3356z00_1074;

																					{
																						BgL_variablez00_bglt
																							BgL_auxz00_3719;
																						BgL_auxz00_3719 =
																							(BgL_variablez00_bglt)
																							(BgL_globalz00_1049);
																						BgL_arg3356z00_1074 =
																							(((BgL_variablez00_bglt)
																								CREF(BgL_auxz00_3719))->
																							BgL_typez00);
																					}
																					BgL_auxz00_3629 =
																						(obj_t)
																						(BGl_makezd2varzd2zzast_nodez00
																						(BgL_locz00_19, BgL_arg3356z00_1074,
																							(BgL_variablez00_bglt)
																							(BgL_globalz00_1049)));
																				}
																		}
																	}
															}
														else
															{	/* Ast/sexp.scm 134 */
																BgL_auxz00_3629 =
																	(obj_t)
																	(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																	(BGl_string3908z00zzast_sexpz00,
																		BgL_expz00_17, BgL_locz00_19));
															}
													}
											}
										else
											{	/* Ast/sexp.scm 97 */
												bool_t BgL_testz00_3727;

												if (BGl_iszd2azf3z21zz__objectz00(BgL_atomz00_874,
														BGl_localz00zzast_varz00))
													{	/* Ast/sexp.scm 97 */
														BgL_testz00_3727 = ((bool_t) 1);
													}
												else
													{	/* Ast/sexp.scm 97 */
														BgL_testz00_3727 =
															BGl_iszd2azf3z21zz__objectz00(BgL_atomz00_874,
															BGl_globalz00zzast_varz00);
													}
												if (BgL_testz00_3727)
													{	/* Ast/sexp.scm 97 */
														BGl_usezd2variablez12zc0zzast_sexpz00(
															(BgL_variablez00_bglt) (BgL_atomz00_874),
															BgL_locz00_19, BgL_sitez00_20);
														{	/* Ast/sexp.scm 99 */
															bool_t BgL_testz00_3733;

															if (
																(BgL_sitez00_20 == CNST_TABLE_REF(((long) 19))))
																{	/* Ast/sexp.scm 99 */
																	BgL_testz00_3733 = ((bool_t) 0);
																}
															else
																{	/* Ast/sexp.scm 99 */
																	BgL_valuez00_bglt BgL_arg3367z00_1085;

																	{
																		BgL_variablez00_bglt BgL_auxz00_3737;

																		BgL_auxz00_3737 =
																			(BgL_variablez00_bglt) (BgL_atomz00_874);
																		BgL_arg3367z00_1085 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_3737))->BgL_valuez00);
																	}
																	{	/* Ast/sexp.scm 99 */
																		obj_t BgL_obj1776z00_2194;

																		BgL_obj1776z00_2194 =
																			(obj_t) (BgL_arg3367z00_1085);
																		BgL_testz00_3733 =
																			BGl_iszd2azf3z21zz__objectz00
																			(BgL_obj1776z00_2194,
																			BGl_funz00zzast_varz00);
																	}
																}
															if (BgL_testz00_3733)
																{	/* Ast/sexp.scm 102 */
																	BgL_typez00_bglt BgL_arg3364z00_1082;

																	{
																		BgL_variablez00_bglt BgL_auxz00_3742;

																		BgL_auxz00_3742 =
																			(BgL_variablez00_bglt) (BgL_atomz00_874);
																		BgL_arg3364z00_1082 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_3742))->BgL_typez00);
																	}
																	BgL_auxz00_3629 =
																		(obj_t) (BGl_makezd2closurezd2zzast_nodez00
																		(BgL_locz00_19, BgL_arg3364z00_1082,
																			(BgL_variablez00_bglt)
																			(BgL_atomz00_874)));
																}
															else
																{	/* Ast/sexp.scm 106 */
																	BgL_typez00_bglt BgL_arg3365z00_1083;

																	{
																		BgL_variablez00_bglt BgL_auxz00_3748;

																		BgL_auxz00_3748 =
																			(BgL_variablez00_bglt) (BgL_atomz00_874);
																		BgL_arg3365z00_1083 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_3748))->BgL_typez00);
																	}
																	BgL_auxz00_3629 =
																		(obj_t) (BGl_makezd2varzd2zzast_nodez00
																		(BgL_locz00_19, BgL_arg3365z00_1083,
																			(BgL_variablez00_bglt)
																			(BgL_atomz00_874)));
																}
														}
													}
												else
													{	/* Ast/sexp.scm 108 */
														bool_t BgL_testz00_3754;

														if (STRUCTP(BgL_atomz00_874))
															{	/* Ast/sexp.scm 108 */
																BgL_testz00_3754 = ((bool_t) 1);
															}
														else
															{	/* Ast/sexp.scm 108 */
																if (VECTORP(BgL_atomz00_874))
																	{	/* Ast/sexp.scm 109 */
																		BgL_testz00_3754 = ((bool_t) 1);
																	}
																else
																	{	/* Ast/sexp.scm 109 */
																		BgL_testz00_3754 =
																			BGL_OBJECTP(BgL_atomz00_874);
																	}
															}
														if (BgL_testz00_3754)
															{	/* Ast/sexp.scm 108 */
																BgL_auxz00_3629 =
																	(obj_t)
																	(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																	(BGl_string3910z00zzast_sexpz00,
																		BgL_expz00_17, BgL_locz00_19));
															}
														else
															{	/* Ast/sexp.scm 115 */
																BgL_typez00_bglt BgL_arg3369z00_1087;

																BgL_arg3369z00_1087 =
																	BGl_typeofzd2atomzd2zztype_typeofz00
																	(BgL_atomz00_874);
																BgL_auxz00_3629 =
																	(obj_t) (BGl_makezd2atomzd2zzast_nodez00
																	(BgL_locz00_19, BgL_arg3369z00_1087,
																		BgL_atomz00_874));
															}
													}
											}
										return (BgL_nodez00_bglt) (BgL_auxz00_3629);
									}
							}
					}
			}
		}
	}



/* liip */
	obj_t BGl_liipz00zzast_sexpz00(obj_t BgL_argsz00_1377)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 349 */
			if (NULLP(BgL_argsz00_1377))
				{	/* Ast/sexp.scm 350 */
					return CNST_TABLE_REF(((long) 30));
				}
			else
				{	/* Ast/sexp.scm 352 */
					obj_t BgL_arg3578z00_1380;

					obj_t BgL_arg3579z00_1381;

					BgL_arg3578z00_1380 = CNST_TABLE_REF(((long) 31));
					{	/* Ast/sexp.scm 352 */
						obj_t BgL_arg3580z00_1382;

						obj_t BgL_arg3581z00_1383;

						BgL_arg3580z00_1382 = CAR(BgL_argsz00_1377);
						BgL_arg3581z00_1383 =
							BGl_liipz00zzast_sexpz00(CDR(BgL_argsz00_1377));
						{	/* Ast/sexp.scm 352 */
							obj_t BgL_list3583z00_1385;

							{	/* Ast/sexp.scm 352 */
								obj_t BgL_arg3584z00_1386;

								BgL_arg3584z00_1386 = MAKE_PAIR(BNIL, BNIL);
								BgL_list3583z00_1385 =
									MAKE_PAIR(BgL_arg3581z00_1383, BgL_arg3584z00_1386);
							}
							BgL_arg3579z00_1381 =
								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_arg3580z00_1382,
								BgL_list3583z00_1385);
					}}
					return MAKE_PAIR(BgL_arg3578z00_1380, BgL_arg3579z00_1381);
				}
		}
	}



/* loop */
	obj_t BGl_loopz00zzast_sexpz00(obj_t BgL_expz00_2598, obj_t BgL_locz00_2597,
		obj_t BgL_varsz00_1339, obj_t BgL_argsz00_1340)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 334 */
		BGl_loopz00zzast_sexpz00:
			if (NULLP(BgL_varsz00_1339))
				{	/* Ast/sexp.scm 337 */
					if (NULLP(BgL_argsz00_1340))
						{	/* Ast/sexp.scm 338 */
							return BNIL;
						}
					else
						{	/* Ast/sexp.scm 338 */
							return
								BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_2597,
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00()),
								BGl_string3912z00zzast_sexpz00, BgL_expz00_2598, BNIL);
						}
				}
			else
				{	/* Ast/sexp.scm 337 */
					if (PAIRP(BgL_varsz00_1339))
						{	/* Ast/sexp.scm 345 */
							if (BGl_dssslzd2namedzd2constantzf3zf3zztools_dssslz00(CAR
									(BgL_varsz00_1339)))
								{	/* Ast/sexp.scm 355 */
									obj_t BgL_argz00_1350;

									BgL_argz00_1350 =
										BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(CDR
										(BgL_varsz00_1339));
									if (CBOOL(BgL_argz00_1350))
										{
											obj_t BgL_varsz00_3793;

											BgL_varsz00_3793 = BgL_argz00_1350;
											BgL_varsz00_1339 = BgL_varsz00_3793;
											goto BGl_loopz00zzast_sexpz00;
										}
									else
										{
											obj_t BgL_varsz00_3794;

											BgL_varsz00_3794 = BNIL;
											BgL_varsz00_1339 = BgL_varsz00_3794;
											goto BGl_loopz00zzast_sexpz00;
										}
								}
							else
								{	/* Ast/sexp.scm 360 */
									bool_t BgL_testz00_3795;

									{	/* Ast/sexp.scm 360 */
										obj_t BgL_auxz00_3796;

										BgL_auxz00_3796 = CAR(BgL_varsz00_1339);
										BgL_testz00_3795 = SYMBOLP(BgL_auxz00_3796);
									}
									if (BgL_testz00_3795)
										{	/* Ast/sexp.scm 360 */
											if (NULLP(BgL_argsz00_1340))
												{	/* Ast/sexp.scm 366 */
													return
														BGl_userzd2errorzf2locationz20zztools_errorz00
														(BgL_locz00_2597,
														BGl_shapez00zztools_shapez00
														(BGl_currentzd2functionzd2zztools_errorz00()),
														BGl_string3912z00zzast_sexpz00, BgL_expz00_2598,
														BNIL);
												}
											else
												{	/* Ast/sexp.scm 373 */
													obj_t BgL_arg3557z00_1358;

													obj_t BgL_arg3558z00_1359;

													{	/* Ast/sexp.scm 373 */
														obj_t BgL_arg3559z00_1360;

														obj_t BgL_arg3560z00_1361;

														BgL_arg3559z00_1360 = CAR(BgL_varsz00_1339);
														BgL_arg3560z00_1361 = CAR(BgL_argsz00_1340);
														{	/* Ast/sexp.scm 373 */
															obj_t BgL_list3561z00_1362;

															{	/* Ast/sexp.scm 373 */
																obj_t BgL_arg3562z00_1363;

																BgL_arg3562z00_1363 =
																	MAKE_PAIR(BgL_arg3560z00_1361, BNIL);
																BgL_list3561z00_1362 =
																	MAKE_PAIR(BgL_arg3559z00_1360,
																	BgL_arg3562z00_1363);
															}
															BgL_arg3557z00_1358 = BgL_list3561z00_1362;
														}
													}
													BgL_arg3558z00_1359 =
														BGl_loopz00zzast_sexpz00(BgL_expz00_2598,
														BgL_locz00_2597, CDR(BgL_varsz00_1339),
														CDR(BgL_argsz00_1340));
													return MAKE_PAIR(BgL_arg3557z00_1358,
														BgL_arg3558z00_1359);
												}
										}
									else
										{	/* Ast/sexp.scm 360 */
											return
												BGl_userzd2errorzf2locationz20zztools_errorz00
												(BgL_locz00_2597,
												BGl_shapez00zztools_shapez00
												(BGl_currentzd2functionzd2zztools_errorz00()),
												BGl_string3913z00zzast_sexpz00, BgL_expz00_2598, BNIL);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 349 */
							obj_t BgL_arg3571z00_1372;

							{	/* Ast/sexp.scm 349 */
								obj_t BgL_arg3573z00_1374;

								BgL_arg3573z00_1374 =
									BGl_liipz00zzast_sexpz00(BgL_argsz00_1340);
								{	/* Ast/sexp.scm 347 */
									obj_t BgL_list3574z00_1375;

									{	/* Ast/sexp.scm 347 */
										obj_t BgL_arg3576z00_1376;

										BgL_arg3576z00_1376 = MAKE_PAIR(BgL_arg3573z00_1374, BNIL);
										BgL_list3574z00_1375 =
											MAKE_PAIR(BgL_varsz00_1339, BgL_arg3576z00_1376);
									}
									BgL_arg3571z00_1372 = BgL_list3574z00_1375;
								}
							}
							{	/* Ast/sexp.scm 346 */
								obj_t BgL_list3572z00_1373;

								BgL_list3572z00_1373 = MAKE_PAIR(BgL_arg3571z00_1372, BNIL);
								return BgL_list3572z00_1373;
							}
						}
				}
		}
	}



/* _sexp->node */
	obj_t BGl__sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_envz00_2564,
		obj_t BgL_expz00_2565, obj_t BgL_stackz00_2566, obj_t BgL_locz00_2567,
		obj_t BgL_sitez00_2568)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 80 */
			return
				(obj_t) (BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_2565,
					BgL_stackz00_2566, BgL_locz00_2567, BgL_sitez00_2568));
		}
	}



/* <anonymous:3590> */
	obj_t BGl_zc3anonymousza33590ze3z83zzast_sexpz00(obj_t BgL_envz00_2569,
		obj_t BgL_objz00_2571, obj_t BgL_procz00_2572, obj_t BgL_msgz00_2573)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 379 */
			{	/* Ast/sexp.scm 380 */
				obj_t BgL_locz00_2570;

				BgL_locz00_2570 = PROCEDURE_REF(BgL_envz00_2569, (int) (((long) 0)));
				{
					obj_t BgL_objz00_1392;

					obj_t BgL_procz00_1393;

					obj_t BgL_msgz00_1394;

					BgL_objz00_1392 = BgL_objz00_2571;
					BgL_procz00_1393 = BgL_procz00_2572;
					BgL_msgz00_1394 = BgL_msgz00_2573;
					return
						BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_2570,
						BgL_objz00_1392, BgL_procz00_1393, BgL_msgz00_1394, BNIL);
				}
			}
		}
	}



/* sexp*->node */
	BGL_EXPORTED_DEF obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t
		BgL_expza2za2_21, obj_t BgL_stackz00_22, obj_t BgL_locz00_23,
		obj_t BgL_sitez00_24)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 556 */
			{
				obj_t BgL_expsz00_1590;

				obj_t BgL_resz00_1591;

				obj_t BgL_locz00_1592;

				BgL_expsz00_1590 = BgL_expza2za2_21;
				BgL_resz00_1591 = BNIL;
				BgL_locz00_1592 = BgL_locz00_23;
			BgL_loopz00_1593:
				if (NULLP(BgL_expsz00_1590))
					{	/* Ast/sexp.scm 561 */
						return
							(obj_t) (BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
							(BGl_string3914z00zzast_sexpz00, BgL_expsz00_1590,
								BgL_locz00_1592));
					}
				else
					{	/* Ast/sexp.scm 561 */
						if (NULLP(CDR(BgL_expsz00_1590)))
							{	/* Ast/sexp.scm 564 */
								obj_t BgL_locz00_1596;

								obj_t BgL_nsitez00_1597;

								BgL_locz00_1596 =
									BGl_findzd2locationzf2locz20zztools_locationz00(CAR
									(BgL_expsz00_1590),
									BGl_findzd2locationzf2locz20zztools_locationz00
									(BgL_expsz00_1590, BgL_locz00_1592));
								if ((BgL_sitez00_24 == CNST_TABLE_REF(((long) 19))))
									{	/* Ast/sexp.scm 566 */
										BgL_nsitez00_1597 = CNST_TABLE_REF(((long) 1));
									}
								else
									{	/* Ast/sexp.scm 566 */
										BgL_nsitez00_1597 = BgL_sitez00_24;
									}
								{	/* Ast/sexp.scm 567 */
									obj_t BgL_arg3728z00_1598;

									{	/* Ast/sexp.scm 567 */
										BgL_nodez00_bglt BgL_arg3729z00_1599;

										BgL_arg3729z00_1599 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(CAR(BgL_expsz00_1590),
											BgL_stackz00_22, BgL_locz00_1596, BgL_nsitez00_1597);
										BgL_arg3728z00_1598 =
											MAKE_PAIR((obj_t) (BgL_arg3729z00_1599), BgL_resz00_1591);
									}
									return bgl_reverse_bang(BgL_arg3728z00_1598);
								}
							}
						else
							{	/* Ast/sexp.scm 569 */
								obj_t BgL_locz00_1604;

								BgL_locz00_1604 =
									BGl_findzd2locationzf2locz20zztools_locationz00(CAR
									(BgL_expsz00_1590),
									BGl_findzd2locationzf2locz20zztools_locationz00
									(BgL_expsz00_1590, BgL_locz00_1592));
								{	/* Ast/sexp.scm 571 */
									obj_t BgL_arg3734z00_1605;

									obj_t BgL_arg3735z00_1606;

									BgL_arg3734z00_1605 = CDR(BgL_expsz00_1590);
									{	/* Ast/sexp.scm 572 */
										BgL_nodez00_bglt BgL_arg3736z00_1607;

										{	/* Ast/sexp.scm 572 */
											obj_t BgL_arg3737z00_1608;

											obj_t BgL_arg3738z00_1609;

											BgL_arg3737z00_1608 = CAR(BgL_expsz00_1590);
											BgL_arg3738z00_1609 = CNST_TABLE_REF(((long) 1));
											BgL_arg3736z00_1607 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3737z00_1608,
												BgL_stackz00_22, BgL_locz00_1604, BgL_arg3738z00_1609);
										}
										BgL_arg3735z00_1606 =
											MAKE_PAIR((obj_t) (BgL_arg3736z00_1607), BgL_resz00_1591);
									}
									{
										obj_t BgL_locz00_3854;

										obj_t BgL_resz00_3853;

										obj_t BgL_expsz00_3852;

										BgL_expsz00_3852 = BgL_arg3734z00_1605;
										BgL_resz00_3853 = BgL_arg3735z00_1606;
										BgL_locz00_3854 = BgL_locz00_1604;
										BgL_locz00_1592 = BgL_locz00_3854;
										BgL_resz00_1591 = BgL_resz00_3853;
										BgL_expsz00_1590 = BgL_expsz00_3852;
										goto BgL_loopz00_1593;
									}
								}
							}
					}
			}
		}
	}



/* _sexp*->node */
	obj_t BGl__sexpza2zd2ze3nodez93zzast_sexpz00(obj_t BgL_envz00_2574,
		obj_t BgL_expza2za2_2575, obj_t BgL_stackz00_2576, obj_t BgL_locz00_2577,
		obj_t BgL_sitez00_2578)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 556 */
			return
				BGl_sexpza2zd2ze3nodez93zzast_sexpz00(BgL_expza2za2_2575,
				BgL_stackz00_2576, BgL_locz00_2577, BgL_sitez00_2578);
		}
	}



/* lookup */
	obj_t BGl_lookupz00zzast_sexpz00(obj_t BgL_namez00_25, obj_t BgL_stackz00_26)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 585 */
			{	/* Ast/sexp.scm 586 */
				bool_t BgL_testz00_3856;

				if ((BgL_namez00_25 == BGl_za2cachezd2nameza2zd2zzast_sexpz00))
					{	/* Ast/sexp.scm 586 */
						BgL_testz00_3856 =
							(BgL_stackz00_26 == BGl_za2cachezd2stackza2zd2zzast_sexpz00);
					}
				else
					{	/* Ast/sexp.scm 586 */
						BgL_testz00_3856 = ((bool_t) 0);
					}
				if (BgL_testz00_3856)
					{	/* Ast/sexp.scm 586 */
						return BGl_za2cachezd2resza2zd2zzast_sexpz00;
					}
				else
					{	/* Ast/sexp.scm 586 */
						BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BgL_namez00_25;
						BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BgL_stackz00_26;
						{
							obj_t BgL_stackz00_1614;

							BgL_stackz00_1614 = BgL_stackz00_26;
						BgL_loopz00_1615:
							if (NULLP(BgL_stackz00_1614))
								{	/* Ast/sexp.scm 594 */
									BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE;
									return BFALSE;
								}
							else
								{	/* Ast/sexp.scm 597 */
									bool_t BgL_testz00_3862;

									{	/* Ast/sexp.scm 597 */
										obj_t BgL_auxz00_3863;

										{	/* Ast/sexp.scm 597 */
											BgL_variablez00_bglt BgL_obj1523z00_2497;

											{	/* Ast/sexp.scm 597 */
												obj_t BgL_pairz00_2496;

												BgL_pairz00_2496 = BgL_stackz00_1614;
												BgL_obj1523z00_2497 =
													(BgL_variablez00_bglt) (CAR(BgL_pairz00_2496));
											}
											BgL_auxz00_3863 =
												(((BgL_variablez00_bglt) CREF(BgL_obj1523z00_2497))->
												BgL_idz00);
										}
										BgL_testz00_3862 = (BgL_auxz00_3863 == BgL_namez00_25);
									}
									if (BgL_testz00_3862)
										{	/* Ast/sexp.scm 597 */
											BGl_za2cachezd2resza2zd2zzast_sexpz00 =
												CAR(BgL_stackz00_1614);
											return CAR(BgL_stackz00_1614);
										}
									else
										{
											obj_t BgL_stackz00_3870;

											BgL_stackz00_3870 = CDR(BgL_stackz00_1614);
											BgL_stackz00_1614 = BgL_stackz00_3870;
											goto BgL_loopz00_1615;
										}
								}
						}
					}
			}
		}
	}



/* use-variable! */
	BGL_EXPORTED_DEF obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt BgL_varz00_27,
		obj_t BgL_locz00_28, obj_t BgL_sitez00_29)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 606 */
			if ((BgL_sitez00_29 == CNST_TABLE_REF(((long) 12))))
				{	/* Ast/sexp.scm 609 */
					BgL_variablez00_bglt BgL_obj1535z00_2501;

					obj_t BgL_val1534z00_2502;

					BgL_obj1535z00_2501 = BgL_varz00_27;
					BgL_val1534z00_2502 = CNST_TABLE_REF(((long) 32));
					((((BgL_variablez00_bglt) CREF(BgL_obj1535z00_2501))->BgL_accessz00) =
						((obj_t) BgL_val1534z00_2502), BUNSPEC);
				}
			else
				{	/* Ast/sexp.scm 608 */
					BFALSE;
				}
			{	/* Ast/sexp.scm 610 */
				BgL_valuez00_bglt BgL_valz00_1623;

				BgL_valz00_1623 =
					(((BgL_variablez00_bglt) CREF(BgL_varz00_27))->BgL_valuez00);
				{	/* Ast/sexp.scm 611 */
					bool_t BgL_testz00_3878;

					if ((BgL_sitez00_29 == CNST_TABLE_REF(((long) 12))))
						{	/* Ast/sexp.scm 611 */
							obj_t BgL_obj1776z00_2504;

							BgL_obj1776z00_2504 = (obj_t) (BgL_valz00_1623);
							BgL_testz00_3878 =
								BGl_iszd2azf3z21zz__objectz00(BgL_obj1776z00_2504,
								BGl_funz00zzast_varz00);
						}
					else
						{	/* Ast/sexp.scm 611 */
							BgL_testz00_3878 = ((bool_t) 0);
						}
					if (BgL_testz00_3878)
						{	/* Ast/sexp.scm 612 */
							obj_t BgL_arg3753z00_1626;

							BgL_arg3753z00_1626 =
								BGl_shapez00zztools_shapez00((obj_t) (BgL_varz00_27));
							return
								(obj_t) (BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
								(BGl_string3915z00zzast_sexpz00, BgL_arg3753z00_1626,
									BgL_locz00_28));
						}
					else
						{	/* Ast/sexp.scm 611 */
							return BFALSE;
						}
				}
			}
		}
	}



/* _use-variable! */
	obj_t BGl__usezd2variablez12zc0zzast_sexpz00(obj_t BgL_envz00_2579,
		obj_t BgL_varz00_2580, obj_t BgL_locz00_2581, obj_t BgL_sitez00_2582)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 606 */
			return
				BGl_usezd2variablez12zc0zzast_sexpz00(
				(BgL_variablez00_bglt) (BgL_varz00_2580), BgL_locz00_2581,
				BgL_sitez00_2582);
		}
	}



/* error-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t BgL_msgz00_30,
		obj_t BgL_expz00_31, obj_t BgL_locz00_32)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 617 */
			{	/* Ast/sexp.scm 619 */
				obj_t BgL_arg3755z00_1628;

				BgL_nodez00_bglt BgL_arg3756z00_1629;

				BgL_arg3755z00_1628 =
					BGl_shapez00zztools_shapez00(BGl_currentzd2functionzd2zztools_errorz00
					());
				BgL_arg3756z00_1629 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 30)), BNIL,
					BgL_locz00_32, CNST_TABLE_REF(((long) 1)));
				{	/* Ast/sexp.scm 618 */
					obj_t BgL_list3757z00_1630;

					BgL_list3757z00_1630 = MAKE_PAIR((obj_t) (BgL_arg3756z00_1629), BNIL);
					return
						(BgL_nodez00_bglt) (BGl_userzd2errorzf2locationz20zztools_errorz00
						(BgL_locz00_32, BgL_arg3755z00_1628, BgL_msgz00_30, BgL_expz00_31,
							BgL_list3757z00_1630));
				}
			}
		}
	}



/* _error-sexp->node */
	obj_t BGl__errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t BgL_envz00_2583,
		obj_t BgL_msgz00_2584, obj_t BgL_expz00_2585, obj_t BgL_locz00_2586)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 617 */
			return
				(obj_t) (BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BgL_msgz00_2584,
					BgL_expz00_2585, BgL_locz00_2586));
		}
	}



/* define-primop-ref->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_33, BgL_nodez00_bglt BgL_refz00_34)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 627 */
			{	/* Ast/sexp.scm 628 */
				BgL_nodez00_bglt BgL_funz00_1632;

				BgL_funz00_1632 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 33)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 19)));
				{	/* Ast/sexp.scm 629 */
					bool_t BgL_testz00_3904;

					{	/* Ast/sexp.scm 629 */
						obj_t BgL_obj2088z00_2505;

						BgL_obj2088z00_2505 = (obj_t) (BgL_funz00_1632);
						BgL_testz00_3904 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj2088z00_2505,
							BGl_varz00zzast_nodez00);
					}
					if (BgL_testz00_3904)
						{	/* Ast/sexp.scm 630 */
							obj_t BgL_arg3761z00_1635;

							{	/* Ast/sexp.scm 632 */
								BgL_nodez00_bglt BgL_arg3762z00_1636;

								{	/* Ast/sexp.scm 632 */
									obj_t BgL_arg3765z00_1639;

									obj_t BgL_arg3767z00_1641;

									{	/* Ast/sexp.scm 632 */
										obj_t BgL_arg3768z00_1642;

										obj_t BgL_arg3769z00_1643;

										BgL_arg3768z00_1642 = CNST_TABLE_REF(((long) 21));
										{	/* Ast/sexp.scm 632 */
											obj_t BgL_arg3770z00_1644;

											{
												BgL_variablez00_bglt BgL_auxz00_3908;

												BgL_auxz00_3908 =
													(BgL_variablez00_bglt) (BgL_globalz00_33);
												BgL_arg3770z00_1644 =
													(((BgL_variablez00_bglt) CREF(BgL_auxz00_3908))->
													BgL_idz00);
											}
											{	/* Ast/sexp.scm 632 */
												obj_t BgL_list3772z00_1646;

												BgL_list3772z00_1646 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3769z00_1643 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3770z00_1644, BgL_list3772z00_1646);
										}}
										BgL_arg3765z00_1639 =
											MAKE_PAIR(BgL_arg3768z00_1642, BgL_arg3769z00_1643);
									}
									BgL_arg3767z00_1641 = CNST_TABLE_REF(((long) 1));
									BgL_arg3762z00_1636 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3765z00_1639,
										BNIL, BFALSE, BgL_arg3767z00_1641);
								}
								{	/* Ast/sexp.scm 632 */
									obj_t BgL_list3763z00_1637;

									{	/* Ast/sexp.scm 632 */
										obj_t BgL_arg3764z00_1638;

										BgL_arg3764z00_1638 =
											MAKE_PAIR((obj_t) (BgL_refz00_34), BNIL);
										BgL_list3763z00_1637 =
											MAKE_PAIR(
											(obj_t) (BgL_arg3762z00_1636), BgL_arg3764z00_1638);
									}
									BgL_arg3761z00_1635 = BgL_list3763z00_1637;
							}}
							return
								(BgL_nodez00_bglt) (BGl_makezd2appzd2zzast_nodez00(BFALSE,
									(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00), BUNSPEC,
									BINT(((long) -1)),
									(BgL_varz00_bglt) (BgL_funz00_1632), BgL_arg3761z00_1635));
						}
					else
						{	/* Ast/sexp.scm 629 */
							return BgL_funz00_1632;
						}
				}
			}
		}
	}



/* _define-primop-ref->node */
	obj_t BGl__definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(obj_t
		BgL_envz00_2587, obj_t BgL_globalz00_2588, obj_t BgL_refz00_2589)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 627 */
			return
				(obj_t) (BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(
					(BgL_globalz00_bglt) (BgL_globalz00_2588),
					(BgL_nodez00_bglt) (BgL_refz00_2589)));
		}
	}



/* define-primop->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_35)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 642 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				(BgL_variablez00_bglt) (BgL_globalz00_35), BFALSE,
				CNST_TABLE_REF(((long) 1)));
			{	/* Ast/sexp.scm 644 */
				BgL_nodez00_bglt BgL_funz00_1647;

				BgL_funz00_1647 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 34)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 19)));
				{	/* Ast/sexp.scm 645 */
					bool_t BgL_testz00_3935;

					{	/* Ast/sexp.scm 645 */
						obj_t BgL_obj2088z00_2509;

						BgL_obj2088z00_2509 = (obj_t) (BgL_funz00_1647);
						BgL_testz00_3935 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj2088z00_2509,
							BGl_varz00zzast_nodez00);
					}
					if (BgL_testz00_3935)
						{	/* Ast/sexp.scm 646 */
							obj_t BgL_arg3775z00_1650;

							{	/* Ast/sexp.scm 648 */
								BgL_nodez00_bglt BgL_arg3776z00_1651;

								BgL_nodez00_bglt BgL_arg3778z00_1652;

								{	/* Ast/sexp.scm 648 */
									obj_t BgL_arg3781z00_1655;

									obj_t BgL_arg3783z00_1657;

									{	/* Ast/sexp.scm 648 */
										obj_t BgL_arg3784z00_1658;

										obj_t BgL_arg3785z00_1659;

										BgL_arg3784z00_1658 = CNST_TABLE_REF(((long) 21));
										{	/* Ast/sexp.scm 648 */
											obj_t BgL_arg3786z00_1660;

											{
												BgL_variablez00_bglt BgL_auxz00_3939;

												BgL_auxz00_3939 =
													(BgL_variablez00_bglt) (BgL_globalz00_35);
												BgL_arg3786z00_1660 =
													(((BgL_variablez00_bglt) CREF(BgL_auxz00_3939))->
													BgL_idz00);
											}
											{	/* Ast/sexp.scm 648 */
												obj_t BgL_list3788z00_1662;

												BgL_list3788z00_1662 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3785z00_1659 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3786z00_1660, BgL_list3788z00_1662);
										}}
										BgL_arg3781z00_1655 =
											MAKE_PAIR(BgL_arg3784z00_1658, BgL_arg3785z00_1659);
									}
									BgL_arg3783z00_1657 = CNST_TABLE_REF(((long) 1));
									BgL_arg3776z00_1651 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3781z00_1655,
										BNIL, BFALSE, BgL_arg3783z00_1657);
								}
								BgL_arg3778z00_1652 =
									BGl_sexpzd2ze3nodez31zzast_sexpz00(
									(obj_t) (BgL_globalz00_35), BNIL, BFALSE,
									CNST_TABLE_REF(((long) 1)));
								{	/* Ast/sexp.scm 648 */
									obj_t BgL_list3779z00_1653;

									{	/* Ast/sexp.scm 648 */
										obj_t BgL_arg3780z00_1654;

										BgL_arg3780z00_1654 =
											MAKE_PAIR((obj_t) (BgL_arg3778z00_1652), BNIL);
										BgL_list3779z00_1653 =
											MAKE_PAIR(
											(obj_t) (BgL_arg3776z00_1651), BgL_arg3780z00_1654);
									}
									BgL_arg3775z00_1650 = BgL_list3779z00_1653;
							}}
							return
								(BgL_nodez00_bglt) (BGl_makezd2appzd2zzast_nodez00(BFALSE,
									(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00), BUNSPEC,
									BINT(((long) -1)),
									(BgL_varz00_bglt) (BgL_funz00_1647), BgL_arg3775z00_1650));
						}
					else
						{	/* Ast/sexp.scm 645 */
							return BgL_funz00_1647;
						}
				}
			}
		}
	}



/* _define-primop->node */
	obj_t BGl__definezd2primopzd2ze3nodeze3zzast_sexpz00(obj_t BgL_envz00_2590,
		obj_t BgL_globalz00_2591)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 642 */
			return
				(obj_t) (BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(
					(BgL_globalz00_bglt) (BgL_globalz00_2591)));
		}
	}



/* location->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt BgL_globalz00_36)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 661 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				(BgL_variablez00_bglt) (BgL_globalz00_36), BFALSE,
				CNST_TABLE_REF(((long) 1)));
			{	/* Ast/sexp.scm 663 */
				BgL_nodez00_bglt BgL_funz00_1663;

				BgL_funz00_1663 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 35)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 19)));
				{	/* Ast/sexp.scm 664 */
					bool_t BgL_testz00_3968;

					{	/* Ast/sexp.scm 664 */
						obj_t BgL_obj2088z00_2513;

						BgL_obj2088z00_2513 = (obj_t) (BgL_funz00_1663);
						BgL_testz00_3968 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj2088z00_2513,
							BGl_varz00zzast_nodez00);
					}
					if (BgL_testz00_3968)
						{	/* Ast/sexp.scm 665 */
							obj_t BgL_exprz00_1665;

							{	/* Ast/sexp.scm 665 */
								bool_t BgL_testz00_3971;

								{	/* Ast/sexp.scm 665 */
									obj_t BgL_arg3800z00_1675;

									BgL_arg3800z00_1675 =
										BGl_thezd2backendzd2zzbackend_backendz00();
									{
										BgL_backendz00_bglt BgL_auxz00_3973;

										BgL_auxz00_3973 =
											(BgL_backendz00_bglt) (BgL_arg3800z00_1675);
										BgL_testz00_3971 =
											(((BgL_backendz00_bglt) CREF(BgL_auxz00_3973))->
											BgL_pragmazd2supportzd2);
									}
								}
								if (BgL_testz00_3971)
									{	/* Ast/sexp.scm 666 */
										obj_t BgL_arg3796z00_1671;

										obj_t BgL_arg3797z00_1672;

										BgL_arg3796z00_1671 = CNST_TABLE_REF(((long) 36));
										{	/* Ast/sexp.scm 666 */
											obj_t BgL_list3798z00_1673;

											{	/* Ast/sexp.scm 666 */
												obj_t BgL_arg3799z00_1674;

												BgL_arg3799z00_1674 = MAKE_PAIR(BNIL, BNIL);
												BgL_list3798z00_1673 =
													MAKE_PAIR(
													(obj_t) (BgL_globalz00_36), BgL_arg3799z00_1674);
											}
											BgL_arg3797z00_1672 =
												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
												(BGl_string3916z00zzast_sexpz00, BgL_list3798z00_1673);
										}
										BgL_exprz00_1665 =
											MAKE_PAIR(BgL_arg3796z00_1671, BgL_arg3797z00_1672);
									}
								else
									{	/* Ast/sexp.scm 665 */
										BgL_exprz00_1665 = (obj_t) (BgL_globalz00_36);
									}
							}
							{	/* Ast/sexp.scm 668 */
								obj_t BgL_arg3792z00_1667;

								{	/* Ast/sexp.scm 670 */
									BgL_nodez00_bglt BgL_arg3793z00_1668;

									BgL_arg3793z00_1668 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_exprz00_1665, BNIL,
										BFALSE, CNST_TABLE_REF(((long) 1)));
									{	/* Ast/sexp.scm 670 */
										obj_t BgL_list3794z00_1669;

										BgL_list3794z00_1669 =
											MAKE_PAIR((obj_t) (BgL_arg3793z00_1668), BNIL);
										BgL_arg3792z00_1667 = BgL_list3794z00_1669;
								}}
								return
									(BgL_nodez00_bglt) (BGl_makezd2appzd2zzast_nodez00(BFALSE,
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00),
										BUNSPEC, BINT(((long) -1)),
										(BgL_varz00_bglt) (BgL_funz00_1663), BgL_arg3792z00_1667));
						}}
					else
						{	/* Ast/sexp.scm 664 */
							return BgL_funz00_1663;
						}
				}
			}
		}
	}



/* _location->node */
	obj_t BGl__locationzd2ze3nodez31zzast_sexpz00(obj_t BgL_envz00_2592,
		obj_t BgL_globalz00_2593)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 661 */
			return
				(obj_t) (BGl_locationzd2ze3nodez31zzast_sexpz00(
					(BgL_globalz00_bglt) (BgL_globalz00_2593)));
		}
	}



/* make-anonymous-name */
	BGL_EXPORTED_DEF obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t
		BgL_locz00_37, obj_t BgL_prefz00_38)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 676 */
			{	/* Ast/sexp.scm 677 */
				obj_t BgL_prefz00_1676;

				{	/* Ast/sexp.scm 677 */
					bool_t BgL_testz00_3995;

					if (PAIRP(BgL_prefz00_38))
						{	/* Ast/sexp.scm 677 */
							obj_t BgL_auxz00_3998;

							BgL_auxz00_3998 = CAR(BgL_prefz00_38);
							BgL_testz00_3995 = STRINGP(BgL_auxz00_3998);
						}
					else
						{	/* Ast/sexp.scm 677 */
							BgL_testz00_3995 = ((bool_t) 0);
						}
					if (BgL_testz00_3995)
						{	/* Ast/sexp.scm 677 */
							BgL_prefz00_1676 = CAR(BgL_prefz00_38);
						}
					else
						{	/* Ast/sexp.scm 677 */
							BgL_prefz00_1676 = BGl_string3917z00zzast_sexpz00;
						}
				}
				{	/* Ast/sexp.scm 680 */
					bool_t BgL_testz00_4002;

					if (STRUCTP(BgL_locz00_37))
						{	/* Ast/sexp.scm 680 */
							BgL_testz00_4002 =
								(STRUCT_KEY(BgL_locz00_37) == CNST_TABLE_REF(((long) 13)));
						}
					else
						{	/* Ast/sexp.scm 680 */
							BgL_testz00_4002 = ((bool_t) 0);
						}
					if (BgL_testz00_4002)
						{	/* Ast/sexp.scm 681 */
							obj_t BgL_filez00_1678;

							obj_t BgL_linez00_1679;

							obj_t BgL_basez00_1680;

							BgL_filez00_1678 = STRUCT_REF(BgL_locz00_37, (int) (((long) 0)));
							BgL_linez00_1679 = STRUCT_REF(BgL_locz00_37, (int) (((long) 2)));
							BgL_basez00_1680 =
								SYMBOL_TO_STRING(BGl_gensymz00zz__r4_symbols_6_4z00
								(string_append_3(BGl_string3918z00zzast_sexpz00,
										BgL_prefz00_1676, BGl_string3919z00zzast_sexpz00)));
							{	/* Ast/sexp.scm 685 */
								bool_t BgL_testz00_4015;

								{	/* Ast/sexp.scm 685 */
									bool_t BgL_testz00_4016;

									if (
										((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00) >=
											((long) 1)))
										{	/* Ast/sexp.scm 686 */
											obj_t BgL_arg3820z00_1702;

											obj_t BgL_arg3821z00_1703;

											BgL_arg3820z00_1702 = CNST_TABLE_REF(((long) 37));
											{	/* Ast/sexp.scm 686 */
												obj_t BgL_arg3822z00_1704;

												BgL_arg3822z00_1704 =
													BGl_thezd2backendzd2zzbackend_backendz00();
												{
													BgL_backendz00_bglt BgL_auxz00_4022;

													BgL_auxz00_4022 =
														(BgL_backendz00_bglt) (BgL_arg3822z00_1704);
													BgL_arg3821z00_1703 =
														(((BgL_backendz00_bglt) CREF(BgL_auxz00_4022))->
														BgL_debugzd2supportzd2);
											}}
											BgL_testz00_4016 =
												CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(BgL_arg3820z00_1702, BgL_arg3821z00_1703));
										}
									else
										{	/* Ast/sexp.scm 685 */
											BgL_testz00_4016 = ((bool_t) 0);
										}
									if (BgL_testz00_4016)
										{	/* Ast/sexp.scm 685 */
											BgL_testz00_4015 = ((bool_t) 1);
										}
									else
										{	/* Ast/sexp.scm 685 */
											BgL_testz00_4015 =
												(
												(long)
												CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00) >=
												((long) 1));
								}}
								if (BgL_testz00_4015)
									{	/* Ast/sexp.scm 688 */
										obj_t BgL_filez00_1682;

										if (bigloo_strncmp(BgL_filez00_1678,
												BGl_string3920z00zzast_sexpz00, ((long) 2)))
											{	/* Ast/sexp.scm 688 */
												BgL_filez00_1682 =
													c_substring(BgL_filez00_1678, ((long) 2),
													STRING_LENGTH(BgL_filez00_1678));
											}
										else
											{	/* Ast/sexp.scm 688 */
												BgL_filez00_1682 = BgL_filez00_1678;
											}
										{	/* Ast/sexp.scm 692 */
											obj_t BgL_arg3803z00_1683;

											{	/* Ast/sexp.scm 692 */
												char *BgL_arg3806z00_1686;

												{	/* Ast/sexp.scm 693 */

													BgL_arg3806z00_1686 =
														BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00
														(BgL_linez00_1679, BINT(((long) 10)));
												}
												{	/* Ast/sexp.scm 692 */
													obj_t BgL_list3808z00_1688;

													{	/* Ast/sexp.scm 692 */
														obj_t BgL_arg3809z00_1689;

														{	/* Ast/sexp.scm 692 */
															obj_t BgL_arg3810z00_1690;

															{	/* Ast/sexp.scm 692 */
																obj_t BgL_arg3811z00_1691;

																{	/* Ast/sexp.scm 692 */
																	obj_t BgL_arg3812z00_1692;

																	{	/* Ast/sexp.scm 692 */
																		obj_t BgL_arg3813z00_1693;

																		BgL_arg3813z00_1693 =
																			MAKE_PAIR(BGl_string3921z00zzast_sexpz00,
																			BNIL);
																		BgL_arg3812z00_1692 =
																			MAKE_PAIR(string_to_bstring
																			(BgL_arg3806z00_1686),
																			BgL_arg3813z00_1693);
																	}
																	BgL_arg3811z00_1691 =
																		MAKE_PAIR(BGl_string3919z00zzast_sexpz00,
																		BgL_arg3812z00_1692);
																}
																BgL_arg3810z00_1690 =
																	MAKE_PAIR(BgL_filez00_1682,
																	BgL_arg3811z00_1691);
															}
															BgL_arg3809z00_1689 =
																MAKE_PAIR(BGl_string3919z00zzast_sexpz00,
																BgL_arg3810z00_1690);
														}
														BgL_list3808z00_1688 =
															MAKE_PAIR(BgL_basez00_1680, BgL_arg3809z00_1689);
													}
													BgL_arg3803z00_1683 =
														BGl_stringzd2appendzd2zz__r4_strings_6_7z00
														(BgL_list3808z00_1688);
											}}
											return
												string_to_symbol(BSTRING_TO_STRING
												(BgL_arg3803z00_1683));
										}
									}
								else
									{	/* Ast/sexp.scm 696 */
										obj_t BgL_arg3817z00_1699;

										BgL_arg3817z00_1699 =
											string_append(BgL_basez00_1680,
											BGl_string3921z00zzast_sexpz00);
										return
											string_to_symbol(BSTRING_TO_STRING(BgL_arg3817z00_1699));
									}
							}
						}
					else
						{	/* Ast/sexp.scm 697 */
							obj_t BgL_arg3825z00_1707;

							{	/* Ast/sexp.scm 697 */
								obj_t BgL_arg3826z00_1708;

								obj_t BgL_arg3827z00_1709;

								BgL_arg3826z00_1708 =
									SYMBOL_TO_STRING(BGl_gensymz00zz__r4_symbols_6_4z00
									(string_append_3(BGl_string3918z00zzast_sexpz00,
											BgL_prefz00_1676, BGl_string3922z00zzast_sexpz00)));
								{	/* Ast/sexp.scm 697 */
									obj_t BgL_symbolz00_2550;

									BgL_symbolz00_2550 = CNST_TABLE_REF(((long) 38));
									BgL_arg3827z00_1709 = SYMBOL_TO_STRING(BgL_symbolz00_2550);
								}
								{	/* Ast/sexp.scm 697 */
									obj_t BgL_list3828z00_1710;

									{	/* Ast/sexp.scm 697 */
										obj_t BgL_arg3829z00_1711;

										BgL_arg3829z00_1711 = MAKE_PAIR(BgL_arg3827z00_1709, BNIL);
										BgL_list3828z00_1710 =
											MAKE_PAIR(BgL_arg3826z00_1708, BgL_arg3829z00_1711);
									}
									BgL_arg3825z00_1707 =
										BGl_stringzd2appendzd2zz__r4_strings_6_7z00
										(BgL_list3828z00_1710);
							}}
							return string_to_symbol(BSTRING_TO_STRING(BgL_arg3825z00_1707));
						}
				}
			}
		}
	}



/* _make-anonymous-name */
	obj_t BGl__makezd2anonymouszd2namez00zzast_sexpz00(obj_t BgL_envz00_2594,
		obj_t BgL_locz00_2595, obj_t BgL_prefz00_2596)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 676 */
			return
				BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_2595,
				BgL_prefz00_2596);
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_prognz00(((long) 139728077),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 315910987),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_dssslz00(((long) 315458190),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 341705556),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 446742181),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_buildz00(((long) 46924743),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_pragmaz00(((long) 292906466),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_labelsz00(((long) 473735386),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_letz00(((long) 387357065),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_exitz00(((long) 341189244),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 271227279),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_applyz00(((long) 121557513),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 453255680),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_feffectz00(((long) 53594424),
				BSTRING_TO_STRING(BGl_string3923z00zzast_sexpz00));
		}
	}

#ifdef __cplusplus
}
#endif
