/*===========================================================================*/
/*   (Ast/shrinkify.scm)                                                     */
/*   Bigloo (3.2b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon May 25 12:42:12 CEST 2009       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/shrinkify.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;


	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t
		BGl_shrinkzd2nodez12zd2default3116z12zzast_shrinkifyz00(BgL_nodez00_bglt);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl__shrinkzd2nodez123423zc0zzast_shrinkifyz00(obj_t, obj_t);
	extern obj_t BGl_kwotez00zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2cast3136z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_shrinkzd2nodez12zd2funcall3132z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl__shrinkzd2variablez12zd2def3114z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2setq3138z12zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00();
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2conditi3140z12zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t);
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2extern3134z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2appzd2ly3130zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2boxzd2ref3148zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl__shrinkzd2nodez12zd2default3116z12zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static obj_t
		BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt);
	static obj_t BGl_shrinkzd2nodez12zd2fail3142z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2app3128z12zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzast_shrinkifyz00();
	extern obj_t BGl_setqz00zzast_nodez00;
	BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt);
	static obj_t BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 = BUNSPEC;
	static obj_t
		BGl_shrinkzd2nodez12zd2setzd2exzd23156z12zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2kwote3124z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_genericzd2initzd2zzast_shrinkifyz00();
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2select3144z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2letzd2fun3152zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl__shrinkifyz12z12zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
	static obj_t BGl_shrinkzd2nodez12zd2letzd2var3154zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2jumpzd2ex3158zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2var3122z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2boxzd2set3150zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2sequenc3126z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl_shrinkzd2nodez12zd2atom3120z12zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	static obj_t
		BGl_shrinkzd2variablez12zd2def3114z12zzast_shrinkifyz00
		(BgL_variablez00_bglt);
	static obj_t BGl_shrinkzd2nodez12zd2makezd2bo3146zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl__shrinkzd2variablez123422zc0zzast_shrinkifyz00(obj_t, obj_t);
	static bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
	static obj_t __cnst[1];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_shrinkzd2variablez12zd2def3114zd2envzc0zzast_shrinkifyz00,
		BgL_bgl__shrinkza7d2variab3449za7,
		BGl__shrinkzd2variablez12zd2def3114z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
		BgL_bgl__shrinkza7d2variab3450za7,
		BGl__shrinkzd2variablez123422zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_shrinkzd2nodez12zd2default3116zd2envzc0zzast_shrinkifyz00,
		BgL_bgl__shrinkza7d2nodeza713451z00,
		BGl__shrinkzd2nodez12zd2default3116z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3425z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123452z00,
		BGl_shrinkzd2nodez12zd2atom3120z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3426z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123453z00,
		BGl_shrinkzd2nodez12zd2var3122z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3427z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123454z00,
		BGl_shrinkzd2nodez12zd2kwote3124z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3428z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123455z00,
		BGl_shrinkzd2nodez12zd2sequenc3126z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3430z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123456z00,
		BGl_shrinkzd2nodez12zd2appzd2ly3130zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3429z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123457z00,
		BGl_shrinkzd2nodez12zd2app3128z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3431z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123458z00,
		BGl_shrinkzd2nodez12zd2funcall3132z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3432z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123459z00,
		BGl_shrinkzd2nodez12zd2extern3134z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3433z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123460z00,
		BGl_shrinkzd2nodez12zd2cast3136z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3434z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123461z00,
		BGl_shrinkzd2nodez12zd2setq3138z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3435z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123462z00,
		BGl_shrinkzd2nodez12zd2conditi3140z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3436z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123463z00,
		BGl_shrinkzd2nodez12zd2fail3142z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3437z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123464z00,
		BGl_shrinkzd2nodez12zd2select3144z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3438z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123465z00,
		BGl_shrinkzd2nodez12zd2makezd2bo3146zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3440z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123466z00,
		BGl_shrinkzd2nodez12zd2boxzd2set3150zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3439z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123467z00,
		BGl_shrinkzd2nodez12zd2boxzd2ref3148zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3441z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123468z00,
		BGl_shrinkzd2nodez12zd2letzd2fun3152zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3442z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123469z00,
		BGl_shrinkzd2nodez12zd2letzd2var3154zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3443z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123470z00,
		BGl_shrinkzd2nodez12zd2setzd2exzd23156z12zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3444z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123471z00,
		BGl_shrinkzd2nodez12zd2jumpzd2ex3158zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_shrinkifyz12zd2envzc0zzast_shrinkifyz00,
		BgL_bgl__shrinkifyza712za7123472z00, BGl__shrinkifyz12z12zzast_shrinkifyz00,
		0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string3424z00zzast_shrinkifyz00,
		BgL_bgl_string3424za700za7za7a3473za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string3445z00zzast_shrinkifyz00,
		BgL_bgl_string3445za700za7za7a3474za7, "ast_shrinkify", 13);
	      DEFINE_STRING(BGl_string3446z00zzast_shrinkifyz00,
		BgL_bgl_string3446za700za7za7a3475za7, "shrink-node!-default3116 ", 25);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
		BgL_bgl__shrinkza7d2nodeza713476z00,
		BGl__shrinkzd2nodez123423zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long
		BgL_checksumz00_2561, char *BgL_fromz00_2562)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_shrinkifyz00))
				{
					BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
					BGl_cnstzd2initzd2zzast_shrinkifyz00();
					BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
					BGl_genericzd2initzd2zzast_shrinkifyz00();
					BGl_methodzd2initzd2zzast_shrinkifyz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"ast_shrinkify");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			{	/* Ast/shrinkify.scm 15 */
				obj_t BgL_cportz00_2550;

				BgL_cportz00_2550 =
					bgl_open_input_string(BGl_string3446z00zzast_shrinkifyz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2551;

					BgL_iz00_2551 = ((long) 0);
				BgL_loopz00_2552:
					if ((BgL_iz00_2551 == ((long) -1)))
						{	/* Ast/shrinkify.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Ast/shrinkify.scm 15 */
							{	/* Ast/shrinkify.scm 15 */
								obj_t BgL_arg3448z00_2554;

								{	/* Ast/shrinkify.scm 15 */

									{	/* Ast/shrinkify.scm 15 */
										obj_t BgL_locationz00_2556;

										BgL_locationz00_2556 = BBOOL(((bool_t) 0));
										{	/* Ast/shrinkify.scm 15 */

											BgL_arg3448z00_2554 =
												BGl_readz00zz__readerz00(BgL_cportz00_2550,
												BgL_locationz00_2556);
										}
									}
								}
								{	/* Ast/shrinkify.scm 15 */
									int BgL_auxz00_2580;

									BgL_auxz00_2580 = (int) (BgL_iz00_2551);
									CNST_TABLE_SET(BgL_auxz00_2580, BgL_arg3448z00_2554);
							}}
							{	/* Ast/shrinkify.scm 15 */
								int BgL_auxz00_2557;

								BgL_auxz00_2557 = (int) ((BgL_iz00_2551 - ((long) 1)));
								{
									long BgL_iz00_2585;

									BgL_iz00_2585 = (long) (BgL_auxz00_2557);
									BgL_iz00_2551 = BgL_iz00_2585;
									goto BgL_loopz00_2552;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			return BUNSPEC;
		}
	}



/* shrinkify! */
	BGL_EXPORTED_DEF obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t
		BgL_globalsz00_1)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 25 */
			BGl_forzd2eachzd2globalz12z12zzast_envz00
				(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BNIL);
			{
				obj_t BgL_l3098z00_759;

				BgL_l3098z00_759 = BgL_globalsz00_1;
			BgL_forzd2each3099zd2_760:
				if (PAIRP(BgL_l3098z00_759))
					{	/* Ast/shrinkify.scm 27 */
						{	/* Ast/shrinkify.scm 28 */
							obj_t BgL_globalz00_762;

							BgL_globalz00_762 = CAR(BgL_l3098z00_759);
							{	/* Ast/shrinkify.scm 28 */
								BgL_valuez00_bglt BgL_sfunz00_763;

								{
									BgL_variablez00_bglt BgL_auxz00_2591;

									BgL_auxz00_2591 = (BgL_variablez00_bglt) (BgL_globalz00_762);
									BgL_sfunz00_763 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_2591))->
										BgL_valuez00);
								}
								{	/* Ast/shrinkify.scm 29 */
									obj_t BgL_g3097z00_764;

									{
										BgL_sfunz00_bglt BgL_auxz00_2594;

										BgL_auxz00_2594 = (BgL_sfunz00_bglt) (BgL_sfunz00_763);
										BgL_g3097z00_764 =
											(((BgL_sfunz00_bglt) CREF(BgL_auxz00_2594))->BgL_argsz00);
									}
									{
										obj_t BgL_l3094z00_765;

										BgL_l3094z00_765 = BgL_g3097z00_764;
									BgL_forzd2each3096zd2_766:
										if (PAIRP(BgL_l3094z00_765))
											{	/* Ast/shrinkify.scm 29 */
												{	/* Ast/shrinkify.scm 29 */
													obj_t BgL_arg3162z00_768;

													BgL_arg3162z00_768 = CAR(BgL_l3094z00_765);
													{	/* Ast/shrinkify.scm 29 */
														BgL_variablez00_bglt BgL_variablez00_1363;

														BgL_variablez00_1363 =
															(BgL_variablez00_bglt) (BgL_arg3162z00_768);
														{	/* Ast/shrinkify.scm 29 */
															obj_t BgL_method3115z00_1364;

															{	/* Ast/shrinkify.scm 29 */
																BgL_objectz00_bglt BgL_objz00_1365;

																BgL_objz00_1365 =
																	(BgL_objectz00_bglt) (BgL_variablez00_1363);
																{	/* Ast/shrinkify.scm 29 */
																	long BgL_objzd2classzd2numz00_1366;

																	BgL_objzd2classzd2numz00_1366 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_1365);
																	{	/* Ast/shrinkify.scm 29 */
																		obj_t BgL_arg2356z00_1367;

																		BgL_arg2356z00_1367 =
																			PROCEDURE_REF
																			(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
																			(int) (((long) 1)));
																		{	/* Ast/shrinkify.scm 29 */
																			obj_t BgL_arrayz00_1369;

																			int BgL_offsetz00_1370;

																			BgL_arrayz00_1369 = BgL_arg2356z00_1367;
																			BgL_offsetz00_1370 =
																				(int) (BgL_objzd2classzd2numz00_1366);
																			{	/* Ast/shrinkify.scm 29 */
																				long BgL_offsetz00_1371;

																				BgL_offsetz00_1371 =
																					(
																					(long) (BgL_offsetz00_1370) -
																					OBJECT_TYPE);
																				{	/* Ast/shrinkify.scm 29 */
																					long BgL_modz00_1372;

																					{	/* Ast/shrinkify.scm 29 */
																						int BgL_arg2358z00_1373;

																						BgL_arg2358z00_1373 =
																							(int) (((long) 8));
																						{	/* Ast/shrinkify.scm 29 */
																							long BgL_auxz00_2609;

																							BgL_auxz00_2609 =
																								(long) (BgL_arg2358z00_1373);
																							BgL_modz00_1372 =
																								(BgL_offsetz00_1371 /
																								BgL_auxz00_2609);
																					}}
																					{	/* Ast/shrinkify.scm 29 */
																						long BgL_restz00_1374;

																						{	/* Ast/shrinkify.scm 29 */
																							int BgL_arg2357z00_1375;

																							BgL_arg2357z00_1375 =
																								(int) (((long) 8));
																							{	/* Ast/shrinkify.scm 29 */
																								long BgL_auxz00_2613;

																								BgL_auxz00_2613 =
																									(long) (BgL_arg2357z00_1375);
																								BgL_restz00_1374 =
																									(BgL_offsetz00_1371 %
																									BgL_auxz00_2613);
																						}}
																						{	/* Ast/shrinkify.scm 29 */

																							BgL_method3115z00_1364 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_1369,
																									(int) (BgL_modz00_1372)),
																								(int) (BgL_restz00_1374));
															}}}}}}}}
															PROCEDURE_ENTRY(BgL_method3115z00_1364)
																(BgL_method3115z00_1364,
																(obj_t) (BgL_variablez00_1363), BEOA);
												}}}
												{
													obj_t BgL_l3094z00_2623;

													BgL_l3094z00_2623 = CDR(BgL_l3094z00_765);
													BgL_l3094z00_765 = BgL_l3094z00_2623;
													goto BgL_forzd2each3096zd2_766;
												}
											}
										else
											{	/* Ast/shrinkify.scm 29 */
												((bool_t) 1);
											}
									}
								}
								{	/* Ast/shrinkify.scm 30 */
									obj_t BgL_arg3164z00_770;

									{	/* Ast/shrinkify.scm 30 */
										BgL_sfunz00_bglt BgL_obj1722z00_1391;

										{	/* Ast/shrinkify.scm 30 */
											BgL_variablez00_bglt BgL_obj1450z00_1390;

											BgL_obj1450z00_1390 =
												(BgL_variablez00_bglt) (BgL_globalz00_762);
											BgL_obj1722z00_1391 =
												(BgL_sfunz00_bglt) (
												(((BgL_variablez00_bglt) CREF(BgL_obj1450z00_1390))->
													BgL_valuez00));
										}
										BgL_arg3164z00_770 =
											(((BgL_sfunz00_bglt) CREF(BgL_obj1722z00_1391))->
											BgL_bodyz00);
									}
									{	/* Ast/shrinkify.scm 30 */
										obj_t BgL_res3321z00_1418;

										{	/* Ast/shrinkify.scm 30 */
											BgL_nodez00_bglt BgL_nodez00_1392;

											BgL_nodez00_1392 =
												(BgL_nodez00_bglt) (BgL_arg3164z00_770);
											{	/* Ast/shrinkify.scm 30 */
												obj_t BgL_method3118z00_1393;

												{	/* Ast/shrinkify.scm 30 */
													BgL_objectz00_bglt BgL_objz00_1394;

													BgL_objz00_1394 =
														(BgL_objectz00_bglt) (BgL_nodez00_1392);
													{	/* Ast/shrinkify.scm 30 */
														long BgL_objzd2classzd2numz00_1395;

														BgL_objzd2classzd2numz00_1395 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_1394);
														{	/* Ast/shrinkify.scm 30 */
															obj_t BgL_arg2356z00_1396;

															BgL_arg2356z00_1396 =
																PROCEDURE_REF
																(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
																(int) (((long) 1)));
															{	/* Ast/shrinkify.scm 30 */
																obj_t BgL_arrayz00_1398;

																int BgL_offsetz00_1399;

																BgL_arrayz00_1398 = BgL_arg2356z00_1396;
																BgL_offsetz00_1399 =
																	(int) (BgL_objzd2classzd2numz00_1395);
																{	/* Ast/shrinkify.scm 30 */
																	long BgL_offsetz00_1400;

																	BgL_offsetz00_1400 =
																		((long) (BgL_offsetz00_1399) - OBJECT_TYPE);
																	{	/* Ast/shrinkify.scm 30 */
																		long BgL_modz00_1401;

																		{	/* Ast/shrinkify.scm 30 */
																			int BgL_arg2358z00_1402;

																			BgL_arg2358z00_1402 = (int) (((long) 8));
																			{	/* Ast/shrinkify.scm 30 */
																				long BgL_auxz00_2638;

																				BgL_auxz00_2638 =
																					(long) (BgL_arg2358z00_1402);
																				BgL_modz00_1401 =
																					(BgL_offsetz00_1400 /
																					BgL_auxz00_2638);
																		}}
																		{	/* Ast/shrinkify.scm 30 */
																			long BgL_restz00_1403;

																			{	/* Ast/shrinkify.scm 30 */
																				int BgL_arg2357z00_1404;

																				BgL_arg2357z00_1404 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 30 */
																					long BgL_auxz00_2642;

																					BgL_auxz00_2642 =
																						(long) (BgL_arg2357z00_1404);
																					BgL_restz00_1403 =
																						(BgL_offsetz00_1400 %
																						BgL_auxz00_2642);
																			}}
																			{	/* Ast/shrinkify.scm 30 */

																				BgL_method3118z00_1393 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_1398,
																						(int) (BgL_modz00_1401)),
																					(int) (BgL_restz00_1403));
												}}}}}}}}
												{	/* Ast/shrinkify.scm 30 */
													obj_t BgL_xz00_2520;

													BgL_xz00_2520 =
														PROCEDURE_ENTRY(BgL_method3118z00_1393)
														(BgL_method3118z00_1393, (obj_t) (BgL_nodez00_1392),
														BEOA);
													BgL_res3321z00_1418 = BUNSPEC;
										}}} BgL_res3321z00_1418;
						}}}}
						{
							obj_t BgL_l3098z00_2652;

							BgL_l3098z00_2652 = CDR(BgL_l3098z00_759);
							BgL_l3098z00_759 = BgL_l3098z00_2652;
							goto BgL_forzd2each3099zd2_760;
						}
					}
				else
					{	/* Ast/shrinkify.scm 27 */
						((bool_t) 1);
					}
			}
			return BgL_globalsz00_1;
		}
	}



/* _shrinkify! */
	obj_t BGl__shrinkifyz12z12zzast_shrinkifyz00(obj_t BgL_envz00_2450,
		obj_t BgL_globalsz00_2451)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 25 */
			return BGl_shrinkifyz12z12zzast_shrinkifyz00(BgL_globalsz00_2451);
		}
	}



/* shrink-node*! */
	bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t BgL_nodeza2za2_26)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 221 */
			{
				obj_t BgL_l3112z00_773;

				BgL_l3112z00_773 = BgL_nodeza2za2_26;
			BgL_forzd2each3113zd2_774:
				if (PAIRP(BgL_l3112z00_773))
					{	/* Ast/shrinkify.scm 222 */
						{	/* Ast/shrinkify.scm 222 */
							obj_t BgL_arg3168z00_776;

							BgL_arg3168z00_776 = CAR(BgL_l3112z00_773);
							{	/* Ast/shrinkify.scm 222 */
								obj_t BgL_res3324z00_1448;

								{	/* Ast/shrinkify.scm 222 */
									BgL_nodez00_bglt BgL_nodez00_1422;

									BgL_nodez00_1422 = (BgL_nodez00_bglt) (BgL_arg3168z00_776);
									{	/* Ast/shrinkify.scm 222 */
										obj_t BgL_method3118z00_1423;

										{	/* Ast/shrinkify.scm 222 */
											BgL_objectz00_bglt BgL_objz00_1424;

											BgL_objz00_1424 = (BgL_objectz00_bglt) (BgL_nodez00_1422);
											{	/* Ast/shrinkify.scm 222 */
												long BgL_objzd2classzd2numz00_1425;

												BgL_objzd2classzd2numz00_1425 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1424);
												{	/* Ast/shrinkify.scm 222 */
													obj_t BgL_arg2356z00_1426;

													BgL_arg2356z00_1426 =
														PROCEDURE_REF
														(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
														(int) (((long) 1)));
													{	/* Ast/shrinkify.scm 222 */
														obj_t BgL_arrayz00_1428;

														int BgL_offsetz00_1429;

														BgL_arrayz00_1428 = BgL_arg2356z00_1426;
														BgL_offsetz00_1429 =
															(int) (BgL_objzd2classzd2numz00_1425);
														{	/* Ast/shrinkify.scm 222 */
															long BgL_offsetz00_1430;

															BgL_offsetz00_1430 =
																((long) (BgL_offsetz00_1429) - OBJECT_TYPE);
															{	/* Ast/shrinkify.scm 222 */
																long BgL_modz00_1431;

																{	/* Ast/shrinkify.scm 222 */
																	int BgL_arg2358z00_1432;

																	BgL_arg2358z00_1432 = (int) (((long) 8));
																	{	/* Ast/shrinkify.scm 222 */
																		long BgL_auxz00_2667;

																		BgL_auxz00_2667 =
																			(long) (BgL_arg2358z00_1432);
																		BgL_modz00_1431 =
																			(BgL_offsetz00_1430 / BgL_auxz00_2667);
																}}
																{	/* Ast/shrinkify.scm 222 */
																	long BgL_restz00_1433;

																	{	/* Ast/shrinkify.scm 222 */
																		int BgL_arg2357z00_1434;

																		BgL_arg2357z00_1434 = (int) (((long) 8));
																		{	/* Ast/shrinkify.scm 222 */
																			long BgL_auxz00_2671;

																			BgL_auxz00_2671 =
																				(long) (BgL_arg2357z00_1434);
																			BgL_restz00_1433 =
																				(BgL_offsetz00_1430 % BgL_auxz00_2671);
																	}}
																	{	/* Ast/shrinkify.scm 222 */

																		BgL_method3118z00_1423 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1428,
																				(int) (BgL_modz00_1431)),
																			(int) (BgL_restz00_1433));
										}}}}}}}}
										{	/* Ast/shrinkify.scm 222 */
											obj_t BgL_xz00_2521;

											BgL_xz00_2521 =
												PROCEDURE_ENTRY(BgL_method3118z00_1423)
												(BgL_method3118z00_1423, (obj_t) (BgL_nodez00_1422),
												BEOA);
											BgL_res3324z00_1448 = BUNSPEC;
								}}} BgL_res3324z00_1448;
						}}
						{
							obj_t BgL_l3112z00_2681;

							BgL_l3112z00_2681 = CDR(BgL_l3112z00_773);
							BgL_l3112z00_773 = BgL_l3112z00_2681;
							goto BgL_forzd2each3113zd2_774;
						}
					}
				else
					{	/* Ast/shrinkify.scm 222 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_addzd2genericz12zc0zz__objectz00
				(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
				BGl_shrinkzd2variablez12zd2def3114zd2envzc0zzast_shrinkifyz00);
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_shrinkzd2nodez12zd2default3116zd2envzc0zzast_shrinkifyz00);
		}
	}



/* shrink-variable! */
	obj_t BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt
		BgL_variablez00_2)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 37 */
			{	/* Ast/shrinkify.scm 37 */
				obj_t BgL_method3115z00_1450;

				{	/* Ast/shrinkify.scm 37 */
					BgL_objectz00_bglt BgL_objz00_1451;

					BgL_objz00_1451 = (BgL_objectz00_bglt) (BgL_variablez00_2);
					{	/* Ast/shrinkify.scm 37 */
						long BgL_objzd2classzd2numz00_1452;

						BgL_objzd2classzd2numz00_1452 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1451);
						{	/* Ast/shrinkify.scm 37 */
							obj_t BgL_arg2356z00_1453;

							BgL_arg2356z00_1453 =
								PROCEDURE_REF
								(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
								(int) (((long) 1)));
							{	/* Ast/shrinkify.scm 37 */
								obj_t BgL_arrayz00_1455;

								int BgL_offsetz00_1456;

								BgL_arrayz00_1455 = BgL_arg2356z00_1453;
								BgL_offsetz00_1456 = (int) (BgL_objzd2classzd2numz00_1452);
								{	/* Ast/shrinkify.scm 37 */
									long BgL_offsetz00_1457;

									BgL_offsetz00_1457 =
										((long) (BgL_offsetz00_1456) - OBJECT_TYPE);
									{	/* Ast/shrinkify.scm 37 */
										long BgL_modz00_1458;

										{	/* Ast/shrinkify.scm 37 */
											int BgL_arg2358z00_1459;

											BgL_arg2358z00_1459 = (int) (((long) 8));
											{	/* Ast/shrinkify.scm 37 */
												long BgL_auxz00_2693;

												BgL_auxz00_2693 = (long) (BgL_arg2358z00_1459);
												BgL_modz00_1458 =
													(BgL_offsetz00_1457 / BgL_auxz00_2693);
										}}
										{	/* Ast/shrinkify.scm 37 */
											long BgL_restz00_1460;

											{	/* Ast/shrinkify.scm 37 */
												int BgL_arg2357z00_1461;

												BgL_arg2357z00_1461 = (int) (((long) 8));
												{	/* Ast/shrinkify.scm 37 */
													long BgL_auxz00_2697;

													BgL_auxz00_2697 = (long) (BgL_arg2357z00_1461);
													BgL_restz00_1460 =
														(BgL_offsetz00_1457 % BgL_auxz00_2697);
											}}
											{	/* Ast/shrinkify.scm 37 */

												BgL_method3115z00_1450 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1455,
														(int) (BgL_modz00_1458)), (int) (BgL_restz00_1460));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3115z00_1450) (BgL_method3115z00_1450,
					(obj_t) (BgL_variablez00_2), BEOA);
			}
		}
	}



/* _shrink-variable!3422 */
	obj_t BGl__shrinkzd2variablez123422zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2452, obj_t BgL_variablez00_2453)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 37 */
			return
				BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
				(BgL_variablez00_bglt) (BgL_variablez00_2453));
		}
	}



/* shrink-variable!-def3114 */
	obj_t
		BGl_shrinkzd2variablez12zd2def3114z12zzast_shrinkifyz00(BgL_variablez00_bglt
		BgL_variablez00_3)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			{	/* Ast/shrinkify.scm 38 */
				bool_t BgL_testz00_2709;

				{	/* Ast/shrinkify.scm 38 */
					bool_t BgL_testz00_2710;

					{	/* Ast/shrinkify.scm 38 */
						obj_t BgL_auxz00_2711;

						{	/* Ast/shrinkify.scm 38 */
							BgL_objectz00_bglt BgL_auxz00_2712;

							BgL_auxz00_2712 = (BgL_objectz00_bglt) (BgL_variablez00_3);
							BgL_auxz00_2711 = BGL_OBJECT_WIDENING(BgL_auxz00_2712);
						}
						BgL_testz00_2710 = CBOOL(BgL_auxz00_2711);
					}
					if (BgL_testz00_2710)
						{	/* Ast/shrinkify.scm 38 */
							BgL_testz00_2709 = ((bool_t) 1);
						}
					else
						{	/* Ast/shrinkify.scm 38 */
							BgL_testz00_2709 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_2709)
					{	/* Ast/shrinkify.scm 38 */
						{	/* Ast/shrinkify.scm 39 */
							long BgL_arg3218z00_1153;

							{	/* Ast/shrinkify.scm 39 */
								obj_t BgL_arg3219z00_1154;

								{	/* Ast/shrinkify.scm 39 */
									obj_t BgL_arg3220z00_1155;

									{	/* Ast/shrinkify.scm 39 */
										BgL_objectz00_bglt BgL_objectz00_1478;

										BgL_objectz00_1478 =
											(BgL_objectz00_bglt) (BgL_variablez00_3);
										{	/* Ast/shrinkify.scm 39 */
											long BgL_arg2359z00_1479;

											{	/* Ast/shrinkify.scm 39 */
												long BgL_arg2360z00_1480;

												BgL_arg2360z00_1480 =
													BGL_OBJECT_CLASS_NUM(BgL_objectz00_1478);
												BgL_arg2359z00_1479 =
													(BgL_arg2360z00_1480 - OBJECT_TYPE);
											}
											BgL_arg3220z00_1155 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg2359z00_1479));
									}}
									BgL_arg3219z00_1154 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg3220z00_1155);
								}
								BgL_arg3218z00_1153 =
									BGl_classzd2numzd2zz__objectz00(BgL_arg3219z00_1154);
							}
							BGL_OBJECT_CLASS_NUM_SET(
								(BgL_objectz00_bglt) (BgL_variablez00_3), BgL_arg3218z00_1153);
						}
						{	/* Ast/shrinkify.scm 39 */
							BgL_objectz00_bglt BgL_auxz00_2725;

							BgL_auxz00_2725 = (BgL_objectz00_bglt) (BgL_variablez00_3);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_2725, BFALSE);
						}
						(obj_t) (BgL_variablez00_3);
					}
				else
					{	/* Ast/shrinkify.scm 38 */
						BFALSE;
					}
			}
			{	/* Ast/shrinkify.scm 40 */
				bool_t BgL_testz00_2729;

				{	/* Ast/shrinkify.scm 40 */
					bool_t BgL_testz00_2730;

					{	/* Ast/shrinkify.scm 40 */
						obj_t BgL_auxz00_2731;

						{	/* Ast/shrinkify.scm 40 */
							BgL_objectz00_bglt BgL_auxz00_2732;

							BgL_auxz00_2732 =
								(BgL_objectz00_bglt) (
								(((BgL_variablez00_bglt) CREF(BgL_variablez00_3))->
									BgL_valuez00));
							BgL_auxz00_2731 = BGL_OBJECT_WIDENING(BgL_auxz00_2732);
						}
						BgL_testz00_2730 = CBOOL(BgL_auxz00_2731);
					}
					if (BgL_testz00_2730)
						{	/* Ast/shrinkify.scm 40 */
							BgL_testz00_2729 = ((bool_t) 1);
						}
					else
						{	/* Ast/shrinkify.scm 40 */
							BgL_testz00_2729 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_2729)
					{	/* Ast/shrinkify.scm 41 */
						BgL_valuez00_bglt BgL_o3080z00_1157;

						BgL_o3080z00_1157 =
							(((BgL_variablez00_bglt) CREF(BgL_variablez00_3))->BgL_valuez00);
						{	/* Ast/shrinkify.scm 41 */
							long BgL_arg3222z00_1158;

							{	/* Ast/shrinkify.scm 41 */
								obj_t BgL_arg3223z00_1159;

								{	/* Ast/shrinkify.scm 41 */
									obj_t BgL_arg3224z00_1160;

									{	/* Ast/shrinkify.scm 41 */
										BgL_objectz00_bglt BgL_objectz00_1493;

										BgL_objectz00_1493 =
											(BgL_objectz00_bglt) (BgL_o3080z00_1157);
										{	/* Ast/shrinkify.scm 41 */
											long BgL_arg2359z00_1494;

											{	/* Ast/shrinkify.scm 41 */
												long BgL_arg2360z00_1495;

												BgL_arg2360z00_1495 =
													BGL_OBJECT_CLASS_NUM(BgL_objectz00_1493);
												BgL_arg2359z00_1494 =
													(BgL_arg2360z00_1495 - OBJECT_TYPE);
											}
											BgL_arg3224z00_1160 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg2359z00_1494));
									}}
									BgL_arg3223z00_1159 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg3224z00_1160);
								}
								BgL_arg3222z00_1158 =
									BGl_classzd2numzd2zz__objectz00(BgL_arg3223z00_1159);
							}
							BGL_OBJECT_CLASS_NUM_SET(
								(BgL_objectz00_bglt) (BgL_o3080z00_1157), BgL_arg3222z00_1158);
						}
						{	/* Ast/shrinkify.scm 41 */
							BgL_objectz00_bglt BgL_auxz00_2747;

							BgL_auxz00_2747 = (BgL_objectz00_bglt) (BgL_o3080z00_1157);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_2747, BFALSE);
						}
						return (obj_t) (BgL_o3080z00_1157);
					}
				else
					{	/* Ast/shrinkify.scm 40 */
						return BFALSE;
					}
			}
		}
	}



/* _shrink-variable!-def3114 */
	obj_t BGl__shrinkzd2variablez12zd2def3114z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2456, obj_t BgL_variablez00_2457)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			return
				BGl_shrinkzd2variablez12zd2def3114z12zzast_shrinkifyz00(
				(BgL_variablez00_bglt) (BgL_variablez00_2457));
		}
	}



/* shrink-node! */
	obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt
		BgL_nodez00_4)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 46 */
			{	/* Ast/shrinkify.scm 46 */
				obj_t BgL_method3118z00_1503;

				{	/* Ast/shrinkify.scm 46 */
					BgL_objectz00_bglt BgL_objz00_1504;

					BgL_objz00_1504 = (BgL_objectz00_bglt) (BgL_nodez00_4);
					{	/* Ast/shrinkify.scm 46 */
						long BgL_objzd2classzd2numz00_1505;

						BgL_objzd2classzd2numz00_1505 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1504);
						{	/* Ast/shrinkify.scm 46 */
							obj_t BgL_arg2356z00_1506;

							BgL_arg2356z00_1506 =
								PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
								(int) (((long) 1)));
							{	/* Ast/shrinkify.scm 46 */
								obj_t BgL_arrayz00_1508;

								int BgL_offsetz00_1509;

								BgL_arrayz00_1508 = BgL_arg2356z00_1506;
								BgL_offsetz00_1509 = (int) (BgL_objzd2classzd2numz00_1505);
								{	/* Ast/shrinkify.scm 46 */
									long BgL_offsetz00_1510;

									BgL_offsetz00_1510 =
										((long) (BgL_offsetz00_1509) - OBJECT_TYPE);
									{	/* Ast/shrinkify.scm 46 */
										long BgL_modz00_1511;

										{	/* Ast/shrinkify.scm 46 */
											int BgL_arg2358z00_1512;

											BgL_arg2358z00_1512 = (int) (((long) 8));
											{	/* Ast/shrinkify.scm 46 */
												long BgL_auxz00_2761;

												BgL_auxz00_2761 = (long) (BgL_arg2358z00_1512);
												BgL_modz00_1511 =
													(BgL_offsetz00_1510 / BgL_auxz00_2761);
										}}
										{	/* Ast/shrinkify.scm 46 */
											long BgL_restz00_1513;

											{	/* Ast/shrinkify.scm 46 */
												int BgL_arg2357z00_1514;

												BgL_arg2357z00_1514 = (int) (((long) 8));
												{	/* Ast/shrinkify.scm 46 */
													long BgL_auxz00_2765;

													BgL_auxz00_2765 = (long) (BgL_arg2357z00_1514);
													BgL_restz00_1513 =
														(BgL_offsetz00_1510 % BgL_auxz00_2765);
											}}
											{	/* Ast/shrinkify.scm 46 */

												BgL_method3118z00_1503 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1508,
														(int) (BgL_modz00_1511)), (int) (BgL_restz00_1513));
				}}}}}}}}
				{	/* Ast/shrinkify.scm 46 */
					obj_t BgL_xz00_2522;

					BgL_xz00_2522 =
						PROCEDURE_ENTRY(BgL_method3118z00_1503) (BgL_method3118z00_1503,
						(obj_t) (BgL_nodez00_4), BEOA);
					return BUNSPEC;
				}
			}
		}
	}



/* _shrink-node!3423 */
	obj_t BGl__shrinkzd2nodez123423zc0zzast_shrinkifyz00(obj_t BgL_envz00_2454,
		obj_t BgL_nodez00_2455)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 46 */
			return
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(BgL_nodez00_bglt) (BgL_nodez00_2455));
		}
	}



/* shrink-node!-default3116 */
	obj_t BGl_shrinkzd2nodez12zd2default3116z12zzast_shrinkifyz00(BgL_nodez00_bglt
		BgL_nodez00_5)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			{	/* Ast/shrinkify.scm 15 */
				obj_t BgL_xz00_2523;

				BgL_xz00_2523 =
					BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
					BGl_string3424z00zzast_shrinkifyz00, (obj_t) (BgL_nodez00_5));
				return BUNSPEC;
			}
		}
	}



/* _shrink-node!-default3116 */
	obj_t BGl__shrinkzd2nodez12zd2default3116z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2458, obj_t BgL_nodez00_2459)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			return
				BGl_shrinkzd2nodez12zd2default3116z12zzast_shrinkifyz00(
				(BgL_nodez00_bglt) (BgL_nodez00_2459));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_atomz00zzast_nodez00, BGl_proc3425z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_varz00zzast_nodez00, BGl_proc3426z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_kwotez00zzast_nodez00, BGl_proc3427z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_sequencez00zzast_nodez00, BGl_proc3428z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_appz00zzast_nodez00, BGl_proc3429z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3430z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_funcallz00zzast_nodez00, BGl_proc3431z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_externz00zzast_nodez00, BGl_proc3432z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_castz00zzast_nodez00, BGl_proc3433z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_setqz00zzast_nodez00, BGl_proc3434z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3435z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_failz00zzast_nodez00, BGl_proc3436z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_selectz00zzast_nodez00, BGl_proc3437z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3438z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3439z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3440z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3441z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3442z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3443z00zzast_shrinkifyz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3444z00zzast_shrinkifyz00);
		}
	}



/* shrink-node!-jump-ex3158 */
	obj_t BGl_shrinkzd2nodez12zd2jumpzd2ex3158zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2480, obj_t BgL_nodez00_2481)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 213 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1350;

				BgL_nodez00_1350 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_2481);
				{	/* Ast/shrinkify.scm 214 */
					BgL_nodez00_bglt BgL_arg3314z00_1353;

					BgL_arg3314z00_1353 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1350))->
						BgL_exitz00);
					{	/* Ast/shrinkify.scm 214 */
						obj_t BgL_res3418z00_2421;

						{	/* Ast/shrinkify.scm 214 */
							obj_t BgL_method3118z00_2396;

							{	/* Ast/shrinkify.scm 214 */
								BgL_objectz00_bglt BgL_objz00_2397;

								BgL_objz00_2397 = (BgL_objectz00_bglt) (BgL_arg3314z00_1353);
								{	/* Ast/shrinkify.scm 214 */
									long BgL_objzd2classzd2numz00_2398;

									BgL_objzd2classzd2numz00_2398 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2397);
									{	/* Ast/shrinkify.scm 214 */
										obj_t BgL_arg2356z00_2399;

										BgL_arg2356z00_2399 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 214 */
											obj_t BgL_arrayz00_2401;

											int BgL_offsetz00_2402;

											BgL_arrayz00_2401 = BgL_arg2356z00_2399;
											BgL_offsetz00_2402 =
												(int) (BgL_objzd2classzd2numz00_2398);
											{	/* Ast/shrinkify.scm 214 */
												long BgL_offsetz00_2403;

												BgL_offsetz00_2403 =
													((long) (BgL_offsetz00_2402) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 214 */
													long BgL_modz00_2404;

													{	/* Ast/shrinkify.scm 214 */
														int BgL_arg2358z00_2405;

														BgL_arg2358z00_2405 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 214 */
															long BgL_auxz00_2811;

															BgL_auxz00_2811 = (long) (BgL_arg2358z00_2405);
															BgL_modz00_2404 =
																(BgL_offsetz00_2403 / BgL_auxz00_2811);
													}}
													{	/* Ast/shrinkify.scm 214 */
														long BgL_restz00_2406;

														{	/* Ast/shrinkify.scm 214 */
															int BgL_arg2357z00_2407;

															BgL_arg2357z00_2407 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 214 */
																long BgL_auxz00_2815;

																BgL_auxz00_2815 = (long) (BgL_arg2357z00_2407);
																BgL_restz00_2406 =
																	(BgL_offsetz00_2403 % BgL_auxz00_2815);
														}}
														{	/* Ast/shrinkify.scm 214 */

															BgL_method3118z00_2396 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2401,
																	(int) (BgL_modz00_2404)),
																(int) (BgL_restz00_2406));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 214 */
								obj_t BgL_xz00_2524;

								BgL_xz00_2524 =
									PROCEDURE_ENTRY(BgL_method3118z00_2396)
									(BgL_method3118z00_2396, (obj_t) (BgL_arg3314z00_1353), BEOA);
								BgL_res3418z00_2421 = BUNSPEC;
						}} BgL_res3418z00_2421;
				}}
				{	/* Ast/shrinkify.scm 215 */
					BgL_nodez00_bglt BgL_arg3315z00_1354;

					BgL_arg3315z00_1354 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1350))->
						BgL_valuez00);
					{	/* Ast/shrinkify.scm 215 */
						obj_t BgL_res3421z00_2449;

						{	/* Ast/shrinkify.scm 215 */
							obj_t BgL_method3118z00_2424;

							{	/* Ast/shrinkify.scm 215 */
								BgL_objectz00_bglt BgL_objz00_2425;

								BgL_objz00_2425 = (BgL_objectz00_bglt) (BgL_arg3315z00_1354);
								{	/* Ast/shrinkify.scm 215 */
									long BgL_objzd2classzd2numz00_2426;

									BgL_objzd2classzd2numz00_2426 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2425);
									{	/* Ast/shrinkify.scm 215 */
										obj_t BgL_arg2356z00_2427;

										BgL_arg2356z00_2427 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 215 */
											obj_t BgL_arrayz00_2429;

											int BgL_offsetz00_2430;

											BgL_arrayz00_2429 = BgL_arg2356z00_2427;
											BgL_offsetz00_2430 =
												(int) (BgL_objzd2classzd2numz00_2426);
											{	/* Ast/shrinkify.scm 215 */
												long BgL_offsetz00_2431;

												BgL_offsetz00_2431 =
													((long) (BgL_offsetz00_2430) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 215 */
													long BgL_modz00_2432;

													{	/* Ast/shrinkify.scm 215 */
														int BgL_arg2358z00_2433;

														BgL_arg2358z00_2433 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 215 */
															long BgL_auxz00_2834;

															BgL_auxz00_2834 = (long) (BgL_arg2358z00_2433);
															BgL_modz00_2432 =
																(BgL_offsetz00_2431 / BgL_auxz00_2834);
													}}
													{	/* Ast/shrinkify.scm 215 */
														long BgL_restz00_2434;

														{	/* Ast/shrinkify.scm 215 */
															int BgL_arg2357z00_2435;

															BgL_arg2357z00_2435 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 215 */
																long BgL_auxz00_2838;

																BgL_auxz00_2838 = (long) (BgL_arg2357z00_2435);
																BgL_restz00_2434 =
																	(BgL_offsetz00_2431 % BgL_auxz00_2838);
														}}
														{	/* Ast/shrinkify.scm 215 */

															BgL_method3118z00_2424 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2429,
																	(int) (BgL_modz00_2432)),
																(int) (BgL_restz00_2434));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 215 */
								obj_t BgL_xz00_2525;

								BgL_xz00_2525 =
									PROCEDURE_ENTRY(BgL_method3118z00_2424)
									(BgL_method3118z00_2424, (obj_t) (BgL_arg3315z00_1354), BEOA);
								BgL_res3421z00_2449 = BUNSPEC;
						}} BgL_res3421z00_2449;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-set-ex-3156 */
	obj_t BGl_shrinkzd2nodez12zd2setzd2exzd23156z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2482, obj_t BgL_nodez00_2483)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 204 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1342;

				BgL_nodez00_1342 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_2483);
				{	/* Ast/shrinkify.scm 206 */
					BgL_varz00_bglt BgL_arg3311z00_1346;

					BgL_arg3311z00_1346 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1342))->BgL_varz00);
					{	/* Ast/shrinkify.scm 206 */
						obj_t BgL_res3412z00_2365;

						{	/* Ast/shrinkify.scm 206 */
							BgL_nodez00_bglt BgL_nodez00_2339;

							BgL_nodez00_2339 = (BgL_nodez00_bglt) (BgL_arg3311z00_1346);
							{	/* Ast/shrinkify.scm 206 */
								obj_t BgL_method3118z00_2340;

								{	/* Ast/shrinkify.scm 206 */
									BgL_objectz00_bglt BgL_objz00_2341;

									BgL_objz00_2341 = (BgL_objectz00_bglt) (BgL_nodez00_2339);
									{	/* Ast/shrinkify.scm 206 */
										long BgL_objzd2classzd2numz00_2342;

										BgL_objzd2classzd2numz00_2342 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2341);
										{	/* Ast/shrinkify.scm 206 */
											obj_t BgL_arg2356z00_2343;

											BgL_arg2356z00_2343 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 206 */
												obj_t BgL_arrayz00_2345;

												int BgL_offsetz00_2346;

												BgL_arrayz00_2345 = BgL_arg2356z00_2343;
												BgL_offsetz00_2346 =
													(int) (BgL_objzd2classzd2numz00_2342);
												{	/* Ast/shrinkify.scm 206 */
													long BgL_offsetz00_2347;

													BgL_offsetz00_2347 =
														((long) (BgL_offsetz00_2346) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 206 */
														long BgL_modz00_2348;

														{	/* Ast/shrinkify.scm 206 */
															int BgL_arg2358z00_2349;

															BgL_arg2358z00_2349 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 206 */
																long BgL_auxz00_2859;

																BgL_auxz00_2859 = (long) (BgL_arg2358z00_2349);
																BgL_modz00_2348 =
																	(BgL_offsetz00_2347 / BgL_auxz00_2859);
														}}
														{	/* Ast/shrinkify.scm 206 */
															long BgL_restz00_2350;

															{	/* Ast/shrinkify.scm 206 */
																int BgL_arg2357z00_2351;

																BgL_arg2357z00_2351 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 206 */
																	long BgL_auxz00_2863;

																	BgL_auxz00_2863 =
																		(long) (BgL_arg2357z00_2351);
																	BgL_restz00_2350 =
																		(BgL_offsetz00_2347 % BgL_auxz00_2863);
															}}
															{	/* Ast/shrinkify.scm 206 */

																BgL_method3118z00_2340 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2345,
																		(int) (BgL_modz00_2348)),
																	(int) (BgL_restz00_2350));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 206 */
									obj_t BgL_xz00_2526;

									BgL_xz00_2526 =
										PROCEDURE_ENTRY(BgL_method3118z00_2340)
										(BgL_method3118z00_2340, (obj_t) (BgL_nodez00_2339), BEOA);
									BgL_res3412z00_2365 = BUNSPEC;
						}}} BgL_res3412z00_2365;
				}}
				{	/* Ast/shrinkify.scm 207 */
					BgL_nodez00_bglt BgL_arg3312z00_1347;

					BgL_arg3312z00_1347 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1342))->BgL_bodyz00);
					{	/* Ast/shrinkify.scm 207 */
						obj_t BgL_res3415z00_2393;

						{	/* Ast/shrinkify.scm 207 */
							obj_t BgL_method3118z00_2368;

							{	/* Ast/shrinkify.scm 207 */
								BgL_objectz00_bglt BgL_objz00_2369;

								BgL_objz00_2369 = (BgL_objectz00_bglt) (BgL_arg3312z00_1347);
								{	/* Ast/shrinkify.scm 207 */
									long BgL_objzd2classzd2numz00_2370;

									BgL_objzd2classzd2numz00_2370 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2369);
									{	/* Ast/shrinkify.scm 207 */
										obj_t BgL_arg2356z00_2371;

										BgL_arg2356z00_2371 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 207 */
											obj_t BgL_arrayz00_2373;

											int BgL_offsetz00_2374;

											BgL_arrayz00_2373 = BgL_arg2356z00_2371;
											BgL_offsetz00_2374 =
												(int) (BgL_objzd2classzd2numz00_2370);
											{	/* Ast/shrinkify.scm 207 */
												long BgL_offsetz00_2375;

												BgL_offsetz00_2375 =
													((long) (BgL_offsetz00_2374) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 207 */
													long BgL_modz00_2376;

													{	/* Ast/shrinkify.scm 207 */
														int BgL_arg2358z00_2377;

														BgL_arg2358z00_2377 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 207 */
															long BgL_auxz00_2882;

															BgL_auxz00_2882 = (long) (BgL_arg2358z00_2377);
															BgL_modz00_2376 =
																(BgL_offsetz00_2375 / BgL_auxz00_2882);
													}}
													{	/* Ast/shrinkify.scm 207 */
														long BgL_restz00_2378;

														{	/* Ast/shrinkify.scm 207 */
															int BgL_arg2357z00_2379;

															BgL_arg2357z00_2379 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 207 */
																long BgL_auxz00_2886;

																BgL_auxz00_2886 = (long) (BgL_arg2357z00_2379);
																BgL_restz00_2378 =
																	(BgL_offsetz00_2375 % BgL_auxz00_2886);
														}}
														{	/* Ast/shrinkify.scm 207 */

															BgL_method3118z00_2368 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2373,
																	(int) (BgL_modz00_2376)),
																(int) (BgL_restz00_2378));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 207 */
								obj_t BgL_xz00_2527;

								BgL_xz00_2527 =
									PROCEDURE_ENTRY(BgL_method3118z00_2368)
									(BgL_method3118z00_2368, (obj_t) (BgL_arg3312z00_1347), BEOA);
								BgL_res3415z00_2393 = BUNSPEC;
						}} BgL_res3415z00_2393;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-let-var3154 */
	obj_t BGl_shrinkzd2nodez12zd2letzd2var3154zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2484, obj_t BgL_nodez00_2485)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 192 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1327;

				BgL_nodez00_1327 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_2485);
				{	/* Ast/shrinkify.scm 194 */
					BgL_nodez00_bglt BgL_arg3305z00_1331;

					BgL_arg3305z00_1331 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1327))->BgL_bodyz00);
					{	/* Ast/shrinkify.scm 194 */
						obj_t BgL_res3404z00_2278;

						{	/* Ast/shrinkify.scm 194 */
							obj_t BgL_method3118z00_2253;

							{	/* Ast/shrinkify.scm 194 */
								BgL_objectz00_bglt BgL_objz00_2254;

								BgL_objz00_2254 = (BgL_objectz00_bglt) (BgL_arg3305z00_1331);
								{	/* Ast/shrinkify.scm 194 */
									long BgL_objzd2classzd2numz00_2255;

									BgL_objzd2classzd2numz00_2255 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2254);
									{	/* Ast/shrinkify.scm 194 */
										obj_t BgL_arg2356z00_2256;

										BgL_arg2356z00_2256 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 194 */
											obj_t BgL_arrayz00_2258;

											int BgL_offsetz00_2259;

											BgL_arrayz00_2258 = BgL_arg2356z00_2256;
											BgL_offsetz00_2259 =
												(int) (BgL_objzd2classzd2numz00_2255);
											{	/* Ast/shrinkify.scm 194 */
												long BgL_offsetz00_2260;

												BgL_offsetz00_2260 =
													((long) (BgL_offsetz00_2259) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 194 */
													long BgL_modz00_2261;

													{	/* Ast/shrinkify.scm 194 */
														int BgL_arg2358z00_2262;

														BgL_arg2358z00_2262 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 194 */
															long BgL_auxz00_2906;

															BgL_auxz00_2906 = (long) (BgL_arg2358z00_2262);
															BgL_modz00_2261 =
																(BgL_offsetz00_2260 / BgL_auxz00_2906);
													}}
													{	/* Ast/shrinkify.scm 194 */
														long BgL_restz00_2263;

														{	/* Ast/shrinkify.scm 194 */
															int BgL_arg2357z00_2264;

															BgL_arg2357z00_2264 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 194 */
																long BgL_auxz00_2910;

																BgL_auxz00_2910 = (long) (BgL_arg2357z00_2264);
																BgL_restz00_2263 =
																	(BgL_offsetz00_2260 % BgL_auxz00_2910);
														}}
														{	/* Ast/shrinkify.scm 194 */

															BgL_method3118z00_2253 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2258,
																	(int) (BgL_modz00_2261)),
																(int) (BgL_restz00_2263));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 194 */
								obj_t BgL_xz00_2528;

								BgL_xz00_2528 =
									PROCEDURE_ENTRY(BgL_method3118z00_2253)
									(BgL_method3118z00_2253, (obj_t) (BgL_arg3305z00_1331), BEOA);
								BgL_res3404z00_2278 = BUNSPEC;
						}} BgL_res3404z00_2278;
				}}
				{	/* Ast/shrinkify.scm 195 */
					obj_t BgL_g3111z00_1332;

					BgL_g3111z00_1332 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1327))->BgL_bindingsz00);
					{
						obj_t BgL_l3109z00_1333;

						BgL_l3109z00_1333 = BgL_g3111z00_1332;
					BgL_forzd2each3110zd2_1334:
						if (PAIRP(BgL_l3109z00_1333))
							{	/* Ast/shrinkify.scm 195 */
								{	/* Ast/shrinkify.scm 197 */
									obj_t BgL_bindingz00_1336;

									BgL_bindingz00_1336 = CAR(BgL_l3109z00_1333);
									{	/* Ast/shrinkify.scm 196 */
										obj_t BgL_arg3307z00_1337;

										BgL_arg3307z00_1337 = CAR(BgL_bindingz00_1336);
										{	/* Ast/shrinkify.scm 196 */
											BgL_variablez00_bglt BgL_variablez00_2283;

											BgL_variablez00_2283 =
												(BgL_variablez00_bglt) (BgL_arg3307z00_1337);
											{	/* Ast/shrinkify.scm 196 */
												obj_t BgL_method3115z00_2284;

												{	/* Ast/shrinkify.scm 196 */
													BgL_objectz00_bglt BgL_objz00_2285;

													BgL_objz00_2285 =
														(BgL_objectz00_bglt) (BgL_variablez00_2283);
													{	/* Ast/shrinkify.scm 196 */
														long BgL_objzd2classzd2numz00_2286;

														BgL_objzd2classzd2numz00_2286 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_2285);
														{	/* Ast/shrinkify.scm 196 */
															obj_t BgL_arg2356z00_2287;

															BgL_arg2356z00_2287 =
																PROCEDURE_REF
																(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
																(int) (((long) 1)));
															{	/* Ast/shrinkify.scm 196 */
																obj_t BgL_arrayz00_2289;

																int BgL_offsetz00_2290;

																BgL_arrayz00_2289 = BgL_arg2356z00_2287;
																BgL_offsetz00_2290 =
																	(int) (BgL_objzd2classzd2numz00_2286);
																{	/* Ast/shrinkify.scm 196 */
																	long BgL_offsetz00_2291;

																	BgL_offsetz00_2291 =
																		((long) (BgL_offsetz00_2290) - OBJECT_TYPE);
																	{	/* Ast/shrinkify.scm 196 */
																		long BgL_modz00_2292;

																		{	/* Ast/shrinkify.scm 196 */
																			int BgL_arg2358z00_2293;

																			BgL_arg2358z00_2293 = (int) (((long) 8));
																			{	/* Ast/shrinkify.scm 196 */
																				long BgL_auxz00_2934;

																				BgL_auxz00_2934 =
																					(long) (BgL_arg2358z00_2293);
																				BgL_modz00_2292 =
																					(BgL_offsetz00_2291 /
																					BgL_auxz00_2934);
																		}}
																		{	/* Ast/shrinkify.scm 196 */
																			long BgL_restz00_2294;

																			{	/* Ast/shrinkify.scm 196 */
																				int BgL_arg2357z00_2295;

																				BgL_arg2357z00_2295 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 196 */
																					long BgL_auxz00_2938;

																					BgL_auxz00_2938 =
																						(long) (BgL_arg2357z00_2295);
																					BgL_restz00_2294 =
																						(BgL_offsetz00_2291 %
																						BgL_auxz00_2938);
																			}}
																			{	/* Ast/shrinkify.scm 196 */

																				BgL_method3115z00_2284 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_2289,
																						(int) (BgL_modz00_2292)),
																					(int) (BgL_restz00_2294));
												}}}}}}}}
												PROCEDURE_ENTRY(BgL_method3115z00_2284)
													(BgL_method3115z00_2284,
													(obj_t) (BgL_variablez00_2283), BEOA);
									}}}
									{	/* Ast/shrinkify.scm 197 */
										obj_t BgL_arg3308z00_1338;

										BgL_arg3308z00_1338 = CDR(BgL_bindingz00_1336);
										{	/* Ast/shrinkify.scm 197 */
											obj_t BgL_res3409z00_2336;

											{	/* Ast/shrinkify.scm 197 */
												BgL_nodez00_bglt BgL_nodez00_2310;

												BgL_nodez00_2310 =
													(BgL_nodez00_bglt) (BgL_arg3308z00_1338);
												{	/* Ast/shrinkify.scm 197 */
													obj_t BgL_method3118z00_2311;

													{	/* Ast/shrinkify.scm 197 */
														BgL_objectz00_bglt BgL_objz00_2312;

														BgL_objz00_2312 =
															(BgL_objectz00_bglt) (BgL_nodez00_2310);
														{	/* Ast/shrinkify.scm 197 */
															long BgL_objzd2classzd2numz00_2313;

															BgL_objzd2classzd2numz00_2313 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_2312);
															{	/* Ast/shrinkify.scm 197 */
																obj_t BgL_arg2356z00_2314;

																BgL_arg2356z00_2314 =
																	PROCEDURE_REF
																	(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
																	(int) (((long) 1)));
																{	/* Ast/shrinkify.scm 197 */
																	obj_t BgL_arrayz00_2316;

																	int BgL_offsetz00_2317;

																	BgL_arrayz00_2316 = BgL_arg2356z00_2314;
																	BgL_offsetz00_2317 =
																		(int) (BgL_objzd2classzd2numz00_2313);
																	{	/* Ast/shrinkify.scm 197 */
																		long BgL_offsetz00_2318;

																		BgL_offsetz00_2318 =
																			(
																			(long) (BgL_offsetz00_2317) -
																			OBJECT_TYPE);
																		{	/* Ast/shrinkify.scm 197 */
																			long BgL_modz00_2319;

																			{	/* Ast/shrinkify.scm 197 */
																				int BgL_arg2358z00_2320;

																				BgL_arg2358z00_2320 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 197 */
																					long BgL_auxz00_2958;

																					BgL_auxz00_2958 =
																						(long) (BgL_arg2358z00_2320);
																					BgL_modz00_2319 =
																						(BgL_offsetz00_2318 /
																						BgL_auxz00_2958);
																			}}
																			{	/* Ast/shrinkify.scm 197 */
																				long BgL_restz00_2321;

																				{	/* Ast/shrinkify.scm 197 */
																					int BgL_arg2357z00_2322;

																					BgL_arg2357z00_2322 =
																						(int) (((long) 8));
																					{	/* Ast/shrinkify.scm 197 */
																						long BgL_auxz00_2962;

																						BgL_auxz00_2962 =
																							(long) (BgL_arg2357z00_2322);
																						BgL_restz00_2321 =
																							(BgL_offsetz00_2318 %
																							BgL_auxz00_2962);
																				}}
																				{	/* Ast/shrinkify.scm 197 */

																					BgL_method3118z00_2311 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_2316,
																							(int) (BgL_modz00_2319)),
																						(int) (BgL_restz00_2321));
													}}}}}}}}
													{	/* Ast/shrinkify.scm 197 */
														obj_t BgL_xz00_2529;

														BgL_xz00_2529 =
															PROCEDURE_ENTRY(BgL_method3118z00_2311)
															(BgL_method3118z00_2311,
															(obj_t) (BgL_nodez00_2310), BEOA);
														BgL_res3409z00_2336 = BUNSPEC;
											}}} BgL_res3409z00_2336;
								}}}
								{
									obj_t BgL_l3109z00_2972;

									BgL_l3109z00_2972 = CDR(BgL_l3109z00_1333);
									BgL_l3109z00_1333 = BgL_l3109z00_2972;
									goto BgL_forzd2each3110zd2_1334;
								}
							}
						else
							{	/* Ast/shrinkify.scm 195 */
								((bool_t) 1);
							}
					}
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-let-fun3152 */
	obj_t BGl_shrinkzd2nodez12zd2letzd2fun3152zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2486, obj_t BgL_nodez00_2487)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 178 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1306;

				BgL_nodez00_1306 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_2487);
				{	/* Ast/shrinkify.scm 180 */
					BgL_nodez00_bglt BgL_arg3297z00_1310;

					BgL_arg3297z00_1310 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1306))->BgL_bodyz00);
					{	/* Ast/shrinkify.scm 180 */
						obj_t BgL_res3394z00_2161;

						{	/* Ast/shrinkify.scm 180 */
							obj_t BgL_method3118z00_2136;

							{	/* Ast/shrinkify.scm 180 */
								BgL_objectz00_bglt BgL_objz00_2137;

								BgL_objz00_2137 = (BgL_objectz00_bglt) (BgL_arg3297z00_1310);
								{	/* Ast/shrinkify.scm 180 */
									long BgL_objzd2classzd2numz00_2138;

									BgL_objzd2classzd2numz00_2138 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2137);
									{	/* Ast/shrinkify.scm 180 */
										obj_t BgL_arg2356z00_2139;

										BgL_arg2356z00_2139 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 180 */
											obj_t BgL_arrayz00_2141;

											int BgL_offsetz00_2142;

											BgL_arrayz00_2141 = BgL_arg2356z00_2139;
											BgL_offsetz00_2142 =
												(int) (BgL_objzd2classzd2numz00_2138);
											{	/* Ast/shrinkify.scm 180 */
												long BgL_offsetz00_2143;

												BgL_offsetz00_2143 =
													((long) (BgL_offsetz00_2142) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 180 */
													long BgL_modz00_2144;

													{	/* Ast/shrinkify.scm 180 */
														int BgL_arg2358z00_2145;

														BgL_arg2358z00_2145 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 180 */
															long BgL_auxz00_2984;

															BgL_auxz00_2984 = (long) (BgL_arg2358z00_2145);
															BgL_modz00_2144 =
																(BgL_offsetz00_2143 / BgL_auxz00_2984);
													}}
													{	/* Ast/shrinkify.scm 180 */
														long BgL_restz00_2146;

														{	/* Ast/shrinkify.scm 180 */
															int BgL_arg2357z00_2147;

															BgL_arg2357z00_2147 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 180 */
																long BgL_auxz00_2988;

																BgL_auxz00_2988 = (long) (BgL_arg2357z00_2147);
																BgL_restz00_2146 =
																	(BgL_offsetz00_2143 % BgL_auxz00_2988);
														}}
														{	/* Ast/shrinkify.scm 180 */

															BgL_method3118z00_2136 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2141,
																	(int) (BgL_modz00_2144)),
																(int) (BgL_restz00_2146));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 180 */
								obj_t BgL_xz00_2530;

								BgL_xz00_2530 =
									PROCEDURE_ENTRY(BgL_method3118z00_2136)
									(BgL_method3118z00_2136, (obj_t) (BgL_arg3297z00_1310), BEOA);
								BgL_res3394z00_2161 = BUNSPEC;
						}} BgL_res3394z00_2161;
				}}
				{	/* Ast/shrinkify.scm 181 */
					obj_t BgL_g3108z00_1311;

					BgL_g3108z00_1311 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1306))->BgL_localsz00);
					{
						obj_t BgL_l3106z00_1312;

						BgL_l3106z00_1312 = BgL_g3108z00_1311;
					BgL_forzd2each3107zd2_1313:
						if (PAIRP(BgL_l3106z00_1312))
							{	/* Ast/shrinkify.scm 181 */
								{	/* Ast/shrinkify.scm 182 */
									obj_t BgL_localz00_1315;

									BgL_localz00_1315 = CAR(BgL_l3106z00_1312);
									{	/* Ast/shrinkify.scm 182 */
										BgL_valuez00_bglt BgL_sfunz00_1316;

										{
											BgL_variablez00_bglt BgL_auxz00_3002;

											BgL_auxz00_3002 =
												(BgL_variablez00_bglt) (BgL_localz00_1315);
											BgL_sfunz00_1316 =
												(((BgL_variablez00_bglt) CREF(BgL_auxz00_3002))->
												BgL_valuez00);
										}
										{	/* Ast/shrinkify.scm 183 */
											BgL_variablez00_bglt BgL_variablez00_2166;

											BgL_variablez00_2166 =
												(BgL_variablez00_bglt) (BgL_localz00_1315);
											{	/* Ast/shrinkify.scm 183 */
												obj_t BgL_method3115z00_2167;

												{	/* Ast/shrinkify.scm 183 */
													BgL_objectz00_bglt BgL_objz00_2168;

													BgL_objz00_2168 =
														(BgL_objectz00_bglt) (BgL_variablez00_2166);
													{	/* Ast/shrinkify.scm 183 */
														long BgL_objzd2classzd2numz00_2169;

														BgL_objzd2classzd2numz00_2169 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_2168);
														{	/* Ast/shrinkify.scm 183 */
															obj_t BgL_arg2356z00_2170;

															BgL_arg2356z00_2170 =
																PROCEDURE_REF
																(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
																(int) (((long) 1)));
															{	/* Ast/shrinkify.scm 183 */
																obj_t BgL_arrayz00_2172;

																int BgL_offsetz00_2173;

																BgL_arrayz00_2172 = BgL_arg2356z00_2170;
																BgL_offsetz00_2173 =
																	(int) (BgL_objzd2classzd2numz00_2169);
																{	/* Ast/shrinkify.scm 183 */
																	long BgL_offsetz00_2174;

																	BgL_offsetz00_2174 =
																		((long) (BgL_offsetz00_2173) - OBJECT_TYPE);
																	{	/* Ast/shrinkify.scm 183 */
																		long BgL_modz00_2175;

																		{	/* Ast/shrinkify.scm 183 */
																			int BgL_arg2358z00_2176;

																			BgL_arg2358z00_2176 = (int) (((long) 8));
																			{	/* Ast/shrinkify.scm 183 */
																				long BgL_auxz00_3014;

																				BgL_auxz00_3014 =
																					(long) (BgL_arg2358z00_2176);
																				BgL_modz00_2175 =
																					(BgL_offsetz00_2174 /
																					BgL_auxz00_3014);
																		}}
																		{	/* Ast/shrinkify.scm 183 */
																			long BgL_restz00_2177;

																			{	/* Ast/shrinkify.scm 183 */
																				int BgL_arg2357z00_2178;

																				BgL_arg2357z00_2178 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 183 */
																					long BgL_auxz00_3018;

																					BgL_auxz00_3018 =
																						(long) (BgL_arg2357z00_2178);
																					BgL_restz00_2177 =
																						(BgL_offsetz00_2174 %
																						BgL_auxz00_3018);
																			}}
																			{	/* Ast/shrinkify.scm 183 */

																				BgL_method3115z00_2167 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_2172,
																						(int) (BgL_modz00_2175)),
																					(int) (BgL_restz00_2177));
												}}}}}}}}
												PROCEDURE_ENTRY(BgL_method3115z00_2167)
													(BgL_method3115z00_2167,
													(obj_t) (BgL_variablez00_2166), BEOA);
										}}
										{	/* Ast/shrinkify.scm 184 */
											obj_t BgL_g3105z00_1317;

											{
												BgL_sfunz00_bglt BgL_auxz00_3028;

												BgL_auxz00_3028 = (BgL_sfunz00_bglt) (BgL_sfunz00_1316);
												BgL_g3105z00_1317 =
													(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3028))->
													BgL_argsz00);
											}
											{
												obj_t BgL_l3103z00_1318;

												BgL_l3103z00_1318 = BgL_g3105z00_1317;
											BgL_forzd2each3104zd2_1319:
												if (PAIRP(BgL_l3103z00_1318))
													{	/* Ast/shrinkify.scm 184 */
														{	/* Ast/shrinkify.scm 184 */
															obj_t BgL_arg3300z00_1321;

															BgL_arg3300z00_1321 = CAR(BgL_l3103z00_1318);
															{	/* Ast/shrinkify.scm 184 */
																BgL_variablez00_bglt BgL_variablez00_2195;

																BgL_variablez00_2195 =
																	(BgL_variablez00_bglt) (BgL_arg3300z00_1321);
																{	/* Ast/shrinkify.scm 184 */
																	obj_t BgL_method3115z00_2196;

																	{	/* Ast/shrinkify.scm 184 */
																		BgL_objectz00_bglt BgL_objz00_2197;

																		BgL_objz00_2197 =
																			(BgL_objectz00_bglt)
																			(BgL_variablez00_2195);
																		{	/* Ast/shrinkify.scm 184 */
																			long BgL_objzd2classzd2numz00_2198;

																			BgL_objzd2classzd2numz00_2198 =
																				BGL_OBJECT_CLASS_NUM(BgL_objz00_2197);
																			{	/* Ast/shrinkify.scm 184 */
																				obj_t BgL_arg2356z00_2199;

																				BgL_arg2356z00_2199 =
																					PROCEDURE_REF
																					(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
																					(int) (((long) 1)));
																				{	/* Ast/shrinkify.scm 184 */
																					obj_t BgL_arrayz00_2201;

																					int BgL_offsetz00_2202;

																					BgL_arrayz00_2201 =
																						BgL_arg2356z00_2199;
																					BgL_offsetz00_2202 =
																						(int)
																						(BgL_objzd2classzd2numz00_2198);
																					{	/* Ast/shrinkify.scm 184 */
																						long BgL_offsetz00_2203;

																						BgL_offsetz00_2203 =
																							(
																							(long) (BgL_offsetz00_2202) -
																							OBJECT_TYPE);
																						{	/* Ast/shrinkify.scm 184 */
																							long BgL_modz00_2204;

																							{	/* Ast/shrinkify.scm 184 */
																								int BgL_arg2358z00_2205;

																								BgL_arg2358z00_2205 =
																									(int) (((long) 8));
																								{	/* Ast/shrinkify.scm 184 */
																									long BgL_auxz00_3043;

																									BgL_auxz00_3043 =
																										(long)
																										(BgL_arg2358z00_2205);
																									BgL_modz00_2204 =
																										(BgL_offsetz00_2203 /
																										BgL_auxz00_3043);
																							}}
																							{	/* Ast/shrinkify.scm 184 */
																								long BgL_restz00_2206;

																								{	/* Ast/shrinkify.scm 184 */
																									int BgL_arg2357z00_2207;

																									BgL_arg2357z00_2207 =
																										(int) (((long) 8));
																									{	/* Ast/shrinkify.scm 184 */
																										long BgL_auxz00_3047;

																										BgL_auxz00_3047 =
																											(long)
																											(BgL_arg2357z00_2207);
																										BgL_restz00_2206 =
																											(BgL_offsetz00_2203 %
																											BgL_auxz00_3047);
																								}}
																								{	/* Ast/shrinkify.scm 184 */

																									BgL_method3115z00_2196 =
																										VECTOR_REF(VECTOR_REF
																										(BgL_arrayz00_2201,
																											(int) (BgL_modz00_2204)),
																										(int) (BgL_restz00_2206));
																	}}}}}}}}
																	PROCEDURE_ENTRY(BgL_method3115z00_2196)
																		(BgL_method3115z00_2196,
																		(obj_t) (BgL_variablez00_2195), BEOA);
														}}}
														{
															obj_t BgL_l3103z00_3057;

															BgL_l3103z00_3057 = CDR(BgL_l3103z00_1318);
															BgL_l3103z00_1318 = BgL_l3103z00_3057;
															goto BgL_forzd2each3104zd2_1319;
														}
													}
												else
													{	/* Ast/shrinkify.scm 184 */
														((bool_t) 1);
													}
											}
										}
										{	/* Ast/shrinkify.scm 185 */
											obj_t BgL_arg3302z00_1323;

											{
												BgL_sfunz00_bglt BgL_auxz00_3059;

												BgL_auxz00_3059 = (BgL_sfunz00_bglt) (BgL_sfunz00_1316);
												BgL_arg3302z00_1323 =
													(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3059))->
													BgL_bodyz00);
											}
											{	/* Ast/shrinkify.scm 185 */
												obj_t BgL_res3401z00_2249;

												{	/* Ast/shrinkify.scm 185 */
													BgL_nodez00_bglt BgL_nodez00_2223;

													BgL_nodez00_2223 =
														(BgL_nodez00_bglt) (BgL_arg3302z00_1323);
													{	/* Ast/shrinkify.scm 185 */
														obj_t BgL_method3118z00_2224;

														{	/* Ast/shrinkify.scm 185 */
															BgL_objectz00_bglt BgL_objz00_2225;

															BgL_objz00_2225 =
																(BgL_objectz00_bglt) (BgL_nodez00_2223);
															{	/* Ast/shrinkify.scm 185 */
																long BgL_objzd2classzd2numz00_2226;

																BgL_objzd2classzd2numz00_2226 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_2225);
																{	/* Ast/shrinkify.scm 185 */
																	obj_t BgL_arg2356z00_2227;

																	BgL_arg2356z00_2227 =
																		PROCEDURE_REF
																		(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
																		(int) (((long) 1)));
																	{	/* Ast/shrinkify.scm 185 */
																		obj_t BgL_arrayz00_2229;

																		int BgL_offsetz00_2230;

																		BgL_arrayz00_2229 = BgL_arg2356z00_2227;
																		BgL_offsetz00_2230 =
																			(int) (BgL_objzd2classzd2numz00_2226);
																		{	/* Ast/shrinkify.scm 185 */
																			long BgL_offsetz00_2231;

																			BgL_offsetz00_2231 =
																				(
																				(long) (BgL_offsetz00_2230) -
																				OBJECT_TYPE);
																			{	/* Ast/shrinkify.scm 185 */
																				long BgL_modz00_2232;

																				{	/* Ast/shrinkify.scm 185 */
																					int BgL_arg2358z00_2233;

																					BgL_arg2358z00_2233 =
																						(int) (((long) 8));
																					{	/* Ast/shrinkify.scm 185 */
																						long BgL_auxz00_3071;

																						BgL_auxz00_3071 =
																							(long) (BgL_arg2358z00_2233);
																						BgL_modz00_2232 =
																							(BgL_offsetz00_2231 /
																							BgL_auxz00_3071);
																				}}
																				{	/* Ast/shrinkify.scm 185 */
																					long BgL_restz00_2234;

																					{	/* Ast/shrinkify.scm 185 */
																						int BgL_arg2357z00_2235;

																						BgL_arg2357z00_2235 =
																							(int) (((long) 8));
																						{	/* Ast/shrinkify.scm 185 */
																							long BgL_auxz00_3075;

																							BgL_auxz00_3075 =
																								(long) (BgL_arg2357z00_2235);
																							BgL_restz00_2234 =
																								(BgL_offsetz00_2231 %
																								BgL_auxz00_3075);
																					}}
																					{	/* Ast/shrinkify.scm 185 */

																						BgL_method3118z00_2224 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_2229,
																								(int) (BgL_modz00_2232)),
																							(int) (BgL_restz00_2234));
														}}}}}}}}
														{	/* Ast/shrinkify.scm 185 */
															obj_t BgL_xz00_2531;

															BgL_xz00_2531 =
																PROCEDURE_ENTRY(BgL_method3118z00_2224)
																(BgL_method3118z00_2224,
																(obj_t) (BgL_nodez00_2223), BEOA);
															BgL_res3401z00_2249 = BUNSPEC;
												}}} BgL_res3401z00_2249;
								}}}}
								{
									obj_t BgL_l3106z00_3085;

									BgL_l3106z00_3085 = CDR(BgL_l3106z00_1312);
									BgL_l3106z00_1312 = BgL_l3106z00_3085;
									goto BgL_forzd2each3107zd2_1313;
								}
							}
						else
							{	/* Ast/shrinkify.scm 181 */
								((bool_t) 1);
							}
					}
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-box-set3150 */
	obj_t BGl_shrinkzd2nodez12zd2boxzd2set3150zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2488, obj_t BgL_nodez00_2489)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 169 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1294;

				BgL_nodez00_1294 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_2489);
				{	/* Ast/shrinkify.scm 170 */
					bool_t BgL_testz00_3088;

					{	/* Ast/shrinkify.scm 170 */
						bool_t BgL_testz00_3089;

						{	/* Ast/shrinkify.scm 170 */
							obj_t BgL_auxz00_3090;

							{	/* Ast/shrinkify.scm 170 */
								BgL_objectz00_bglt BgL_auxz00_3091;

								BgL_auxz00_3091 = (BgL_objectz00_bglt) (BgL_nodez00_1294);
								BgL_auxz00_3090 = BGL_OBJECT_WIDENING(BgL_auxz00_3091);
							}
							BgL_testz00_3089 = CBOOL(BgL_auxz00_3090);
						}
						if (BgL_testz00_3089)
							{	/* Ast/shrinkify.scm 170 */
								BgL_testz00_3088 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 170 */
								BgL_testz00_3088 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3088)
						{	/* Ast/shrinkify.scm 170 */
							{	/* Ast/shrinkify.scm 170 */
								long BgL_arg3291z00_1299;

								{	/* Ast/shrinkify.scm 170 */
									obj_t BgL_arg3292z00_1300;

									{	/* Ast/shrinkify.scm 170 */
										obj_t BgL_arg3293z00_1301;

										{	/* Ast/shrinkify.scm 170 */
											BgL_objectz00_bglt BgL_objectz00_2068;

											BgL_objectz00_2068 =
												(BgL_objectz00_bglt) (BgL_nodez00_1294);
											{	/* Ast/shrinkify.scm 170 */
												long BgL_arg2359z00_2069;

												{	/* Ast/shrinkify.scm 170 */
													long BgL_arg2360z00_2070;

													BgL_arg2360z00_2070 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_2068);
													BgL_arg2359z00_2069 =
														(BgL_arg2360z00_2070 - OBJECT_TYPE);
												}
												BgL_arg3293z00_1301 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2359z00_2069));
										}}
										BgL_arg3292z00_1300 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3293z00_1301);
									}
									BgL_arg3291z00_1299 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3292z00_1300);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1294), BgL_arg3291z00_1299);
							}
							{	/* Ast/shrinkify.scm 170 */
								BgL_objectz00_bglt BgL_auxz00_3104;

								BgL_auxz00_3104 = (BgL_objectz00_bglt) (BgL_nodez00_1294);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3104, BFALSE);
							}
							(obj_t) (BgL_nodez00_1294);
						}
					else
						{	/* Ast/shrinkify.scm 170 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 171 */
					BgL_varz00_bglt BgL_arg3294z00_1302;

					BgL_arg3294z00_1302 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1294))->BgL_varz00);
					{	/* Ast/shrinkify.scm 171 */
						obj_t BgL_res3388z00_2105;

						{	/* Ast/shrinkify.scm 171 */
							BgL_nodez00_bglt BgL_nodez00_2079;

							BgL_nodez00_2079 = (BgL_nodez00_bglt) (BgL_arg3294z00_1302);
							{	/* Ast/shrinkify.scm 171 */
								obj_t BgL_method3118z00_2080;

								{	/* Ast/shrinkify.scm 171 */
									BgL_objectz00_bglt BgL_objz00_2081;

									BgL_objz00_2081 = (BgL_objectz00_bglt) (BgL_nodez00_2079);
									{	/* Ast/shrinkify.scm 171 */
										long BgL_objzd2classzd2numz00_2082;

										BgL_objzd2classzd2numz00_2082 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2081);
										{	/* Ast/shrinkify.scm 171 */
											obj_t BgL_arg2356z00_2083;

											BgL_arg2356z00_2083 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 171 */
												obj_t BgL_arrayz00_2085;

												int BgL_offsetz00_2086;

												BgL_arrayz00_2085 = BgL_arg2356z00_2083;
												BgL_offsetz00_2086 =
													(int) (BgL_objzd2classzd2numz00_2082);
												{	/* Ast/shrinkify.scm 171 */
													long BgL_offsetz00_2087;

													BgL_offsetz00_2087 =
														((long) (BgL_offsetz00_2086) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 171 */
														long BgL_modz00_2088;

														{	/* Ast/shrinkify.scm 171 */
															int BgL_arg2358z00_2089;

															BgL_arg2358z00_2089 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 171 */
																long BgL_auxz00_3118;

																BgL_auxz00_3118 = (long) (BgL_arg2358z00_2089);
																BgL_modz00_2088 =
																	(BgL_offsetz00_2087 / BgL_auxz00_3118);
														}}
														{	/* Ast/shrinkify.scm 171 */
															long BgL_restz00_2090;

															{	/* Ast/shrinkify.scm 171 */
																int BgL_arg2357z00_2091;

																BgL_arg2357z00_2091 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 171 */
																	long BgL_auxz00_3122;

																	BgL_auxz00_3122 =
																		(long) (BgL_arg2357z00_2091);
																	BgL_restz00_2090 =
																		(BgL_offsetz00_2087 % BgL_auxz00_3122);
															}}
															{	/* Ast/shrinkify.scm 171 */

																BgL_method3118z00_2080 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2085,
																		(int) (BgL_modz00_2088)),
																	(int) (BgL_restz00_2090));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 171 */
									obj_t BgL_xz00_2532;

									BgL_xz00_2532 =
										PROCEDURE_ENTRY(BgL_method3118z00_2080)
										(BgL_method3118z00_2080, (obj_t) (BgL_nodez00_2079), BEOA);
									BgL_res3388z00_2105 = BUNSPEC;
						}}} BgL_res3388z00_2105;
				}}
				{	/* Ast/shrinkify.scm 172 */
					BgL_nodez00_bglt BgL_arg3295z00_1303;

					BgL_arg3295z00_1303 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1294))->BgL_valuez00);
					{	/* Ast/shrinkify.scm 172 */
						obj_t BgL_res3391z00_2133;

						{	/* Ast/shrinkify.scm 172 */
							obj_t BgL_method3118z00_2108;

							{	/* Ast/shrinkify.scm 172 */
								BgL_objectz00_bglt BgL_objz00_2109;

								BgL_objz00_2109 = (BgL_objectz00_bglt) (BgL_arg3295z00_1303);
								{	/* Ast/shrinkify.scm 172 */
									long BgL_objzd2classzd2numz00_2110;

									BgL_objzd2classzd2numz00_2110 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2109);
									{	/* Ast/shrinkify.scm 172 */
										obj_t BgL_arg2356z00_2111;

										BgL_arg2356z00_2111 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 172 */
											obj_t BgL_arrayz00_2113;

											int BgL_offsetz00_2114;

											BgL_arrayz00_2113 = BgL_arg2356z00_2111;
											BgL_offsetz00_2114 =
												(int) (BgL_objzd2classzd2numz00_2110);
											{	/* Ast/shrinkify.scm 172 */
												long BgL_offsetz00_2115;

												BgL_offsetz00_2115 =
													((long) (BgL_offsetz00_2114) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 172 */
													long BgL_modz00_2116;

													{	/* Ast/shrinkify.scm 172 */
														int BgL_arg2358z00_2117;

														BgL_arg2358z00_2117 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 172 */
															long BgL_auxz00_3141;

															BgL_auxz00_3141 = (long) (BgL_arg2358z00_2117);
															BgL_modz00_2116 =
																(BgL_offsetz00_2115 / BgL_auxz00_3141);
													}}
													{	/* Ast/shrinkify.scm 172 */
														long BgL_restz00_2118;

														{	/* Ast/shrinkify.scm 172 */
															int BgL_arg2357z00_2119;

															BgL_arg2357z00_2119 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 172 */
																long BgL_auxz00_3145;

																BgL_auxz00_3145 = (long) (BgL_arg2357z00_2119);
																BgL_restz00_2118 =
																	(BgL_offsetz00_2115 % BgL_auxz00_3145);
														}}
														{	/* Ast/shrinkify.scm 172 */

															BgL_method3118z00_2108 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2113,
																	(int) (BgL_modz00_2116)),
																(int) (BgL_restz00_2118));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 172 */
								obj_t BgL_xz00_2533;

								BgL_xz00_2533 =
									PROCEDURE_ENTRY(BgL_method3118z00_2108)
									(BgL_method3118z00_2108, (obj_t) (BgL_arg3295z00_1303), BEOA);
								BgL_res3391z00_2133 = BUNSPEC;
						}} BgL_res3391z00_2133;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-box-ref3148 */
	obj_t BGl_shrinkzd2nodez12zd2boxzd2ref3148zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2490, obj_t BgL_nodez00_2491)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 161 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1283;

				BgL_nodez00_1283 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_2491);
				{	/* Ast/shrinkify.scm 162 */
					bool_t BgL_testz00_3156;

					{	/* Ast/shrinkify.scm 162 */
						bool_t BgL_testz00_3157;

						{	/* Ast/shrinkify.scm 162 */
							obj_t BgL_auxz00_3158;

							{	/* Ast/shrinkify.scm 162 */
								BgL_objectz00_bglt BgL_auxz00_3159;

								BgL_auxz00_3159 = (BgL_objectz00_bglt) (BgL_nodez00_1283);
								BgL_auxz00_3158 = BGL_OBJECT_WIDENING(BgL_auxz00_3159);
							}
							BgL_testz00_3157 = CBOOL(BgL_auxz00_3158);
						}
						if (BgL_testz00_3157)
							{	/* Ast/shrinkify.scm 162 */
								BgL_testz00_3156 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 162 */
								BgL_testz00_3156 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3156)
						{	/* Ast/shrinkify.scm 162 */
							{	/* Ast/shrinkify.scm 162 */
								long BgL_arg3285z00_1288;

								{	/* Ast/shrinkify.scm 162 */
									obj_t BgL_arg3286z00_1289;

									{	/* Ast/shrinkify.scm 162 */
										obj_t BgL_arg3287z00_1290;

										{	/* Ast/shrinkify.scm 162 */
											BgL_objectz00_bglt BgL_objectz00_2027;

											BgL_objectz00_2027 =
												(BgL_objectz00_bglt) (BgL_nodez00_1283);
											{	/* Ast/shrinkify.scm 162 */
												long BgL_arg2359z00_2028;

												{	/* Ast/shrinkify.scm 162 */
													long BgL_arg2360z00_2029;

													BgL_arg2360z00_2029 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_2027);
													BgL_arg2359z00_2028 =
														(BgL_arg2360z00_2029 - OBJECT_TYPE);
												}
												BgL_arg3287z00_1290 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2359z00_2028));
										}}
										BgL_arg3286z00_1289 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3287z00_1290);
									}
									BgL_arg3285z00_1288 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3286z00_1289);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1283), BgL_arg3285z00_1288);
							}
							{	/* Ast/shrinkify.scm 162 */
								BgL_objectz00_bglt BgL_auxz00_3172;

								BgL_auxz00_3172 = (BgL_objectz00_bglt) (BgL_nodez00_1283);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3172, BFALSE);
							}
							(obj_t) (BgL_nodez00_1283);
						}
					else
						{	/* Ast/shrinkify.scm 162 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 163 */
					BgL_varz00_bglt BgL_arg3288z00_1291;

					BgL_arg3288z00_1291 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1283))->BgL_varz00);
					{	/* Ast/shrinkify.scm 163 */
						obj_t BgL_res3384z00_2064;

						{	/* Ast/shrinkify.scm 163 */
							BgL_nodez00_bglt BgL_nodez00_2038;

							BgL_nodez00_2038 = (BgL_nodez00_bglt) (BgL_arg3288z00_1291);
							{	/* Ast/shrinkify.scm 163 */
								obj_t BgL_method3118z00_2039;

								{	/* Ast/shrinkify.scm 163 */
									BgL_objectz00_bglt BgL_objz00_2040;

									BgL_objz00_2040 = (BgL_objectz00_bglt) (BgL_nodez00_2038);
									{	/* Ast/shrinkify.scm 163 */
										long BgL_objzd2classzd2numz00_2041;

										BgL_objzd2classzd2numz00_2041 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2040);
										{	/* Ast/shrinkify.scm 163 */
											obj_t BgL_arg2356z00_2042;

											BgL_arg2356z00_2042 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 163 */
												obj_t BgL_arrayz00_2044;

												int BgL_offsetz00_2045;

												BgL_arrayz00_2044 = BgL_arg2356z00_2042;
												BgL_offsetz00_2045 =
													(int) (BgL_objzd2classzd2numz00_2041);
												{	/* Ast/shrinkify.scm 163 */
													long BgL_offsetz00_2046;

													BgL_offsetz00_2046 =
														((long) (BgL_offsetz00_2045) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 163 */
														long BgL_modz00_2047;

														{	/* Ast/shrinkify.scm 163 */
															int BgL_arg2358z00_2048;

															BgL_arg2358z00_2048 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 163 */
																long BgL_auxz00_3186;

																BgL_auxz00_3186 = (long) (BgL_arg2358z00_2048);
																BgL_modz00_2047 =
																	(BgL_offsetz00_2046 / BgL_auxz00_3186);
														}}
														{	/* Ast/shrinkify.scm 163 */
															long BgL_restz00_2049;

															{	/* Ast/shrinkify.scm 163 */
																int BgL_arg2357z00_2050;

																BgL_arg2357z00_2050 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 163 */
																	long BgL_auxz00_3190;

																	BgL_auxz00_3190 =
																		(long) (BgL_arg2357z00_2050);
																	BgL_restz00_2049 =
																		(BgL_offsetz00_2046 % BgL_auxz00_3190);
															}}
															{	/* Ast/shrinkify.scm 163 */

																BgL_method3118z00_2039 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2044,
																		(int) (BgL_modz00_2047)),
																	(int) (BgL_restz00_2049));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 163 */
									obj_t BgL_xz00_2534;

									BgL_xz00_2534 =
										PROCEDURE_ENTRY(BgL_method3118z00_2039)
										(BgL_method3118z00_2039, (obj_t) (BgL_nodez00_2038), BEOA);
									BgL_res3384z00_2064 = BUNSPEC;
						}}} BgL_res3384z00_2064;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-make-bo3146 */
	obj_t BGl_shrinkzd2nodez12zd2makezd2bo3146zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2492, obj_t BgL_nodez00_2493)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 153 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1272;

				BgL_nodez00_1272 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_2493);
				{	/* Ast/shrinkify.scm 154 */
					bool_t BgL_testz00_3201;

					{	/* Ast/shrinkify.scm 154 */
						bool_t BgL_testz00_3202;

						{	/* Ast/shrinkify.scm 154 */
							obj_t BgL_auxz00_3203;

							{	/* Ast/shrinkify.scm 154 */
								BgL_objectz00_bglt BgL_auxz00_3204;

								BgL_auxz00_3204 = (BgL_objectz00_bglt) (BgL_nodez00_1272);
								BgL_auxz00_3203 = BGL_OBJECT_WIDENING(BgL_auxz00_3204);
							}
							BgL_testz00_3202 = CBOOL(BgL_auxz00_3203);
						}
						if (BgL_testz00_3202)
							{	/* Ast/shrinkify.scm 154 */
								BgL_testz00_3201 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 154 */
								BgL_testz00_3201 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3201)
						{	/* Ast/shrinkify.scm 154 */
							{	/* Ast/shrinkify.scm 154 */
								long BgL_arg3279z00_1277;

								{	/* Ast/shrinkify.scm 154 */
									obj_t BgL_arg3280z00_1278;

									{	/* Ast/shrinkify.scm 154 */
										obj_t BgL_arg3281z00_1279;

										{	/* Ast/shrinkify.scm 154 */
											BgL_objectz00_bglt BgL_objectz00_1986;

											BgL_objectz00_1986 =
												(BgL_objectz00_bglt) (BgL_nodez00_1272);
											{	/* Ast/shrinkify.scm 154 */
												long BgL_arg2359z00_1987;

												{	/* Ast/shrinkify.scm 154 */
													long BgL_arg2360z00_1988;

													BgL_arg2360z00_1988 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_1986);
													BgL_arg2359z00_1987 =
														(BgL_arg2360z00_1988 - OBJECT_TYPE);
												}
												BgL_arg3281z00_1279 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2359z00_1987));
										}}
										BgL_arg3280z00_1278 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3281z00_1279);
									}
									BgL_arg3279z00_1277 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3280z00_1278);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1272), BgL_arg3279z00_1277);
							}
							{	/* Ast/shrinkify.scm 154 */
								BgL_objectz00_bglt BgL_auxz00_3217;

								BgL_auxz00_3217 = (BgL_objectz00_bglt) (BgL_nodez00_1272);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3217, BFALSE);
							}
							(obj_t) (BgL_nodez00_1272);
						}
					else
						{	/* Ast/shrinkify.scm 154 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 155 */
					BgL_nodez00_bglt BgL_arg3282z00_1280;

					BgL_arg3282z00_1280 =
						(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1272))->BgL_valuez00);
					{	/* Ast/shrinkify.scm 155 */
						obj_t BgL_res3380z00_2023;

						{	/* Ast/shrinkify.scm 155 */
							obj_t BgL_method3118z00_1998;

							{	/* Ast/shrinkify.scm 155 */
								BgL_objectz00_bglt BgL_objz00_1999;

								BgL_objz00_1999 = (BgL_objectz00_bglt) (BgL_arg3282z00_1280);
								{	/* Ast/shrinkify.scm 155 */
									long BgL_objzd2classzd2numz00_2000;

									BgL_objzd2classzd2numz00_2000 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1999);
									{	/* Ast/shrinkify.scm 155 */
										obj_t BgL_arg2356z00_2001;

										BgL_arg2356z00_2001 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 155 */
											obj_t BgL_arrayz00_2003;

											int BgL_offsetz00_2004;

											BgL_arrayz00_2003 = BgL_arg2356z00_2001;
											BgL_offsetz00_2004 =
												(int) (BgL_objzd2classzd2numz00_2000);
											{	/* Ast/shrinkify.scm 155 */
												long BgL_offsetz00_2005;

												BgL_offsetz00_2005 =
													((long) (BgL_offsetz00_2004) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 155 */
													long BgL_modz00_2006;

													{	/* Ast/shrinkify.scm 155 */
														int BgL_arg2358z00_2007;

														BgL_arg2358z00_2007 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 155 */
															long BgL_auxz00_3230;

															BgL_auxz00_3230 = (long) (BgL_arg2358z00_2007);
															BgL_modz00_2006 =
																(BgL_offsetz00_2005 / BgL_auxz00_3230);
													}}
													{	/* Ast/shrinkify.scm 155 */
														long BgL_restz00_2008;

														{	/* Ast/shrinkify.scm 155 */
															int BgL_arg2357z00_2009;

															BgL_arg2357z00_2009 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 155 */
																long BgL_auxz00_3234;

																BgL_auxz00_3234 = (long) (BgL_arg2357z00_2009);
																BgL_restz00_2008 =
																	(BgL_offsetz00_2005 % BgL_auxz00_3234);
														}}
														{	/* Ast/shrinkify.scm 155 */

															BgL_method3118z00_1998 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2003,
																	(int) (BgL_modz00_2006)),
																(int) (BgL_restz00_2008));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 155 */
								obj_t BgL_xz00_2535;

								BgL_xz00_2535 =
									PROCEDURE_ENTRY(BgL_method3118z00_1998)
									(BgL_method3118z00_1998, (obj_t) (BgL_arg3282z00_1280), BEOA);
								BgL_res3380z00_2023 = BUNSPEC;
						}} BgL_res3380z00_2023;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-select3144 */
	obj_t BGl_shrinkzd2nodez12zd2select3144z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2494, obj_t BgL_nodez00_2495)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 143 */
			{
				BgL_selectz00_bglt BgL_nodez00_1259;

				BgL_nodez00_1259 = (BgL_selectz00_bglt) (BgL_nodez00_2495);
				{	/* Ast/shrinkify.scm 144 */
					BgL_nodez00_bglt BgL_arg3273z00_1262;

					BgL_arg3273z00_1262 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_1259))->BgL_testz00);
					{	/* Ast/shrinkify.scm 144 */
						obj_t BgL_res3373z00_1950;

						{	/* Ast/shrinkify.scm 144 */
							obj_t BgL_method3118z00_1925;

							{	/* Ast/shrinkify.scm 144 */
								BgL_objectz00_bglt BgL_objz00_1926;

								BgL_objz00_1926 = (BgL_objectz00_bglt) (BgL_arg3273z00_1262);
								{	/* Ast/shrinkify.scm 144 */
									long BgL_objzd2classzd2numz00_1927;

									BgL_objzd2classzd2numz00_1927 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1926);
									{	/* Ast/shrinkify.scm 144 */
										obj_t BgL_arg2356z00_1928;

										BgL_arg2356z00_1928 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 144 */
											obj_t BgL_arrayz00_1930;

											int BgL_offsetz00_1931;

											BgL_arrayz00_1930 = BgL_arg2356z00_1928;
											BgL_offsetz00_1931 =
												(int) (BgL_objzd2classzd2numz00_1927);
											{	/* Ast/shrinkify.scm 144 */
												long BgL_offsetz00_1932;

												BgL_offsetz00_1932 =
													((long) (BgL_offsetz00_1931) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 144 */
													long BgL_modz00_1933;

													{	/* Ast/shrinkify.scm 144 */
														int BgL_arg2358z00_1934;

														BgL_arg2358z00_1934 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 144 */
															long BgL_auxz00_3254;

															BgL_auxz00_3254 = (long) (BgL_arg2358z00_1934);
															BgL_modz00_1933 =
																(BgL_offsetz00_1932 / BgL_auxz00_3254);
													}}
													{	/* Ast/shrinkify.scm 144 */
														long BgL_restz00_1935;

														{	/* Ast/shrinkify.scm 144 */
															int BgL_arg2357z00_1936;

															BgL_arg2357z00_1936 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 144 */
																long BgL_auxz00_3258;

																BgL_auxz00_3258 = (long) (BgL_arg2357z00_1936);
																BgL_restz00_1935 =
																	(BgL_offsetz00_1932 % BgL_auxz00_3258);
														}}
														{	/* Ast/shrinkify.scm 144 */

															BgL_method3118z00_1925 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1930,
																	(int) (BgL_modz00_1933)),
																(int) (BgL_restz00_1935));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 144 */
								obj_t BgL_xz00_2536;

								BgL_xz00_2536 =
									PROCEDURE_ENTRY(BgL_method3118z00_1925)
									(BgL_method3118z00_1925, (obj_t) (BgL_arg3273z00_1262), BEOA);
								BgL_res3373z00_1950 = BUNSPEC;
						}} BgL_res3373z00_1950;
				}}
				{	/* Ast/shrinkify.scm 145 */
					obj_t BgL_g3102z00_1263;

					BgL_g3102z00_1263 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_1259))->BgL_clausesz00);
					{
						obj_t BgL_l3100z00_1264;

						BgL_l3100z00_1264 = BgL_g3102z00_1263;
					BgL_forzd2each3101zd2_1265:
						if (PAIRP(BgL_l3100z00_1264))
							{	/* Ast/shrinkify.scm 147 */
								{	/* Ast/shrinkify.scm 146 */
									obj_t BgL_clausez00_1267;

									BgL_clausez00_1267 = CAR(BgL_l3100z00_1264);
									{	/* Ast/shrinkify.scm 146 */
										obj_t BgL_arg3275z00_1268;

										BgL_arg3275z00_1268 = CDR(BgL_clausez00_1267);
										{	/* Ast/shrinkify.scm 146 */
											obj_t BgL_res3376z00_1981;

											{	/* Ast/shrinkify.scm 146 */
												BgL_nodez00_bglt BgL_nodez00_1955;

												BgL_nodez00_1955 =
													(BgL_nodez00_bglt) (BgL_arg3275z00_1268);
												{	/* Ast/shrinkify.scm 146 */
													obj_t BgL_method3118z00_1956;

													{	/* Ast/shrinkify.scm 146 */
														BgL_objectz00_bglt BgL_objz00_1957;

														BgL_objz00_1957 =
															(BgL_objectz00_bglt) (BgL_nodez00_1955);
														{	/* Ast/shrinkify.scm 146 */
															long BgL_objzd2classzd2numz00_1958;

															BgL_objzd2classzd2numz00_1958 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_1957);
															{	/* Ast/shrinkify.scm 146 */
																obj_t BgL_arg2356z00_1959;

																BgL_arg2356z00_1959 =
																	PROCEDURE_REF
																	(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
																	(int) (((long) 1)));
																{	/* Ast/shrinkify.scm 146 */
																	obj_t BgL_arrayz00_1961;

																	int BgL_offsetz00_1962;

																	BgL_arrayz00_1961 = BgL_arg2356z00_1959;
																	BgL_offsetz00_1962 =
																		(int) (BgL_objzd2classzd2numz00_1958);
																	{	/* Ast/shrinkify.scm 146 */
																		long BgL_offsetz00_1963;

																		BgL_offsetz00_1963 =
																			(
																			(long) (BgL_offsetz00_1962) -
																			OBJECT_TYPE);
																		{	/* Ast/shrinkify.scm 146 */
																			long BgL_modz00_1964;

																			{	/* Ast/shrinkify.scm 146 */
																				int BgL_arg2358z00_1965;

																				BgL_arg2358z00_1965 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 146 */
																					long BgL_auxz00_3282;

																					BgL_auxz00_3282 =
																						(long) (BgL_arg2358z00_1965);
																					BgL_modz00_1964 =
																						(BgL_offsetz00_1963 /
																						BgL_auxz00_3282);
																			}}
																			{	/* Ast/shrinkify.scm 146 */
																				long BgL_restz00_1966;

																				{	/* Ast/shrinkify.scm 146 */
																					int BgL_arg2357z00_1967;

																					BgL_arg2357z00_1967 =
																						(int) (((long) 8));
																					{	/* Ast/shrinkify.scm 146 */
																						long BgL_auxz00_3286;

																						BgL_auxz00_3286 =
																							(long) (BgL_arg2357z00_1967);
																						BgL_restz00_1966 =
																							(BgL_offsetz00_1963 %
																							BgL_auxz00_3286);
																				}}
																				{	/* Ast/shrinkify.scm 146 */

																					BgL_method3118z00_1956 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_1961,
																							(int) (BgL_modz00_1964)),
																						(int) (BgL_restz00_1966));
													}}}}}}}}
													{	/* Ast/shrinkify.scm 146 */
														obj_t BgL_xz00_2537;

														BgL_xz00_2537 =
															PROCEDURE_ENTRY(BgL_method3118z00_1956)
															(BgL_method3118z00_1956,
															(obj_t) (BgL_nodez00_1955), BEOA);
														BgL_res3376z00_1981 = BUNSPEC;
											}}} BgL_res3376z00_1981;
								}}}
								{
									obj_t BgL_l3100z00_3296;

									BgL_l3100z00_3296 = CDR(BgL_l3100z00_1264);
									BgL_l3100z00_1264 = BgL_l3100z00_3296;
									goto BgL_forzd2each3101zd2_1265;
								}
							}
						else
							{	/* Ast/shrinkify.scm 147 */
								((bool_t) 1);
							}
					}
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-fail3142 */
	obj_t BGl_shrinkzd2nodez12zd2fail3142z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2496, obj_t BgL_nodez00_2497)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 134 */
			{
				BgL_failz00_bglt BgL_nodez00_1251;

				BgL_nodez00_1251 = (BgL_failz00_bglt) (BgL_nodez00_2497);
				{	/* Ast/shrinkify.scm 135 */
					BgL_nodez00_bglt BgL_arg3269z00_1254;

					BgL_arg3269z00_1254 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1251))->BgL_procz00);
					{	/* Ast/shrinkify.scm 135 */
						obj_t BgL_res3364z00_1866;

						{	/* Ast/shrinkify.scm 135 */
							obj_t BgL_method3118z00_1841;

							{	/* Ast/shrinkify.scm 135 */
								BgL_objectz00_bglt BgL_objz00_1842;

								BgL_objz00_1842 = (BgL_objectz00_bglt) (BgL_arg3269z00_1254);
								{	/* Ast/shrinkify.scm 135 */
									long BgL_objzd2classzd2numz00_1843;

									BgL_objzd2classzd2numz00_1843 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1842);
									{	/* Ast/shrinkify.scm 135 */
										obj_t BgL_arg2356z00_1844;

										BgL_arg2356z00_1844 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 135 */
											obj_t BgL_arrayz00_1846;

											int BgL_offsetz00_1847;

											BgL_arrayz00_1846 = BgL_arg2356z00_1844;
											BgL_offsetz00_1847 =
												(int) (BgL_objzd2classzd2numz00_1843);
											{	/* Ast/shrinkify.scm 135 */
												long BgL_offsetz00_1848;

												BgL_offsetz00_1848 =
													((long) (BgL_offsetz00_1847) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 135 */
													long BgL_modz00_1849;

													{	/* Ast/shrinkify.scm 135 */
														int BgL_arg2358z00_1850;

														BgL_arg2358z00_1850 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 135 */
															long BgL_auxz00_3308;

															BgL_auxz00_3308 = (long) (BgL_arg2358z00_1850);
															BgL_modz00_1849 =
																(BgL_offsetz00_1848 / BgL_auxz00_3308);
													}}
													{	/* Ast/shrinkify.scm 135 */
														long BgL_restz00_1851;

														{	/* Ast/shrinkify.scm 135 */
															int BgL_arg2357z00_1852;

															BgL_arg2357z00_1852 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 135 */
																long BgL_auxz00_3312;

																BgL_auxz00_3312 = (long) (BgL_arg2357z00_1852);
																BgL_restz00_1851 =
																	(BgL_offsetz00_1848 % BgL_auxz00_3312);
														}}
														{	/* Ast/shrinkify.scm 135 */

															BgL_method3118z00_1841 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1846,
																	(int) (BgL_modz00_1849)),
																(int) (BgL_restz00_1851));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 135 */
								obj_t BgL_xz00_2538;

								BgL_xz00_2538 =
									PROCEDURE_ENTRY(BgL_method3118z00_1841)
									(BgL_method3118z00_1841, (obj_t) (BgL_arg3269z00_1254), BEOA);
								BgL_res3364z00_1866 = BUNSPEC;
						}} BgL_res3364z00_1866;
				}}
				{	/* Ast/shrinkify.scm 136 */
					BgL_nodez00_bglt BgL_arg3270z00_1255;

					BgL_arg3270z00_1255 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1251))->BgL_msgz00);
					{	/* Ast/shrinkify.scm 136 */
						obj_t BgL_res3367z00_1894;

						{	/* Ast/shrinkify.scm 136 */
							obj_t BgL_method3118z00_1869;

							{	/* Ast/shrinkify.scm 136 */
								BgL_objectz00_bglt BgL_objz00_1870;

								BgL_objz00_1870 = (BgL_objectz00_bglt) (BgL_arg3270z00_1255);
								{	/* Ast/shrinkify.scm 136 */
									long BgL_objzd2classzd2numz00_1871;

									BgL_objzd2classzd2numz00_1871 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1870);
									{	/* Ast/shrinkify.scm 136 */
										obj_t BgL_arg2356z00_1872;

										BgL_arg2356z00_1872 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 136 */
											obj_t BgL_arrayz00_1874;

											int BgL_offsetz00_1875;

											BgL_arrayz00_1874 = BgL_arg2356z00_1872;
											BgL_offsetz00_1875 =
												(int) (BgL_objzd2classzd2numz00_1871);
											{	/* Ast/shrinkify.scm 136 */
												long BgL_offsetz00_1876;

												BgL_offsetz00_1876 =
													((long) (BgL_offsetz00_1875) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 136 */
													long BgL_modz00_1877;

													{	/* Ast/shrinkify.scm 136 */
														int BgL_arg2358z00_1878;

														BgL_arg2358z00_1878 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 136 */
															long BgL_auxz00_3331;

															BgL_auxz00_3331 = (long) (BgL_arg2358z00_1878);
															BgL_modz00_1877 =
																(BgL_offsetz00_1876 / BgL_auxz00_3331);
													}}
													{	/* Ast/shrinkify.scm 136 */
														long BgL_restz00_1879;

														{	/* Ast/shrinkify.scm 136 */
															int BgL_arg2357z00_1880;

															BgL_arg2357z00_1880 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 136 */
																long BgL_auxz00_3335;

																BgL_auxz00_3335 = (long) (BgL_arg2357z00_1880);
																BgL_restz00_1879 =
																	(BgL_offsetz00_1876 % BgL_auxz00_3335);
														}}
														{	/* Ast/shrinkify.scm 136 */

															BgL_method3118z00_1869 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1874,
																	(int) (BgL_modz00_1877)),
																(int) (BgL_restz00_1879));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 136 */
								obj_t BgL_xz00_2539;

								BgL_xz00_2539 =
									PROCEDURE_ENTRY(BgL_method3118z00_1869)
									(BgL_method3118z00_1869, (obj_t) (BgL_arg3270z00_1255), BEOA);
								BgL_res3367z00_1894 = BUNSPEC;
						}} BgL_res3367z00_1894;
				}}
				{	/* Ast/shrinkify.scm 137 */
					BgL_nodez00_bglt BgL_arg3271z00_1256;

					BgL_arg3271z00_1256 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1251))->BgL_objz00);
					{	/* Ast/shrinkify.scm 137 */
						obj_t BgL_res3370z00_1922;

						{	/* Ast/shrinkify.scm 137 */
							obj_t BgL_method3118z00_1897;

							{	/* Ast/shrinkify.scm 137 */
								BgL_objectz00_bglt BgL_objz00_1898;

								BgL_objz00_1898 = (BgL_objectz00_bglt) (BgL_arg3271z00_1256);
								{	/* Ast/shrinkify.scm 137 */
									long BgL_objzd2classzd2numz00_1899;

									BgL_objzd2classzd2numz00_1899 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1898);
									{	/* Ast/shrinkify.scm 137 */
										obj_t BgL_arg2356z00_1900;

										BgL_arg2356z00_1900 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 137 */
											obj_t BgL_arrayz00_1902;

											int BgL_offsetz00_1903;

											BgL_arrayz00_1902 = BgL_arg2356z00_1900;
											BgL_offsetz00_1903 =
												(int) (BgL_objzd2classzd2numz00_1899);
											{	/* Ast/shrinkify.scm 137 */
												long BgL_offsetz00_1904;

												BgL_offsetz00_1904 =
													((long) (BgL_offsetz00_1903) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 137 */
													long BgL_modz00_1905;

													{	/* Ast/shrinkify.scm 137 */
														int BgL_arg2358z00_1906;

														BgL_arg2358z00_1906 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 137 */
															long BgL_auxz00_3354;

															BgL_auxz00_3354 = (long) (BgL_arg2358z00_1906);
															BgL_modz00_1905 =
																(BgL_offsetz00_1904 / BgL_auxz00_3354);
													}}
													{	/* Ast/shrinkify.scm 137 */
														long BgL_restz00_1907;

														{	/* Ast/shrinkify.scm 137 */
															int BgL_arg2357z00_1908;

															BgL_arg2357z00_1908 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 137 */
																long BgL_auxz00_3358;

																BgL_auxz00_3358 = (long) (BgL_arg2357z00_1908);
																BgL_restz00_1907 =
																	(BgL_offsetz00_1904 % BgL_auxz00_3358);
														}}
														{	/* Ast/shrinkify.scm 137 */

															BgL_method3118z00_1897 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1902,
																	(int) (BgL_modz00_1905)),
																(int) (BgL_restz00_1907));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 137 */
								obj_t BgL_xz00_2540;

								BgL_xz00_2540 =
									PROCEDURE_ENTRY(BgL_method3118z00_1897)
									(BgL_method3118z00_1897, (obj_t) (BgL_arg3271z00_1256), BEOA);
								BgL_res3370z00_1922 = BUNSPEC;
						}} BgL_res3370z00_1922;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-conditi3140 */
	obj_t BGl_shrinkzd2nodez12zd2conditi3140z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2498, obj_t BgL_nodez00_2499)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 125 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1243;

				BgL_nodez00_1243 = (BgL_conditionalz00_bglt) (BgL_nodez00_2499);
				{	/* Ast/shrinkify.scm 126 */
					BgL_nodez00_bglt BgL_arg3265z00_1246;

					BgL_arg3265z00_1246 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1243))->BgL_testz00);
					{	/* Ast/shrinkify.scm 126 */
						obj_t BgL_res3355z00_1782;

						{	/* Ast/shrinkify.scm 126 */
							obj_t BgL_method3118z00_1757;

							{	/* Ast/shrinkify.scm 126 */
								BgL_objectz00_bglt BgL_objz00_1758;

								BgL_objz00_1758 = (BgL_objectz00_bglt) (BgL_arg3265z00_1246);
								{	/* Ast/shrinkify.scm 126 */
									long BgL_objzd2classzd2numz00_1759;

									BgL_objzd2classzd2numz00_1759 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1758);
									{	/* Ast/shrinkify.scm 126 */
										obj_t BgL_arg2356z00_1760;

										BgL_arg2356z00_1760 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 126 */
											obj_t BgL_arrayz00_1762;

											int BgL_offsetz00_1763;

											BgL_arrayz00_1762 = BgL_arg2356z00_1760;
											BgL_offsetz00_1763 =
												(int) (BgL_objzd2classzd2numz00_1759);
											{	/* Ast/shrinkify.scm 126 */
												long BgL_offsetz00_1764;

												BgL_offsetz00_1764 =
													((long) (BgL_offsetz00_1763) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 126 */
													long BgL_modz00_1765;

													{	/* Ast/shrinkify.scm 126 */
														int BgL_arg2358z00_1766;

														BgL_arg2358z00_1766 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 126 */
															long BgL_auxz00_3378;

															BgL_auxz00_3378 = (long) (BgL_arg2358z00_1766);
															BgL_modz00_1765 =
																(BgL_offsetz00_1764 / BgL_auxz00_3378);
													}}
													{	/* Ast/shrinkify.scm 126 */
														long BgL_restz00_1767;

														{	/* Ast/shrinkify.scm 126 */
															int BgL_arg2357z00_1768;

															BgL_arg2357z00_1768 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 126 */
																long BgL_auxz00_3382;

																BgL_auxz00_3382 = (long) (BgL_arg2357z00_1768);
																BgL_restz00_1767 =
																	(BgL_offsetz00_1764 % BgL_auxz00_3382);
														}}
														{	/* Ast/shrinkify.scm 126 */

															BgL_method3118z00_1757 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1762,
																	(int) (BgL_modz00_1765)),
																(int) (BgL_restz00_1767));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 126 */
								obj_t BgL_xz00_2541;

								BgL_xz00_2541 =
									PROCEDURE_ENTRY(BgL_method3118z00_1757)
									(BgL_method3118z00_1757, (obj_t) (BgL_arg3265z00_1246), BEOA);
								BgL_res3355z00_1782 = BUNSPEC;
						}} BgL_res3355z00_1782;
				}}
				{	/* Ast/shrinkify.scm 127 */
					BgL_nodez00_bglt BgL_arg3266z00_1247;

					BgL_arg3266z00_1247 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1243))->BgL_truez00);
					{	/* Ast/shrinkify.scm 127 */
						obj_t BgL_res3358z00_1810;

						{	/* Ast/shrinkify.scm 127 */
							obj_t BgL_method3118z00_1785;

							{	/* Ast/shrinkify.scm 127 */
								BgL_objectz00_bglt BgL_objz00_1786;

								BgL_objz00_1786 = (BgL_objectz00_bglt) (BgL_arg3266z00_1247);
								{	/* Ast/shrinkify.scm 127 */
									long BgL_objzd2classzd2numz00_1787;

									BgL_objzd2classzd2numz00_1787 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1786);
									{	/* Ast/shrinkify.scm 127 */
										obj_t BgL_arg2356z00_1788;

										BgL_arg2356z00_1788 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 127 */
											obj_t BgL_arrayz00_1790;

											int BgL_offsetz00_1791;

											BgL_arrayz00_1790 = BgL_arg2356z00_1788;
											BgL_offsetz00_1791 =
												(int) (BgL_objzd2classzd2numz00_1787);
											{	/* Ast/shrinkify.scm 127 */
												long BgL_offsetz00_1792;

												BgL_offsetz00_1792 =
													((long) (BgL_offsetz00_1791) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 127 */
													long BgL_modz00_1793;

													{	/* Ast/shrinkify.scm 127 */
														int BgL_arg2358z00_1794;

														BgL_arg2358z00_1794 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 127 */
															long BgL_auxz00_3401;

															BgL_auxz00_3401 = (long) (BgL_arg2358z00_1794);
															BgL_modz00_1793 =
																(BgL_offsetz00_1792 / BgL_auxz00_3401);
													}}
													{	/* Ast/shrinkify.scm 127 */
														long BgL_restz00_1795;

														{	/* Ast/shrinkify.scm 127 */
															int BgL_arg2357z00_1796;

															BgL_arg2357z00_1796 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 127 */
																long BgL_auxz00_3405;

																BgL_auxz00_3405 = (long) (BgL_arg2357z00_1796);
																BgL_restz00_1795 =
																	(BgL_offsetz00_1792 % BgL_auxz00_3405);
														}}
														{	/* Ast/shrinkify.scm 127 */

															BgL_method3118z00_1785 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1790,
																	(int) (BgL_modz00_1793)),
																(int) (BgL_restz00_1795));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 127 */
								obj_t BgL_xz00_2542;

								BgL_xz00_2542 =
									PROCEDURE_ENTRY(BgL_method3118z00_1785)
									(BgL_method3118z00_1785, (obj_t) (BgL_arg3266z00_1247), BEOA);
								BgL_res3358z00_1810 = BUNSPEC;
						}} BgL_res3358z00_1810;
				}}
				{	/* Ast/shrinkify.scm 128 */
					BgL_nodez00_bglt BgL_arg3267z00_1248;

					BgL_arg3267z00_1248 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1243))->BgL_falsez00);
					{	/* Ast/shrinkify.scm 128 */
						obj_t BgL_res3361z00_1838;

						{	/* Ast/shrinkify.scm 128 */
							obj_t BgL_method3118z00_1813;

							{	/* Ast/shrinkify.scm 128 */
								BgL_objectz00_bglt BgL_objz00_1814;

								BgL_objz00_1814 = (BgL_objectz00_bglt) (BgL_arg3267z00_1248);
								{	/* Ast/shrinkify.scm 128 */
									long BgL_objzd2classzd2numz00_1815;

									BgL_objzd2classzd2numz00_1815 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1814);
									{	/* Ast/shrinkify.scm 128 */
										obj_t BgL_arg2356z00_1816;

										BgL_arg2356z00_1816 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 128 */
											obj_t BgL_arrayz00_1818;

											int BgL_offsetz00_1819;

											BgL_arrayz00_1818 = BgL_arg2356z00_1816;
											BgL_offsetz00_1819 =
												(int) (BgL_objzd2classzd2numz00_1815);
											{	/* Ast/shrinkify.scm 128 */
												long BgL_offsetz00_1820;

												BgL_offsetz00_1820 =
													((long) (BgL_offsetz00_1819) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 128 */
													long BgL_modz00_1821;

													{	/* Ast/shrinkify.scm 128 */
														int BgL_arg2358z00_1822;

														BgL_arg2358z00_1822 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 128 */
															long BgL_auxz00_3424;

															BgL_auxz00_3424 = (long) (BgL_arg2358z00_1822);
															BgL_modz00_1821 =
																(BgL_offsetz00_1820 / BgL_auxz00_3424);
													}}
													{	/* Ast/shrinkify.scm 128 */
														long BgL_restz00_1823;

														{	/* Ast/shrinkify.scm 128 */
															int BgL_arg2357z00_1824;

															BgL_arg2357z00_1824 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 128 */
																long BgL_auxz00_3428;

																BgL_auxz00_3428 = (long) (BgL_arg2357z00_1824);
																BgL_restz00_1823 =
																	(BgL_offsetz00_1820 % BgL_auxz00_3428);
														}}
														{	/* Ast/shrinkify.scm 128 */

															BgL_method3118z00_1813 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1818,
																	(int) (BgL_modz00_1821)),
																(int) (BgL_restz00_1823));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 128 */
								obj_t BgL_xz00_2543;

								BgL_xz00_2543 =
									PROCEDURE_ENTRY(BgL_method3118z00_1813)
									(BgL_method3118z00_1813, (obj_t) (BgL_arg3267z00_1248), BEOA);
								BgL_res3361z00_1838 = BUNSPEC;
						}} BgL_res3361z00_1838;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-setq3138 */
	obj_t BGl_shrinkzd2nodez12zd2setq3138z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2500, obj_t BgL_nodez00_2501)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 118 */
			{
				BgL_setqz00_bglt BgL_nodez00_1237;

				BgL_nodez00_1237 = (BgL_setqz00_bglt) (BgL_nodez00_2501);
				{	/* Ast/shrinkify.scm 119 */
					BgL_nodez00_bglt BgL_arg3263z00_1726;

					BgL_arg3263z00_1726 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1237))->BgL_valuez00);
					{	/* Ast/shrinkify.scm 119 */
						obj_t BgL_res3352z00_1754;

						{	/* Ast/shrinkify.scm 119 */
							obj_t BgL_method3118z00_1729;

							{	/* Ast/shrinkify.scm 119 */
								BgL_objectz00_bglt BgL_objz00_1730;

								BgL_objz00_1730 = (BgL_objectz00_bglt) (BgL_arg3263z00_1726);
								{	/* Ast/shrinkify.scm 119 */
									long BgL_objzd2classzd2numz00_1731;

									BgL_objzd2classzd2numz00_1731 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1730);
									{	/* Ast/shrinkify.scm 119 */
										obj_t BgL_arg2356z00_1732;

										BgL_arg2356z00_1732 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 119 */
											obj_t BgL_arrayz00_1734;

											int BgL_offsetz00_1735;

											BgL_arrayz00_1734 = BgL_arg2356z00_1732;
											BgL_offsetz00_1735 =
												(int) (BgL_objzd2classzd2numz00_1731);
											{	/* Ast/shrinkify.scm 119 */
												long BgL_offsetz00_1736;

												BgL_offsetz00_1736 =
													((long) (BgL_offsetz00_1735) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 119 */
													long BgL_modz00_1737;

													{	/* Ast/shrinkify.scm 119 */
														int BgL_arg2358z00_1738;

														BgL_arg2358z00_1738 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 119 */
															long BgL_auxz00_3448;

															BgL_auxz00_3448 = (long) (BgL_arg2358z00_1738);
															BgL_modz00_1737 =
																(BgL_offsetz00_1736 / BgL_auxz00_3448);
													}}
													{	/* Ast/shrinkify.scm 119 */
														long BgL_restz00_1739;

														{	/* Ast/shrinkify.scm 119 */
															int BgL_arg2357z00_1740;

															BgL_arg2357z00_1740 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 119 */
																long BgL_auxz00_3452;

																BgL_auxz00_3452 = (long) (BgL_arg2357z00_1740);
																BgL_restz00_1739 =
																	(BgL_offsetz00_1736 % BgL_auxz00_3452);
														}}
														{	/* Ast/shrinkify.scm 119 */

															BgL_method3118z00_1729 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1734,
																	(int) (BgL_modz00_1737)),
																(int) (BgL_restz00_1739));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 119 */
								obj_t BgL_xz00_2544;

								BgL_xz00_2544 =
									PROCEDURE_ENTRY(BgL_method3118z00_1729)
									(BgL_method3118z00_1729, (obj_t) (BgL_arg3263z00_1726), BEOA);
								BgL_res3352z00_1754 = BUNSPEC;
						}} BgL_res3352z00_1754;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-cast3136 */
	obj_t BGl_shrinkzd2nodez12zd2cast3136z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2502, obj_t BgL_nodez00_2503)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 111 */
			{
				BgL_castz00_bglt BgL_nodez00_1231;

				{	/* Ast/shrinkify.scm 112 */
					BgL_castz00_bglt BgL_auxz00_3463;

					BgL_nodez00_1231 = (BgL_castz00_bglt) (BgL_nodez00_2503);
					{	/* Ast/shrinkify.scm 112 */
						BgL_nodez00_bglt BgL_arg3261z00_1697;

						BgL_arg3261z00_1697 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1231))->BgL_argz00);
						{	/* Ast/shrinkify.scm 112 */
							obj_t BgL_res3349z00_1725;

							{	/* Ast/shrinkify.scm 112 */
								obj_t BgL_method3118z00_1700;

								{	/* Ast/shrinkify.scm 112 */
									BgL_objectz00_bglt BgL_objz00_1701;

									BgL_objz00_1701 = (BgL_objectz00_bglt) (BgL_arg3261z00_1697);
									{	/* Ast/shrinkify.scm 112 */
										long BgL_objzd2classzd2numz00_1702;

										BgL_objzd2classzd2numz00_1702 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1701);
										{	/* Ast/shrinkify.scm 112 */
											obj_t BgL_arg2356z00_1703;

											BgL_arg2356z00_1703 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 112 */
												obj_t BgL_arrayz00_1705;

												int BgL_offsetz00_1706;

												BgL_arrayz00_1705 = BgL_arg2356z00_1703;
												BgL_offsetz00_1706 =
													(int) (BgL_objzd2classzd2numz00_1702);
												{	/* Ast/shrinkify.scm 112 */
													long BgL_offsetz00_1707;

													BgL_offsetz00_1707 =
														((long) (BgL_offsetz00_1706) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 112 */
														long BgL_modz00_1708;

														{	/* Ast/shrinkify.scm 112 */
															int BgL_arg2358z00_1709;

															BgL_arg2358z00_1709 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 112 */
																long BgL_auxz00_3473;

																BgL_auxz00_3473 = (long) (BgL_arg2358z00_1709);
																BgL_modz00_1708 =
																	(BgL_offsetz00_1707 / BgL_auxz00_3473);
														}}
														{	/* Ast/shrinkify.scm 112 */
															long BgL_restz00_1710;

															{	/* Ast/shrinkify.scm 112 */
																int BgL_arg2357z00_1711;

																BgL_arg2357z00_1711 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 112 */
																	long BgL_auxz00_3477;

																	BgL_auxz00_3477 =
																		(long) (BgL_arg2357z00_1711);
																	BgL_restz00_1710 =
																		(BgL_offsetz00_1707 % BgL_auxz00_3477);
															}}
															{	/* Ast/shrinkify.scm 112 */

																BgL_method3118z00_1700 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1705,
																		(int) (BgL_modz00_1708)),
																	(int) (BgL_restz00_1710));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 112 */
									obj_t BgL_xz00_2545;

									BgL_xz00_2545 =
										PROCEDURE_ENTRY(BgL_method3118z00_1700)
										(BgL_method3118z00_1700, (obj_t) (BgL_arg3261z00_1697),
										BEOA);
									BgL_res3349z00_1725 = BUNSPEC;
							}} BgL_res3349z00_1725;
					}}
					BgL_auxz00_3463 = BgL_nodez00_1231;
					return (obj_t) (BgL_auxz00_3463);
				}
			}
		}
	}



/* shrink-node!-extern3134 */
	obj_t BGl_shrinkzd2nodez12zd2extern3134z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2504, obj_t BgL_nodez00_2505)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 103 */
			{
				BgL_externz00_bglt BgL_nodez00_1220;

				{	/* Ast/shrinkify.scm 104 */
					BgL_externz00_bglt BgL_auxz00_3489;

					BgL_nodez00_1220 = (BgL_externz00_bglt) (BgL_nodez00_2505);
					{	/* Ast/shrinkify.scm 104 */
						bool_t BgL_testz00_3490;

						{	/* Ast/shrinkify.scm 104 */
							bool_t BgL_testz00_3491;

							{	/* Ast/shrinkify.scm 104 */
								obj_t BgL_auxz00_3492;

								{	/* Ast/shrinkify.scm 104 */
									BgL_objectz00_bglt BgL_auxz00_3493;

									BgL_auxz00_3493 = (BgL_objectz00_bglt) (BgL_nodez00_1220);
									BgL_auxz00_3492 = BGL_OBJECT_WIDENING(BgL_auxz00_3493);
								}
								BgL_testz00_3491 = CBOOL(BgL_auxz00_3492);
							}
							if (BgL_testz00_3491)
								{	/* Ast/shrinkify.scm 104 */
									BgL_testz00_3490 = ((bool_t) 1);
								}
							else
								{	/* Ast/shrinkify.scm 104 */
									BgL_testz00_3490 = ((bool_t) 0);
								}
						}
						if (BgL_testz00_3490)
							{	/* Ast/shrinkify.scm 104 */
								{	/* Ast/shrinkify.scm 104 */
									long BgL_arg3256z00_1225;

									{	/* Ast/shrinkify.scm 104 */
										obj_t BgL_arg3257z00_1226;

										{	/* Ast/shrinkify.scm 104 */
											obj_t BgL_arg3258z00_1227;

											{	/* Ast/shrinkify.scm 104 */
												BgL_objectz00_bglt BgL_objectz00_1686;

												BgL_objectz00_1686 =
													(BgL_objectz00_bglt) (BgL_nodez00_1220);
												{	/* Ast/shrinkify.scm 104 */
													long BgL_arg2359z00_1687;

													{	/* Ast/shrinkify.scm 104 */
														long BgL_arg2360z00_1688;

														BgL_arg2360z00_1688 =
															BGL_OBJECT_CLASS_NUM(BgL_objectz00_1686);
														BgL_arg2359z00_1687 =
															(BgL_arg2360z00_1688 - OBJECT_TYPE);
													}
													BgL_arg3258z00_1227 =
														VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
														(int) (BgL_arg2359z00_1687));
											}}
											BgL_arg3257z00_1226 =
												BGl_classzd2superzd2zz__objectz00(BgL_arg3258z00_1227);
										}
										BgL_arg3256z00_1225 =
											BGl_classzd2numzd2zz__objectz00(BgL_arg3257z00_1226);
									}
									BGL_OBJECT_CLASS_NUM_SET(
										(BgL_objectz00_bglt) (BgL_nodez00_1220),
										BgL_arg3256z00_1225);
								}
								{	/* Ast/shrinkify.scm 104 */
									BgL_objectz00_bglt BgL_auxz00_3506;

									BgL_auxz00_3506 = (BgL_objectz00_bglt) (BgL_nodez00_1220);
									BGL_OBJECT_WIDENING_SET(BgL_auxz00_3506, BFALSE);
								}
								(obj_t) (BgL_nodez00_1220);
							}
						else
							{	/* Ast/shrinkify.scm 104 */
								BFALSE;
							}
					}
					{	/* Ast/shrinkify.scm 105 */
						obj_t BgL_arg3259z00_1228;

						BgL_arg3259z00_1228 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1220))->BgL_exprza2za2);
						BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3259z00_1228);
					}
					BgL_auxz00_3489 = BgL_nodez00_1220;
					return (obj_t) (BgL_auxz00_3489);
				}
			}
		}
	}



/* shrink-node!-funcall3132 */
	obj_t BGl_shrinkzd2nodez12zd2funcall3132z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2506, obj_t BgL_nodez00_2507)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 94 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1208;

				BgL_nodez00_1208 = (BgL_funcallz00_bglt) (BgL_nodez00_2507);
				{	/* Ast/shrinkify.scm 95 */
					bool_t BgL_testz00_3514;

					{	/* Ast/shrinkify.scm 95 */
						bool_t BgL_testz00_3515;

						{	/* Ast/shrinkify.scm 95 */
							obj_t BgL_auxz00_3516;

							{	/* Ast/shrinkify.scm 95 */
								BgL_objectz00_bglt BgL_auxz00_3517;

								BgL_auxz00_3517 = (BgL_objectz00_bglt) (BgL_nodez00_1208);
								BgL_auxz00_3516 = BGL_OBJECT_WIDENING(BgL_auxz00_3517);
							}
							BgL_testz00_3515 = CBOOL(BgL_auxz00_3516);
						}
						if (BgL_testz00_3515)
							{	/* Ast/shrinkify.scm 95 */
								BgL_testz00_3514 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 95 */
								BgL_testz00_3514 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3514)
						{	/* Ast/shrinkify.scm 95 */
							{	/* Ast/shrinkify.scm 95 */
								long BgL_arg3249z00_1213;

								{	/* Ast/shrinkify.scm 95 */
									obj_t BgL_arg3250z00_1214;

									{	/* Ast/shrinkify.scm 95 */
										obj_t BgL_arg3251z00_1215;

										{	/* Ast/shrinkify.scm 95 */
											BgL_objectz00_bglt BgL_objectz00_1644;

											BgL_objectz00_1644 =
												(BgL_objectz00_bglt) (BgL_nodez00_1208);
											{	/* Ast/shrinkify.scm 95 */
												long BgL_arg2359z00_1645;

												{	/* Ast/shrinkify.scm 95 */
													long BgL_arg2360z00_1646;

													BgL_arg2360z00_1646 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_1644);
													BgL_arg2359z00_1645 =
														(BgL_arg2360z00_1646 - OBJECT_TYPE);
												}
												BgL_arg3251z00_1215 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2359z00_1645));
										}}
										BgL_arg3250z00_1214 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3251z00_1215);
									}
									BgL_arg3249z00_1213 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3250z00_1214);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1208), BgL_arg3249z00_1213);
							}
							{	/* Ast/shrinkify.scm 95 */
								BgL_objectz00_bglt BgL_auxz00_3530;

								BgL_auxz00_3530 = (BgL_objectz00_bglt) (BgL_nodez00_1208);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3530, BFALSE);
							}
							(obj_t) (BgL_nodez00_1208);
						}
					else
						{	/* Ast/shrinkify.scm 95 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 96 */
					BgL_nodez00_bglt BgL_arg3252z00_1216;

					BgL_arg3252z00_1216 =
						(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1208))->BgL_funz00);
					{	/* Ast/shrinkify.scm 96 */
						obj_t BgL_res3345z00_1681;

						{	/* Ast/shrinkify.scm 96 */
							obj_t BgL_method3118z00_1656;

							{	/* Ast/shrinkify.scm 96 */
								BgL_objectz00_bglt BgL_objz00_1657;

								BgL_objz00_1657 = (BgL_objectz00_bglt) (BgL_arg3252z00_1216);
								{	/* Ast/shrinkify.scm 96 */
									long BgL_objzd2classzd2numz00_1658;

									BgL_objzd2classzd2numz00_1658 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1657);
									{	/* Ast/shrinkify.scm 96 */
										obj_t BgL_arg2356z00_1659;

										BgL_arg2356z00_1659 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 96 */
											obj_t BgL_arrayz00_1661;

											int BgL_offsetz00_1662;

											BgL_arrayz00_1661 = BgL_arg2356z00_1659;
											BgL_offsetz00_1662 =
												(int) (BgL_objzd2classzd2numz00_1658);
											{	/* Ast/shrinkify.scm 96 */
												long BgL_offsetz00_1663;

												BgL_offsetz00_1663 =
													((long) (BgL_offsetz00_1662) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 96 */
													long BgL_modz00_1664;

													{	/* Ast/shrinkify.scm 96 */
														int BgL_arg2358z00_1665;

														BgL_arg2358z00_1665 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 96 */
															long BgL_auxz00_3543;

															BgL_auxz00_3543 = (long) (BgL_arg2358z00_1665);
															BgL_modz00_1664 =
																(BgL_offsetz00_1663 / BgL_auxz00_3543);
													}}
													{	/* Ast/shrinkify.scm 96 */
														long BgL_restz00_1666;

														{	/* Ast/shrinkify.scm 96 */
															int BgL_arg2357z00_1667;

															BgL_arg2357z00_1667 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 96 */
																long BgL_auxz00_3547;

																BgL_auxz00_3547 = (long) (BgL_arg2357z00_1667);
																BgL_restz00_1666 =
																	(BgL_offsetz00_1663 % BgL_auxz00_3547);
														}}
														{	/* Ast/shrinkify.scm 96 */

															BgL_method3118z00_1656 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1661,
																	(int) (BgL_modz00_1664)),
																(int) (BgL_restz00_1666));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 96 */
								obj_t BgL_xz00_2546;

								BgL_xz00_2546 =
									PROCEDURE_ENTRY(BgL_method3118z00_1656)
									(BgL_method3118z00_1656, (obj_t) (BgL_arg3252z00_1216), BEOA);
								BgL_res3345z00_1681 = BUNSPEC;
						}} BgL_res3345z00_1681;
				}}
				{	/* Ast/shrinkify.scm 97 */
					obj_t BgL_arg3253z00_1217;

					BgL_arg3253z00_1217 =
						(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1208))->BgL_argsz00);
					BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3253z00_1217);
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-app-ly3130 */
	obj_t BGl_shrinkzd2nodez12zd2appzd2ly3130zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2508, obj_t BgL_nodez00_2509)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 85 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1196;

				BgL_nodez00_1196 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_2509);
				{	/* Ast/shrinkify.scm 86 */
					bool_t BgL_testz00_3560;

					{	/* Ast/shrinkify.scm 86 */
						bool_t BgL_testz00_3561;

						{	/* Ast/shrinkify.scm 86 */
							obj_t BgL_auxz00_3562;

							{	/* Ast/shrinkify.scm 86 */
								BgL_objectz00_bglt BgL_auxz00_3563;

								BgL_auxz00_3563 = (BgL_objectz00_bglt) (BgL_nodez00_1196);
								BgL_auxz00_3562 = BGL_OBJECT_WIDENING(BgL_auxz00_3563);
							}
							BgL_testz00_3561 = CBOOL(BgL_auxz00_3562);
						}
						if (BgL_testz00_3561)
							{	/* Ast/shrinkify.scm 86 */
								BgL_testz00_3560 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 86 */
								BgL_testz00_3560 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3560)
						{	/* Ast/shrinkify.scm 86 */
							{	/* Ast/shrinkify.scm 86 */
								long BgL_arg3241z00_1201;

								{	/* Ast/shrinkify.scm 86 */
									obj_t BgL_arg3242z00_1202;

									{	/* Ast/shrinkify.scm 86 */
										obj_t BgL_arg3243z00_1203;

										{	/* Ast/shrinkify.scm 86 */
											BgL_objectz00_bglt BgL_objectz00_1575;

											BgL_objectz00_1575 =
												(BgL_objectz00_bglt) (BgL_nodez00_1196);
											{	/* Ast/shrinkify.scm 86 */
												long BgL_arg2359z00_1576;

												{	/* Ast/shrinkify.scm 86 */
													long BgL_arg2360z00_1577;

													BgL_arg2360z00_1577 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_1575);
													BgL_arg2359z00_1576 =
														(BgL_arg2360z00_1577 - OBJECT_TYPE);
												}
												BgL_arg3243z00_1203 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2359z00_1576));
										}}
										BgL_arg3242z00_1202 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3243z00_1203);
									}
									BgL_arg3241z00_1201 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3242z00_1202);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1196), BgL_arg3241z00_1201);
							}
							{	/* Ast/shrinkify.scm 86 */
								BgL_objectz00_bglt BgL_auxz00_3576;

								BgL_auxz00_3576 = (BgL_objectz00_bglt) (BgL_nodez00_1196);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3576, BFALSE);
							}
							(obj_t) (BgL_nodez00_1196);
						}
					else
						{	/* Ast/shrinkify.scm 86 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 87 */
					BgL_nodez00_bglt BgL_arg3244z00_1204;

					BgL_arg3244z00_1204 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1196))->BgL_funz00);
					{	/* Ast/shrinkify.scm 87 */
						obj_t BgL_res3338z00_1612;

						{	/* Ast/shrinkify.scm 87 */
							obj_t BgL_method3118z00_1587;

							{	/* Ast/shrinkify.scm 87 */
								BgL_objectz00_bglt BgL_objz00_1588;

								BgL_objz00_1588 = (BgL_objectz00_bglt) (BgL_arg3244z00_1204);
								{	/* Ast/shrinkify.scm 87 */
									long BgL_objzd2classzd2numz00_1589;

									BgL_objzd2classzd2numz00_1589 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1588);
									{	/* Ast/shrinkify.scm 87 */
										obj_t BgL_arg2356z00_1590;

										BgL_arg2356z00_1590 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 87 */
											obj_t BgL_arrayz00_1592;

											int BgL_offsetz00_1593;

											BgL_arrayz00_1592 = BgL_arg2356z00_1590;
											BgL_offsetz00_1593 =
												(int) (BgL_objzd2classzd2numz00_1589);
											{	/* Ast/shrinkify.scm 87 */
												long BgL_offsetz00_1594;

												BgL_offsetz00_1594 =
													((long) (BgL_offsetz00_1593) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 87 */
													long BgL_modz00_1595;

													{	/* Ast/shrinkify.scm 87 */
														int BgL_arg2358z00_1596;

														BgL_arg2358z00_1596 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 87 */
															long BgL_auxz00_3589;

															BgL_auxz00_3589 = (long) (BgL_arg2358z00_1596);
															BgL_modz00_1595 =
																(BgL_offsetz00_1594 / BgL_auxz00_3589);
													}}
													{	/* Ast/shrinkify.scm 87 */
														long BgL_restz00_1597;

														{	/* Ast/shrinkify.scm 87 */
															int BgL_arg2357z00_1598;

															BgL_arg2357z00_1598 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 87 */
																long BgL_auxz00_3593;

																BgL_auxz00_3593 = (long) (BgL_arg2357z00_1598);
																BgL_restz00_1597 =
																	(BgL_offsetz00_1594 % BgL_auxz00_3593);
														}}
														{	/* Ast/shrinkify.scm 87 */

															BgL_method3118z00_1587 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1592,
																	(int) (BgL_modz00_1595)),
																(int) (BgL_restz00_1597));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 87 */
								obj_t BgL_xz00_2547;

								BgL_xz00_2547 =
									PROCEDURE_ENTRY(BgL_method3118z00_1587)
									(BgL_method3118z00_1587, (obj_t) (BgL_arg3244z00_1204), BEOA);
								BgL_res3338z00_1612 = BUNSPEC;
						}} BgL_res3338z00_1612;
				}}
				{	/* Ast/shrinkify.scm 88 */
					BgL_nodez00_bglt BgL_arg3245z00_1205;

					BgL_arg3245z00_1205 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1196))->BgL_argz00);
					{	/* Ast/shrinkify.scm 88 */
						obj_t BgL_res3341z00_1640;

						{	/* Ast/shrinkify.scm 88 */
							obj_t BgL_method3118z00_1615;

							{	/* Ast/shrinkify.scm 88 */
								BgL_objectz00_bglt BgL_objz00_1616;

								BgL_objz00_1616 = (BgL_objectz00_bglt) (BgL_arg3245z00_1205);
								{	/* Ast/shrinkify.scm 88 */
									long BgL_objzd2classzd2numz00_1617;

									BgL_objzd2classzd2numz00_1617 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1616);
									{	/* Ast/shrinkify.scm 88 */
										obj_t BgL_arg2356z00_1618;

										BgL_arg2356z00_1618 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 88 */
											obj_t BgL_arrayz00_1620;

											int BgL_offsetz00_1621;

											BgL_arrayz00_1620 = BgL_arg2356z00_1618;
											BgL_offsetz00_1621 =
												(int) (BgL_objzd2classzd2numz00_1617);
											{	/* Ast/shrinkify.scm 88 */
												long BgL_offsetz00_1622;

												BgL_offsetz00_1622 =
													((long) (BgL_offsetz00_1621) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 88 */
													long BgL_modz00_1623;

													{	/* Ast/shrinkify.scm 88 */
														int BgL_arg2358z00_1624;

														BgL_arg2358z00_1624 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 88 */
															long BgL_auxz00_3612;

															BgL_auxz00_3612 = (long) (BgL_arg2358z00_1624);
															BgL_modz00_1623 =
																(BgL_offsetz00_1622 / BgL_auxz00_3612);
													}}
													{	/* Ast/shrinkify.scm 88 */
														long BgL_restz00_1625;

														{	/* Ast/shrinkify.scm 88 */
															int BgL_arg2357z00_1626;

															BgL_arg2357z00_1626 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 88 */
																long BgL_auxz00_3616;

																BgL_auxz00_3616 = (long) (BgL_arg2357z00_1626);
																BgL_restz00_1625 =
																	(BgL_offsetz00_1622 % BgL_auxz00_3616);
														}}
														{	/* Ast/shrinkify.scm 88 */

															BgL_method3118z00_1615 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1620,
																	(int) (BgL_modz00_1623)),
																(int) (BgL_restz00_1625));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 88 */
								obj_t BgL_xz00_2548;

								BgL_xz00_2548 =
									PROCEDURE_ENTRY(BgL_method3118z00_1615)
									(BgL_method3118z00_1615, (obj_t) (BgL_arg3245z00_1205), BEOA);
								BgL_res3341z00_1640 = BUNSPEC;
						}} BgL_res3341z00_1640;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-app3128 */
	obj_t BGl_shrinkzd2nodez12zd2app3128z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2510, obj_t BgL_nodez00_2511)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 76 */
			{
				BgL_appz00_bglt BgL_nodez00_1184;

				BgL_nodez00_1184 = (BgL_appz00_bglt) (BgL_nodez00_2511);
				{	/* Ast/shrinkify.scm 77 */
					bool_t BgL_testz00_3627;

					{	/* Ast/shrinkify.scm 77 */
						bool_t BgL_testz00_3628;

						{	/* Ast/shrinkify.scm 77 */
							obj_t BgL_auxz00_3629;

							{	/* Ast/shrinkify.scm 77 */
								BgL_objectz00_bglt BgL_auxz00_3630;

								BgL_auxz00_3630 = (BgL_objectz00_bglt) (BgL_nodez00_1184);
								BgL_auxz00_3629 = BGL_OBJECT_WIDENING(BgL_auxz00_3630);
							}
							BgL_testz00_3628 = CBOOL(BgL_auxz00_3629);
						}
						if (BgL_testz00_3628)
							{	/* Ast/shrinkify.scm 77 */
								BgL_testz00_3627 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 77 */
								BgL_testz00_3627 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3627)
						{	/* Ast/shrinkify.scm 77 */
							{	/* Ast/shrinkify.scm 77 */
								long BgL_arg3234z00_1189;

								{	/* Ast/shrinkify.scm 77 */
									obj_t BgL_arg3235z00_1190;

									{	/* Ast/shrinkify.scm 77 */
										obj_t BgL_arg3236z00_1191;

										{	/* Ast/shrinkify.scm 77 */
											BgL_objectz00_bglt BgL_objectz00_1533;

											BgL_objectz00_1533 =
												(BgL_objectz00_bglt) (BgL_nodez00_1184);
											{	/* Ast/shrinkify.scm 77 */
												long BgL_arg2359z00_1534;

												{	/* Ast/shrinkify.scm 77 */
													long BgL_arg2360z00_1535;

													BgL_arg2360z00_1535 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_1533);
													BgL_arg2359z00_1534 =
														(BgL_arg2360z00_1535 - OBJECT_TYPE);
												}
												BgL_arg3236z00_1191 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2359z00_1534));
										}}
										BgL_arg3235z00_1190 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3236z00_1191);
									}
									BgL_arg3234z00_1189 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3235z00_1190);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1184), BgL_arg3234z00_1189);
							}
							{	/* Ast/shrinkify.scm 77 */
								BgL_objectz00_bglt BgL_auxz00_3643;

								BgL_auxz00_3643 = (BgL_objectz00_bglt) (BgL_nodez00_1184);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3643, BFALSE);
							}
							(obj_t) (BgL_nodez00_1184);
						}
					else
						{	/* Ast/shrinkify.scm 77 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 78 */
					BgL_varz00_bglt BgL_arg3237z00_1192;

					BgL_arg3237z00_1192 =
						(((BgL_appz00_bglt) CREF(BgL_nodez00_1184))->BgL_funz00);
					{	/* Ast/shrinkify.scm 78 */
						obj_t BgL_res3334z00_1570;

						{	/* Ast/shrinkify.scm 78 */
							BgL_nodez00_bglt BgL_nodez00_1544;

							BgL_nodez00_1544 = (BgL_nodez00_bglt) (BgL_arg3237z00_1192);
							{	/* Ast/shrinkify.scm 78 */
								obj_t BgL_method3118z00_1545;

								{	/* Ast/shrinkify.scm 78 */
									BgL_objectz00_bglt BgL_objz00_1546;

									BgL_objz00_1546 = (BgL_objectz00_bglt) (BgL_nodez00_1544);
									{	/* Ast/shrinkify.scm 78 */
										long BgL_objzd2classzd2numz00_1547;

										BgL_objzd2classzd2numz00_1547 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1546);
										{	/* Ast/shrinkify.scm 78 */
											obj_t BgL_arg2356z00_1548;

											BgL_arg2356z00_1548 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 78 */
												obj_t BgL_arrayz00_1550;

												int BgL_offsetz00_1551;

												BgL_arrayz00_1550 = BgL_arg2356z00_1548;
												BgL_offsetz00_1551 =
													(int) (BgL_objzd2classzd2numz00_1547);
												{	/* Ast/shrinkify.scm 78 */
													long BgL_offsetz00_1552;

													BgL_offsetz00_1552 =
														((long) (BgL_offsetz00_1551) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 78 */
														long BgL_modz00_1553;

														{	/* Ast/shrinkify.scm 78 */
															int BgL_arg2358z00_1554;

															BgL_arg2358z00_1554 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 78 */
																long BgL_auxz00_3657;

																BgL_auxz00_3657 = (long) (BgL_arg2358z00_1554);
																BgL_modz00_1553 =
																	(BgL_offsetz00_1552 / BgL_auxz00_3657);
														}}
														{	/* Ast/shrinkify.scm 78 */
															long BgL_restz00_1555;

															{	/* Ast/shrinkify.scm 78 */
																int BgL_arg2357z00_1556;

																BgL_arg2357z00_1556 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 78 */
																	long BgL_auxz00_3661;

																	BgL_auxz00_3661 =
																		(long) (BgL_arg2357z00_1556);
																	BgL_restz00_1555 =
																		(BgL_offsetz00_1552 % BgL_auxz00_3661);
															}}
															{	/* Ast/shrinkify.scm 78 */

																BgL_method3118z00_1545 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1550,
																		(int) (BgL_modz00_1553)),
																	(int) (BgL_restz00_1555));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 78 */
									obj_t BgL_xz00_2549;

									BgL_xz00_2549 =
										PROCEDURE_ENTRY(BgL_method3118z00_1545)
										(BgL_method3118z00_1545, (obj_t) (BgL_nodez00_1544), BEOA);
									BgL_res3334z00_1570 = BUNSPEC;
						}}} BgL_res3334z00_1570;
				}}
				{	/* Ast/shrinkify.scm 79 */
					obj_t BgL_arg3238z00_1193;

					BgL_arg3238z00_1193 =
						(((BgL_appz00_bglt) CREF(BgL_nodez00_1184))->BgL_argsz00);
					BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3238z00_1193);
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-sequenc3126 */
	obj_t BGl_shrinkzd2nodez12zd2sequenc3126z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2512, obj_t BgL_nodez00_2513)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 69 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1178;

				BgL_nodez00_1178 = (BgL_sequencez00_bglt) (BgL_nodez00_2513);
				{	/* Ast/shrinkify.scm 70 */
					obj_t BgL_arg3231z00_1528;

					BgL_arg3231z00_1528 =
						(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1178))->BgL_nodesz00);
					BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3231z00_1528);
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-kwote3124 */
	obj_t BGl_shrinkzd2nodez12zd2kwote3124z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2514, obj_t BgL_nodez00_2515)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 63 */
			return BUNSPEC;
		}
	}



/* shrink-node!-var3122 */
	obj_t BGl_shrinkzd2nodez12zd2var3122z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2516, obj_t BgL_nodez00_2517)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 57 */
			return BUNSPEC;
		}
	}



/* shrink-node!-atom3120 */
	obj_t BGl_shrinkzd2nodez12zd2atom3120z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2518, obj_t BgL_nodez00_2519)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 51 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3445z00zzast_shrinkifyz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3445z00zzast_shrinkifyz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3445z00zzast_shrinkifyz00));
			return
				BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string3445z00zzast_shrinkifyz00));
		}
	}

#ifdef __cplusplus
}
#endif
