/*===========================================================================*/
/*   (Inline/inline.scm)                                                     */
/*   Bigloo (3.2b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon May 25 12:42:12 CEST 2009       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Inline/inline.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_isfunz00_bgl
	{
		struct BgL_nodez00_bgl *BgL_originalzd2bodyzd2;
		obj_t BgL_recursivezd2callszd2;
	}               *BgL_isfunz00_bglt;


	static obj_t BGl_inlinezd2nodezd2atom3198z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	static obj_t BGl_inlinezd2nodezd2letzd2var3226zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_isfunz00_bglt
		BGl_makezd2isfunzd2zzinline_inlinez00(long, obj_t, obj_t, obj_t, bool_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, BgL_nodez00_bglt, obj_t);
	BGL_IMPORT obj_t BGl_objectzd2ze3structz31zz__objectz00(BgL_objectz00_bglt);
	BGL_EXPORTED_DECL BgL_isfunz00_bglt BGl_isfunzd2nilzd2zzinline_inlinez00();
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl__isfunzf3zf3zzinline_inlinez00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, bool_t,
		obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_nodezd2nilzd2zzast_nodez00();
	static obj_t BGl__inlinezd2sfunz12zc0zzinline_inlinez00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzinline_inlinez00();
	BGL_EXPORTED_DECL BgL_sfunz00_bglt
		BGl_z52allocatezd2isfunz80zzinline_inlinez00();
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_isfunz00_bglt
		BGl_wideningzd2isfunzd2zzinline_inlinez00(BgL_nodez00_bglt, obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzinline_inlinez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_alphatiza7eza7(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_walkz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzinline_inlinez00();
	BGL_IMPORT long bgl_list_length(obj_t);
	static obj_t BGl_inlinezd2nodezd2cast3214z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t BGl_isfunzf3zf3zzinline_inlinez00(obj_t);
	static obj_t BGl__wideningzd2isfun3513zd2zzinline_inlinez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl__isfunzd2nilzd2zzinline_inlinez00(obj_t);
	static obj_t BGl__inlinezd2nodezd2default3195z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl_inlinezd2nodezd2setzd2exzd2i3228z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_alphatiza7eza7zzast_alphatiza7eza7(obj_t, obj_t,
		obj_t, BgL_nodez00_bglt);
	static obj_t BGl_inlinezd2nodezd2sequence3204z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl__makezd2isfunzd2zzinline_inlinez00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2setq3216z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_objectzd2ze3structzd2isfun3239ze3zzinline_inlinez00(obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_inlinezd2nodezd2default3195z00zzinline_inlinez00(BgL_nodez00_bglt, long,
		obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2extern3212z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2boxzd2setz123237zc0zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_sfunz00_bglt BGl_makezd2sfunzd2zzast_varz00(long, obj_t, obj_t,
		obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2appzd2ly3208zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_inlinezd2nodezd2zzinline_inlinez00(BgL_nodez00_bglt, long, obj_t);
	static obj_t BGl_inlinezd2nodezd2conditio3218z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzinline_inlinez00();
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_inlinezd2nodezd2app3206z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2funcall3210z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_sfunz00zzast_varz00;
	extern obj_t BGl_za2nonzd2inlinedzd2callsza2z00zzinline_walkz00;
	static obj_t BGl__inlinezd2nodeza2z12z62zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzinline_inlinez00 = BUNSPEC;
	static obj_t BGl_inlinezd2nodezd2jumpzd2exzd23230z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzinline_inlinez00();
	BGL_EXPORTED_DECL BgL_isfunz00_bglt
		BGl_fillzd2isfunz12zc0zzinline_inlinez00(BgL_isfunz00_bglt,
		BgL_nodez00_bglt, obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	BGL_EXPORTED_DECL obj_t BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2fail3220z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl__inlinezd2nodezd2zzinline_inlinez00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_importedzd2moduleszd2initz00zzinline_inlinez00();
	BGL_IMPORT obj_t make_struct(obj_t, int, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_inlinezd2sfunz12zc0zzinline_inlinez00(BgL_variablez00_bglt, long,
		obj_t);
	static obj_t BGl_inlinezd2nodezd2makezd2box3232zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2select3222z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl_inlinezd2nodezd2boxzd2ref3235zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl__fillzd2isfunz12zc0zzinline_inlinez00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	extern BgL_nodez00_bglt BGl_inlinezd2appzd2zzinline_appz00(BgL_appz00_bglt,
		long, obj_t);
	static obj_t BGl__z52allocatezd2isfunz80zzinline_inlinez00(obj_t);
	static obj_t BGl_inlinezd2nodezd2var3200z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	BGL_IMPORT BgL_objectz00_bglt
		BGl_structzb2objectzd2ze3objectz83zz__objectz00(BgL_objectz00_bglt, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl_inlinezd2nodezd2kwote3202z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2optimza2z00zzengine_paramz00;
	extern obj_t BGl_za2kfactorza2z00zzinline_walkz00;
	extern bool_t BGl_inlinezd2appzf3z21zzinline_appz00(BgL_variablez00_bglt,
		long, long, obj_t);
	static obj_t BGl_structzb2objectzd2ze3objec3241z83zzinline_inlinez00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_isfunz00zzinline_inlinez00 = BUNSPEC;
	static obj_t BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00 = BUNSPEC;
	static obj_t BGl_objectzd2initzd2zzinline_inlinez00();
	static obj_t BGl__sfunzf3zf3zzinline_inlinez00(obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzinline_inlinez00();
	static obj_t BGl_inlinezd2nodezd2letzd2fun3224zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t __cnst[5];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_isfunzf3zd2envz21zzinline_inlinez00,
		BgL_bgl__isfunza7f3za7f3za7za7in3548z00, BGl__isfunzf3zf3zzinline_inlinez00,
		0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_inlinezd2nodezd2default3195zd2envzd2zzinline_inlinez00,
		BgL_bgl__inlineza7d2nodeza7d3549z00,
		BGl__inlinezd2nodezd2default3195z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_sfunzf3zd2envz21zzinline_inlinez00,
		BgL_bgl__sfunza7f3za7f3za7za7inl3550z00, BGl__sfunzf3zf3zzinline_inlinez00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
		BgL_bgl__inlineza7d2nodeza7d3551z00,
		BGl__inlinezd2nodezd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_inlinezd2nodeza2z12zd2envzb0zzinline_inlinez00,
		BgL_bgl__inlineza7d2nodeza7a3552z00,
		BGl__inlinezd2nodeza2z12z62zzinline_inlinez00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_inlinezd2sfunz12zd2envz12zzinline_inlinez00,
		BgL_bgl__inlineza7d2sfunza713553z00,
		BGl__inlinezd2sfunz12zc0zzinline_inlinez00, 0L, BUNSPEC, 3);
	BGL_IMPORT obj_t BGl_objectzd2ze3structzd2envze3zz__objectz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_wideningzd2isfunzd2envz00zzinline_inlinez00,
		BgL_bgl__wideningza7d2isfu3554za7,
		BGl__wideningzd2isfun3513zd2zzinline_inlinez00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_z52allocatezd2isfunzd2envz52zzinline_inlinez00,
		BgL_bgl__za752allocateza7d2i3555z00,
		BGl__z52allocatezd2isfunz80zzinline_inlinez00, 0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_isfunzd2nilzd2envz00zzinline_inlinez00,
		BgL_bgl__isfunza7d2nilza7d2za73556za7,
		BGl__isfunzd2nilzd2zzinline_inlinez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_fillzd2isfunz12zd2envz12zzinline_inlinez00,
		BgL_bgl__fillza7d2isfunza7123557z00,
		BGl__fillzd2isfunz12zc0zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_makezd2isfunzd2envz00zzinline_inlinez00,
		BgL_bgl__makeza7d2isfunza7d23558z00, BGl__makezd2isfunzd2zzinline_inlinez00,
		0L, BUNSPEC, 19);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3520z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23559z00,
		BGl_inlinezd2nodezd2atom3198z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3521z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23560z00,
		BGl_inlinezd2nodezd2var3200z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3522z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23561z00,
		BGl_inlinezd2nodezd2kwote3202z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3523z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23562z00,
		BGl_inlinezd2nodezd2sequence3204z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3524z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23563z00,
		BGl_inlinezd2nodezd2app3206z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3525z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23564z00,
		BGl_inlinezd2nodezd2appzd2ly3208zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3526z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23565z00,
		BGl_inlinezd2nodezd2funcall3210z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3527z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23566z00,
		BGl_inlinezd2nodezd2extern3212z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3528z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23567z00,
		BGl_inlinezd2nodezd2cast3214z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3530z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23568z00,
		BGl_inlinezd2nodezd2conditio3218z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3529z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23569z00,
		BGl_inlinezd2nodezd2setq3216z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3531z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23570z00,
		BGl_inlinezd2nodezd2fail3220z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3532z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23571z00,
		BGl_inlinezd2nodezd2select3222z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3533z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23572z00,
		BGl_inlinezd2nodezd2letzd2fun3224zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3534z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23573z00,
		BGl_inlinezd2nodezd2letzd2var3226zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3535z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23574z00,
		BGl_inlinezd2nodezd2setzd2exzd2i3228z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3536z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23575z00,
		BGl_inlinezd2nodezd2jumpzd2exzd23230z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3537z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23576z00,
		BGl_inlinezd2nodezd2makezd2box3232zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3538z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23577z00,
		BGl_inlinezd2nodezd2boxzd2ref3235zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3540z00zzinline_inlinez00,
		BgL_bgl_objectza7d2za7e3stru3578z00,
		BGl_objectzd2ze3structzd2isfun3239ze3zzinline_inlinez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3539z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23579z00,
		BGl_inlinezd2nodezd2boxzd2setz123237zc0zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3541z00zzinline_inlinez00,
		BgL_bgl_structza7b2objectza73580z00,
		BGl_structzb2objectzd2ze3objec3241z83zzinline_inlinez00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string3519z00zzinline_inlinez00,
		BgL_bgl_string3519za700za7za7i3581za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string3542z00zzinline_inlinez00,
		BgL_bgl_string3542za700za7za7i3582za7, "inline_inline", 13);
	      DEFINE_STRING(BGl_string3543z00zzinline_inlinez00,
		BgL_bgl_string3543za700za7za7i3583za7,
		"read static inline-node-default3195 isfun done ", 47);
	BGL_IMPORT obj_t BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00;



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzinline_inlinez00(long
		BgL_checksumz00_2725, char *BgL_fromz00_2726)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzinline_inlinez00))
				{
					BGl_requirezd2initializa7ationz75zzinline_inlinez00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzinline_inlinez00();
					BGl_cnstzd2initzd2zzinline_inlinez00();
					BGl_importedzd2moduleszd2initz00zzinline_inlinez00();
					BGl_objectzd2initzd2zzinline_inlinez00();
					BGl_genericzd2initzd2zzinline_inlinez00();
					BGl_methodzd2initzd2zzinline_inlinez00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"inline_inline");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"inline_inline");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "inline_inline");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"inline_inline");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			{	/* Inline/inline.scm 15 */
				obj_t BgL_cportz00_2696;

				BgL_cportz00_2696 =
					bgl_open_input_string(BGl_string3543z00zzinline_inlinez00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2697;

					BgL_iz00_2697 = ((long) 4);
				BgL_loopz00_2698:
					if ((BgL_iz00_2697 == ((long) -1)))
						{	/* Inline/inline.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Inline/inline.scm 15 */
							{	/* Inline/inline.scm 15 */
								obj_t BgL_arg3545z00_2700;

								{	/* Inline/inline.scm 15 */

									{	/* Inline/inline.scm 15 */
										obj_t BgL_locationz00_2702;

										BgL_locationz00_2702 = BBOOL(((bool_t) 0));
										{	/* Inline/inline.scm 15 */

											BgL_arg3545z00_2700 =
												BGl_readz00zz__readerz00(BgL_cportz00_2696,
												BgL_locationz00_2702);
										}
									}
								}
								{	/* Inline/inline.scm 15 */
									int BgL_auxz00_2746;

									BgL_auxz00_2746 = (int) (BgL_iz00_2697);
									CNST_TABLE_SET(BgL_auxz00_2746, BgL_arg3545z00_2700);
							}}
							{	/* Inline/inline.scm 15 */
								int BgL_auxz00_2703;

								BgL_auxz00_2703 = (int) ((BgL_iz00_2697 - ((long) 1)));
								{
									long BgL_iz00_2751;

									BgL_iz00_2751 = (long) (BgL_auxz00_2703);
									BgL_iz00_2697 = BgL_iz00_2751;
									goto BgL_loopz00_2698;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			return BUNSPEC;
		}
	}



/* inline-sfun! */
	BGL_EXPORTED_DEF obj_t
		BGl_inlinezd2sfunz12zc0zzinline_inlinez00(BgL_variablez00_bglt
		BgL_variablez00_1, long BgL_kfactorz00_2, obj_t BgL_stackz00_3)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 34 */
			{	/* Inline/inline.scm 37 */
				BgL_valuez00_bglt BgL_sfunz00_836;

				BgL_sfunz00_836 =
					(((BgL_variablez00_bglt) CREF(BgL_variablez00_1))->BgL_valuez00);
				{	/* Inline/inline.scm 37 */
					obj_t BgL_isfunz00_837;

					if (BGl_iszd2azf3z21zz__objectz00
						(BGl_sfunzf3zd2envz21zzinline_inlinez00,
							BGl_isfunz00zzinline_inlinez00))
						{	/* Inline/inline.scm 38 */
							BgL_isfunz00_837 = (obj_t) (BgL_sfunz00_836);
						}
					else
						{	/* Inline/inline.scm 40 */
							BgL_sfunz00_bglt BgL_obj3172z00_849;

							BgL_obj3172z00_849 =
								((BgL_sfunz00_bglt) (BgL_sfunz00_bglt) (BgL_sfunz00_836));
							{	/* Inline/inline.scm 40 */
								BgL_isfunz00_bglt BgL_arg3253z00_850;

								{	/* Inline/inline.scm 40 */
									obj_t BgL_arg3254z00_851;

									{
										BgL_sfunz00_bglt BgL_auxz00_2759;

										BgL_auxz00_2759 = (BgL_sfunz00_bglt) (BgL_sfunz00_836);
										BgL_arg3254z00_851 =
											(((BgL_sfunz00_bglt) CREF(BgL_auxz00_2759))->BgL_bodyz00);
									}
									{	/* Inline/inline.scm 40 */
										BgL_isfunz00_bglt BgL_res3425z00_1517;

										{	/* Inline/inline.scm 40 */
											BgL_nodez00_bglt BgL_originalzd2body3079zd2_1508;

											BgL_originalzd2body3079zd2_1508 =
												(BgL_nodez00_bglt) (BgL_arg3254z00_851);
											{	/* Inline/inline.scm 40 */
												BgL_isfunz00_bglt BgL_new3081z00_1510;

												BgL_new3081z00_1510 =
													((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
																BgL_isfunz00_bgl))));
												{	/* Inline/inline.scm 40 */
													BgL_isfunz00_bglt BgL_res3424z00_1516;

													{	/* Inline/inline.scm 40 */
														BgL_isfunz00_bglt BgL_new3106z00_1511;

														BgL_new3106z00_1511 = BgL_new3081z00_1510;
														{	/* Inline/inline.scm 40 */
															BgL_nodez00_bglt BgL_originalzd2body3104zd2_1514;

															obj_t BgL_recursivezd2calls3105zd2_1515;

															BgL_originalzd2body3104zd2_1514 =
																BgL_originalzd2body3079zd2_1508;
															BgL_recursivezd2calls3105zd2_1515 = BUNSPEC;
															((((BgL_isfunz00_bglt)
																		CREF(BgL_new3106z00_1511))->
																	BgL_originalzd2bodyzd2) =
																((BgL_nodez00_bglt)
																	BgL_originalzd2body3104zd2_1514), BUNSPEC);
															((((BgL_isfunz00_bglt)
																		CREF(BgL_new3106z00_1511))->
																	BgL_recursivezd2callszd2) =
																((obj_t) BgL_recursivezd2calls3105zd2_1515),
																BUNSPEC);
															BgL_res3424z00_1516 = BgL_new3106z00_1511;
													}} BgL_res3424z00_1516;
												}
												BgL_res3425z00_1517 = BgL_new3081z00_1510;
										}}
										BgL_arg3253z00_850 = BgL_res3425z00_1517;
								}}
								{	/* Inline/inline.scm 40 */
									obj_t BgL_auxz00_2768;

									BgL_objectz00_bglt BgL_auxz00_2766;

									BgL_auxz00_2768 = (obj_t) (BgL_arg3253z00_850);
									BgL_auxz00_2766 = (BgL_objectz00_bglt) (BgL_obj3172z00_849);
									BGL_OBJECT_WIDENING_SET(BgL_auxz00_2766, BgL_auxz00_2768);
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								(BgL_objectz00_bglt) (BgL_obj3172z00_849),
								BGl_classzd2numzd2zz__objectz00
								(BGl_isfunz00zzinline_inlinez00));
							BgL_isfunz00_837 = (obj_t) (BgL_obj3172z00_849);
						}
					{	/* Inline/inline.scm 38 */
						BgL_nodez00_bglt BgL_ozd2bodyzd2_838;

						{	/* Inline/inline.scm 41 */
							BgL_isfunz00_bglt BgL_obj3118z00_1520;

							BgL_obj3118z00_1520 = (BgL_isfunz00_bglt) (BgL_isfunz00_837);
							{
								obj_t BgL_auxz00_2776;

								{	/* Inline/inline.scm 41 */
									BgL_objectz00_bglt BgL_auxz00_2777;

									BgL_auxz00_2777 = (BgL_objectz00_bglt) (BgL_obj3118z00_1520);
									BgL_auxz00_2776 = BGL_OBJECT_WIDENING(BgL_auxz00_2777);
								}
								BgL_ozd2bodyzd2_838 =
									(((BgL_isfunz00_bglt) CREF(BgL_auxz00_2776))->
									BgL_originalzd2bodyzd2);
						}}
						{	/* Inline/inline.scm 41 */
							BgL_nodez00_bglt BgL_inlzd2bodyzd2_839;

							{	/* Inline/inline.scm 42 */
								bool_t BgL_testz00_2781;

								{	/* Inline/inline.scm 44 */
									long BgL_arg3245z00_843;

									{	/* Inline/inline.scm 44 */
										long BgL_auxz00_2782;

										{	/* Inline/inline.scm 44 */
											obj_t BgL_auxz00_2783;

											{
												BgL_sfunz00_bglt BgL_auxz00_2784;

												BgL_auxz00_2784 = (BgL_sfunz00_bglt) (BgL_sfunz00_836);
												BgL_auxz00_2783 =
													(((BgL_sfunz00_bglt) CREF(BgL_auxz00_2784))->
													BgL_argsz00);
											}
											BgL_auxz00_2782 = bgl_list_length(BgL_auxz00_2783);
										}
										BgL_arg3245z00_843 = (((long) 1) + BgL_auxz00_2782);
									}
									BgL_testz00_2781 =
										BGl_inlinezd2appzf3z21zzinline_appz00(BgL_variablez00_1,
										(long) CINT(BGl_za2kfactorza2z00zzinline_walkz00),
										BgL_arg3245z00_843, BNIL);
								}
								if (BgL_testz00_2781)
									{	/* Inline/inline.scm 42 */
										BgL_inlzd2bodyzd2_839 =
											BGl_alphatiza7eza7zzast_alphatiza7eza7(BNIL, BNIL, BFALSE,
											BgL_ozd2bodyzd2_838);
									}
								else
									{	/* Inline/inline.scm 42 */
										BgL_inlzd2bodyzd2_839 = BgL_ozd2bodyzd2_838;
									}
							}
							{	/* Inline/inline.scm 42 */

								{	/* Inline/inline.scm 55 */
									BgL_nodez00_bglt BgL_arg3242z00_840;

									{	/* Inline/inline.scm 55 */
										obj_t BgL_arg3243z00_841;

										BgL_arg3243z00_841 =
											MAKE_PAIR((obj_t) (BgL_variablez00_1), BgL_stackz00_3);
										{	/* Inline/inline.scm 53 */
											BgL_nodez00_bglt BgL_res3428z00_1552;

											{	/* Inline/inline.scm 53 */
												obj_t BgL_method3196z00_1527;

												{	/* Inline/inline.scm 53 */
													BgL_objectz00_bglt BgL_objz00_1528;

													BgL_objz00_1528 =
														(BgL_objectz00_bglt) (BgL_inlzd2bodyzd2_839);
													{	/* Inline/inline.scm 53 */
														long BgL_objzd2classzd2numz00_1529;

														BgL_objzd2classzd2numz00_1529 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_1528);
														{	/* Inline/inline.scm 53 */
															obj_t BgL_arg2356z00_1530;

															BgL_arg2356z00_1530 =
																PROCEDURE_REF
																(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
																(int) (((long) 1)));
															{	/* Inline/inline.scm 53 */
																obj_t BgL_arrayz00_1532;

																int BgL_offsetz00_1533;

																BgL_arrayz00_1532 = BgL_arg2356z00_1530;
																BgL_offsetz00_1533 =
																	(int) (BgL_objzd2classzd2numz00_1529);
																{	/* Inline/inline.scm 53 */
																	long BgL_offsetz00_1534;

																	BgL_offsetz00_1534 =
																		((long) (BgL_offsetz00_1533) - OBJECT_TYPE);
																	{	/* Inline/inline.scm 53 */
																		long BgL_modz00_1535;

																		{	/* Inline/inline.scm 53 */
																			int BgL_arg2358z00_1536;

																			BgL_arg2358z00_1536 = (int) (((long) 8));
																			{	/* Inline/inline.scm 53 */
																				long BgL_auxz00_2802;

																				BgL_auxz00_2802 =
																					(long) (BgL_arg2358z00_1536);
																				BgL_modz00_1535 =
																					(BgL_offsetz00_1534 /
																					BgL_auxz00_2802);
																		}}
																		{	/* Inline/inline.scm 53 */
																			long BgL_restz00_1537;

																			{	/* Inline/inline.scm 53 */
																				int BgL_arg2357z00_1538;

																				BgL_arg2357z00_1538 =
																					(int) (((long) 8));
																				{	/* Inline/inline.scm 53 */
																					long BgL_auxz00_2806;

																					BgL_auxz00_2806 =
																						(long) (BgL_arg2357z00_1538);
																					BgL_restz00_1537 =
																						(BgL_offsetz00_1534 %
																						BgL_auxz00_2806);
																			}}
																			{	/* Inline/inline.scm 53 */

																				BgL_method3196z00_1527 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_1532,
																						(int) (BgL_modz00_1535)),
																					(int) (BgL_restz00_1537));
												}}}}}}}}
												BgL_res3428z00_1552 =
													(BgL_nodez00_bglt) (PROCEDURE_ENTRY
													(BgL_method3196z00_1527) (BgL_method3196z00_1527,
														(obj_t) (BgL_inlzd2bodyzd2_839),
														BINT(BgL_kfactorz00_2), BgL_arg3243z00_841, BEOA));
											}
											BgL_arg3242z00_840 = BgL_res3428z00_1552;
									}}
									{
										obj_t BgL_auxz00_2820;

										BgL_sfunz00_bglt BgL_auxz00_2818;

										BgL_auxz00_2820 = (obj_t) (BgL_arg3242z00_840);
										BgL_auxz00_2818 = (BgL_sfunz00_bglt) (BgL_sfunz00_836);
										((((BgL_sfunz00_bglt) CREF(BgL_auxz00_2818))->BgL_bodyz00) =
											((obj_t) BgL_auxz00_2820), BUNSPEC);
								}}
								return BNIL;
							}
						}
					}
				}
			}
		}
	}



/* _inline-sfun! */
	obj_t BGl__inlinezd2sfunz12zc0zzinline_inlinez00(obj_t BgL_envz00_2535,
		obj_t BgL_variablez00_2536, obj_t BgL_kfactorz00_2537,
		obj_t BgL_stackz00_2538)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 34 */
			return
				BGl_inlinezd2sfunz12zc0zzinline_inlinez00(
				(BgL_variablez00_bglt) (BgL_variablez00_2536),
				(long) CINT(BgL_kfactorz00_2537), BgL_stackz00_2538);
		}
	}



/* inline-node*! */
	BGL_EXPORTED_DEF obj_t BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(obj_t
		BgL_nodeza2za2_70, obj_t BgL_kfactorz00_71, obj_t BgL_stackz00_72)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 238 */
		BGl_inlinezd2nodeza2z12z62zzinline_inlinez00:
			if (NULLP(BgL_nodeza2za2_70))
				{	/* Inline/inline.scm 239 */
					return CNST_TABLE_REF(((long) 0));
				}
			else
				{	/* Inline/inline.scm 239 */
					{	/* Inline/inline.scm 242 */
						BgL_nodez00_bglt BgL_arg3257z00_854;

						{	/* Inline/inline.scm 242 */
							obj_t BgL_arg3258z00_855;

							BgL_arg3258z00_855 = CAR(BgL_nodeza2za2_70);
							{	/* Inline/inline.scm 242 */
								BgL_nodez00_bglt BgL_res3431z00_1585;

								{	/* Inline/inline.scm 242 */
									BgL_nodez00_bglt BgL_nodez00_1557;

									long BgL_kfactorz00_1558;

									BgL_nodez00_1557 = (BgL_nodez00_bglt) (BgL_arg3258z00_855);
									BgL_kfactorz00_1558 = (long) CINT(BgL_kfactorz00_71);
									{	/* Inline/inline.scm 242 */
										obj_t BgL_method3196z00_1560;

										{	/* Inline/inline.scm 242 */
											BgL_objectz00_bglt BgL_objz00_1561;

											BgL_objz00_1561 = (BgL_objectz00_bglt) (BgL_nodez00_1557);
											{	/* Inline/inline.scm 242 */
												long BgL_objzd2classzd2numz00_1562;

												BgL_objzd2classzd2numz00_1562 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1561);
												{	/* Inline/inline.scm 242 */
													obj_t BgL_arg2356z00_1563;

													BgL_arg2356z00_1563 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 242 */
														obj_t BgL_arrayz00_1565;

														int BgL_offsetz00_1566;

														BgL_arrayz00_1565 = BgL_arg2356z00_1563;
														BgL_offsetz00_1566 =
															(int) (BgL_objzd2classzd2numz00_1562);
														{	/* Inline/inline.scm 242 */
															long BgL_offsetz00_1567;

															BgL_offsetz00_1567 =
																((long) (BgL_offsetz00_1566) - OBJECT_TYPE);
															{	/* Inline/inline.scm 242 */
																long BgL_modz00_1568;

																{	/* Inline/inline.scm 242 */
																	int BgL_arg2358z00_1569;

																	BgL_arg2358z00_1569 = (int) (((long) 8));
																	{	/* Inline/inline.scm 242 */
																		long BgL_auxz00_2840;

																		BgL_auxz00_2840 =
																			(long) (BgL_arg2358z00_1569);
																		BgL_modz00_1568 =
																			(BgL_offsetz00_1567 / BgL_auxz00_2840);
																}}
																{	/* Inline/inline.scm 242 */
																	long BgL_restz00_1570;

																	{	/* Inline/inline.scm 242 */
																		int BgL_arg2357z00_1571;

																		BgL_arg2357z00_1571 = (int) (((long) 8));
																		{	/* Inline/inline.scm 242 */
																			long BgL_auxz00_2844;

																			BgL_auxz00_2844 =
																				(long) (BgL_arg2357z00_1571);
																			BgL_restz00_1570 =
																				(BgL_offsetz00_1567 % BgL_auxz00_2844);
																	}}
																	{	/* Inline/inline.scm 242 */

																		BgL_method3196z00_1560 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1565,
																				(int) (BgL_modz00_1568)),
																			(int) (BgL_restz00_1570));
										}}}}}}}}
										BgL_res3431z00_1585 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_1560) (BgL_method3196z00_1560,
												(obj_t) (BgL_nodez00_1557), BINT(BgL_kfactorz00_1558),
												BgL_stackz00_72, BEOA));
								}}
								BgL_arg3257z00_854 = BgL_res3431z00_1585;
						}}
						{	/* Inline/inline.scm 242 */
							obj_t BgL_auxz00_2856;

							BgL_auxz00_2856 = (obj_t) (BgL_arg3257z00_854);
							SET_CAR(BgL_nodeza2za2_70, BgL_auxz00_2856);
					}}
					{
						obj_t BgL_nodeza2za2_2859;

						BgL_nodeza2za2_2859 = CDR(BgL_nodeza2za2_70);
						BgL_nodeza2za2_70 = BgL_nodeza2za2_2859;
						goto BGl_inlinezd2nodeza2z12z62zzinline_inlinez00;
					}
				}
		}
	}



/* _inline-node*! */
	obj_t BGl__inlinezd2nodeza2z12z62zzinline_inlinez00(obj_t BgL_envz00_2545,
		obj_t BgL_nodeza2za2_2546, obj_t BgL_kfactorz00_2547,
		obj_t BgL_stackz00_2548)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 238 */
			return
				BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_nodeza2za2_2546,
				BgL_kfactorz00_2547, BgL_stackz00_2548);
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			{	/* Inline/inline.scm 25 */
				obj_t BgL_arg3260z00_857;

				obj_t BgL_arg3261z00_858;

				obj_t BgL_arg3264z00_861;

				BgL_arg3260z00_857 = CNST_TABLE_REF(((long) 1));
				BgL_arg3261z00_858 = BGl_sfunz00zzast_varz00;
				{	/* Inline/inline.scm 25 */
					obj_t BgL_v3194z00_862;

					BgL_v3194z00_862 = create_vector((int) (((long) 0)));
					BgL_arg3264z00_861 = BgL_v3194z00_862;
				}
				BGl_isfunz00zzinline_inlinez00 =
					BGl_registerzd2classz12zc0zz__objectz00(BgL_arg3260z00_857,
					BgL_arg3261z00_858, ((bool_t) 0), BFALSE,
					BGl_z52allocatezd2isfunzd2envz52zzinline_inlinez00,
					BGl_isfunzd2nilzd2envz00zzinline_inlinez00,
					BGl_isfunzf3zd2envz21zzinline_inlinez00, ((long) 461696808), BFALSE,
					BFALSE, BgL_arg3264z00_861);
			}
			return (BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00 = BUNSPEC, BUNSPEC);
		}
	}



/* isfun? */
	BGL_EXPORTED_DEF bool_t BGl_isfunzf3zf3zzinline_inlinez00(obj_t
		BgL_obj3117z00_73)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return
				BGl_iszd2azf3z21zz__objectz00(BgL_obj3117z00_73,
				BGl_isfunz00zzinline_inlinez00);
		}
	}



/* _isfun? */
	obj_t BGl__isfunzf3zf3zzinline_inlinez00(obj_t BgL_envz00_2551,
		obj_t BgL_obj3117z00_2552)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return
				BBOOL(BGl_iszd2azf3z21zz__objectz00(BgL_obj3117z00_2552,
					BGl_isfunz00zzinline_inlinez00));
		}
	}



/* widening-isfun */
	BGL_EXPORTED_DEF BgL_isfunz00_bglt
		BGl_wideningzd2isfunzd2zzinline_inlinez00(BgL_nodez00_bglt
		BgL_originalzd2body3079zd2_77, obj_t BgL_recursivezd2calls3080zd2_78)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_isfunz00_bglt BgL_new3081z00_1589;

				BgL_new3081z00_1589 =
					((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
								BgL_isfunz00_bgl))));
				{	/* Inline/inline.scm 25 */
					BgL_isfunz00_bglt BgL_res3432z00_1595;

					{	/* Inline/inline.scm 25 */
						BgL_isfunz00_bglt BgL_new3106z00_1590;

						BgL_new3106z00_1590 = BgL_new3081z00_1589;
						{	/* Inline/inline.scm 25 */
							BgL_nodez00_bglt BgL_originalzd2body3104zd2_1593;

							obj_t BgL_recursivezd2calls3105zd2_1594;

							BgL_originalzd2body3104zd2_1593 = BgL_originalzd2body3079zd2_77;
							BgL_recursivezd2calls3105zd2_1594 =
								BgL_recursivezd2calls3080zd2_78;
							((((BgL_isfunz00_bglt) CREF(BgL_new3106z00_1590))->
									BgL_originalzd2bodyzd2) =
								((BgL_nodez00_bglt) BgL_originalzd2body3104zd2_1593), BUNSPEC);
							((((BgL_isfunz00_bglt) CREF(BgL_new3106z00_1590))->
									BgL_recursivezd2callszd2) =
								((obj_t) BgL_recursivezd2calls3105zd2_1594), BUNSPEC);
							BgL_res3432z00_1595 = BgL_new3106z00_1590;
					}} BgL_res3432z00_1595;
				}
				return BgL_new3081z00_1589;
			}
		}
	}



/* _widening-isfun3513 */
	obj_t BGl__wideningzd2isfun3513zd2zzinline_inlinez00(obj_t BgL_envz00_2553,
		obj_t BgL_originalzd2body3079zd2_2554,
		obj_t BgL_recursivezd2calls3080zd2_2555)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return
				(obj_t) (BGl_wideningzd2isfunzd2zzinline_inlinez00(
					(BgL_nodez00_bglt) (BgL_originalzd2body3079zd2_2554),
					BgL_recursivezd2calls3080zd2_2555));
		}
	}



/* make-isfun */
	BGL_EXPORTED_DEF BgL_isfunz00_bglt BGl_makezd2isfunzd2zzinline_inlinez00(long
		BgL_arity3085z00_79, obj_t BgL_sidezd2effectzf33086z21_80,
		obj_t BgL_predicatezd2of3087zd2_81, obj_t BgL_stackzd2allocator3088zd2_82,
		bool_t BgL_topzf33089zf3_83, obj_t BgL_thezd2closure3090zd2_84,
		obj_t BgL_effect3091z00_85, obj_t BgL_property3092z00_86,
		obj_t BgL_args3093z00_87, obj_t BgL_argszd2name3094zd2_88,
		obj_t BgL_body3095z00_89, obj_t BgL_class3096z00_90,
		obj_t BgL_dssslzd2keywords3097zd2_91, obj_t BgL_loc3098z00_92,
		obj_t BgL_optionals3099z00_93, obj_t BgL_keys3100z00_94,
		obj_t BgL_thezd2closurezd2global3101z00_95,
		BgL_nodez00_bglt BgL_originalzd2body3083zd2_96,
		obj_t BgL_recursivezd2calls3084zd2_97)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_sfunz00_bglt BgL_aux3102z00_1596;

				BgL_aux3102z00_1596 =
					BGl_makezd2sfunzd2zzast_varz00(BgL_arity3085z00_79,
					BgL_sidezd2effectzf33086z21_80, BgL_predicatezd2of3087zd2_81,
					BgL_stackzd2allocator3088zd2_82, BgL_topzf33089zf3_83,
					BgL_thezd2closure3090zd2_84, BgL_effect3091z00_85,
					BgL_property3092z00_86, BgL_args3093z00_87, BgL_argszd2name3094zd2_88,
					BgL_body3095z00_89, BgL_class3096z00_90,
					BgL_dssslzd2keywords3097zd2_91, BgL_loc3098z00_92,
					BgL_optionals3099z00_93, BgL_keys3100z00_94,
					BgL_thezd2closurezd2global3101z00_95);
				BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_aux3102z00_1596),
					BGl_classzd2numzd2zz__objectz00(BGl_isfunz00zzinline_inlinez00));
				{	/* Inline/inline.scm 25 */
					BgL_isfunz00_bglt BgL_arg3266z00_1598;

					{	/* Inline/inline.scm 25 */
						BgL_isfunz00_bglt BgL_res3434z00_1611;

						{	/* Inline/inline.scm 25 */
							BgL_isfunz00_bglt BgL_new3081z00_1604;

							BgL_new3081z00_1604 =
								((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_isfunz00_bgl))));
							{	/* Inline/inline.scm 25 */
								BgL_isfunz00_bglt BgL_res3433z00_1610;

								{	/* Inline/inline.scm 25 */
									BgL_isfunz00_bglt BgL_new3106z00_1605;

									BgL_new3106z00_1605 = BgL_new3081z00_1604;
									{	/* Inline/inline.scm 25 */
										BgL_nodez00_bglt BgL_originalzd2body3104zd2_1608;

										obj_t BgL_recursivezd2calls3105zd2_1609;

										BgL_originalzd2body3104zd2_1608 =
											BgL_originalzd2body3083zd2_96;
										BgL_recursivezd2calls3105zd2_1609 =
											BgL_recursivezd2calls3084zd2_97;
										((((BgL_isfunz00_bglt) CREF(BgL_new3106z00_1605))->
												BgL_originalzd2bodyzd2) =
											((BgL_nodez00_bglt) BgL_originalzd2body3104zd2_1608),
											BUNSPEC);
										((((BgL_isfunz00_bglt) CREF(BgL_new3106z00_1605))->
												BgL_recursivezd2callszd2) =
											((obj_t) BgL_recursivezd2calls3105zd2_1609), BUNSPEC);
										BgL_res3433z00_1610 = BgL_new3106z00_1605;
								}} BgL_res3433z00_1610;
							}
							BgL_res3434z00_1611 = BgL_new3081z00_1604;
						}
						BgL_arg3266z00_1598 = BgL_res3434z00_1611;
					}
					{	/* Inline/inline.scm 25 */
						obj_t BgL_auxz00_2884;

						BgL_objectz00_bglt BgL_auxz00_2882;

						BgL_auxz00_2884 = (obj_t) (BgL_arg3266z00_1598);
						BgL_auxz00_2882 = (BgL_objectz00_bglt) (BgL_aux3102z00_1596);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_2882, BgL_auxz00_2884);
				}}
				return ((BgL_isfunz00_bglt) (BgL_isfunz00_bglt) (BgL_aux3102z00_1596));
			}
		}
	}



/* _make-isfun */
	obj_t BGl__makezd2isfunzd2zzinline_inlinez00(obj_t BgL_envz00_2556,
		obj_t BgL_arity3085z00_2557, obj_t BgL_sidezd2effectzf33086z21_2558,
		obj_t BgL_predicatezd2of3087zd2_2559,
		obj_t BgL_stackzd2allocator3088zd2_2560, obj_t BgL_topzf33089zf3_2561,
		obj_t BgL_thezd2closure3090zd2_2562, obj_t BgL_effect3091z00_2563,
		obj_t BgL_property3092z00_2564, obj_t BgL_args3093z00_2565,
		obj_t BgL_argszd2name3094zd2_2566, obj_t BgL_body3095z00_2567,
		obj_t BgL_class3096z00_2568, obj_t BgL_dssslzd2keywords3097zd2_2569,
		obj_t BgL_loc3098z00_2570, obj_t BgL_optionals3099z00_2571,
		obj_t BgL_keys3100z00_2572, obj_t BgL_thezd2closurezd2global3101z00_2573,
		obj_t BgL_originalzd2body3083zd2_2574,
		obj_t BgL_recursivezd2calls3084zd2_2575)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return
				(obj_t) (BGl_makezd2isfunzd2zzinline_inlinez00(
					(long) CINT(BgL_arity3085z00_2557), BgL_sidezd2effectzf33086z21_2558,
					BgL_predicatezd2of3087zd2_2559, BgL_stackzd2allocator3088zd2_2560,
					CBOOL(BgL_topzf33089zf3_2561), BgL_thezd2closure3090zd2_2562,
					BgL_effect3091z00_2563, BgL_property3092z00_2564,
					BgL_args3093z00_2565, BgL_argszd2name3094zd2_2566,
					BgL_body3095z00_2567, BgL_class3096z00_2568,
					BgL_dssslzd2keywords3097zd2_2569, BgL_loc3098z00_2570,
					BgL_optionals3099z00_2571, BgL_keys3100z00_2572,
					BgL_thezd2closurezd2global3101z00_2573,
					(BgL_nodez00_bglt) (BgL_originalzd2body3083zd2_2574),
					BgL_recursivezd2calls3084zd2_2575));
		}
	}



/* fill-isfun! */
	BGL_EXPORTED_DEF BgL_isfunz00_bglt
		BGl_fillzd2isfunz12zc0zzinline_inlinez00(BgL_isfunz00_bglt
		BgL_new3106z00_98, BgL_nodez00_bglt BgL_originalzd2body3104zd2_99,
		obj_t BgL_recursivezd2calls3105zd2_100)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_nodez00_bglt BgL_originalzd2body3104zd2_2705;

				obj_t BgL_recursivezd2calls3105zd2_2706;

				BgL_originalzd2body3104zd2_2705 = BgL_originalzd2body3104zd2_99;
				BgL_recursivezd2calls3105zd2_2706 = BgL_recursivezd2calls3105zd2_100;
				((((BgL_isfunz00_bglt) CREF(BgL_new3106z00_98))->
						BgL_originalzd2bodyzd2) =
					((BgL_nodez00_bglt) BgL_originalzd2body3104zd2_2705), BUNSPEC);
				((((BgL_isfunz00_bglt) CREF(BgL_new3106z00_98))->
						BgL_recursivezd2callszd2) =
					((obj_t) BgL_recursivezd2calls3105zd2_2706), BUNSPEC);
				return BgL_new3106z00_98;
			}
		}
	}



/* _fill-isfun! */
	obj_t BGl__fillzd2isfunz12zc0zzinline_inlinez00(obj_t BgL_envz00_2576,
		obj_t BgL_new3106z00_2577, obj_t BgL_originalzd2body3104zd2_2578,
		obj_t BgL_recursivezd2calls3105zd2_2579)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_isfunz00_bglt BgL_auxz00_2896;

				{	/* Inline/inline.scm 25 */
					BgL_isfunz00_bglt BgL_res3546z00_2712;

					{	/* Inline/inline.scm 25 */
						BgL_isfunz00_bglt BgL_new3106z00_2707;

						BgL_nodez00_bglt BgL_originalzd2body3104zd2_2708;

						BgL_new3106z00_2707 = (BgL_isfunz00_bglt) (BgL_new3106z00_2577);
						BgL_originalzd2body3104zd2_2708 =
							(BgL_nodez00_bglt) (BgL_originalzd2body3104zd2_2578);
						{	/* Inline/inline.scm 25 */
							BgL_nodez00_bglt BgL_originalzd2body3104zd2_2710;

							obj_t BgL_recursivezd2calls3105zd2_2711;

							BgL_originalzd2body3104zd2_2710 = BgL_originalzd2body3104zd2_2708;
							BgL_recursivezd2calls3105zd2_2711 =
								BgL_recursivezd2calls3105zd2_2579;
							((((BgL_isfunz00_bglt) CREF(BgL_new3106z00_2707))->
									BgL_originalzd2bodyzd2) =
								((BgL_nodez00_bglt) BgL_originalzd2body3104zd2_2710), BUNSPEC);
							((((BgL_isfunz00_bglt) CREF(BgL_new3106z00_2707))->
									BgL_recursivezd2callszd2) =
								((obj_t) BgL_recursivezd2calls3105zd2_2711), BUNSPEC);
							BgL_res3546z00_2712 = BgL_new3106z00_2707;
						}
					}
					BgL_auxz00_2896 = BgL_res3546z00_2712;
				}
				return (obj_t) (BgL_auxz00_2896);
			}
		}
	}



/* %allocate-isfun */
	BGL_EXPORTED_DEF BgL_sfunz00_bglt
		BGl_z52allocatezd2isfunz80zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_sfunz00_bglt BgL_new3110z00_2713;

				BgL_new3110z00_2713 =
					((BgL_sfunz00_bglt) BREF(GC_MALLOC(sizeof(struct BgL_sfunz00_bgl))));
				BGL_OBJECT_CLASS_NUM_SET(
					(BgL_objectz00_bglt) (BgL_new3110z00_2713),
					BGl_classzd2numzd2zz__objectz00(BGl_isfunz00zzinline_inlinez00));
				{	/* Inline/inline.scm 25 */
					BgL_objectz00_bglt BgL_auxz00_2906;

					BgL_auxz00_2906 = (BgL_objectz00_bglt) (BgL_new3110z00_2713);
					BGL_OBJECT_WIDENING_SET(BgL_auxz00_2906, BFALSE);
				}
				return BgL_new3110z00_2713;
			}
		}
	}



/* _%allocate-isfun */
	obj_t BGl__z52allocatezd2isfunz80zzinline_inlinez00(obj_t BgL_envz00_2549)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_sfunz00_bglt BgL_auxz00_2909;

				{	/* Inline/inline.scm 25 */
					BgL_sfunz00_bglt BgL_res3547z00_2717;

					{	/* Inline/inline.scm 25 */
						BgL_sfunz00_bglt BgL_new3110z00_2715;

						BgL_new3110z00_2715 =
							((BgL_sfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_sfunz00_bgl))));
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_new3110z00_2715),
							BGl_classzd2numzd2zz__objectz00(BGl_isfunz00zzinline_inlinez00));
						{	/* Inline/inline.scm 25 */
							BgL_objectz00_bglt BgL_auxz00_2914;

							BgL_auxz00_2914 = (BgL_objectz00_bglt) (BgL_new3110z00_2715);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_2914, BFALSE);
						}
						BgL_res3547z00_2717 = BgL_new3110z00_2715;
					}
					BgL_auxz00_2909 = BgL_res3547z00_2717;
				}
				return (obj_t) (BgL_auxz00_2909);
			}
		}
	}



/* isfun-nil */
	BGL_EXPORTED_DEF BgL_isfunz00_bglt BGl_isfunzd2nilzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			if ((BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00 == BUNSPEC))
				{	/* Inline/inline.scm 25 */
					{	/* Inline/inline.scm 25 */
						BgL_sfunz00_bglt BgL_res3435z00_1622;

						{	/* Inline/inline.scm 25 */
							BgL_sfunz00_bglt BgL_new1792z00_1618;

							BgL_new1792z00_1618 =
								((BgL_sfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_sfunz00_bgl))));
							BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
								(BgL_new1792z00_1618),
								BGl_classzd2numzd2zz__objectz00(BGl_sfunz00zzast_varz00));
							{	/* Inline/inline.scm 25 */
								BgL_objectz00_bglt BgL_auxz00_2924;

								BgL_auxz00_2924 = (BgL_objectz00_bglt) (BgL_new1792z00_1618);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_2924, BFALSE);
							}
							BgL_res3435z00_1622 = BgL_new1792z00_1618;
						}
						BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00 =
							(obj_t) (BgL_res3435z00_1622);
					}
					{	/* Inline/inline.scm 25 */
						BgL_sfunz00_bglt BgL_res3436z00_1658;

						{	/* Inline/inline.scm 25 */
							BgL_sfunz00_bglt BgL_new1773z00_1623;

							BgL_new1773z00_1623 =
								(BgL_sfunz00_bglt)
								(BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00);
							{	/* Inline/inline.scm 25 */
								long BgL_arity1756z00_1641;

								obj_t BgL_sidezd2effectzf31757z21_1642;

								obj_t BgL_predicatezd2of1758zd2_1643;

								obj_t BgL_stackzd2allocator1759zd2_1644;

								bool_t BgL_topzf31760zf3_1645;

								obj_t BgL_thezd2closure1761zd2_1646;

								obj_t BgL_effect1762z00_1647;

								obj_t BgL_property1763z00_1648;

								obj_t BgL_args1764z00_1649;

								obj_t BgL_argszd2name1765zd2_1650;

								obj_t BgL_body1766z00_1651;

								obj_t BgL_class1767z00_1652;

								obj_t BgL_dssslzd2keywords1768zd2_1653;

								obj_t BgL_loc1769z00_1654;

								obj_t BgL_optionals1770z00_1655;

								obj_t BgL_keys1771z00_1656;

								obj_t BgL_thezd2closurezd2global1772z00_1657;

								BgL_arity1756z00_1641 = ((long) 0);
								BgL_sidezd2effectzf31757z21_1642 = BUNSPEC;
								BgL_predicatezd2of1758zd2_1643 = BUNSPEC;
								BgL_stackzd2allocator1759zd2_1644 = BUNSPEC;
								BgL_topzf31760zf3_1645 = ((bool_t) 0);
								BgL_thezd2closure1761zd2_1646 = BUNSPEC;
								BgL_effect1762z00_1647 = BUNSPEC;
								BgL_property1763z00_1648 = BUNSPEC;
								BgL_args1764z00_1649 = BUNSPEC;
								BgL_argszd2name1765zd2_1650 = BUNSPEC;
								BgL_body1766z00_1651 = BUNSPEC;
								BgL_class1767z00_1652 = BUNSPEC;
								BgL_dssslzd2keywords1768zd2_1653 = BUNSPEC;
								BgL_loc1769z00_1654 = BUNSPEC;
								BgL_optionals1770z00_1655 = BUNSPEC;
								BgL_keys1771z00_1656 = BUNSPEC;
								BgL_thezd2closurezd2global1772z00_1657 = BUNSPEC;
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->
										BgL_arityz00) = ((long) BgL_arity1756z00_1641), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->
										BgL_sidezd2effectzf3z21) =
									((obj_t) BgL_sidezd2effectzf31757z21_1642), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->
										BgL_predicatezd2ofzd2) =
									((obj_t) BgL_predicatezd2of1758zd2_1643), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->
										BgL_stackzd2allocatorzd2) =
									((obj_t) BgL_stackzd2allocator1759zd2_1644), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->
										BgL_topzf3zf3) =
									((bool_t) BgL_topzf31760zf3_1645), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->
										BgL_thezd2closurezd2) =
									((obj_t) BgL_thezd2closure1761zd2_1646), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->
										BgL_effectz00) = ((obj_t) BgL_effect1762z00_1647), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->
										BgL_propertyz00) =
									((obj_t) BgL_property1763z00_1648), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->BgL_argsz00) =
									((obj_t) BgL_args1764z00_1649), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->
										BgL_argszd2namezd2) =
									((obj_t) BgL_argszd2name1765zd2_1650), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->BgL_bodyz00) =
									((obj_t) BgL_body1766z00_1651), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->
										BgL_classz00) = ((obj_t) BgL_class1767z00_1652), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->
										BgL_dssslzd2keywordszd2) =
									((obj_t) BgL_dssslzd2keywords1768zd2_1653), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->BgL_locz00) =
									((obj_t) BgL_loc1769z00_1654), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->
										BgL_optionalsz00) =
									((obj_t) BgL_optionals1770z00_1655), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->BgL_keysz00) =
									((obj_t) BgL_keys1771z00_1656), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1773z00_1623))->
										BgL_thezd2closurezd2globalz00) =
									((obj_t) BgL_thezd2closurezd2global1772z00_1657), BUNSPEC);
								BgL_res3436z00_1658 = BgL_new1773z00_1623;
						}} BgL_res3436z00_1658;
					}
					{	/* Inline/inline.scm 25 */
						long BgL_arg3269z00_873;

						BgL_arg3269z00_873 =
							BGl_classzd2numzd2zz__objectz00(BGl_isfunz00zzinline_inlinez00);
						BGL_OBJECT_CLASS_NUM_SET(
							(BgL_objectz00_bglt)
							(BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00),
							BgL_arg3269z00_873);
					}
					{	/* Inline/inline.scm 25 */
						BgL_isfunz00_bglt BgL_arg3270z00_874;

						{	/* Inline/inline.scm 25 */
							BgL_nodez00_bglt BgL_arg3271z00_875;

							BgL_arg3271z00_875 = BGl_nodezd2nilzd2zzast_nodez00();
							{	/* Inline/inline.scm 25 */
								BgL_isfunz00_bglt BgL_res3438z00_1670;

								{	/* Inline/inline.scm 25 */
									BgL_isfunz00_bglt BgL_new3081z00_1663;

									BgL_new3081z00_1663 =
										((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
													BgL_isfunz00_bgl))));
									{	/* Inline/inline.scm 25 */
										BgL_isfunz00_bglt BgL_res3437z00_1669;

										{	/* Inline/inline.scm 25 */
											BgL_isfunz00_bglt BgL_new3106z00_1664;

											BgL_new3106z00_1664 = BgL_new3081z00_1663;
											{	/* Inline/inline.scm 25 */
												BgL_nodez00_bglt BgL_originalzd2body3104zd2_1667;

												obj_t BgL_recursivezd2calls3105zd2_1668;

												BgL_originalzd2body3104zd2_1667 = BgL_arg3271z00_875;
												BgL_recursivezd2calls3105zd2_1668 = BUNSPEC;
												((((BgL_isfunz00_bglt) CREF(BgL_new3106z00_1664))->
														BgL_originalzd2bodyzd2) =
													((BgL_nodez00_bglt) BgL_originalzd2body3104zd2_1667),
													BUNSPEC);
												((((BgL_isfunz00_bglt) CREF(BgL_new3106z00_1664))->
														BgL_recursivezd2callszd2) =
													((obj_t) BgL_recursivezd2calls3105zd2_1668), BUNSPEC);
												BgL_res3437z00_1669 = BgL_new3106z00_1664;
										}} BgL_res3437z00_1669;
									}
									BgL_res3438z00_1670 = BgL_new3081z00_1663;
								}
								BgL_arg3270z00_874 = BgL_res3438z00_1670;
						}}
						{	/* Inline/inline.scm 25 */
							obj_t BgL_auxz00_2955;

							BgL_objectz00_bglt BgL_auxz00_2953;

							BgL_auxz00_2955 = (obj_t) (BgL_arg3270z00_874);
							BgL_auxz00_2953 =
								(BgL_objectz00_bglt)
								(BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_2953, BgL_auxz00_2955);
				}}}
			else
				{	/* Inline/inline.scm 25 */
					BFALSE;
				}
			return
				(BgL_isfunz00_bglt) (BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00);
		}
	}



/* _isfun-nil */
	obj_t BGl__isfunzd2nilzd2zzinline_inlinez00(obj_t BgL_envz00_2550)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return (obj_t) (BGl_isfunzd2nilzd2zzinline_inlinez00());
		}
	}



/* _sfun? */
	obj_t BGl__sfunzf3zf3zzinline_inlinez00(obj_t BgL_envz00_2539,
		obj_t BgL_obj1793z00_2540)
	{
		AN_OBJECT;
		{	/* Ast/var.scm 94 */
			return
				BBOOL(BGl_iszd2azf3z21zz__objectz00(BgL_obj1793z00_2540,
					BGl_sfunz00zzast_varz00));
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_inlinezd2nodezd2default3195zd2envzd2zzinline_inlinez00);
		}
	}



/* inline-node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_inlinezd2nodezd2zzinline_inlinez00(BgL_nodez00_bglt BgL_nodez00_4,
		long BgL_kfactorz00_5, obj_t BgL_stackz00_6)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 62 */
			{	/* Inline/inline.scm 62 */
				obj_t BgL_method3196z00_1692;

				{	/* Inline/inline.scm 62 */
					BgL_objectz00_bglt BgL_objz00_1693;

					BgL_objz00_1693 = (BgL_objectz00_bglt) (BgL_nodez00_4);
					{	/* Inline/inline.scm 62 */
						long BgL_objzd2classzd2numz00_1694;

						BgL_objzd2classzd2numz00_1694 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1693);
						{	/* Inline/inline.scm 62 */
							obj_t BgL_arg2356z00_1695;

							BgL_arg2356z00_1695 =
								PROCEDURE_REF(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
								(int) (((long) 1)));
							{	/* Inline/inline.scm 62 */
								obj_t BgL_arrayz00_1697;

								int BgL_offsetz00_1698;

								BgL_arrayz00_1697 = BgL_arg2356z00_1695;
								BgL_offsetz00_1698 = (int) (BgL_objzd2classzd2numz00_1694);
								{	/* Inline/inline.scm 62 */
									long BgL_offsetz00_1699;

									BgL_offsetz00_1699 =
										((long) (BgL_offsetz00_1698) - OBJECT_TYPE);
									{	/* Inline/inline.scm 62 */
										long BgL_modz00_1700;

										{	/* Inline/inline.scm 62 */
											int BgL_arg2358z00_1701;

											BgL_arg2358z00_1701 = (int) (((long) 8));
											{	/* Inline/inline.scm 62 */
												long BgL_auxz00_2972;

												BgL_auxz00_2972 = (long) (BgL_arg2358z00_1701);
												BgL_modz00_1700 =
													(BgL_offsetz00_1699 / BgL_auxz00_2972);
										}}
										{	/* Inline/inline.scm 62 */
											long BgL_restz00_1702;

											{	/* Inline/inline.scm 62 */
												int BgL_arg2357z00_1703;

												BgL_arg2357z00_1703 = (int) (((long) 8));
												{	/* Inline/inline.scm 62 */
													long BgL_auxz00_2976;

													BgL_auxz00_2976 = (long) (BgL_arg2357z00_1703);
													BgL_restz00_1702 =
														(BgL_offsetz00_1699 % BgL_auxz00_2976);
											}}
											{	/* Inline/inline.scm 62 */

												BgL_method3196z00_1692 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1697,
														(int) (BgL_modz00_1700)), (int) (BgL_restz00_1702));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3196z00_1692)
					(BgL_method3196z00_1692, (obj_t) (BgL_nodez00_4),
						BINT(BgL_kfactorz00_5), BgL_stackz00_6, BEOA));
			}
		}
	}



/* _inline-node */
	obj_t BGl__inlinezd2nodezd2zzinline_inlinez00(obj_t BgL_envz00_2541,
		obj_t BgL_nodez00_2542, obj_t BgL_kfactorz00_2543, obj_t BgL_stackz00_2544)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 62 */
			return
				(obj_t) (BGl_inlinezd2nodezd2zzinline_inlinez00(
					(BgL_nodez00_bglt) (BgL_nodez00_2542),
					(long) CINT(BgL_kfactorz00_2543), BgL_stackz00_2544));
		}
	}



/* inline-node-default3195 */
	BgL_nodez00_bglt
		BGl_inlinezd2nodezd2default3195z00zzinline_inlinez00(BgL_nodez00_bglt
		BgL_nodez00_7, long BgL_kfactorz00_8, obj_t BgL_stackz00_9)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			return
				(BgL_nodez00_bglt) (BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
					BGl_string3519z00zzinline_inlinez00, (obj_t) (BgL_nodez00_7)));
		}
	}



/* _inline-node-default3195 */
	obj_t BGl__inlinezd2nodezd2default3195z00zzinline_inlinez00(obj_t
		BgL_envz00_2580, obj_t BgL_nodez00_2581, obj_t BgL_kfactorz00_2582,
		obj_t BgL_stackz00_2583)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			return
				(obj_t) (BGl_inlinezd2nodezd2default3195z00zzinline_inlinez00(
					(BgL_nodez00_bglt) (BgL_nodez00_2581),
					(long) CINT(BgL_kfactorz00_2582), BgL_stackz00_2583));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_atomz00zzast_nodez00,
				BGl_proc3520z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_varz00zzast_nodez00,
				BGl_proc3521z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_kwotez00zzast_nodez00, BGl_proc3522z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_sequencez00zzast_nodez00, BGl_proc3523z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_appz00zzast_nodez00,
				BGl_proc3524z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3525z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_funcallz00zzast_nodez00, BGl_proc3526z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_externz00zzast_nodez00, BGl_proc3527z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_castz00zzast_nodez00,
				BGl_proc3528z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_setqz00zzast_nodez00,
				BGl_proc3529z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3530z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_failz00zzast_nodez00,
				BGl_proc3531z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_selectz00zzast_nodez00, BGl_proc3532z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3533z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3534z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3535z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3536z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3537z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3538z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3539z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_objectzd2ze3structzd2envze3zz__objectz00,
				BGl_isfunz00zzinline_inlinez00, BGl_proc3540z00zzinline_inlinez00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
				BGl_isfunz00zzinline_inlinez00, BGl_proc3541z00zzinline_inlinez00);
		}
	}



/* struct+object->objec3241 */
	obj_t BGl_structzb2objectzd2ze3objec3241z83zzinline_inlinez00(obj_t
		BgL_envz00_2611, obj_t BgL_oz00_2612, obj_t BgL_sz00_2613)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{
				BgL_isfunz00_bglt BgL_oz00_1493;

				obj_t BgL_sz00_1494;

				{	/* Inline/inline.scm 25 */
					BgL_isfunz00_bglt BgL_auxz00_3022;

					BgL_oz00_1493 = (BgL_isfunz00_bglt) (BgL_oz00_2612);
					BgL_sz00_1494 = BgL_sz00_2613;
					{

						{	/* Inline/inline.scm 25 */
							obj_t BgL_old3114z00_1497;

							obj_t BgL_aux3115z00_1498;

							{	/* Inline/inline.scm 25 */
								obj_t BgL_nextzd2method3240zd2_1504;

								BgL_nextzd2method3240zd2_1504 =
									BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
									(BgL_objectz00_bglt) (BgL_oz00_1493),
									BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
									BGl_isfunz00zzinline_inlinez00);
								if (PROCEDUREP(BgL_nextzd2method3240zd2_1504))
									{	/* Inline/inline.scm 25 */
										BgL_old3114z00_1497 =
											PROCEDURE_ENTRY(BgL_nextzd2method3240zd2_1504)
											(BgL_nextzd2method3240zd2_1504, (obj_t) (BgL_oz00_1493),
											BgL_sz00_1494, BEOA);
									}
								else
									{	/* Inline/inline.scm 25 */
										BgL_old3114z00_1497 =
											(obj_t) (BGl_structzb2objectzd2ze3objectz83zz__objectz00(
												(BgL_objectz00_bglt) (BgL_oz00_1493), BgL_sz00_1494));
									}
							}
							BgL_aux3115z00_1498 =
								STRUCT_REF(BgL_sz00_1494, (int) (((long) 0)));
							{	/* Inline/inline.scm 25 */
								BgL_isfunz00_bglt BgL_new3116z00_1499;

								BgL_new3116z00_1499 =
									((BgL_isfunz00_bglt) (BgL_old3114z00_1497));
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_new3116z00_1499),
									BGl_classzd2numzd2zz__objectz00
									(BGl_isfunz00zzinline_inlinez00));
								{	/* Inline/inline.scm 25 */
									BgL_isfunz00_bglt BgL_arg3420z00_1501;

									{	/* Inline/inline.scm 25 */
										obj_t BgL_arg3421z00_1502;

										obj_t BgL_arg3422z00_1503;

										BgL_arg3421z00_1502 =
											STRUCT_REF(BgL_aux3115z00_1498, (int) (((long) 0)));
										BgL_arg3422z00_1503 =
											STRUCT_REF(BgL_aux3115z00_1498, (int) (((long) 1)));
										{	/* Inline/inline.scm 25 */
											BgL_isfunz00_bglt BgL_res3512z00_2533;

											{	/* Inline/inline.scm 25 */
												BgL_nodez00_bglt BgL_originalzd2body3079zd2_2524;

												BgL_originalzd2body3079zd2_2524 =
													(BgL_nodez00_bglt) (BgL_arg3421z00_1502);
												{	/* Inline/inline.scm 25 */
													BgL_isfunz00_bglt BgL_new3081z00_2526;

													BgL_new3081z00_2526 =
														((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
																	BgL_isfunz00_bgl))));
													{	/* Inline/inline.scm 25 */
														BgL_isfunz00_bglt BgL_res3511z00_2532;

														{	/* Inline/inline.scm 25 */
															BgL_isfunz00_bglt BgL_new3106z00_2527;

															BgL_new3106z00_2527 = BgL_new3081z00_2526;
															{	/* Inline/inline.scm 25 */
																BgL_nodez00_bglt
																	BgL_originalzd2body3104zd2_2530;
																obj_t BgL_recursivezd2calls3105zd2_2531;

																BgL_originalzd2body3104zd2_2530 =
																	BgL_originalzd2body3079zd2_2524;
																BgL_recursivezd2calls3105zd2_2531 =
																	BgL_arg3422z00_1503;
																((((BgL_isfunz00_bglt)
																			CREF(BgL_new3106z00_2527))->
																		BgL_originalzd2bodyzd2) =
																	((BgL_nodez00_bglt)
																		BgL_originalzd2body3104zd2_2530), BUNSPEC);
																((((BgL_isfunz00_bglt)
																			CREF(BgL_new3106z00_2527))->
																		BgL_recursivezd2callszd2) =
																	((obj_t) BgL_recursivezd2calls3105zd2_2531),
																	BUNSPEC);
																BgL_res3511z00_2532 = BgL_new3106z00_2527;
														}} BgL_res3511z00_2532;
													}
													BgL_res3512z00_2533 = BgL_new3081z00_2526;
											}}
											BgL_arg3420z00_1501 = BgL_res3512z00_2533;
									}}
									{	/* Inline/inline.scm 25 */
										obj_t BgL_auxz00_3049;

										BgL_objectz00_bglt BgL_auxz00_3047;

										BgL_auxz00_3049 = (obj_t) (BgL_arg3420z00_1501);
										BgL_auxz00_3047 =
											(BgL_objectz00_bglt) (BgL_new3116z00_1499);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_3047, BgL_auxz00_3049);
								}}
								BgL_auxz00_3022 = BgL_new3116z00_1499;
					}}}
					return (obj_t) (BgL_auxz00_3022);
				}
			}
		}
	}



/* object->struct-isfun3239 */
	obj_t BGl_objectzd2ze3structzd2isfun3239ze3zzinline_inlinez00(obj_t
		BgL_envz00_2614, obj_t BgL_obj3111z00_2615)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{
				BgL_isfunz00_bglt BgL_obj3111z00_1481;

				BgL_obj3111z00_1481 = (BgL_isfunz00_bglt) (BgL_obj3111z00_2615);
				{

					{	/* Inline/inline.scm 25 */
						obj_t BgL_res3112z00_1484;

						{	/* Inline/inline.scm 25 */
							obj_t BgL_nextzd2method3238zd2_1491;

							BgL_nextzd2method3238zd2_1491 =
								BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
								(BgL_objectz00_bglt) (BgL_obj3111z00_1481),
								BGl_objectzd2ze3structzd2envze3zz__objectz00,
								BGl_isfunz00zzinline_inlinez00);
							if (PROCEDUREP(BgL_nextzd2method3238zd2_1491))
								{	/* Inline/inline.scm 25 */
									BgL_res3112z00_1484 =
										PROCEDURE_ENTRY(BgL_nextzd2method3238zd2_1491)
										(BgL_nextzd2method3238zd2_1491,
										(obj_t) (BgL_obj3111z00_1481), BEOA);
								}
							else
								{	/* Inline/inline.scm 25 */
									BgL_res3112z00_1484 =
										BGl_objectzd2ze3structz31zz__objectz00(
										(BgL_objectz00_bglt) (BgL_obj3111z00_1481));
								}
						}
						{	/* Inline/inline.scm 25 */
							obj_t BgL_aux3113z00_1485;

							{	/* Inline/inline.scm 25 */
								obj_t BgL_keyz00_2495;

								BgL_keyz00_2495 = CNST_TABLE_REF(((long) 1));
								BgL_aux3113z00_1485 =
									make_struct(BgL_keyz00_2495, (int) (((long) 2)), BUNSPEC);
							}
							{	/* Inline/inline.scm 25 */
								BgL_nodez00_bglt BgL_arg3414z00_1487;

								{
									obj_t BgL_auxz00_3066;

									{	/* Inline/inline.scm 25 */
										BgL_objectz00_bglt BgL_auxz00_3067;

										BgL_auxz00_3067 =
											(BgL_objectz00_bglt) (BgL_obj3111z00_1481);
										BgL_auxz00_3066 = BGL_OBJECT_WIDENING(BgL_auxz00_3067);
									}
									BgL_arg3414z00_1487 =
										(((BgL_isfunz00_bglt) CREF(BgL_auxz00_3066))->
										BgL_originalzd2bodyzd2);
								}
								{	/* Inline/inline.scm 25 */
									obj_t BgL_auxz00_3073;

									int BgL_auxz00_3071;

									BgL_auxz00_3073 = (obj_t) (BgL_arg3414z00_1487);
									BgL_auxz00_3071 = (int) (((long) 0));
									STRUCT_SET(BgL_aux3113z00_1485, BgL_auxz00_3071,
										BgL_auxz00_3073);
							}}
							{	/* Inline/inline.scm 25 */
								obj_t BgL_arg3416z00_1489;

								{
									obj_t BgL_auxz00_3076;

									{	/* Inline/inline.scm 25 */
										BgL_objectz00_bglt BgL_auxz00_3077;

										BgL_auxz00_3077 =
											(BgL_objectz00_bglt) (BgL_obj3111z00_1481);
										BgL_auxz00_3076 = BGL_OBJECT_WIDENING(BgL_auxz00_3077);
									}
									BgL_arg3416z00_1489 =
										(((BgL_isfunz00_bglt) CREF(BgL_auxz00_3076))->
										BgL_recursivezd2callszd2);
								}
								{	/* Inline/inline.scm 25 */
									int BgL_auxz00_3081;

									BgL_auxz00_3081 = (int) (((long) 1));
									STRUCT_SET(BgL_aux3113z00_1485, BgL_auxz00_3081,
										BgL_arg3416z00_1489);
							}}
							{	/* Inline/inline.scm 25 */
								int BgL_auxz00_3084;

								BgL_auxz00_3084 = (int) (((long) 0));
								STRUCT_SET(BgL_res3112z00_1484, BgL_auxz00_3084,
									BgL_aux3113z00_1485);
							}
							{	/* Inline/inline.scm 25 */
								obj_t BgL_auxz00_3087;

								BgL_auxz00_3087 = STRUCT_KEY(BgL_res3112z00_1484);
								STRUCT_KEY_SET(BgL_aux3113z00_1485, BgL_auxz00_3087);
							}
							{	/* Inline/inline.scm 25 */
								obj_t BgL_kz00_2514;

								BgL_kz00_2514 = CNST_TABLE_REF(((long) 1));
								STRUCT_KEY_SET(BgL_res3112z00_1484, BgL_kz00_2514);
							}
							return BgL_res3112z00_1484;
						}
					}
				}
			}
		}
	}



/* inline-node-box-set!3237 */
	obj_t BGl_inlinezd2nodezd2boxzd2setz123237zc0zzinline_inlinez00(obj_t
		BgL_envz00_2616, obj_t BgL_nodez00_2617, obj_t BgL_kfactorz00_2618,
		obj_t BgL_stackz00_2619)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 229 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1469;

				obj_t BgL_kfactorz00_1470;

				obj_t BgL_stackz00_1471;

				{	/* Inline/inline.scm 230 */
					BgL_boxzd2setz12zc0_bglt BgL_auxz00_3093;

					BgL_nodez00_1469 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_2617);
					BgL_kfactorz00_1470 = BgL_kfactorz00_2618;
					BgL_stackz00_1471 = BgL_stackz00_2619;
					{	/* Inline/inline.scm 231 */
						BgL_nodez00_bglt BgL_arg3407z00_1475;

						{	/* Inline/inline.scm 231 */
							BgL_varz00_bglt BgL_arg3408z00_1476;

							BgL_arg3408z00_1476 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1469))->
								BgL_varz00);
							{	/* Inline/inline.scm 231 */
								BgL_nodez00_bglt BgL_res3506z00_2460;

								{	/* Inline/inline.scm 231 */
									BgL_nodez00_bglt BgL_nodez00_2432;

									long BgL_kfactorz00_2433;

									BgL_nodez00_2432 = (BgL_nodez00_bglt) (BgL_arg3408z00_1476);
									BgL_kfactorz00_2433 = (long) CINT(BgL_kfactorz00_1470);
									{	/* Inline/inline.scm 231 */
										obj_t BgL_method3196z00_2435;

										{	/* Inline/inline.scm 231 */
											BgL_objectz00_bglt BgL_objz00_2436;

											BgL_objz00_2436 = (BgL_objectz00_bglt) (BgL_nodez00_2432);
											{	/* Inline/inline.scm 231 */
												long BgL_objzd2classzd2numz00_2437;

												BgL_objzd2classzd2numz00_2437 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2436);
												{	/* Inline/inline.scm 231 */
													obj_t BgL_arg2356z00_2438;

													BgL_arg2356z00_2438 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 231 */
														obj_t BgL_arrayz00_2440;

														int BgL_offsetz00_2441;

														BgL_arrayz00_2440 = BgL_arg2356z00_2438;
														BgL_offsetz00_2441 =
															(int) (BgL_objzd2classzd2numz00_2437);
														{	/* Inline/inline.scm 231 */
															long BgL_offsetz00_2442;

															BgL_offsetz00_2442 =
																((long) (BgL_offsetz00_2441) - OBJECT_TYPE);
															{	/* Inline/inline.scm 231 */
																long BgL_modz00_2443;

																{	/* Inline/inline.scm 231 */
																	int BgL_arg2358z00_2444;

																	BgL_arg2358z00_2444 = (int) (((long) 8));
																	{	/* Inline/inline.scm 231 */
																		long BgL_auxz00_3105;

																		BgL_auxz00_3105 =
																			(long) (BgL_arg2358z00_2444);
																		BgL_modz00_2443 =
																			(BgL_offsetz00_2442 / BgL_auxz00_3105);
																}}
																{	/* Inline/inline.scm 231 */
																	long BgL_restz00_2445;

																	{	/* Inline/inline.scm 231 */
																		int BgL_arg2357z00_2446;

																		BgL_arg2357z00_2446 = (int) (((long) 8));
																		{	/* Inline/inline.scm 231 */
																			long BgL_auxz00_3109;

																			BgL_auxz00_3109 =
																				(long) (BgL_arg2357z00_2446);
																			BgL_restz00_2445 =
																				(BgL_offsetz00_2442 % BgL_auxz00_3109);
																	}}
																	{	/* Inline/inline.scm 231 */

																		BgL_method3196z00_2435 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2440,
																				(int) (BgL_modz00_2443)),
																			(int) (BgL_restz00_2445));
										}}}}}}}}
										BgL_res3506z00_2460 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_2435) (BgL_method3196z00_2435,
												(obj_t) (BgL_nodez00_2432), BINT(BgL_kfactorz00_2433),
												BgL_stackz00_1471, BEOA));
								}}
								BgL_arg3407z00_1475 = BgL_res3506z00_2460;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3121;

							BgL_auxz00_3121 = (BgL_varz00_bglt) (BgL_arg3407z00_1475);
							((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1469))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_3121), BUNSPEC);
					}}
					{	/* Inline/inline.scm 232 */
						BgL_nodez00_bglt BgL_arg3410z00_1477;

						{	/* Inline/inline.scm 232 */
							BgL_nodez00_bglt BgL_arg3411z00_1478;

							BgL_arg3411z00_1478 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1469))->
								BgL_valuez00);
							{	/* Inline/inline.scm 232 */
								BgL_nodez00_bglt BgL_res3509z00_2492;

								{	/* Inline/inline.scm 232 */
									long BgL_kfactorz00_2465;

									BgL_kfactorz00_2465 = (long) CINT(BgL_kfactorz00_1470);
									{	/* Inline/inline.scm 232 */
										obj_t BgL_method3196z00_2467;

										{	/* Inline/inline.scm 232 */
											BgL_objectz00_bglt BgL_objz00_2468;

											BgL_objz00_2468 =
												(BgL_objectz00_bglt) (BgL_arg3411z00_1478);
											{	/* Inline/inline.scm 232 */
												long BgL_objzd2classzd2numz00_2469;

												BgL_objzd2classzd2numz00_2469 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2468);
												{	/* Inline/inline.scm 232 */
													obj_t BgL_arg2356z00_2470;

													BgL_arg2356z00_2470 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 232 */
														obj_t BgL_arrayz00_2472;

														int BgL_offsetz00_2473;

														BgL_arrayz00_2472 = BgL_arg2356z00_2470;
														BgL_offsetz00_2473 =
															(int) (BgL_objzd2classzd2numz00_2469);
														{	/* Inline/inline.scm 232 */
															long BgL_offsetz00_2474;

															BgL_offsetz00_2474 =
																((long) (BgL_offsetz00_2473) - OBJECT_TYPE);
															{	/* Inline/inline.scm 232 */
																long BgL_modz00_2475;

																{	/* Inline/inline.scm 232 */
																	int BgL_arg2358z00_2476;

																	BgL_arg2358z00_2476 = (int) (((long) 8));
																	{	/* Inline/inline.scm 232 */
																		long BgL_auxz00_3134;

																		BgL_auxz00_3134 =
																			(long) (BgL_arg2358z00_2476);
																		BgL_modz00_2475 =
																			(BgL_offsetz00_2474 / BgL_auxz00_3134);
																}}
																{	/* Inline/inline.scm 232 */
																	long BgL_restz00_2477;

																	{	/* Inline/inline.scm 232 */
																		int BgL_arg2357z00_2478;

																		BgL_arg2357z00_2478 = (int) (((long) 8));
																		{	/* Inline/inline.scm 232 */
																			long BgL_auxz00_3138;

																			BgL_auxz00_3138 =
																				(long) (BgL_arg2357z00_2478);
																			BgL_restz00_2477 =
																				(BgL_offsetz00_2474 % BgL_auxz00_3138);
																	}}
																	{	/* Inline/inline.scm 232 */

																		BgL_method3196z00_2467 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2472,
																				(int) (BgL_modz00_2475)),
																			(int) (BgL_restz00_2477));
										}}}}}}}}
										BgL_res3509z00_2492 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_2467) (BgL_method3196z00_2467,
												(obj_t) (BgL_arg3411z00_1478),
												BINT(BgL_kfactorz00_2465), BgL_stackz00_1471, BEOA));
								}}
								BgL_arg3410z00_1477 = BgL_res3509z00_2492;
						}}
						((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1469))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3410z00_1477), BUNSPEC);
					}
					BgL_auxz00_3093 = BgL_nodez00_1469;
					return (obj_t) (BgL_auxz00_3093);
				}
			}
		}
	}



/* inline-node-box-ref3235 */
	obj_t BGl_inlinezd2nodezd2boxzd2ref3235zd2zzinline_inlinez00(obj_t
		BgL_envz00_2620, obj_t BgL_nodez00_2621, obj_t BgL_kfactorz00_2622,
		obj_t BgL_stackz00_2623)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 222 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1460;

				obj_t BgL_kfactorz00_1461;

				obj_t BgL_stackz00_1462;

				{	/* Inline/inline.scm 223 */
					BgL_boxzd2refzd2_bglt BgL_auxz00_3153;

					BgL_nodez00_1460 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_2621);
					BgL_kfactorz00_1461 = BgL_kfactorz00_2622;
					BgL_stackz00_1462 = BgL_stackz00_2623;
					{	/* Inline/inline.scm 223 */
						BgL_nodez00_bglt BgL_arg3404z00_2397;

						{	/* Inline/inline.scm 223 */
							BgL_varz00_bglt BgL_arg3405z00_2398;

							BgL_arg3405z00_2398 =
								(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1460))->BgL_varz00);
							{	/* Inline/inline.scm 223 */
								BgL_nodez00_bglt BgL_res3503z00_2428;

								{	/* Inline/inline.scm 223 */
									BgL_nodez00_bglt BgL_nodez00_2400;

									long BgL_kfactorz00_2401;

									BgL_nodez00_2400 = (BgL_nodez00_bglt) (BgL_arg3405z00_2398);
									BgL_kfactorz00_2401 = (long) CINT(BgL_kfactorz00_1461);
									{	/* Inline/inline.scm 223 */
										obj_t BgL_method3196z00_2403;

										{	/* Inline/inline.scm 223 */
											BgL_objectz00_bglt BgL_objz00_2404;

											BgL_objz00_2404 = (BgL_objectz00_bglt) (BgL_nodez00_2400);
											{	/* Inline/inline.scm 223 */
												long BgL_objzd2classzd2numz00_2405;

												BgL_objzd2classzd2numz00_2405 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2404);
												{	/* Inline/inline.scm 223 */
													obj_t BgL_arg2356z00_2406;

													BgL_arg2356z00_2406 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 223 */
														obj_t BgL_arrayz00_2408;

														int BgL_offsetz00_2409;

														BgL_arrayz00_2408 = BgL_arg2356z00_2406;
														BgL_offsetz00_2409 =
															(int) (BgL_objzd2classzd2numz00_2405);
														{	/* Inline/inline.scm 223 */
															long BgL_offsetz00_2410;

															BgL_offsetz00_2410 =
																((long) (BgL_offsetz00_2409) - OBJECT_TYPE);
															{	/* Inline/inline.scm 223 */
																long BgL_modz00_2411;

																{	/* Inline/inline.scm 223 */
																	int BgL_arg2358z00_2412;

																	BgL_arg2358z00_2412 = (int) (((long) 8));
																	{	/* Inline/inline.scm 223 */
																		long BgL_auxz00_3165;

																		BgL_auxz00_3165 =
																			(long) (BgL_arg2358z00_2412);
																		BgL_modz00_2411 =
																			(BgL_offsetz00_2410 / BgL_auxz00_3165);
																}}
																{	/* Inline/inline.scm 223 */
																	long BgL_restz00_2413;

																	{	/* Inline/inline.scm 223 */
																		int BgL_arg2357z00_2414;

																		BgL_arg2357z00_2414 = (int) (((long) 8));
																		{	/* Inline/inline.scm 223 */
																			long BgL_auxz00_3169;

																			BgL_auxz00_3169 =
																				(long) (BgL_arg2357z00_2414);
																			BgL_restz00_2413 =
																				(BgL_offsetz00_2410 % BgL_auxz00_3169);
																	}}
																	{	/* Inline/inline.scm 223 */

																		BgL_method3196z00_2403 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2408,
																				(int) (BgL_modz00_2411)),
																			(int) (BgL_restz00_2413));
										}}}}}}}}
										BgL_res3503z00_2428 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_2403) (BgL_method3196z00_2403,
												(obj_t) (BgL_nodez00_2400), BINT(BgL_kfactorz00_2401),
												BgL_stackz00_1462, BEOA));
								}}
								BgL_arg3404z00_2397 = BgL_res3503z00_2428;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3181;

							BgL_auxz00_3181 = (BgL_varz00_bglt) (BgL_arg3404z00_2397);
							((((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1460))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_3181), BUNSPEC);
					}}
					BgL_auxz00_3153 = BgL_nodez00_1460;
					return (obj_t) (BgL_auxz00_3153);
				}
			}
		}
	}



/* inline-node-make-box3232 */
	obj_t BGl_inlinezd2nodezd2makezd2box3232zd2zzinline_inlinez00(obj_t
		BgL_envz00_2624, obj_t BgL_nodez00_2625, obj_t BgL_kfactorz00_2626,
		obj_t BgL_stackz00_2627)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 215 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1451;

				obj_t BgL_kfactorz00_1452;

				obj_t BgL_stackz00_1453;

				{	/* Inline/inline.scm 216 */
					BgL_makezd2boxzd2_bglt BgL_auxz00_3186;

					BgL_nodez00_1451 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_2625);
					BgL_kfactorz00_1452 = BgL_kfactorz00_2626;
					BgL_stackz00_1453 = BgL_stackz00_2627;
					{	/* Inline/inline.scm 216 */
						BgL_nodez00_bglt BgL_arg3401z00_2363;

						{	/* Inline/inline.scm 216 */
							BgL_nodez00_bglt BgL_arg3402z00_2364;

							BgL_arg3402z00_2364 =
								(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1451))->
								BgL_valuez00);
							{	/* Inline/inline.scm 216 */
								BgL_nodez00_bglt BgL_res3500z00_2394;

								{	/* Inline/inline.scm 216 */
									long BgL_kfactorz00_2367;

									BgL_kfactorz00_2367 = (long) CINT(BgL_kfactorz00_1452);
									{	/* Inline/inline.scm 216 */
										obj_t BgL_method3196z00_2369;

										{	/* Inline/inline.scm 216 */
											BgL_objectz00_bglt BgL_objz00_2370;

											BgL_objz00_2370 =
												(BgL_objectz00_bglt) (BgL_arg3402z00_2364);
											{	/* Inline/inline.scm 216 */
												long BgL_objzd2classzd2numz00_2371;

												BgL_objzd2classzd2numz00_2371 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2370);
												{	/* Inline/inline.scm 216 */
													obj_t BgL_arg2356z00_2372;

													BgL_arg2356z00_2372 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 216 */
														obj_t BgL_arrayz00_2374;

														int BgL_offsetz00_2375;

														BgL_arrayz00_2374 = BgL_arg2356z00_2372;
														BgL_offsetz00_2375 =
															(int) (BgL_objzd2classzd2numz00_2371);
														{	/* Inline/inline.scm 216 */
															long BgL_offsetz00_2376;

															BgL_offsetz00_2376 =
																((long) (BgL_offsetz00_2375) - OBJECT_TYPE);
															{	/* Inline/inline.scm 216 */
																long BgL_modz00_2377;

																{	/* Inline/inline.scm 216 */
																	int BgL_arg2358z00_2378;

																	BgL_arg2358z00_2378 = (int) (((long) 8));
																	{	/* Inline/inline.scm 216 */
																		long BgL_auxz00_3197;

																		BgL_auxz00_3197 =
																			(long) (BgL_arg2358z00_2378);
																		BgL_modz00_2377 =
																			(BgL_offsetz00_2376 / BgL_auxz00_3197);
																}}
																{	/* Inline/inline.scm 216 */
																	long BgL_restz00_2379;

																	{	/* Inline/inline.scm 216 */
																		int BgL_arg2357z00_2380;

																		BgL_arg2357z00_2380 = (int) (((long) 8));
																		{	/* Inline/inline.scm 216 */
																			long BgL_auxz00_3201;

																			BgL_auxz00_3201 =
																				(long) (BgL_arg2357z00_2380);
																			BgL_restz00_2379 =
																				(BgL_offsetz00_2376 % BgL_auxz00_3201);
																	}}
																	{	/* Inline/inline.scm 216 */

																		BgL_method3196z00_2369 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2374,
																				(int) (BgL_modz00_2377)),
																			(int) (BgL_restz00_2379));
										}}}}}}}}
										BgL_res3500z00_2394 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_2369) (BgL_method3196z00_2369,
												(obj_t) (BgL_arg3402z00_2364),
												BINT(BgL_kfactorz00_2367), BgL_stackz00_1453, BEOA));
								}}
								BgL_arg3401z00_2363 = BgL_res3500z00_2394;
						}}
						((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1451))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3401z00_2363), BUNSPEC);
					}
					BgL_auxz00_3186 = BgL_nodez00_1451;
					return (obj_t) (BgL_auxz00_3186);
				}
			}
		}
	}



/* inline-node-jump-ex-3230 */
	obj_t BGl_inlinezd2nodezd2jumpzd2exzd23230z00zzinline_inlinez00(obj_t
		BgL_envz00_2628, obj_t BgL_nodez00_2629, obj_t BgL_kfactorz00_2630,
		obj_t BgL_stackz00_2631)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 206 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1439;

				obj_t BgL_kfactorz00_1440;

				obj_t BgL_stackz00_1441;

				{	/* Inline/inline.scm 207 */
					BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_3216;

					BgL_nodez00_1439 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_2629);
					BgL_kfactorz00_1440 = BgL_kfactorz00_2630;
					BgL_stackz00_1441 = BgL_stackz00_2631;
					{	/* Inline/inline.scm 208 */
						BgL_nodez00_bglt BgL_arg3396z00_1445;

						{	/* Inline/inline.scm 208 */
							BgL_nodez00_bglt BgL_arg3397z00_1446;

							BgL_arg3397z00_1446 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1439))->
								BgL_exitz00);
							{	/* Inline/inline.scm 208 */
								BgL_nodez00_bglt BgL_res3494z00_2328;

								{	/* Inline/inline.scm 208 */
									long BgL_kfactorz00_2301;

									BgL_kfactorz00_2301 = (long) CINT(BgL_kfactorz00_1440);
									{	/* Inline/inline.scm 208 */
										obj_t BgL_method3196z00_2303;

										{	/* Inline/inline.scm 208 */
											BgL_objectz00_bglt BgL_objz00_2304;

											BgL_objz00_2304 =
												(BgL_objectz00_bglt) (BgL_arg3397z00_1446);
											{	/* Inline/inline.scm 208 */
												long BgL_objzd2classzd2numz00_2305;

												BgL_objzd2classzd2numz00_2305 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2304);
												{	/* Inline/inline.scm 208 */
													obj_t BgL_arg2356z00_2306;

													BgL_arg2356z00_2306 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 208 */
														obj_t BgL_arrayz00_2308;

														int BgL_offsetz00_2309;

														BgL_arrayz00_2308 = BgL_arg2356z00_2306;
														BgL_offsetz00_2309 =
															(int) (BgL_objzd2classzd2numz00_2305);
														{	/* Inline/inline.scm 208 */
															long BgL_offsetz00_2310;

															BgL_offsetz00_2310 =
																((long) (BgL_offsetz00_2309) - OBJECT_TYPE);
															{	/* Inline/inline.scm 208 */
																long BgL_modz00_2311;

																{	/* Inline/inline.scm 208 */
																	int BgL_arg2358z00_2312;

																	BgL_arg2358z00_2312 = (int) (((long) 8));
																	{	/* Inline/inline.scm 208 */
																		long BgL_auxz00_3227;

																		BgL_auxz00_3227 =
																			(long) (BgL_arg2358z00_2312);
																		BgL_modz00_2311 =
																			(BgL_offsetz00_2310 / BgL_auxz00_3227);
																}}
																{	/* Inline/inline.scm 208 */
																	long BgL_restz00_2313;

																	{	/* Inline/inline.scm 208 */
																		int BgL_arg2357z00_2314;

																		BgL_arg2357z00_2314 = (int) (((long) 8));
																		{	/* Inline/inline.scm 208 */
																			long BgL_auxz00_3231;

																			BgL_auxz00_3231 =
																				(long) (BgL_arg2357z00_2314);
																			BgL_restz00_2313 =
																				(BgL_offsetz00_2310 % BgL_auxz00_3231);
																	}}
																	{	/* Inline/inline.scm 208 */

																		BgL_method3196z00_2303 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2308,
																				(int) (BgL_modz00_2311)),
																			(int) (BgL_restz00_2313));
										}}}}}}}}
										BgL_res3494z00_2328 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_2303) (BgL_method3196z00_2303,
												(obj_t) (BgL_arg3397z00_1446),
												BINT(BgL_kfactorz00_2301), BgL_stackz00_1441, BEOA));
								}}
								BgL_arg3396z00_1445 = BgL_res3494z00_2328;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1439))->
								BgL_exitz00) =
							((BgL_nodez00_bglt) BgL_arg3396z00_1445), BUNSPEC);
					}
					{	/* Inline/inline.scm 209 */
						BgL_nodez00_bglt BgL_arg3398z00_1447;

						{	/* Inline/inline.scm 209 */
							BgL_nodez00_bglt BgL_arg3399z00_1448;

							BgL_arg3399z00_1448 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1439))->
								BgL_valuez00);
							{	/* Inline/inline.scm 209 */
								BgL_nodez00_bglt BgL_res3497z00_2360;

								{	/* Inline/inline.scm 209 */
									long BgL_kfactorz00_2333;

									BgL_kfactorz00_2333 = (long) CINT(BgL_kfactorz00_1440);
									{	/* Inline/inline.scm 209 */
										obj_t BgL_method3196z00_2335;

										{	/* Inline/inline.scm 209 */
											BgL_objectz00_bglt BgL_objz00_2336;

											BgL_objz00_2336 =
												(BgL_objectz00_bglt) (BgL_arg3399z00_1448);
											{	/* Inline/inline.scm 209 */
												long BgL_objzd2classzd2numz00_2337;

												BgL_objzd2classzd2numz00_2337 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2336);
												{	/* Inline/inline.scm 209 */
													obj_t BgL_arg2356z00_2338;

													BgL_arg2356z00_2338 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 209 */
														obj_t BgL_arrayz00_2340;

														int BgL_offsetz00_2341;

														BgL_arrayz00_2340 = BgL_arg2356z00_2338;
														BgL_offsetz00_2341 =
															(int) (BgL_objzd2classzd2numz00_2337);
														{	/* Inline/inline.scm 209 */
															long BgL_offsetz00_2342;

															BgL_offsetz00_2342 =
																((long) (BgL_offsetz00_2341) - OBJECT_TYPE);
															{	/* Inline/inline.scm 209 */
																long BgL_modz00_2343;

																{	/* Inline/inline.scm 209 */
																	int BgL_arg2358z00_2344;

																	BgL_arg2358z00_2344 = (int) (((long) 8));
																	{	/* Inline/inline.scm 209 */
																		long BgL_auxz00_3254;

																		BgL_auxz00_3254 =
																			(long) (BgL_arg2358z00_2344);
																		BgL_modz00_2343 =
																			(BgL_offsetz00_2342 / BgL_auxz00_3254);
																}}
																{	/* Inline/inline.scm 209 */
																	long BgL_restz00_2345;

																	{	/* Inline/inline.scm 209 */
																		int BgL_arg2357z00_2346;

																		BgL_arg2357z00_2346 = (int) (((long) 8));
																		{	/* Inline/inline.scm 209 */
																			long BgL_auxz00_3258;

																			BgL_auxz00_3258 =
																				(long) (BgL_arg2357z00_2346);
																			BgL_restz00_2345 =
																				(BgL_offsetz00_2342 % BgL_auxz00_3258);
																	}}
																	{	/* Inline/inline.scm 209 */

																		BgL_method3196z00_2335 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2340,
																				(int) (BgL_modz00_2343)),
																			(int) (BgL_restz00_2345));
										}}}}}}}}
										BgL_res3497z00_2360 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_2335) (BgL_method3196z00_2335,
												(obj_t) (BgL_arg3399z00_1448),
												BINT(BgL_kfactorz00_2333), BgL_stackz00_1441, BEOA));
								}}
								BgL_arg3398z00_1447 = BgL_res3497z00_2360;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1439))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3398z00_1447), BUNSPEC);
					}
					BgL_auxz00_3216 = BgL_nodez00_1439;
					return (obj_t) (BgL_auxz00_3216);
				}
			}
		}
	}



/* inline-node-set-ex-i3228 */
	obj_t BGl_inlinezd2nodezd2setzd2exzd2i3228z00zzinline_inlinez00(obj_t
		BgL_envz00_2632, obj_t BgL_nodez00_2633, obj_t BgL_kfactorz00_2634,
		obj_t BgL_stackz00_2635)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 199 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1430;

				obj_t BgL_kfactorz00_1431;

				obj_t BgL_stackz00_1432;

				{	/* Inline/inline.scm 200 */
					BgL_setzd2exzd2itz00_bglt BgL_auxz00_3273;

					BgL_nodez00_1430 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_2633);
					BgL_kfactorz00_1431 = BgL_kfactorz00_2634;
					BgL_stackz00_1432 = BgL_stackz00_2635;
					{	/* Inline/inline.scm 200 */
						BgL_nodez00_bglt BgL_arg3393z00_2265;

						{	/* Inline/inline.scm 200 */
							BgL_nodez00_bglt BgL_arg3394z00_2266;

							BgL_arg3394z00_2266 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1430))->
								BgL_bodyz00);
							{	/* Inline/inline.scm 200 */
								BgL_nodez00_bglt BgL_res3491z00_2296;

								{	/* Inline/inline.scm 200 */
									long BgL_kfactorz00_2269;

									BgL_kfactorz00_2269 = (long) CINT(BgL_kfactorz00_1431);
									{	/* Inline/inline.scm 200 */
										obj_t BgL_method3196z00_2271;

										{	/* Inline/inline.scm 200 */
											BgL_objectz00_bglt BgL_objz00_2272;

											BgL_objz00_2272 =
												(BgL_objectz00_bglt) (BgL_arg3394z00_2266);
											{	/* Inline/inline.scm 200 */
												long BgL_objzd2classzd2numz00_2273;

												BgL_objzd2classzd2numz00_2273 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2272);
												{	/* Inline/inline.scm 200 */
													obj_t BgL_arg2356z00_2274;

													BgL_arg2356z00_2274 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 200 */
														obj_t BgL_arrayz00_2276;

														int BgL_offsetz00_2277;

														BgL_arrayz00_2276 = BgL_arg2356z00_2274;
														BgL_offsetz00_2277 =
															(int) (BgL_objzd2classzd2numz00_2273);
														{	/* Inline/inline.scm 200 */
															long BgL_offsetz00_2278;

															BgL_offsetz00_2278 =
																((long) (BgL_offsetz00_2277) - OBJECT_TYPE);
															{	/* Inline/inline.scm 200 */
																long BgL_modz00_2279;

																{	/* Inline/inline.scm 200 */
																	int BgL_arg2358z00_2280;

																	BgL_arg2358z00_2280 = (int) (((long) 8));
																	{	/* Inline/inline.scm 200 */
																		long BgL_auxz00_3284;

																		BgL_auxz00_3284 =
																			(long) (BgL_arg2358z00_2280);
																		BgL_modz00_2279 =
																			(BgL_offsetz00_2278 / BgL_auxz00_3284);
																}}
																{	/* Inline/inline.scm 200 */
																	long BgL_restz00_2281;

																	{	/* Inline/inline.scm 200 */
																		int BgL_arg2357z00_2282;

																		BgL_arg2357z00_2282 = (int) (((long) 8));
																		{	/* Inline/inline.scm 200 */
																			long BgL_auxz00_3288;

																			BgL_auxz00_3288 =
																				(long) (BgL_arg2357z00_2282);
																			BgL_restz00_2281 =
																				(BgL_offsetz00_2278 % BgL_auxz00_3288);
																	}}
																	{	/* Inline/inline.scm 200 */

																		BgL_method3196z00_2271 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2276,
																				(int) (BgL_modz00_2279)),
																			(int) (BgL_restz00_2281));
										}}}}}}}}
										BgL_res3491z00_2296 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_2271) (BgL_method3196z00_2271,
												(obj_t) (BgL_arg3394z00_2266),
												BINT(BgL_kfactorz00_2269), BgL_stackz00_1432, BEOA));
								}}
								BgL_arg3393z00_2265 = BgL_res3491z00_2296;
						}}
						((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1430))->
								BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3393z00_2265), BUNSPEC);
					}
					BgL_auxz00_3273 = BgL_nodez00_1430;
					return (obj_t) (BgL_auxz00_3273);
				}
			}
		}
	}



/* inline-node-let-var3226 */
	obj_t BGl_inlinezd2nodezd2letzd2var3226zd2zzinline_inlinez00(obj_t
		BgL_envz00_2636, obj_t BgL_nodez00_2637, obj_t BgL_kfactorz00_2638,
		obj_t BgL_stackz00_2639)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 189 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1413;

				obj_t BgL_kfactorz00_1414;

				obj_t BgL_stackz00_1415;

				{	/* Inline/inline.scm 190 */
					BgL_letzd2varzd2_bglt BgL_auxz00_3303;

					BgL_nodez00_1413 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_2637);
					BgL_kfactorz00_1414 = BgL_kfactorz00_2638;
					BgL_stackz00_1415 = BgL_stackz00_2639;
					{	/* Inline/inline.scm 190 */
						obj_t BgL_g3193z00_1418;

						BgL_g3193z00_1418 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1413))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3191z00_1419;

							BgL_l3191z00_1419 = BgL_g3193z00_1418;
						BgL_forzd2each3192zd2_1420:
							if (PAIRP(BgL_l3191z00_1419))
								{	/* Inline/inline.scm 192 */
									{	/* Inline/inline.scm 191 */
										obj_t BgL_bindingz00_1422;

										BgL_bindingz00_1422 = CAR(BgL_l3191z00_1419);
										{	/* Inline/inline.scm 191 */
											BgL_nodez00_bglt BgL_arg3387z00_1423;

											{	/* Inline/inline.scm 191 */
												obj_t BgL_arg3388z00_1424;

												BgL_arg3388z00_1424 = CDR(BgL_bindingz00_1422);
												{	/* Inline/inline.scm 191 */
													BgL_nodez00_bglt BgL_res3485z00_2229;

													{	/* Inline/inline.scm 191 */
														BgL_nodez00_bglt BgL_nodez00_2201;

														long BgL_kfactorz00_2202;

														BgL_nodez00_2201 =
															(BgL_nodez00_bglt) (BgL_arg3388z00_1424);
														BgL_kfactorz00_2202 =
															(long) CINT(BgL_kfactorz00_1414);
														{	/* Inline/inline.scm 191 */
															obj_t BgL_method3196z00_2204;

															{	/* Inline/inline.scm 191 */
																BgL_objectz00_bglt BgL_objz00_2205;

																BgL_objz00_2205 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2201);
																{	/* Inline/inline.scm 191 */
																	long BgL_objzd2classzd2numz00_2206;

																	BgL_objzd2classzd2numz00_2206 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2205);
																	{	/* Inline/inline.scm 191 */
																		obj_t BgL_arg2356z00_2207;

																		BgL_arg2356z00_2207 =
																			PROCEDURE_REF
																			(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
																			(int) (((long) 1)));
																		{	/* Inline/inline.scm 191 */
																			obj_t BgL_arrayz00_2209;

																			int BgL_offsetz00_2210;

																			BgL_arrayz00_2209 = BgL_arg2356z00_2207;
																			BgL_offsetz00_2210 =
																				(int) (BgL_objzd2classzd2numz00_2206);
																			{	/* Inline/inline.scm 191 */
																				long BgL_offsetz00_2211;

																				BgL_offsetz00_2211 =
																					(
																					(long) (BgL_offsetz00_2210) -
																					OBJECT_TYPE);
																				{	/* Inline/inline.scm 191 */
																					long BgL_modz00_2212;

																					{	/* Inline/inline.scm 191 */
																						int BgL_arg2358z00_2213;

																						BgL_arg2358z00_2213 =
																							(int) (((long) 8));
																						{	/* Inline/inline.scm 191 */
																							long BgL_auxz00_3319;

																							BgL_auxz00_3319 =
																								(long) (BgL_arg2358z00_2213);
																							BgL_modz00_2212 =
																								(BgL_offsetz00_2211 /
																								BgL_auxz00_3319);
																					}}
																					{	/* Inline/inline.scm 191 */
																						long BgL_restz00_2214;

																						{	/* Inline/inline.scm 191 */
																							int BgL_arg2357z00_2215;

																							BgL_arg2357z00_2215 =
																								(int) (((long) 8));
																							{	/* Inline/inline.scm 191 */
																								long BgL_auxz00_3323;

																								BgL_auxz00_3323 =
																									(long) (BgL_arg2357z00_2215);
																								BgL_restz00_2214 =
																									(BgL_offsetz00_2211 %
																									BgL_auxz00_3323);
																						}}
																						{	/* Inline/inline.scm 191 */

																							BgL_method3196z00_2204 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2209,
																									(int) (BgL_modz00_2212)),
																								(int) (BgL_restz00_2214));
															}}}}}}}}
															BgL_res3485z00_2229 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3196z00_2204)
																(BgL_method3196z00_2204,
																	(obj_t) (BgL_nodez00_2201),
																	BINT(BgL_kfactorz00_2202), BgL_stackz00_1415,
																	BEOA));
													}}
													BgL_arg3387z00_1423 = BgL_res3485z00_2229;
											}}
											{	/* Inline/inline.scm 191 */
												obj_t BgL_auxz00_3335;

												BgL_auxz00_3335 = (obj_t) (BgL_arg3387z00_1423);
												SET_CDR(BgL_bindingz00_1422, BgL_auxz00_3335);
									}}}
									{
										obj_t BgL_l3191z00_3338;

										BgL_l3191z00_3338 = CDR(BgL_l3191z00_1419);
										BgL_l3191z00_1419 = BgL_l3191z00_3338;
										goto BgL_forzd2each3192zd2_1420;
									}
								}
							else
								{	/* Inline/inline.scm 192 */
									((bool_t) 1);
								}
						}
					}
					{	/* Inline/inline.scm 193 */
						BgL_nodez00_bglt BgL_arg3390z00_1426;

						{	/* Inline/inline.scm 193 */
							BgL_nodez00_bglt BgL_arg3391z00_1427;

							BgL_arg3391z00_1427 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1413))->BgL_bodyz00);
							{	/* Inline/inline.scm 193 */
								BgL_nodez00_bglt BgL_res3488z00_2262;

								{	/* Inline/inline.scm 193 */
									long BgL_kfactorz00_2235;

									BgL_kfactorz00_2235 = (long) CINT(BgL_kfactorz00_1414);
									{	/* Inline/inline.scm 193 */
										obj_t BgL_method3196z00_2237;

										{	/* Inline/inline.scm 193 */
											BgL_objectz00_bglt BgL_objz00_2238;

											BgL_objz00_2238 =
												(BgL_objectz00_bglt) (BgL_arg3391z00_1427);
											{	/* Inline/inline.scm 193 */
												long BgL_objzd2classzd2numz00_2239;

												BgL_objzd2classzd2numz00_2239 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2238);
												{	/* Inline/inline.scm 193 */
													obj_t BgL_arg2356z00_2240;

													BgL_arg2356z00_2240 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 193 */
														obj_t BgL_arrayz00_2242;

														int BgL_offsetz00_2243;

														BgL_arrayz00_2242 = BgL_arg2356z00_2240;
														BgL_offsetz00_2243 =
															(int) (BgL_objzd2classzd2numz00_2239);
														{	/* Inline/inline.scm 193 */
															long BgL_offsetz00_2244;

															BgL_offsetz00_2244 =
																((long) (BgL_offsetz00_2243) - OBJECT_TYPE);
															{	/* Inline/inline.scm 193 */
																long BgL_modz00_2245;

																{	/* Inline/inline.scm 193 */
																	int BgL_arg2358z00_2246;

																	BgL_arg2358z00_2246 = (int) (((long) 8));
																	{	/* Inline/inline.scm 193 */
																		long BgL_auxz00_3350;

																		BgL_auxz00_3350 =
																			(long) (BgL_arg2358z00_2246);
																		BgL_modz00_2245 =
																			(BgL_offsetz00_2244 / BgL_auxz00_3350);
																}}
																{	/* Inline/inline.scm 193 */
																	long BgL_restz00_2247;

																	{	/* Inline/inline.scm 193 */
																		int BgL_arg2357z00_2248;

																		BgL_arg2357z00_2248 = (int) (((long) 8));
																		{	/* Inline/inline.scm 193 */
																			long BgL_auxz00_3354;

																			BgL_auxz00_3354 =
																				(long) (BgL_arg2357z00_2248);
																			BgL_restz00_2247 =
																				(BgL_offsetz00_2244 % BgL_auxz00_3354);
																	}}
																	{	/* Inline/inline.scm 193 */

																		BgL_method3196z00_2237 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2242,
																				(int) (BgL_modz00_2245)),
																			(int) (BgL_restz00_2247));
										}}}}}}}}
										BgL_res3488z00_2262 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_2237) (BgL_method3196z00_2237,
												(obj_t) (BgL_arg3391z00_1427),
												BINT(BgL_kfactorz00_2235), BgL_stackz00_1415, BEOA));
								}}
								BgL_arg3390z00_1426 = BgL_res3488z00_2262;
						}}
						((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1413))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3390z00_1426), BUNSPEC);
					}
					BgL_auxz00_3303 = BgL_nodez00_1413;
					return (obj_t) (BgL_auxz00_3303);
				}
			}
		}
	}



/* inline-node-let-fun3224 */
	obj_t BGl_inlinezd2nodezd2letzd2fun3224zd2zzinline_inlinez00(obj_t
		BgL_envz00_2640, obj_t BgL_nodez00_2641, obj_t BgL_kfactorz00_2642,
		obj_t BgL_stackz00_2643)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 179 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1398;

				obj_t BgL_kfactorz00_1399;

				obj_t BgL_stackz00_1400;

				{	/* Inline/inline.scm 180 */
					BgL_letzd2funzd2_bglt BgL_auxz00_3369;

					BgL_nodez00_1398 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_2641);
					BgL_kfactorz00_1399 = BgL_kfactorz00_2642;
					BgL_stackz00_1400 = BgL_stackz00_2643;
					{	/* Inline/inline.scm 180 */
						BgL_nodez00_bglt BgL_arg3381z00_1403;

						{	/* Inline/inline.scm 180 */
							BgL_nodez00_bglt BgL_arg3382z00_1404;

							BgL_arg3382z00_1404 =
								(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1398))->BgL_bodyz00);
							{	/* Inline/inline.scm 180 */
								BgL_nodez00_bglt BgL_res3482z00_2190;

								{	/* Inline/inline.scm 180 */
									long BgL_kfactorz00_2163;

									BgL_kfactorz00_2163 = (long) CINT(BgL_kfactorz00_1399);
									{	/* Inline/inline.scm 180 */
										obj_t BgL_method3196z00_2165;

										{	/* Inline/inline.scm 180 */
											BgL_objectz00_bglt BgL_objz00_2166;

											BgL_objz00_2166 =
												(BgL_objectz00_bglt) (BgL_arg3382z00_1404);
											{	/* Inline/inline.scm 180 */
												long BgL_objzd2classzd2numz00_2167;

												BgL_objzd2classzd2numz00_2167 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2166);
												{	/* Inline/inline.scm 180 */
													obj_t BgL_arg2356z00_2168;

													BgL_arg2356z00_2168 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 180 */
														obj_t BgL_arrayz00_2170;

														int BgL_offsetz00_2171;

														BgL_arrayz00_2170 = BgL_arg2356z00_2168;
														BgL_offsetz00_2171 =
															(int) (BgL_objzd2classzd2numz00_2167);
														{	/* Inline/inline.scm 180 */
															long BgL_offsetz00_2172;

															BgL_offsetz00_2172 =
																((long) (BgL_offsetz00_2171) - OBJECT_TYPE);
															{	/* Inline/inline.scm 180 */
																long BgL_modz00_2173;

																{	/* Inline/inline.scm 180 */
																	int BgL_arg2358z00_2174;

																	BgL_arg2358z00_2174 = (int) (((long) 8));
																	{	/* Inline/inline.scm 180 */
																		long BgL_auxz00_3380;

																		BgL_auxz00_3380 =
																			(long) (BgL_arg2358z00_2174);
																		BgL_modz00_2173 =
																			(BgL_offsetz00_2172 / BgL_auxz00_3380);
																}}
																{	/* Inline/inline.scm 180 */
																	long BgL_restz00_2175;

																	{	/* Inline/inline.scm 180 */
																		int BgL_arg2357z00_2176;

																		BgL_arg2357z00_2176 = (int) (((long) 8));
																		{	/* Inline/inline.scm 180 */
																			long BgL_auxz00_3384;

																			BgL_auxz00_3384 =
																				(long) (BgL_arg2357z00_2176);
																			BgL_restz00_2175 =
																				(BgL_offsetz00_2172 % BgL_auxz00_3384);
																	}}
																	{	/* Inline/inline.scm 180 */

																		BgL_method3196z00_2165 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2170,
																				(int) (BgL_modz00_2173)),
																			(int) (BgL_restz00_2175));
										}}}}}}}}
										BgL_res3482z00_2190 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_2165) (BgL_method3196z00_2165,
												(obj_t) (BgL_arg3382z00_1404),
												BINT(BgL_kfactorz00_2163), BgL_stackz00_1400, BEOA));
								}}
								BgL_arg3381z00_1403 = BgL_res3482z00_2190;
						}}
						((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1398))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3381z00_1403), BUNSPEC);
					}
					{	/* Inline/inline.scm 181 */
						obj_t BgL_g3190z00_1405;

						BgL_g3190z00_1405 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1398))->BgL_localsz00);
						{
							obj_t BgL_l3188z00_1406;

							BgL_l3188z00_1406 = BgL_g3190z00_1405;
						BgL_forzd2each3189zd2_1407:
							if (PAIRP(BgL_l3188z00_1406))
								{	/* Inline/inline.scm 183 */
									{	/* Inline/inline.scm 182 */
										obj_t BgL_localz00_1409;

										BgL_localz00_1409 = CAR(BgL_l3188z00_1406);
										BGl_inlinezd2sfunz12zc0zzinline_inlinez00(
											(BgL_variablez00_bglt) (BgL_localz00_1409),
											(long) CINT(BgL_kfactorz00_1399), BgL_stackz00_1400);
									}
									{
										obj_t BgL_l3188z00_3404;

										BgL_l3188z00_3404 = CDR(BgL_l3188z00_1406);
										BgL_l3188z00_1406 = BgL_l3188z00_3404;
										goto BgL_forzd2each3189zd2_1407;
									}
								}
							else
								{	/* Inline/inline.scm 183 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_3369 = BgL_nodez00_1398;
					return (obj_t) (BgL_auxz00_3369);
				}
			}
		}
	}



/* inline-node-select3222 */
	obj_t BGl_inlinezd2nodezd2select3222z00zzinline_inlinez00(obj_t
		BgL_envz00_2644, obj_t BgL_nodez00_2645, obj_t BgL_kfactorz00_2646,
		obj_t BgL_stackz00_2647)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 169 */
			{
				BgL_selectz00_bglt BgL_nodez00_1381;

				obj_t BgL_kfactorz00_1382;

				obj_t BgL_stackz00_1383;

				{	/* Inline/inline.scm 170 */
					BgL_selectz00_bglt BgL_auxz00_3408;

					BgL_nodez00_1381 = (BgL_selectz00_bglt) (BgL_nodez00_2645);
					BgL_kfactorz00_1382 = BgL_kfactorz00_2646;
					BgL_stackz00_1383 = BgL_stackz00_2647;
					{	/* Inline/inline.scm 170 */
						BgL_nodez00_bglt BgL_arg3374z00_1386;

						{	/* Inline/inline.scm 170 */
							BgL_nodez00_bglt BgL_arg3375z00_1387;

							BgL_arg3375z00_1387 =
								(((BgL_selectz00_bglt) CREF(BgL_nodez00_1381))->BgL_testz00);
							{	/* Inline/inline.scm 170 */
								BgL_nodez00_bglt BgL_res3476z00_2122;

								{	/* Inline/inline.scm 170 */
									long BgL_kfactorz00_2095;

									BgL_kfactorz00_2095 = (long) CINT(BgL_kfactorz00_1382);
									{	/* Inline/inline.scm 170 */
										obj_t BgL_method3196z00_2097;

										{	/* Inline/inline.scm 170 */
											BgL_objectz00_bglt BgL_objz00_2098;

											BgL_objz00_2098 =
												(BgL_objectz00_bglt) (BgL_arg3375z00_1387);
											{	/* Inline/inline.scm 170 */
												long BgL_objzd2classzd2numz00_2099;

												BgL_objzd2classzd2numz00_2099 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2098);
												{	/* Inline/inline.scm 170 */
													obj_t BgL_arg2356z00_2100;

													BgL_arg2356z00_2100 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 170 */
														obj_t BgL_arrayz00_2102;

														int BgL_offsetz00_2103;

														BgL_arrayz00_2102 = BgL_arg2356z00_2100;
														BgL_offsetz00_2103 =
															(int) (BgL_objzd2classzd2numz00_2099);
														{	/* Inline/inline.scm 170 */
															long BgL_offsetz00_2104;

															BgL_offsetz00_2104 =
																((long) (BgL_offsetz00_2103) - OBJECT_TYPE);
															{	/* Inline/inline.scm 170 */
																long BgL_modz00_2105;

																{	/* Inline/inline.scm 170 */
																	int BgL_arg2358z00_2106;

																	BgL_arg2358z00_2106 = (int) (((long) 8));
																	{	/* Inline/inline.scm 170 */
																		long BgL_auxz00_3419;

																		BgL_auxz00_3419 =
																			(long) (BgL_arg2358z00_2106);
																		BgL_modz00_2105 =
																			(BgL_offsetz00_2104 / BgL_auxz00_3419);
																}}
																{	/* Inline/inline.scm 170 */
																	long BgL_restz00_2107;

																	{	/* Inline/inline.scm 170 */
																		int BgL_arg2357z00_2108;

																		BgL_arg2357z00_2108 = (int) (((long) 8));
																		{	/* Inline/inline.scm 170 */
																			long BgL_auxz00_3423;

																			BgL_auxz00_3423 =
																				(long) (BgL_arg2357z00_2108);
																			BgL_restz00_2107 =
																				(BgL_offsetz00_2104 % BgL_auxz00_3423);
																	}}
																	{	/* Inline/inline.scm 170 */

																		BgL_method3196z00_2097 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2102,
																				(int) (BgL_modz00_2105)),
																			(int) (BgL_restz00_2107));
										}}}}}}}}
										BgL_res3476z00_2122 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_2097) (BgL_method3196z00_2097,
												(obj_t) (BgL_arg3375z00_1387),
												BINT(BgL_kfactorz00_2095), BgL_stackz00_1383, BEOA));
								}}
								BgL_arg3374z00_1386 = BgL_res3476z00_2122;
						}}
						((((BgL_selectz00_bglt) CREF(BgL_nodez00_1381))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3374z00_1386), BUNSPEC);
					}
					{	/* Inline/inline.scm 171 */
						obj_t BgL_g3187z00_1388;

						BgL_g3187z00_1388 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1381))->BgL_clausesz00);
						{
							obj_t BgL_l3185z00_1389;

							BgL_l3185z00_1389 = BgL_g3187z00_1388;
						BgL_forzd2each3186zd2_1390:
							if (PAIRP(BgL_l3185z00_1389))
								{	/* Inline/inline.scm 173 */
									{	/* Inline/inline.scm 172 */
										obj_t BgL_clausez00_1392;

										BgL_clausez00_1392 = CAR(BgL_l3185z00_1389);
										{	/* Inline/inline.scm 172 */
											BgL_nodez00_bglt BgL_arg3377z00_1393;

											{	/* Inline/inline.scm 172 */
												obj_t BgL_arg3378z00_1394;

												BgL_arg3378z00_1394 = CDR(BgL_clausez00_1392);
												{	/* Inline/inline.scm 172 */
													BgL_nodez00_bglt BgL_res3479z00_2157;

													{	/* Inline/inline.scm 172 */
														BgL_nodez00_bglt BgL_nodez00_2129;

														long BgL_kfactorz00_2130;

														BgL_nodez00_2129 =
															(BgL_nodez00_bglt) (BgL_arg3378z00_1394);
														BgL_kfactorz00_2130 =
															(long) CINT(BgL_kfactorz00_1382);
														{	/* Inline/inline.scm 172 */
															obj_t BgL_method3196z00_2132;

															{	/* Inline/inline.scm 172 */
																BgL_objectz00_bglt BgL_objz00_2133;

																BgL_objz00_2133 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2129);
																{	/* Inline/inline.scm 172 */
																	long BgL_objzd2classzd2numz00_2134;

																	BgL_objzd2classzd2numz00_2134 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2133);
																	{	/* Inline/inline.scm 172 */
																		obj_t BgL_arg2356z00_2135;

																		BgL_arg2356z00_2135 =
																			PROCEDURE_REF
																			(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
																			(int) (((long) 1)));
																		{	/* Inline/inline.scm 172 */
																			obj_t BgL_arrayz00_2137;

																			int BgL_offsetz00_2138;

																			BgL_arrayz00_2137 = BgL_arg2356z00_2135;
																			BgL_offsetz00_2138 =
																				(int) (BgL_objzd2classzd2numz00_2134);
																			{	/* Inline/inline.scm 172 */
																				long BgL_offsetz00_2139;

																				BgL_offsetz00_2139 =
																					(
																					(long) (BgL_offsetz00_2138) -
																					OBJECT_TYPE);
																				{	/* Inline/inline.scm 172 */
																					long BgL_modz00_2140;

																					{	/* Inline/inline.scm 172 */
																						int BgL_arg2358z00_2141;

																						BgL_arg2358z00_2141 =
																							(int) (((long) 8));
																						{	/* Inline/inline.scm 172 */
																							long BgL_auxz00_3451;

																							BgL_auxz00_3451 =
																								(long) (BgL_arg2358z00_2141);
																							BgL_modz00_2140 =
																								(BgL_offsetz00_2139 /
																								BgL_auxz00_3451);
																					}}
																					{	/* Inline/inline.scm 172 */
																						long BgL_restz00_2142;

																						{	/* Inline/inline.scm 172 */
																							int BgL_arg2357z00_2143;

																							BgL_arg2357z00_2143 =
																								(int) (((long) 8));
																							{	/* Inline/inline.scm 172 */
																								long BgL_auxz00_3455;

																								BgL_auxz00_3455 =
																									(long) (BgL_arg2357z00_2143);
																								BgL_restz00_2142 =
																									(BgL_offsetz00_2139 %
																									BgL_auxz00_3455);
																						}}
																						{	/* Inline/inline.scm 172 */

																							BgL_method3196z00_2132 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2137,
																									(int) (BgL_modz00_2140)),
																								(int) (BgL_restz00_2142));
															}}}}}}}}
															BgL_res3479z00_2157 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3196z00_2132)
																(BgL_method3196z00_2132,
																	(obj_t) (BgL_nodez00_2129),
																	BINT(BgL_kfactorz00_2130), BgL_stackz00_1383,
																	BEOA));
													}}
													BgL_arg3377z00_1393 = BgL_res3479z00_2157;
											}}
											{	/* Inline/inline.scm 172 */
												obj_t BgL_auxz00_3467;

												BgL_auxz00_3467 = (obj_t) (BgL_arg3377z00_1393);
												SET_CDR(BgL_clausez00_1392, BgL_auxz00_3467);
									}}}
									{
										obj_t BgL_l3185z00_3470;

										BgL_l3185z00_3470 = CDR(BgL_l3185z00_1389);
										BgL_l3185z00_1389 = BgL_l3185z00_3470;
										goto BgL_forzd2each3186zd2_1390;
									}
								}
							else
								{	/* Inline/inline.scm 173 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_3408 = BgL_nodez00_1381;
					return (obj_t) (BgL_auxz00_3408);
				}
			}
		}
	}



/* inline-node-fail3220 */
	obj_t BGl_inlinezd2nodezd2fail3220z00zzinline_inlinez00(obj_t BgL_envz00_2648,
		obj_t BgL_nodez00_2649, obj_t BgL_kfactorz00_2650, obj_t BgL_stackz00_2651)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 159 */
			{
				BgL_failz00_bglt BgL_nodez00_1367;

				obj_t BgL_kfactorz00_1368;

				obj_t BgL_stackz00_1369;

				{	/* Inline/inline.scm 160 */
					BgL_failz00_bglt BgL_auxz00_3474;

					BgL_nodez00_1367 = (BgL_failz00_bglt) (BgL_nodez00_2649);
					BgL_kfactorz00_1368 = BgL_kfactorz00_2650;
					BgL_stackz00_1369 = BgL_stackz00_2651;
					{	/* Inline/inline.scm 161 */
						BgL_nodez00_bglt BgL_arg3367z00_1373;

						{	/* Inline/inline.scm 161 */
							BgL_nodez00_bglt BgL_arg3368z00_1374;

							BgL_arg3368z00_1374 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1367))->BgL_procz00);
							{	/* Inline/inline.scm 161 */
								BgL_nodez00_bglt BgL_res3467z00_2026;

								{	/* Inline/inline.scm 161 */
									long BgL_kfactorz00_1999;

									BgL_kfactorz00_1999 = (long) CINT(BgL_kfactorz00_1368);
									{	/* Inline/inline.scm 161 */
										obj_t BgL_method3196z00_2001;

										{	/* Inline/inline.scm 161 */
											BgL_objectz00_bglt BgL_objz00_2002;

											BgL_objz00_2002 =
												(BgL_objectz00_bglt) (BgL_arg3368z00_1374);
											{	/* Inline/inline.scm 161 */
												long BgL_objzd2classzd2numz00_2003;

												BgL_objzd2classzd2numz00_2003 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2002);
												{	/* Inline/inline.scm 161 */
													obj_t BgL_arg2356z00_2004;

													BgL_arg2356z00_2004 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 161 */
														obj_t BgL_arrayz00_2006;

														int BgL_offsetz00_2007;

														BgL_arrayz00_2006 = BgL_arg2356z00_2004;
														BgL_offsetz00_2007 =
															(int) (BgL_objzd2classzd2numz00_2003);
														{	/* Inline/inline.scm 161 */
															long BgL_offsetz00_2008;

															BgL_offsetz00_2008 =
																((long) (BgL_offsetz00_2007) - OBJECT_TYPE);
															{	/* Inline/inline.scm 161 */
																long BgL_modz00_2009;

																{	/* Inline/inline.scm 161 */
																	int BgL_arg2358z00_2010;

																	BgL_arg2358z00_2010 = (int) (((long) 8));
																	{	/* Inline/inline.scm 161 */
																		long BgL_auxz00_3485;

																		BgL_auxz00_3485 =
																			(long) (BgL_arg2358z00_2010);
																		BgL_modz00_2009 =
																			(BgL_offsetz00_2008 / BgL_auxz00_3485);
																}}
																{	/* Inline/inline.scm 161 */
																	long BgL_restz00_2011;

																	{	/* Inline/inline.scm 161 */
																		int BgL_arg2357z00_2012;

																		BgL_arg2357z00_2012 = (int) (((long) 8));
																		{	/* Inline/inline.scm 161 */
																			long BgL_auxz00_3489;

																			BgL_auxz00_3489 =
																				(long) (BgL_arg2357z00_2012);
																			BgL_restz00_2011 =
																				(BgL_offsetz00_2008 % BgL_auxz00_3489);
																	}}
																	{	/* Inline/inline.scm 161 */

																		BgL_method3196z00_2001 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2006,
																				(int) (BgL_modz00_2009)),
																			(int) (BgL_restz00_2011));
										}}}}}}}}
										BgL_res3467z00_2026 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_2001) (BgL_method3196z00_2001,
												(obj_t) (BgL_arg3368z00_1374),
												BINT(BgL_kfactorz00_1999), BgL_stackz00_1369, BEOA));
								}}
								BgL_arg3367z00_1373 = BgL_res3467z00_2026;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1367))->BgL_procz00) =
							((BgL_nodez00_bglt) BgL_arg3367z00_1373), BUNSPEC);
					}
					{	/* Inline/inline.scm 162 */
						BgL_nodez00_bglt BgL_arg3369z00_1375;

						{	/* Inline/inline.scm 162 */
							BgL_nodez00_bglt BgL_arg3370z00_1376;

							BgL_arg3370z00_1376 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1367))->BgL_msgz00);
							{	/* Inline/inline.scm 162 */
								BgL_nodez00_bglt BgL_res3470z00_2058;

								{	/* Inline/inline.scm 162 */
									long BgL_kfactorz00_2031;

									BgL_kfactorz00_2031 = (long) CINT(BgL_kfactorz00_1368);
									{	/* Inline/inline.scm 162 */
										obj_t BgL_method3196z00_2033;

										{	/* Inline/inline.scm 162 */
											BgL_objectz00_bglt BgL_objz00_2034;

											BgL_objz00_2034 =
												(BgL_objectz00_bglt) (BgL_arg3370z00_1376);
											{	/* Inline/inline.scm 162 */
												long BgL_objzd2classzd2numz00_2035;

												BgL_objzd2classzd2numz00_2035 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2034);
												{	/* Inline/inline.scm 162 */
													obj_t BgL_arg2356z00_2036;

													BgL_arg2356z00_2036 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 162 */
														obj_t BgL_arrayz00_2038;

														int BgL_offsetz00_2039;

														BgL_arrayz00_2038 = BgL_arg2356z00_2036;
														BgL_offsetz00_2039 =
															(int) (BgL_objzd2classzd2numz00_2035);
														{	/* Inline/inline.scm 162 */
															long BgL_offsetz00_2040;

															BgL_offsetz00_2040 =
																((long) (BgL_offsetz00_2039) - OBJECT_TYPE);
															{	/* Inline/inline.scm 162 */
																long BgL_modz00_2041;

																{	/* Inline/inline.scm 162 */
																	int BgL_arg2358z00_2042;

																	BgL_arg2358z00_2042 = (int) (((long) 8));
																	{	/* Inline/inline.scm 162 */
																		long BgL_auxz00_3512;

																		BgL_auxz00_3512 =
																			(long) (BgL_arg2358z00_2042);
																		BgL_modz00_2041 =
																			(BgL_offsetz00_2040 / BgL_auxz00_3512);
																}}
																{	/* Inline/inline.scm 162 */
																	long BgL_restz00_2043;

																	{	/* Inline/inline.scm 162 */
																		int BgL_arg2357z00_2044;

																		BgL_arg2357z00_2044 = (int) (((long) 8));
																		{	/* Inline/inline.scm 162 */
																			long BgL_auxz00_3516;

																			BgL_auxz00_3516 =
																				(long) (BgL_arg2357z00_2044);
																			BgL_restz00_2043 =
																				(BgL_offsetz00_2040 % BgL_auxz00_3516);
																	}}
																	{	/* Inline/inline.scm 162 */

																		BgL_method3196z00_2033 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2038,
																				(int) (BgL_modz00_2041)),
																			(int) (BgL_restz00_2043));
										}}}}}}}}
										BgL_res3470z00_2058 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_2033) (BgL_method3196z00_2033,
												(obj_t) (BgL_arg3370z00_1376),
												BINT(BgL_kfactorz00_2031), BgL_stackz00_1369, BEOA));
								}}
								BgL_arg3369z00_1375 = BgL_res3470z00_2058;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1367))->BgL_msgz00) =
							((BgL_nodez00_bglt) BgL_arg3369z00_1375), BUNSPEC);
					}
					{	/* Inline/inline.scm 163 */
						BgL_nodez00_bglt BgL_arg3371z00_1377;

						{	/* Inline/inline.scm 163 */
							BgL_nodez00_bglt BgL_arg3372z00_1378;

							BgL_arg3372z00_1378 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1367))->BgL_objz00);
							{	/* Inline/inline.scm 163 */
								BgL_nodez00_bglt BgL_res3473z00_2090;

								{	/* Inline/inline.scm 163 */
									long BgL_kfactorz00_2063;

									BgL_kfactorz00_2063 = (long) CINT(BgL_kfactorz00_1368);
									{	/* Inline/inline.scm 163 */
										obj_t BgL_method3196z00_2065;

										{	/* Inline/inline.scm 163 */
											BgL_objectz00_bglt BgL_objz00_2066;

											BgL_objz00_2066 =
												(BgL_objectz00_bglt) (BgL_arg3372z00_1378);
											{	/* Inline/inline.scm 163 */
												long BgL_objzd2classzd2numz00_2067;

												BgL_objzd2classzd2numz00_2067 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2066);
												{	/* Inline/inline.scm 163 */
													obj_t BgL_arg2356z00_2068;

													BgL_arg2356z00_2068 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 163 */
														obj_t BgL_arrayz00_2070;

														int BgL_offsetz00_2071;

														BgL_arrayz00_2070 = BgL_arg2356z00_2068;
														BgL_offsetz00_2071 =
															(int) (BgL_objzd2classzd2numz00_2067);
														{	/* Inline/inline.scm 163 */
															long BgL_offsetz00_2072;

															BgL_offsetz00_2072 =
																((long) (BgL_offsetz00_2071) - OBJECT_TYPE);
															{	/* Inline/inline.scm 163 */
																long BgL_modz00_2073;

																{	/* Inline/inline.scm 163 */
																	int BgL_arg2358z00_2074;

																	BgL_arg2358z00_2074 = (int) (((long) 8));
																	{	/* Inline/inline.scm 163 */
																		long BgL_auxz00_3539;

																		BgL_auxz00_3539 =
																			(long) (BgL_arg2358z00_2074);
																		BgL_modz00_2073 =
																			(BgL_offsetz00_2072 / BgL_auxz00_3539);
																}}
																{	/* Inline/inline.scm 163 */
																	long BgL_restz00_2075;

																	{	/* Inline/inline.scm 163 */
																		int BgL_arg2357z00_2076;

																		BgL_arg2357z00_2076 = (int) (((long) 8));
																		{	/* Inline/inline.scm 163 */
																			long BgL_auxz00_3543;

																			BgL_auxz00_3543 =
																				(long) (BgL_arg2357z00_2076);
																			BgL_restz00_2075 =
																				(BgL_offsetz00_2072 % BgL_auxz00_3543);
																	}}
																	{	/* Inline/inline.scm 163 */

																		BgL_method3196z00_2065 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2070,
																				(int) (BgL_modz00_2073)),
																			(int) (BgL_restz00_2075));
										}}}}}}}}
										BgL_res3473z00_2090 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_2065) (BgL_method3196z00_2065,
												(obj_t) (BgL_arg3372z00_1378),
												BINT(BgL_kfactorz00_2063), BgL_stackz00_1369, BEOA));
								}}
								BgL_arg3371z00_1377 = BgL_res3473z00_2090;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1367))->BgL_objz00) =
							((BgL_nodez00_bglt) BgL_arg3371z00_1377), BUNSPEC);
					}
					BgL_auxz00_3474 = BgL_nodez00_1367;
					return (obj_t) (BgL_auxz00_3474);
				}
			}
		}
	}



/* inline-node-conditio3218 */
	obj_t BGl_inlinezd2nodezd2conditio3218z00zzinline_inlinez00(obj_t
		BgL_envz00_2652, obj_t BgL_nodez00_2653, obj_t BgL_kfactorz00_2654,
		obj_t BgL_stackz00_2655)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 149 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1353;

				obj_t BgL_kfactorz00_1354;

				obj_t BgL_stackz00_1355;

				{	/* Inline/inline.scm 150 */
					BgL_conditionalz00_bglt BgL_auxz00_3558;

					BgL_nodez00_1353 = (BgL_conditionalz00_bglt) (BgL_nodez00_2653);
					BgL_kfactorz00_1354 = BgL_kfactorz00_2654;
					BgL_stackz00_1355 = BgL_stackz00_2655;
					{	/* Inline/inline.scm 151 */
						BgL_nodez00_bglt BgL_arg3360z00_1359;

						{	/* Inline/inline.scm 151 */
							BgL_nodez00_bglt BgL_arg3361z00_1360;

							BgL_arg3361z00_1360 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1353))->
								BgL_testz00);
							{	/* Inline/inline.scm 151 */
								BgL_nodez00_bglt BgL_res3458z00_1930;

								{	/* Inline/inline.scm 151 */
									long BgL_kfactorz00_1903;

									BgL_kfactorz00_1903 = (long) CINT(BgL_kfactorz00_1354);
									{	/* Inline/inline.scm 151 */
										obj_t BgL_method3196z00_1905;

										{	/* Inline/inline.scm 151 */
											BgL_objectz00_bglt BgL_objz00_1906;

											BgL_objz00_1906 =
												(BgL_objectz00_bglt) (BgL_arg3361z00_1360);
											{	/* Inline/inline.scm 151 */
												long BgL_objzd2classzd2numz00_1907;

												BgL_objzd2classzd2numz00_1907 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1906);
												{	/* Inline/inline.scm 151 */
													obj_t BgL_arg2356z00_1908;

													BgL_arg2356z00_1908 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 151 */
														obj_t BgL_arrayz00_1910;

														int BgL_offsetz00_1911;

														BgL_arrayz00_1910 = BgL_arg2356z00_1908;
														BgL_offsetz00_1911 =
															(int) (BgL_objzd2classzd2numz00_1907);
														{	/* Inline/inline.scm 151 */
															long BgL_offsetz00_1912;

															BgL_offsetz00_1912 =
																((long) (BgL_offsetz00_1911) - OBJECT_TYPE);
															{	/* Inline/inline.scm 151 */
																long BgL_modz00_1913;

																{	/* Inline/inline.scm 151 */
																	int BgL_arg2358z00_1914;

																	BgL_arg2358z00_1914 = (int) (((long) 8));
																	{	/* Inline/inline.scm 151 */
																		long BgL_auxz00_3569;

																		BgL_auxz00_3569 =
																			(long) (BgL_arg2358z00_1914);
																		BgL_modz00_1913 =
																			(BgL_offsetz00_1912 / BgL_auxz00_3569);
																}}
																{	/* Inline/inline.scm 151 */
																	long BgL_restz00_1915;

																	{	/* Inline/inline.scm 151 */
																		int BgL_arg2357z00_1916;

																		BgL_arg2357z00_1916 = (int) (((long) 8));
																		{	/* Inline/inline.scm 151 */
																			long BgL_auxz00_3573;

																			BgL_auxz00_3573 =
																				(long) (BgL_arg2357z00_1916);
																			BgL_restz00_1915 =
																				(BgL_offsetz00_1912 % BgL_auxz00_3573);
																	}}
																	{	/* Inline/inline.scm 151 */

																		BgL_method3196z00_1905 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1910,
																				(int) (BgL_modz00_1913)),
																			(int) (BgL_restz00_1915));
										}}}}}}}}
										BgL_res3458z00_1930 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_1905) (BgL_method3196z00_1905,
												(obj_t) (BgL_arg3361z00_1360),
												BINT(BgL_kfactorz00_1903), BgL_stackz00_1355, BEOA));
								}}
								BgL_arg3360z00_1359 = BgL_res3458z00_1930;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1353))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3360z00_1359), BUNSPEC);
					}
					{	/* Inline/inline.scm 152 */
						BgL_nodez00_bglt BgL_arg3362z00_1361;

						{	/* Inline/inline.scm 152 */
							BgL_nodez00_bglt BgL_arg3363z00_1362;

							BgL_arg3363z00_1362 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1353))->
								BgL_truez00);
							{	/* Inline/inline.scm 152 */
								BgL_nodez00_bglt BgL_res3461z00_1962;

								{	/* Inline/inline.scm 152 */
									long BgL_kfactorz00_1935;

									BgL_kfactorz00_1935 = (long) CINT(BgL_kfactorz00_1354);
									{	/* Inline/inline.scm 152 */
										obj_t BgL_method3196z00_1937;

										{	/* Inline/inline.scm 152 */
											BgL_objectz00_bglt BgL_objz00_1938;

											BgL_objz00_1938 =
												(BgL_objectz00_bglt) (BgL_arg3363z00_1362);
											{	/* Inline/inline.scm 152 */
												long BgL_objzd2classzd2numz00_1939;

												BgL_objzd2classzd2numz00_1939 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1938);
												{	/* Inline/inline.scm 152 */
													obj_t BgL_arg2356z00_1940;

													BgL_arg2356z00_1940 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 152 */
														obj_t BgL_arrayz00_1942;

														int BgL_offsetz00_1943;

														BgL_arrayz00_1942 = BgL_arg2356z00_1940;
														BgL_offsetz00_1943 =
															(int) (BgL_objzd2classzd2numz00_1939);
														{	/* Inline/inline.scm 152 */
															long BgL_offsetz00_1944;

															BgL_offsetz00_1944 =
																((long) (BgL_offsetz00_1943) - OBJECT_TYPE);
															{	/* Inline/inline.scm 152 */
																long BgL_modz00_1945;

																{	/* Inline/inline.scm 152 */
																	int BgL_arg2358z00_1946;

																	BgL_arg2358z00_1946 = (int) (((long) 8));
																	{	/* Inline/inline.scm 152 */
																		long BgL_auxz00_3596;

																		BgL_auxz00_3596 =
																			(long) (BgL_arg2358z00_1946);
																		BgL_modz00_1945 =
																			(BgL_offsetz00_1944 / BgL_auxz00_3596);
																}}
																{	/* Inline/inline.scm 152 */
																	long BgL_restz00_1947;

																	{	/* Inline/inline.scm 152 */
																		int BgL_arg2357z00_1948;

																		BgL_arg2357z00_1948 = (int) (((long) 8));
																		{	/* Inline/inline.scm 152 */
																			long BgL_auxz00_3600;

																			BgL_auxz00_3600 =
																				(long) (BgL_arg2357z00_1948);
																			BgL_restz00_1947 =
																				(BgL_offsetz00_1944 % BgL_auxz00_3600);
																	}}
																	{	/* Inline/inline.scm 152 */

																		BgL_method3196z00_1937 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1942,
																				(int) (BgL_modz00_1945)),
																			(int) (BgL_restz00_1947));
										}}}}}}}}
										BgL_res3461z00_1962 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_1937) (BgL_method3196z00_1937,
												(obj_t) (BgL_arg3363z00_1362),
												BINT(BgL_kfactorz00_1935), BgL_stackz00_1355, BEOA));
								}}
								BgL_arg3362z00_1361 = BgL_res3461z00_1962;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1353))->BgL_truez00) =
							((BgL_nodez00_bglt) BgL_arg3362z00_1361), BUNSPEC);
					}
					{	/* Inline/inline.scm 153 */
						BgL_nodez00_bglt BgL_arg3364z00_1363;

						{	/* Inline/inline.scm 153 */
							BgL_nodez00_bglt BgL_arg3365z00_1364;

							BgL_arg3365z00_1364 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1353))->
								BgL_falsez00);
							{	/* Inline/inline.scm 153 */
								BgL_nodez00_bglt BgL_res3464z00_1994;

								{	/* Inline/inline.scm 153 */
									long BgL_kfactorz00_1967;

									BgL_kfactorz00_1967 = (long) CINT(BgL_kfactorz00_1354);
									{	/* Inline/inline.scm 153 */
										obj_t BgL_method3196z00_1969;

										{	/* Inline/inline.scm 153 */
											BgL_objectz00_bglt BgL_objz00_1970;

											BgL_objz00_1970 =
												(BgL_objectz00_bglt) (BgL_arg3365z00_1364);
											{	/* Inline/inline.scm 153 */
												long BgL_objzd2classzd2numz00_1971;

												BgL_objzd2classzd2numz00_1971 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1970);
												{	/* Inline/inline.scm 153 */
													obj_t BgL_arg2356z00_1972;

													BgL_arg2356z00_1972 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 153 */
														obj_t BgL_arrayz00_1974;

														int BgL_offsetz00_1975;

														BgL_arrayz00_1974 = BgL_arg2356z00_1972;
														BgL_offsetz00_1975 =
															(int) (BgL_objzd2classzd2numz00_1971);
														{	/* Inline/inline.scm 153 */
															long BgL_offsetz00_1976;

															BgL_offsetz00_1976 =
																((long) (BgL_offsetz00_1975) - OBJECT_TYPE);
															{	/* Inline/inline.scm 153 */
																long BgL_modz00_1977;

																{	/* Inline/inline.scm 153 */
																	int BgL_arg2358z00_1978;

																	BgL_arg2358z00_1978 = (int) (((long) 8));
																	{	/* Inline/inline.scm 153 */
																		long BgL_auxz00_3623;

																		BgL_auxz00_3623 =
																			(long) (BgL_arg2358z00_1978);
																		BgL_modz00_1977 =
																			(BgL_offsetz00_1976 / BgL_auxz00_3623);
																}}
																{	/* Inline/inline.scm 153 */
																	long BgL_restz00_1979;

																	{	/* Inline/inline.scm 153 */
																		int BgL_arg2357z00_1980;

																		BgL_arg2357z00_1980 = (int) (((long) 8));
																		{	/* Inline/inline.scm 153 */
																			long BgL_auxz00_3627;

																			BgL_auxz00_3627 =
																				(long) (BgL_arg2357z00_1980);
																			BgL_restz00_1979 =
																				(BgL_offsetz00_1976 % BgL_auxz00_3627);
																	}}
																	{	/* Inline/inline.scm 153 */

																		BgL_method3196z00_1969 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1974,
																				(int) (BgL_modz00_1977)),
																			(int) (BgL_restz00_1979));
										}}}}}}}}
										BgL_res3464z00_1994 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_1969) (BgL_method3196z00_1969,
												(obj_t) (BgL_arg3365z00_1364),
												BINT(BgL_kfactorz00_1967), BgL_stackz00_1355, BEOA));
								}}
								BgL_arg3364z00_1363 = BgL_res3464z00_1994;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1353))->
								BgL_falsez00) =
							((BgL_nodez00_bglt) BgL_arg3364z00_1363), BUNSPEC);
					}
					BgL_auxz00_3558 = BgL_nodez00_1353;
					return (obj_t) (BgL_auxz00_3558);
				}
			}
		}
	}



/* inline-node-setq3216 */
	obj_t BGl_inlinezd2nodezd2setq3216z00zzinline_inlinez00(obj_t BgL_envz00_2656,
		obj_t BgL_nodez00_2657, obj_t BgL_kfactorz00_2658, obj_t BgL_stackz00_2659)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 142 */
			{
				BgL_setqz00_bglt BgL_nodez00_1344;

				obj_t BgL_kfactorz00_1345;

				obj_t BgL_stackz00_1346;

				{	/* Inline/inline.scm 143 */
					BgL_setqz00_bglt BgL_auxz00_3642;

					BgL_nodez00_1344 = (BgL_setqz00_bglt) (BgL_nodez00_2657);
					BgL_kfactorz00_1345 = BgL_kfactorz00_2658;
					BgL_stackz00_1346 = BgL_stackz00_2659;
					{	/* Inline/inline.scm 143 */
						BgL_nodez00_bglt BgL_arg3357z00_1867;

						{	/* Inline/inline.scm 143 */
							BgL_nodez00_bglt BgL_arg3358z00_1868;

							BgL_arg3358z00_1868 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1344))->BgL_valuez00);
							{	/* Inline/inline.scm 143 */
								BgL_nodez00_bglt BgL_res3455z00_1898;

								{	/* Inline/inline.scm 143 */
									long BgL_kfactorz00_1871;

									BgL_kfactorz00_1871 = (long) CINT(BgL_kfactorz00_1345);
									{	/* Inline/inline.scm 143 */
										obj_t BgL_method3196z00_1873;

										{	/* Inline/inline.scm 143 */
											BgL_objectz00_bglt BgL_objz00_1874;

											BgL_objz00_1874 =
												(BgL_objectz00_bglt) (BgL_arg3358z00_1868);
											{	/* Inline/inline.scm 143 */
												long BgL_objzd2classzd2numz00_1875;

												BgL_objzd2classzd2numz00_1875 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1874);
												{	/* Inline/inline.scm 143 */
													obj_t BgL_arg2356z00_1876;

													BgL_arg2356z00_1876 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 143 */
														obj_t BgL_arrayz00_1878;

														int BgL_offsetz00_1879;

														BgL_arrayz00_1878 = BgL_arg2356z00_1876;
														BgL_offsetz00_1879 =
															(int) (BgL_objzd2classzd2numz00_1875);
														{	/* Inline/inline.scm 143 */
															long BgL_offsetz00_1880;

															BgL_offsetz00_1880 =
																((long) (BgL_offsetz00_1879) - OBJECT_TYPE);
															{	/* Inline/inline.scm 143 */
																long BgL_modz00_1881;

																{	/* Inline/inline.scm 143 */
																	int BgL_arg2358z00_1882;

																	BgL_arg2358z00_1882 = (int) (((long) 8));
																	{	/* Inline/inline.scm 143 */
																		long BgL_auxz00_3653;

																		BgL_auxz00_3653 =
																			(long) (BgL_arg2358z00_1882);
																		BgL_modz00_1881 =
																			(BgL_offsetz00_1880 / BgL_auxz00_3653);
																}}
																{	/* Inline/inline.scm 143 */
																	long BgL_restz00_1883;

																	{	/* Inline/inline.scm 143 */
																		int BgL_arg2357z00_1884;

																		BgL_arg2357z00_1884 = (int) (((long) 8));
																		{	/* Inline/inline.scm 143 */
																			long BgL_auxz00_3657;

																			BgL_auxz00_3657 =
																				(long) (BgL_arg2357z00_1884);
																			BgL_restz00_1883 =
																				(BgL_offsetz00_1880 % BgL_auxz00_3657);
																	}}
																	{	/* Inline/inline.scm 143 */

																		BgL_method3196z00_1873 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1878,
																				(int) (BgL_modz00_1881)),
																			(int) (BgL_restz00_1883));
										}}}}}}}}
										BgL_res3455z00_1898 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_1873) (BgL_method3196z00_1873,
												(obj_t) (BgL_arg3358z00_1868),
												BINT(BgL_kfactorz00_1871), BgL_stackz00_1346, BEOA));
								}}
								BgL_arg3357z00_1867 = BgL_res3455z00_1898;
						}}
						((((BgL_setqz00_bglt) CREF(BgL_nodez00_1344))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3357z00_1867), BUNSPEC);
					}
					BgL_auxz00_3642 = BgL_nodez00_1344;
					return (obj_t) (BgL_auxz00_3642);
				}
			}
		}
	}



/* inline-node-cast3214 */
	obj_t BGl_inlinezd2nodezd2cast3214z00zzinline_inlinez00(obj_t BgL_envz00_2660,
		obj_t BgL_nodez00_2661, obj_t BgL_kfactorz00_2662, obj_t BgL_stackz00_2663)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 135 */
			{
				BgL_castz00_bglt BgL_nodez00_1336;

				obj_t BgL_kfactorz00_1337;

				obj_t BgL_stackz00_1338;

				{	/* Inline/inline.scm 136 */
					BgL_castz00_bglt BgL_auxz00_3672;

					BgL_nodez00_1336 = (BgL_castz00_bglt) (BgL_nodez00_2661);
					BgL_kfactorz00_1337 = BgL_kfactorz00_2662;
					BgL_stackz00_1338 = BgL_stackz00_2663;
					{	/* Inline/inline.scm 136 */
						BgL_nodez00_bglt BgL_arg3355z00_1836;

						BgL_arg3355z00_1836 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1336))->BgL_argz00);
						{	/* Inline/inline.scm 136 */
							BgL_nodez00_bglt BgL_res3452z00_1866;

							{	/* Inline/inline.scm 136 */
								long BgL_kfactorz00_1839;

								BgL_kfactorz00_1839 = (long) CINT(BgL_kfactorz00_1337);
								{	/* Inline/inline.scm 136 */
									obj_t BgL_method3196z00_1841;

									{	/* Inline/inline.scm 136 */
										BgL_objectz00_bglt BgL_objz00_1842;

										BgL_objz00_1842 =
											(BgL_objectz00_bglt) (BgL_arg3355z00_1836);
										{	/* Inline/inline.scm 136 */
											long BgL_objzd2classzd2numz00_1843;

											BgL_objzd2classzd2numz00_1843 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1842);
											{	/* Inline/inline.scm 136 */
												obj_t BgL_arg2356z00_1844;

												BgL_arg2356z00_1844 =
													PROCEDURE_REF
													(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
													(int) (((long) 1)));
												{	/* Inline/inline.scm 136 */
													obj_t BgL_arrayz00_1846;

													int BgL_offsetz00_1847;

													BgL_arrayz00_1846 = BgL_arg2356z00_1844;
													BgL_offsetz00_1847 =
														(int) (BgL_objzd2classzd2numz00_1843);
													{	/* Inline/inline.scm 136 */
														long BgL_offsetz00_1848;

														BgL_offsetz00_1848 =
															((long) (BgL_offsetz00_1847) - OBJECT_TYPE);
														{	/* Inline/inline.scm 136 */
															long BgL_modz00_1849;

															{	/* Inline/inline.scm 136 */
																int BgL_arg2358z00_1850;

																BgL_arg2358z00_1850 = (int) (((long) 8));
																{	/* Inline/inline.scm 136 */
																	long BgL_auxz00_3683;

																	BgL_auxz00_3683 =
																		(long) (BgL_arg2358z00_1850);
																	BgL_modz00_1849 =
																		(BgL_offsetz00_1848 / BgL_auxz00_3683);
															}}
															{	/* Inline/inline.scm 136 */
																long BgL_restz00_1851;

																{	/* Inline/inline.scm 136 */
																	int BgL_arg2357z00_1852;

																	BgL_arg2357z00_1852 = (int) (((long) 8));
																	{	/* Inline/inline.scm 136 */
																		long BgL_auxz00_3687;

																		BgL_auxz00_3687 =
																			(long) (BgL_arg2357z00_1852);
																		BgL_restz00_1851 =
																			(BgL_offsetz00_1848 % BgL_auxz00_3687);
																}}
																{	/* Inline/inline.scm 136 */

																	BgL_method3196z00_1841 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1846,
																			(int) (BgL_modz00_1849)),
																		(int) (BgL_restz00_1851));
									}}}}}}}}
									BgL_res3452z00_1866 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3196z00_1841)
										(BgL_method3196z00_1841, (obj_t) (BgL_arg3355z00_1836),
											BINT(BgL_kfactorz00_1839), BgL_stackz00_1338, BEOA));
							}} BgL_res3452z00_1866;
					}}
					BgL_auxz00_3672 = BgL_nodez00_1336;
					return (obj_t) (BgL_auxz00_3672);
				}
			}
		}
	}



/* inline-node-extern3212 */
	obj_t BGl_inlinezd2nodezd2extern3212z00zzinline_inlinez00(obj_t
		BgL_envz00_2664, obj_t BgL_nodez00_2665, obj_t BgL_kfactorz00_2666,
		obj_t BgL_stackz00_2667)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 128 */
			{
				BgL_externz00_bglt BgL_nodez00_1328;

				obj_t BgL_kfactorz00_1329;

				obj_t BgL_stackz00_1330;

				{	/* Inline/inline.scm 129 */
					BgL_externz00_bglt BgL_auxz00_3701;

					BgL_nodez00_1328 = (BgL_externz00_bglt) (BgL_nodez00_2665);
					BgL_kfactorz00_1329 = BgL_kfactorz00_2666;
					BgL_stackz00_1330 = BgL_stackz00_2667;
					{	/* Inline/inline.scm 129 */
						obj_t BgL_arg3353z00_1834;

						BgL_arg3353z00_1834 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1328))->BgL_exprza2za2);
						BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_arg3353z00_1834,
							BgL_kfactorz00_1329, BgL_stackz00_1330);
					}
					BgL_auxz00_3701 = BgL_nodez00_1328;
					return (obj_t) (BgL_auxz00_3701);
				}
			}
		}
	}



/* inline-node-funcall3210 */
	obj_t BGl_inlinezd2nodezd2funcall3210z00zzinline_inlinez00(obj_t
		BgL_envz00_2668, obj_t BgL_nodez00_2669, obj_t BgL_kfactorz00_2670,
		obj_t BgL_stackz00_2671)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 118 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1318;

				obj_t BgL_kfactorz00_1319;

				obj_t BgL_stackz00_1320;

				{	/* Inline/inline.scm 120 */
					BgL_funcallz00_bglt BgL_auxz00_3706;

					BgL_nodez00_1318 = (BgL_funcallz00_bglt) (BgL_nodez00_2669);
					BgL_kfactorz00_1319 = BgL_kfactorz00_2670;
					BgL_stackz00_1320 = BgL_stackz00_2671;
					{	/* Inline/inline.scm 120 */
						long BgL_za71za7_1799;

						BgL_za71za7_1799 =
							(long) CINT(BGl_za2nonzd2inlinedzd2callsza2z00zzinline_walkz00);
						BGl_za2nonzd2inlinedzd2callsza2z00zzinline_walkz00 =
							BINT((BgL_za71za7_1799 + ((long) 1)));
					}
					{	/* Inline/inline.scm 121 */
						BgL_nodez00_bglt BgL_arg3349z00_1323;

						{	/* Inline/inline.scm 121 */
							BgL_nodez00_bglt BgL_arg3350z00_1324;

							BgL_arg3350z00_1324 =
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1318))->BgL_funz00);
							{	/* Inline/inline.scm 121 */
								BgL_nodez00_bglt BgL_res3449z00_1830;

								{	/* Inline/inline.scm 121 */
									long BgL_kfactorz00_1803;

									BgL_kfactorz00_1803 = (long) CINT(BgL_kfactorz00_1319);
									{	/* Inline/inline.scm 121 */
										obj_t BgL_method3196z00_1805;

										{	/* Inline/inline.scm 121 */
											BgL_objectz00_bglt BgL_objz00_1806;

											BgL_objz00_1806 =
												(BgL_objectz00_bglt) (BgL_arg3350z00_1324);
											{	/* Inline/inline.scm 121 */
												long BgL_objzd2classzd2numz00_1807;

												BgL_objzd2classzd2numz00_1807 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1806);
												{	/* Inline/inline.scm 121 */
													obj_t BgL_arg2356z00_1808;

													BgL_arg2356z00_1808 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 121 */
														obj_t BgL_arrayz00_1810;

														int BgL_offsetz00_1811;

														BgL_arrayz00_1810 = BgL_arg2356z00_1808;
														BgL_offsetz00_1811 =
															(int) (BgL_objzd2classzd2numz00_1807);
														{	/* Inline/inline.scm 121 */
															long BgL_offsetz00_1812;

															BgL_offsetz00_1812 =
																((long) (BgL_offsetz00_1811) - OBJECT_TYPE);
															{	/* Inline/inline.scm 121 */
																long BgL_modz00_1813;

																{	/* Inline/inline.scm 121 */
																	int BgL_arg2358z00_1814;

																	BgL_arg2358z00_1814 = (int) (((long) 8));
																	{	/* Inline/inline.scm 121 */
																		long BgL_auxz00_3720;

																		BgL_auxz00_3720 =
																			(long) (BgL_arg2358z00_1814);
																		BgL_modz00_1813 =
																			(BgL_offsetz00_1812 / BgL_auxz00_3720);
																}}
																{	/* Inline/inline.scm 121 */
																	long BgL_restz00_1815;

																	{	/* Inline/inline.scm 121 */
																		int BgL_arg2357z00_1816;

																		BgL_arg2357z00_1816 = (int) (((long) 8));
																		{	/* Inline/inline.scm 121 */
																			long BgL_auxz00_3724;

																			BgL_auxz00_3724 =
																				(long) (BgL_arg2357z00_1816);
																			BgL_restz00_1815 =
																				(BgL_offsetz00_1812 % BgL_auxz00_3724);
																	}}
																	{	/* Inline/inline.scm 121 */

																		BgL_method3196z00_1805 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1810,
																				(int) (BgL_modz00_1813)),
																			(int) (BgL_restz00_1815));
										}}}}}}}}
										BgL_res3449z00_1830 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_1805) (BgL_method3196z00_1805,
												(obj_t) (BgL_arg3350z00_1324),
												BINT(BgL_kfactorz00_1803), BgL_stackz00_1320, BEOA));
								}}
								BgL_arg3349z00_1323 = BgL_res3449z00_1830;
						}}
						((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1318))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3349z00_1323), BUNSPEC);
					}
					{	/* Inline/inline.scm 122 */
						obj_t BgL_arg3351z00_1325;

						BgL_arg3351z00_1325 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1318))->BgL_argsz00);
						BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_arg3351z00_1325,
							BgL_kfactorz00_1319, BgL_stackz00_1320);
					}
					BgL_auxz00_3706 = BgL_nodez00_1318;
					return (obj_t) (BgL_auxz00_3706);
				}
			}
		}
	}



/* inline-node-app-ly3208 */
	obj_t BGl_inlinezd2nodezd2appzd2ly3208zd2zzinline_inlinez00(obj_t
		BgL_envz00_2672, obj_t BgL_nodez00_2673, obj_t BgL_kfactorz00_2674,
		obj_t BgL_stackz00_2675)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 109 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1306;

				obj_t BgL_kfactorz00_1307;

				obj_t BgL_stackz00_1308;

				{	/* Inline/inline.scm 110 */
					BgL_appzd2lyzd2_bglt BgL_auxz00_3741;

					BgL_nodez00_1306 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_2673);
					BgL_kfactorz00_1307 = BgL_kfactorz00_2674;
					BgL_stackz00_1308 = BgL_stackz00_2675;
					{	/* Inline/inline.scm 111 */
						BgL_nodez00_bglt BgL_arg3344z00_1312;

						{	/* Inline/inline.scm 111 */
							BgL_nodez00_bglt BgL_arg3345z00_1313;

							BgL_arg3345z00_1313 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1306))->BgL_funz00);
							{	/* Inline/inline.scm 111 */
								BgL_nodez00_bglt BgL_res3443z00_1764;

								{	/* Inline/inline.scm 111 */
									long BgL_kfactorz00_1737;

									BgL_kfactorz00_1737 = (long) CINT(BgL_kfactorz00_1307);
									{	/* Inline/inline.scm 111 */
										obj_t BgL_method3196z00_1739;

										{	/* Inline/inline.scm 111 */
											BgL_objectz00_bglt BgL_objz00_1740;

											BgL_objz00_1740 =
												(BgL_objectz00_bglt) (BgL_arg3345z00_1313);
											{	/* Inline/inline.scm 111 */
												long BgL_objzd2classzd2numz00_1741;

												BgL_objzd2classzd2numz00_1741 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1740);
												{	/* Inline/inline.scm 111 */
													obj_t BgL_arg2356z00_1742;

													BgL_arg2356z00_1742 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 111 */
														obj_t BgL_arrayz00_1744;

														int BgL_offsetz00_1745;

														BgL_arrayz00_1744 = BgL_arg2356z00_1742;
														BgL_offsetz00_1745 =
															(int) (BgL_objzd2classzd2numz00_1741);
														{	/* Inline/inline.scm 111 */
															long BgL_offsetz00_1746;

															BgL_offsetz00_1746 =
																((long) (BgL_offsetz00_1745) - OBJECT_TYPE);
															{	/* Inline/inline.scm 111 */
																long BgL_modz00_1747;

																{	/* Inline/inline.scm 111 */
																	int BgL_arg2358z00_1748;

																	BgL_arg2358z00_1748 = (int) (((long) 8));
																	{	/* Inline/inline.scm 111 */
																		long BgL_auxz00_3752;

																		BgL_auxz00_3752 =
																			(long) (BgL_arg2358z00_1748);
																		BgL_modz00_1747 =
																			(BgL_offsetz00_1746 / BgL_auxz00_3752);
																}}
																{	/* Inline/inline.scm 111 */
																	long BgL_restz00_1749;

																	{	/* Inline/inline.scm 111 */
																		int BgL_arg2357z00_1750;

																		BgL_arg2357z00_1750 = (int) (((long) 8));
																		{	/* Inline/inline.scm 111 */
																			long BgL_auxz00_3756;

																			BgL_auxz00_3756 =
																				(long) (BgL_arg2357z00_1750);
																			BgL_restz00_1749 =
																				(BgL_offsetz00_1746 % BgL_auxz00_3756);
																	}}
																	{	/* Inline/inline.scm 111 */

																		BgL_method3196z00_1739 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1744,
																				(int) (BgL_modz00_1747)),
																			(int) (BgL_restz00_1749));
										}}}}}}}}
										BgL_res3443z00_1764 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_1739) (BgL_method3196z00_1739,
												(obj_t) (BgL_arg3345z00_1313),
												BINT(BgL_kfactorz00_1737), BgL_stackz00_1308, BEOA));
								}}
								BgL_arg3344z00_1312 = BgL_res3443z00_1764;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1306))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3344z00_1312), BUNSPEC);
					}
					{	/* Inline/inline.scm 112 */
						BgL_nodez00_bglt BgL_arg3346z00_1314;

						{	/* Inline/inline.scm 112 */
							BgL_nodez00_bglt BgL_arg3347z00_1315;

							BgL_arg3347z00_1315 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1306))->BgL_argz00);
							{	/* Inline/inline.scm 112 */
								BgL_nodez00_bglt BgL_res3446z00_1796;

								{	/* Inline/inline.scm 112 */
									long BgL_kfactorz00_1769;

									BgL_kfactorz00_1769 = (long) CINT(BgL_kfactorz00_1307);
									{	/* Inline/inline.scm 112 */
										obj_t BgL_method3196z00_1771;

										{	/* Inline/inline.scm 112 */
											BgL_objectz00_bglt BgL_objz00_1772;

											BgL_objz00_1772 =
												(BgL_objectz00_bglt) (BgL_arg3347z00_1315);
											{	/* Inline/inline.scm 112 */
												long BgL_objzd2classzd2numz00_1773;

												BgL_objzd2classzd2numz00_1773 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1772);
												{	/* Inline/inline.scm 112 */
													obj_t BgL_arg2356z00_1774;

													BgL_arg2356z00_1774 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 112 */
														obj_t BgL_arrayz00_1776;

														int BgL_offsetz00_1777;

														BgL_arrayz00_1776 = BgL_arg2356z00_1774;
														BgL_offsetz00_1777 =
															(int) (BgL_objzd2classzd2numz00_1773);
														{	/* Inline/inline.scm 112 */
															long BgL_offsetz00_1778;

															BgL_offsetz00_1778 =
																((long) (BgL_offsetz00_1777) - OBJECT_TYPE);
															{	/* Inline/inline.scm 112 */
																long BgL_modz00_1779;

																{	/* Inline/inline.scm 112 */
																	int BgL_arg2358z00_1780;

																	BgL_arg2358z00_1780 = (int) (((long) 8));
																	{	/* Inline/inline.scm 112 */
																		long BgL_auxz00_3779;

																		BgL_auxz00_3779 =
																			(long) (BgL_arg2358z00_1780);
																		BgL_modz00_1779 =
																			(BgL_offsetz00_1778 / BgL_auxz00_3779);
																}}
																{	/* Inline/inline.scm 112 */
																	long BgL_restz00_1781;

																	{	/* Inline/inline.scm 112 */
																		int BgL_arg2357z00_1782;

																		BgL_arg2357z00_1782 = (int) (((long) 8));
																		{	/* Inline/inline.scm 112 */
																			long BgL_auxz00_3783;

																			BgL_auxz00_3783 =
																				(long) (BgL_arg2357z00_1782);
																			BgL_restz00_1781 =
																				(BgL_offsetz00_1778 % BgL_auxz00_3783);
																	}}
																	{	/* Inline/inline.scm 112 */

																		BgL_method3196z00_1771 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1776,
																				(int) (BgL_modz00_1779)),
																			(int) (BgL_restz00_1781));
										}}}}}}}}
										BgL_res3446z00_1796 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3196z00_1771) (BgL_method3196z00_1771,
												(obj_t) (BgL_arg3347z00_1315),
												BINT(BgL_kfactorz00_1769), BgL_stackz00_1308, BEOA));
								}}
								BgL_arg3346z00_1314 = BgL_res3446z00_1796;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1306))->BgL_argz00) =
							((BgL_nodez00_bglt) BgL_arg3346z00_1314), BUNSPEC);
					}
					BgL_auxz00_3741 = BgL_nodez00_1306;
					return (obj_t) (BgL_auxz00_3741);
				}
			}
		}
	}



/* inline-node-app3206 */
	obj_t BGl_inlinezd2nodezd2app3206z00zzinline_inlinez00(obj_t BgL_envz00_2676,
		obj_t BgL_nodez00_2677, obj_t BgL_kfactorz00_2678, obj_t BgL_stackz00_2679)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 102 */
			{
				BgL_appz00_bglt BgL_nodez00_1298;

				obj_t BgL_kfactorz00_1299;

				obj_t BgL_stackz00_1300;

				{	/* Inline/inline.scm 103 */
					BgL_nodez00_bglt BgL_auxz00_3798;

					BgL_nodez00_1298 = (BgL_appz00_bglt) (BgL_nodez00_2677);
					BgL_kfactorz00_1299 = BgL_kfactorz00_2678;
					BgL_stackz00_1300 = BgL_stackz00_2679;
					{	/* Inline/inline.scm 103 */
						obj_t BgL_arg3342z00_1733;

						BgL_arg3342z00_1733 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1298))->BgL_argsz00);
						BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_arg3342z00_1733,
							BgL_kfactorz00_1299, BgL_stackz00_1300);
					}
					BgL_auxz00_3798 =
						BGl_inlinezd2appzd2zzinline_appz00(BgL_nodez00_1298,
						(long) CINT(BgL_kfactorz00_1299), BgL_stackz00_1300);
					return (obj_t) (BgL_auxz00_3798);
				}
			}
		}
	}



/* inline-node-sequence3204 */
	obj_t BGl_inlinezd2nodezd2sequence3204z00zzinline_inlinez00(obj_t
		BgL_envz00_2680, obj_t BgL_nodez00_2681, obj_t BgL_kfactorz00_2682,
		obj_t BgL_stackz00_2683)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 95 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1290;

				obj_t BgL_kfactorz00_1291;

				obj_t BgL_stackz00_1292;

				{	/* Inline/inline.scm 96 */
					BgL_sequencez00_bglt BgL_auxz00_3805;

					BgL_nodez00_1290 = (BgL_sequencez00_bglt) (BgL_nodez00_2681);
					BgL_kfactorz00_1291 = BgL_kfactorz00_2682;
					BgL_stackz00_1292 = BgL_stackz00_2683;
					{	/* Inline/inline.scm 96 */
						obj_t BgL_arg3340z00_1731;

						BgL_arg3340z00_1731 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1290))->BgL_nodesz00);
						BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_arg3340z00_1731,
							BgL_kfactorz00_1291, BgL_stackz00_1292);
					}
					BgL_auxz00_3805 = BgL_nodez00_1290;
					return (obj_t) (BgL_auxz00_3805);
				}
			}
		}
	}



/* inline-node-kwote3202 */
	obj_t BGl_inlinezd2nodezd2kwote3202z00zzinline_inlinez00(obj_t
		BgL_envz00_2684, obj_t BgL_nodez00_2685, obj_t BgL_kfactorz00_2686,
		obj_t BgL_stackz00_2687)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 89 */
			return (obj_t) ((BgL_kwotez00_bglt) (BgL_nodez00_2685));
		}
	}



/* inline-node-var3200 */
	obj_t BGl_inlinezd2nodezd2var3200z00zzinline_inlinez00(obj_t BgL_envz00_2688,
		obj_t BgL_nodez00_2689, obj_t BgL_kfactorz00_2690, obj_t BgL_stackz00_2691)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 73 */
			{
				BgL_varz00_bglt BgL_nodez00_1256;

				obj_t BgL_kfactorz00_1257;

				obj_t BgL_stackz00_1258;

				BgL_nodez00_1256 = (BgL_varz00_bglt) (BgL_nodez00_2689);
				BgL_kfactorz00_1257 = BgL_kfactorz00_2690;
				BgL_stackz00_1258 = BgL_stackz00_2691;
				{	/* Inline/inline.scm 75 */
					bool_t BgL_testz00_3812;

					if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) > ((long) 0)))
						{	/* Inline/inline.scm 76 */
							bool_t BgL_testz00_3816;

							{	/* Inline/inline.scm 76 */
								BgL_variablez00_bglt BgL_arg3337z00_1280;

								BgL_arg3337z00_1280 =
									(((BgL_varz00_bglt) CREF(BgL_nodez00_1256))->BgL_variablez00);
								{	/* Inline/inline.scm 76 */
									obj_t BgL_obj1590z00_1720;

									BgL_obj1590z00_1720 = (obj_t) (BgL_arg3337z00_1280);
									BgL_testz00_3816 =
										BGl_iszd2azf3z21zz__objectz00(BgL_obj1590z00_1720,
										BGl_globalz00zzast_varz00);
							}}
							if (BgL_testz00_3816)
								{	/* Inline/inline.scm 77 */
									bool_t BgL_testz00_3820;

									{	/* Inline/inline.scm 77 */
										obj_t BgL_auxz00_3821;

										{	/* Inline/inline.scm 77 */
											BgL_globalz00_bglt BgL_obj1518z00_1722;

											BgL_obj1518z00_1722 =
												(BgL_globalz00_bglt) (
												(((BgL_varz00_bglt) CREF(BgL_nodez00_1256))->
													BgL_variablez00));
											BgL_auxz00_3821 =
												(((BgL_globalz00_bglt) CREF(BgL_obj1518z00_1722))->
												BgL_importz00);
										}
										BgL_testz00_3820 =
											(BgL_auxz00_3821 == CNST_TABLE_REF(((long) 3)));
									}
									if (BgL_testz00_3820)
										{	/* Inline/inline.scm 78 */
											bool_t BgL_testz00_3827;

											{	/* Inline/inline.scm 78 */
												obj_t BgL_auxz00_3828;

												{	/* Inline/inline.scm 78 */
													BgL_variablez00_bglt BgL_obj1453z00_1724;

													BgL_obj1453z00_1724 =
														(((BgL_varz00_bglt) CREF(BgL_nodez00_1256))->
														BgL_variablez00);
													BgL_auxz00_3828 =
														(((BgL_variablez00_bglt)
															CREF(BgL_obj1453z00_1724))->BgL_accessz00);
												}
												BgL_testz00_3827 =
													(BgL_auxz00_3828 == CNST_TABLE_REF(((long) 4)));
											}
											if (BgL_testz00_3827)
												{	/* Inline/inline.scm 79 */
													obj_t BgL_arg3329z00_1272;

													{	/* Inline/inline.scm 79 */
														BgL_globalz00_bglt BgL_obj1533z00_1726;

														BgL_obj1533z00_1726 =
															(BgL_globalz00_bglt) (
															(((BgL_varz00_bglt) CREF(BgL_nodez00_1256))->
																BgL_variablez00));
														BgL_arg3329z00_1272 =
															(((BgL_globalz00_bglt)
																CREF(BgL_obj1533z00_1726))->BgL_srcz00);
													}
													BgL_testz00_3812 =
														BGl_iszd2azf3z21zz__objectz00(BgL_arg3329z00_1272,
														BGl_atomz00zzast_nodez00);
												}
											else
												{	/* Inline/inline.scm 78 */
													BgL_testz00_3812 = ((bool_t) 0);
												}
										}
									else
										{	/* Inline/inline.scm 77 */
											BgL_testz00_3812 = ((bool_t) 0);
										}
								}
							else
								{	/* Inline/inline.scm 76 */
									BgL_testz00_3812 = ((bool_t) 0);
								}
						}
					else
						{	/* Inline/inline.scm 75 */
							BgL_testz00_3812 = ((bool_t) 0);
						}
					if (BgL_testz00_3812)
						{	/* Inline/inline.scm 75 */
							{	/* Inline/inline.scm 83 */
								obj_t BgL_arg3322z00_1265;

								obj_t BgL_arg3323z00_1266;

								{
									BgL_nodez00_bglt BgL_auxz00_3837;

									BgL_auxz00_3837 = (BgL_nodez00_bglt) (BgL_nodez00_1256);
									BgL_arg3322z00_1265 =
										(((BgL_nodez00_bglt) CREF(BgL_auxz00_3837))->BgL_locz00);
								}
								{	/* Inline/inline.scm 83 */
									BgL_globalz00_bglt BgL_obj1533z00_1730;

									BgL_obj1533z00_1730 =
										(BgL_globalz00_bglt) (
										(((BgL_varz00_bglt) CREF(BgL_nodez00_1256))->
											BgL_variablez00));
									BgL_arg3323z00_1266 =
										(((BgL_globalz00_bglt) CREF(BgL_obj1533z00_1730))->
										BgL_srcz00);
								}
								return
									(obj_t) (BGl_alphatiza7eza7zzast_alphatiza7eza7(BNIL, BNIL,
										BgL_arg3322z00_1265,
										(BgL_nodez00_bglt) (BgL_arg3323z00_1266)));
							}
						}
					else
						{	/* Inline/inline.scm 75 */
							return (obj_t) (BgL_nodez00_1256);
						}
				}
			}
		}
	}



/* inline-node-atom3198 */
	obj_t BGl_inlinezd2nodezd2atom3198z00zzinline_inlinez00(obj_t BgL_envz00_2692,
		obj_t BgL_nodez00_2693, obj_t BgL_kfactorz00_2694, obj_t BgL_stackz00_2695)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 67 */
			return (obj_t) ((BgL_atomz00_bglt) (BgL_nodez00_2693));
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3542z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3542z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3542z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3542z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzinline_walkz00(((long) 175384950),
				BSTRING_TO_STRING(BGl_string3542z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzinline_appz00(((long) 472786230),
				BSTRING_TO_STRING(BGl_string3542z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzast_alphatiza7eza7(((long) 509694479),
				BSTRING_TO_STRING(BGl_string3542z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 446742181),
				BSTRING_TO_STRING(BGl_string3542z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3542z00zzinline_inlinez00));
			return
				BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3542z00zzinline_inlinez00));
		}
	}

#ifdef __cplusplus
}
#endif
