/*===========================================================================*/
/*   (Trace/walk.scm)                                                        */
/*   Bigloo (3.2b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon May 25 12:42:12 CEST 2009       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Trace/walk.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;


	static obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	static obj_t BGl_findzd2lastzd2nodezd2letzd2f3265z00zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2jumpzd2exzd2i3299z00zztrace_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_tracezd2nodezd2extern3281z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2appzd2l3249z00zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2appzd2ly3277zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_enterzd2functionzd2zztools_errorz00(obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_findzd2lastzd2nodezd2setzd2e3267z00zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_cnstzd2initzd2zztrace_walkz00();
	static BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt,
		obj_t);
	static obj_t BGl_tracezd2nodezd2condition3287z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	extern obj_t BGl_variablez00zzast_varz00;
	static obj_t BGl_tracezd2nodezd2letzd2fun3293zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	static obj_t BGl_tracezd2nodezd2sequence3273z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2app3275z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_findzd2lastzd2nodezd2setq3255zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2initzd2zztrace_walkz00();
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2letzd2v3263z00zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	static obj_t BGl_tracezd2nodezd2letzd2var3295zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2boxzd2setz123305zc0zztrace_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2app3247zd2zztrace_walkz00(obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	static obj_t BGl_tracezd2nodezd2select3291z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_leavezd2functionzd2zztools_errorz00();
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	static obj_t BGl_toplevelzd2tracezd2nodezd23309zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2tracezd2nodezd23311zd2zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl__findzd2lastzd2nodez00zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2selec3261zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2setzd2exzd2it3297z00zztrace_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static obj_t BGl__toplevelzd2tracezd2nodez00zztrace_walkz00(obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2fail3259zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2funca3251zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_methodzd2initzd2zztrace_walkz00();
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	static obj_t BGl__findzd2lastzd2nodezd2defau3241zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl__tracezd2nodezd2zztrace_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zztrace_walkz00 = BUNSPEC;
	extern obj_t BGl_za2bmemzd2profilingza2zd2zzengine_paramz00;
	static obj_t BGl_tracezd2nodezd2makezd2box3301zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zztrace_walkz00();
	extern obj_t BGl_pragmaz00zzast_nodez00;
	static obj_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2seque3245zd2zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t BGl_findzd2lastzd2nodezd2condi3257zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2cast3283z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t BGl__tracezd2nodezd2default3270z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
	static BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt,
		BgL_typez00_bglt, obj_t, obj_t, obj_t);
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	static obj_t BGl__toplevelzd2tracezd2nodezd23306zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00();
	BGL_EXPORTED_DECL obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t);
	BGL_IMPORT obj_t bgl_display_string(obj_t, obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_tracezd2nodezd2funcall3279z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2setq3285z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t string_to_symbol(char *);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl__tracezd2walkz12zc0zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2jumpzd23269z00zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	static obj_t BGl_findzd2lastzd2nodezd2exter3253zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2boxzd2ref3303zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
	static obj_t BGl_tracezd2nodezd2fail3289z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t __cnst[15];


	   
		 
		DEFINE_STRING(BGl_string3800z00zztrace_walkz00,
		BgL_bgl_string3800za700za7za7t3838za7, "%import@", 8);
	      DEFINE_STRING(BGl_string3801z00zztrace_walkz00,
		BgL_bgl_string3801za700za7za7t3839za7, ", ~a:~a", 7);
	      DEFINE_STRING(BGl_string3791z00zztrace_walkz00,
		BgL_bgl_string3791za700za7za7t3840za7, "Trace", 5);
	      DEFINE_STRING(BGl_string3792z00zztrace_walkz00,
		BgL_bgl_string3792za700za7za7t3841za7, "   . ", 5);
	      DEFINE_STRING(BGl_string3793z00zztrace_walkz00,
		BgL_bgl_string3793za700za7za7t3842za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string3794z00zztrace_walkz00,
		BgL_bgl_string3794za700za7za7t3843za7, " error", 6);
	      DEFINE_STRING(BGl_string3795z00zztrace_walkz00,
		BgL_bgl_string3795za700za7za7t3844za7, "s", 1);
	      DEFINE_STRING(BGl_string3796z00zztrace_walkz00,
		BgL_bgl_string3796za700za7za7t3845za7, "", 0);
	      DEFINE_STRING(BGl_string3797z00zztrace_walkz00,
		BgL_bgl_string3797za700za7za7t3846za7, " occured, ending ...", 20);
	      DEFINE_STRING(BGl_string3798z00zztrace_walkz00,
		BgL_bgl_string3798za700za7za7t3847za7, "failure during postlude hook", 28);
	      DEFINE_STRING(BGl_string3799z00zztrace_walkz00,
		BgL_bgl_string3799za700za7za7t3848za7, "%toplevel@", 10);
	      DEFINE_STRING(BGl_string3834z00zztrace_walkz00,
		BgL_bgl_string3834za700za7za7t3849za7, "trace_walk", 10);
	      DEFINE_STRING(BGl_string3835z00zztrace_walkz00,
		BgL_bgl_string3835za700za7za7t3850za7,
		"done value ($pop-trace) $pop-trace $push-trace quote let location |:| symbol aux no-trace imported-modules-init toplevel-init pass-started ",
		139);
	      DEFINE_STATIC_BGL_GENERIC(BGl_tracezd2nodezd2envz00zztrace_walkz00,
		BgL_bgl__traceza7d2nodeza7d23851z00, BGl__tracezd2nodezd2zztrace_walkz00,
		0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl__findza7d2lastza7d2n3852z00,
		BGl__findzd2lastzd2nodez00zztrace_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_tracezd2nodezd2default3270zd2envzd2zztrace_walkz00,
		BgL_bgl__traceza7d2nodeza7d23853z00,
		BGl__tracezd2nodezd2default3270z00zztrace_walkz00, 0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl__toplevelza7d2trac3854za7,
		BGl__toplevelzd2tracezd2nodez00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_tracezd2walkz12zd2envz12zztrace_walkz00,
		BgL_bgl__traceza7d2walkza7123855z00, BGl__tracezd2walkz12zc0zztrace_walkz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_toplevelzd2tracezd2nodezd23306zd2envz00zztrace_walkz00,
		BgL_bgl__toplevelza7d2trac3856za7,
		BGl__toplevelzd2tracezd2nodezd23306zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_findzd2lastzd2nodezd2defau3241zd2envz00zztrace_walkz00,
		BgL_bgl__findza7d2lastza7d2n3857z00,
		BGl__findzd2lastzd2nodezd2defau3241zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3802z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3858z00,
		BGl_findzd2lastzd2nodezd2seque3245zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3803z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3859z00,
		BGl_findzd2lastzd2nodezd2app3247zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3804z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3860z00,
		BGl_findzd2lastzd2nodezd2appzd2l3249z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3805z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3861z00,
		BGl_findzd2lastzd2nodezd2funca3251zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3806z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3862z00,
		BGl_findzd2lastzd2nodezd2exter3253zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3807z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3863z00,
		BGl_findzd2lastzd2nodezd2setq3255zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3808z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3864z00,
		BGl_findzd2lastzd2nodezd2condi3257zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3810z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3865z00,
		BGl_findzd2lastzd2nodezd2selec3261zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3809z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3866z00,
		BGl_findzd2lastzd2nodezd2fail3259zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3811z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3867z00,
		BGl_findzd2lastzd2nodezd2letzd2v3263z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3812z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3868z00,
		BGl_findzd2lastzd2nodezd2letzd2f3265z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3813z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3869z00,
		BGl_findzd2lastzd2nodezd2setzd2e3267z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3814z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3870z00,
		BGl_findzd2lastzd2nodezd2jumpzd23269z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3815z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2s3871z00,
		BGl_tracezd2nodezd2sequence3273z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3816z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2a3872z00,
		BGl_tracezd2nodezd2app3275z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3817z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2a3873z00,
		BGl_tracezd2nodezd2appzd2ly3277zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3818z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2f3874z00,
		BGl_tracezd2nodezd2funcall3279z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3820z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2c3875z00,
		BGl_tracezd2nodezd2cast3283z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3819z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2e3876z00,
		BGl_tracezd2nodezd2extern3281z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3821z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2s3877z00,
		BGl_tracezd2nodezd2setq3285z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3822z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2c3878z00,
		BGl_tracezd2nodezd2condition3287z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3823z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2f3879z00,
		BGl_tracezd2nodezd2fail3289z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3824z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2s3880z00,
		BGl_tracezd2nodezd2select3291z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3825z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2l3881z00,
		BGl_tracezd2nodezd2letzd2fun3293zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3826z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2l3882z00,
		BGl_tracezd2nodezd2letzd2var3295zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3827z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2s3883z00,
		BGl_tracezd2nodezd2setzd2exzd2it3297z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3828z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2j3884z00,
		BGl_tracezd2nodezd2jumpzd2exzd2i3299z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3830z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2b3885z00,
		BGl_tracezd2nodezd2boxzd2ref3303zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3829z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2m3886z00,
		BGl_tracezd2nodezd2makezd2box3301zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3831z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2b3887z00,
		BGl_tracezd2nodezd2boxzd2setz123305zc0zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3832z00zztrace_walkz00,
		BgL_bgl_toplevelza7d2trace3888za7,
		BGl_toplevelzd2tracezd2nodezd23309zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3833z00zztrace_walkz00,
		BgL_bgl_toplevelza7d2trace3889za7,
		BGl_toplevelzd2tracezd2nodezd23311zd2zztrace_walkz00, 0L, BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long
		BgL_checksumz00_3438, char *BgL_fromz00_3439)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zztrace_walkz00))
				{
					BGl_requirezd2initializa7ationz75zztrace_walkz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
					BGl_cnstzd2initzd2zztrace_walkz00();
					BGl_importedzd2moduleszd2initz00zztrace_walkz00();
					BGl_genericzd2initzd2zztrace_walkz00();
					BGl_methodzd2initzd2zztrace_walkz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"trace_walk");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			{	/* Trace/walk.scm 15 */
				obj_t BgL_cportz00_3426;

				BgL_cportz00_3426 =
					bgl_open_input_string(BGl_string3835z00zztrace_walkz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_3427;

					BgL_iz00_3427 = ((long) 14);
				BgL_loopz00_3428:
					if ((BgL_iz00_3427 == ((long) -1)))
						{	/* Trace/walk.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Trace/walk.scm 15 */
							{	/* Trace/walk.scm 15 */
								obj_t BgL_arg3837z00_3430;

								{	/* Trace/walk.scm 15 */

									{	/* Trace/walk.scm 15 */
										obj_t BgL_locationz00_3432;

										BgL_locationz00_3432 = BBOOL(((bool_t) 0));
										{	/* Trace/walk.scm 15 */

											BgL_arg3837z00_3430 =
												BGl_readz00zz__readerz00(BgL_cportz00_3426,
												BgL_locationz00_3432);
										}
									}
								}
								{	/* Trace/walk.scm 15 */
									int BgL_auxz00_3463;

									BgL_auxz00_3463 = (int) (BgL_iz00_3427);
									CNST_TABLE_SET(BgL_auxz00_3463, BgL_arg3837z00_3430);
							}}
							{	/* Trace/walk.scm 15 */
								int BgL_auxz00_3433;

								BgL_auxz00_3433 = (int) ((BgL_iz00_3427 - ((long) 1)));
								{
									long BgL_iz00_3468;

									BgL_iz00_3468 = (long) (BgL_auxz00_3433);
									BgL_iz00_3427 = BgL_iz00_3468;
									goto BgL_loopz00_3428;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return BUNSPEC;
		}
	}



/* trace-walk! */
	BGL_EXPORTED_DEF obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t
		BgL_globalsz00_15)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 36 */
			{	/* Trace/walk.scm 37 */
				obj_t BgL_list3321z00_915;

				{	/* Trace/walk.scm 37 */
					obj_t BgL_arg3323z00_917;

					{	/* Trace/walk.scm 37 */
						obj_t BgL_arg3325z00_919;

						BgL_arg3325z00_919 = MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
						BgL_arg3323z00_917 =
							MAKE_PAIR(BGl_string3791z00zztrace_walkz00, BgL_arg3325z00_919);
					}
					BgL_list3321z00_915 =
						MAKE_PAIR(BGl_string3792z00zztrace_walkz00, BgL_arg3323z00_917);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list3321z00_915);
			}
			BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = BINT(((long) 0));
			BGl_za2currentzd2passza2zd2zzengine_passz00 =
				BGl_string3791z00zztrace_walkz00;
			{
				obj_t BgL_hooksz00_922;

				obj_t BgL_hnamesz00_923;

				BgL_hooksz00_922 = BNIL;
				BgL_hnamesz00_923 = BNIL;
			BgL_loopz00_924:
				if (NULLP(BgL_hooksz00_922))
					{	/* Trace/walk.scm 37 */
						CNST_TABLE_REF(((long) 0));
					}
				else
					{	/* Trace/walk.scm 37 */
						bool_t BgL_testz00_3480;

						{	/* Trace/walk.scm 37 */
							obj_t BgL_fun3333z00_932;

							BgL_fun3333z00_932 = CAR(BgL_hooksz00_922);
							BgL_testz00_3480 =
								CBOOL(PROCEDURE_ENTRY(BgL_fun3333z00_932) (BgL_fun3333z00_932,
									BEOA));
						}
						if (BgL_testz00_3480)
							{
								obj_t BgL_hnamesz00_3487;

								obj_t BgL_hooksz00_3485;

								BgL_hooksz00_3485 = CDR(BgL_hooksz00_922);
								BgL_hnamesz00_3487 = CDR(BgL_hnamesz00_923);
								BgL_hnamesz00_923 = BgL_hnamesz00_3487;
								BgL_hooksz00_922 = BgL_hooksz00_3485;
								goto BgL_loopz00_924;
							}
						else
							{	/* Trace/walk.scm 37 */
								BGl_internalzd2errorzd2zztools_errorz00
									(BGl_string3791z00zztrace_walkz00,
									BGl_string3793z00zztrace_walkz00, CAR(BgL_hnamesz00_923));
							}
					}
			}
			{	/* Trace/walk.scm 43 */
				obj_t BgL_idz00_934;

				BgL_idz00_934 = CNST_TABLE_REF(((long) 1));
				{	/* Trace/walk.scm 43 */
					obj_t BgL_gloz00_935;

					{	/* Trace/walk.scm 44 */
						obj_t BgL_list3338z00_940;

						BgL_list3338z00_940 =
							MAKE_PAIR(BGl_za2moduleza2z00zzmodule_modulez00, BNIL);
						BgL_gloz00_935 =
							BGl_findzd2globalzd2zzast_envz00(BgL_idz00_934,
							BgL_list3338z00_940);
					}
					{	/* Trace/walk.scm 44 */

						if (BGl_iszd2azf3z21zz__objectz00(BgL_gloz00_935,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 46 */
								BgL_valuez00_bglt BgL_instance3191z00_937;

								{
									BgL_variablez00_bglt BgL_auxz00_3496;

									BgL_auxz00_3496 = (BgL_variablez00_bglt) (BgL_gloz00_935);
									BgL_instance3191z00_937 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_3496))->
										BgL_valuez00);
								}
								{	/* Trace/walk.scm 47 */
									BgL_nodez00_bglt BgL_arg3336z00_938;

									{	/* Trace/walk.scm 47 */
										obj_t BgL_arg3337z00_939;

										{
											BgL_sfunz00_bglt BgL_auxz00_3499;

											BgL_auxz00_3499 =
												(BgL_sfunz00_bglt) (BgL_instance3191z00_937);
											BgL_arg3337z00_939 =
												(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3499))->
												BgL_bodyz00);
										}
										{	/* Trace/walk.scm 47 */
											BgL_nodez00_bglt BgL_res3671z00_1847;

											{	/* Trace/walk.scm 47 */
												BgL_nodez00_bglt BgL_nodez00_1821;

												BgL_nodez00_1821 =
													(BgL_nodez00_bglt) (BgL_arg3337z00_939);
												{	/* Trace/walk.scm 47 */
													obj_t BgL_method3307z00_1822;

													{	/* Trace/walk.scm 47 */
														BgL_objectz00_bglt BgL_objz00_1823;

														BgL_objz00_1823 =
															(BgL_objectz00_bglt) (BgL_nodez00_1821);
														{	/* Trace/walk.scm 47 */
															long BgL_objzd2classzd2numz00_1824;

															BgL_objzd2classzd2numz00_1824 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_1823);
															{	/* Trace/walk.scm 47 */
																obj_t BgL_arg2356z00_1825;

																BgL_arg2356z00_1825 =
																	PROCEDURE_REF
																	(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
																	(int) (((long) 1)));
																{	/* Trace/walk.scm 47 */
																	obj_t BgL_arrayz00_1827;

																	int BgL_offsetz00_1828;

																	BgL_arrayz00_1827 = BgL_arg2356z00_1825;
																	BgL_offsetz00_1828 =
																		(int) (BgL_objzd2classzd2numz00_1824);
																	{	/* Trace/walk.scm 47 */
																		long BgL_offsetz00_1829;

																		BgL_offsetz00_1829 =
																			(
																			(long) (BgL_offsetz00_1828) -
																			OBJECT_TYPE);
																		{	/* Trace/walk.scm 47 */
																			long BgL_modz00_1830;

																			{	/* Trace/walk.scm 47 */
																				int BgL_arg2358z00_1831;

																				BgL_arg2358z00_1831 =
																					(int) (((long) 8));
																				{	/* Trace/walk.scm 47 */
																					long BgL_auxz00_3511;

																					BgL_auxz00_3511 =
																						(long) (BgL_arg2358z00_1831);
																					BgL_modz00_1830 =
																						(BgL_offsetz00_1829 /
																						BgL_auxz00_3511);
																			}}
																			{	/* Trace/walk.scm 47 */
																				long BgL_restz00_1832;

																				{	/* Trace/walk.scm 47 */
																					int BgL_arg2357z00_1833;

																					BgL_arg2357z00_1833 =
																						(int) (((long) 8));
																					{	/* Trace/walk.scm 47 */
																						long BgL_auxz00_3515;

																						BgL_auxz00_3515 =
																							(long) (BgL_arg2357z00_1833);
																						BgL_restz00_1832 =
																							(BgL_offsetz00_1829 %
																							BgL_auxz00_3515);
																				}}
																				{	/* Trace/walk.scm 47 */

																					BgL_method3307z00_1822 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_1827,
																							(int) (BgL_modz00_1830)),
																						(int) (BgL_restz00_1832));
													}}}}}}}}
													BgL_res3671z00_1847 =
														(BgL_nodez00_bglt) (PROCEDURE_ENTRY
														(BgL_method3307z00_1822) (BgL_method3307z00_1822,
															(obj_t) (BgL_nodez00_1821), BEOA));
											}}
											BgL_arg3336z00_938 = BgL_res3671z00_1847;
									}}
									{
										obj_t BgL_auxz00_3528;

										BgL_sfunz00_bglt BgL_auxz00_3526;

										BgL_auxz00_3528 = (obj_t) (BgL_arg3336z00_938);
										BgL_auxz00_3526 =
											(BgL_sfunz00_bglt) (BgL_instance3191z00_937);
										((((BgL_sfunz00_bglt) CREF(BgL_auxz00_3526))->BgL_bodyz00) =
											((obj_t) BgL_auxz00_3528), BUNSPEC);
							}}}
						else
							{	/* Trace/walk.scm 45 */
								BFALSE;
							}
					}
				}
			}
			{
				obj_t BgL_l3228z00_941;

				BgL_l3228z00_941 = BgL_globalsz00_15;
			BgL_forzd2each3229zd2_942:
				if (PAIRP(BgL_l3228z00_941))
					{	/* Trace/walk.scm 49 */
						BGl_tracezd2funz12zc0zztrace_walkz00(CAR(BgL_l3228z00_941), BNIL);
						{
							obj_t BgL_l3228z00_3535;

							BgL_l3228z00_3535 = CDR(BgL_l3228z00_941);
							BgL_l3228z00_941 = BgL_l3228z00_3535;
							goto BgL_forzd2each3229zd2_942;
						}
					}
				else
					{	/* Trace/walk.scm 49 */
						((bool_t) 1);
					}
			}
			if (
				((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
					((long) 0)))
				{	/* Trace/walk.scm 50 */
					{	/* Trace/walk.scm 50 */
						obj_t BgL_port3230z00_948;

						{	/* Trace/walk.scm 50 */
							obj_t BgL_res3672z00_1856;

							{	/* Trace/walk.scm 50 */
								obj_t BgL_auxz00_3540;

								BgL_auxz00_3540 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3672z00_1856 =
									BGL_ENV_CURRENT_ERROR_PORT(BgL_auxz00_3540);
							}
							BgL_port3230z00_948 = BgL_res3672z00_1856;
						}
						bgl_display_obj(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
							BgL_port3230z00_948);
						bgl_display_string(BGl_string3794z00zztrace_walkz00,
							BgL_port3230z00_948);
						{	/* Trace/walk.scm 50 */
							obj_t BgL_arg3342z00_949;

							{	/* Trace/walk.scm 50 */
								bool_t BgL_testz00_3545;

								if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
									{	/* Trace/walk.scm 50 */
										BgL_testz00_3545 =
											BGl_2ze3ze3zz__r4_numbers_6_5z00
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
											BINT(((long) 1)));
									}
								else
									{	/* Trace/walk.scm 50 */
										BgL_testz00_3545 = ((bool_t) 0);
									}
								if (BgL_testz00_3545)
									{	/* Trace/walk.scm 50 */
										BgL_arg3342z00_949 = BGl_string3795z00zztrace_walkz00;
									}
								else
									{	/* Trace/walk.scm 50 */
										BgL_arg3342z00_949 = BGl_string3796z00zztrace_walkz00;
									}
							}
							bgl_display_obj(BgL_arg3342z00_949, BgL_port3230z00_948);
						}
						bgl_display_string(BGl_string3797z00zztrace_walkz00,
							BgL_port3230z00_948);
						bgl_display_char(((unsigned char) '\n'), BgL_port3230z00_948);
					}
					{	/* Trace/walk.scm 50 */
						obj_t BgL_list3345z00_952;

						BgL_list3345z00_952 = MAKE_PAIR(BINT(((long) -1)), BNIL);
						return BGl_exitz00zz__errorz00(BgL_list3345z00_952);
					}
				}
			else
				{
					obj_t BgL_hooksz00_955;

					obj_t BgL_hnamesz00_956;

					BgL_hooksz00_955 = BNIL;
					BgL_hnamesz00_956 = BNIL;
				BgL_loopz00_957:
					if (NULLP(BgL_hooksz00_955))
						{	/* Trace/walk.scm 50 */
							return BgL_globalsz00_15;
						}
					else
						{	/* Trace/walk.scm 50 */
							bool_t BgL_testz00_3558;

							{	/* Trace/walk.scm 50 */
								obj_t BgL_fun3352z00_964;

								BgL_fun3352z00_964 = CAR(BgL_hooksz00_955);
								BgL_testz00_3558 =
									CBOOL(PROCEDURE_ENTRY(BgL_fun3352z00_964) (BgL_fun3352z00_964,
										BEOA));
							}
							if (BgL_testz00_3558)
								{
									obj_t BgL_hnamesz00_3565;

									obj_t BgL_hooksz00_3563;

									BgL_hooksz00_3563 = CDR(BgL_hooksz00_955);
									BgL_hnamesz00_3565 = CDR(BgL_hnamesz00_956);
									BgL_hnamesz00_956 = BgL_hnamesz00_3565;
									BgL_hooksz00_955 = BgL_hooksz00_3563;
									goto BgL_loopz00_957;
								}
							else
								{	/* Trace/walk.scm 50 */
									obj_t BgL_arg3351z00_963;

									BgL_arg3351z00_963 = CAR(BgL_hnamesz00_956);
									return
										BGl_internalzd2errorzd2zztools_errorz00
										(BGl_za2currentzd2passza2zd2zzengine_passz00,
										BGl_string3798z00zztrace_walkz00, BgL_arg3351z00_963);
								}
						}
				}
		}
	}



/* _trace-walk! */
	obj_t BGl__tracezd2walkz12zc0zztrace_walkz00(obj_t BgL_envz00_3296,
		obj_t BgL_globalsz00_3297)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 36 */
			return BGl_tracezd2walkz12zc0zztrace_walkz00(BgL_globalsz00_3297);
		}
	}



/* trace-id */
	obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t BgL_variablez00_16)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 61 */
			{	/* Trace/walk.scm 63 */
				bool_t BgL_testz00_3570;

				if (BGl_iszd2azf3z21zz__objectz00(BgL_variablez00_16,
						BGl_globalz00zzast_varz00))
					{	/* Trace/walk.scm 64 */
						obj_t BgL_auxz00_3573;

						{
							BgL_variablez00_bglt BgL_auxz00_3574;

							BgL_auxz00_3574 = (BgL_variablez00_bglt) (BgL_variablez00_16);
							BgL_auxz00_3573 =
								(((BgL_variablez00_bglt) CREF(BgL_auxz00_3574))->BgL_idz00);
						}
						BgL_testz00_3570 = (BgL_auxz00_3573 == CNST_TABLE_REF(((long) 1)));
					}
				else
					{	/* Trace/walk.scm 63 */
						BgL_testz00_3570 = ((bool_t) 0);
					}
				if (BgL_testz00_3570)
					{	/* Trace/walk.scm 65 */
						obj_t BgL_arg3355z00_967;

						{	/* Trace/walk.scm 65 */
							obj_t BgL_arg3356z00_968;

							obj_t BgL_arg3357z00_969;

							BgL_arg3356z00_968 =
								SYMBOL_TO_STRING(string_to_symbol(BSTRING_TO_STRING
									(BGl_string3799z00zztrace_walkz00)));
							{	/* Trace/walk.scm 65 */
								obj_t BgL_arg3361z00_973;

								{
									BgL_globalz00_bglt BgL_auxz00_3582;

									BgL_auxz00_3582 = (BgL_globalz00_bglt) (BgL_variablez00_16);
									BgL_arg3361z00_973 =
										(((BgL_globalz00_bglt) CREF(BgL_auxz00_3582))->
										BgL_modulez00);
								}
								BgL_arg3357z00_969 = SYMBOL_TO_STRING(BgL_arg3361z00_973);
							}
							{	/* Trace/walk.scm 65 */
								obj_t BgL_list3358z00_970;

								{	/* Trace/walk.scm 65 */
									obj_t BgL_arg3359z00_971;

									BgL_arg3359z00_971 = MAKE_PAIR(BgL_arg3357z00_969, BNIL);
									BgL_list3358z00_970 =
										MAKE_PAIR(BgL_arg3356z00_968, BgL_arg3359z00_971);
								}
								BgL_arg3355z00_967 =
									BGl_stringzd2appendzd2zz__r4_strings_6_7z00
									(BgL_list3358z00_970);
							}
						}
						return string_to_symbol(BSTRING_TO_STRING(BgL_arg3355z00_967));
					}
				else
					{	/* Trace/walk.scm 66 */
						bool_t BgL_testz00_3591;

						if (BGl_iszd2azf3z21zz__objectz00(BgL_variablez00_16,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 67 */
								obj_t BgL_auxz00_3594;

								{
									BgL_variablez00_bglt BgL_auxz00_3595;

									BgL_auxz00_3595 = (BgL_variablez00_bglt) (BgL_variablez00_16);
									BgL_auxz00_3594 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_3595))->BgL_idz00);
								}
								BgL_testz00_3591 =
									(BgL_auxz00_3594 == CNST_TABLE_REF(((long) 2)));
							}
						else
							{	/* Trace/walk.scm 66 */
								BgL_testz00_3591 = ((bool_t) 0);
							}
						if (BgL_testz00_3591)
							{	/* Trace/walk.scm 68 */
								obj_t BgL_arg3363z00_975;

								{	/* Trace/walk.scm 68 */
									obj_t BgL_arg3364z00_976;

									obj_t BgL_arg3365z00_977;

									BgL_arg3364z00_976 =
										SYMBOL_TO_STRING(string_to_symbol(BSTRING_TO_STRING
											(BGl_string3800z00zztrace_walkz00)));
									{	/* Trace/walk.scm 68 */
										obj_t BgL_arg3369z00_981;

										{
											BgL_globalz00_bglt BgL_auxz00_3603;

											BgL_auxz00_3603 =
												(BgL_globalz00_bglt) (BgL_variablez00_16);
											BgL_arg3369z00_981 =
												(((BgL_globalz00_bglt) CREF(BgL_auxz00_3603))->
												BgL_modulez00);
										}
										BgL_arg3365z00_977 = SYMBOL_TO_STRING(BgL_arg3369z00_981);
									}
									{	/* Trace/walk.scm 68 */
										obj_t BgL_list3366z00_978;

										{	/* Trace/walk.scm 68 */
											obj_t BgL_arg3367z00_979;

											BgL_arg3367z00_979 = MAKE_PAIR(BgL_arg3365z00_977, BNIL);
											BgL_list3366z00_978 =
												MAKE_PAIR(BgL_arg3364z00_976, BgL_arg3367z00_979);
										}
										BgL_arg3363z00_975 =
											BGl_stringzd2appendzd2zz__r4_strings_6_7z00
											(BgL_list3366z00_978);
									}
								}
								return string_to_symbol(BSTRING_TO_STRING(BgL_arg3363z00_975));
							}
						else
							{
								BgL_variablez00_bglt BgL_auxz00_3612;

								BgL_auxz00_3612 = (BgL_variablez00_bglt) (BgL_variablez00_16);
								return
									(((BgL_variablez00_bglt) CREF(BgL_auxz00_3612))->BgL_idz00);
							}
					}
			}
		}
	}



/* trace-fun! */
	obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t BgL_varz00_17,
		obj_t BgL_stackz00_18)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 78 */
			{	/* Trace/walk.scm 79 */
				BgL_valuez00_bglt BgL_funz00_988;

				{
					BgL_variablez00_bglt BgL_auxz00_3615;

					BgL_auxz00_3615 = (BgL_variablez00_bglt) (BgL_varz00_17);
					BgL_funz00_988 =
						(((BgL_variablez00_bglt) CREF(BgL_auxz00_3615))->BgL_valuez00);
				}
				{	/* Trace/walk.scm 79 */
					obj_t BgL_bodyz00_989;

					{
						BgL_sfunz00_bglt BgL_auxz00_3618;

						BgL_auxz00_3618 = (BgL_sfunz00_bglt) (BgL_funz00_988);
						BgL_bodyz00_989 =
							(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3618))->BgL_bodyz00);
					}
					{	/* Trace/walk.scm 80 */
						BgL_typez00_bglt BgL_typez00_990;

						{
							BgL_variablez00_bglt BgL_auxz00_3621;

							BgL_auxz00_3621 = (BgL_variablez00_bglt) (BgL_varz00_17);
							BgL_typez00_990 =
								(((BgL_variablez00_bglt) CREF(BgL_auxz00_3621))->BgL_typez00);
						}
						{	/* Trace/walk.scm 81 */
							obj_t BgL_llocz00_991;

							if (BGl_iszd2azf3z21zz__objectz00(BgL_varz00_17,
									BGl_globalz00zzast_varz00))
								{	/* Trace/walk.scm 83 */
									obj_t BgL_arg3389z00_1008;

									{	/* Trace/walk.scm 83 */
										obj_t BgL_auxz00_3626;

										{
											BgL_globalz00_bglt BgL_auxz00_3627;

											BgL_auxz00_3627 = (BgL_globalz00_bglt) (BgL_varz00_17);
											BgL_auxz00_3626 =
												(((BgL_globalz00_bglt) CREF(BgL_auxz00_3627))->
												BgL_srcz00);
										}
										BgL_arg3389z00_1008 =
											BGl_findzd2lastzd2sexpz00zztrace_walkz00(BgL_auxz00_3626);
									}
									BgL_llocz00_991 =
										BGl_findzd2locationzd2zztools_locationz00
										(BgL_arg3389z00_1008);
								}
							else
								{	/* Trace/walk.scm 84 */
									obj_t BgL_arg3391z00_1010;

									{	/* Trace/walk.scm 84 */
										BgL_nodez00_bglt BgL_nodez00_1889;

										BgL_nodez00_1889 = (BgL_nodez00_bglt) (BgL_bodyz00_989);
										{	/* Trace/walk.scm 84 */
											obj_t BgL_method3242z00_1890;

											{	/* Trace/walk.scm 84 */
												BgL_objectz00_bglt BgL_objz00_1891;

												BgL_objz00_1891 =
													(BgL_objectz00_bglt) (BgL_nodez00_1889);
												{	/* Trace/walk.scm 84 */
													long BgL_objzd2classzd2numz00_1892;

													BgL_objzd2classzd2numz00_1892 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_1891);
													{	/* Trace/walk.scm 84 */
														obj_t BgL_arg2356z00_1893;

														BgL_arg2356z00_1893 =
															PROCEDURE_REF
															(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
															(int) (((long) 1)));
														{	/* Trace/walk.scm 84 */
															obj_t BgL_arrayz00_1895;

															int BgL_offsetz00_1896;

															BgL_arrayz00_1895 = BgL_arg2356z00_1893;
															BgL_offsetz00_1896 =
																(int) (BgL_objzd2classzd2numz00_1892);
															{	/* Trace/walk.scm 84 */
																long BgL_offsetz00_1897;

																BgL_offsetz00_1897 =
																	((long) (BgL_offsetz00_1896) - OBJECT_TYPE);
																{	/* Trace/walk.scm 84 */
																	long BgL_modz00_1898;

																	{	/* Trace/walk.scm 84 */
																		int BgL_arg2358z00_1899;

																		BgL_arg2358z00_1899 = (int) (((long) 8));
																		{	/* Trace/walk.scm 84 */
																			long BgL_auxz00_3641;

																			BgL_auxz00_3641 =
																				(long) (BgL_arg2358z00_1899);
																			BgL_modz00_1898 =
																				(BgL_offsetz00_1897 / BgL_auxz00_3641);
																	}}
																	{	/* Trace/walk.scm 84 */
																		long BgL_restz00_1900;

																		{	/* Trace/walk.scm 84 */
																			int BgL_arg2357z00_1901;

																			BgL_arg2357z00_1901 = (int) (((long) 8));
																			{	/* Trace/walk.scm 84 */
																				long BgL_auxz00_3645;

																				BgL_auxz00_3645 =
																					(long) (BgL_arg2357z00_1901);
																				BgL_restz00_1900 =
																					(BgL_offsetz00_1897 %
																					BgL_auxz00_3645);
																		}}
																		{	/* Trace/walk.scm 84 */

																			BgL_method3242z00_1890 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_1895,
																					(int) (BgL_modz00_1898)),
																				(int) (BgL_restz00_1900));
											}}}}}}}}
											BgL_arg3391z00_1010 =
												PROCEDURE_ENTRY(BgL_method3242z00_1890)
												(BgL_method3242z00_1890, (obj_t) (BgL_nodez00_1889),
												BEOA);
									}}
									{
										BgL_nodez00_bglt BgL_auxz00_3655;

										BgL_auxz00_3655 = (BgL_nodez00_bglt) (BgL_arg3391z00_1010);
										BgL_llocz00_991 =
											(((BgL_nodez00_bglt) CREF(BgL_auxz00_3655))->BgL_locz00);
								}}
							{	/* Trace/walk.scm 82 */

								{	/* Trace/walk.scm 85 */
									bool_t BgL_testz00_3658;

									{	/* Trace/walk.scm 85 */
										bool_t BgL_testz00_3659;

										{	/* Trace/walk.scm 85 */
											BgL_funz00_bglt BgL_obj1656z00_1916;

											BgL_obj1656z00_1916 = (BgL_funz00_bglt) (BgL_funz00_988);
											BgL_testz00_3659 =
												CBOOL(
												(((BgL_funz00_bglt) CREF(BgL_obj1656z00_1916))->
													BgL_predicatezd2ofzd2));
										}
										if (BgL_testz00_3659)
											{	/* Trace/walk.scm 85 */
												BgL_testz00_3658 = ((bool_t) 0);
											}
										else
											{	/* Trace/walk.scm 86 */
												bool_t BgL_testz00_3663;

												{	/* Trace/walk.scm 86 */
													obj_t BgL_auxz00_3664;

													{	/* Trace/walk.scm 86 */
														obj_t BgL_auxz00_3665;

														{
															BgL_sfunz00_bglt BgL_auxz00_3667;

															BgL_auxz00_3667 =
																(BgL_sfunz00_bglt) (BgL_funz00_988);
															BgL_auxz00_3665 =
																(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3667))->
																BgL_propertyz00);
														}
														BgL_auxz00_3664 =
															BGl_memqz00zz__r4_pairs_and_lists_6_3z00
															(CNST_TABLE_REF(((long) 3)), BgL_auxz00_3665);
													}
													BgL_testz00_3663 = CBOOL(BgL_auxz00_3664);
												}
												if (BgL_testz00_3663)
													{	/* Trace/walk.scm 86 */
														BgL_testz00_3658 = ((bool_t) 0);
													}
												else
													{	/* Trace/walk.scm 86 */
														BgL_testz00_3658 = ((bool_t) 1);
													}
											}
									}
									if (BgL_testz00_3658)
										{	/* Trace/walk.scm 85 */
											BGl_enterzd2functionzd2zztools_errorz00
												(BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_17));
											{	/* Trace/walk.scm 89 */
												obj_t BgL_newzd2bodyzd2_994;

												{	/* Trace/walk.scm 89 */
													bool_t BgL_testz00_3674;

													if (
														((long)
															CINT
															(BGl_za2compilerzd2debugza2zd2zzengine_paramz00)
															>= ((long) 3)))
														{	/* Trace/walk.scm 89 */
															BgL_testz00_3674 = ((bool_t) 1);
														}
													else
														{	/* Trace/walk.scm 89 */
															if (BGl_iszd2azf3z21zz__objectz00(BgL_varz00_17,
																	BGl_globalz00zzast_varz00))
																{	/* Trace/walk.scm 91 */
																	obj_t BgL_auxz00_3680;

																	{
																		BgL_variablez00_bglt BgL_auxz00_3681;

																		BgL_auxz00_3681 =
																			(BgL_variablez00_bglt) (BgL_varz00_17);
																		BgL_auxz00_3680 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_3681))->BgL_idz00);
																	}
																	BgL_testz00_3674 =
																		(BgL_auxz00_3680 ==
																		CNST_TABLE_REF(((long) 1)));
																}
															else
																{	/* Trace/walk.scm 90 */
																	BgL_testz00_3674 = ((bool_t) 0);
																}
														}
													if (BgL_testz00_3674)
														{	/* Trace/walk.scm 100 */
															obj_t BgL_arg3380z00_998;

															BgL_arg3380z00_998 =
																MAKE_PAIR(BgL_varz00_17, BgL_stackz00_18);
															{	/* Trace/walk.scm 100 */
																BgL_nodez00_bglt BgL_res3678z00_1949;

																{	/* Trace/walk.scm 100 */
																	BgL_nodez00_bglt BgL_nodez00_1922;

																	BgL_nodez00_1922 =
																		(BgL_nodez00_bglt) (BgL_bodyz00_989);
																	{	/* Trace/walk.scm 100 */
																		obj_t BgL_method3271z00_1924;

																		{	/* Trace/walk.scm 100 */
																			BgL_objectz00_bglt BgL_objz00_1925;

																			BgL_objz00_1925 =
																				(BgL_objectz00_bglt) (BgL_nodez00_1922);
																			{	/* Trace/walk.scm 100 */
																				long BgL_objzd2classzd2numz00_1926;

																				BgL_objzd2classzd2numz00_1926 =
																					BGL_OBJECT_CLASS_NUM(BgL_objz00_1925);
																				{	/* Trace/walk.scm 100 */
																					obj_t BgL_arg2356z00_1927;

																					BgL_arg2356z00_1927 =
																						PROCEDURE_REF
																						(BGl_tracezd2nodezd2envz00zztrace_walkz00,
																						(int) (((long) 1)));
																					{	/* Trace/walk.scm 100 */
																						obj_t BgL_arrayz00_1929;

																						int BgL_offsetz00_1930;

																						BgL_arrayz00_1929 =
																							BgL_arg2356z00_1927;
																						BgL_offsetz00_1930 =
																							(int)
																							(BgL_objzd2classzd2numz00_1926);
																						{	/* Trace/walk.scm 100 */
																							long BgL_offsetz00_1931;

																							BgL_offsetz00_1931 =
																								(
																								(long) (BgL_offsetz00_1930) -
																								OBJECT_TYPE);
																							{	/* Trace/walk.scm 100 */
																								long BgL_modz00_1932;

																								{	/* Trace/walk.scm 100 */
																									int BgL_arg2358z00_1933;

																									BgL_arg2358z00_1933 =
																										(int) (((long) 8));
																									{	/* Trace/walk.scm 100 */
																										long BgL_auxz00_3696;

																										BgL_auxz00_3696 =
																											(long)
																											(BgL_arg2358z00_1933);
																										BgL_modz00_1932 =
																											(BgL_offsetz00_1931 /
																											BgL_auxz00_3696);
																								}}
																								{	/* Trace/walk.scm 100 */
																									long BgL_restz00_1934;

																									{	/* Trace/walk.scm 100 */
																										int BgL_arg2357z00_1935;

																										BgL_arg2357z00_1935 =
																											(int) (((long) 8));
																										{	/* Trace/walk.scm 100 */
																											long BgL_auxz00_3700;

																											BgL_auxz00_3700 =
																												(long)
																												(BgL_arg2357z00_1935);
																											BgL_restz00_1934 =
																												(BgL_offsetz00_1931 %
																												BgL_auxz00_3700);
																									}}
																									{	/* Trace/walk.scm 100 */

																										BgL_method3271z00_1924 =
																											VECTOR_REF(VECTOR_REF
																											(BgL_arrayz00_1929,
																												(int)
																												(BgL_modz00_1932)),
																											(int) (BgL_restz00_1934));
																		}}}}}}}}
																		BgL_res3678z00_1949 =
																			(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																			(BgL_method3271z00_1924)
																			(BgL_method3271z00_1924,
																				(obj_t) (BgL_nodez00_1922),
																				BgL_arg3380z00_998, BEOA));
																}}
																BgL_newzd2bodyzd2_994 =
																	(obj_t) (BgL_res3678z00_1949);
														}}
													else
														{	/* Trace/walk.scm 89 */
															BgL_newzd2bodyzd2_994 = BgL_bodyz00_989;
														}
												}
												{	/* Trace/walk.scm 89 */
													BgL_letzd2varzd2_bglt BgL_new2zd2bodyzd2_995;

													BgL_new2zd2bodyzd2_995 =
														BGl_makezd2tracedzd2nodez00zztrace_walkz00(
														(BgL_nodez00_bglt) (BgL_newzd2bodyzd2_994),
														BgL_typez00_990,
														BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_17),
														BgL_llocz00_991, BgL_stackz00_18);
													{	/* Trace/walk.scm 102 */

														{
															obj_t BgL_auxz00_3717;

															BgL_sfunz00_bglt BgL_auxz00_3715;

															BgL_auxz00_3717 =
																(obj_t) (BgL_new2zd2bodyzd2_995);
															BgL_auxz00_3715 =
																(BgL_sfunz00_bglt) (BgL_funz00_988);
															((((BgL_sfunz00_bglt) CREF(BgL_auxz00_3715))->
																	BgL_bodyz00) =
																((obj_t) BgL_auxz00_3717), BUNSPEC);
														}
														return BGl_leavezd2functionzd2zztools_errorz00();
													}
												}
											}
										}
									else
										{	/* Trace/walk.scm 85 */
											return BFALSE;
										}
								}
							}
						}
					}
				}
			}
		}
	}



/* find-last-sexp */
	obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t BgL_sexpz00_19)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 117 */
			{
				obj_t BgL_sexpz00_1011;

				obj_t BgL_resz00_1012;

				BgL_sexpz00_1011 = BgL_sexpz00_19;
				BgL_resz00_1012 = BgL_sexpz00_19;
			BgL_loopz00_1013:
				if (PAIRP(BgL_sexpz00_1011))
					{	/* Trace/walk.scm 123 */
						bool_t BgL_testz00_3723;

						{	/* Trace/walk.scm 123 */
							obj_t BgL_auxz00_3724;

							BgL_auxz00_3724 = CDR(BgL_sexpz00_1011);
							BgL_testz00_3723 = PAIRP(BgL_auxz00_3724);
						}
						if (BgL_testz00_3723)
							{
								obj_t BgL_resz00_3729;

								obj_t BgL_sexpz00_3727;

								BgL_sexpz00_3727 =
									BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00
									(BgL_sexpz00_1011);
								BgL_resz00_3729 = BgL_sexpz00_1011;
								BgL_resz00_1012 = BgL_resz00_3729;
								BgL_sexpz00_1011 = BgL_sexpz00_3727;
								goto BgL_loopz00_1013;
							}
						else
							{
								obj_t BgL_resz00_3732;

								obj_t BgL_sexpz00_3730;

								BgL_sexpz00_3730 = CAR(BgL_sexpz00_1011);
								BgL_resz00_3732 = BgL_sexpz00_1011;
								BgL_resz00_1012 = BgL_resz00_3732;
								BgL_sexpz00_1011 = BgL_sexpz00_3730;
								goto BgL_loopz00_1013;
							}
					}
				else
					{	/* Trace/walk.scm 121 */
						return BgL_resz00_1012;
					}
			}
		}
	}



/* make-traced-node */
	BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt BgL_nodez00_35,
		BgL_typez00_bglt BgL_typez00_36, obj_t BgL_symbolz00_37,
		obj_t BgL_llocz00_38, obj_t BgL_stackz00_39)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 233 */
			{	/* Trace/walk.scm 234 */
				obj_t BgL_locz00_1019;

				BgL_locz00_1019 =
					(((BgL_nodez00_bglt) CREF(BgL_nodez00_35))->BgL_locz00);
				{	/* Trace/walk.scm 234 */
					obj_t BgL_auxz00_1020;

					BgL_auxz00_1020 =
						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
						(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 4))));
					{	/* Trace/walk.scm 235 */
						obj_t BgL_tauxz00_1021;

						{	/* Trace/walk.scm 236 */
							obj_t BgL_arg3465z00_1094;

							BgL_arg3465z00_1094 =
								(((BgL_typez00_bglt) CREF(BgL_typez00_36))->BgL_idz00);
							BgL_tauxz00_1021 =
								BGl_makezd2typedzd2identz00zzast_identz00(BgL_auxz00_1020,
								BgL_arg3465z00_1094);
						}
						{	/* Trace/walk.scm 236 */
							obj_t BgL_symz00_1022;

							BgL_symz00_1022 =
								BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
								(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											5))));
							{	/* Trace/walk.scm 237 */
								obj_t BgL_szb2zb2_1023;

								{	/* Trace/walk.scm 238 */
									bool_t BgL_testz00_3742;

									if (PAIRP(BgL_stackz00_39))
										{	/* Trace/walk.scm 238 */
											obj_t BgL_arg3463z00_1092;

											BgL_arg3463z00_1092 = CAR(BgL_stackz00_39);
											BgL_testz00_3742 =
												BGl_iszd2azf3z21zz__objectz00(BgL_arg3463z00_1092,
												BGl_variablez00zzast_varz00);
										}
									else
										{	/* Trace/walk.scm 238 */
											BgL_testz00_3742 = ((bool_t) 0);
										}
									if (BgL_testz00_3742)
										{	/* Trace/walk.scm 239 */
											obj_t BgL_arg3456z00_1085;

											obj_t BgL_arg3457z00_1086;

											BgL_arg3456z00_1085 = CNST_TABLE_REF(((long) 6));
											{	/* Trace/walk.scm 239 */
												BgL_variablez00_bglt BgL_obj1443z00_1962;

												{	/* Trace/walk.scm 239 */
													obj_t BgL_pairz00_1961;

													BgL_pairz00_1961 = BgL_stackz00_39;
													BgL_obj1443z00_1962 =
														(BgL_variablez00_bglt) (CAR(BgL_pairz00_1961));
												}
												BgL_arg3457z00_1086 =
													(((BgL_variablez00_bglt) CREF(BgL_obj1443z00_1962))->
													BgL_idz00);
											}
											{	/* Trace/walk.scm 239 */
												obj_t BgL_list3458z00_1087;

												{	/* Trace/walk.scm 239 */
													obj_t BgL_arg3459z00_1088;

													{	/* Trace/walk.scm 239 */
														obj_t BgL_arg3460z00_1089;

														BgL_arg3460z00_1089 =
															MAKE_PAIR(BgL_arg3457z00_1086, BNIL);
														BgL_arg3459z00_1088 =
															MAKE_PAIR(BgL_arg3456z00_1085,
															BgL_arg3460z00_1089);
													}
													BgL_list3458z00_1087 =
														MAKE_PAIR(BgL_symbolz00_37, BgL_arg3459z00_1088);
												}
												BgL_szb2zb2_1023 =
													BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
													(BgL_list3458z00_1087);
										}}
									else
										{	/* Trace/walk.scm 238 */
											BgL_szb2zb2_1023 = BgL_symbolz00_37;
										}
								}
								{	/* Trace/walk.scm 238 */
									obj_t BgL_szb2zb2z00_1024;

									{	/* Trace/walk.scm 241 */
										bool_t BgL_testz00_3755;

										{	/* Trace/walk.scm 241 */
											bool_t BgL_testz00_3756;

											if (STRUCTP(BgL_locz00_1019))
												{	/* Trace/walk.scm 241 */
													BgL_testz00_3756 =
														(STRUCT_KEY(BgL_locz00_1019) ==
														CNST_TABLE_REF(((long) 7)));
												}
											else
												{	/* Trace/walk.scm 241 */
													BgL_testz00_3756 = ((bool_t) 0);
												}
											if (BgL_testz00_3756)
												{	/* Trace/walk.scm 241 */
													if (CBOOL
														(BGl_za2bmemzd2profilingza2zd2zzengine_paramz00))
														{	/* Trace/walk.scm 241 */
															BgL_testz00_3755 = ((bool_t) 0);
														}
													else
														{	/* Trace/walk.scm 241 */
															BgL_testz00_3755 = ((bool_t) 1);
														}
												}
											else
												{	/* Trace/walk.scm 241 */
													BgL_testz00_3755 = ((bool_t) 0);
												}
										}
										if (BgL_testz00_3755)
											{	/* Trace/walk.scm 245 */
												obj_t BgL_slocz00_1071;

												{	/* Trace/walk.scm 245 */
													obj_t BgL_arg3450z00_1079;

													obj_t BgL_arg3451z00_1080;

													BgL_arg3450z00_1079 =
														STRUCT_REF(BgL_locz00_1019, (int) (((long) 0)));
													BgL_arg3451z00_1080 =
														STRUCT_REF(BgL_locz00_1019, (int) (((long) 2)));
													{	/* Trace/walk.scm 245 */
														obj_t BgL_list3452z00_1081;

														{	/* Trace/walk.scm 245 */
															obj_t BgL_arg3453z00_1082;

															BgL_arg3453z00_1082 =
																MAKE_PAIR(BgL_arg3451z00_1080, BNIL);
															BgL_list3452z00_1081 =
																MAKE_PAIR(BgL_arg3450z00_1079,
																BgL_arg3453z00_1082);
														}
														BgL_slocz00_1071 =
															BGl_formatz00zz__r4_output_6_10_3z00
															(BGl_string3801z00zztrace_walkz00,
															BgL_list3452z00_1081);
												}}
												{	/* Trace/walk.scm 248 */
													obj_t BgL_arg3443z00_1072;

													{	/* Trace/walk.scm 248 */
														obj_t BgL_arg3444z00_1073;

														obj_t BgL_arg3445z00_1074;

														BgL_arg3444z00_1073 =
															SYMBOL_TO_STRING(BgL_szb2zb2_1023);
														{	/* Trace/walk.scm 248 */
															obj_t BgL_arg3448z00_1077;

															{	/* Trace/walk.scm 248 */
																obj_t BgL_stringz00_1977;

																BgL_stringz00_1977 = BgL_slocz00_1071;
																BgL_arg3448z00_1077 =
																	string_to_symbol(BSTRING_TO_STRING
																	(BgL_stringz00_1977));
															}
															BgL_arg3445z00_1074 =
																SYMBOL_TO_STRING(BgL_arg3448z00_1077);
														}
														{	/* Trace/walk.scm 248 */
															obj_t BgL_list3446z00_1075;

															{	/* Trace/walk.scm 248 */
																obj_t BgL_arg3447z00_1076;

																BgL_arg3447z00_1076 =
																	MAKE_PAIR(BgL_arg3445z00_1074, BNIL);
																BgL_list3446z00_1075 =
																	MAKE_PAIR(BgL_arg3444z00_1073,
																	BgL_arg3447z00_1076);
															}
															BgL_arg3443z00_1072 =
																BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																(BgL_list3446z00_1075);
													}}
													BgL_szb2zb2z00_1024 =
														string_to_symbol(BSTRING_TO_STRING
														(BgL_arg3443z00_1072));
											}}
										else
											{	/* Trace/walk.scm 241 */
												BgL_szb2zb2z00_1024 = BgL_szb2zb2_1023;
											}
									}
									{	/* Trace/walk.scm 241 */
										obj_t BgL_expz00_1025;

										{	/* Trace/walk.scm 250 */
											obj_t BgL_arg3399z00_1029;

											obj_t BgL_arg3400z00_1030;

											BgL_arg3399z00_1029 = CNST_TABLE_REF(((long) 8));
											{	/* Trace/walk.scm 250 */
												obj_t BgL_arg3401z00_1031;

												obj_t BgL_arg3402z00_1032;

												{	/* Trace/walk.scm 250 */
													obj_t BgL_arg3406z00_1036;

													{	/* Trace/walk.scm 250 */
														obj_t BgL_arg3408z00_1038;

														{	/* Trace/walk.scm 250 */
															obj_t BgL_arg3410z00_1039;

															{	/* Trace/walk.scm 250 */
																obj_t BgL_arg3413z00_1042;

																obj_t BgL_arg3414z00_1043;

																BgL_arg3413z00_1042 =
																	CNST_TABLE_REF(((long) 9));
																{	/* Trace/walk.scm 250 */
																	obj_t BgL_list3415z00_1044;

																	BgL_list3415z00_1044 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg3414z00_1043 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_szb2zb2z00_1024, BgL_list3415z00_1044);
																}
																BgL_arg3410z00_1039 =
																	MAKE_PAIR(BgL_arg3413z00_1042,
																	BgL_arg3414z00_1043);
															}
															{	/* Trace/walk.scm 250 */
																obj_t BgL_list3412z00_1041;

																BgL_list3412z00_1041 = MAKE_PAIR(BNIL, BNIL);
																BgL_arg3408z00_1038 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_arg3410z00_1039, BgL_list3412z00_1041);
														}}
														BgL_arg3406z00_1036 =
															MAKE_PAIR(BgL_symz00_1022, BgL_arg3408z00_1038);
													}
													BgL_arg3401z00_1031 =
														MAKE_PAIR(BgL_arg3406z00_1036, BNIL);
												}
												{	/* Trace/walk.scm 251 */
													obj_t BgL_arg3416z00_1045;

													obj_t BgL_arg3417z00_1046;

													BgL_arg3416z00_1045 = CNST_TABLE_REF(((long) 8));
													{	/* Trace/walk.scm 251 */
														obj_t BgL_arg3419z00_1048;

														obj_t BgL_arg3420z00_1049;

														{	/* Trace/walk.scm 252 */
															obj_t BgL_arg3425z00_1054;

															obj_t BgL_arg3426z00_1055;

															BgL_arg3425z00_1054 = CNST_TABLE_REF(((long) 10));
															{	/* Trace/walk.scm 252 */
																obj_t BgL_list3427z00_1056;

																BgL_list3427z00_1056 = MAKE_PAIR(BNIL, BNIL);
																BgL_arg3426z00_1055 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_symz00_1022, BgL_list3427z00_1056);
															}
															BgL_arg3419z00_1048 =
																MAKE_PAIR(BgL_arg3425z00_1054,
																BgL_arg3426z00_1055);
														}
														{	/* Trace/walk.scm 253 */
															obj_t BgL_arg3428z00_1057;

															obj_t BgL_arg3429z00_1058;

															BgL_arg3428z00_1057 = CNST_TABLE_REF(((long) 8));
															{	/* Trace/walk.scm 253 */
																obj_t BgL_arg3430z00_1059;

																obj_t BgL_arg3431z00_1060;

																{	/* Trace/walk.scm 253 */
																	obj_t BgL_arg3436z00_1065;

																	{	/* Trace/walk.scm 253 */
																		obj_t BgL_arg3439z00_1067;

																		{	/* Trace/walk.scm 253 */
																			obj_t BgL_list3440z00_1068;

																			BgL_list3440z00_1068 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg3439z00_1067 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				((obj_t) (BgL_nodez00_35),
																				BgL_list3440z00_1068);
																		}
																		BgL_arg3436z00_1065 =
																			MAKE_PAIR(BgL_tauxz00_1021,
																			BgL_arg3439z00_1067);
																	}
																	BgL_arg3430z00_1059 =
																		MAKE_PAIR(BgL_arg3436z00_1065, BNIL);
																}
																{	/* Trace/walk.scm 254 */
																	bool_t BgL_testz00_3800;

																	if (STRUCTP(BgL_llocz00_38))
																		{	/* Trace/walk.scm 254 */
																			BgL_testz00_3800 =
																				(STRUCT_KEY(BgL_llocz00_38) ==
																				CNST_TABLE_REF(((long) 7)));
																		}
																	else
																		{	/* Trace/walk.scm 254 */
																			BgL_testz00_3800 = ((bool_t) 0);
																		}
																	if (BgL_testz00_3800)
																		{	/* Trace/walk.scm 255 */
																			obj_t BgL_res3681z00_1990;

																			{	/* Trace/walk.scm 255 */
																				obj_t BgL_obj1z00_1987;

																				BgL_obj1z00_1987 =
																					CNST_TABLE_REF(((long) 11));
																				BgL_res3681z00_1990 =
																					MAKE_EXTENDED_PAIR(BgL_obj1z00_1987,
																					BNIL, BgL_llocz00_38);
																			}
																			BgL_arg3431z00_1060 = BgL_res3681z00_1990;
																		}
																	else
																		{	/* Trace/walk.scm 254 */
																			BgL_arg3431z00_1060 =
																				CNST_TABLE_REF(((long) 12));
																}}
																{	/* Trace/walk.scm 253 */
																	obj_t BgL_list3433z00_1062;

																	{	/* Trace/walk.scm 253 */
																		obj_t BgL_arg3434z00_1063;

																		{	/* Trace/walk.scm 253 */
																			obj_t BgL_arg3435z00_1064;

																			BgL_arg3435z00_1064 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg3434z00_1063 =
																				MAKE_PAIR(BgL_auxz00_1020,
																				BgL_arg3435z00_1064);
																		}
																		BgL_list3433z00_1062 =
																			MAKE_PAIR(BgL_arg3431z00_1060,
																			BgL_arg3434z00_1063);
																	}
																	BgL_arg3429z00_1058 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg3430z00_1059, BgL_list3433z00_1062);
															}}
															BgL_arg3420z00_1049 =
																MAKE_PAIR(BgL_arg3428z00_1057,
																BgL_arg3429z00_1058);
														}
														{	/* Trace/walk.scm 251 */
															obj_t BgL_list3422z00_1051;

															{	/* Trace/walk.scm 251 */
																obj_t BgL_arg3423z00_1052;

																{	/* Trace/walk.scm 251 */
																	obj_t BgL_arg3424z00_1053;

																	BgL_arg3424z00_1053 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg3423z00_1052 =
																		MAKE_PAIR(BgL_arg3420z00_1049,
																		BgL_arg3424z00_1053);
																}
																BgL_list3422z00_1051 =
																	MAKE_PAIR(BgL_arg3419z00_1048,
																	BgL_arg3423z00_1052);
															}
															BgL_arg3417z00_1046 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BNIL, BgL_list3422z00_1051);
													}}
													BgL_arg3402z00_1032 =
														MAKE_PAIR(BgL_arg3416z00_1045, BgL_arg3417z00_1046);
												}
												{	/* Trace/walk.scm 250 */
													obj_t BgL_list3404z00_1034;

													{	/* Trace/walk.scm 250 */
														obj_t BgL_arg3405z00_1035;

														BgL_arg3405z00_1035 = MAKE_PAIR(BNIL, BNIL);
														BgL_list3404z00_1034 =
															MAKE_PAIR(BgL_arg3402z00_1032,
															BgL_arg3405z00_1035);
													}
													BgL_arg3400z00_1030 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg3401z00_1031, BgL_list3404z00_1034);
											}}
											BgL_expz00_1025 =
												MAKE_PAIR(BgL_arg3399z00_1029, BgL_arg3400z00_1030);
										}
										{	/* Trace/walk.scm 250 */
											BgL_nodez00_bglt BgL_nodez00_1026;

											BgL_nodez00_1026 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_1025,
												BNIL, BgL_locz00_1019, CNST_TABLE_REF(((long) 13)));
											{	/* Trace/walk.scm 258 */

												{	/* Trace/walk.scm 259 */
													bool_t BgL_arg3397z00_1027;

													{	/* Trace/walk.scm 259 */
														obj_t BgL_arg3398z00_1028;

														BgL_arg3398z00_1028 =
															BGl_thezd2backendzd2zzbackend_backendz00();
														{
															BgL_backendz00_bglt BgL_auxz00_3826;

															BgL_auxz00_3826 =
																(BgL_backendz00_bglt) (BgL_arg3398z00_1028);
															BgL_arg3397z00_1027 =
																(((BgL_backendz00_bglt) CREF(BgL_auxz00_3826))->
																BgL_removezd2emptyzd2letz00);
													}}
													{
														BgL_letzd2varzd2_bglt BgL_auxz00_3829;

														BgL_auxz00_3829 =
															(BgL_letzd2varzd2_bglt) (BgL_nodez00_1026);
														((((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_3829))->
																BgL_removablezf3zf3) =
															((bool_t) BgL_arg3397z00_1027), BUNSPEC);
												}}
												return (BgL_letzd2varzd2_bglt) (BgL_nodez00_1026);
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* trace-node*! */
	obj_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t BgL_nodeza2za2_78,
		obj_t BgL_stackz00_79)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 414 */
		BGl_tracezd2nodeza2z12z62zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_78))
				{	/* Trace/walk.scm 415 */
					return CNST_TABLE_REF(((long) 14));
				}
			else
				{	/* Trace/walk.scm 415 */
					{	/* Trace/walk.scm 418 */
						BgL_nodez00_bglt BgL_arg3468z00_1097;

						{	/* Trace/walk.scm 418 */
							obj_t BgL_arg3469z00_1098;

							BgL_arg3469z00_1098 = CAR(BgL_nodeza2za2_78);
							{	/* Trace/walk.scm 418 */
								BgL_nodez00_bglt BgL_res3684z00_2023;

								{	/* Trace/walk.scm 418 */
									BgL_nodez00_bglt BgL_nodez00_1996;

									BgL_nodez00_1996 = (BgL_nodez00_bglt) (BgL_arg3469z00_1098);
									{	/* Trace/walk.scm 418 */
										obj_t BgL_method3271z00_1998;

										{	/* Trace/walk.scm 418 */
											BgL_objectz00_bglt BgL_objz00_1999;

											BgL_objz00_1999 = (BgL_objectz00_bglt) (BgL_nodez00_1996);
											{	/* Trace/walk.scm 418 */
												long BgL_objzd2classzd2numz00_2000;

												BgL_objzd2classzd2numz00_2000 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1999);
												{	/* Trace/walk.scm 418 */
													obj_t BgL_arg2356z00_2001;

													BgL_arg2356z00_2001 =
														PROCEDURE_REF
														(BGl_tracezd2nodezd2envz00zztrace_walkz00,
														(int) (((long) 1)));
													{	/* Trace/walk.scm 418 */
														obj_t BgL_arrayz00_2003;

														int BgL_offsetz00_2004;

														BgL_arrayz00_2003 = BgL_arg2356z00_2001;
														BgL_offsetz00_2004 =
															(int) (BgL_objzd2classzd2numz00_2000);
														{	/* Trace/walk.scm 418 */
															long BgL_offsetz00_2005;

															BgL_offsetz00_2005 =
																((long) (BgL_offsetz00_2004) - OBJECT_TYPE);
															{	/* Trace/walk.scm 418 */
																long BgL_modz00_2006;

																{	/* Trace/walk.scm 418 */
																	int BgL_arg2358z00_2007;

																	BgL_arg2358z00_2007 = (int) (((long) 8));
																	{	/* Trace/walk.scm 418 */
																		long BgL_auxz00_3846;

																		BgL_auxz00_3846 =
																			(long) (BgL_arg2358z00_2007);
																		BgL_modz00_2006 =
																			(BgL_offsetz00_2005 / BgL_auxz00_3846);
																}}
																{	/* Trace/walk.scm 418 */
																	long BgL_restz00_2008;

																	{	/* Trace/walk.scm 418 */
																		int BgL_arg2357z00_2009;

																		BgL_arg2357z00_2009 = (int) (((long) 8));
																		{	/* Trace/walk.scm 418 */
																			long BgL_auxz00_3850;

																			BgL_auxz00_3850 =
																				(long) (BgL_arg2357z00_2009);
																			BgL_restz00_2008 =
																				(BgL_offsetz00_2005 % BgL_auxz00_3850);
																	}}
																	{	/* Trace/walk.scm 418 */

																		BgL_method3271z00_1998 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2003,
																				(int) (BgL_modz00_2006)),
																			(int) (BgL_restz00_2008));
										}}}}}}}}
										BgL_res3684z00_2023 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3271z00_1998) (BgL_method3271z00_1998,
												(obj_t) (BgL_nodez00_1996), BgL_stackz00_79, BEOA));
								}}
								BgL_arg3468z00_1097 = BgL_res3684z00_2023;
						}}
						{	/* Trace/walk.scm 418 */
							obj_t BgL_auxz00_3861;

							BgL_auxz00_3861 = (obj_t) (BgL_arg3468z00_1097);
							SET_CAR(BgL_nodeza2za2_78, BgL_auxz00_3861);
					}}
					{
						obj_t BgL_nodeza2za2_3864;

						BgL_nodeza2za2_3864 = CDR(BgL_nodeza2za2_78);
						BgL_nodeza2za2_78 = BgL_nodeza2za2_3864;
						goto BGl_tracezd2nodeza2z12z62zztrace_walkz00;
					}
				}
		}
	}



/* toplevel-trace-node*! */
	obj_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t
		BgL_nodeza2za2_84)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 459 */
		BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_84))
				{	/* Trace/walk.scm 460 */
					return CNST_TABLE_REF(((long) 14));
				}
			else
				{	/* Trace/walk.scm 460 */
					{	/* Trace/walk.scm 463 */
						BgL_nodez00_bglt BgL_arg3472z00_1101;

						{	/* Trace/walk.scm 463 */
							obj_t BgL_arg3473z00_1102;

							BgL_arg3473z00_1102 = CAR(BgL_nodeza2za2_84);
							{	/* Trace/walk.scm 463 */
								BgL_nodez00_bglt BgL_res3687z00_2055;

								{	/* Trace/walk.scm 463 */
									BgL_nodez00_bglt BgL_nodez00_2029;

									BgL_nodez00_2029 = (BgL_nodez00_bglt) (BgL_arg3473z00_1102);
									{	/* Trace/walk.scm 463 */
										obj_t BgL_method3307z00_2030;

										{	/* Trace/walk.scm 463 */
											BgL_objectz00_bglt BgL_objz00_2031;

											BgL_objz00_2031 = (BgL_objectz00_bglt) (BgL_nodez00_2029);
											{	/* Trace/walk.scm 463 */
												long BgL_objzd2classzd2numz00_2032;

												BgL_objzd2classzd2numz00_2032 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2031);
												{	/* Trace/walk.scm 463 */
													obj_t BgL_arg2356z00_2033;

													BgL_arg2356z00_2033 =
														PROCEDURE_REF
														(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
														(int) (((long) 1)));
													{	/* Trace/walk.scm 463 */
														obj_t BgL_arrayz00_2035;

														int BgL_offsetz00_2036;

														BgL_arrayz00_2035 = BgL_arg2356z00_2033;
														BgL_offsetz00_2036 =
															(int) (BgL_objzd2classzd2numz00_2032);
														{	/* Trace/walk.scm 463 */
															long BgL_offsetz00_2037;

															BgL_offsetz00_2037 =
																((long) (BgL_offsetz00_2036) - OBJECT_TYPE);
															{	/* Trace/walk.scm 463 */
																long BgL_modz00_2038;

																{	/* Trace/walk.scm 463 */
																	int BgL_arg2358z00_2039;

																	BgL_arg2358z00_2039 = (int) (((long) 8));
																	{	/* Trace/walk.scm 463 */
																		long BgL_auxz00_3879;

																		BgL_auxz00_3879 =
																			(long) (BgL_arg2358z00_2039);
																		BgL_modz00_2038 =
																			(BgL_offsetz00_2037 / BgL_auxz00_3879);
																}}
																{	/* Trace/walk.scm 463 */
																	long BgL_restz00_2040;

																	{	/* Trace/walk.scm 463 */
																		int BgL_arg2357z00_2041;

																		BgL_arg2357z00_2041 = (int) (((long) 8));
																		{	/* Trace/walk.scm 463 */
																			long BgL_auxz00_3883;

																			BgL_auxz00_3883 =
																				(long) (BgL_arg2357z00_2041);
																			BgL_restz00_2040 =
																				(BgL_offsetz00_2037 % BgL_auxz00_3883);
																	}}
																	{	/* Trace/walk.scm 463 */

																		BgL_method3307z00_2030 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2035,
																				(int) (BgL_modz00_2038)),
																			(int) (BgL_restz00_2040));
										}}}}}}}}
										BgL_res3687z00_2055 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3307z00_2030) (BgL_method3307z00_2030,
												(obj_t) (BgL_nodez00_2029), BEOA));
								}}
								BgL_arg3472z00_1101 = BgL_res3687z00_2055;
						}}
						{	/* Trace/walk.scm 463 */
							obj_t BgL_auxz00_3894;

							BgL_auxz00_3894 = (obj_t) (BgL_arg3472z00_1101);
							SET_CAR(BgL_nodeza2za2_84, BgL_auxz00_3894);
					}}
					{
						obj_t BgL_nodeza2za2_3897;

						BgL_nodeza2za2_3897 = CDR(BgL_nodeza2za2_84);
						BgL_nodeza2za2_84 = BgL_nodeza2za2_3897;
						goto BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00;
					}
				}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_addzd2genericz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_findzd2lastzd2nodezd2defau3241zd2envz00zztrace_walkz00);
			BGl_addzd2genericz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_tracezd2nodezd2default3270zd2envzd2zztrace_walkz00);
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_toplevelzd2tracezd2nodezd23306zd2envz00zztrace_walkz00);
		}
	}



/* find-last-node */
	obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_20)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 134 */
			{	/* Trace/walk.scm 134 */
				obj_t BgL_method3242z00_2059;

				{	/* Trace/walk.scm 134 */
					BgL_objectz00_bglt BgL_objz00_2060;

					BgL_objz00_2060 = (BgL_objectz00_bglt) (BgL_nodez00_20);
					{	/* Trace/walk.scm 134 */
						long BgL_objzd2classzd2numz00_2061;

						BgL_objzd2classzd2numz00_2061 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2060);
						{	/* Trace/walk.scm 134 */
							obj_t BgL_arg2356z00_2062;

							BgL_arg2356z00_2062 =
								PROCEDURE_REF(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 134 */
								obj_t BgL_arrayz00_2064;

								int BgL_offsetz00_2065;

								BgL_arrayz00_2064 = BgL_arg2356z00_2062;
								BgL_offsetz00_2065 = (int) (BgL_objzd2classzd2numz00_2061);
								{	/* Trace/walk.scm 134 */
									long BgL_offsetz00_2066;

									BgL_offsetz00_2066 =
										((long) (BgL_offsetz00_2065) - OBJECT_TYPE);
									{	/* Trace/walk.scm 134 */
										long BgL_modz00_2067;

										{	/* Trace/walk.scm 134 */
											int BgL_arg2358z00_2068;

											BgL_arg2358z00_2068 = (int) (((long) 8));
											{	/* Trace/walk.scm 134 */
												long BgL_auxz00_3910;

												BgL_auxz00_3910 = (long) (BgL_arg2358z00_2068);
												BgL_modz00_2067 =
													(BgL_offsetz00_2066 / BgL_auxz00_3910);
										}}
										{	/* Trace/walk.scm 134 */
											long BgL_restz00_2069;

											{	/* Trace/walk.scm 134 */
												int BgL_arg2357z00_2070;

												BgL_arg2357z00_2070 = (int) (((long) 8));
												{	/* Trace/walk.scm 134 */
													long BgL_auxz00_3914;

													BgL_auxz00_3914 = (long) (BgL_arg2357z00_2070);
													BgL_restz00_2069 =
														(BgL_offsetz00_2066 % BgL_auxz00_3914);
											}}
											{	/* Trace/walk.scm 134 */

												BgL_method3242z00_2059 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2064,
														(int) (BgL_modz00_2067)), (int) (BgL_restz00_2069));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3242z00_2059) (BgL_method3242z00_2059,
					(obj_t) (BgL_nodez00_20), BEOA);
			}
		}
	}



/* _find-last-node */
	obj_t BGl__findzd2lastzd2nodez00zztrace_walkz00(obj_t BgL_envz00_3300,
		obj_t BgL_nodez00_3301)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 134 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(BgL_nodez00_bglt) (BgL_nodez00_3301));
		}
	}



/* _find-last-node-defau3241 */
	obj_t BGl__findzd2lastzd2nodezd2defau3241zd2zztrace_walkz00(obj_t
		BgL_envz00_3305, obj_t BgL_nodez00_3306)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return (obj_t) ((BgL_nodez00_bglt) (BgL_nodez00_3306));
		}
	}



/* trace-node */
	BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_40, obj_t BgL_stackz00_41)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 265 */
			{	/* Trace/walk.scm 265 */
				obj_t BgL_method3271z00_2084;

				{	/* Trace/walk.scm 265 */
					BgL_objectz00_bglt BgL_objz00_2085;

					BgL_objz00_2085 = (BgL_objectz00_bglt) (BgL_nodez00_40);
					{	/* Trace/walk.scm 265 */
						long BgL_objzd2classzd2numz00_2086;

						BgL_objzd2classzd2numz00_2086 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2085);
						{	/* Trace/walk.scm 265 */
							obj_t BgL_arg2356z00_2087;

							BgL_arg2356z00_2087 =
								PROCEDURE_REF(BGl_tracezd2nodezd2envz00zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 265 */
								obj_t BgL_arrayz00_2089;

								int BgL_offsetz00_2090;

								BgL_arrayz00_2089 = BgL_arg2356z00_2087;
								BgL_offsetz00_2090 = (int) (BgL_objzd2classzd2numz00_2086);
								{	/* Trace/walk.scm 265 */
									long BgL_offsetz00_2091;

									BgL_offsetz00_2091 =
										((long) (BgL_offsetz00_2090) - OBJECT_TYPE);
									{	/* Trace/walk.scm 265 */
										long BgL_modz00_2092;

										{	/* Trace/walk.scm 265 */
											int BgL_arg2358z00_2093;

											BgL_arg2358z00_2093 = (int) (((long) 8));
											{	/* Trace/walk.scm 265 */
												long BgL_auxz00_3936;

												BgL_auxz00_3936 = (long) (BgL_arg2358z00_2093);
												BgL_modz00_2092 =
													(BgL_offsetz00_2091 / BgL_auxz00_3936);
										}}
										{	/* Trace/walk.scm 265 */
											long BgL_restz00_2094;

											{	/* Trace/walk.scm 265 */
												int BgL_arg2357z00_2095;

												BgL_arg2357z00_2095 = (int) (((long) 8));
												{	/* Trace/walk.scm 265 */
													long BgL_auxz00_3940;

													BgL_auxz00_3940 = (long) (BgL_arg2357z00_2095);
													BgL_restz00_2094 =
														(BgL_offsetz00_2091 % BgL_auxz00_3940);
											}}
											{	/* Trace/walk.scm 265 */

												BgL_method3271z00_2084 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2089,
														(int) (BgL_modz00_2092)), (int) (BgL_restz00_2094));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2084)
					(BgL_method3271z00_2084, (obj_t) (BgL_nodez00_40), BgL_stackz00_41,
						BEOA));
			}
		}
	}



/* _trace-node */
	obj_t BGl__tracezd2nodezd2zztrace_walkz00(obj_t BgL_envz00_3302,
		obj_t BgL_nodez00_3303, obj_t BgL_stackz00_3304)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 265 */
			return
				(obj_t) (BGl_tracezd2nodezd2zztrace_walkz00(
					(BgL_nodez00_bglt) (BgL_nodez00_3303), BgL_stackz00_3304));
		}
	}



/* _trace-node-default3270 */
	obj_t BGl__tracezd2nodezd2default3270z00zztrace_walkz00(obj_t BgL_envz00_3307,
		obj_t BgL_nodez00_3308, obj_t BgL_stackz00_3309)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return (obj_t) ((BgL_nodez00_bglt) (BgL_nodez00_3308));
		}
	}



/* toplevel-trace-node */
	BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_80)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 424 */
			{	/* Trace/walk.scm 424 */
				obj_t BgL_method3307z00_2109;

				{	/* Trace/walk.scm 424 */
					BgL_objectz00_bglt BgL_objz00_2110;

					BgL_objz00_2110 = (BgL_objectz00_bglt) (BgL_nodez00_80);
					{	/* Trace/walk.scm 424 */
						long BgL_objzd2classzd2numz00_2111;

						BgL_objzd2classzd2numz00_2111 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2110);
						{	/* Trace/walk.scm 424 */
							obj_t BgL_arg2356z00_2112;

							BgL_arg2356z00_2112 =
								PROCEDURE_REF
								(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 424 */
								obj_t BgL_arrayz00_2114;

								int BgL_offsetz00_2115;

								BgL_arrayz00_2114 = BgL_arg2356z00_2112;
								BgL_offsetz00_2115 = (int) (BgL_objzd2classzd2numz00_2111);
								{	/* Trace/walk.scm 424 */
									long BgL_offsetz00_2116;

									BgL_offsetz00_2116 =
										((long) (BgL_offsetz00_2115) - OBJECT_TYPE);
									{	/* Trace/walk.scm 424 */
										long BgL_modz00_2117;

										{	/* Trace/walk.scm 424 */
											int BgL_arg2358z00_2118;

											BgL_arg2358z00_2118 = (int) (((long) 8));
											{	/* Trace/walk.scm 424 */
												long BgL_auxz00_3964;

												BgL_auxz00_3964 = (long) (BgL_arg2358z00_2118);
												BgL_modz00_2117 =
													(BgL_offsetz00_2116 / BgL_auxz00_3964);
										}}
										{	/* Trace/walk.scm 424 */
											long BgL_restz00_2119;

											{	/* Trace/walk.scm 424 */
												int BgL_arg2357z00_2120;

												BgL_arg2357z00_2120 = (int) (((long) 8));
												{	/* Trace/walk.scm 424 */
													long BgL_auxz00_3968;

													BgL_auxz00_3968 = (long) (BgL_arg2357z00_2120);
													BgL_restz00_2119 =
														(BgL_offsetz00_2116 % BgL_auxz00_3968);
											}}
											{	/* Trace/walk.scm 424 */

												BgL_method3307z00_2109 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2114,
														(int) (BgL_modz00_2117)), (int) (BgL_restz00_2119));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3307z00_2109)
					(BgL_method3307z00_2109, (obj_t) (BgL_nodez00_80), BEOA));
			}
		}
	}



/* _toplevel-trace-node */
	obj_t BGl__toplevelzd2tracezd2nodez00zztrace_walkz00(obj_t BgL_envz00_3298,
		obj_t BgL_nodez00_3299)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 424 */
			return
				(obj_t) (BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(
					(BgL_nodez00_bglt) (BgL_nodez00_3299)));
		}
	}



/* _toplevel-trace-node-3306 */
	obj_t BGl__toplevelzd2tracezd2nodezd23306zd2zztrace_walkz00(obj_t
		BgL_envz00_3310, obj_t BgL_nodez00_3311)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return (obj_t) ((BgL_nodez00_bglt) (BgL_nodez00_3311));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc3802z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc3803z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3804z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_funcallz00zzast_nodez00, BGl_proc3805z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_externz00zzast_nodez00, BGl_proc3806z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc3807z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3808z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_failz00zzast_nodez00, BGl_proc3809z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_selectz00zzast_nodez00, BGl_proc3810z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3811z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3812z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3813z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3814z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3815z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3816z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3817z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3818z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3819z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3820z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3821z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3822z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3823z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3824z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3825z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3826z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3827z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3828z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3829z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3830z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3831z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc3832z00zztrace_walkz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc3833z00zztrace_walkz00);
		}
	}



/* toplevel-trace-node-3311 */
	obj_t BGl_toplevelzd2tracezd2nodezd23311zd2zztrace_walkz00(obj_t
		BgL_envz00_3344, obj_t BgL_nodez00_3345)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 442 */
			{
				BgL_setqz00_bglt BgL_nodez00_1774;

				{	/* Trace/walk.scm 443 */
					BgL_setqz00_bglt BgL_auxz00_4016;

					BgL_nodez00_1774 = (BgL_setqz00_bglt) (BgL_nodez00_3345);
					{	/* Trace/walk.scm 444 */
						BgL_varz00_bglt BgL_instance3226z00_1778;

						BgL_instance3226z00_1778 =
							(((BgL_setqz00_bglt) CREF(BgL_nodez00_1774))->BgL_varz00);
						{	/* Trace/walk.scm 445 */
							bool_t BgL_testz00_4018;

							{	/* Trace/walk.scm 445 */
								bool_t BgL_testz00_4019;

								{	/* Trace/walk.scm 445 */
									BgL_variablez00_bglt BgL_arg3664z00_1797;

									BgL_arg3664z00_1797 =
										(((BgL_varz00_bglt) CREF(BgL_instance3226z00_1778))->
										BgL_variablez00);
									{	/* Trace/walk.scm 445 */
										obj_t BgL_obj1590z00_3279;

										BgL_obj1590z00_3279 = (obj_t) (BgL_arg3664z00_1797);
										BgL_testz00_4019 =
											BGl_iszd2azf3z21zz__objectz00(BgL_obj1590z00_3279,
											BGl_globalz00zzast_varz00);
									}
								}
								if (BgL_testz00_4019)
									{	/* Trace/walk.scm 446 */
										bool_t BgL_testz00_4023;

										{	/* Trace/walk.scm 446 */
											bool_t BgL_testz00_4024;

											{	/* Trace/walk.scm 446 */
												BgL_nodez00_bglt BgL_arg3663z00_1796;

												BgL_arg3663z00_1796 =
													(((BgL_setqz00_bglt) CREF(BgL_nodez00_1774))->
													BgL_valuez00);
												{	/* Trace/walk.scm 446 */
													obj_t BgL_obj1988z00_3281;

													BgL_obj1988z00_3281 = (obj_t) (BgL_arg3663z00_1796);
													BgL_testz00_4024 =
														BGl_iszd2azf3z21zz__objectz00(BgL_obj1988z00_3281,
														BGl_atomz00zzast_nodez00);
												}
											}
											if (BgL_testz00_4024)
												{	/* Trace/walk.scm 446 */
													BgL_testz00_4023 = ((bool_t) 1);
												}
											else
												{	/* Trace/walk.scm 447 */
													bool_t BgL_testz00_4028;

													{	/* Trace/walk.scm 447 */
														BgL_nodez00_bglt BgL_arg3662z00_1795;

														BgL_arg3662z00_1795 =
															(((BgL_setqz00_bglt) CREF(BgL_nodez00_1774))->
															BgL_valuez00);
														{	/* Trace/walk.scm 447 */
															obj_t BgL_obj2008z00_3283;

															BgL_obj2008z00_3283 =
																(obj_t) (BgL_arg3662z00_1795);
															BgL_testz00_4028 =
																BGl_iszd2azf3z21zz__objectz00
																(BgL_obj2008z00_3283, BGl_varz00zzast_nodez00);
														}
													}
													if (BgL_testz00_4028)
														{	/* Trace/walk.scm 447 */
															BgL_testz00_4023 = ((bool_t) 1);
														}
													else
														{	/* Trace/walk.scm 448 */
															bool_t BgL_testz00_4032;

															{	/* Trace/walk.scm 448 */
																BgL_nodez00_bglt BgL_arg3661z00_1794;

																BgL_arg3661z00_1794 =
																	(((BgL_setqz00_bglt) CREF(BgL_nodez00_1774))->
																	BgL_valuez00);
																{	/* Trace/walk.scm 448 */
																	obj_t BgL_obj2046z00_3285;

																	BgL_obj2046z00_3285 =
																		(obj_t) (BgL_arg3661z00_1794);
																	BgL_testz00_4032 =
																		BGl_iszd2azf3z21zz__objectz00
																		(BgL_obj2046z00_3285,
																		BGl_kwotez00zzast_nodez00);
																}
															}
															if (BgL_testz00_4032)
																{	/* Trace/walk.scm 448 */
																	BgL_testz00_4023 = ((bool_t) 1);
																}
															else
																{	/* Trace/walk.scm 449 */
																	BgL_nodez00_bglt BgL_arg3660z00_1793;

																	BgL_arg3660z00_1793 =
																		(((BgL_setqz00_bglt)
																			CREF(BgL_nodez00_1774))->BgL_valuez00);
																	{	/* Trace/walk.scm 449 */
																		obj_t BgL_obj2260z00_3287;

																		BgL_obj2260z00_3287 =
																			(obj_t) (BgL_arg3660z00_1793);
																		BgL_testz00_4023 =
																			BGl_iszd2azf3z21zz__objectz00
																			(BgL_obj2260z00_3287,
																			BGl_pragmaz00zzast_nodez00);
																	}
																}
														}
												}
										}
										if (BgL_testz00_4023)
											{	/* Trace/walk.scm 446 */
												BgL_testz00_4018 = ((bool_t) 0);
											}
										else
											{	/* Trace/walk.scm 446 */
												BgL_testz00_4018 = ((bool_t) 1);
											}
									}
								else
									{	/* Trace/walk.scm 445 */
										BgL_testz00_4018 = ((bool_t) 0);
									}
							}
							if (BgL_testz00_4018)
								{	/* Trace/walk.scm 450 */
									obj_t BgL_idz00_1780;

									{	/* Trace/walk.scm 450 */
										BgL_variablez00_bglt BgL_obj1443z00_3289;

										BgL_obj1443z00_3289 =
											(((BgL_varz00_bglt) CREF(BgL_instance3226z00_1778))->
											BgL_variablez00);
										BgL_idz00_1780 =
											(((BgL_variablez00_bglt) CREF(BgL_obj1443z00_3289))->
											BgL_idz00);
									}
									{	/* Trace/walk.scm 450 */
										BgL_typez00_bglt BgL_typez00_1781;

										{	/* Trace/walk.scm 451 */
											BgL_variablez00_bglt BgL_obj1447z00_3291;

											BgL_obj1447z00_3291 =
												(((BgL_varz00_bglt) CREF(BgL_instance3226z00_1778))->
												BgL_variablez00);
											BgL_typez00_1781 =
												(((BgL_variablez00_bglt) CREF(BgL_obj1447z00_3291))->
												BgL_typez00);
										}
										{	/* Trace/walk.scm 451 */
											BgL_letzd2varzd2_bglt BgL_tracez00_1782;

											{	/* Trace/walk.scm 452 */
												BgL_nodez00_bglt BgL_arg3650z00_1783;

												obj_t BgL_arg3651z00_1784;

												BgL_arg3650z00_1783 =
													(((BgL_setqz00_bglt) CREF(BgL_nodez00_1774))->
													BgL_valuez00);
												{
													BgL_nodez00_bglt BgL_auxz00_4044;

													BgL_auxz00_4044 =
														(BgL_nodez00_bglt) (BgL_nodez00_1774);
													BgL_arg3651z00_1784 =
														(((BgL_nodez00_bglt) CREF(BgL_auxz00_4044))->
														BgL_locz00);
												}
												BgL_tracez00_1782 =
													BGl_makezd2tracedzd2nodez00zztrace_walkz00
													(BgL_arg3650z00_1783, BgL_typez00_1781,
													BgL_idz00_1780, BgL_arg3651z00_1784, BNIL);
											}
											{	/* Trace/walk.scm 452 */

												{
													BgL_nodez00_bglt BgL_auxz00_4048;

													BgL_auxz00_4048 =
														(BgL_nodez00_bglt) (BgL_tracez00_1782);
													((((BgL_setqz00_bglt) CREF(BgL_nodez00_1774))->
															BgL_valuez00) =
														((BgL_nodez00_bglt) BgL_auxz00_4048), BUNSPEC);
												}
											}
										}
									}
								}
							else
								{	/* Trace/walk.scm 445 */
									BFALSE;
								}
						}
					}
					BgL_auxz00_4016 = BgL_nodez00_1774;
					return (obj_t) (BgL_auxz00_4016);
				}
			}
		}
	}



/* toplevel-trace-node-3309 */
	obj_t BGl_toplevelzd2tracezd2nodezd23309zd2zztrace_walkz00(obj_t
		BgL_envz00_3346, obj_t BgL_nodez00_3347)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 430 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1768;

				{	/* Trace/walk.scm 431 */
					BgL_sequencez00_bglt BgL_auxz00_4053;

					BgL_nodez00_1768 = (BgL_sequencez00_bglt) (BgL_nodez00_3347);
					{	/* Trace/walk.scm 431 */
						obj_t BgL_arg3647z00_3275;

						BgL_arg3647z00_3275 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1768))->BgL_nodesz00);
						BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00
							(BgL_arg3647z00_3275);
					}
					BgL_auxz00_4053 = BgL_nodez00_1768;
					return (obj_t) (BgL_auxz00_4053);
				}
			}
		}
	}



/* trace-node-box-set!3305 */
	obj_t BGl_tracezd2nodezd2boxzd2setz123305zc0zztrace_walkz00(obj_t
		BgL_envz00_3348, obj_t BgL_nodez00_3349, obj_t BgL_stackz00_3350)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 405 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1757;

				obj_t BgL_stackz00_1758;

				{	/* Trace/walk.scm 406 */
					BgL_boxzd2setz12zc0_bglt BgL_auxz00_4058;

					BgL_nodez00_1757 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_3349);
					BgL_stackz00_1758 = BgL_stackz00_3350;
					{	/* Trace/walk.scm 407 */
						BgL_nodez00_bglt BgL_arg3642z00_1762;

						{	/* Trace/walk.scm 407 */
							BgL_varz00_bglt BgL_arg3643z00_1763;

							BgL_arg3643z00_1763 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1757))->
								BgL_varz00);
							{	/* Trace/walk.scm 407 */
								BgL_nodez00_bglt BgL_res3787z00_3241;

								{	/* Trace/walk.scm 407 */
									BgL_nodez00_bglt BgL_nodez00_3214;

									BgL_nodez00_3214 = (BgL_nodez00_bglt) (BgL_arg3643z00_1763);
									{	/* Trace/walk.scm 407 */
										obj_t BgL_method3271z00_3216;

										{	/* Trace/walk.scm 407 */
											BgL_objectz00_bglt BgL_objz00_3217;

											BgL_objz00_3217 = (BgL_objectz00_bglt) (BgL_nodez00_3214);
											{	/* Trace/walk.scm 407 */
												long BgL_objzd2classzd2numz00_3218;

												BgL_objzd2classzd2numz00_3218 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3217);
												{	/* Trace/walk.scm 407 */
													obj_t BgL_arg2356z00_3219;

													BgL_arg2356z00_3219 =
														PROCEDURE_REF
														(BGl_tracezd2nodezd2envz00zztrace_walkz00,
														(int) (((long) 1)));
													{	/* Trace/walk.scm 407 */
														obj_t BgL_arrayz00_3221;

														int BgL_offsetz00_3222;

														BgL_arrayz00_3221 = BgL_arg2356z00_3219;
														BgL_offsetz00_3222 =
															(int) (BgL_objzd2classzd2numz00_3218);
														{	/* Trace/walk.scm 407 */
															long BgL_offsetz00_3223;

															BgL_offsetz00_3223 =
																((long) (BgL_offsetz00_3222) - OBJECT_TYPE);
															{	/* Trace/walk.scm 407 */
																long BgL_modz00_3224;

																{	/* Trace/walk.scm 407 */
																	int BgL_arg2358z00_3225;

																	BgL_arg2358z00_3225 = (int) (((long) 8));
																	{	/* Trace/walk.scm 407 */
																		long BgL_auxz00_4069;

																		BgL_auxz00_4069 =
																			(long) (BgL_arg2358z00_3225);
																		BgL_modz00_3224 =
																			(BgL_offsetz00_3223 / BgL_auxz00_4069);
																}}
																{	/* Trace/walk.scm 407 */
																	long BgL_restz00_3226;

																	{	/* Trace/walk.scm 407 */
																		int BgL_arg2357z00_3227;

																		BgL_arg2357z00_3227 = (int) (((long) 8));
																		{	/* Trace/walk.scm 407 */
																			long BgL_auxz00_4073;

																			BgL_auxz00_4073 =
																				(long) (BgL_arg2357z00_3227);
																			BgL_restz00_3226 =
																				(BgL_offsetz00_3223 % BgL_auxz00_4073);
																	}}
																	{	/* Trace/walk.scm 407 */

																		BgL_method3271z00_3216 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3221,
																				(int) (BgL_modz00_3224)),
																			(int) (BgL_restz00_3226));
										}}}}}}}}
										BgL_res3787z00_3241 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3271z00_3216) (BgL_method3271z00_3216,
												(obj_t) (BgL_nodez00_3214), BgL_stackz00_1758, BEOA));
								}}
								BgL_arg3642z00_1762 = BgL_res3787z00_3241;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_4084;

							BgL_auxz00_4084 = (BgL_varz00_bglt) (BgL_arg3642z00_1762);
							((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1757))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_4084), BUNSPEC);
					}}
					{	/* Trace/walk.scm 408 */
						BgL_nodez00_bglt BgL_arg3644z00_1764;

						{	/* Trace/walk.scm 408 */
							BgL_nodez00_bglt BgL_arg3645z00_1765;

							BgL_arg3645z00_1765 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1757))->
								BgL_valuez00);
							{	/* Trace/walk.scm 408 */
								BgL_nodez00_bglt BgL_res3790z00_3272;

								{	/* Trace/walk.scm 408 */
									obj_t BgL_method3271z00_3247;

									{	/* Trace/walk.scm 408 */
										BgL_objectz00_bglt BgL_objz00_3248;

										BgL_objz00_3248 =
											(BgL_objectz00_bglt) (BgL_arg3645z00_1765);
										{	/* Trace/walk.scm 408 */
											long BgL_objzd2classzd2numz00_3249;

											BgL_objzd2classzd2numz00_3249 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3248);
											{	/* Trace/walk.scm 408 */
												obj_t BgL_arg2356z00_3250;

												BgL_arg2356z00_3250 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 408 */
													obj_t BgL_arrayz00_3252;

													int BgL_offsetz00_3253;

													BgL_arrayz00_3252 = BgL_arg2356z00_3250;
													BgL_offsetz00_3253 =
														(int) (BgL_objzd2classzd2numz00_3249);
													{	/* Trace/walk.scm 408 */
														long BgL_offsetz00_3254;

														BgL_offsetz00_3254 =
															((long) (BgL_offsetz00_3253) - OBJECT_TYPE);
														{	/* Trace/walk.scm 408 */
															long BgL_modz00_3255;

															{	/* Trace/walk.scm 408 */
																int BgL_arg2358z00_3256;

																BgL_arg2358z00_3256 = (int) (((long) 8));
																{	/* Trace/walk.scm 408 */
																	long BgL_auxz00_4096;

																	BgL_auxz00_4096 =
																		(long) (BgL_arg2358z00_3256);
																	BgL_modz00_3255 =
																		(BgL_offsetz00_3254 / BgL_auxz00_4096);
															}}
															{	/* Trace/walk.scm 408 */
																long BgL_restz00_3257;

																{	/* Trace/walk.scm 408 */
																	int BgL_arg2357z00_3258;

																	BgL_arg2357z00_3258 = (int) (((long) 8));
																	{	/* Trace/walk.scm 408 */
																		long BgL_auxz00_4100;

																		BgL_auxz00_4100 =
																			(long) (BgL_arg2357z00_3258);
																		BgL_restz00_3257 =
																			(BgL_offsetz00_3254 % BgL_auxz00_4100);
																}}
																{	/* Trace/walk.scm 408 */

																	BgL_method3271z00_3247 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3252,
																			(int) (BgL_modz00_3255)),
																		(int) (BgL_restz00_3257));
									}}}}}}}}
									BgL_res3790z00_3272 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_3247)
										(BgL_method3271z00_3247, (obj_t) (BgL_arg3645z00_1765),
											BgL_stackz00_1758, BEOA));
								}
								BgL_arg3644z00_1764 = BgL_res3790z00_3272;
						}}
						((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1757))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3644z00_1764), BUNSPEC);
					}
					BgL_auxz00_4058 = BgL_nodez00_1757;
					return (obj_t) (BgL_auxz00_4058);
				}
			}
		}
	}



/* trace-node-box-ref3303 */
	obj_t BGl_tracezd2nodezd2boxzd2ref3303zd2zztrace_walkz00(obj_t
		BgL_envz00_3351, obj_t BgL_nodez00_3352, obj_t BgL_stackz00_3353)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 398 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1749;

				obj_t BgL_stackz00_1750;

				{	/* Trace/walk.scm 399 */
					BgL_boxzd2refzd2_bglt BgL_auxz00_4114;

					BgL_nodez00_1749 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_3352);
					BgL_stackz00_1750 = BgL_stackz00_3353;
					{	/* Trace/walk.scm 399 */
						BgL_nodez00_bglt BgL_arg3639z00_3180;

						{	/* Trace/walk.scm 399 */
							BgL_varz00_bglt BgL_arg3640z00_3181;

							BgL_arg3640z00_3181 =
								(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1749))->BgL_varz00);
							{	/* Trace/walk.scm 399 */
								BgL_nodez00_bglt BgL_res3784z00_3210;

								{	/* Trace/walk.scm 399 */
									BgL_nodez00_bglt BgL_nodez00_3183;

									BgL_nodez00_3183 = (BgL_nodez00_bglt) (BgL_arg3640z00_3181);
									{	/* Trace/walk.scm 399 */
										obj_t BgL_method3271z00_3185;

										{	/* Trace/walk.scm 399 */
											BgL_objectz00_bglt BgL_objz00_3186;

											BgL_objz00_3186 = (BgL_objectz00_bglt) (BgL_nodez00_3183);
											{	/* Trace/walk.scm 399 */
												long BgL_objzd2classzd2numz00_3187;

												BgL_objzd2classzd2numz00_3187 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3186);
												{	/* Trace/walk.scm 399 */
													obj_t BgL_arg2356z00_3188;

													BgL_arg2356z00_3188 =
														PROCEDURE_REF
														(BGl_tracezd2nodezd2envz00zztrace_walkz00,
														(int) (((long) 1)));
													{	/* Trace/walk.scm 399 */
														obj_t BgL_arrayz00_3190;

														int BgL_offsetz00_3191;

														BgL_arrayz00_3190 = BgL_arg2356z00_3188;
														BgL_offsetz00_3191 =
															(int) (BgL_objzd2classzd2numz00_3187);
														{	/* Trace/walk.scm 399 */
															long BgL_offsetz00_3192;

															BgL_offsetz00_3192 =
																((long) (BgL_offsetz00_3191) - OBJECT_TYPE);
															{	/* Trace/walk.scm 399 */
																long BgL_modz00_3193;

																{	/* Trace/walk.scm 399 */
																	int BgL_arg2358z00_3194;

																	BgL_arg2358z00_3194 = (int) (((long) 8));
																	{	/* Trace/walk.scm 399 */
																		long BgL_auxz00_4125;

																		BgL_auxz00_4125 =
																			(long) (BgL_arg2358z00_3194);
																		BgL_modz00_3193 =
																			(BgL_offsetz00_3192 / BgL_auxz00_4125);
																}}
																{	/* Trace/walk.scm 399 */
																	long BgL_restz00_3195;

																	{	/* Trace/walk.scm 399 */
																		int BgL_arg2357z00_3196;

																		BgL_arg2357z00_3196 = (int) (((long) 8));
																		{	/* Trace/walk.scm 399 */
																			long BgL_auxz00_4129;

																			BgL_auxz00_4129 =
																				(long) (BgL_arg2357z00_3196);
																			BgL_restz00_3195 =
																				(BgL_offsetz00_3192 % BgL_auxz00_4129);
																	}}
																	{	/* Trace/walk.scm 399 */

																		BgL_method3271z00_3185 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3190,
																				(int) (BgL_modz00_3193)),
																			(int) (BgL_restz00_3195));
										}}}}}}}}
										BgL_res3784z00_3210 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3271z00_3185) (BgL_method3271z00_3185,
												(obj_t) (BgL_nodez00_3183), BgL_stackz00_1750, BEOA));
								}}
								BgL_arg3639z00_3180 = BgL_res3784z00_3210;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_4140;

							BgL_auxz00_4140 = (BgL_varz00_bglt) (BgL_arg3639z00_3180);
							((((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1749))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_4140), BUNSPEC);
					}}
					BgL_auxz00_4114 = BgL_nodez00_1749;
					return (obj_t) (BgL_auxz00_4114);
				}
			}
		}
	}



/* trace-node-make-box3301 */
	obj_t BGl_tracezd2nodezd2makezd2box3301zd2zztrace_walkz00(obj_t
		BgL_envz00_3354, obj_t BgL_nodez00_3355, obj_t BgL_stackz00_3356)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 391 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1741;

				obj_t BgL_stackz00_1742;

				{	/* Trace/walk.scm 392 */
					BgL_makezd2boxzd2_bglt BgL_auxz00_4145;

					BgL_nodez00_1741 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_3355);
					BgL_stackz00_1742 = BgL_stackz00_3356;
					{	/* Trace/walk.scm 392 */
						BgL_nodez00_bglt BgL_arg3636z00_3147;

						{	/* Trace/walk.scm 392 */
							BgL_nodez00_bglt BgL_arg3637z00_3148;

							BgL_arg3637z00_3148 =
								(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1741))->
								BgL_valuez00);
							{	/* Trace/walk.scm 392 */
								BgL_nodez00_bglt BgL_res3781z00_3177;

								{	/* Trace/walk.scm 392 */
									obj_t BgL_method3271z00_3152;

									{	/* Trace/walk.scm 392 */
										BgL_objectz00_bglt BgL_objz00_3153;

										BgL_objz00_3153 =
											(BgL_objectz00_bglt) (BgL_arg3637z00_3148);
										{	/* Trace/walk.scm 392 */
											long BgL_objzd2classzd2numz00_3154;

											BgL_objzd2classzd2numz00_3154 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3153);
											{	/* Trace/walk.scm 392 */
												obj_t BgL_arg2356z00_3155;

												BgL_arg2356z00_3155 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 392 */
													obj_t BgL_arrayz00_3157;

													int BgL_offsetz00_3158;

													BgL_arrayz00_3157 = BgL_arg2356z00_3155;
													BgL_offsetz00_3158 =
														(int) (BgL_objzd2classzd2numz00_3154);
													{	/* Trace/walk.scm 392 */
														long BgL_offsetz00_3159;

														BgL_offsetz00_3159 =
															((long) (BgL_offsetz00_3158) - OBJECT_TYPE);
														{	/* Trace/walk.scm 392 */
															long BgL_modz00_3160;

															{	/* Trace/walk.scm 392 */
																int BgL_arg2358z00_3161;

																BgL_arg2358z00_3161 = (int) (((long) 8));
																{	/* Trace/walk.scm 392 */
																	long BgL_auxz00_4155;

																	BgL_auxz00_4155 =
																		(long) (BgL_arg2358z00_3161);
																	BgL_modz00_3160 =
																		(BgL_offsetz00_3159 / BgL_auxz00_4155);
															}}
															{	/* Trace/walk.scm 392 */
																long BgL_restz00_3162;

																{	/* Trace/walk.scm 392 */
																	int BgL_arg2357z00_3163;

																	BgL_arg2357z00_3163 = (int) (((long) 8));
																	{	/* Trace/walk.scm 392 */
																		long BgL_auxz00_4159;

																		BgL_auxz00_4159 =
																			(long) (BgL_arg2357z00_3163);
																		BgL_restz00_3162 =
																			(BgL_offsetz00_3159 % BgL_auxz00_4159);
																}}
																{	/* Trace/walk.scm 392 */

																	BgL_method3271z00_3152 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3157,
																			(int) (BgL_modz00_3160)),
																		(int) (BgL_restz00_3162));
									}}}}}}}}
									BgL_res3781z00_3177 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_3152)
										(BgL_method3271z00_3152, (obj_t) (BgL_arg3637z00_3148),
											BgL_stackz00_1742, BEOA));
								}
								BgL_arg3636z00_3147 = BgL_res3781z00_3177;
						}}
						((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1741))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3636z00_3147), BUNSPEC);
					}
					BgL_auxz00_4145 = BgL_nodez00_1741;
					return (obj_t) (BgL_auxz00_4145);
				}
			}
		}
	}



/* trace-node-jump-ex-i3299 */
	obj_t BGl_tracezd2nodezd2jumpzd2exzd2i3299z00zztrace_walkz00(obj_t
		BgL_envz00_3357, obj_t BgL_nodez00_3358, obj_t BgL_stackz00_3359)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 382 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1730;

				obj_t BgL_stackz00_1731;

				{	/* Trace/walk.scm 383 */
					BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_4173;

					BgL_nodez00_1730 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_3358);
					BgL_stackz00_1731 = BgL_stackz00_3359;
					{	/* Trace/walk.scm 384 */
						BgL_nodez00_bglt BgL_arg3631z00_1735;

						{	/* Trace/walk.scm 384 */
							BgL_nodez00_bglt BgL_arg3632z00_1736;

							BgL_arg3632z00_1736 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1730))->
								BgL_exitz00);
							{	/* Trace/walk.scm 384 */
								BgL_nodez00_bglt BgL_res3775z00_3113;

								{	/* Trace/walk.scm 384 */
									obj_t BgL_method3271z00_3088;

									{	/* Trace/walk.scm 384 */
										BgL_objectz00_bglt BgL_objz00_3089;

										BgL_objz00_3089 =
											(BgL_objectz00_bglt) (BgL_arg3632z00_1736);
										{	/* Trace/walk.scm 384 */
											long BgL_objzd2classzd2numz00_3090;

											BgL_objzd2classzd2numz00_3090 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3089);
											{	/* Trace/walk.scm 384 */
												obj_t BgL_arg2356z00_3091;

												BgL_arg2356z00_3091 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 384 */
													obj_t BgL_arrayz00_3093;

													int BgL_offsetz00_3094;

													BgL_arrayz00_3093 = BgL_arg2356z00_3091;
													BgL_offsetz00_3094 =
														(int) (BgL_objzd2classzd2numz00_3090);
													{	/* Trace/walk.scm 384 */
														long BgL_offsetz00_3095;

														BgL_offsetz00_3095 =
															((long) (BgL_offsetz00_3094) - OBJECT_TYPE);
														{	/* Trace/walk.scm 384 */
															long BgL_modz00_3096;

															{	/* Trace/walk.scm 384 */
																int BgL_arg2358z00_3097;

																BgL_arg2358z00_3097 = (int) (((long) 8));
																{	/* Trace/walk.scm 384 */
																	long BgL_auxz00_4183;

																	BgL_auxz00_4183 =
																		(long) (BgL_arg2358z00_3097);
																	BgL_modz00_3096 =
																		(BgL_offsetz00_3095 / BgL_auxz00_4183);
															}}
															{	/* Trace/walk.scm 384 */
																long BgL_restz00_3098;

																{	/* Trace/walk.scm 384 */
																	int BgL_arg2357z00_3099;

																	BgL_arg2357z00_3099 = (int) (((long) 8));
																	{	/* Trace/walk.scm 384 */
																		long BgL_auxz00_4187;

																		BgL_auxz00_4187 =
																			(long) (BgL_arg2357z00_3099);
																		BgL_restz00_3098 =
																			(BgL_offsetz00_3095 % BgL_auxz00_4187);
																}}
																{	/* Trace/walk.scm 384 */

																	BgL_method3271z00_3088 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3093,
																			(int) (BgL_modz00_3096)),
																		(int) (BgL_restz00_3098));
									}}}}}}}}
									BgL_res3775z00_3113 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_3088)
										(BgL_method3271z00_3088, (obj_t) (BgL_arg3632z00_1736),
											BgL_stackz00_1731, BEOA));
								}
								BgL_arg3631z00_1735 = BgL_res3775z00_3113;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1730))->
								BgL_exitz00) =
							((BgL_nodez00_bglt) BgL_arg3631z00_1735), BUNSPEC);
					}
					{	/* Trace/walk.scm 385 */
						BgL_nodez00_bglt BgL_arg3633z00_1737;

						{	/* Trace/walk.scm 385 */
							BgL_nodez00_bglt BgL_arg3634z00_1738;

							BgL_arg3634z00_1738 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1730))->
								BgL_valuez00);
							{	/* Trace/walk.scm 385 */
								BgL_nodez00_bglt BgL_res3778z00_3144;

								{	/* Trace/walk.scm 385 */
									obj_t BgL_method3271z00_3119;

									{	/* Trace/walk.scm 385 */
										BgL_objectz00_bglt BgL_objz00_3120;

										BgL_objz00_3120 =
											(BgL_objectz00_bglt) (BgL_arg3634z00_1738);
										{	/* Trace/walk.scm 385 */
											long BgL_objzd2classzd2numz00_3121;

											BgL_objzd2classzd2numz00_3121 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3120);
											{	/* Trace/walk.scm 385 */
												obj_t BgL_arg2356z00_3122;

												BgL_arg2356z00_3122 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 385 */
													obj_t BgL_arrayz00_3124;

													int BgL_offsetz00_3125;

													BgL_arrayz00_3124 = BgL_arg2356z00_3122;
													BgL_offsetz00_3125 =
														(int) (BgL_objzd2classzd2numz00_3121);
													{	/* Trace/walk.scm 385 */
														long BgL_offsetz00_3126;

														BgL_offsetz00_3126 =
															((long) (BgL_offsetz00_3125) - OBJECT_TYPE);
														{	/* Trace/walk.scm 385 */
															long BgL_modz00_3127;

															{	/* Trace/walk.scm 385 */
																int BgL_arg2358z00_3128;

																BgL_arg2358z00_3128 = (int) (((long) 8));
																{	/* Trace/walk.scm 385 */
																	long BgL_auxz00_4208;

																	BgL_auxz00_4208 =
																		(long) (BgL_arg2358z00_3128);
																	BgL_modz00_3127 =
																		(BgL_offsetz00_3126 / BgL_auxz00_4208);
															}}
															{	/* Trace/walk.scm 385 */
																long BgL_restz00_3129;

																{	/* Trace/walk.scm 385 */
																	int BgL_arg2357z00_3130;

																	BgL_arg2357z00_3130 = (int) (((long) 8));
																	{	/* Trace/walk.scm 385 */
																		long BgL_auxz00_4212;

																		BgL_auxz00_4212 =
																			(long) (BgL_arg2357z00_3130);
																		BgL_restz00_3129 =
																			(BgL_offsetz00_3126 % BgL_auxz00_4212);
																}}
																{	/* Trace/walk.scm 385 */

																	BgL_method3271z00_3119 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3124,
																			(int) (BgL_modz00_3127)),
																		(int) (BgL_restz00_3129));
									}}}}}}}}
									BgL_res3778z00_3144 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_3119)
										(BgL_method3271z00_3119, (obj_t) (BgL_arg3634z00_1738),
											BgL_stackz00_1731, BEOA));
								}
								BgL_arg3633z00_1737 = BgL_res3778z00_3144;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1730))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3633z00_1737), BUNSPEC);
					}
					BgL_auxz00_4173 = BgL_nodez00_1730;
					return (obj_t) (BgL_auxz00_4173);
				}
			}
		}
	}



/* trace-node-set-ex-it3297 */
	obj_t BGl_tracezd2nodezd2setzd2exzd2it3297z00zztrace_walkz00(obj_t
		BgL_envz00_3360, obj_t BgL_nodez00_3361, obj_t BgL_stackz00_3362)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 375 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1722;

				obj_t BgL_stackz00_1723;

				{	/* Trace/walk.scm 376 */
					BgL_setzd2exzd2itz00_bglt BgL_auxz00_4226;

					BgL_nodez00_1722 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_3361);
					BgL_stackz00_1723 = BgL_stackz00_3362;
					{	/* Trace/walk.scm 376 */
						BgL_nodez00_bglt BgL_arg3628z00_3052;

						{	/* Trace/walk.scm 376 */
							BgL_nodez00_bglt BgL_arg3629z00_3053;

							BgL_arg3629z00_3053 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1722))->
								BgL_bodyz00);
							{	/* Trace/walk.scm 376 */
								BgL_nodez00_bglt BgL_res3772z00_3082;

								{	/* Trace/walk.scm 376 */
									obj_t BgL_method3271z00_3057;

									{	/* Trace/walk.scm 376 */
										BgL_objectz00_bglt BgL_objz00_3058;

										BgL_objz00_3058 =
											(BgL_objectz00_bglt) (BgL_arg3629z00_3053);
										{	/* Trace/walk.scm 376 */
											long BgL_objzd2classzd2numz00_3059;

											BgL_objzd2classzd2numz00_3059 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3058);
											{	/* Trace/walk.scm 376 */
												obj_t BgL_arg2356z00_3060;

												BgL_arg2356z00_3060 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 376 */
													obj_t BgL_arrayz00_3062;

													int BgL_offsetz00_3063;

													BgL_arrayz00_3062 = BgL_arg2356z00_3060;
													BgL_offsetz00_3063 =
														(int) (BgL_objzd2classzd2numz00_3059);
													{	/* Trace/walk.scm 376 */
														long BgL_offsetz00_3064;

														BgL_offsetz00_3064 =
															((long) (BgL_offsetz00_3063) - OBJECT_TYPE);
														{	/* Trace/walk.scm 376 */
															long BgL_modz00_3065;

															{	/* Trace/walk.scm 376 */
																int BgL_arg2358z00_3066;

																BgL_arg2358z00_3066 = (int) (((long) 8));
																{	/* Trace/walk.scm 376 */
																	long BgL_auxz00_4236;

																	BgL_auxz00_4236 =
																		(long) (BgL_arg2358z00_3066);
																	BgL_modz00_3065 =
																		(BgL_offsetz00_3064 / BgL_auxz00_4236);
															}}
															{	/* Trace/walk.scm 376 */
																long BgL_restz00_3067;

																{	/* Trace/walk.scm 376 */
																	int BgL_arg2357z00_3068;

																	BgL_arg2357z00_3068 = (int) (((long) 8));
																	{	/* Trace/walk.scm 376 */
																		long BgL_auxz00_4240;

																		BgL_auxz00_4240 =
																			(long) (BgL_arg2357z00_3068);
																		BgL_restz00_3067 =
																			(BgL_offsetz00_3064 % BgL_auxz00_4240);
																}}
																{	/* Trace/walk.scm 376 */

																	BgL_method3271z00_3057 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3062,
																			(int) (BgL_modz00_3065)),
																		(int) (BgL_restz00_3067));
									}}}}}}}}
									BgL_res3772z00_3082 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_3057)
										(BgL_method3271z00_3057, (obj_t) (BgL_arg3629z00_3053),
											BgL_stackz00_1723, BEOA));
								}
								BgL_arg3628z00_3052 = BgL_res3772z00_3082;
						}}
						((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1722))->
								BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3628z00_3052), BUNSPEC);
					}
					BgL_auxz00_4226 = BgL_nodez00_1722;
					return (obj_t) (BgL_auxz00_4226);
				}
			}
		}
	}



/* trace-node-let-var3295 */
	obj_t BGl_tracezd2nodezd2letzd2var3295zd2zztrace_walkz00(obj_t
		BgL_envz00_3363, obj_t BgL_nodez00_3364, obj_t BgL_stackz00_3365)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 364 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1705;

				obj_t BgL_stackz00_1706;

				{	/* Trace/walk.scm 365 */
					BgL_letzd2varzd2_bglt BgL_auxz00_4254;

					BgL_nodez00_1705 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_3364);
					BgL_stackz00_1706 = BgL_stackz00_3365;
					{	/* Trace/walk.scm 366 */
						obj_t BgL_g3240z00_1710;

						BgL_g3240z00_1710 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1705))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3238z00_1711;

							BgL_l3238z00_1711 = BgL_g3240z00_1710;
						BgL_forzd2each3239zd2_1712:
							if (PAIRP(BgL_l3238z00_1711))
								{	/* Trace/walk.scm 366 */
									{	/* Trace/walk.scm 367 */
										obj_t BgL_bindingz00_1714;

										BgL_bindingz00_1714 = CAR(BgL_l3238z00_1711);
										{	/* Trace/walk.scm 367 */
											BgL_nodez00_bglt BgL_arg3622z00_1715;

											{	/* Trace/walk.scm 367 */
												obj_t BgL_arg3623z00_1716;

												BgL_arg3623z00_1716 = CDR(BgL_bindingz00_1714);
												{	/* Trace/walk.scm 367 */
													BgL_nodez00_bglt BgL_res3766z00_3017;

													{	/* Trace/walk.scm 367 */
														BgL_nodez00_bglt BgL_nodez00_2990;

														BgL_nodez00_2990 =
															(BgL_nodez00_bglt) (BgL_arg3623z00_1716);
														{	/* Trace/walk.scm 367 */
															obj_t BgL_method3271z00_2992;

															{	/* Trace/walk.scm 367 */
																BgL_objectz00_bglt BgL_objz00_2993;

																BgL_objz00_2993 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2990);
																{	/* Trace/walk.scm 367 */
																	long BgL_objzd2classzd2numz00_2994;

																	BgL_objzd2classzd2numz00_2994 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2993);
																	{	/* Trace/walk.scm 367 */
																		obj_t BgL_arg2356z00_2995;

																		BgL_arg2356z00_2995 =
																			PROCEDURE_REF
																			(BGl_tracezd2nodezd2envz00zztrace_walkz00,
																			(int) (((long) 1)));
																		{	/* Trace/walk.scm 367 */
																			obj_t BgL_arrayz00_2997;

																			int BgL_offsetz00_2998;

																			BgL_arrayz00_2997 = BgL_arg2356z00_2995;
																			BgL_offsetz00_2998 =
																				(int) (BgL_objzd2classzd2numz00_2994);
																			{	/* Trace/walk.scm 367 */
																				long BgL_offsetz00_2999;

																				BgL_offsetz00_2999 =
																					(
																					(long) (BgL_offsetz00_2998) -
																					OBJECT_TYPE);
																				{	/* Trace/walk.scm 367 */
																					long BgL_modz00_3000;

																					{	/* Trace/walk.scm 367 */
																						int BgL_arg2358z00_3001;

																						BgL_arg2358z00_3001 =
																							(int) (((long) 8));
																						{	/* Trace/walk.scm 367 */
																							long BgL_auxz00_4269;

																							BgL_auxz00_4269 =
																								(long) (BgL_arg2358z00_3001);
																							BgL_modz00_3000 =
																								(BgL_offsetz00_2999 /
																								BgL_auxz00_4269);
																					}}
																					{	/* Trace/walk.scm 367 */
																						long BgL_restz00_3002;

																						{	/* Trace/walk.scm 367 */
																							int BgL_arg2357z00_3003;

																							BgL_arg2357z00_3003 =
																								(int) (((long) 8));
																							{	/* Trace/walk.scm 367 */
																								long BgL_auxz00_4273;

																								BgL_auxz00_4273 =
																									(long) (BgL_arg2357z00_3003);
																								BgL_restz00_3002 =
																									(BgL_offsetz00_2999 %
																									BgL_auxz00_4273);
																						}}
																						{	/* Trace/walk.scm 367 */

																							BgL_method3271z00_2992 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2997,
																									(int) (BgL_modz00_3000)),
																								(int) (BgL_restz00_3002));
															}}}}}}}}
															BgL_res3766z00_3017 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3271z00_2992)
																(BgL_method3271z00_2992,
																	(obj_t) (BgL_nodez00_2990), BgL_stackz00_1706,
																	BEOA));
													}}
													BgL_arg3622z00_1715 = BgL_res3766z00_3017;
											}}
											{	/* Trace/walk.scm 367 */
												obj_t BgL_auxz00_4284;

												BgL_auxz00_4284 = (obj_t) (BgL_arg3622z00_1715);
												SET_CDR(BgL_bindingz00_1714, BgL_auxz00_4284);
									}}}
									{
										obj_t BgL_l3238z00_4287;

										BgL_l3238z00_4287 = CDR(BgL_l3238z00_1711);
										BgL_l3238z00_1711 = BgL_l3238z00_4287;
										goto BgL_forzd2each3239zd2_1712;
									}
								}
							else
								{	/* Trace/walk.scm 366 */
									((bool_t) 1);
								}
						}
					}
					{	/* Trace/walk.scm 369 */
						BgL_nodez00_bglt BgL_arg3625z00_1718;

						{	/* Trace/walk.scm 369 */
							BgL_nodez00_bglt BgL_arg3626z00_1719;

							BgL_arg3626z00_1719 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1705))->BgL_bodyz00);
							{	/* Trace/walk.scm 369 */
								BgL_nodez00_bglt BgL_res3769z00_3049;

								{	/* Trace/walk.scm 369 */
									obj_t BgL_method3271z00_3024;

									{	/* Trace/walk.scm 369 */
										BgL_objectz00_bglt BgL_objz00_3025;

										BgL_objz00_3025 =
											(BgL_objectz00_bglt) (BgL_arg3626z00_1719);
										{	/* Trace/walk.scm 369 */
											long BgL_objzd2classzd2numz00_3026;

											BgL_objzd2classzd2numz00_3026 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3025);
											{	/* Trace/walk.scm 369 */
												obj_t BgL_arg2356z00_3027;

												BgL_arg2356z00_3027 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 369 */
													obj_t BgL_arrayz00_3029;

													int BgL_offsetz00_3030;

													BgL_arrayz00_3029 = BgL_arg2356z00_3027;
													BgL_offsetz00_3030 =
														(int) (BgL_objzd2classzd2numz00_3026);
													{	/* Trace/walk.scm 369 */
														long BgL_offsetz00_3031;

														BgL_offsetz00_3031 =
															((long) (BgL_offsetz00_3030) - OBJECT_TYPE);
														{	/* Trace/walk.scm 369 */
															long BgL_modz00_3032;

															{	/* Trace/walk.scm 369 */
																int BgL_arg2358z00_3033;

																BgL_arg2358z00_3033 = (int) (((long) 8));
																{	/* Trace/walk.scm 369 */
																	long BgL_auxz00_4298;

																	BgL_auxz00_4298 =
																		(long) (BgL_arg2358z00_3033);
																	BgL_modz00_3032 =
																		(BgL_offsetz00_3031 / BgL_auxz00_4298);
															}}
															{	/* Trace/walk.scm 369 */
																long BgL_restz00_3034;

																{	/* Trace/walk.scm 369 */
																	int BgL_arg2357z00_3035;

																	BgL_arg2357z00_3035 = (int) (((long) 8));
																	{	/* Trace/walk.scm 369 */
																		long BgL_auxz00_4302;

																		BgL_auxz00_4302 =
																			(long) (BgL_arg2357z00_3035);
																		BgL_restz00_3034 =
																			(BgL_offsetz00_3031 % BgL_auxz00_4302);
																}}
																{	/* Trace/walk.scm 369 */

																	BgL_method3271z00_3024 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3029,
																			(int) (BgL_modz00_3032)),
																		(int) (BgL_restz00_3034));
									}}}}}}}}
									BgL_res3769z00_3049 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_3024)
										(BgL_method3271z00_3024, (obj_t) (BgL_arg3626z00_1719),
											BgL_stackz00_1706, BEOA));
								}
								BgL_arg3625z00_1718 = BgL_res3769z00_3049;
						}}
						((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1705))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3625z00_1718), BUNSPEC);
					}
					BgL_auxz00_4254 = BgL_nodez00_1705;
					return (obj_t) (BgL_auxz00_4254);
				}
			}
		}
	}



/* trace-node-let-fun3293 */
	obj_t BGl_tracezd2nodezd2letzd2fun3293zd2zztrace_walkz00(obj_t
		BgL_envz00_3366, obj_t BgL_nodez00_3367, obj_t BgL_stackz00_3368)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 355 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1690;

				obj_t BgL_stackz00_1691;

				{	/* Trace/walk.scm 356 */
					BgL_letzd2funzd2_bglt BgL_auxz00_4316;

					BgL_nodez00_1690 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_3367);
					BgL_stackz00_1691 = BgL_stackz00_3368;
					{	/* Trace/walk.scm 357 */
						obj_t BgL_g3237z00_1695;

						BgL_g3237z00_1695 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1690))->BgL_localsz00);
						{
							obj_t BgL_l3235z00_1696;

							BgL_l3235z00_1696 = BgL_g3237z00_1695;
						BgL_forzd2each3236zd2_1697:
							if (PAIRP(BgL_l3235z00_1696))
								{	/* Trace/walk.scm 357 */
									BGl_tracezd2funz12zc0zztrace_walkz00(CAR(BgL_l3235z00_1696),
										BgL_stackz00_1691);
									{
										obj_t BgL_l3235z00_4322;

										BgL_l3235z00_4322 = CDR(BgL_l3235z00_1696);
										BgL_l3235z00_1696 = BgL_l3235z00_4322;
										goto BgL_forzd2each3236zd2_1697;
									}
								}
							else
								{	/* Trace/walk.scm 357 */
									((bool_t) 1);
								}
						}
					}
					{	/* Trace/walk.scm 358 */
						BgL_nodez00_bglt BgL_arg3618z00_1701;

						{	/* Trace/walk.scm 358 */
							BgL_nodez00_bglt BgL_arg3619z00_1702;

							BgL_arg3619z00_1702 =
								(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1690))->BgL_bodyz00);
							{	/* Trace/walk.scm 358 */
								BgL_nodez00_bglt BgL_res3763z00_2983;

								{	/* Trace/walk.scm 358 */
									obj_t BgL_method3271z00_2958;

									{	/* Trace/walk.scm 358 */
										BgL_objectz00_bglt BgL_objz00_2959;

										BgL_objz00_2959 =
											(BgL_objectz00_bglt) (BgL_arg3619z00_1702);
										{	/* Trace/walk.scm 358 */
											long BgL_objzd2classzd2numz00_2960;

											BgL_objzd2classzd2numz00_2960 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2959);
											{	/* Trace/walk.scm 358 */
												obj_t BgL_arg2356z00_2961;

												BgL_arg2356z00_2961 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 358 */
													obj_t BgL_arrayz00_2963;

													int BgL_offsetz00_2964;

													BgL_arrayz00_2963 = BgL_arg2356z00_2961;
													BgL_offsetz00_2964 =
														(int) (BgL_objzd2classzd2numz00_2960);
													{	/* Trace/walk.scm 358 */
														long BgL_offsetz00_2965;

														BgL_offsetz00_2965 =
															((long) (BgL_offsetz00_2964) - OBJECT_TYPE);
														{	/* Trace/walk.scm 358 */
															long BgL_modz00_2966;

															{	/* Trace/walk.scm 358 */
																int BgL_arg2358z00_2967;

																BgL_arg2358z00_2967 = (int) (((long) 8));
																{	/* Trace/walk.scm 358 */
																	long BgL_auxz00_4333;

																	BgL_auxz00_4333 =
																		(long) (BgL_arg2358z00_2967);
																	BgL_modz00_2966 =
																		(BgL_offsetz00_2965 / BgL_auxz00_4333);
															}}
															{	/* Trace/walk.scm 358 */
																long BgL_restz00_2968;

																{	/* Trace/walk.scm 358 */
																	int BgL_arg2357z00_2969;

																	BgL_arg2357z00_2969 = (int) (((long) 8));
																	{	/* Trace/walk.scm 358 */
																		long BgL_auxz00_4337;

																		BgL_auxz00_4337 =
																			(long) (BgL_arg2357z00_2969);
																		BgL_restz00_2968 =
																			(BgL_offsetz00_2965 % BgL_auxz00_4337);
																}}
																{	/* Trace/walk.scm 358 */

																	BgL_method3271z00_2958 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2963,
																			(int) (BgL_modz00_2966)),
																		(int) (BgL_restz00_2968));
									}}}}}}}}
									BgL_res3763z00_2983 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2958)
										(BgL_method3271z00_2958, (obj_t) (BgL_arg3619z00_1702),
											BgL_stackz00_1691, BEOA));
								}
								BgL_arg3618z00_1701 = BgL_res3763z00_2983;
						}}
						((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1690))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3618z00_1701), BUNSPEC);
					}
					BgL_auxz00_4316 = BgL_nodez00_1690;
					return (obj_t) (BgL_auxz00_4316);
				}
			}
		}
	}



/* trace-node-select3291 */
	obj_t BGl_tracezd2nodezd2select3291z00zztrace_walkz00(obj_t BgL_envz00_3369,
		obj_t BgL_nodez00_3370, obj_t BgL_stackz00_3371)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 344 */
			{
				BgL_selectz00_bglt BgL_nodez00_1673;

				obj_t BgL_stackz00_1674;

				{	/* Trace/walk.scm 345 */
					BgL_selectz00_bglt BgL_auxz00_4351;

					BgL_nodez00_1673 = (BgL_selectz00_bglt) (BgL_nodez00_3370);
					BgL_stackz00_1674 = BgL_stackz00_3371;
					{	/* Trace/walk.scm 346 */
						BgL_nodez00_bglt BgL_arg3609z00_1678;

						{	/* Trace/walk.scm 346 */
							BgL_nodez00_bglt BgL_arg3610z00_1679;

							BgL_arg3610z00_1679 =
								(((BgL_selectz00_bglt) CREF(BgL_nodez00_1673))->BgL_testz00);
							{	/* Trace/walk.scm 346 */
								BgL_nodez00_bglt BgL_res3757z00_2913;

								{	/* Trace/walk.scm 346 */
									obj_t BgL_method3271z00_2888;

									{	/* Trace/walk.scm 346 */
										BgL_objectz00_bglt BgL_objz00_2889;

										BgL_objz00_2889 =
											(BgL_objectz00_bglt) (BgL_arg3610z00_1679);
										{	/* Trace/walk.scm 346 */
											long BgL_objzd2classzd2numz00_2890;

											BgL_objzd2classzd2numz00_2890 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2889);
											{	/* Trace/walk.scm 346 */
												obj_t BgL_arg2356z00_2891;

												BgL_arg2356z00_2891 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 346 */
													obj_t BgL_arrayz00_2893;

													int BgL_offsetz00_2894;

													BgL_arrayz00_2893 = BgL_arg2356z00_2891;
													BgL_offsetz00_2894 =
														(int) (BgL_objzd2classzd2numz00_2890);
													{	/* Trace/walk.scm 346 */
														long BgL_offsetz00_2895;

														BgL_offsetz00_2895 =
															((long) (BgL_offsetz00_2894) - OBJECT_TYPE);
														{	/* Trace/walk.scm 346 */
															long BgL_modz00_2896;

															{	/* Trace/walk.scm 346 */
																int BgL_arg2358z00_2897;

																BgL_arg2358z00_2897 = (int) (((long) 8));
																{	/* Trace/walk.scm 346 */
																	long BgL_auxz00_4361;

																	BgL_auxz00_4361 =
																		(long) (BgL_arg2358z00_2897);
																	BgL_modz00_2896 =
																		(BgL_offsetz00_2895 / BgL_auxz00_4361);
															}}
															{	/* Trace/walk.scm 346 */
																long BgL_restz00_2898;

																{	/* Trace/walk.scm 346 */
																	int BgL_arg2357z00_2899;

																	BgL_arg2357z00_2899 = (int) (((long) 8));
																	{	/* Trace/walk.scm 346 */
																		long BgL_auxz00_4365;

																		BgL_auxz00_4365 =
																			(long) (BgL_arg2357z00_2899);
																		BgL_restz00_2898 =
																			(BgL_offsetz00_2895 % BgL_auxz00_4365);
																}}
																{	/* Trace/walk.scm 346 */

																	BgL_method3271z00_2888 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2893,
																			(int) (BgL_modz00_2896)),
																		(int) (BgL_restz00_2898));
									}}}}}}}}
									BgL_res3757z00_2913 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2888)
										(BgL_method3271z00_2888, (obj_t) (BgL_arg3610z00_1679),
											BgL_stackz00_1674, BEOA));
								}
								BgL_arg3609z00_1678 = BgL_res3757z00_2913;
						}}
						((((BgL_selectz00_bglt) CREF(BgL_nodez00_1673))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3609z00_1678), BUNSPEC);
					}
					{	/* Trace/walk.scm 347 */
						obj_t BgL_g3234z00_1680;

						BgL_g3234z00_1680 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1673))->BgL_clausesz00);
						{
							obj_t BgL_l3231z00_1681;

							BgL_l3231z00_1681 = BgL_g3234z00_1680;
						BgL_forzd2each3233zd2_1682:
							if (PAIRP(BgL_l3231z00_1681))
								{	/* Trace/walk.scm 347 */
									{	/* Trace/walk.scm 348 */
										obj_t BgL_clausez00_1684;

										BgL_clausez00_1684 = CAR(BgL_l3231z00_1681);
										{	/* Trace/walk.scm 348 */
											BgL_nodez00_bglt BgL_arg3612z00_1685;

											{	/* Trace/walk.scm 348 */
												obj_t BgL_arg3613z00_1686;

												BgL_arg3613z00_1686 = CDR(BgL_clausez00_1684);
												{	/* Trace/walk.scm 348 */
													BgL_nodez00_bglt BgL_res3760z00_2947;

													{	/* Trace/walk.scm 348 */
														BgL_nodez00_bglt BgL_nodez00_2920;

														BgL_nodez00_2920 =
															(BgL_nodez00_bglt) (BgL_arg3613z00_1686);
														{	/* Trace/walk.scm 348 */
															obj_t BgL_method3271z00_2922;

															{	/* Trace/walk.scm 348 */
																BgL_objectz00_bglt BgL_objz00_2923;

																BgL_objz00_2923 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2920);
																{	/* Trace/walk.scm 348 */
																	long BgL_objzd2classzd2numz00_2924;

																	BgL_objzd2classzd2numz00_2924 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2923);
																	{	/* Trace/walk.scm 348 */
																		obj_t BgL_arg2356z00_2925;

																		BgL_arg2356z00_2925 =
																			PROCEDURE_REF
																			(BGl_tracezd2nodezd2envz00zztrace_walkz00,
																			(int) (((long) 1)));
																		{	/* Trace/walk.scm 348 */
																			obj_t BgL_arrayz00_2927;

																			int BgL_offsetz00_2928;

																			BgL_arrayz00_2927 = BgL_arg2356z00_2925;
																			BgL_offsetz00_2928 =
																				(int) (BgL_objzd2classzd2numz00_2924);
																			{	/* Trace/walk.scm 348 */
																				long BgL_offsetz00_2929;

																				BgL_offsetz00_2929 =
																					(
																					(long) (BgL_offsetz00_2928) -
																					OBJECT_TYPE);
																				{	/* Trace/walk.scm 348 */
																					long BgL_modz00_2930;

																					{	/* Trace/walk.scm 348 */
																						int BgL_arg2358z00_2931;

																						BgL_arg2358z00_2931 =
																							(int) (((long) 8));
																						{	/* Trace/walk.scm 348 */
																							long BgL_auxz00_4391;

																							BgL_auxz00_4391 =
																								(long) (BgL_arg2358z00_2931);
																							BgL_modz00_2930 =
																								(BgL_offsetz00_2929 /
																								BgL_auxz00_4391);
																					}}
																					{	/* Trace/walk.scm 348 */
																						long BgL_restz00_2932;

																						{	/* Trace/walk.scm 348 */
																							int BgL_arg2357z00_2933;

																							BgL_arg2357z00_2933 =
																								(int) (((long) 8));
																							{	/* Trace/walk.scm 348 */
																								long BgL_auxz00_4395;

																								BgL_auxz00_4395 =
																									(long) (BgL_arg2357z00_2933);
																								BgL_restz00_2932 =
																									(BgL_offsetz00_2929 %
																									BgL_auxz00_4395);
																						}}
																						{	/* Trace/walk.scm 348 */

																							BgL_method3271z00_2922 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2927,
																									(int) (BgL_modz00_2930)),
																								(int) (BgL_restz00_2932));
															}}}}}}}}
															BgL_res3760z00_2947 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3271z00_2922)
																(BgL_method3271z00_2922,
																	(obj_t) (BgL_nodez00_2920), BgL_stackz00_1674,
																	BEOA));
													}}
													BgL_arg3612z00_1685 = BgL_res3760z00_2947;
											}}
											{	/* Trace/walk.scm 348 */
												obj_t BgL_auxz00_4406;

												BgL_auxz00_4406 = (obj_t) (BgL_arg3612z00_1685);
												SET_CDR(BgL_clausez00_1684, BgL_auxz00_4406);
									}}}
									{
										obj_t BgL_l3231z00_4409;

										BgL_l3231z00_4409 = CDR(BgL_l3231z00_1681);
										BgL_l3231z00_1681 = BgL_l3231z00_4409;
										goto BgL_forzd2each3233zd2_1682;
									}
								}
							else
								{	/* Trace/walk.scm 347 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_4351 = BgL_nodez00_1673;
					return (obj_t) (BgL_auxz00_4351);
				}
			}
		}
	}



/* trace-node-fail3289 */
	obj_t BGl_tracezd2nodezd2fail3289z00zztrace_walkz00(obj_t BgL_envz00_3372,
		obj_t BgL_nodez00_3373, obj_t BgL_stackz00_3374)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 334 */
			{
				BgL_failz00_bglt BgL_nodez00_1660;

				obj_t BgL_stackz00_1661;

				{	/* Trace/walk.scm 335 */
					BgL_failz00_bglt BgL_auxz00_4413;

					BgL_nodez00_1660 = (BgL_failz00_bglt) (BgL_nodez00_3373);
					BgL_stackz00_1661 = BgL_stackz00_3374;
					{	/* Trace/walk.scm 336 */
						BgL_nodez00_bglt BgL_arg3602z00_1665;

						{	/* Trace/walk.scm 336 */
							BgL_nodez00_bglt BgL_arg3603z00_1666;

							BgL_arg3603z00_1666 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1660))->BgL_procz00);
							{	/* Trace/walk.scm 336 */
								BgL_nodez00_bglt BgL_res3748z00_2820;

								{	/* Trace/walk.scm 336 */
									obj_t BgL_method3271z00_2795;

									{	/* Trace/walk.scm 336 */
										BgL_objectz00_bglt BgL_objz00_2796;

										BgL_objz00_2796 =
											(BgL_objectz00_bglt) (BgL_arg3603z00_1666);
										{	/* Trace/walk.scm 336 */
											long BgL_objzd2classzd2numz00_2797;

											BgL_objzd2classzd2numz00_2797 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2796);
											{	/* Trace/walk.scm 336 */
												obj_t BgL_arg2356z00_2798;

												BgL_arg2356z00_2798 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 336 */
													obj_t BgL_arrayz00_2800;

													int BgL_offsetz00_2801;

													BgL_arrayz00_2800 = BgL_arg2356z00_2798;
													BgL_offsetz00_2801 =
														(int) (BgL_objzd2classzd2numz00_2797);
													{	/* Trace/walk.scm 336 */
														long BgL_offsetz00_2802;

														BgL_offsetz00_2802 =
															((long) (BgL_offsetz00_2801) - OBJECT_TYPE);
														{	/* Trace/walk.scm 336 */
															long BgL_modz00_2803;

															{	/* Trace/walk.scm 336 */
																int BgL_arg2358z00_2804;

																BgL_arg2358z00_2804 = (int) (((long) 8));
																{	/* Trace/walk.scm 336 */
																	long BgL_auxz00_4423;

																	BgL_auxz00_4423 =
																		(long) (BgL_arg2358z00_2804);
																	BgL_modz00_2803 =
																		(BgL_offsetz00_2802 / BgL_auxz00_4423);
															}}
															{	/* Trace/walk.scm 336 */
																long BgL_restz00_2805;

																{	/* Trace/walk.scm 336 */
																	int BgL_arg2357z00_2806;

																	BgL_arg2357z00_2806 = (int) (((long) 8));
																	{	/* Trace/walk.scm 336 */
																		long BgL_auxz00_4427;

																		BgL_auxz00_4427 =
																			(long) (BgL_arg2357z00_2806);
																		BgL_restz00_2805 =
																			(BgL_offsetz00_2802 % BgL_auxz00_4427);
																}}
																{	/* Trace/walk.scm 336 */

																	BgL_method3271z00_2795 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2800,
																			(int) (BgL_modz00_2803)),
																		(int) (BgL_restz00_2805));
									}}}}}}}}
									BgL_res3748z00_2820 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2795)
										(BgL_method3271z00_2795, (obj_t) (BgL_arg3603z00_1666),
											BgL_stackz00_1661, BEOA));
								}
								BgL_arg3602z00_1665 = BgL_res3748z00_2820;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1660))->BgL_procz00) =
							((BgL_nodez00_bglt) BgL_arg3602z00_1665), BUNSPEC);
					}
					{	/* Trace/walk.scm 337 */
						BgL_nodez00_bglt BgL_arg3604z00_1667;

						{	/* Trace/walk.scm 337 */
							BgL_nodez00_bglt BgL_arg3605z00_1668;

							BgL_arg3605z00_1668 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1660))->BgL_msgz00);
							{	/* Trace/walk.scm 337 */
								BgL_nodez00_bglt BgL_res3751z00_2851;

								{	/* Trace/walk.scm 337 */
									obj_t BgL_method3271z00_2826;

									{	/* Trace/walk.scm 337 */
										BgL_objectz00_bglt BgL_objz00_2827;

										BgL_objz00_2827 =
											(BgL_objectz00_bglt) (BgL_arg3605z00_1668);
										{	/* Trace/walk.scm 337 */
											long BgL_objzd2classzd2numz00_2828;

											BgL_objzd2classzd2numz00_2828 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2827);
											{	/* Trace/walk.scm 337 */
												obj_t BgL_arg2356z00_2829;

												BgL_arg2356z00_2829 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 337 */
													obj_t BgL_arrayz00_2831;

													int BgL_offsetz00_2832;

													BgL_arrayz00_2831 = BgL_arg2356z00_2829;
													BgL_offsetz00_2832 =
														(int) (BgL_objzd2classzd2numz00_2828);
													{	/* Trace/walk.scm 337 */
														long BgL_offsetz00_2833;

														BgL_offsetz00_2833 =
															((long) (BgL_offsetz00_2832) - OBJECT_TYPE);
														{	/* Trace/walk.scm 337 */
															long BgL_modz00_2834;

															{	/* Trace/walk.scm 337 */
																int BgL_arg2358z00_2835;

																BgL_arg2358z00_2835 = (int) (((long) 8));
																{	/* Trace/walk.scm 337 */
																	long BgL_auxz00_4448;

																	BgL_auxz00_4448 =
																		(long) (BgL_arg2358z00_2835);
																	BgL_modz00_2834 =
																		(BgL_offsetz00_2833 / BgL_auxz00_4448);
															}}
															{	/* Trace/walk.scm 337 */
																long BgL_restz00_2836;

																{	/* Trace/walk.scm 337 */
																	int BgL_arg2357z00_2837;

																	BgL_arg2357z00_2837 = (int) (((long) 8));
																	{	/* Trace/walk.scm 337 */
																		long BgL_auxz00_4452;

																		BgL_auxz00_4452 =
																			(long) (BgL_arg2357z00_2837);
																		BgL_restz00_2836 =
																			(BgL_offsetz00_2833 % BgL_auxz00_4452);
																}}
																{	/* Trace/walk.scm 337 */

																	BgL_method3271z00_2826 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2831,
																			(int) (BgL_modz00_2834)),
																		(int) (BgL_restz00_2836));
									}}}}}}}}
									BgL_res3751z00_2851 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2826)
										(BgL_method3271z00_2826, (obj_t) (BgL_arg3605z00_1668),
											BgL_stackz00_1661, BEOA));
								}
								BgL_arg3604z00_1667 = BgL_res3751z00_2851;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1660))->BgL_msgz00) =
							((BgL_nodez00_bglt) BgL_arg3604z00_1667), BUNSPEC);
					}
					{	/* Trace/walk.scm 338 */
						BgL_nodez00_bglt BgL_arg3606z00_1669;

						{	/* Trace/walk.scm 338 */
							BgL_nodez00_bglt BgL_arg3607z00_1670;

							BgL_arg3607z00_1670 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1660))->BgL_objz00);
							{	/* Trace/walk.scm 338 */
								BgL_nodez00_bglt BgL_res3754z00_2882;

								{	/* Trace/walk.scm 338 */
									obj_t BgL_method3271z00_2857;

									{	/* Trace/walk.scm 338 */
										BgL_objectz00_bglt BgL_objz00_2858;

										BgL_objz00_2858 =
											(BgL_objectz00_bglt) (BgL_arg3607z00_1670);
										{	/* Trace/walk.scm 338 */
											long BgL_objzd2classzd2numz00_2859;

											BgL_objzd2classzd2numz00_2859 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2858);
											{	/* Trace/walk.scm 338 */
												obj_t BgL_arg2356z00_2860;

												BgL_arg2356z00_2860 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 338 */
													obj_t BgL_arrayz00_2862;

													int BgL_offsetz00_2863;

													BgL_arrayz00_2862 = BgL_arg2356z00_2860;
													BgL_offsetz00_2863 =
														(int) (BgL_objzd2classzd2numz00_2859);
													{	/* Trace/walk.scm 338 */
														long BgL_offsetz00_2864;

														BgL_offsetz00_2864 =
															((long) (BgL_offsetz00_2863) - OBJECT_TYPE);
														{	/* Trace/walk.scm 338 */
															long BgL_modz00_2865;

															{	/* Trace/walk.scm 338 */
																int BgL_arg2358z00_2866;

																BgL_arg2358z00_2866 = (int) (((long) 8));
																{	/* Trace/walk.scm 338 */
																	long BgL_auxz00_4473;

																	BgL_auxz00_4473 =
																		(long) (BgL_arg2358z00_2866);
																	BgL_modz00_2865 =
																		(BgL_offsetz00_2864 / BgL_auxz00_4473);
															}}
															{	/* Trace/walk.scm 338 */
																long BgL_restz00_2867;

																{	/* Trace/walk.scm 338 */
																	int BgL_arg2357z00_2868;

																	BgL_arg2357z00_2868 = (int) (((long) 8));
																	{	/* Trace/walk.scm 338 */
																		long BgL_auxz00_4477;

																		BgL_auxz00_4477 =
																			(long) (BgL_arg2357z00_2868);
																		BgL_restz00_2867 =
																			(BgL_offsetz00_2864 % BgL_auxz00_4477);
																}}
																{	/* Trace/walk.scm 338 */

																	BgL_method3271z00_2857 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2862,
																			(int) (BgL_modz00_2865)),
																		(int) (BgL_restz00_2867));
									}}}}}}}}
									BgL_res3754z00_2882 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2857)
										(BgL_method3271z00_2857, (obj_t) (BgL_arg3607z00_1670),
											BgL_stackz00_1661, BEOA));
								}
								BgL_arg3606z00_1669 = BgL_res3754z00_2882;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1660))->BgL_objz00) =
							((BgL_nodez00_bglt) BgL_arg3606z00_1669), BUNSPEC);
					}
					BgL_auxz00_4413 = BgL_nodez00_1660;
					return (obj_t) (BgL_auxz00_4413);
				}
			}
		}
	}



/* trace-node-condition3287 */
	obj_t BGl_tracezd2nodezd2condition3287z00zztrace_walkz00(obj_t
		BgL_envz00_3375, obj_t BgL_nodez00_3376, obj_t BgL_stackz00_3377)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 324 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1647;

				obj_t BgL_stackz00_1648;

				{	/* Trace/walk.scm 325 */
					BgL_conditionalz00_bglt BgL_auxz00_4491;

					BgL_nodez00_1647 = (BgL_conditionalz00_bglt) (BgL_nodez00_3376);
					BgL_stackz00_1648 = BgL_stackz00_3377;
					{	/* Trace/walk.scm 326 */
						BgL_nodez00_bglt BgL_arg3594z00_1652;

						{	/* Trace/walk.scm 326 */
							BgL_nodez00_bglt BgL_arg3595z00_1653;

							BgL_arg3595z00_1653 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1647))->
								BgL_testz00);
							{	/* Trace/walk.scm 326 */
								BgL_nodez00_bglt BgL_res3739z00_2727;

								{	/* Trace/walk.scm 326 */
									obj_t BgL_method3271z00_2702;

									{	/* Trace/walk.scm 326 */
										BgL_objectz00_bglt BgL_objz00_2703;

										BgL_objz00_2703 =
											(BgL_objectz00_bglt) (BgL_arg3595z00_1653);
										{	/* Trace/walk.scm 326 */
											long BgL_objzd2classzd2numz00_2704;

											BgL_objzd2classzd2numz00_2704 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2703);
											{	/* Trace/walk.scm 326 */
												obj_t BgL_arg2356z00_2705;

												BgL_arg2356z00_2705 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 326 */
													obj_t BgL_arrayz00_2707;

													int BgL_offsetz00_2708;

													BgL_arrayz00_2707 = BgL_arg2356z00_2705;
													BgL_offsetz00_2708 =
														(int) (BgL_objzd2classzd2numz00_2704);
													{	/* Trace/walk.scm 326 */
														long BgL_offsetz00_2709;

														BgL_offsetz00_2709 =
															((long) (BgL_offsetz00_2708) - OBJECT_TYPE);
														{	/* Trace/walk.scm 326 */
															long BgL_modz00_2710;

															{	/* Trace/walk.scm 326 */
																int BgL_arg2358z00_2711;

																BgL_arg2358z00_2711 = (int) (((long) 8));
																{	/* Trace/walk.scm 326 */
																	long BgL_auxz00_4501;

																	BgL_auxz00_4501 =
																		(long) (BgL_arg2358z00_2711);
																	BgL_modz00_2710 =
																		(BgL_offsetz00_2709 / BgL_auxz00_4501);
															}}
															{	/* Trace/walk.scm 326 */
																long BgL_restz00_2712;

																{	/* Trace/walk.scm 326 */
																	int BgL_arg2357z00_2713;

																	BgL_arg2357z00_2713 = (int) (((long) 8));
																	{	/* Trace/walk.scm 326 */
																		long BgL_auxz00_4505;

																		BgL_auxz00_4505 =
																			(long) (BgL_arg2357z00_2713);
																		BgL_restz00_2712 =
																			(BgL_offsetz00_2709 % BgL_auxz00_4505);
																}}
																{	/* Trace/walk.scm 326 */

																	BgL_method3271z00_2702 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2707,
																			(int) (BgL_modz00_2710)),
																		(int) (BgL_restz00_2712));
									}}}}}}}}
									BgL_res3739z00_2727 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2702)
										(BgL_method3271z00_2702, (obj_t) (BgL_arg3595z00_1653),
											BgL_stackz00_1648, BEOA));
								}
								BgL_arg3594z00_1652 = BgL_res3739z00_2727;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1647))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3594z00_1652), BUNSPEC);
					}
					{	/* Trace/walk.scm 327 */
						BgL_nodez00_bglt BgL_arg3596z00_1654;

						{	/* Trace/walk.scm 327 */
							BgL_nodez00_bglt BgL_arg3597z00_1655;

							BgL_arg3597z00_1655 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1647))->
								BgL_truez00);
							{	/* Trace/walk.scm 327 */
								BgL_nodez00_bglt BgL_res3742z00_2758;

								{	/* Trace/walk.scm 327 */
									obj_t BgL_method3271z00_2733;

									{	/* Trace/walk.scm 327 */
										BgL_objectz00_bglt BgL_objz00_2734;

										BgL_objz00_2734 =
											(BgL_objectz00_bglt) (BgL_arg3597z00_1655);
										{	/* Trace/walk.scm 327 */
											long BgL_objzd2classzd2numz00_2735;

											BgL_objzd2classzd2numz00_2735 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2734);
											{	/* Trace/walk.scm 327 */
												obj_t BgL_arg2356z00_2736;

												BgL_arg2356z00_2736 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 327 */
													obj_t BgL_arrayz00_2738;

													int BgL_offsetz00_2739;

													BgL_arrayz00_2738 = BgL_arg2356z00_2736;
													BgL_offsetz00_2739 =
														(int) (BgL_objzd2classzd2numz00_2735);
													{	/* Trace/walk.scm 327 */
														long BgL_offsetz00_2740;

														BgL_offsetz00_2740 =
															((long) (BgL_offsetz00_2739) - OBJECT_TYPE);
														{	/* Trace/walk.scm 327 */
															long BgL_modz00_2741;

															{	/* Trace/walk.scm 327 */
																int BgL_arg2358z00_2742;

																BgL_arg2358z00_2742 = (int) (((long) 8));
																{	/* Trace/walk.scm 327 */
																	long BgL_auxz00_4526;

																	BgL_auxz00_4526 =
																		(long) (BgL_arg2358z00_2742);
																	BgL_modz00_2741 =
																		(BgL_offsetz00_2740 / BgL_auxz00_4526);
															}}
															{	/* Trace/walk.scm 327 */
																long BgL_restz00_2743;

																{	/* Trace/walk.scm 327 */
																	int BgL_arg2357z00_2744;

																	BgL_arg2357z00_2744 = (int) (((long) 8));
																	{	/* Trace/walk.scm 327 */
																		long BgL_auxz00_4530;

																		BgL_auxz00_4530 =
																			(long) (BgL_arg2357z00_2744);
																		BgL_restz00_2743 =
																			(BgL_offsetz00_2740 % BgL_auxz00_4530);
																}}
																{	/* Trace/walk.scm 327 */

																	BgL_method3271z00_2733 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2738,
																			(int) (BgL_modz00_2741)),
																		(int) (BgL_restz00_2743));
									}}}}}}}}
									BgL_res3742z00_2758 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2733)
										(BgL_method3271z00_2733, (obj_t) (BgL_arg3597z00_1655),
											BgL_stackz00_1648, BEOA));
								}
								BgL_arg3596z00_1654 = BgL_res3742z00_2758;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1647))->BgL_truez00) =
							((BgL_nodez00_bglt) BgL_arg3596z00_1654), BUNSPEC);
					}
					{	/* Trace/walk.scm 328 */
						BgL_nodez00_bglt BgL_arg3598z00_1656;

						{	/* Trace/walk.scm 328 */
							BgL_nodez00_bglt BgL_arg3600z00_1657;

							BgL_arg3600z00_1657 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1647))->
								BgL_falsez00);
							{	/* Trace/walk.scm 328 */
								BgL_nodez00_bglt BgL_res3745z00_2789;

								{	/* Trace/walk.scm 328 */
									obj_t BgL_method3271z00_2764;

									{	/* Trace/walk.scm 328 */
										BgL_objectz00_bglt BgL_objz00_2765;

										BgL_objz00_2765 =
											(BgL_objectz00_bglt) (BgL_arg3600z00_1657);
										{	/* Trace/walk.scm 328 */
											long BgL_objzd2classzd2numz00_2766;

											BgL_objzd2classzd2numz00_2766 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2765);
											{	/* Trace/walk.scm 328 */
												obj_t BgL_arg2356z00_2767;

												BgL_arg2356z00_2767 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 328 */
													obj_t BgL_arrayz00_2769;

													int BgL_offsetz00_2770;

													BgL_arrayz00_2769 = BgL_arg2356z00_2767;
													BgL_offsetz00_2770 =
														(int) (BgL_objzd2classzd2numz00_2766);
													{	/* Trace/walk.scm 328 */
														long BgL_offsetz00_2771;

														BgL_offsetz00_2771 =
															((long) (BgL_offsetz00_2770) - OBJECT_TYPE);
														{	/* Trace/walk.scm 328 */
															long BgL_modz00_2772;

															{	/* Trace/walk.scm 328 */
																int BgL_arg2358z00_2773;

																BgL_arg2358z00_2773 = (int) (((long) 8));
																{	/* Trace/walk.scm 328 */
																	long BgL_auxz00_4551;

																	BgL_auxz00_4551 =
																		(long) (BgL_arg2358z00_2773);
																	BgL_modz00_2772 =
																		(BgL_offsetz00_2771 / BgL_auxz00_4551);
															}}
															{	/* Trace/walk.scm 328 */
																long BgL_restz00_2774;

																{	/* Trace/walk.scm 328 */
																	int BgL_arg2357z00_2775;

																	BgL_arg2357z00_2775 = (int) (((long) 8));
																	{	/* Trace/walk.scm 328 */
																		long BgL_auxz00_4555;

																		BgL_auxz00_4555 =
																			(long) (BgL_arg2357z00_2775);
																		BgL_restz00_2774 =
																			(BgL_offsetz00_2771 % BgL_auxz00_4555);
																}}
																{	/* Trace/walk.scm 328 */

																	BgL_method3271z00_2764 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2769,
																			(int) (BgL_modz00_2772)),
																		(int) (BgL_restz00_2774));
									}}}}}}}}
									BgL_res3745z00_2789 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2764)
										(BgL_method3271z00_2764, (obj_t) (BgL_arg3600z00_1657),
											BgL_stackz00_1648, BEOA));
								}
								BgL_arg3598z00_1656 = BgL_res3745z00_2789;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1647))->
								BgL_falsez00) =
							((BgL_nodez00_bglt) BgL_arg3598z00_1656), BUNSPEC);
					}
					BgL_auxz00_4491 = BgL_nodez00_1647;
					return (obj_t) (BgL_auxz00_4491);
				}
			}
		}
	}



/* trace-node-setq3285 */
	obj_t BGl_tracezd2nodezd2setq3285z00zztrace_walkz00(obj_t BgL_envz00_3378,
		obj_t BgL_nodez00_3379, obj_t BgL_stackz00_3380)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 317 */
			{
				BgL_setqz00_bglt BgL_nodez00_1639;

				obj_t BgL_stackz00_1640;

				{	/* Trace/walk.scm 318 */
					BgL_setqz00_bglt BgL_auxz00_4569;

					BgL_nodez00_1639 = (BgL_setqz00_bglt) (BgL_nodez00_3379);
					BgL_stackz00_1640 = BgL_stackz00_3380;
					{	/* Trace/walk.scm 318 */
						BgL_nodez00_bglt BgL_arg3591z00_2666;

						{	/* Trace/walk.scm 318 */
							BgL_nodez00_bglt BgL_arg3592z00_2667;

							BgL_arg3592z00_2667 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1639))->BgL_valuez00);
							{	/* Trace/walk.scm 318 */
								BgL_nodez00_bglt BgL_res3736z00_2696;

								{	/* Trace/walk.scm 318 */
									obj_t BgL_method3271z00_2671;

									{	/* Trace/walk.scm 318 */
										BgL_objectz00_bglt BgL_objz00_2672;

										BgL_objz00_2672 =
											(BgL_objectz00_bglt) (BgL_arg3592z00_2667);
										{	/* Trace/walk.scm 318 */
											long BgL_objzd2classzd2numz00_2673;

											BgL_objzd2classzd2numz00_2673 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2672);
											{	/* Trace/walk.scm 318 */
												obj_t BgL_arg2356z00_2674;

												BgL_arg2356z00_2674 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 318 */
													obj_t BgL_arrayz00_2676;

													int BgL_offsetz00_2677;

													BgL_arrayz00_2676 = BgL_arg2356z00_2674;
													BgL_offsetz00_2677 =
														(int) (BgL_objzd2classzd2numz00_2673);
													{	/* Trace/walk.scm 318 */
														long BgL_offsetz00_2678;

														BgL_offsetz00_2678 =
															((long) (BgL_offsetz00_2677) - OBJECT_TYPE);
														{	/* Trace/walk.scm 318 */
															long BgL_modz00_2679;

															{	/* Trace/walk.scm 318 */
																int BgL_arg2358z00_2680;

																BgL_arg2358z00_2680 = (int) (((long) 8));
																{	/* Trace/walk.scm 318 */
																	long BgL_auxz00_4579;

																	BgL_auxz00_4579 =
																		(long) (BgL_arg2358z00_2680);
																	BgL_modz00_2679 =
																		(BgL_offsetz00_2678 / BgL_auxz00_4579);
															}}
															{	/* Trace/walk.scm 318 */
																long BgL_restz00_2681;

																{	/* Trace/walk.scm 318 */
																	int BgL_arg2357z00_2682;

																	BgL_arg2357z00_2682 = (int) (((long) 8));
																	{	/* Trace/walk.scm 318 */
																		long BgL_auxz00_4583;

																		BgL_auxz00_4583 =
																			(long) (BgL_arg2357z00_2682);
																		BgL_restz00_2681 =
																			(BgL_offsetz00_2678 % BgL_auxz00_4583);
																}}
																{	/* Trace/walk.scm 318 */

																	BgL_method3271z00_2671 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2676,
																			(int) (BgL_modz00_2679)),
																		(int) (BgL_restz00_2681));
									}}}}}}}}
									BgL_res3736z00_2696 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2671)
										(BgL_method3271z00_2671, (obj_t) (BgL_arg3592z00_2667),
											BgL_stackz00_1640, BEOA));
								}
								BgL_arg3591z00_2666 = BgL_res3736z00_2696;
						}}
						((((BgL_setqz00_bglt) CREF(BgL_nodez00_1639))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3591z00_2666), BUNSPEC);
					}
					BgL_auxz00_4569 = BgL_nodez00_1639;
					return (obj_t) (BgL_auxz00_4569);
				}
			}
		}
	}



/* trace-node-cast3283 */
	obj_t BGl_tracezd2nodezd2cast3283z00zztrace_walkz00(obj_t BgL_envz00_3381,
		obj_t BgL_nodez00_3382, obj_t BgL_stackz00_3383)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 310 */
			{
				BgL_castz00_bglt BgL_nodez00_1632;

				obj_t BgL_stackz00_1633;

				{	/* Trace/walk.scm 311 */
					BgL_castz00_bglt BgL_auxz00_4597;

					BgL_nodez00_1632 = (BgL_castz00_bglt) (BgL_nodez00_3382);
					BgL_stackz00_1633 = BgL_stackz00_3383;
					{	/* Trace/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3589z00_2636;

						BgL_arg3589z00_2636 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1632))->BgL_argz00);
						{	/* Trace/walk.scm 311 */
							BgL_nodez00_bglt BgL_res3733z00_2665;

							{	/* Trace/walk.scm 311 */
								obj_t BgL_method3271z00_2640;

								{	/* Trace/walk.scm 311 */
									BgL_objectz00_bglt BgL_objz00_2641;

									BgL_objz00_2641 = (BgL_objectz00_bglt) (BgL_arg3589z00_2636);
									{	/* Trace/walk.scm 311 */
										long BgL_objzd2classzd2numz00_2642;

										BgL_objzd2classzd2numz00_2642 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2641);
										{	/* Trace/walk.scm 311 */
											obj_t BgL_arg2356z00_2643;

											BgL_arg2356z00_2643 =
												PROCEDURE_REF(BGl_tracezd2nodezd2envz00zztrace_walkz00,
												(int) (((long) 1)));
											{	/* Trace/walk.scm 311 */
												obj_t BgL_arrayz00_2645;

												int BgL_offsetz00_2646;

												BgL_arrayz00_2645 = BgL_arg2356z00_2643;
												BgL_offsetz00_2646 =
													(int) (BgL_objzd2classzd2numz00_2642);
												{	/* Trace/walk.scm 311 */
													long BgL_offsetz00_2647;

													BgL_offsetz00_2647 =
														((long) (BgL_offsetz00_2646) - OBJECT_TYPE);
													{	/* Trace/walk.scm 311 */
														long BgL_modz00_2648;

														{	/* Trace/walk.scm 311 */
															int BgL_arg2358z00_2649;

															BgL_arg2358z00_2649 = (int) (((long) 8));
															{	/* Trace/walk.scm 311 */
																long BgL_auxz00_4607;

																BgL_auxz00_4607 = (long) (BgL_arg2358z00_2649);
																BgL_modz00_2648 =
																	(BgL_offsetz00_2647 / BgL_auxz00_4607);
														}}
														{	/* Trace/walk.scm 311 */
															long BgL_restz00_2650;

															{	/* Trace/walk.scm 311 */
																int BgL_arg2357z00_2651;

																BgL_arg2357z00_2651 = (int) (((long) 8));
																{	/* Trace/walk.scm 311 */
																	long BgL_auxz00_4611;

																	BgL_auxz00_4611 =
																		(long) (BgL_arg2357z00_2651);
																	BgL_restz00_2650 =
																		(BgL_offsetz00_2647 % BgL_auxz00_4611);
															}}
															{	/* Trace/walk.scm 311 */

																BgL_method3271z00_2640 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2645,
																		(int) (BgL_modz00_2648)),
																	(int) (BgL_restz00_2650));
								}}}}}}}}
								BgL_res3733z00_2665 =
									(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2640)
									(BgL_method3271z00_2640, (obj_t) (BgL_arg3589z00_2636),
										BgL_stackz00_1633, BEOA));
							} BgL_res3733z00_2665;
					}}
					BgL_auxz00_4597 = BgL_nodez00_1632;
					return (obj_t) (BgL_auxz00_4597);
				}
			}
		}
	}



/* trace-node-extern3281 */
	obj_t BGl_tracezd2nodezd2extern3281z00zztrace_walkz00(obj_t BgL_envz00_3384,
		obj_t BgL_nodez00_3385, obj_t BgL_stackz00_3386)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 303 */
			{
				BgL_externz00_bglt BgL_nodez00_1625;

				obj_t BgL_stackz00_1626;

				{	/* Trace/walk.scm 304 */
					BgL_externz00_bglt BgL_auxz00_4624;

					BgL_nodez00_1625 = (BgL_externz00_bglt) (BgL_nodez00_3385);
					BgL_stackz00_1626 = BgL_stackz00_3386;
					{	/* Trace/walk.scm 304 */
						obj_t BgL_arg3587z00_2634;

						BgL_arg3587z00_2634 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1625))->BgL_exprza2za2);
						BGl_tracezd2nodeza2z12z62zztrace_walkz00(BgL_arg3587z00_2634,
							BgL_stackz00_1626);
					}
					BgL_auxz00_4624 = BgL_nodez00_1625;
					return (obj_t) (BgL_auxz00_4624);
				}
			}
		}
	}



/* trace-node-funcall3279 */
	obj_t BGl_tracezd2nodezd2funcall3279z00zztrace_walkz00(obj_t BgL_envz00_3387,
		obj_t BgL_nodez00_3388, obj_t BgL_stackz00_3389)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 294 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1615;

				obj_t BgL_stackz00_1616;

				{	/* Trace/walk.scm 295 */
					BgL_funcallz00_bglt BgL_auxz00_4629;

					BgL_nodez00_1615 = (BgL_funcallz00_bglt) (BgL_nodez00_3388);
					BgL_stackz00_1616 = BgL_stackz00_3389;
					{	/* Trace/walk.scm 296 */
						BgL_nodez00_bglt BgL_arg3583z00_1620;

						{	/* Trace/walk.scm 296 */
							BgL_nodez00_bglt BgL_arg3584z00_1621;

							BgL_arg3584z00_1621 =
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1615))->BgL_funz00);
							{	/* Trace/walk.scm 296 */
								BgL_nodez00_bglt BgL_res3730z00_2630;

								{	/* Trace/walk.scm 296 */
									obj_t BgL_method3271z00_2605;

									{	/* Trace/walk.scm 296 */
										BgL_objectz00_bglt BgL_objz00_2606;

										BgL_objz00_2606 =
											(BgL_objectz00_bglt) (BgL_arg3584z00_1621);
										{	/* Trace/walk.scm 296 */
											long BgL_objzd2classzd2numz00_2607;

											BgL_objzd2classzd2numz00_2607 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2606);
											{	/* Trace/walk.scm 296 */
												obj_t BgL_arg2356z00_2608;

												BgL_arg2356z00_2608 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 296 */
													obj_t BgL_arrayz00_2610;

													int BgL_offsetz00_2611;

													BgL_arrayz00_2610 = BgL_arg2356z00_2608;
													BgL_offsetz00_2611 =
														(int) (BgL_objzd2classzd2numz00_2607);
													{	/* Trace/walk.scm 296 */
														long BgL_offsetz00_2612;

														BgL_offsetz00_2612 =
															((long) (BgL_offsetz00_2611) - OBJECT_TYPE);
														{	/* Trace/walk.scm 296 */
															long BgL_modz00_2613;

															{	/* Trace/walk.scm 296 */
																int BgL_arg2358z00_2614;

																BgL_arg2358z00_2614 = (int) (((long) 8));
																{	/* Trace/walk.scm 296 */
																	long BgL_auxz00_4639;

																	BgL_auxz00_4639 =
																		(long) (BgL_arg2358z00_2614);
																	BgL_modz00_2613 =
																		(BgL_offsetz00_2612 / BgL_auxz00_4639);
															}}
															{	/* Trace/walk.scm 296 */
																long BgL_restz00_2615;

																{	/* Trace/walk.scm 296 */
																	int BgL_arg2357z00_2616;

																	BgL_arg2357z00_2616 = (int) (((long) 8));
																	{	/* Trace/walk.scm 296 */
																		long BgL_auxz00_4643;

																		BgL_auxz00_4643 =
																			(long) (BgL_arg2357z00_2616);
																		BgL_restz00_2615 =
																			(BgL_offsetz00_2612 % BgL_auxz00_4643);
																}}
																{	/* Trace/walk.scm 296 */

																	BgL_method3271z00_2605 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2610,
																			(int) (BgL_modz00_2613)),
																		(int) (BgL_restz00_2615));
									}}}}}}}}
									BgL_res3730z00_2630 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2605)
										(BgL_method3271z00_2605, (obj_t) (BgL_arg3584z00_1621),
											BgL_stackz00_1616, BEOA));
								}
								BgL_arg3583z00_1620 = BgL_res3730z00_2630;
						}}
						((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1615))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3583z00_1620), BUNSPEC);
					}
					{	/* Trace/walk.scm 297 */
						obj_t BgL_arg3585z00_1622;

						BgL_arg3585z00_1622 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1615))->BgL_argsz00);
						BGl_tracezd2nodeza2z12z62zztrace_walkz00(BgL_arg3585z00_1622,
							BgL_stackz00_1616);
					}
					BgL_auxz00_4629 = BgL_nodez00_1615;
					return (obj_t) (BgL_auxz00_4629);
				}
			}
		}
	}



/* trace-node-app-ly3277 */
	obj_t BGl_tracezd2nodezd2appzd2ly3277zd2zztrace_walkz00(obj_t BgL_envz00_3390,
		obj_t BgL_nodez00_3391, obj_t BgL_stackz00_3392)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 285 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1604;

				obj_t BgL_stackz00_1605;

				{	/* Trace/walk.scm 286 */
					BgL_appzd2lyzd2_bglt BgL_auxz00_4659;

					BgL_nodez00_1604 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_3391);
					BgL_stackz00_1605 = BgL_stackz00_3392;
					{	/* Trace/walk.scm 287 */
						BgL_nodez00_bglt BgL_arg3578z00_1609;

						{	/* Trace/walk.scm 287 */
							BgL_nodez00_bglt BgL_arg3579z00_1610;

							BgL_arg3579z00_1610 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1604))->BgL_funz00);
							{	/* Trace/walk.scm 287 */
								BgL_nodez00_bglt BgL_res3724z00_2568;

								{	/* Trace/walk.scm 287 */
									obj_t BgL_method3271z00_2543;

									{	/* Trace/walk.scm 287 */
										BgL_objectz00_bglt BgL_objz00_2544;

										BgL_objz00_2544 =
											(BgL_objectz00_bglt) (BgL_arg3579z00_1610);
										{	/* Trace/walk.scm 287 */
											long BgL_objzd2classzd2numz00_2545;

											BgL_objzd2classzd2numz00_2545 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2544);
											{	/* Trace/walk.scm 287 */
												obj_t BgL_arg2356z00_2546;

												BgL_arg2356z00_2546 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 287 */
													obj_t BgL_arrayz00_2548;

													int BgL_offsetz00_2549;

													BgL_arrayz00_2548 = BgL_arg2356z00_2546;
													BgL_offsetz00_2549 =
														(int) (BgL_objzd2classzd2numz00_2545);
													{	/* Trace/walk.scm 287 */
														long BgL_offsetz00_2550;

														BgL_offsetz00_2550 =
															((long) (BgL_offsetz00_2549) - OBJECT_TYPE);
														{	/* Trace/walk.scm 287 */
															long BgL_modz00_2551;

															{	/* Trace/walk.scm 287 */
																int BgL_arg2358z00_2552;

																BgL_arg2358z00_2552 = (int) (((long) 8));
																{	/* Trace/walk.scm 287 */
																	long BgL_auxz00_4669;

																	BgL_auxz00_4669 =
																		(long) (BgL_arg2358z00_2552);
																	BgL_modz00_2551 =
																		(BgL_offsetz00_2550 / BgL_auxz00_4669);
															}}
															{	/* Trace/walk.scm 287 */
																long BgL_restz00_2553;

																{	/* Trace/walk.scm 287 */
																	int BgL_arg2357z00_2554;

																	BgL_arg2357z00_2554 = (int) (((long) 8));
																	{	/* Trace/walk.scm 287 */
																		long BgL_auxz00_4673;

																		BgL_auxz00_4673 =
																			(long) (BgL_arg2357z00_2554);
																		BgL_restz00_2553 =
																			(BgL_offsetz00_2550 % BgL_auxz00_4673);
																}}
																{	/* Trace/walk.scm 287 */

																	BgL_method3271z00_2543 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2548,
																			(int) (BgL_modz00_2551)),
																		(int) (BgL_restz00_2553));
									}}}}}}}}
									BgL_res3724z00_2568 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2543)
										(BgL_method3271z00_2543, (obj_t) (BgL_arg3579z00_1610),
											BgL_stackz00_1605, BEOA));
								}
								BgL_arg3578z00_1609 = BgL_res3724z00_2568;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1604))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3578z00_1609), BUNSPEC);
					}
					{	/* Trace/walk.scm 288 */
						BgL_nodez00_bglt BgL_arg3580z00_1611;

						{	/* Trace/walk.scm 288 */
							BgL_nodez00_bglt BgL_arg3581z00_1612;

							BgL_arg3581z00_1612 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1604))->BgL_argz00);
							{	/* Trace/walk.scm 288 */
								BgL_nodez00_bglt BgL_res3727z00_2599;

								{	/* Trace/walk.scm 288 */
									obj_t BgL_method3271z00_2574;

									{	/* Trace/walk.scm 288 */
										BgL_objectz00_bglt BgL_objz00_2575;

										BgL_objz00_2575 =
											(BgL_objectz00_bglt) (BgL_arg3581z00_1612);
										{	/* Trace/walk.scm 288 */
											long BgL_objzd2classzd2numz00_2576;

											BgL_objzd2classzd2numz00_2576 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2575);
											{	/* Trace/walk.scm 288 */
												obj_t BgL_arg2356z00_2577;

												BgL_arg2356z00_2577 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 288 */
													obj_t BgL_arrayz00_2579;

													int BgL_offsetz00_2580;

													BgL_arrayz00_2579 = BgL_arg2356z00_2577;
													BgL_offsetz00_2580 =
														(int) (BgL_objzd2classzd2numz00_2576);
													{	/* Trace/walk.scm 288 */
														long BgL_offsetz00_2581;

														BgL_offsetz00_2581 =
															((long) (BgL_offsetz00_2580) - OBJECT_TYPE);
														{	/* Trace/walk.scm 288 */
															long BgL_modz00_2582;

															{	/* Trace/walk.scm 288 */
																int BgL_arg2358z00_2583;

																BgL_arg2358z00_2583 = (int) (((long) 8));
																{	/* Trace/walk.scm 288 */
																	long BgL_auxz00_4694;

																	BgL_auxz00_4694 =
																		(long) (BgL_arg2358z00_2583);
																	BgL_modz00_2582 =
																		(BgL_offsetz00_2581 / BgL_auxz00_4694);
															}}
															{	/* Trace/walk.scm 288 */
																long BgL_restz00_2584;

																{	/* Trace/walk.scm 288 */
																	int BgL_arg2357z00_2585;

																	BgL_arg2357z00_2585 = (int) (((long) 8));
																	{	/* Trace/walk.scm 288 */
																		long BgL_auxz00_4698;

																		BgL_auxz00_4698 =
																			(long) (BgL_arg2357z00_2585);
																		BgL_restz00_2584 =
																			(BgL_offsetz00_2581 % BgL_auxz00_4698);
																}}
																{	/* Trace/walk.scm 288 */

																	BgL_method3271z00_2574 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2579,
																			(int) (BgL_modz00_2582)),
																		(int) (BgL_restz00_2584));
									}}}}}}}}
									BgL_res3727z00_2599 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3271z00_2574)
										(BgL_method3271z00_2574, (obj_t) (BgL_arg3581z00_1612),
											BgL_stackz00_1605, BEOA));
								}
								BgL_arg3580z00_1611 = BgL_res3727z00_2599;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1604))->BgL_argz00) =
							((BgL_nodez00_bglt) BgL_arg3580z00_1611), BUNSPEC);
					}
					BgL_auxz00_4659 = BgL_nodez00_1604;
					return (obj_t) (BgL_auxz00_4659);
				}
			}
		}
	}



/* trace-node-app3275 */
	obj_t BGl_tracezd2nodezd2app3275z00zztrace_walkz00(obj_t BgL_envz00_3393,
		obj_t BgL_nodez00_3394, obj_t BgL_stackz00_3395)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 278 */
			{
				BgL_appz00_bglt BgL_nodez00_1597;

				obj_t BgL_stackz00_1598;

				{	/* Trace/walk.scm 279 */
					BgL_appz00_bglt BgL_auxz00_4712;

					BgL_nodez00_1597 = (BgL_appz00_bglt) (BgL_nodez00_3394);
					BgL_stackz00_1598 = BgL_stackz00_3395;
					{	/* Trace/walk.scm 279 */
						obj_t BgL_arg3576z00_2538;

						BgL_arg3576z00_2538 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1597))->BgL_argsz00);
						BGl_tracezd2nodeza2z12z62zztrace_walkz00(BgL_arg3576z00_2538,
							BgL_stackz00_1598);
					}
					BgL_auxz00_4712 = BgL_nodez00_1597;
					return (obj_t) (BgL_auxz00_4712);
				}
			}
		}
	}



/* trace-node-sequence3273 */
	obj_t BGl_tracezd2nodezd2sequence3273z00zztrace_walkz00(obj_t BgL_envz00_3396,
		obj_t BgL_nodez00_3397, obj_t BgL_stackz00_3398)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 271 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1590;

				obj_t BgL_stackz00_1591;

				{	/* Trace/walk.scm 272 */
					BgL_sequencez00_bglt BgL_auxz00_4717;

					BgL_nodez00_1590 = (BgL_sequencez00_bglt) (BgL_nodez00_3397);
					BgL_stackz00_1591 = BgL_stackz00_3398;
					{	/* Trace/walk.scm 272 */
						obj_t BgL_arg3574z00_2536;

						BgL_arg3574z00_2536 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1590))->BgL_nodesz00);
						BGl_tracezd2nodeza2z12z62zztrace_walkz00(BgL_arg3574z00_2536,
							BgL_stackz00_1591);
					}
					BgL_auxz00_4717 = BgL_nodez00_1590;
					return (obj_t) (BgL_auxz00_4717);
				}
			}
		}
	}



/* find-last-node-jump-3269 */
	obj_t BGl_findzd2lastzd2nodezd2jumpzd23269z00zztrace_walkz00(obj_t
		BgL_envz00_3399, obj_t BgL_nodez00_3400)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 227 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1584;

				BgL_nodez00_1584 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_3400);
				{	/* Trace/walk.scm 228 */
					BgL_nodez00_bglt BgL_arg3572z00_2508;

					BgL_arg3572z00_2508 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1584))->
						BgL_valuez00);
					{	/* Trace/walk.scm 228 */
						obj_t BgL_method3242z00_2511;

						{	/* Trace/walk.scm 228 */
							BgL_objectz00_bglt BgL_objz00_2512;

							BgL_objz00_2512 = (BgL_objectz00_bglt) (BgL_arg3572z00_2508);
							{	/* Trace/walk.scm 228 */
								long BgL_objzd2classzd2numz00_2513;

								BgL_objzd2classzd2numz00_2513 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2512);
								{	/* Trace/walk.scm 228 */
									obj_t BgL_arg2356z00_2514;

									BgL_arg2356z00_2514 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 228 */
										obj_t BgL_arrayz00_2516;

										int BgL_offsetz00_2517;

										BgL_arrayz00_2516 = BgL_arg2356z00_2514;
										BgL_offsetz00_2517 = (int) (BgL_objzd2classzd2numz00_2513);
										{	/* Trace/walk.scm 228 */
											long BgL_offsetz00_2518;

											BgL_offsetz00_2518 =
												((long) (BgL_offsetz00_2517) - OBJECT_TYPE);
											{	/* Trace/walk.scm 228 */
												long BgL_modz00_2519;

												{	/* Trace/walk.scm 228 */
													int BgL_arg2358z00_2520;

													BgL_arg2358z00_2520 = (int) (((long) 8));
													{	/* Trace/walk.scm 228 */
														long BgL_auxz00_4731;

														BgL_auxz00_4731 = (long) (BgL_arg2358z00_2520);
														BgL_modz00_2519 =
															(BgL_offsetz00_2518 / BgL_auxz00_4731);
												}}
												{	/* Trace/walk.scm 228 */
													long BgL_restz00_2521;

													{	/* Trace/walk.scm 228 */
														int BgL_arg2357z00_2522;

														BgL_arg2357z00_2522 = (int) (((long) 8));
														{	/* Trace/walk.scm 228 */
															long BgL_auxz00_4735;

															BgL_auxz00_4735 = (long) (BgL_arg2357z00_2522);
															BgL_restz00_2521 =
																(BgL_offsetz00_2518 % BgL_auxz00_4735);
													}}
													{	/* Trace/walk.scm 228 */

														BgL_method3242z00_2511 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2516,
																(int) (BgL_modz00_2519)),
															(int) (BgL_restz00_2521));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3242z00_2511) (BgL_method3242z00_2511,
							(obj_t) (BgL_arg3572z00_2508), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-set-e3267 */
	obj_t BGl_findzd2lastzd2nodezd2setzd2e3267z00zztrace_walkz00(obj_t
		BgL_envz00_3401, obj_t BgL_nodez00_3402)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 221 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1578;

				BgL_nodez00_1578 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_3402);
				{	/* Trace/walk.scm 222 */
					BgL_nodez00_bglt BgL_arg3570z00_2480;

					BgL_arg3570z00_2480 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1578))->BgL_bodyz00);
					{	/* Trace/walk.scm 222 */
						obj_t BgL_method3242z00_2483;

						{	/* Trace/walk.scm 222 */
							BgL_objectz00_bglt BgL_objz00_2484;

							BgL_objz00_2484 = (BgL_objectz00_bglt) (BgL_arg3570z00_2480);
							{	/* Trace/walk.scm 222 */
								long BgL_objzd2classzd2numz00_2485;

								BgL_objzd2classzd2numz00_2485 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2484);
								{	/* Trace/walk.scm 222 */
									obj_t BgL_arg2356z00_2486;

									BgL_arg2356z00_2486 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 222 */
										obj_t BgL_arrayz00_2488;

										int BgL_offsetz00_2489;

										BgL_arrayz00_2488 = BgL_arg2356z00_2486;
										BgL_offsetz00_2489 = (int) (BgL_objzd2classzd2numz00_2485);
										{	/* Trace/walk.scm 222 */
											long BgL_offsetz00_2490;

											BgL_offsetz00_2490 =
												((long) (BgL_offsetz00_2489) - OBJECT_TYPE);
											{	/* Trace/walk.scm 222 */
												long BgL_modz00_2491;

												{	/* Trace/walk.scm 222 */
													int BgL_arg2358z00_2492;

													BgL_arg2358z00_2492 = (int) (((long) 8));
													{	/* Trace/walk.scm 222 */
														long BgL_auxz00_4755;

														BgL_auxz00_4755 = (long) (BgL_arg2358z00_2492);
														BgL_modz00_2491 =
															(BgL_offsetz00_2490 / BgL_auxz00_4755);
												}}
												{	/* Trace/walk.scm 222 */
													long BgL_restz00_2493;

													{	/* Trace/walk.scm 222 */
														int BgL_arg2357z00_2494;

														BgL_arg2357z00_2494 = (int) (((long) 8));
														{	/* Trace/walk.scm 222 */
															long BgL_auxz00_4759;

															BgL_auxz00_4759 = (long) (BgL_arg2357z00_2494);
															BgL_restz00_2493 =
																(BgL_offsetz00_2490 % BgL_auxz00_4759);
													}}
													{	/* Trace/walk.scm 222 */

														BgL_method3242z00_2483 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2488,
																(int) (BgL_modz00_2491)),
															(int) (BgL_restz00_2493));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3242z00_2483) (BgL_method3242z00_2483,
							(obj_t) (BgL_arg3570z00_2480), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-let-f3265 */
	obj_t BGl_findzd2lastzd2nodezd2letzd2f3265z00zztrace_walkz00(obj_t
		BgL_envz00_3403, obj_t BgL_nodez00_3404)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 215 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1572;

				BgL_nodez00_1572 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_3404);
				{	/* Trace/walk.scm 216 */
					BgL_nodez00_bglt BgL_arg3568z00_2452;

					BgL_arg3568z00_2452 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1572))->BgL_bodyz00);
					{	/* Trace/walk.scm 216 */
						obj_t BgL_method3242z00_2455;

						{	/* Trace/walk.scm 216 */
							BgL_objectz00_bglt BgL_objz00_2456;

							BgL_objz00_2456 = (BgL_objectz00_bglt) (BgL_arg3568z00_2452);
							{	/* Trace/walk.scm 216 */
								long BgL_objzd2classzd2numz00_2457;

								BgL_objzd2classzd2numz00_2457 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2456);
								{	/* Trace/walk.scm 216 */
									obj_t BgL_arg2356z00_2458;

									BgL_arg2356z00_2458 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 216 */
										obj_t BgL_arrayz00_2460;

										int BgL_offsetz00_2461;

										BgL_arrayz00_2460 = BgL_arg2356z00_2458;
										BgL_offsetz00_2461 = (int) (BgL_objzd2classzd2numz00_2457);
										{	/* Trace/walk.scm 216 */
											long BgL_offsetz00_2462;

											BgL_offsetz00_2462 =
												((long) (BgL_offsetz00_2461) - OBJECT_TYPE);
											{	/* Trace/walk.scm 216 */
												long BgL_modz00_2463;

												{	/* Trace/walk.scm 216 */
													int BgL_arg2358z00_2464;

													BgL_arg2358z00_2464 = (int) (((long) 8));
													{	/* Trace/walk.scm 216 */
														long BgL_auxz00_4779;

														BgL_auxz00_4779 = (long) (BgL_arg2358z00_2464);
														BgL_modz00_2463 =
															(BgL_offsetz00_2462 / BgL_auxz00_4779);
												}}
												{	/* Trace/walk.scm 216 */
													long BgL_restz00_2465;

													{	/* Trace/walk.scm 216 */
														int BgL_arg2357z00_2466;

														BgL_arg2357z00_2466 = (int) (((long) 8));
														{	/* Trace/walk.scm 216 */
															long BgL_auxz00_4783;

															BgL_auxz00_4783 = (long) (BgL_arg2357z00_2466);
															BgL_restz00_2465 =
																(BgL_offsetz00_2462 % BgL_auxz00_4783);
													}}
													{	/* Trace/walk.scm 216 */

														BgL_method3242z00_2455 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2460,
																(int) (BgL_modz00_2463)),
															(int) (BgL_restz00_2465));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3242z00_2455) (BgL_method3242z00_2455,
							(obj_t) (BgL_arg3568z00_2452), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-let-v3263 */
	obj_t BGl_findzd2lastzd2nodezd2letzd2v3263z00zztrace_walkz00(obj_t
		BgL_envz00_3405, obj_t BgL_nodez00_3406)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 209 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1566;

				BgL_nodez00_1566 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_3406);
				{	/* Trace/walk.scm 210 */
					BgL_nodez00_bglt BgL_arg3566z00_2424;

					BgL_arg3566z00_2424 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1566))->BgL_bodyz00);
					{	/* Trace/walk.scm 210 */
						obj_t BgL_method3242z00_2427;

						{	/* Trace/walk.scm 210 */
							BgL_objectz00_bglt BgL_objz00_2428;

							BgL_objz00_2428 = (BgL_objectz00_bglt) (BgL_arg3566z00_2424);
							{	/* Trace/walk.scm 210 */
								long BgL_objzd2classzd2numz00_2429;

								BgL_objzd2classzd2numz00_2429 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2428);
								{	/* Trace/walk.scm 210 */
									obj_t BgL_arg2356z00_2430;

									BgL_arg2356z00_2430 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 210 */
										obj_t BgL_arrayz00_2432;

										int BgL_offsetz00_2433;

										BgL_arrayz00_2432 = BgL_arg2356z00_2430;
										BgL_offsetz00_2433 = (int) (BgL_objzd2classzd2numz00_2429);
										{	/* Trace/walk.scm 210 */
											long BgL_offsetz00_2434;

											BgL_offsetz00_2434 =
												((long) (BgL_offsetz00_2433) - OBJECT_TYPE);
											{	/* Trace/walk.scm 210 */
												long BgL_modz00_2435;

												{	/* Trace/walk.scm 210 */
													int BgL_arg2358z00_2436;

													BgL_arg2358z00_2436 = (int) (((long) 8));
													{	/* Trace/walk.scm 210 */
														long BgL_auxz00_4803;

														BgL_auxz00_4803 = (long) (BgL_arg2358z00_2436);
														BgL_modz00_2435 =
															(BgL_offsetz00_2434 / BgL_auxz00_4803);
												}}
												{	/* Trace/walk.scm 210 */
													long BgL_restz00_2437;

													{	/* Trace/walk.scm 210 */
														int BgL_arg2357z00_2438;

														BgL_arg2357z00_2438 = (int) (((long) 8));
														{	/* Trace/walk.scm 210 */
															long BgL_auxz00_4807;

															BgL_auxz00_4807 = (long) (BgL_arg2357z00_2438);
															BgL_restz00_2437 =
																(BgL_offsetz00_2434 % BgL_auxz00_4807);
													}}
													{	/* Trace/walk.scm 210 */

														BgL_method3242z00_2427 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2432,
																(int) (BgL_modz00_2435)),
															(int) (BgL_restz00_2437));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3242z00_2427) (BgL_method3242z00_2427,
							(obj_t) (BgL_arg3566z00_2424), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-selec3261 */
	obj_t BGl_findzd2lastzd2nodezd2selec3261zd2zztrace_walkz00(obj_t
		BgL_envz00_3407, obj_t BgL_nodez00_3408)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 200 */
			{
				BgL_selectz00_bglt BgL_nodez00_1554;

				BgL_nodez00_1554 = (BgL_selectz00_bglt) (BgL_nodez00_3408);
				{	/* Trace/walk.scm 202 */
					bool_t BgL_testz00_4818;

					{	/* Trace/walk.scm 202 */
						obj_t BgL_auxz00_4819;

						BgL_auxz00_4819 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1554))->BgL_clausesz00);
						BgL_testz00_4818 = PAIRP(BgL_auxz00_4819);
					}
					if (BgL_testz00_4818)
						{	/* Trace/walk.scm 203 */
							obj_t BgL_arg3560z00_1559;

							BgL_arg3560z00_1559 =
								CDR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_selectz00_bglt) CREF(BgL_nodez00_1554))->
										BgL_clausesz00)));
							{	/* Trace/walk.scm 203 */
								BgL_nodez00_bglt BgL_nodez00_2397;

								BgL_nodez00_2397 = (BgL_nodez00_bglt) (BgL_arg3560z00_1559);
								{	/* Trace/walk.scm 203 */
									obj_t BgL_method3242z00_2398;

									{	/* Trace/walk.scm 203 */
										BgL_objectz00_bglt BgL_objz00_2399;

										BgL_objz00_2399 = (BgL_objectz00_bglt) (BgL_nodez00_2397);
										{	/* Trace/walk.scm 203 */
											long BgL_objzd2classzd2numz00_2400;

											BgL_objzd2classzd2numz00_2400 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2399);
											{	/* Trace/walk.scm 203 */
												obj_t BgL_arg2356z00_2401;

												BgL_arg2356z00_2401 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 203 */
													obj_t BgL_arrayz00_2403;

													int BgL_offsetz00_2404;

													BgL_arrayz00_2403 = BgL_arg2356z00_2401;
													BgL_offsetz00_2404 =
														(int) (BgL_objzd2classzd2numz00_2400);
													{	/* Trace/walk.scm 203 */
														long BgL_offsetz00_2405;

														BgL_offsetz00_2405 =
															((long) (BgL_offsetz00_2404) - OBJECT_TYPE);
														{	/* Trace/walk.scm 203 */
															long BgL_modz00_2406;

															{	/* Trace/walk.scm 203 */
																int BgL_arg2358z00_2407;

																BgL_arg2358z00_2407 = (int) (((long) 8));
																{	/* Trace/walk.scm 203 */
																	long BgL_auxz00_4834;

																	BgL_auxz00_4834 =
																		(long) (BgL_arg2358z00_2407);
																	BgL_modz00_2406 =
																		(BgL_offsetz00_2405 / BgL_auxz00_4834);
															}}
															{	/* Trace/walk.scm 203 */
																long BgL_restz00_2408;

																{	/* Trace/walk.scm 203 */
																	int BgL_arg2357z00_2409;

																	BgL_arg2357z00_2409 = (int) (((long) 8));
																	{	/* Trace/walk.scm 203 */
																		long BgL_auxz00_4838;

																		BgL_auxz00_4838 =
																			(long) (BgL_arg2357z00_2409);
																		BgL_restz00_2408 =
																			(BgL_offsetz00_2405 % BgL_auxz00_4838);
																}}
																{	/* Trace/walk.scm 203 */

																	BgL_method3242z00_2398 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2403,
																			(int) (BgL_modz00_2406)),
																		(int) (BgL_restz00_2408));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3242z00_2398)
										(BgL_method3242z00_2398, (obj_t) (BgL_nodez00_2397), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 202 */
							return
								BGl_findzd2lastzd2sexpz00zztrace_walkz00(
								(obj_t) (
									(((BgL_selectz00_bglt) CREF(BgL_nodez00_1554))->
										BgL_testz00)));
						}
				}
			}
		}
	}



/* find-last-node-fail3259 */
	obj_t BGl_findzd2lastzd2nodezd2fail3259zd2zztrace_walkz00(obj_t
		BgL_envz00_3409, obj_t BgL_nodez00_3410)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 194 */
			{
				BgL_failz00_bglt BgL_nodez00_1548;

				BgL_nodez00_1548 = (BgL_failz00_bglt) (BgL_nodez00_3410);
				{	/* Trace/walk.scm 195 */
					BgL_nodez00_bglt BgL_arg3557z00_2365;

					BgL_arg3557z00_2365 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1548))->BgL_objz00);
					{	/* Trace/walk.scm 195 */
						obj_t BgL_method3242z00_2368;

						{	/* Trace/walk.scm 195 */
							BgL_objectz00_bglt BgL_objz00_2369;

							BgL_objz00_2369 = (BgL_objectz00_bglt) (BgL_arg3557z00_2365);
							{	/* Trace/walk.scm 195 */
								long BgL_objzd2classzd2numz00_2370;

								BgL_objzd2classzd2numz00_2370 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2369);
								{	/* Trace/walk.scm 195 */
									obj_t BgL_arg2356z00_2371;

									BgL_arg2356z00_2371 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 195 */
										obj_t BgL_arrayz00_2373;

										int BgL_offsetz00_2374;

										BgL_arrayz00_2373 = BgL_arg2356z00_2371;
										BgL_offsetz00_2374 = (int) (BgL_objzd2classzd2numz00_2370);
										{	/* Trace/walk.scm 195 */
											long BgL_offsetz00_2375;

											BgL_offsetz00_2375 =
												((long) (BgL_offsetz00_2374) - OBJECT_TYPE);
											{	/* Trace/walk.scm 195 */
												long BgL_modz00_2376;

												{	/* Trace/walk.scm 195 */
													int BgL_arg2358z00_2377;

													BgL_arg2358z00_2377 = (int) (((long) 8));
													{	/* Trace/walk.scm 195 */
														long BgL_auxz00_4861;

														BgL_auxz00_4861 = (long) (BgL_arg2358z00_2377);
														BgL_modz00_2376 =
															(BgL_offsetz00_2375 / BgL_auxz00_4861);
												}}
												{	/* Trace/walk.scm 195 */
													long BgL_restz00_2378;

													{	/* Trace/walk.scm 195 */
														int BgL_arg2357z00_2379;

														BgL_arg2357z00_2379 = (int) (((long) 8));
														{	/* Trace/walk.scm 195 */
															long BgL_auxz00_4865;

															BgL_auxz00_4865 = (long) (BgL_arg2357z00_2379);
															BgL_restz00_2378 =
																(BgL_offsetz00_2375 % BgL_auxz00_4865);
													}}
													{	/* Trace/walk.scm 195 */

														BgL_method3242z00_2368 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2373,
																(int) (BgL_modz00_2376)),
															(int) (BgL_restz00_2378));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3242z00_2368) (BgL_method3242z00_2368,
							(obj_t) (BgL_arg3557z00_2365), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-condi3257 */
	obj_t BGl_findzd2lastzd2nodezd2condi3257zd2zztrace_walkz00(obj_t
		BgL_envz00_3411, obj_t BgL_nodez00_3412)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 188 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1542;

				BgL_nodez00_1542 = (BgL_conditionalz00_bglt) (BgL_nodez00_3412);
				{	/* Trace/walk.scm 189 */
					BgL_nodez00_bglt BgL_arg3555z00_2337;

					BgL_arg3555z00_2337 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1542))->BgL_falsez00);
					{	/* Trace/walk.scm 189 */
						obj_t BgL_method3242z00_2340;

						{	/* Trace/walk.scm 189 */
							BgL_objectz00_bglt BgL_objz00_2341;

							BgL_objz00_2341 = (BgL_objectz00_bglt) (BgL_arg3555z00_2337);
							{	/* Trace/walk.scm 189 */
								long BgL_objzd2classzd2numz00_2342;

								BgL_objzd2classzd2numz00_2342 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2341);
								{	/* Trace/walk.scm 189 */
									obj_t BgL_arg2356z00_2343;

									BgL_arg2356z00_2343 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 189 */
										obj_t BgL_arrayz00_2345;

										int BgL_offsetz00_2346;

										BgL_arrayz00_2345 = BgL_arg2356z00_2343;
										BgL_offsetz00_2346 = (int) (BgL_objzd2classzd2numz00_2342);
										{	/* Trace/walk.scm 189 */
											long BgL_offsetz00_2347;

											BgL_offsetz00_2347 =
												((long) (BgL_offsetz00_2346) - OBJECT_TYPE);
											{	/* Trace/walk.scm 189 */
												long BgL_modz00_2348;

												{	/* Trace/walk.scm 189 */
													int BgL_arg2358z00_2349;

													BgL_arg2358z00_2349 = (int) (((long) 8));
													{	/* Trace/walk.scm 189 */
														long BgL_auxz00_4885;

														BgL_auxz00_4885 = (long) (BgL_arg2358z00_2349);
														BgL_modz00_2348 =
															(BgL_offsetz00_2347 / BgL_auxz00_4885);
												}}
												{	/* Trace/walk.scm 189 */
													long BgL_restz00_2350;

													{	/* Trace/walk.scm 189 */
														int BgL_arg2357z00_2351;

														BgL_arg2357z00_2351 = (int) (((long) 8));
														{	/* Trace/walk.scm 189 */
															long BgL_auxz00_4889;

															BgL_auxz00_4889 = (long) (BgL_arg2357z00_2351);
															BgL_restz00_2350 =
																(BgL_offsetz00_2347 % BgL_auxz00_4889);
													}}
													{	/* Trace/walk.scm 189 */

														BgL_method3242z00_2340 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2345,
																(int) (BgL_modz00_2348)),
															(int) (BgL_restz00_2350));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3242z00_2340) (BgL_method3242z00_2340,
							(obj_t) (BgL_arg3555z00_2337), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-setq3255 */
	obj_t BGl_findzd2lastzd2nodezd2setq3255zd2zztrace_walkz00(obj_t
		BgL_envz00_3413, obj_t BgL_nodez00_3414)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 182 */
			{
				BgL_setqz00_bglt BgL_nodez00_1536;

				BgL_nodez00_1536 = (BgL_setqz00_bglt) (BgL_nodez00_3414);
				{	/* Trace/walk.scm 183 */
					BgL_nodez00_bglt BgL_arg3553z00_2309;

					BgL_arg3553z00_2309 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1536))->BgL_valuez00);
					{	/* Trace/walk.scm 183 */
						obj_t BgL_method3242z00_2312;

						{	/* Trace/walk.scm 183 */
							BgL_objectz00_bglt BgL_objz00_2313;

							BgL_objz00_2313 = (BgL_objectz00_bglt) (BgL_arg3553z00_2309);
							{	/* Trace/walk.scm 183 */
								long BgL_objzd2classzd2numz00_2314;

								BgL_objzd2classzd2numz00_2314 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2313);
								{	/* Trace/walk.scm 183 */
									obj_t BgL_arg2356z00_2315;

									BgL_arg2356z00_2315 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 183 */
										obj_t BgL_arrayz00_2317;

										int BgL_offsetz00_2318;

										BgL_arrayz00_2317 = BgL_arg2356z00_2315;
										BgL_offsetz00_2318 = (int) (BgL_objzd2classzd2numz00_2314);
										{	/* Trace/walk.scm 183 */
											long BgL_offsetz00_2319;

											BgL_offsetz00_2319 =
												((long) (BgL_offsetz00_2318) - OBJECT_TYPE);
											{	/* Trace/walk.scm 183 */
												long BgL_modz00_2320;

												{	/* Trace/walk.scm 183 */
													int BgL_arg2358z00_2321;

													BgL_arg2358z00_2321 = (int) (((long) 8));
													{	/* Trace/walk.scm 183 */
														long BgL_auxz00_4909;

														BgL_auxz00_4909 = (long) (BgL_arg2358z00_2321);
														BgL_modz00_2320 =
															(BgL_offsetz00_2319 / BgL_auxz00_4909);
												}}
												{	/* Trace/walk.scm 183 */
													long BgL_restz00_2322;

													{	/* Trace/walk.scm 183 */
														int BgL_arg2357z00_2323;

														BgL_arg2357z00_2323 = (int) (((long) 8));
														{	/* Trace/walk.scm 183 */
															long BgL_auxz00_4913;

															BgL_auxz00_4913 = (long) (BgL_arg2357z00_2323);
															BgL_restz00_2322 =
																(BgL_offsetz00_2319 % BgL_auxz00_4913);
													}}
													{	/* Trace/walk.scm 183 */

														BgL_method3242z00_2312 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2317,
																(int) (BgL_modz00_2320)),
															(int) (BgL_restz00_2322));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3242z00_2312) (BgL_method3242z00_2312,
							(obj_t) (BgL_arg3553z00_2309), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-exter3253 */
	obj_t BGl_findzd2lastzd2nodezd2exter3253zd2zztrace_walkz00(obj_t
		BgL_envz00_3415, obj_t BgL_nodez00_3416)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 173 */
			{
				BgL_externz00_bglt BgL_nodez00_1525;

				BgL_nodez00_1525 = (BgL_externz00_bglt) (BgL_nodez00_3416);
				{	/* Trace/walk.scm 175 */
					bool_t BgL_testz00_4924;

					{	/* Trace/walk.scm 175 */
						obj_t BgL_auxz00_4925;

						BgL_auxz00_4925 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1525))->BgL_exprza2za2);
						BgL_testz00_4924 = PAIRP(BgL_auxz00_4925);
					}
					if (BgL_testz00_4924)
						{	/* Trace/walk.scm 176 */
							obj_t BgL_arg3548z00_1530;

							BgL_arg3548z00_1530 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_externz00_bglt) CREF(BgL_nodez00_1525))->
										BgL_exprza2za2)));
							{	/* Trace/walk.scm 176 */
								BgL_nodez00_bglt BgL_nodez00_2283;

								BgL_nodez00_2283 = (BgL_nodez00_bglt) (BgL_arg3548z00_1530);
								{	/* Trace/walk.scm 176 */
									obj_t BgL_method3242z00_2284;

									{	/* Trace/walk.scm 176 */
										BgL_objectz00_bglt BgL_objz00_2285;

										BgL_objz00_2285 = (BgL_objectz00_bglt) (BgL_nodez00_2283);
										{	/* Trace/walk.scm 176 */
											long BgL_objzd2classzd2numz00_2286;

											BgL_objzd2classzd2numz00_2286 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2285);
											{	/* Trace/walk.scm 176 */
												obj_t BgL_arg2356z00_2287;

												BgL_arg2356z00_2287 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 176 */
													obj_t BgL_arrayz00_2289;

													int BgL_offsetz00_2290;

													BgL_arrayz00_2289 = BgL_arg2356z00_2287;
													BgL_offsetz00_2290 =
														(int) (BgL_objzd2classzd2numz00_2286);
													{	/* Trace/walk.scm 176 */
														long BgL_offsetz00_2291;

														BgL_offsetz00_2291 =
															((long) (BgL_offsetz00_2290) - OBJECT_TYPE);
														{	/* Trace/walk.scm 176 */
															long BgL_modz00_2292;

															{	/* Trace/walk.scm 176 */
																int BgL_arg2358z00_2293;

																BgL_arg2358z00_2293 = (int) (((long) 8));
																{	/* Trace/walk.scm 176 */
																	long BgL_auxz00_4940;

																	BgL_auxz00_4940 =
																		(long) (BgL_arg2358z00_2293);
																	BgL_modz00_2292 =
																		(BgL_offsetz00_2291 / BgL_auxz00_4940);
															}}
															{	/* Trace/walk.scm 176 */
																long BgL_restz00_2294;

																{	/* Trace/walk.scm 176 */
																	int BgL_arg2357z00_2295;

																	BgL_arg2357z00_2295 = (int) (((long) 8));
																	{	/* Trace/walk.scm 176 */
																		long BgL_auxz00_4944;

																		BgL_auxz00_4944 =
																			(long) (BgL_arg2357z00_2295);
																		BgL_restz00_2294 =
																			(BgL_offsetz00_2291 % BgL_auxz00_4944);
																}}
																{	/* Trace/walk.scm 176 */

																	BgL_method3242z00_2284 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2289,
																			(int) (BgL_modz00_2292)),
																		(int) (BgL_restz00_2294));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3242z00_2284)
										(BgL_method3242z00_2284, (obj_t) (BgL_nodez00_2283), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 175 */
							return (obj_t) (BgL_nodez00_1525);
						}
				}
			}
		}
	}



/* find-last-node-funca3251 */
	obj_t BGl_findzd2lastzd2nodezd2funca3251zd2zztrace_walkz00(obj_t
		BgL_envz00_3417, obj_t BgL_nodez00_3418)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 164 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1513;

				BgL_nodez00_1513 = (BgL_funcallz00_bglt) (BgL_nodez00_3418);
				{	/* Trace/walk.scm 166 */
					bool_t BgL_testz00_4956;

					{	/* Trace/walk.scm 166 */
						obj_t BgL_auxz00_4957;

						BgL_auxz00_4957 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1513))->BgL_argsz00);
						BgL_testz00_4956 = PAIRP(BgL_auxz00_4957);
					}
					if (BgL_testz00_4956)
						{	/* Trace/walk.scm 167 */
							obj_t BgL_arg3541z00_1518;

							BgL_arg3541z00_1518 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1513))->
										BgL_argsz00)));
							{	/* Trace/walk.scm 167 */
								BgL_nodez00_bglt BgL_nodez00_2226;

								BgL_nodez00_2226 = (BgL_nodez00_bglt) (BgL_arg3541z00_1518);
								{	/* Trace/walk.scm 167 */
									obj_t BgL_method3242z00_2227;

									{	/* Trace/walk.scm 167 */
										BgL_objectz00_bglt BgL_objz00_2228;

										BgL_objz00_2228 = (BgL_objectz00_bglt) (BgL_nodez00_2226);
										{	/* Trace/walk.scm 167 */
											long BgL_objzd2classzd2numz00_2229;

											BgL_objzd2classzd2numz00_2229 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2228);
											{	/* Trace/walk.scm 167 */
												obj_t BgL_arg2356z00_2230;

												BgL_arg2356z00_2230 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 167 */
													obj_t BgL_arrayz00_2232;

													int BgL_offsetz00_2233;

													BgL_arrayz00_2232 = BgL_arg2356z00_2230;
													BgL_offsetz00_2233 =
														(int) (BgL_objzd2classzd2numz00_2229);
													{	/* Trace/walk.scm 167 */
														long BgL_offsetz00_2234;

														BgL_offsetz00_2234 =
															((long) (BgL_offsetz00_2233) - OBJECT_TYPE);
														{	/* Trace/walk.scm 167 */
															long BgL_modz00_2235;

															{	/* Trace/walk.scm 167 */
																int BgL_arg2358z00_2236;

																BgL_arg2358z00_2236 = (int) (((long) 8));
																{	/* Trace/walk.scm 167 */
																	long BgL_auxz00_4972;

																	BgL_auxz00_4972 =
																		(long) (BgL_arg2358z00_2236);
																	BgL_modz00_2235 =
																		(BgL_offsetz00_2234 / BgL_auxz00_4972);
															}}
															{	/* Trace/walk.scm 167 */
																long BgL_restz00_2237;

																{	/* Trace/walk.scm 167 */
																	int BgL_arg2357z00_2238;

																	BgL_arg2357z00_2238 = (int) (((long) 8));
																	{	/* Trace/walk.scm 167 */
																		long BgL_auxz00_4976;

																		BgL_auxz00_4976 =
																			(long) (BgL_arg2357z00_2238);
																		BgL_restz00_2237 =
																			(BgL_offsetz00_2234 % BgL_auxz00_4976);
																}}
																{	/* Trace/walk.scm 167 */

																	BgL_method3242z00_2227 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2232,
																			(int) (BgL_modz00_2235)),
																		(int) (BgL_restz00_2237));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3242z00_2227)
										(BgL_method3242z00_2227, (obj_t) (BgL_nodez00_2226), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 168 */
							BgL_nodez00_bglt BgL_arg3544z00_1521;

							BgL_arg3544z00_1521 =
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1513))->BgL_funz00);
							{	/* Trace/walk.scm 168 */
								obj_t BgL_method3242z00_2254;

								{	/* Trace/walk.scm 168 */
									BgL_objectz00_bglt BgL_objz00_2255;

									BgL_objz00_2255 = (BgL_objectz00_bglt) (BgL_arg3544z00_1521);
									{	/* Trace/walk.scm 168 */
										long BgL_objzd2classzd2numz00_2256;

										BgL_objzd2classzd2numz00_2256 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2255);
										{	/* Trace/walk.scm 168 */
											obj_t BgL_arg2356z00_2257;

											BgL_arg2356z00_2257 =
												PROCEDURE_REF
												(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
												(int) (((long) 1)));
											{	/* Trace/walk.scm 168 */
												obj_t BgL_arrayz00_2259;

												int BgL_offsetz00_2260;

												BgL_arrayz00_2259 = BgL_arg2356z00_2257;
												BgL_offsetz00_2260 =
													(int) (BgL_objzd2classzd2numz00_2256);
												{	/* Trace/walk.scm 168 */
													long BgL_offsetz00_2261;

													BgL_offsetz00_2261 =
														((long) (BgL_offsetz00_2260) - OBJECT_TYPE);
													{	/* Trace/walk.scm 168 */
														long BgL_modz00_2262;

														{	/* Trace/walk.scm 168 */
															int BgL_arg2358z00_2263;

															BgL_arg2358z00_2263 = (int) (((long) 8));
															{	/* Trace/walk.scm 168 */
																long BgL_auxz00_4995;

																BgL_auxz00_4995 = (long) (BgL_arg2358z00_2263);
																BgL_modz00_2262 =
																	(BgL_offsetz00_2261 / BgL_auxz00_4995);
														}}
														{	/* Trace/walk.scm 168 */
															long BgL_restz00_2264;

															{	/* Trace/walk.scm 168 */
																int BgL_arg2357z00_2265;

																BgL_arg2357z00_2265 = (int) (((long) 8));
																{	/* Trace/walk.scm 168 */
																	long BgL_auxz00_4999;

																	BgL_auxz00_4999 =
																		(long) (BgL_arg2357z00_2265);
																	BgL_restz00_2264 =
																		(BgL_offsetz00_2261 % BgL_auxz00_4999);
															}}
															{	/* Trace/walk.scm 168 */

																BgL_method3242z00_2254 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2259,
																		(int) (BgL_modz00_2262)),
																	(int) (BgL_restz00_2264));
								}}}}}}}}
								return
									PROCEDURE_ENTRY(BgL_method3242z00_2254)
									(BgL_method3242z00_2254, (obj_t) (BgL_arg3544z00_1521), BEOA);
							}
						}
				}
			}
		}
	}



/* find-last-node-app-l3249 */
	obj_t BGl_findzd2lastzd2nodezd2appzd2l3249z00zztrace_walkz00(obj_t
		BgL_envz00_3419, obj_t BgL_nodez00_3420)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 158 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1507;

				BgL_nodez00_1507 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_3420);
				{	/* Trace/walk.scm 159 */
					BgL_nodez00_bglt BgL_arg3538z00_2194;

					BgL_arg3538z00_2194 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1507))->BgL_argz00);
					{	/* Trace/walk.scm 159 */
						obj_t BgL_method3242z00_2197;

						{	/* Trace/walk.scm 159 */
							BgL_objectz00_bglt BgL_objz00_2198;

							BgL_objz00_2198 = (BgL_objectz00_bglt) (BgL_arg3538z00_2194);
							{	/* Trace/walk.scm 159 */
								long BgL_objzd2classzd2numz00_2199;

								BgL_objzd2classzd2numz00_2199 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2198);
								{	/* Trace/walk.scm 159 */
									obj_t BgL_arg2356z00_2200;

									BgL_arg2356z00_2200 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 159 */
										obj_t BgL_arrayz00_2202;

										int BgL_offsetz00_2203;

										BgL_arrayz00_2202 = BgL_arg2356z00_2200;
										BgL_offsetz00_2203 = (int) (BgL_objzd2classzd2numz00_2199);
										{	/* Trace/walk.scm 159 */
											long BgL_offsetz00_2204;

											BgL_offsetz00_2204 =
												((long) (BgL_offsetz00_2203) - OBJECT_TYPE);
											{	/* Trace/walk.scm 159 */
												long BgL_modz00_2205;

												{	/* Trace/walk.scm 159 */
													int BgL_arg2358z00_2206;

													BgL_arg2358z00_2206 = (int) (((long) 8));
													{	/* Trace/walk.scm 159 */
														long BgL_auxz00_5019;

														BgL_auxz00_5019 = (long) (BgL_arg2358z00_2206);
														BgL_modz00_2205 =
															(BgL_offsetz00_2204 / BgL_auxz00_5019);
												}}
												{	/* Trace/walk.scm 159 */
													long BgL_restz00_2207;

													{	/* Trace/walk.scm 159 */
														int BgL_arg2357z00_2208;

														BgL_arg2357z00_2208 = (int) (((long) 8));
														{	/* Trace/walk.scm 159 */
															long BgL_auxz00_5023;

															BgL_auxz00_5023 = (long) (BgL_arg2357z00_2208);
															BgL_restz00_2207 =
																(BgL_offsetz00_2204 % BgL_auxz00_5023);
													}}
													{	/* Trace/walk.scm 159 */

														BgL_method3242z00_2197 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2202,
																(int) (BgL_modz00_2205)),
															(int) (BgL_restz00_2207));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3242z00_2197) (BgL_method3242z00_2197,
							(obj_t) (BgL_arg3538z00_2194), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-app3247 */
	obj_t BGl_findzd2lastzd2nodezd2app3247zd2zztrace_walkz00(obj_t
		BgL_envz00_3421, obj_t BgL_nodez00_3422)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 149 */
			{
				BgL_appz00_bglt BgL_nodez00_1496;

				BgL_nodez00_1496 = (BgL_appz00_bglt) (BgL_nodez00_3422);
				{	/* Trace/walk.scm 151 */
					bool_t BgL_testz00_5034;

					{	/* Trace/walk.scm 151 */
						obj_t BgL_auxz00_5035;

						BgL_auxz00_5035 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1496))->BgL_argsz00);
						BgL_testz00_5034 = PAIRP(BgL_auxz00_5035);
					}
					if (BgL_testz00_5034)
						{	/* Trace/walk.scm 152 */
							obj_t BgL_arg3532z00_1501;

							BgL_arg3532z00_1501 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_appz00_bglt) CREF(BgL_nodez00_1496))->BgL_argsz00)));
							{	/* Trace/walk.scm 152 */
								BgL_nodez00_bglt BgL_nodez00_2168;

								BgL_nodez00_2168 = (BgL_nodez00_bglt) (BgL_arg3532z00_1501);
								{	/* Trace/walk.scm 152 */
									obj_t BgL_method3242z00_2169;

									{	/* Trace/walk.scm 152 */
										BgL_objectz00_bglt BgL_objz00_2170;

										BgL_objz00_2170 = (BgL_objectz00_bglt) (BgL_nodez00_2168);
										{	/* Trace/walk.scm 152 */
											long BgL_objzd2classzd2numz00_2171;

											BgL_objzd2classzd2numz00_2171 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2170);
											{	/* Trace/walk.scm 152 */
												obj_t BgL_arg2356z00_2172;

												BgL_arg2356z00_2172 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 152 */
													obj_t BgL_arrayz00_2174;

													int BgL_offsetz00_2175;

													BgL_arrayz00_2174 = BgL_arg2356z00_2172;
													BgL_offsetz00_2175 =
														(int) (BgL_objzd2classzd2numz00_2171);
													{	/* Trace/walk.scm 152 */
														long BgL_offsetz00_2176;

														BgL_offsetz00_2176 =
															((long) (BgL_offsetz00_2175) - OBJECT_TYPE);
														{	/* Trace/walk.scm 152 */
															long BgL_modz00_2177;

															{	/* Trace/walk.scm 152 */
																int BgL_arg2358z00_2178;

																BgL_arg2358z00_2178 = (int) (((long) 8));
																{	/* Trace/walk.scm 152 */
																	long BgL_auxz00_5050;

																	BgL_auxz00_5050 =
																		(long) (BgL_arg2358z00_2178);
																	BgL_modz00_2177 =
																		(BgL_offsetz00_2176 / BgL_auxz00_5050);
															}}
															{	/* Trace/walk.scm 152 */
																long BgL_restz00_2179;

																{	/* Trace/walk.scm 152 */
																	int BgL_arg2357z00_2180;

																	BgL_arg2357z00_2180 = (int) (((long) 8));
																	{	/* Trace/walk.scm 152 */
																		long BgL_auxz00_5054;

																		BgL_auxz00_5054 =
																			(long) (BgL_arg2357z00_2180);
																		BgL_restz00_2179 =
																			(BgL_offsetz00_2176 % BgL_auxz00_5054);
																}}
																{	/* Trace/walk.scm 152 */

																	BgL_method3242z00_2169 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2174,
																			(int) (BgL_modz00_2177)),
																		(int) (BgL_restz00_2179));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3242z00_2169)
										(BgL_method3242z00_2169, (obj_t) (BgL_nodez00_2168), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 151 */
							return (obj_t) (BgL_nodez00_1496);
						}
				}
			}
		}
	}



/* find-last-node-seque3245 */
	obj_t BGl_findzd2lastzd2nodezd2seque3245zd2zztrace_walkz00(obj_t
		BgL_envz00_3423, obj_t BgL_nodez00_3424)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 140 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1485;

				BgL_nodez00_1485 = (BgL_sequencez00_bglt) (BgL_nodez00_3424);
				{	/* Trace/walk.scm 142 */
					bool_t BgL_testz00_5066;

					{	/* Trace/walk.scm 142 */
						obj_t BgL_auxz00_5067;

						BgL_auxz00_5067 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1485))->BgL_nodesz00);
						BgL_testz00_5066 = PAIRP(BgL_auxz00_5067);
					}
					if (BgL_testz00_5066)
						{	/* Trace/walk.scm 143 */
							obj_t BgL_arg3526z00_1490;

							BgL_arg3526z00_1490 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1485))->
										BgL_nodesz00)));
							{	/* Trace/walk.scm 143 */
								BgL_nodez00_bglt BgL_nodez00_2138;

								BgL_nodez00_2138 = (BgL_nodez00_bglt) (BgL_arg3526z00_1490);
								{	/* Trace/walk.scm 143 */
									obj_t BgL_method3242z00_2139;

									{	/* Trace/walk.scm 143 */
										BgL_objectz00_bglt BgL_objz00_2140;

										BgL_objz00_2140 = (BgL_objectz00_bglt) (BgL_nodez00_2138);
										{	/* Trace/walk.scm 143 */
											long BgL_objzd2classzd2numz00_2141;

											BgL_objzd2classzd2numz00_2141 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2140);
											{	/* Trace/walk.scm 143 */
												obj_t BgL_arg2356z00_2142;

												BgL_arg2356z00_2142 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 143 */
													obj_t BgL_arrayz00_2144;

													int BgL_offsetz00_2145;

													BgL_arrayz00_2144 = BgL_arg2356z00_2142;
													BgL_offsetz00_2145 =
														(int) (BgL_objzd2classzd2numz00_2141);
													{	/* Trace/walk.scm 143 */
														long BgL_offsetz00_2146;

														BgL_offsetz00_2146 =
															((long) (BgL_offsetz00_2145) - OBJECT_TYPE);
														{	/* Trace/walk.scm 143 */
															long BgL_modz00_2147;

															{	/* Trace/walk.scm 143 */
																int BgL_arg2358z00_2148;

																BgL_arg2358z00_2148 = (int) (((long) 8));
																{	/* Trace/walk.scm 143 */
																	long BgL_auxz00_5082;

																	BgL_auxz00_5082 =
																		(long) (BgL_arg2358z00_2148);
																	BgL_modz00_2147 =
																		(BgL_offsetz00_2146 / BgL_auxz00_5082);
															}}
															{	/* Trace/walk.scm 143 */
																long BgL_restz00_2149;

																{	/* Trace/walk.scm 143 */
																	int BgL_arg2357z00_2150;

																	BgL_arg2357z00_2150 = (int) (((long) 8));
																	{	/* Trace/walk.scm 143 */
																		long BgL_auxz00_5086;

																		BgL_auxz00_5086 =
																			(long) (BgL_arg2357z00_2150);
																		BgL_restz00_2149 =
																			(BgL_offsetz00_2146 % BgL_auxz00_5086);
																}}
																{	/* Trace/walk.scm 143 */

																	BgL_method3242z00_2139 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2144,
																			(int) (BgL_modz00_2147)),
																		(int) (BgL_restz00_2149));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3242z00_2139)
										(BgL_method3242z00_2139, (obj_t) (BgL_nodez00_2138), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 142 */
							return (obj_t) (BgL_nodez00_1485);
						}
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 182148081),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 216344604),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 315910987),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 77938009),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 358171001),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 446742181),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
			return
				BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3834z00zztrace_walkz00));
		}
	}

#ifdef __cplusplus
}
#endif
